/**
 * Copyright (C) 2024 Intel Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file
 * except in compliance with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied.  See the License for the specific language governing permissions
 * and limitations under the License.
 *
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include "widereg.h"

#include <map>
#include <sstream>

#include "lib/log.h"

void widereg_base::log(const char *op, bitvec v) const {
    std::ostringstream tmp;
    LOG1(this << ' ' << op << ' ' << v
              << (v != value ? tmp << " (now " << value << ")", tmp : tmp).str());
}
