// Automatically generated file, please do not modify!
//
#ifndef _EXTENSIONS_EVENT_LOG_SCHEMA_H_
#define _EXTENSIONS_EVENT_LOG_SCHEMA_H_

#include <array>
#include <memory>
#include <string>
#include <vector>

#include "backends/tofino/bf-p4c/logging/logging.h"

namespace Logging {

  class Event_Log_Schema_Logger : public Logger {
  public:
    /// forward declarations
    class Event_Base;
    class EventLoggerProperties;
    class SourceInfo;
    class EventParserError;
    class EventCompilationError;
    class EventCompilationWarning;
    class EventDebug;
    class EventDecision;
    class EventPassChanged;
    class EventIterationChanged;
    class EventPipeProcessingStarted;
    /// type declarations
      class Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
      public:
        // Constructor
        Event_Base() { }
        // Destructor
        virtual ~Event_Base() {
        }

        /// accessors
        /// setters
        /// internal serializer
        virtual void internalSerialize(Writer &        /* unused */        ) const {
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventLoggerProperties : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        bool _enabled;
        /// Mapping of numeric ids to actual event type names.Id of the name is equal to index in this array
        std::vector<std::string> _event_ids;
        /// Mapping of numeric ids to actual file names.Id of the name is equal to index in this array.
        std::vector<std::string> _file_ids;
        int _i;
        /// Mapping of numeric ids to actual pass manager names.Id of the name is equal to index in this array.
        std::vector<std::string> _manager_ids;
        /// Schema version used to produce this JSON.
        std::string _schema_version;
        std::string _start_time;
      public:
        // Constructor
        EventLoggerProperties(const bool enabled,
                              const std::vector<std::string> event_ids,
                              const std::vector<std::string> file_ids,
                              const int i,
                              const std::vector<std::string> manager_ids,
                              const std::string schema_version,
                              const std::string start_time): Event_Base(),
                                _enabled(enabled),
                                _event_ids(event_ids),
                                _file_ids(file_ids),
                                _i(i),
                                _manager_ids(manager_ids),
                                _schema_version(schema_version),
                                _start_time(start_time) { }
        // Destructor
        virtual ~EventLoggerProperties() {
        }

        /// accessors
        bool get_enabled() const { return _enabled; }
        std::vector<std::string>& get_event_ids() { return _event_ids; }
        std::vector<std::string>& get_file_ids() { return _file_ids; }
        int get_i() const { return _i; }
        std::vector<std::string>& get_manager_ids() { return _manager_ids; }
        std::string get_schema_version() const { return _schema_version; }
        std::string get_start_time() const { return _start_time; }
        /// setters
        void append_event_ids(std::string item) {
          _event_ids.push_back(item);
        }
        void append_file_ids(std::string item) {
          _file_ids.push_back(item);
        }
        void append_manager_ids(std::string item) {
          _manager_ids.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("enabled");
          writer.Bool(_enabled);
          writer.Key("event_ids");
          writer.StartArray();
          for ( auto e : _event_ids)
            writer.String(e.c_str());
          writer.EndArray();
          writer.Key("file_ids");
          writer.StartArray();
          for ( auto e : _file_ids)
            writer.String(e.c_str());
          writer.EndArray();
          writer.Key("i");
          writer.Int(_i);
          writer.Key("manager_ids");
          writer.StartArray();
          for ( auto e : _manager_ids)
            writer.String(e.c_str());
          writer.EndArray();
          writer.Key("schema_version");
          writer.String(_schema_version.c_str());
          writer.Key("start_time");
          writer.String(_start_time.c_str());
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class SourceInfo {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _c;
        int _f;
        int _l;
        std::string _p;
      public:
        // Constructor
        SourceInfo(const int c,
                   const int f,
                   const int l,
                   const std::string p): 
                     _c(c),
                     _f(f),
                     _l(l),
                     _p(p) { }
        // Destructor
        virtual ~SourceInfo() {
        }

        /// accessors
        int get_c() const { return _c; }
        int get_f() const { return _f; }
        int get_l() const { return _l; }
        std::string get_p() const { return _p; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("c");
          writer.Int(_c);
          writer.Key("f");
          writer.Int(_f);
          writer.Key("l");
          writer.Int(_l);
          writer.Key("p");
          writer.String(_p.c_str());
          writer.EndObject();
        }
      };

      class EventParserError : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _i;
        std::string _m;
        const         SourceInfo * _si;
        int _t;
      public:
        // Constructor
        EventParserError(const int i,
                         const std::string m,
                         const SourceInfo * si,
                         const int t): Event_Base(),
                           _i(i),
                           _m(m),
                           _si(si),
                           _t(t) { }
        // Destructor
        virtual ~EventParserError() {
          if (_si != nullptr) {
            delete _si;
          }
        }

        /// accessors
        int get_i() const { return _i; }
        std::string get_m() const { return _m; }
        const         SourceInfo * get_si() const { return _si; }
        int get_t() const { return _t; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("i");
          writer.Int(_i);
          writer.Key("m");
          writer.String(_m.c_str());
          if (_si != nullptr) {
          writer.Key("si");
          _si->serialize(writer);
          }
          writer.Key("t");
          writer.Int(_t);
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventCompilationError : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _i;
        std::string _m;
        int _t;
        std::string _a;
        std::string _cn;
        std::vector<SourceInfo *> _si;
      public:
        // Constructor
        EventCompilationError(const int i,
                              const std::string m,
                              const int t,
                              const std::string a = "",
                              const std::string cn = "",
                              const std::vector<SourceInfo *> si = {}): Event_Base(),
                                _i(i),
                                _m(m),
                                _t(t),
                                _a(a),
                                _cn(cn),
                                _si(si) { }
        // Destructor
        virtual ~EventCompilationError() {
          for (auto e : _si) delete e;
          _si.clear();
        }

        /// accessors
        int get_i() const { return _i; }
        std::string get_m() const { return _m; }
        int get_t() const { return _t; }
        std::string get_a() const { return _a; }
        std::string get_cn() const { return _cn; }
        std::vector<SourceInfo *>& get_si() { return _si; }
        /// setters
        void append(SourceInfo * item) {
        if (item != nullptr)
          _si.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("i");
          writer.Int(_i);
          writer.Key("m");
          writer.String(_m.c_str());
          writer.Key("t");
          writer.Int(_t);
          if (_a != "") {
            writer.Key("a");
            writer.String(_a.c_str());
          }
          if (_cn != "") {
            writer.Key("cn");
            writer.String(_cn.c_str());
          }
          if (_si.size() > 0) {
            writer.Key("si");
            writer.StartArray();
            for ( auto e : _si)
              e->serialize(writer);
            writer.EndArray();
          }
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventCompilationWarning : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _i;
        std::string _m;
        int _t;
        std::string _a;
        std::string _cn;
        std::vector<SourceInfo *> _si;
      public:
        // Constructor
        EventCompilationWarning(const int i,
                                const std::string m,
                                const int t,
                                const std::string a = "",
                                const std::string cn = "",
                                const std::vector<SourceInfo *> si = {}): Event_Base(),
                                  _i(i),
                                  _m(m),
                                  _t(t),
                                  _a(a),
                                  _cn(cn),
                                  _si(si) { }
        // Destructor
        virtual ~EventCompilationWarning() {
          for (auto e : _si) delete e;
          _si.clear();
        }

        /// accessors
        int get_i() const { return _i; }
        std::string get_m() const { return _m; }
        int get_t() const { return _t; }
        std::string get_a() const { return _a; }
        std::string get_cn() const { return _cn; }
        std::vector<SourceInfo *>& get_si() { return _si; }
        /// setters
        void append(SourceInfo * item) {
        if (item != nullptr)
          _si.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("i");
          writer.Int(_i);
          writer.Key("m");
          writer.String(_m.c_str());
          writer.Key("t");
          writer.Int(_t);
          if (_a != "") {
            writer.Key("a");
            writer.String(_a.c_str());
          }
          if (_cn != "") {
            writer.Key("cn");
            writer.String(_cn.c_str());
          }
          if (_si.size() > 0) {
            writer.Key("si");
            writer.StartArray();
            for ( auto e : _si)
              e->serialize(writer);
            writer.EndArray();
          }
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventDebug : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _f;
        int _i;
        std::string _m;
        int _t;
        int _v;
      public:
        // Constructor
        EventDebug(const int f,
                   const int i,
                   const std::string m,
                   const int t,
                   const int v): Event_Base(),
                     _f(f),
                     _i(i),
                     _m(m),
                     _t(t),
                     _v(v) { }
        // Destructor
        virtual ~EventDebug() {
        }

        /// accessors
        int get_f() const { return _f; }
        int get_i() const { return _i; }
        std::string get_m() const { return _m; }
        int get_t() const { return _t; }
        int get_v() const { return _v; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("f");
          writer.Int(_f);
          writer.Key("i");
          writer.Int(_i);
          writer.Key("m");
          writer.String(_m.c_str());
          writer.Key("t");
          writer.Int(_t);
          writer.Key("v");
          writer.Int(_v);
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventDecision : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::string _d;
        int _f;
        int _i;
        std::string _m;
        std::string _r;
        int _t;
        int _v;
      public:
        // Constructor
        EventDecision(const std::string d,
                      const int f,
                      const int i,
                      const std::string m,
                      const std::string r,
                      const int t,
                      const int v): Event_Base(),
                        _d(d),
                        _f(f),
                        _i(i),
                        _m(m),
                        _r(r),
                        _t(t),
                        _v(v) { }
        // Destructor
        virtual ~EventDecision() {
        }

        /// accessors
        std::string get_d() const { return _d; }
        int get_f() const { return _f; }
        int get_i() const { return _i; }
        std::string get_m() const { return _m; }
        std::string get_r() const { return _r; }
        int get_t() const { return _t; }
        int get_v() const { return _v; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("d");
          writer.String(_d.c_str());
          writer.Key("f");
          writer.Int(_f);
          writer.Key("i");
          writer.Int(_i);
          writer.Key("m");
          writer.String(_m.c_str());
          writer.Key("r");
          writer.String(_r.c_str());
          writer.Key("t");
          writer.Int(_t);
          writer.Key("v");
          writer.Int(_v);
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventPassChanged : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _i;
        int _mgr;
        std::string _n;
        int _s;
        int _t;
      public:
        // Constructor
        EventPassChanged(const int i,
                         const int mgr,
                         const std::string n,
                         const int s,
                         const int t): Event_Base(),
                           _i(i),
                           _mgr(mgr),
                           _n(n),
                           _s(s),
                           _t(t) { }
        // Destructor
        virtual ~EventPassChanged() {
        }

        /// accessors
        int get_i() const { return _i; }
        int get_mgr() const { return _mgr; }
        std::string get_n() const { return _n; }
        int get_s() const { return _s; }
        int get_t() const { return _t; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("i");
          writer.Int(_i);
          writer.Key("mgr");
          writer.Int(_mgr);
          writer.Key("n");
          writer.String(_n.c_str());
          writer.Key("s");
          writer.Int(_s);
          writer.Key("t");
          writer.Int(_t);
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventIterationChanged : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _i;
        int _num;
        /// Name of phase that is happening
        std::string _phase;
        int _t;
      public:
        // Constructor
        EventIterationChanged(const int i,
                              const int num,
                              const std::string phase,
                              const int t): Event_Base(),
                                _i(i),
                                _num(num),
                                _phase(phase),
                                _t(t) { }
        // Destructor
        virtual ~EventIterationChanged() {
        }

        /// accessors
        int get_i() const { return _i; }
        int get_num() const { return _num; }
        std::string get_phase() const { return _phase; }
        int get_t() const { return _t; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("i");
          writer.Int(_i);
          writer.Key("num");
          writer.Int(_num);
          writer.Key("phase");
          writer.String(_phase.c_str());
          writer.Key("t");
          writer.Int(_t);
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class EventPipeProcessingStarted : public Event_Base {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _i;
        int _pipe;
        int _t;
      public:
        // Constructor
        EventPipeProcessingStarted(const int i,
                                   const int pipe,
                                   const int t): Event_Base(),
                                     _i(i),
                                     _pipe(pipe),
                                     _t(t) { }
        // Destructor
        virtual ~EventPipeProcessingStarted() {
        }

        /// accessors
        int get_i() const { return _i; }
        int get_pipe() const { return _pipe; }
        int get_t() const { return _t; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("i");
          writer.Int(_i);
          writer.Key("pipe");
          writer.Int(_pipe);
          writer.Key("t");
          writer.Int(_t);
          Event_Base::internalSerialize(writer);
          writer.EndObject();
        }
      };

  private:
    std::vector<Event_Base*> _event_base;
    /// Schema version used to produce this JSON.
    std::string _schema_version;
  public:
    // Constructor
    Event_Log_Schema_Logger(const char * __fileName,
                            const std::string schema_version): Logger(__fileName),
                              _schema_version(schema_version) {
        if (schema_version != "1.2.0")
          throw new std::runtime_error("Invalid schema");
      }
    // Destructor
    virtual ~Event_Log_Schema_Logger() {
    }

    /// accessors
    std::vector<Event_Base*>& get_event_base() { return _event_base; }
    std::string get_schema_version() const { return _schema_version; }
    /// setters
    void append(Event_Base* item) {
      _event_base.push_back(item);
    }
    /// serializer
    virtual void serialize(Writer &writer) const override {
      writer.StartObject();
      writer.Key("event_base");
      writer.StartArray();
      for ( auto e : _event_base)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("schema_version");
      writer.String(_schema_version.c_str());
      writer.EndObject();
    }
  };

}  // end namespace Logging
#endif  /** _EXTENSIONS_EVENT_LOG_SCHEMA_H_ */
