// Automatically generated file, please do not modify!
//
#ifndef _EXTENSIONS_PHV_SCHEMA_H_
#define _EXTENSIONS_PHV_SCHEMA_H_

#include <array>
#include <memory>
#include <string>
#include <vector>

#include "backends/tofino/bf-p4c/logging/logging.h"

namespace Logging {

  class Phv_Schema_Logger : public Logger {
  public:
    /// forward declarations
    class Pov_Structure;
    class Resources;
    class Slice;
    class FieldSlice;
    class Structure;
    class FieldInfo;
    class MAULocation;
    class ParserLocation;
    class DeparserLocation;
    class Access;
    class ContainerSlice;
    class SourceLocation;
    class Base_Constraint;
    class BoolConstraint;
    class IntConstraint;
    class ListConstraint;
    class Constraint;
    class Field;
    class FieldGroupItem;
    class Container;
    /// type declarations
      class Pov_Structure {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// The gress of the validity bit.
        std::string _gress;
        int _pov_bit_index;
        std::string _pov_bit_name;
      public:
        // Constructor
        Pov_Structure(const std::string gress,
                      const int pov_bit_index,
                      const std::string pov_bit_name): 
                        _gress(gress),
                        _pov_bit_index(pov_bit_index),
                        _pov_bit_name(pov_bit_name) { }
        // Destructor
        virtual ~Pov_Structure() {
        }

        /// accessors
        std::string get_gress() const { return _gress; }
        int get_pov_bit_index() const { return _pov_bit_index; }
        std::string get_pov_bit_name() const { return _pov_bit_name; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("gress");
          writer.String(_gress.c_str());
          writer.Key("pov_bit_index");
          writer.Int(_pov_bit_index);
          writer.Key("pov_bit_name");
          writer.String(_pov_bit_name.c_str());
          writer.EndObject();
        }
      };

      class Resources {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// The container addresses in this group.
        std::vector<int> _addresses;
        int _bit_width;
        /// The PHV group type.
        std::string _group_type;
        int _num_containers;
      public:
        // Constructor
        Resources(const int bit_width,
                  const std::string group_type,
                  const int num_containers): 
                    _bit_width(bit_width),
                    _group_type(group_type),
                    _num_containers(num_containers) { }
        // Destructor
        virtual ~Resources() {
        }

        /// accessors
        std::vector<int>& get_addresses() { return _addresses; }
        int get_bit_width() const { return _bit_width; }
        std::string get_group_type() const { return _group_type; }
        int get_num_containers() const { return _num_containers; }
        /// setters
        void append(int item) {
          _addresses.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("addresses");
          writer.StartArray();
          for ( auto e : _addresses)
            writer.Int(e);
          writer.EndArray();
          writer.Key("bit_width");
          writer.Int(_bit_width);
          writer.Key("group_type");
          writer.String(_group_type.c_str());
          writer.Key("num_containers");
          writer.Int(_num_containers);
          writer.EndObject();
        }
      };

      class Slice {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _lsb;
        int _msb;
      public:
        // Constructor
        Slice(const int lsb,
              const int msb): 
                _lsb(lsb),
                _msb(msb) { }
        // Destructor
        virtual ~Slice() {
        }

        /// accessors
        int get_lsb() const { return _lsb; }
        int get_msb() const { return _msb; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("lsb");
          writer.Int(_lsb);
          writer.Key("msb");
          writer.Int(_msb);
          writer.EndObject();
        }
      };

      class FieldSlice {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::string _field_name;
        const         Slice * _slice_info;
      public:
        // Constructor
        FieldSlice(const std::string field_name,
                   const Slice * slice_info): 
                     _field_name(field_name),
                     _slice_info(slice_info) { }
        // Destructor
        virtual ~FieldSlice() {
          if (_slice_info != nullptr) {
            delete _slice_info;
          }
        }

        /// accessors
        std::string get_field_name() const { return _field_name; }
        const         Slice * get_slice_info() const { return _slice_info; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("field_name");
          writer.String(_field_name.c_str());
          if (_slice_info != nullptr) {
          writer.Key("slice_info");
          _slice_info->serialize(writer);
          }
          writer.EndObject();
        }
      };

      class Structure {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// The packet thread.
        std::string _gress;
        std::string _name;
        /// An ordered list of fields in the structure,from most significant field to least significant.
        std::vector<FieldSlice *> _ordered_fields;
        /// The type of this structure.
        std::string _type;
      public:
        // Constructor
        Structure(const std::string gress,
                  const std::string name,
                  const std::string type): 
                    _gress(gress),
                    _name(name),
                    _type(type) { }
        // Destructor
        virtual ~Structure() {
          for (auto e : _ordered_fields) delete e;
          _ordered_fields.clear();
        }

        /// accessors
        std::string get_gress() const { return _gress; }
        std::string get_name() const { return _name; }
        std::vector<FieldSlice *>& get_ordered_fields() { return _ordered_fields; }
        std::string get_type() const { return _type; }
        /// setters
        void append(FieldSlice * item) {
        if (item != nullptr)
          _ordered_fields.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("gress");
          writer.String(_gress.c_str());
          writer.Key("name");
          writer.String(_name.c_str());
          writer.Key("ordered_fields");
          writer.StartArray();
          for ( auto e : _ordered_fields)
            e->serialize(writer);
          writer.EndArray();
          writer.Key("type");
          writer.String(_type.c_str());
          writer.EndObject();
        }
      };

      class FieldInfo {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _bit_width;
        /// A classification designation for this field.
        std::string _field_class;
        std::string _field_name;
        /// The packet thread.
        std::string _gress;
        std::string _format_type;
      public:
        // Constructor
        FieldInfo(const int bit_width,
                  const std::string field_class,
                  const std::string field_name,
                  const std::string gress,
                  const std::string format_type = ""): 
                    _bit_width(bit_width),
                    _field_class(field_class),
                    _field_name(field_name),
                    _gress(gress),
                    _format_type(format_type) { }
        // Destructor
        virtual ~FieldInfo() {
        }

        /// accessors
        int get_bit_width() const { return _bit_width; }
        std::string get_field_class() const { return _field_class; }
        std::string get_field_name() const { return _field_name; }
        std::string get_gress() const { return _gress; }
        std::string get_format_type() const { return _format_type; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("bit_width");
          writer.Int(_bit_width);
          writer.Key("field_class");
          writer.String(_field_class.c_str());
          writer.Key("field_name");
          writer.String(_field_name.c_str());
          writer.Key("gress");
          writer.String(_gress.c_str());
          if (_format_type != "") {
            writer.Key("format_type");
            writer.String(_format_type.c_str());
          }
          writer.EndObject();
        }
      };

      class MAULocation {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::string _detail;
        int _stage;
        std::string _type;
        std::string _action;
        std::string _table;
      public:
        // Constructor
        MAULocation(const std::string detail,
                    const int stage,
                    const std::string type,
                    const std::string action = "",
                    const std::string table = ""): 
                      _detail(detail),
                      _stage(stage),
                      _type(type),
                      _action(action),
                      _table(table) { }
        // Destructor
        virtual ~MAULocation() {
        }

        /// accessors
        std::string get_detail() const { return _detail; }
        int get_stage() const { return _stage; }
        std::string get_type() const { return _type; }
        std::string get_action() const { return _action; }
        std::string get_table() const { return _table; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("detail");
          writer.String(_detail.c_str());
          writer.Key("stage");
          writer.Int(_stage);
          writer.Key("type");
          writer.String(_type.c_str());
          if (_action != "") {
            writer.Key("action");
            writer.String(_action.c_str());
          }
          if (_table != "") {
            writer.Key("table");
            writer.String(_table.c_str());
          }
          writer.EndObject();
        }
      };

      class ParserLocation {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::string _detail;
        std::string _state;
        std::string _type;
      public:
        // Constructor
        ParserLocation(const std::string detail,
                       const std::string state,
                       const std::string type): 
                         _detail(detail),
                         _state(state),
                         _type(type) { }
        // Destructor
        virtual ~ParserLocation() {
        }

        /// accessors
        std::string get_detail() const { return _detail; }
        std::string get_state() const { return _state; }
        std::string get_type() const { return _type; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("detail");
          writer.String(_detail.c_str());
          writer.Key("state");
          writer.String(_state.c_str());
          writer.Key("type");
          writer.String(_type.c_str());
          writer.EndObject();
        }
      };

      class DeparserLocation {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::string _detail;
        std::string _type;
      public:
        // Constructor
        DeparserLocation(const std::string detail,
                         const std::string type): 
                           _detail(detail),
                           _type(type) { }
        // Destructor
        virtual ~DeparserLocation() {
        }

        /// accessors
        std::string get_detail() const { return _detail; }
        std::string get_type() const { return _type; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("detail");
          writer.String(_detail.c_str());
          writer.Key("type");
          writer.String(_type.c_str());
          writer.EndObject();
        }
      };

      class Access {
      public:
        /// forward declarations
        /// type declarations
        class Location {
          MAULocation *_data0;
          ParserLocation *_data1;
          DeparserLocation *_data2;
          public:
          Location(const MAULocation e) {
            _data0 = new MAULocation(e);
            _data1 = nullptr;
            _data2 = nullptr;
          }
          Location(const ParserLocation e) {
            _data1 = new ParserLocation(e);
            _data0 = nullptr;
            _data2 = nullptr;
          }
          Location(const DeparserLocation e) {
            _data2 = new DeparserLocation(e);
            _data0 = nullptr;
            _data1 = nullptr;
          }
          /// serializer
          virtual void serialize(Writer &writer) const {
            writer.Key("location");
            if (_data0 != nullptr) {
            _data0->serialize(writer);
            }
            if (_data1 != nullptr) {
            _data1->serialize(writer);
            }
            if (_data2 != nullptr) {
            _data2->serialize(writer);
            }
          }
        };
      private:
        /// The location where this access is occuring.
        Location _location;
      public:
        // Constructor
        Access(const Location location): 
                 _location(location) { }
        // Destructor
        virtual ~Access() {
        }

        /// accessors
        Location get_location() const { return _location; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          _location.serialize(writer);
          writer.EndObject();
        }
      };

      class ContainerSlice {
      public:
        /// forward declarations
        /// type declarations
      private:
        const         FieldSlice * _field_slice;
        int _phv_number;
        /// A list of locations where this field is read.
        std::vector<Access *> _reads;
        const         Slice * _slice_info;
        /// A list of locations where this field is written.
        std::vector<Access *> _writes;
        /// List of field names in the same container which are mutually exclusive with this field.
        std::vector<std::string> _mutually_exclusive_with;
      public:
        // Constructor
        ContainerSlice(const FieldSlice * field_slice,
                       const int phv_number,
                       const Slice * slice_info): 
                         _field_slice(field_slice),
                         _phv_number(phv_number),
                         _slice_info(slice_info) { }
        // Destructor
        virtual ~ContainerSlice() {
          if (_field_slice != nullptr) {
            delete _field_slice;
          }
          for (auto e : _reads) delete e;
          _reads.clear();
          if (_slice_info != nullptr) {
            delete _slice_info;
          }
          for (auto e : _writes) delete e;
          _writes.clear();
        }

        /// accessors
        const         FieldSlice * get_field_slice() const { return _field_slice; }
        int get_phv_number() const { return _phv_number; }
        std::vector<Access *>& get_reads() { return _reads; }
        const         Slice * get_slice_info() const { return _slice_info; }
        std::vector<Access *>& get_writes() { return _writes; }
        std::vector<std::string>& get_mutually_exclusive_with() { return _mutually_exclusive_with; }
        /// setters
        void append_reads(Access * item) {
        if (item != nullptr)
          _reads.push_back(item);
        }
        void append_writes(Access * item) {
        if (item != nullptr)
          _writes.push_back(item);
        }
        void append_mutually_exclusive_with(std::string item) {
          _mutually_exclusive_with.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          if (_field_slice != nullptr) {
          writer.Key("field_slice");
          _field_slice->serialize(writer);
          }
          writer.Key("phv_number");
          writer.Int(_phv_number);
          writer.Key("reads");
          writer.StartArray();
          for ( auto e : _reads)
            e->serialize(writer);
          writer.EndArray();
          if (_slice_info != nullptr) {
          writer.Key("slice_info");
          _slice_info->serialize(writer);
          }
          writer.Key("writes");
          writer.StartArray();
          for ( auto e : _writes)
            e->serialize(writer);
          writer.EndArray();
          if (_mutually_exclusive_with.size() > 0) {
            writer.Key("mutually_exclusive_with");
            writer.StartArray();
            for ( auto e : _mutually_exclusive_with)
              writer.String(e.c_str());
            writer.EndArray();
          }
          writer.EndObject();
        }
      };

      class SourceLocation {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::string _file;
        int _line;
      public:
        // Constructor
        SourceLocation(const std::string file,
                       const int line): 
                         _file(file),
                         _line(line) { }
        // Destructor
        virtual ~SourceLocation() {
        }

        /// accessors
        std::string get_file() const { return _file; }
        int get_line() const { return _line; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("file");
          writer.String(_file.c_str());
          writer.Key("line");
          writer.Int(_line);
          writer.EndObject();
        }
      };

      class Base_Constraint {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _id;
        std::string _name;
        const         SourceLocation * _source;
        const         Access * _pipeline_location;
      public:
        // Constructor
        Base_Constraint(const int id,
                        const std::string name,
                        const SourceLocation * source,
                        const Access * pipeline_location = nullptr): 
                          _id(id),
                          _name(name),
                          _source(source),
                          _pipeline_location(pipeline_location) { }
        // Destructor
        virtual ~Base_Constraint() {
          if (_source != nullptr) {
            delete _source;
          }
          if (_pipeline_location != nullptr) {
            delete _pipeline_location;
          }
        }

        /// accessors
        int get_id() const { return _id; }
        std::string get_name() const { return _name; }
        const         SourceLocation * get_source() const { return _source; }
        const         Access * get_pipeline_location() const { return _pipeline_location; }
        /// setters
        /// internal serializer
        virtual void internalSerialize(Writer &        writer        ) const {
          writer.Key("id");
          writer.Int(_id);
          writer.Key("name");
          writer.String(_name.c_str());
          if (_source != nullptr) {
          writer.Key("source");
          _source->serialize(writer);
          }
          if (_pipeline_location != nullptr) {
            if (_pipeline_location != nullptr) {
            writer.Key("pipeline_location");
            _pipeline_location->serialize(writer);
            }
          }
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          internalSerialize(writer);
          writer.EndObject();
        }
      };

      class BoolConstraint : public Base_Constraint {
      public:
        /// forward declarations
        /// type declarations
      private:
        bool _inverted;
      public:
        // Constructor
        BoolConstraint(const bool inverted,
                       const int id,
                       const std::string name,
                       const SourceLocation * source,
                       const Access * pipeline_location = nullptr): Base_Constraint(id, name, source, pipeline_location),
                         _inverted(inverted) { }
        // Destructor
        virtual ~BoolConstraint() {
        }

        /// accessors
        bool get_inverted() const { return _inverted; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("constraint_type");
          writer.String("BoolConstraint");
          writer.Key("inverted");
          writer.Bool(_inverted);
          Base_Constraint::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class IntConstraint : public Base_Constraint {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _value;
      public:
        // Constructor
        IntConstraint(const int value,
                      const int id,
                      const std::string name,
                      const SourceLocation * source,
                      const Access * pipeline_location = nullptr): Base_Constraint(id, name, source, pipeline_location),
                        _value(value) { }
        // Destructor
        virtual ~IntConstraint() {
        }

        /// accessors
        int get_value() const { return _value; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("constraint_type");
          writer.String("IntConstraint");
          writer.Key("value");
          writer.Int(_value);
          Base_Constraint::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class ListConstraint : public Base_Constraint {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::vector<int> _lists;
      public:
        // Constructor
        ListConstraint(const std::vector<int> lists,
                       const int id,
                       const std::string name,
                       const SourceLocation * source,
                       const Access * pipeline_location = nullptr): Base_Constraint(id, name, source, pipeline_location),
                         _lists(lists) { }
        // Destructor
        virtual ~ListConstraint() {
        }

        /// accessors
        std::vector<int>& get_lists() { return _lists; }
        /// setters
        void append(int item) {
          _lists.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("constraint_type");
          writer.String("ListConstraint");
          writer.Key("lists");
          writer.StartArray();
          for ( auto e : _lists)
            writer.Int(e);
          writer.EndArray();
          Base_Constraint::internalSerialize(writer);
          writer.EndObject();
        }
      };

      class Constraint {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// The reason(s) the constraint is attached to the field. A constraint may be imposed by a multitude of reasonseach coming from a different source. In this array, all such reasons should be listed.
        std::vector<Base_Constraint*> _base_constraint;
        const         FieldSlice * _field_slice;
      public:
        // Constructor
        Constraint(const FieldSlice * field_slice = nullptr): 
                     _field_slice(field_slice) { }
        // Destructor
        virtual ~Constraint() {
          if (_field_slice != nullptr) {
            delete _field_slice;
          }
        }

        /// accessors
        std::vector<Base_Constraint*>& get_base_constraint() { return _base_constraint; }
        const         FieldSlice * get_field_slice() const { return _field_slice; }
        /// setters
        void append(Base_Constraint* item) {
          _base_constraint.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("base_constraint");
          writer.StartArray();
          for ( auto e : _base_constraint)
            e->serialize(writer);
          writer.EndArray();
          if (_field_slice != nullptr) {
            if (_field_slice != nullptr) {
            writer.Key("field_slice");
            _field_slice->serialize(writer);
            }
          }
          writer.EndObject();
        }
      };

      class Field {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// An array of Constraint objects for the field.A field may have multiple constraints, due to multiple uses.The constraints field is required, however, it is allowed to be an empty array.
        std::vector<Constraint *> _constraints;
        const         FieldInfo * _field_info;
        /// A list of field slices comprising this field.
        std::vector<FieldSlice *> _field_slices;
        /// A list of container slices comprising this field.
        std::vector<ContainerSlice *> _phv_slices;
        /// The state in which the field is at the time of logging.
        std::string _status;
        std::string _structure;
      public:
        // Constructor
        Field(const FieldInfo * field_info,
              const std::string status,
              const std::string structure = ""): 
                _field_info(field_info),
                _status(status),
                _structure(structure) { }
        // Destructor
        virtual ~Field() {
          for (auto e : _constraints) delete e;
          _constraints.clear();
          if (_field_info != nullptr) {
            delete _field_info;
          }
          for (auto e : _field_slices) delete e;
          _field_slices.clear();
          for (auto e : _phv_slices) delete e;
          _phv_slices.clear();
        }

        /// accessors
        std::vector<Constraint *>& get_constraints() { return _constraints; }
        const         FieldInfo * get_field_info() const { return _field_info; }
        std::vector<FieldSlice *>& get_field_slices() { return _field_slices; }
        std::vector<ContainerSlice *>& get_phv_slices() { return _phv_slices; }
        std::string get_status() const { return _status; }
        std::string get_structure() const { return _structure; }
        /// setters
        void append_constraints(Constraint * item) {
        if (item != nullptr)
          _constraints.push_back(item);
        }
        void append_field_slices(FieldSlice * item) {
        if (item != nullptr)
          _field_slices.push_back(item);
        }
        void append_phv_slices(ContainerSlice * item) {
        if (item != nullptr)
          _phv_slices.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("constraints");
          writer.StartArray();
          for ( auto e : _constraints)
            e->serialize(writer);
          writer.EndArray();
          if (_field_info != nullptr) {
          writer.Key("field_info");
          _field_info->serialize(writer);
          }
          writer.Key("field_slices");
          writer.StartArray();
          for ( auto e : _field_slices)
            e->serialize(writer);
          writer.EndArray();
          writer.Key("phv_slices");
          writer.StartArray();
          for ( auto e : _phv_slices)
            e->serialize(writer);
          writer.EndArray();
          writer.Key("status");
          writer.String(_status.c_str());
          if (_structure != "") {
            writer.Key("structure");
            writer.String(_structure.c_str());
          }
          writer.EndObject();
        }
      };

      class FieldGroupItem {
      public:
        /// forward declarations
        /// type declarations
      private:
        const         FieldInfo * _field_info;
        const         SourceLocation * _source;
        const         Slice * _slice;
      public:
        // Constructor
        FieldGroupItem(const FieldInfo * field_info,
                       const SourceLocation * source,
                       const Slice * slice = nullptr): 
                         _field_info(field_info),
                         _source(source),
                         _slice(slice) { }
        // Destructor
        virtual ~FieldGroupItem() {
          if (_field_info != nullptr) {
            delete _field_info;
          }
          if (_source != nullptr) {
            delete _source;
          }
          if (_slice != nullptr) {
            delete _slice;
          }
        }

        /// accessors
        const         FieldInfo * get_field_info() const { return _field_info; }
        const         SourceLocation * get_source() const { return _source; }
        const         Slice * get_slice() const { return _slice; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          if (_field_info != nullptr) {
          writer.Key("field_info");
          _field_info->serialize(writer);
          }
          if (_source != nullptr) {
          writer.Key("source");
          _source->serialize(writer);
          }
          if (_slice != nullptr) {
            if (_slice != nullptr) {
            writer.Key("slice");
            _slice->serialize(writer);
            }
          }
          writer.EndObject();
        }
      };

      class Container {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _bit_width;
        /// A string describing the type of this PHV container.
        std::string _container_type;
        /// The packet thread.
        std::string _gress;
        int _phv_deparser_group_number;
        int _phv_mau_group_number;
        int _phv_number;
        /// A list of container slices occupying this container.
        std::vector<ContainerSlice *> _slices;
      public:
        // Constructor
        Container(const int bit_width,
                  const std::string container_type,
                  const std::string gress,
                  const int phv_deparser_group_number,
                  const int phv_mau_group_number,
                  const int phv_number): 
                    _bit_width(bit_width),
                    _container_type(container_type),
                    _gress(gress),
                    _phv_deparser_group_number(phv_deparser_group_number),
                    _phv_mau_group_number(phv_mau_group_number),
                    _phv_number(phv_number) { }
        // Destructor
        virtual ~Container() {
          for (auto e : _slices) delete e;
          _slices.clear();
        }

        /// accessors
        int get_bit_width() const { return _bit_width; }
        std::string get_container_type() const { return _container_type; }
        std::string get_gress() const { return _gress; }
        int get_phv_deparser_group_number() const { return _phv_deparser_group_number; }
        int get_phv_mau_group_number() const { return _phv_mau_group_number; }
        int get_phv_number() const { return _phv_number; }
        std::vector<ContainerSlice *>& get_slices() { return _slices; }
        /// setters
        void append(ContainerSlice * item) {
        if (item != nullptr)
          _slices.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("bit_width");
          writer.Int(_bit_width);
          writer.Key("container_type");
          writer.String(_container_type.c_str());
          writer.Key("gress");
          writer.String(_gress.c_str());
          writer.Key("phv_deparser_group_number");
          writer.Int(_phv_deparser_group_number);
          writer.Key("phv_mau_group_number");
          writer.Int(_phv_mau_group_number);
          writer.Key("phv_number");
          writer.Int(_phv_number);
          writer.Key("slices");
          writer.StartArray();
          for ( auto e : _slices)
            e->serialize(writer);
          writer.EndArray();
          writer.EndObject();
        }
      };

  private:
    std::string _build_date;
    std::string _compiler_version;
    /// Array of reasons for various types and subtypes of constraints. Indexed by constraint id
    std::vector<std::string> _constraint_reasons;
    /// A list of PHV container allocation information.
    std::vector<Container *> _containers;
    /// The list of fields in the program. The fields may be in different stages,depending on the result of the PHV allocation.
    std::vector<Field *> _fields;
    int _nStages;
    /// A list of attributes describing the POV structure.
    std::vector<Pov_Structure *> _pov_structure;
    std::string _program_name;
    /// A list of PHV resource information.
    std::vector<Resources *> _resources;
    std::string _run_id;
    /// Schema version used to produce this JSON.
    std::string _schema_version;
    /// A list of program and compiler-induced structures,e.g. header structures and bridged metadata.
    std::vector<Structure *> _structures;
    /// The target device this program was compiled for.
    std::string _target;
    /// Concrete items pointed to by indices in field_groups
    std::vector<FieldGroupItem *> _field_group_items;
    /// Groups of fields affected by the same constraints
    std::vector<std::vector<int>> _field_groups;
  public:
    // Constructor
    Phv_Schema_Logger(const char * __fileName,
                      const std::string build_date,
                      const std::string compiler_version,
                      const int nStages,
                      const std::string program_name,
                      const std::string run_id,
                      const std::string schema_version,
                      const std::string target): Logger(__fileName),
                        _build_date(build_date),
                        _compiler_version(compiler_version),
                        _nStages(nStages),
                        _program_name(program_name),
                        _run_id(run_id),
                        _schema_version(schema_version),
                        _target(target) {
        if (schema_version != "3.0.0")
          throw new std::runtime_error("Invalid schema");
      }
    // Destructor
    virtual ~Phv_Schema_Logger() {
      for (auto e : _containers) delete e;
      _containers.clear();
      for (auto e : _fields) delete e;
      _fields.clear();
      for (auto e : _pov_structure) delete e;
      _pov_structure.clear();
      for (auto e : _resources) delete e;
      _resources.clear();
      for (auto e : _structures) delete e;
      _structures.clear();
      for (auto e : _field_group_items) delete e;
      _field_group_items.clear();
    }

    /// accessors
    std::string get_build_date() const { return _build_date; }
    std::string get_compiler_version() const { return _compiler_version; }
    std::vector<std::string>& get_constraint_reasons() { return _constraint_reasons; }
    std::vector<Container *>& get_containers() { return _containers; }
    std::vector<Field *>& get_fields() { return _fields; }
    int get_nStages() const { return _nStages; }
    std::vector<Pov_Structure *>& get_pov_structure() { return _pov_structure; }
    std::string get_program_name() const { return _program_name; }
    std::vector<Resources *>& get_resources() { return _resources; }
    std::string get_run_id() const { return _run_id; }
    std::string get_schema_version() const { return _schema_version; }
    std::vector<Structure *>& get_structures() { return _structures; }
    std::string get_target() const { return _target; }
    std::vector<FieldGroupItem *>& get_field_group_items() { return _field_group_items; }
    std::vector<std::vector<int>>& get_field_groups() { return _field_groups; }
    /// setters
    void append_constraint_reasons(std::string item) {
      _constraint_reasons.push_back(item);
    }
    void append_containers(Container * item) {
    if (item != nullptr)
      _containers.push_back(item);
    }
    void append_fields(Field * item) {
    if (item != nullptr)
      _fields.push_back(item);
    }
    void append_pov_structure(Pov_Structure * item) {
    if (item != nullptr)
      _pov_structure.push_back(item);
    }
    void append_resources(Resources * item) {
    if (item != nullptr)
      _resources.push_back(item);
    }
    void append_structures(Structure * item) {
    if (item != nullptr)
      _structures.push_back(item);
    }
    void append_field_group_items(FieldGroupItem * item) {
    if (item != nullptr)
      _field_group_items.push_back(item);
    }
    void append_field_groups(std::vector<int> item) {
      _field_groups.push_back(item);
    }
    /// serializer
    virtual void serialize(Writer &writer) const override {
      writer.StartObject();
      writer.Key("build_date");
      writer.String(_build_date.c_str());
      writer.Key("compiler_version");
      writer.String(_compiler_version.c_str());
      writer.Key("constraint_reasons");
      writer.StartArray();
      for ( auto e : _constraint_reasons)
        writer.String(e.c_str());
      writer.EndArray();
      writer.Key("containers");
      writer.StartArray();
      for ( auto e : _containers)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("fields");
      writer.StartArray();
      for ( auto e : _fields)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("nStages");
      writer.Int(_nStages);
      writer.Key("pov_structure");
      writer.StartArray();
      for ( auto e : _pov_structure)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("program_name");
      writer.String(_program_name.c_str());
      writer.Key("resources");
      writer.StartArray();
      for ( auto e : _resources)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("run_id");
      writer.String(_run_id.c_str());
      writer.Key("schema_version");
      writer.String(_schema_version.c_str());
      writer.Key("structures");
      writer.StartArray();
      for ( auto e : _structures)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("target");
      writer.String(_target.c_str());
      if (_field_group_items.size() > 0) {
        writer.Key("field_group_items");
        writer.StartArray();
        for ( auto e : _field_group_items)
          e->serialize(writer);
        writer.EndArray();
      }
      if (_field_groups.size() > 0) {
        writer.Key("field_groups");
        writer.StartArray();
        for ( auto e : _field_groups)
          {
            writer.StartArray();
            for ( auto f : e )
              writer.Int(f);
            writer.EndArray();
          }
        writer.EndArray();
      }
      writer.EndObject();
    }
  };

}  // end namespace Logging
#endif  /** _EXTENSIONS_PHV_SCHEMA_H_ */
