// Automatically generated file, please do not modify!
//
#ifndef _EXTENSIONS_POWER_SCHEMA_H_
#define _EXTENSIONS_POWER_SCHEMA_H_

#include <array>
#include <memory>
#include <string>
#include <vector>

#include "backends/tofino/bf-p4c/logging/logging.h"

namespace Logging {

  class Power_Schema_Logger : public Logger {
  public:
    /// forward declarations
    class Total_Latency;
    class Total_Power;
    class StageDetails;
    class MatchTables;
    class Features;
    class StageCharacteristics;
    /// type declarations
      class Total_Latency {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// The gress this latency number applies to.
        std::string _gress;
        int _latency;
        int _pipe_number;
      public:
        // Constructor
        Total_Latency(const std::string gress,
                      const int latency,
                      const int pipe_number): 
                        _gress(gress),
                        _latency(latency),
                        _pipe_number(pipe_number) { }
        // Destructor
        virtual ~Total_Latency() {
        }

        /// accessors
        std::string get_gress() const { return _gress; }
        int get_latency() const { return _latency; }
        int get_pipe_number() const { return _pipe_number; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("gress");
          writer.String(_gress.c_str());
          writer.Key("latency");
          writer.Int(_latency);
          writer.Key("pipe_number");
          writer.Int(_pipe_number);
          writer.EndObject();
        }
      };

      class Total_Power {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// The gress this power number applies to.
        std::string _gress;
        int _pipe_number;
        double _power;
      public:
        // Constructor
        Total_Power(const std::string gress,
                    const int pipe_number,
                    const double power): 
                      _gress(gress),
                      _pipe_number(pipe_number),
                      _power(power) { }
        // Destructor
        virtual ~Total_Power() {
        }

        /// accessors
        std::string get_gress() const { return _gress; }
        int get_pipe_number() const { return _pipe_number; }
        double get_power() const { return _power; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("gress");
          writer.String(_gress.c_str());
          writer.Key("pipe_number");
          writer.Int(_pipe_number);
          writer.Key("power");
          writer.Double(_power);
          writer.EndObject();
        }
      };

      class StageDetails {
      public:
        /// forward declarations
        class Memories;
        /// type declarations
          class Memories {
          public:
            /// forward declarations
            /// type declarations
          private:
            /// The type of access performed on the memory.
            std::string _access_type;
            /// The type of memory being used.
            std::string _memory_type;
            int _num_memories;
          public:
            // Constructor
            Memories(const std::string access_type,
                     const std::string memory_type,
                     const int num_memories): 
                       _access_type(access_type),
                       _memory_type(memory_type),
                       _num_memories(num_memories) { }
            // Destructor
            virtual ~Memories() {
            }

            /// accessors
            std::string get_access_type() const { return _access_type; }
            std::string get_memory_type() const { return _memory_type; }
            int get_num_memories() const { return _num_memories; }
            /// setters
            /// serializer
            virtual void serialize(Writer &writer) const {
              writer.StartObject();
              writer.Key("access_type");
              writer.String(_access_type.c_str());
              writer.Key("memory_type");
              writer.String(_memory_type.c_str());
              writer.Key("num_memories");
              writer.Int(_num_memories);
              writer.EndObject();
            }
          };

      private:
        bool _always_runs;
        /// A list of how this table uses memory in this stage, including any attached tables it may have.
        std::vector<Memories *> _memories;
        bool _on_critical_path;
        int _stage_number;
        double _weight;
      public:
        // Constructor
        StageDetails(const bool always_runs,
                     const bool on_critical_path,
                     const int stage_number,
                     const double weight): 
                       _always_runs(always_runs),
                       _on_critical_path(on_critical_path),
                       _stage_number(stage_number),
                       _weight(weight) { }
        // Destructor
        virtual ~StageDetails() {
          for (auto e : _memories) delete e;
          _memories.clear();
        }

        /// accessors
        bool get_always_runs() const { return _always_runs; }
        std::vector<Memories *>& get_memories() { return _memories; }
        bool get_on_critical_path() const { return _on_critical_path; }
        int get_stage_number() const { return _stage_number; }
        double get_weight() const { return _weight; }
        /// setters
        void append(Memories * item) {
        if (item != nullptr)
          _memories.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("always_runs");
          writer.Bool(_always_runs);
          writer.Key("memories");
          writer.StartArray();
          for ( auto e : _memories)
            e->serialize(writer);
          writer.EndArray();
          writer.Key("on_critical_path");
          writer.Bool(_on_critical_path);
          writer.Key("stage_number");
          writer.Int(_stage_number);
          writer.Key("weight");
          writer.Double(_weight);
          writer.EndObject();
        }
      };

      class MatchTables {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// The gress the table belongs to.
        std::string _gress;
        std::string _name;
        /// An array of the per-stage power information for this match table.
        std::vector<StageDetails *> _stages;
      public:
        // Constructor
        MatchTables(const std::string gress,
                    const std::string name): 
                      _gress(gress),
                      _name(name) { }
        // Destructor
        virtual ~MatchTables() {
          for (auto e : _stages) delete e;
          _stages.clear();
        }

        /// accessors
        std::string get_gress() const { return _gress; }
        std::string get_name() const { return _name; }
        std::vector<StageDetails *>& get_stages() { return _stages; }
        /// setters
        void append(StageDetails * item) {
        if (item != nullptr)
          _stages.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("gress");
          writer.String(_gress.c_str());
          writer.Key("name");
          writer.String(_name.c_str());
          writer.Key("stages");
          writer.StartArray();
          for ( auto e : _stages)
            e->serialize(writer);
          writer.EndArray();
          writer.EndObject();
        }
      };

      class Features {
      public:
        /// forward declarations
        /// type declarations
      private:
        bool _exact;
        bool _lpf_wred;
        bool _selectors;
        bool _stateful;
        bool _statistics;
        bool _ternary;
        const int* _max_selector_words;
      public:
        // Constructor
        Features(const bool exact,
                 const bool lpf_wred,
                 const bool selectors,
                 const bool stateful,
                 const bool statistics,
                 const bool ternary,
                 const int* max_selector_words = nullptr): 
                   _exact(exact),
                   _lpf_wred(lpf_wred),
                   _selectors(selectors),
                   _stateful(stateful),
                   _statistics(statistics),
                   _ternary(ternary),
                   _max_selector_words(max_selector_words) { }
        // Destructor
        virtual ~Features() {
        }

        /// accessors
        bool get_exact() const { return _exact; }
        bool get_lpf_wred() const { return _lpf_wred; }
        bool get_selectors() const { return _selectors; }
        bool get_stateful() const { return _stateful; }
        bool get_statistics() const { return _statistics; }
        bool get_ternary() const { return _ternary; }
        const int* get_max_selector_words() const { return _max_selector_words; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("exact");
          writer.Bool(_exact);
          writer.Key("lpf_wred");
          writer.Bool(_lpf_wred);
          writer.Key("selectors");
          writer.Bool(_selectors);
          writer.Key("stateful");
          writer.Bool(_stateful);
          writer.Key("statistics");
          writer.Bool(_statistics);
          writer.Key("ternary");
          writer.Bool(_ternary);
          if (_max_selector_words != nullptr) {
            writer.Key("max_selector_words");
            writer.Int(*_max_selector_words);
          }
          writer.EndObject();
        }
      };

      class StageCharacteristics {
      public:
        /// forward declarations
        /// type declarations
      private:
        int _clock_cycles;
        int _cycles_contribute_to_latency;
        /// The dependency type this stage has on the previous stage.
        std::string _dependency_to_previous;
        const         Features * _features;
        const         Features * _features_to_balance_latency;
        /// The gress these characterisitcs apply to.
        std::string _gress;
        int _predication_cycle;
        int _stage_number;
      public:
        // Constructor
        StageCharacteristics(const int clock_cycles,
                             const int cycles_contribute_to_latency,
                             const std::string dependency_to_previous,
                             const Features * features,
                             const Features * features_to_balance_latency,
                             const std::string gress,
                             const int predication_cycle,
                             const int stage_number): 
                               _clock_cycles(clock_cycles),
                               _cycles_contribute_to_latency(cycles_contribute_to_latency),
                               _dependency_to_previous(dependency_to_previous),
                               _features(features),
                               _features_to_balance_latency(features_to_balance_latency),
                               _gress(gress),
                               _predication_cycle(predication_cycle),
                               _stage_number(stage_number) { }
        // Destructor
        virtual ~StageCharacteristics() {
          if (_features != nullptr) {
            delete _features;
          }
          if (_features_to_balance_latency != nullptr) {
            delete _features_to_balance_latency;
          }
        }

        /// accessors
        int get_clock_cycles() const { return _clock_cycles; }
        int get_cycles_contribute_to_latency() const { return _cycles_contribute_to_latency; }
        std::string get_dependency_to_previous() const { return _dependency_to_previous; }
        const         Features * get_features() const { return _features; }
        const         Features * get_features_to_balance_latency() const { return _features_to_balance_latency; }
        std::string get_gress() const { return _gress; }
        int get_predication_cycle() const { return _predication_cycle; }
        int get_stage_number() const { return _stage_number; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("clock_cycles");
          writer.Int(_clock_cycles);
          writer.Key("cycles_contribute_to_latency");
          writer.Int(_cycles_contribute_to_latency);
          writer.Key("dependency_to_previous");
          writer.String(_dependency_to_previous.c_str());
          if (_features != nullptr) {
          writer.Key("features");
          _features->serialize(writer);
          }
          if (_features_to_balance_latency != nullptr) {
          writer.Key("features_to_balance_latency");
          _features_to_balance_latency->serialize(writer);
          }
          writer.Key("gress");
          writer.String(_gress.c_str());
          writer.Key("predication_cycle");
          writer.Int(_predication_cycle);
          writer.Key("stage_number");
          writer.Int(_stage_number);
          writer.EndObject();
        }
      };

  private:
    std::string _build_date;
    std::string _compiler_version;
    std::string _program_name;
    std::string _run_id;
    std::string _schema_version;
    /// An array of stage characteristics.
    std::vector<StageCharacteristics *> _stage_characteristics;
    /// A list of match table allocation information.
    std::vector<MatchTables *> _tables;
    /// A list of the total latency results per gress per pipe.
    std::vector<Total_Latency *> _total_latency;
    /// A list of the power consumption per gress per pipe.
    std::vector<Total_Power *> _total_power;
  public:
    // Constructor
    Power_Schema_Logger(const char * __fileName,
                        const std::string build_date,
                        const std::string compiler_version,
                        const std::string program_name,
                        const std::string run_id,
                        const std::string schema_version): Logger(__fileName),
                          _build_date(build_date),
                          _compiler_version(compiler_version),
                          _program_name(program_name),
                          _run_id(run_id),
                          _schema_version(schema_version) {
        if (schema_version != "1.0.1")
          throw new std::runtime_error("Invalid schema");
      }
    // Destructor
    virtual ~Power_Schema_Logger() {
      for (auto e : _stage_characteristics) delete e;
      _stage_characteristics.clear();
      for (auto e : _tables) delete e;
      _tables.clear();
      for (auto e : _total_latency) delete e;
      _total_latency.clear();
      for (auto e : _total_power) delete e;
      _total_power.clear();
    }

    /// accessors
    std::string get_build_date() const { return _build_date; }
    std::string get_compiler_version() const { return _compiler_version; }
    std::string get_program_name() const { return _program_name; }
    std::string get_run_id() const { return _run_id; }
    std::string get_schema_version() const { return _schema_version; }
    std::vector<StageCharacteristics *>& get_stage_characteristics() { return _stage_characteristics; }
    std::vector<MatchTables *>& get_tables() { return _tables; }
    std::vector<Total_Latency *>& get_total_latency() { return _total_latency; }
    std::vector<Total_Power *>& get_total_power() { return _total_power; }
    /// setters
    void append_stage_characteristics(StageCharacteristics * item) {
    if (item != nullptr)
      _stage_characteristics.push_back(item);
    }
    void append_tables(MatchTables * item) {
    if (item != nullptr)
      _tables.push_back(item);
    }
    void append_total_latency(Total_Latency * item) {
    if (item != nullptr)
      _total_latency.push_back(item);
    }
    void append_total_power(Total_Power * item) {
    if (item != nullptr)
      _total_power.push_back(item);
    }
    /// serializer
    virtual void serialize(Writer &writer) const override {
      writer.StartObject();
      writer.Key("build_date");
      writer.String(_build_date.c_str());
      writer.Key("compiler_version");
      writer.String(_compiler_version.c_str());
      writer.Key("program_name");
      writer.String(_program_name.c_str());
      writer.Key("run_id");
      writer.String(_run_id.c_str());
      writer.Key("schema_version");
      writer.String(_schema_version.c_str());
      writer.Key("stage_characteristics");
      writer.StartArray();
      for ( auto e : _stage_characteristics)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("tables");
      writer.StartArray();
      for ( auto e : _tables)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("total_latency");
      writer.StartArray();
      for ( auto e : _total_latency)
        e->serialize(writer);
      writer.EndArray();
      writer.Key("total_power");
      writer.StartArray();
      for ( auto e : _total_power)
        e->serialize(writer);
      writer.EndArray();
      writer.EndObject();
    }
  };

}  // end namespace Logging
#endif  /** _EXTENSIONS_POWER_SCHEMA_H_ */
