// Automatically generated file, please do not modify!
//
#ifndef _EXTENSIONS_SOURCE_INFO_SCHEMA_H_
#define _EXTENSIONS_SOURCE_INFO_SCHEMA_H_

#include <array>
#include <memory>
#include <string>
#include <vector>

#include "backends/tofino/bf-p4c/logging/logging.h"

namespace Logging {

  class Source_Info_Schema_Logger : public Logger {
  public:
    /// forward declarations
    class SourceLocation;
    class SymbolDefinition;
    /// type declarations
      class SourceLocation {
      public:
        /// forward declarations
        /// type declarations
      private:
        std::string _file;
        int _line;
        const int* _column;
        const int* _end_line;
        std::string _source_brief;
      public:
        // Constructor
        SourceLocation(const std::string file,
                       const int line,
                       const int* column = nullptr,
                       const int* end_line = nullptr,
                       const std::string source_brief = ""): 
                         _file(file),
                         _line(line),
                         _column(column),
                         _end_line(end_line),
                         _source_brief(source_brief) { }
        // Destructor
        virtual ~SourceLocation() {
        }

        /// accessors
        std::string get_file() const { return _file; }
        int get_line() const { return _line; }
        const int* get_column() const { return _column; }
        const int* get_end_line() const { return _end_line; }
        std::string get_source_brief() const { return _source_brief; }
        /// setters
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("file");
          writer.String(_file.c_str());
          writer.Key("line");
          writer.Int(_line);
          if (_column != nullptr) {
            writer.Key("column");
            writer.Int(*_column);
          }
          if (_end_line != nullptr) {
            writer.Key("end_line");
            writer.Int(*_end_line);
          }
          if (_source_brief != "") {
            writer.Key("source_brief");
            writer.String(_source_brief.c_str());
          }
          writer.EndObject();
        }
      };

      class SymbolDefinition {
      public:
        /// forward declarations
        /// type declarations
      private:
        /// An array of references to this symbol.
        std::vector<SourceLocation *> _references;
        std::string _symbol_name;
        /// Fully qualified symbol name aliases.
        std::vector<std::string> _aliases;
        const         SourceLocation * _declaration;
        /// Symbol scope path as an array.
        std::vector<std::string> _scope;
        std::string _symbol_type;
      public:
        // Constructor
        SymbolDefinition(const std::string symbol_name,
                         const SourceLocation * declaration = nullptr,
                         const std::string symbol_type = ""): 
                           _symbol_name(symbol_name),
                           _declaration(declaration),
                           _symbol_type(symbol_type) { }
        // Destructor
        virtual ~SymbolDefinition() {
          for (auto e : _references) delete e;
          _references.clear();
          if (_declaration != nullptr) {
            delete _declaration;
          }
        }

        /// accessors
        std::vector<SourceLocation *>& get_references() { return _references; }
        std::string get_symbol_name() const { return _symbol_name; }
        std::vector<std::string>& get_aliases() { return _aliases; }
        const         SourceLocation * get_declaration() const { return _declaration; }
        std::vector<std::string>& get_scope() { return _scope; }
        std::string get_symbol_type() const { return _symbol_type; }
        /// setters
        void append_references(SourceLocation * item) {
        if (item != nullptr)
          _references.push_back(item);
        }
        void append_aliases(std::string item) {
          _aliases.push_back(item);
        }
        void append_scope(std::string item) {
          _scope.push_back(item);
        }
        /// serializer
        virtual void serialize(Writer &writer) const {
          writer.StartObject();
          writer.Key("references");
          writer.StartArray();
          for ( auto e : _references)
            e->serialize(writer);
          writer.EndArray();
          writer.Key("symbol_name");
          writer.String(_symbol_name.c_str());
          if (_aliases.size() > 0) {
            writer.Key("aliases");
            writer.StartArray();
            for ( auto e : _aliases)
              writer.String(e.c_str());
            writer.EndArray();
          }
          if (_declaration != nullptr) {
            if (_declaration != nullptr) {
            writer.Key("declaration");
            _declaration->serialize(writer);
            }
          }
          if (_scope.size() > 0) {
            writer.Key("scope");
            writer.StartArray();
            for ( auto e : _scope)
              writer.String(e.c_str());
            writer.EndArray();
          }
          if (_symbol_type != "") {
            writer.Key("symbol_type");
            writer.String(_symbol_type.c_str());
          }
          writer.EndObject();
        }
      };

  private:
    /// Schema version used to produce this JSON.
    std::string _schema_version;
    /// An array of source symbols.
    std::vector<SymbolDefinition *> _symbols;
    std::string _source_root;
  public:
    // Constructor
    Source_Info_Schema_Logger(const char * __fileName,
                              const std::string schema_version,
                              const std::string source_root = ""): Logger(__fileName),
                                _schema_version(schema_version),
                                _source_root(source_root) {
        if (schema_version != "1.0.0")
          throw new std::runtime_error("Invalid schema");
      }
    // Destructor
    virtual ~Source_Info_Schema_Logger() {
      for (auto e : _symbols) delete e;
      _symbols.clear();
    }

    /// accessors
    std::string get_schema_version() const { return _schema_version; }
    std::vector<SymbolDefinition *>& get_symbols() { return _symbols; }
    std::string get_source_root() const { return _source_root; }
    /// setters
    void append(SymbolDefinition * item) {
    if (item != nullptr)
      _symbols.push_back(item);
    }
    /// serializer
    virtual void serialize(Writer &writer) const override {
      writer.StartObject();
      writer.Key("schema_version");
      writer.String(_schema_version.c_str());
      writer.Key("symbols");
      writer.StartArray();
      for ( auto e : _symbols)
        e->serialize(writer);
      writer.EndArray();
      if (_source_root != "") {
        writer.Key("source_root");
        writer.String(_source_root.c_str());
      }
      writer.EndObject();
    }
  };

}  // end namespace Logging
#endif  /** _EXTENSIONS_SOURCE_INFO_SCHEMA_H_ */
