#pragma once
#include <cstdint>
#include "lib/rtti.h"
#define IRNODE_ALL_SUBCLASSES_AND_DIRECT_AND_INDIRECT_BASES(M, T, D, B, ...) \
  M(Type, D(Node), ##__VA_ARGS__) \
    M(Type_Base, D(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Unknown, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
  M(StatOrDecl, D(Node), ##__VA_ARGS__) \
    M(Declaration, D(StatOrDecl) B(Node), ##__VA_ARGS__) \
    M(Type_Declaration, D(Type) B(Node), ##__VA_ARGS__) \
  M(Expression, D(Node), ##__VA_ARGS__) \
    M(Operation, D(Expression) B(Node), ##__VA_ARGS__) \
  M(Path, D(Node), ##__VA_ARGS__) \
      M(NamedExpression, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
  M(AnnotationToken, D(Node), ##__VA_ARGS__) \
  M(Annotation, D(Node), ##__VA_ARGS__) \
  M(Argument, D(Node), ##__VA_ARGS__) \
    M(Type_Any, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_Fragment, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_Type, D(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Boolean, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_State, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Bits, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Varbits, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Parameter, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
  M(ParameterList, D(Node), ##__VA_ARGS__) \
      M(Type_Var, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
    M(Type_InfInt, D(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Dontcare, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Void, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_MatchKind, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
  M(TypeParameters, D(Node), ##__VA_ARGS__) \
      M(StructField, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Type_StructLike, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(Type_Struct, D(Type_StructLike) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(Type_UnknownStruct, D(Type_StructLike) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(Type_HeaderUnion, D(Type_StructLike) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(Type_Header, D(Type_StructLike) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
    M(Type_Set, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_BaseList, D(Type) B(Node), ##__VA_ARGS__) \
      M(Type_List, D(Type_BaseList) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Tuple, D(Type_BaseList) B(Type) B(Node), ##__VA_ARGS__) \
    M(Type_P4List, D(Type) B(Node), ##__VA_ARGS__) \
      M(Type_ArchBlock, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(Type_Package, D(Type_ArchBlock) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(Type_Parser, D(Type_ArchBlock) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(Type_Control, D(Type_ArchBlock) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
    M(Type_Name, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_Array, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_Specialized, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_SpecializedCanonical, D(Type) B(Node), ##__VA_ARGS__) \
      M(Declaration_ID, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Type_String, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Enum, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
      M(SerEnumMember, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Type_SerEnum, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
    M(Type_Table, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_ActionEnum, D(Type) B(Node), ##__VA_ARGS__) \
    M(Type_MethodBase, D(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Method, D(Type_MethodBase) B(Type) B(Node), ##__VA_ARGS__) \
  M(ArgumentInfo, D(Node), ##__VA_ARGS__) \
    M(Type_MethodCall, D(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Action, D(Type_MethodBase) B(Type) B(Node), ##__VA_ARGS__) \
      M(Method, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Type_Typedef, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Newtype, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Extern, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
      M(Operation_Unary, D(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Neg, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(UPlus, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Cmpl, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(LNot, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
      M(Operation_Binary, D(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
      M(Operation_Ternary, D(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Operation_Relation, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Mul, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(Statement, D(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(BaseAssignmentStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(OpAssignmentStatement, D(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
          M(MulAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(Div, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(DivAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(Mod, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(ModAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(Add, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(AddAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(Sub, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(SubAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(AddSat, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(AddSatAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(SubSat, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(SubSatAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(Shl, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(ShlAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(Shr, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(ShrAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
          M(Equ, D(Operation_Relation) B(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(Neq, D(Operation_Relation) B(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(Lss, D(Operation_Relation) B(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(Leq, D(Operation_Relation) B(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(Grt, D(Operation_Relation) B(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(Geq, D(Operation_Relation) B(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(BAnd, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(BAndAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(BOr, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(BOrAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(BXor, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(BXorAssign, D(OpAssignmentStatement) B(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(LAnd, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(LOr, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(Dots, D(Expression) B(Node), ##__VA_ARGS__) \
        M(NamedDots, D(NamedExpression) B(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
    M(Literal, D(Expression) B(Node), ##__VA_ARGS__) \
      M(Constant, D(Literal) B(Expression) B(Node), ##__VA_ARGS__) \
      M(BoolLiteral, D(Literal) B(Expression) B(Node), ##__VA_ARGS__) \
      M(StringLiteral, D(Literal) B(Expression) B(Node), ##__VA_ARGS__) \
    M(PathExpression, D(Expression) B(Node), ##__VA_ARGS__) \
    M(TypeNameExpression, D(Expression) B(Node), ##__VA_ARGS__) \
        M(AbstractSlice, D(Operation_Ternary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(Slice, D(AbstractSlice) B(Operation_Ternary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(PlusSlice, D(AbstractSlice) B(Operation_Ternary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Member, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Concat, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(ArrayIndex, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Range, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Mask, D(Operation_Binary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Mux, D(Operation_Ternary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(DefaultExpression, D(Expression) B(Node), ##__VA_ARGS__) \
    M(This, D(Expression) B(Node), ##__VA_ARGS__) \
        M(Cast, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
  M(SelectCase, D(Node), ##__VA_ARGS__) \
    M(SelectExpression, D(Expression) B(Node), ##__VA_ARGS__) \
    M(MethodCallExpression, D(Expression) B(Node), ##__VA_ARGS__) \
    M(ConstructorCallExpression, D(Expression) B(Node), ##__VA_ARGS__) \
    M(BaseListExpression, D(Expression) B(Node), ##__VA_ARGS__) \
      M(ListExpression, D(BaseListExpression) B(Expression) B(Node), ##__VA_ARGS__) \
      M(P4ListExpression, D(BaseListExpression) B(Expression) B(Node), ##__VA_ARGS__) \
    M(StructExpression, D(Expression) B(Node), ##__VA_ARGS__) \
    M(Invalid, D(Expression) B(Node), ##__VA_ARGS__) \
    M(InvalidHeader, D(Expression) B(Node), ##__VA_ARGS__) \
    M(InvalidHeaderUnion, D(Expression) B(Node), ##__VA_ARGS__) \
      M(HeaderStackExpression, D(BaseListExpression) B(Expression) B(Node), ##__VA_ARGS__) \
  M(ListCompileTimeValue, D(Node), ##__VA_ARGS__) \
  M(P4ListCompileTimeValue, D(Node), ##__VA_ARGS__) \
  M(StructCompileTimeValue, D(Node), ##__VA_ARGS__) \
      M(CompileTimeMethodCall, D(MethodCallExpression) B(Expression) B(Node), ##__VA_ARGS__) \
    M(SymbolicVariable, D(Expression) B(Node), ##__VA_ARGS__) \
      M(ParserState, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(P4Parser, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
      M(P4Control, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
      M(P4Action, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Type_Error, D(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
  M(Declaration_MatchKind, D(Node), ##__VA_ARGS__) \
  M(PropertyValue, D(Node), ##__VA_ARGS__) \
    M(ExpressionValue, D(PropertyValue) B(Node), ##__VA_ARGS__) \
    M(ExpressionListValue, D(PropertyValue) B(Node), ##__VA_ARGS__) \
  M(ActionListElement, D(Node), ##__VA_ARGS__) \
    M(ActionList, D(PropertyValue) B(Node), ##__VA_ARGS__) \
  M(KeyElement, D(Node), ##__VA_ARGS__) \
    M(Key, D(PropertyValue) B(Node), ##__VA_ARGS__) \
  M(Entry, D(Node), ##__VA_ARGS__) \
    M(EntriesList, D(PropertyValue) B(Node), ##__VA_ARGS__) \
      M(Property, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
  M(TableProperties, D(Node), ##__VA_ARGS__) \
      M(P4Table, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(P4ValueSet, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Declaration_Variable, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Declaration_Constant, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Declaration_Instance, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
  M(P4Program, D(Node), ##__VA_ARGS__) \
      M(ExitStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(ReturnStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(EmptyStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(AssignmentStatement, D(BaseAssignmentStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(IfStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(BreakStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(ContinueStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(BlockStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(MethodCallStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
  M(SwitchCase, D(Node), ##__VA_ARGS__) \
      M(SwitchStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(LoopStatement, D(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(ForStatement, D(LoopStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
        M(ForInStatement, D(LoopStatement) B(Statement) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
      M(Function, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
  M(Block, D(Node), ##__VA_ARGS__) \
    M(TableBlock, D(Block) B(Node), ##__VA_ARGS__) \
    M(InstantiatedBlock, D(Block) B(Node), ##__VA_ARGS__) \
      M(ParserBlock, D(InstantiatedBlock) B(Block) B(Node), ##__VA_ARGS__) \
      M(ControlBlock, D(InstantiatedBlock) B(Block) B(Node), ##__VA_ARGS__) \
      M(PackageBlock, D(InstantiatedBlock) B(Block) B(Node), ##__VA_ARGS__) \
      M(ExternBlock, D(InstantiatedBlock) B(Block) B(Node), ##__VA_ARGS__) \
    M(ToplevelBlock, D(Block) B(Node), ##__VA_ARGS__) \
      M(Type_Block, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Counter, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Expression, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_FieldListCalculation, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Meter, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_Register, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(Type_AnyTable, D(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
  M(HeaderOrMetadata, D(Node), ##__VA_ARGS__) \
    M(Header, D(HeaderOrMetadata) B(Node), ##__VA_ARGS__) \
    M(HeaderStack, D(HeaderOrMetadata) B(Node), ##__VA_ARGS__) \
  M(v1HeaderType, D(Node), ##__VA_ARGS__) \
    M(Metadata, D(HeaderOrMetadata) B(Node), ##__VA_ARGS__) \
    M(HeaderRef, D(Expression) B(Node), ##__VA_ARGS__) \
      M(ConcreteHeaderRef, D(HeaderRef) B(Expression) B(Node), ##__VA_ARGS__) \
      M(HeaderStackItemRef, D(HeaderRef) B(Expression) B(Node), ##__VA_ARGS__) \
    M(If, D(Expression) B(Node), ##__VA_ARGS__) \
      M(NamedCond, D(If) B(Expression) B(Node), ##__VA_ARGS__) \
    M(Apply, D(Expression) B(Node), ##__VA_ARGS__) \
      M(Primitive, D(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
  M(FieldList, D(Node), ##__VA_ARGS__) \
  M(FieldListCalculation, D(Node), ##__VA_ARGS__) \
  M(CalculatedField, D(Node), ##__VA_ARGS__) \
  M(ParserValueSet, D(Node), ##__VA_ARGS__) \
  M(CaseEntry, D(Node), ##__VA_ARGS__) \
  M(V1Parser, D(Node), ##__VA_ARGS__) \
  M(ParserException, D(Node), ##__VA_ARGS__) \
  M(Attached, D(Node), ##__VA_ARGS__) \
    M(Stateful, D(Attached) B(Node), ##__VA_ARGS__) \
      M(CounterOrMeter, D(Stateful) B(Attached) B(Node), ##__VA_ARGS__) \
        M(Counter, D(CounterOrMeter) B(Stateful) B(Attached) B(Node), ##__VA_ARGS__) \
        M(Meter, D(CounterOrMeter) B(Stateful) B(Attached) B(Node), ##__VA_ARGS__) \
      M(Register, D(Stateful) B(Attached) B(Node), ##__VA_ARGS__) \
  M(PrimitiveAction, D(Node), ##__VA_ARGS__) \
  M(NameList, D(Node), ##__VA_ARGS__) \
    M(ActionArg, D(Expression) B(Node), ##__VA_ARGS__) \
  M(ActionFunction, D(Node), ##__VA_ARGS__) \
    M(ActionProfile, D(Attached) B(Node), ##__VA_ARGS__) \
    M(ActionSelector, D(Attached) B(Node), ##__VA_ARGS__) \
  M(V1Table, D(Node), ##__VA_ARGS__) \
  M(V1Control, D(Node), ##__VA_ARGS__) \
    M(AttribLocal, D(Expression) B(Node), ##__VA_ARGS__) \
  M(AttribLocals, D(Node), ##__VA_ARGS__) \
      M(Attribute, D(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
    M(GlobalRef, D(Expression) B(Node), ##__VA_ARGS__) \
    M(AttributeRef, D(Expression) B(Node), ##__VA_ARGS__) \
  M(V1Program, D(Node), ##__VA_ARGS__) \
        M(IntMod, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
  M(DpdkDeclaration, D(Node), ##__VA_ARGS__) \
        M(DpdkExternDeclaration, D(Declaration_Instance) B(Declaration) B(StatOrDecl) B(Node), ##__VA_ARGS__) \
          M(DpdkHeaderType, D(Type_Header) B(Type_StructLike) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
  M(DpdkHeaderInstance, D(Node), ##__VA_ARGS__) \
          M(DpdkStructType, D(Type_Struct) B(Type_StructLike) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
  M(DpdkAsmStatement, D(Node), ##__VA_ARGS__) \
  M(DpdkAction, D(Node), ##__VA_ARGS__) \
  M(DpdkTable, D(Node), ##__VA_ARGS__) \
  M(DpdkSelector, D(Node), ##__VA_ARGS__) \
  M(DpdkLearner, D(Node), ##__VA_ARGS__) \
  M(DpdkAsmProgram, D(Node), ##__VA_ARGS__) \
    M(DpdkListStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkApplyStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkLearnStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkMirrorStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkEmitStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkExtractStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkLookaheadStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkJmpStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkJmpLabelStatement, D(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkJmpHitStatement, D(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkJmpMissStatement, D(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkJmpActionStatement, D(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpIfActionRunStatement, D(DpdkJmpActionStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpIfActionNotRunStatement, D(DpdkJmpActionStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkJmpHeaderStatement, D(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpIfInvalidStatement, D(DpdkJmpHeaderStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpIfValidStatement, D(DpdkJmpHeaderStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkJmpCondStatement, D(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpEqualStatement, D(DpdkJmpCondStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpNotEqualStatement, D(DpdkJmpCondStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpGreaterEqualStatement, D(DpdkJmpCondStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpGreaterStatement, D(DpdkJmpCondStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpLessOrEqualStatement, D(DpdkJmpCondStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkJmpLessStatement, D(DpdkJmpCondStatement) B(DpdkJmpStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkRxStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkTxStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkAssignmentStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkUnaryStatement, D(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkMovStatement, D(DpdkUnaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkMovhStatement, D(DpdkUnaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkBinaryStatement, D(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkAddStatement, D(DpdkBinaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkAndStatement, D(DpdkBinaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkShlStatement, D(DpdkBinaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkShrStatement, D(DpdkBinaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkSubStatement, D(DpdkBinaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkOrStatement, D(DpdkBinaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
        M(DpdkXorStatement, D(DpdkBinaryStatement) B(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkRecircidStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkReturnStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkRearmStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkRecirculateStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkLabelStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkChecksumAddStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkChecksumSubStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkChecksumClearStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkHashDeclStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkGetHashStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkGetChecksumStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkCastStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkVerifyStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkMeterDeclStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkMeterExecuteStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkGetTableEntryIndex, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkCounterCountStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkRegisterDeclStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
      M(DpdkRegisterReadStatement, D(DpdkAssignmentStatement) B(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkRegisterWriteStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkValidateStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkInvalidateStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
    M(DpdkDropStatement, D(DpdkAsmStatement) B(Node), ##__VA_ARGS__) \
  M(TCKernelMetadata, D(Node), ##__VA_ARGS__) \
  M(TCActionParam, D(Node), ##__VA_ARGS__) \
  M(TCDefaultActionParam, D(Node), ##__VA_ARGS__) \
  M(TCAction, D(Node), ##__VA_ARGS__) \
  M(TCEntry, D(Node), ##__VA_ARGS__) \
  M(TCTable, D(Node), ##__VA_ARGS__) \
  M(TCKey, D(Node), ##__VA_ARGS__) \
  M(TCExternInstance, D(Node), ##__VA_ARGS__) \
  M(TCExtern, D(Node), ##__VA_ARGS__) \
  M(TCPipeline, D(Node), ##__VA_ARGS__) \
    M(StateVariable, D(Expression) B(Node), ##__VA_ARGS__) \
    M(TaintExpression, D(Expression) B(Node), ##__VA_ARGS__) \
        M(Extracted_Varbits, D(Type_Bits) B(Type_Base) B(Type) B(Node), ##__VA_ARGS__) \
      M(ConcolicVariable, D(SymbolicVariable) B(Expression) B(Node), ##__VA_ARGS__) \
      M(HeaderExpression, D(StructExpression) B(Expression) B(Node), ##__VA_ARGS__) \
    M(InOutReference, D(Expression) B(Node), ##__VA_ARGS__) \
      M(UninitializedTaintExpression, D(TaintExpression) B(Expression) B(Node), ##__VA_ARGS__) \
  M(BFN::HardwareConstrainedField, D(Node), ##__VA_ARGS__) \
  M(BFN::Pipe, D(Node), ##__VA_ARGS__) \
    M(BFN::BridgePath, D(BFN::Pipe) B(Node), ##__VA_ARGS__) \
  M(BFN::Toplevel, D(Node), ##__VA_ARGS__) \
  M(BFN::Unit, D(Node), ##__VA_ARGS__) \
      M(InstanceRef, D(HeaderRef) B(Expression) B(Node), ##__VA_ARGS__) \
        M(V1InstanceRef, D(InstanceRef) B(HeaderRef) B(Expression) B(Node), ##__VA_ARGS__) \
  M(MetadataInfo, D(Node), ##__VA_ARGS__) \
    M(BFN::Value, D(Expression) B(Node), ##__VA_ARGS__) \
      M(BFN::Reference, D(BFN::Value) B(Expression) B(Node), ##__VA_ARGS__) \
        M(TempVar, D(BFN::Reference) B(BFN::Value) B(Expression) B(Node), ##__VA_ARGS__) \
        M(Padding, D(BFN::Reference) B(BFN::Value) B(Expression) B(Node), ##__VA_ARGS__) \
          M(BFN::Type_FixedSizeHeader, D(Type_Header) B(Type_StructLike) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(BFN::ContainerRef, D(BFN::Reference) B(BFN::Value) B(Expression) B(Node), ##__VA_ARGS__) \
        M(BFN::ContainerBitRef, D(BFN::Reference) B(BFN::Value) B(Expression) B(Node), ##__VA_ARGS__) \
          M(BFN::AliasMember, D(Member) B(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
            M(BFN::AliasSlice, D(Slice) B(AbstractSlice) B(Operation_Ternary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(HashListExpression, D(ListExpression) B(BaseListExpression) B(Expression) B(Node), ##__VA_ARGS__) \
      M(HashStructExpression, D(StructExpression) B(Expression) B(Node), ##__VA_ARGS__) \
          M(BFN::ReinterpretCast, D(Cast) B(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(BFN::SignExtend, D(Cast) B(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
        M(BFN::TnaControl, D(P4Control) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(BFN::TnaDeparser, D(P4Control) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
        M(BFN::TnaParser, D(P4Parser) B(Type_Declaration) B(Type) B(Node), ##__VA_ARGS__) \
  M(BFN::P4Thread, D(Node), ##__VA_ARGS__) \
    M(MAU::Table, D(BFN::Unit) B(Node), ##__VA_ARGS__) \
  M(MAU::BackendAttached, D(Node), ##__VA_ARGS__) \
    M(MAU::AttachedMemory, D(Attached) B(Node), ##__VA_ARGS__) \
      M(MAU::Synth2Port, D(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
        M(MAU::Counter, D(MAU::Synth2Port) B(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
        M(MAU::MeterBus2Port, D(MAU::Synth2Port) B(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
          M(MAU::Meter, D(MAU::MeterBus2Port) B(MAU::Synth2Port) B(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
          M(MAU::StatefulAlu, D(MAU::MeterBus2Port) B(MAU::Synth2Port) B(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
      M(MAU::Selector, D(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
      M(MAU::TernaryIndirect, D(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
      M(MAU::ActionData, D(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
      M(MAU::IdleTime, D(MAU::AttachedMemory) B(Attached) B(Node), ##__VA_ARGS__) \
  M(MAU::TableSeq, D(Node), ##__VA_ARGS__) \
        M(MAU::Primitive, D(Primitive) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(MAU::TypedPrimitive, D(MAU::Primitive) B(Primitive) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
          M(MAU::Instruction, D(MAU::Primitive) B(Primitive) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
            M(MAU::SaluInstruction, D(MAU::Instruction) B(MAU::Primitive) B(Primitive) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::ActionArg, D(Expression) B(Node), ##__VA_ARGS__) \
      M(MAU::ConditionalArg, D(MAU::ActionArg) B(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::StatefulCounter, D(Expression) B(Node), ##__VA_ARGS__) \
  M(MAU::StatefulCall, D(Node), ##__VA_ARGS__) \
  M(MAU::VLIWInstruction, D(Node), ##__VA_ARGS__) \
    M(MAU::Action, D(MAU::VLIWInstruction) B(Node), ##__VA_ARGS__) \
    M(MAU::SaluAction, D(MAU::VLIWInstruction) B(Node), ##__VA_ARGS__) \
        M(MAU::FieldListExpression, D(ListExpression) B(BaseListExpression) B(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::HashGenExpression, D(Expression) B(Node), ##__VA_ARGS__) \
        M(MAU::HashDist, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::IXBarExpression, D(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::ActionDataConstant, D(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::RandomNumber, D(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::AttachedOutput, D(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::SaluReg, D(Expression) B(Node), ##__VA_ARGS__) \
      M(MAU::SaluCmpReg, D(MAU::SaluReg) B(Expression) B(Node), ##__VA_ARGS__) \
        M(MAU::SaluFunction, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::SaluRegfileRow, D(Expression) B(Node), ##__VA_ARGS__) \
        M(MAU::MultiOperand, D(ListExpression) B(BaseListExpression) B(Expression) B(Node), ##__VA_ARGS__) \
        M(MAU::WrappedSlice, D(Operation_Ternary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(MAU::TableKey, D(Expression) B(Node), ##__VA_ARGS__) \
        M(RangeMatch, D(Operation_Unary) B(Operation) B(Expression) B(Node), ##__VA_ARGS__) \
    M(BFN::UnresolvedHeaderStackIndex, D(Expression) B(Node), ##__VA_ARGS__) \
    M(BFN::ParserRVal, D(Expression) B(Node), ##__VA_ARGS__) \
      M(BFN::InputBufferRVal, D(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
        M(BFN::PacketRVal, D(BFN::InputBufferRVal) B(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
        M(BFN::MetadataRVal, D(BFN::InputBufferRVal) B(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
      M(BFN::ConstantRVal, D(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
      M(BFN::SavedRVal, D(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
  M(BFN::ParserLVal, D(Node), ##__VA_ARGS__) \
    M(BFN::FieldLVal, D(BFN::ParserLVal) B(Node), ##__VA_ARGS__) \
    M(BFN::MatchLVal, D(BFN::ParserLVal) B(Node), ##__VA_ARGS__) \
      M(BFN::ChecksumLVal, D(BFN::FieldLVal) B(BFN::ParserLVal) B(Node), ##__VA_ARGS__) \
      M(BFN::TotalContainerSize, D(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
  M(BFN::ParserPrimitive, D(Node), ##__VA_ARGS__) \
    M(BFN::Extract, D(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ExtractPhv, D(BFN::Extract) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ExtractClot, D(BFN::Extract) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::SaveToRegister, D(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::ParserCounterPrimitive, D(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::ParserZeroInit, D(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ParserCounterLoadImm, D(BFN::ParserCounterPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ParserCounterLoadPkt, D(BFN::ParserCounterPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ParserCounterIncrement, D(BFN::ParserCounterPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ParserCounterDecrement, D(BFN::ParserCounterPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ParserCounterPop, D(BFN::ParserCounterPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ParserCounterRVal, D(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
        M(BFN::ParserCounterIsZero, D(BFN::ParserCounterRVal) B(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
        M(BFN::ParserCounterIsNegative, D(BFN::ParserCounterRVal) B(BFN::ParserRVal) B(Expression) B(Node), ##__VA_ARGS__) \
    M(BFN::ParserPrioritySet, D(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::ParserChecksumPrimitive, D(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ParserChecksumWritePrimitive, D(BFN::ParserChecksumPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
        M(BFN::ChecksumVerify, D(BFN::ParserChecksumWritePrimitive) B(BFN::ParserChecksumPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
        M(BFN::ChecksumResidualDeposit, D(BFN::ParserChecksumWritePrimitive) B(BFN::ParserChecksumPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ChecksumDepositToClot, D(BFN::ParserChecksumPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ChecksumAdd, D(BFN::ParserChecksumPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::ChecksumSubtract, D(BFN::ParserChecksumPrimitive) B(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::HdrLenIncStop, D(BFN::ParserPrimitive) B(Node), ##__VA_ARGS__) \
  M(BFN::ParserMatchValue, D(Node), ##__VA_ARGS__) \
    M(BFN::ParserConstMatchValue, D(BFN::ParserMatchValue) B(Node), ##__VA_ARGS__) \
    M(BFN::ParserPvsMatchValue, D(BFN::ParserMatchValue) B(Node), ##__VA_ARGS__) \
  M(BFN::Phase0, D(Node), ##__VA_ARGS__) \
  M(BFN::Transition, D(Node), ##__VA_ARGS__) \
  M(BFN::Select, D(Node), ##__VA_ARGS__) \
    M(BFN::ParserState, D(BFN::Unit) B(Node), ##__VA_ARGS__) \
    M(BFN::AbstractParser, D(BFN::Unit) B(Node), ##__VA_ARGS__) \
      M(BFN::Parser, D(BFN::AbstractParser) B(BFN::Unit) B(Node), ##__VA_ARGS__) \
      M(BFN::GhostParser, D(BFN::AbstractParser) B(BFN::Unit) B(Node), ##__VA_ARGS__) \
  M(BFN::DigestFieldList, D(Node), ##__VA_ARGS__) \
  M(BFN::Digest, D(Node), ##__VA_ARGS__) \
  M(BFN::DeparserPrimitive, D(Node), ##__VA_ARGS__) \
    M(BFN::Emit, D(BFN::DeparserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::EmitField, D(BFN::Emit) B(BFN::DeparserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::EmitConstant, D(BFN::Emit) B(BFN::DeparserPrimitive) B(Node), ##__VA_ARGS__) \
      M(BFN::EmitClot, D(BFN::Emit) B(BFN::DeparserPrimitive) B(Node), ##__VA_ARGS__) \
  M(BFN::ChecksumEntry, D(Node), ##__VA_ARGS__) \
      M(BFN::EmitChecksum, D(BFN::Emit) B(BFN::DeparserPrimitive) B(Node), ##__VA_ARGS__) \
  M(BFN::DeparserParameter, D(Node), ##__VA_ARGS__) \
    M(BFN::AbstractDeparser, D(BFN::Unit) B(Node), ##__VA_ARGS__) \
      M(BFN::Deparser, D(BFN::AbstractDeparser) B(BFN::Unit) B(Node), ##__VA_ARGS__) \
  M(BFN::LoweredParserRVal, D(Node), ##__VA_ARGS__) \
    M(BFN::LoweredInputBufferRVal, D(BFN::LoweredParserRVal) B(Node), ##__VA_ARGS__) \
      M(BFN::LoweredPacketRVal, D(BFN::LoweredInputBufferRVal) B(BFN::LoweredParserRVal) B(Node), ##__VA_ARGS__) \
      M(BFN::LoweredMetadataRVal, D(BFN::LoweredInputBufferRVal) B(BFN::LoweredParserRVal) B(Node), ##__VA_ARGS__) \
    M(BFN::LoweredConstantRVal, D(BFN::LoweredParserRVal) B(Node), ##__VA_ARGS__) \
  M(BFN::LoweredParserPrimitive, D(Node), ##__VA_ARGS__) \
    M(BFN::LoweredExtractPhv, D(BFN::LoweredParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::LoweredExtractClot, D(BFN::LoweredParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::LoweredParserChecksum, D(BFN::LoweredParserPrimitive) B(Node), ##__VA_ARGS__) \
    M(BFN::LoweredSave, D(BFN::LoweredParserPrimitive) B(Node), ##__VA_ARGS__) \
  M(BFN::LoweredSelect, D(Node), ##__VA_ARGS__) \
  M(BFN::LoweredParserMatch, D(Node), ##__VA_ARGS__) \
    M(BFN::LoweredParserState, D(BFN::Unit) B(Node), ##__VA_ARGS__) \
      M(BFN::BaseLoweredParser, D(BFN::AbstractParser) B(BFN::Unit) B(Node), ##__VA_ARGS__) \
        M(BFN::LoweredParser, D(BFN::BaseLoweredParser) B(BFN::AbstractParser) B(BFN::Unit) B(Node), ##__VA_ARGS__) \
  M(BFN::LoweredEmit, D(Node), ##__VA_ARGS__) \
    M(BFN::LoweredEmitPhv, D(BFN::LoweredEmit) B(Node), ##__VA_ARGS__) \
    M(BFN::LoweredEmitChecksum, D(BFN::LoweredEmit) B(Node), ##__VA_ARGS__) \
    M(BFN::LoweredEmitClot, D(BFN::LoweredEmit) B(Node), ##__VA_ARGS__) \
    M(BFN::LoweredEmitConstant, D(BFN::LoweredEmit) B(Node), ##__VA_ARGS__) \
  M(BFN::LoweredDeparserParameter, D(Node), ##__VA_ARGS__) \
  M(BFN::DigestTableEntry, D(Node), ##__VA_ARGS__) \
  M(BFN::DigestField, D(Node), ##__VA_ARGS__) \
    M(BFN::LearningTableEntry, D(BFN::DigestTableEntry) B(Node), ##__VA_ARGS__) \
  M(BFN::LoweredDigest, D(Node), ##__VA_ARGS__) \
  M(BFN::ChecksumPhvInput, D(Node), ##__VA_ARGS__) \
  M(BFN::ChecksumClotInput, D(Node), ##__VA_ARGS__) \
  M(BFN::PartialChecksumUnitConfig, D(Node), ##__VA_ARGS__) \
  M(BFN::FullChecksumUnitConfig, D(Node), ##__VA_ARGS__) \
      M(BFN::LoweredDeparser, D(BFN::AbstractDeparser) B(BFN::Unit) B(Node), ##__VA_ARGS__) \
T(Vector<IR::Node>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::Node>, D(Vector<IR::Node>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::Type>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::StatOrDecl>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::StatOrDecl>, D(Vector<IR::StatOrDecl>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::Declaration>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::Declaration>, D(Vector<IR::Declaration>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::Expression>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::NamedExpression>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::NamedExpression>, D(Vector<IR::NamedExpression>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::AnnotationToken>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::Annotation>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::Argument>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::Parameter>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::Parameter>, D(Vector<IR::Parameter>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::Type_Var>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::Type_Var>, D(Vector<IR::Type_Var>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::StructField>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::StructField>, D(Vector<IR::StructField>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::Declaration_ID>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::Declaration_ID>, D(Vector<IR::Declaration_ID>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::SerEnumMember>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::SerEnumMember>, D(Vector<IR::SerEnumMember>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::ArgumentInfo>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::Method>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::SelectCase>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::ParserState>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::ParserState>, D(Vector<IR::ParserState>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::P4Parser>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::ActionListElement>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::ActionListElement>, D(Vector<IR::ActionListElement>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::KeyElement>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::Entry>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::Property>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::Property>, D(Vector<IR::Property>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::SwitchCase>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::Primitive>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::CaseEntry>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkDeclaration>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkDeclaration>, D(Vector<IR::DpdkDeclaration>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkExternDeclaration>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkExternDeclaration>, D(Vector<IR::DpdkExternDeclaration>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkHeaderType>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkHeaderType>, D(Vector<IR::DpdkHeaderType>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkHeaderInstance>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkHeaderInstance>, D(Vector<IR::DpdkHeaderInstance>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkStructType>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkStructType>, D(Vector<IR::DpdkStructType>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkAsmStatement>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkAsmStatement>, D(Vector<IR::DpdkAsmStatement>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkAction>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkAction>, D(Vector<IR::DpdkAction>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkTable>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkTable>, D(Vector<IR::DpdkTable>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkSelector>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkSelector>, D(Vector<IR::DpdkSelector>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::DpdkLearner>, D(Node), ##__VA_ARGS__) \
T(IndexedVector<IR::DpdkLearner>, D(Vector<IR::DpdkLearner>) B(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::HardwareConstrainedField>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::Pipe>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::ContainerRef>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::MAU::Table>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::MAU::BackendAttached>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::MAU::Primitive>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::MAU::SaluInstruction>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::MAU::StatefulCall>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::MAU::TableKey>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::FieldLVal>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::ParserPrimitive>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::SaveToRegister>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::ParserCounterPrimitive>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::Transition>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::Select>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::AbstractParser>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::DigestFieldList>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::Emit>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::ChecksumEntry>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::EmitChecksum>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::DeparserParameter>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::LoweredParserPrimitive>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::LoweredParserChecksum>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::LoweredSave>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::LoweredParserMatch>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::LoweredEmit>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::LoweredDeparserParameter>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::DigestTableEntry>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::LoweredDigest>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::ChecksumPhvInput>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::ChecksumClotInput>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::PartialChecksumUnitConfig>, D(Node), ##__VA_ARGS__) \
T(Vector<IR::BFN::FullChecksumUnitConfig>, D(Node), ##__VA_ARGS__) \

namespace P4::IR {
class CompileTimeValue;
class Type;
class IMayBeGenericType;
class IApply;
class INamespace;
class ISimpleNamespace;
class IGeneralNamespace;
class INestedNamespace;
class IFunctional;
class ITypeVar;
class IContainer;
class Type_Base;
class Type_Unknown;
class StatOrDecl;
class Declaration;
class Type_Declaration;
class Expression;
class Operation;
class Path;
class NamedExpression;
class AnnotationToken;
class Annotation;
class IAnnotated;
class IInstance;
class Argument;
class Type_Any;
class Type_Fragment;
class Type_Type;
class Type_Boolean;
class Type_State;
class Type_Bits;
class Type_Varbits;
class Parameter;
class ParameterList;
class Type_Var;
class Type_InfInt;
class Type_Dontcare;
class Type_Void;
class Type_MatchKind;
class TypeParameters;
class StructField;
class Type_StructLike;
class Type_Struct;
class Type_UnknownStruct;
class Type_HeaderUnion;
class Type_Header;
class Type_Set;
class Type_Indexed;
class Type_BaseList;
class Type_List;
class Type_Tuple;
class Type_P4List;
class Type_ArchBlock;
class Type_Package;
class Type_Parser;
class Type_Control;
class Type_Name;
class Type_Array;
class Type_Specialized;
class Type_SpecializedCanonical;
class Declaration_ID;
class Type_String;
class Type_Enum;
class SerEnumMember;
class Type_SerEnum;
class Type_Table;
class Type_ActionEnum;
class Type_MethodBase;
class Type_Method;
class ArgumentInfo;
class Type_MethodCall;
class Type_Action;
class Method;
class Type_Typedef;
class Type_Newtype;
class Type_Extern;
class Operation_Unary;
class Neg;
class UPlus;
class Cmpl;
class LNot;
class Operation_Binary;
class Operation_Ternary;
class Operation_Relation;
class Mul;
class Statement;
class BaseAssignmentStatement;
class OpAssignmentStatement;
class MulAssign;
class Div;
class DivAssign;
class Mod;
class ModAssign;
class Add;
class AddAssign;
class Sub;
class SubAssign;
class AddSat;
class AddSatAssign;
class SubSat;
class SubSatAssign;
class Shl;
class ShlAssign;
class Shr;
class ShrAssign;
class Equ;
class Neq;
class Lss;
class Leq;
class Grt;
class Geq;
class BAnd;
class BAndAssign;
class BOr;
class BOrAssign;
class BXor;
class BXorAssign;
class LAnd;
class LOr;
class Dots;
class NamedDots;
class Literal;
class Constant;
class BoolLiteral;
class StringLiteral;
class PathExpression;
class TypeNameExpression;
class AbstractSlice;
class Slice;
class PlusSlice;
class Member;
class Concat;
class ArrayIndex;
class Range;
class Mask;
class Mux;
class DefaultExpression;
class This;
class Cast;
class SelectCase;
class SelectExpression;
class MethodCallExpression;
class ConstructorCallExpression;
class BaseListExpression;
class ListExpression;
class P4ListExpression;
class StructExpression;
class Invalid;
class InvalidHeader;
class InvalidHeaderUnion;
class HeaderStackExpression;
class ListCompileTimeValue;
class P4ListCompileTimeValue;
class StructCompileTimeValue;
class CompileTimeMethodCall;
class SymbolicVariable;
class ParserState;
class P4Parser;
class P4Control;
class P4Action;
class Type_Error;
class Declaration_MatchKind;
class PropertyValue;
class ExpressionValue;
class ExpressionListValue;
class ActionListElement;
class ActionList;
class KeyElement;
class Key;
class Entry;
class EntriesList;
class Property;
class TableProperties;
class P4Table;
class P4ValueSet;
class Declaration_Variable;
class Declaration_Constant;
class Declaration_Instance;
class P4Program;
class ExitStatement;
class ReturnStatement;
class EmptyStatement;
class AssignmentStatement;
class IfStatement;
class BreakStatement;
class ContinueStatement;
class BlockStatement;
class MethodCallStatement;
class SwitchCase;
class SwitchStatement;
class LoopStatement;
class ForStatement;
class ForInStatement;
class Function;
class Block;
class TableBlock;
class InstantiatedBlock;
class ParserBlock;
class ControlBlock;
class PackageBlock;
class ExternBlock;
class ToplevelBlock;
class Type_Block;
class Type_Counter;
class Type_Expression;
class Type_FieldListCalculation;
class Type_Meter;
class Type_Register;
class Type_AnyTable;
class HeaderOrMetadata;
class Header;
class HeaderStack;
class v1HeaderType;
class Metadata;
class HeaderRef;
class ConcreteHeaderRef;
class HeaderStackItemRef;
class If;
class NamedCond;
class Apply;
class Primitive;
class FieldList;
class FieldListCalculation;
class CalculatedField;
class ParserValueSet;
class CaseEntry;
class V1Parser;
class ParserException;
class Attached;
class Stateful;
class CounterOrMeter;
class Counter;
class Meter;
class Register;
class PrimitiveAction;
class NameList;
class ActionArg;
class ActionFunction;
class ActionProfile;
class ActionSelector;
class V1Table;
class V1Control;
class AttribLocal;
class AttribLocals;
class Attribute;
class GlobalRef;
class AttributeRef;
class V1Program;
class IntMod;
class IDPDKNode;
class DpdkDeclaration;
class DpdkExternDeclaration;
class DpdkHeaderType;
class DpdkHeaderInstance;
class DpdkStructType;
class DpdkAsmStatement;
class DpdkAction;
class DpdkTable;
class DpdkSelector;
class DpdkLearner;
class DpdkAsmProgram;
class DpdkListStatement;
class DpdkApplyStatement;
class DpdkLearnStatement;
class DpdkMirrorStatement;
class DpdkEmitStatement;
class DpdkExtractStatement;
class DpdkLookaheadStatement;
class DpdkJmpStatement;
class DpdkJmpLabelStatement;
class DpdkJmpHitStatement;
class DpdkJmpMissStatement;
class DpdkJmpActionStatement;
class DpdkJmpIfActionRunStatement;
class DpdkJmpIfActionNotRunStatement;
class DpdkJmpHeaderStatement;
class DpdkJmpIfInvalidStatement;
class DpdkJmpIfValidStatement;
class DpdkJmpCondStatement;
class DpdkJmpEqualStatement;
class DpdkJmpNotEqualStatement;
class DpdkJmpGreaterEqualStatement;
class DpdkJmpGreaterStatement;
class DpdkJmpLessOrEqualStatement;
class DpdkJmpLessStatement;
class DpdkRxStatement;
class DpdkTxStatement;
class DpdkAssignmentStatement;
class DpdkUnaryStatement;
class DpdkMovStatement;
class DpdkMovhStatement;
class DpdkBinaryStatement;
class DpdkAddStatement;
class DpdkAndStatement;
class DpdkShlStatement;
class DpdkShrStatement;
class DpdkSubStatement;
class DpdkOrStatement;
class DpdkXorStatement;
class DpdkRecircidStatement;
class DpdkReturnStatement;
class DpdkRearmStatement;
class DpdkRecirculateStatement;
class DpdkLabelStatement;
class DpdkChecksumAddStatement;
class DpdkChecksumSubStatement;
class DpdkChecksumClearStatement;
class DpdkHashDeclStatement;
class DpdkGetHashStatement;
class DpdkGetChecksumStatement;
class DpdkCastStatement;
class DpdkVerifyStatement;
class DpdkMeterDeclStatement;
class DpdkMeterExecuteStatement;
class DpdkGetTableEntryIndex;
class DpdkCounterCountStatement;
class DpdkRegisterDeclStatement;
class DpdkRegisterReadStatement;
class DpdkRegisterWriteStatement;
class DpdkValidateStatement;
class DpdkInvalidateStatement;
class DpdkDropStatement;
class TCKernelMetadata;
class TCActionParam;
class TCDefaultActionParam;
class TCAction;
class TCEntry;
class TCTable;
class TCKey;
class TCExternInstance;
class TCExtern;
class TCPipeline;
class StateVariable;
class TaintExpression;
class Extracted_Varbits;
class ConcolicVariable;
class HeaderExpression;
class InOutReference;
class UninitializedTaintExpression;
namespace BFN {
class HardwareConstrainedField;
}  // namespace BFN
namespace BFN {
class Pipe;
}  // namespace BFN
namespace BFN {
class BridgePath;
}  // namespace BFN
namespace BFN {
class Toplevel;
}  // namespace BFN
namespace BFN {
class Unit;
}  // namespace BFN
class InstanceRef;
class V1InstanceRef;
class MetadataInfo;
namespace BFN {
class Value;
}  // namespace BFN
namespace BFN {
class Reference;
}  // namespace BFN
class TempVar;
class Padding;
namespace BFN {
class Type_FixedSizeHeader;
}  // namespace BFN
namespace BFN {
class ContainerRef;
}  // namespace BFN
namespace BFN {
class ContainerBitRef;
}  // namespace BFN
namespace BFN {
class AliasMember;
}  // namespace BFN
namespace BFN {
class AliasSlice;
}  // namespace BFN
class HashListExpression;
class HashStructExpression;
namespace BFN {
class ReinterpretCast;
}  // namespace BFN
namespace BFN {
class SignExtend;
}  // namespace BFN
namespace BFN {
class TnaControl;
}  // namespace BFN
namespace BFN {
class TnaDeparser;
}  // namespace BFN
namespace BFN {
class TnaParser;
}  // namespace BFN
namespace BFN {
class P4Thread;
}  // namespace BFN
namespace MAU {
class Table;
}  // namespace MAU
namespace MAU {
class BackendAttached;
}  // namespace MAU
namespace MAU {
class AttachedMemory;
}  // namespace MAU
namespace MAU {
class Synth2Port;
}  // namespace MAU
namespace MAU {
class Counter;
}  // namespace MAU
namespace MAU {
class MeterBus2Port;
}  // namespace MAU
namespace MAU {
class Meter;
}  // namespace MAU
namespace MAU {
class StatefulAlu;
}  // namespace MAU
namespace MAU {
class Selector;
}  // namespace MAU
namespace MAU {
class TernaryIndirect;
}  // namespace MAU
namespace MAU {
class ActionData;
}  // namespace MAU
namespace MAU {
class IdleTime;
}  // namespace MAU
namespace MAU {
class TableSeq;
}  // namespace MAU
namespace MAU {
class Primitive;
}  // namespace MAU
namespace MAU {
class TypedPrimitive;
}  // namespace MAU
namespace MAU {
class Instruction;
}  // namespace MAU
namespace MAU {
class SaluInstruction;
}  // namespace MAU
namespace MAU {
class ActionArg;
}  // namespace MAU
namespace MAU {
class ConditionalArg;
}  // namespace MAU
namespace MAU {
class StatefulCounter;
}  // namespace MAU
namespace MAU {
class StatefulCall;
}  // namespace MAU
namespace MAU {
class VLIWInstruction;
}  // namespace MAU
namespace MAU {
class Action;
}  // namespace MAU
namespace MAU {
class SaluAction;
}  // namespace MAU
namespace MAU {
class FieldListExpression;
}  // namespace MAU
namespace MAU {
class HashGenExpression;
}  // namespace MAU
namespace MAU {
class HashDist;
}  // namespace MAU
namespace MAU {
class IXBarExpression;
}  // namespace MAU
namespace MAU {
class ActionDataConstant;
}  // namespace MAU
namespace MAU {
class RandomNumber;
}  // namespace MAU
namespace MAU {
class AttachedOutput;
}  // namespace MAU
namespace MAU {
class SaluReg;
}  // namespace MAU
namespace MAU {
class SaluCmpReg;
}  // namespace MAU
namespace MAU {
class SaluFunction;
}  // namespace MAU
namespace MAU {
class SaluRegfileRow;
}  // namespace MAU
namespace MAU {
class MultiOperand;
}  // namespace MAU
namespace MAU {
class WrappedSlice;
}  // namespace MAU
namespace MAU {
class TableKey;
}  // namespace MAU
class RangeMatch;
namespace BFN {
class UnresolvedHeaderStackIndex;
}  // namespace BFN
namespace BFN {
class ParserRVal;
}  // namespace BFN
namespace BFN {
class InputBufferRVal;
}  // namespace BFN
namespace BFN {
class PacketRVal;
}  // namespace BFN
namespace BFN {
class MetadataRVal;
}  // namespace BFN
namespace BFN {
class ConstantRVal;
}  // namespace BFN
namespace BFN {
class SavedRVal;
}  // namespace BFN
namespace BFN {
class ParserLVal;
}  // namespace BFN
namespace BFN {
class FieldLVal;
}  // namespace BFN
namespace BFN {
class MatchLVal;
}  // namespace BFN
namespace BFN {
class ChecksumLVal;
}  // namespace BFN
namespace BFN {
class TotalContainerSize;
}  // namespace BFN
namespace BFN {
class ParserPrimitive;
}  // namespace BFN
namespace BFN {
class Extract;
}  // namespace BFN
namespace BFN {
class ExtractPhv;
}  // namespace BFN
namespace BFN {
class ExtractClot;
}  // namespace BFN
namespace BFN {
class SaveToRegister;
}  // namespace BFN
namespace BFN {
class ParserCounterPrimitive;
}  // namespace BFN
namespace BFN {
class ParserZeroInit;
}  // namespace BFN
namespace BFN {
class ParserCounterLoadImm;
}  // namespace BFN
namespace BFN {
class ParserCounterLoadPkt;
}  // namespace BFN
namespace BFN {
class ParserCounterIncrement;
}  // namespace BFN
namespace BFN {
class ParserCounterDecrement;
}  // namespace BFN
namespace BFN {
class ParserCounterPop;
}  // namespace BFN
namespace BFN {
class ParserCounterRVal;
}  // namespace BFN
namespace BFN {
class ParserCounterIsZero;
}  // namespace BFN
namespace BFN {
class ParserCounterIsNegative;
}  // namespace BFN
namespace BFN {
class ParserPrioritySet;
}  // namespace BFN
namespace BFN {
class ParserChecksumPrimitive;
}  // namespace BFN
namespace BFN {
class ParserChecksumWritePrimitive;
}  // namespace BFN
namespace BFN {
class ChecksumVerify;
}  // namespace BFN
namespace BFN {
class ChecksumResidualDeposit;
}  // namespace BFN
namespace BFN {
class ChecksumDepositToClot;
}  // namespace BFN
namespace BFN {
class ChecksumAdd;
}  // namespace BFN
namespace BFN {
class ChecksumSubtract;
}  // namespace BFN
namespace BFN {
class HdrLenIncStop;
}  // namespace BFN
namespace BFN {
class ParserMatchValue;
}  // namespace BFN
namespace BFN {
class ParserConstMatchValue;
}  // namespace BFN
namespace BFN {
class ParserPvsMatchValue;
}  // namespace BFN
namespace BFN {
class Phase0;
}  // namespace BFN
namespace BFN {
class Transition;
}  // namespace BFN
namespace BFN {
class Select;
}  // namespace BFN
namespace BFN {
class ParserState;
}  // namespace BFN
namespace BFN {
class AbstractParser;
}  // namespace BFN
namespace BFN {
class Parser;
}  // namespace BFN
namespace BFN {
class GhostParser;
}  // namespace BFN
namespace BFN {
class DigestFieldList;
}  // namespace BFN
namespace BFN {
class Digest;
}  // namespace BFN
namespace BFN {
class DeparserPrimitive;
}  // namespace BFN
namespace BFN {
class Emit;
}  // namespace BFN
namespace BFN {
class EmitField;
}  // namespace BFN
namespace BFN {
class EmitConstant;
}  // namespace BFN
namespace BFN {
class EmitClot;
}  // namespace BFN
namespace BFN {
class ChecksumEntry;
}  // namespace BFN
namespace BFN {
class EmitChecksum;
}  // namespace BFN
namespace BFN {
class DeparserParameter;
}  // namespace BFN
namespace BFN {
class AbstractDeparser;
}  // namespace BFN
namespace BFN {
class Deparser;
}  // namespace BFN
namespace BFN {
class LoweredParserRVal;
}  // namespace BFN
namespace BFN {
class LoweredInputBufferRVal;
}  // namespace BFN
namespace BFN {
class LoweredPacketRVal;
}  // namespace BFN
namespace BFN {
class LoweredMetadataRVal;
}  // namespace BFN
namespace BFN {
class LoweredConstantRVal;
}  // namespace BFN
namespace BFN {
class LoweredParserPrimitive;
}  // namespace BFN
namespace BFN {
class LoweredExtractPhv;
}  // namespace BFN
namespace BFN {
class LoweredExtractClot;
}  // namespace BFN
namespace BFN {
class LoweredParserChecksum;
}  // namespace BFN
namespace BFN {
class LoweredSave;
}  // namespace BFN
namespace BFN {
class LoweredSelect;
}  // namespace BFN
namespace BFN {
class LoweredParserMatch;
}  // namespace BFN
namespace BFN {
class LoweredParserState;
}  // namespace BFN
namespace BFN {
class BaseLoweredParser;
}  // namespace BFN
namespace BFN {
class LoweredParser;
}  // namespace BFN
namespace BFN {
class LoweredEmit;
}  // namespace BFN
namespace BFN {
class LoweredEmitPhv;
}  // namespace BFN
namespace BFN {
class LoweredEmitChecksum;
}  // namespace BFN
namespace BFN {
class LoweredEmitClot;
}  // namespace BFN
namespace BFN {
class LoweredEmitConstant;
}  // namespace BFN
namespace BFN {
class LoweredDeparserParameter;
}  // namespace BFN
namespace BFN {
class DigestTableEntry;
}  // namespace BFN
namespace BFN {
class DigestField;
}  // namespace BFN
namespace BFN {
class LearningTableEntry;
}  // namespace BFN
namespace BFN {
class LoweredDigest;
}  // namespace BFN
namespace BFN {
class ChecksumPhvInput;
}  // namespace BFN
namespace BFN {
class ChecksumClotInput;
}  // namespace BFN
namespace BFN {
class PartialChecksumUnitConfig;
}  // namespace BFN
namespace BFN {
class FullChecksumUnitConfig;
}  // namespace BFN
namespace BFN {
class LoweredDeparser;
}  // namespace BFN

enum class NodeKind : RTTI::TypeId {
  Auto = 0,
  INode = 1,
  Node = 2,
  CompileTimeValue = 3,
  Type = 4,
  IMayBeGenericType = 5,
  IApply = 6,
  INamespace = 7,
  ISimpleNamespace = 8,
  IGeneralNamespace = 9,
  INestedNamespace = 10,
  IFunctional = 11,
  ITypeVar = 12,
  IContainer = 13,
  Type_Base = 14,
  Type_Unknown = 15,
  StatOrDecl = 16,
  Declaration = 17,
  Type_Declaration = 18,
  Expression = 19,
  Operation = 20,
  Path = 21,
  NamedExpression = 22,
  AnnotationToken = 23,
  Annotation = 24,
  IAnnotated = 25,
  IInstance = 26,
  Argument = 27,
  Type_Any = 28,
  Type_Fragment = 29,
  Type_Type = 30,
  Type_Boolean = 31,
  Type_State = 32,
  Type_Bits = 33,
  Type_Varbits = 34,
  Parameter = 35,
  ParameterList = 36,
  Type_Var = 37,
  Type_InfInt = 38,
  Type_Dontcare = 39,
  Type_Void = 40,
  Type_MatchKind = 41,
  TypeParameters = 42,
  StructField = 43,
  Type_StructLike = 44,
  Type_Struct = 45,
  Type_UnknownStruct = 46,
  Type_HeaderUnion = 47,
  Type_Header = 48,
  Type_Set = 49,
  Type_Indexed = 50,
  Type_BaseList = 51,
  Type_List = 52,
  Type_Tuple = 53,
  Type_P4List = 54,
  Type_ArchBlock = 55,
  Type_Package = 56,
  Type_Parser = 57,
  Type_Control = 58,
  Type_Name = 59,
  Type_Array = 60,
  Type_Specialized = 61,
  Type_SpecializedCanonical = 62,
  Declaration_ID = 63,
  Type_String = 64,
  Type_Enum = 65,
  SerEnumMember = 66,
  Type_SerEnum = 67,
  Type_Table = 68,
  Type_ActionEnum = 69,
  Type_MethodBase = 70,
  Type_Method = 71,
  ArgumentInfo = 72,
  Type_MethodCall = 73,
  Type_Action = 74,
  Method = 75,
  Type_Typedef = 76,
  Type_Newtype = 77,
  Type_Extern = 78,
  Operation_Unary = 79,
  Neg = 80,
  UPlus = 81,
  Cmpl = 82,
  LNot = 83,
  Operation_Binary = 84,
  Operation_Ternary = 85,
  Operation_Relation = 86,
  Mul = 87,
  Statement = 88,
  BaseAssignmentStatement = 89,
  OpAssignmentStatement = 90,
  MulAssign = 91,
  Div = 92,
  DivAssign = 93,
  Mod = 94,
  ModAssign = 95,
  Add = 96,
  AddAssign = 97,
  Sub = 98,
  SubAssign = 99,
  AddSat = 100,
  AddSatAssign = 101,
  SubSat = 102,
  SubSatAssign = 103,
  Shl = 104,
  ShlAssign = 105,
  Shr = 106,
  ShrAssign = 107,
  Equ = 108,
  Neq = 109,
  Lss = 110,
  Leq = 111,
  Grt = 112,
  Geq = 113,
  BAnd = 114,
  BAndAssign = 115,
  BOr = 116,
  BOrAssign = 117,
  BXor = 118,
  BXorAssign = 119,
  LAnd = 120,
  LOr = 121,
  Dots = 122,
  NamedDots = 123,
  Literal = 124,
  Constant = 125,
  BoolLiteral = 126,
  StringLiteral = 127,
  PathExpression = 128,
  TypeNameExpression = 129,
  AbstractSlice = 130,
  Slice = 131,
  PlusSlice = 132,
  Member = 133,
  Concat = 134,
  ArrayIndex = 135,
  Range = 136,
  Mask = 137,
  Mux = 138,
  DefaultExpression = 139,
  This = 140,
  Cast = 141,
  SelectCase = 142,
  SelectExpression = 143,
  MethodCallExpression = 144,
  ConstructorCallExpression = 145,
  BaseListExpression = 146,
  ListExpression = 147,
  P4ListExpression = 148,
  StructExpression = 149,
  Invalid = 150,
  InvalidHeader = 151,
  InvalidHeaderUnion = 152,
  HeaderStackExpression = 153,
  ListCompileTimeValue = 154,
  P4ListCompileTimeValue = 155,
  StructCompileTimeValue = 156,
  CompileTimeMethodCall = 157,
  SymbolicVariable = 158,
  ParserState = 159,
  P4Parser = 160,
  P4Control = 161,
  P4Action = 162,
  Type_Error = 163,
  Declaration_MatchKind = 164,
  PropertyValue = 165,
  ExpressionValue = 166,
  ExpressionListValue = 167,
  ActionListElement = 168,
  ActionList = 169,
  KeyElement = 170,
  Key = 171,
  Entry = 172,
  EntriesList = 173,
  Property = 174,
  TableProperties = 175,
  P4Table = 176,
  P4ValueSet = 177,
  Declaration_Variable = 178,
  Declaration_Constant = 179,
  Declaration_Instance = 180,
  P4Program = 181,
  ExitStatement = 182,
  ReturnStatement = 183,
  EmptyStatement = 184,
  AssignmentStatement = 185,
  IfStatement = 186,
  BreakStatement = 187,
  ContinueStatement = 188,
  BlockStatement = 189,
  MethodCallStatement = 190,
  SwitchCase = 191,
  SwitchStatement = 192,
  LoopStatement = 193,
  ForStatement = 194,
  ForInStatement = 195,
  Function = 196,
  Block = 197,
  TableBlock = 198,
  InstantiatedBlock = 199,
  ParserBlock = 200,
  ControlBlock = 201,
  PackageBlock = 202,
  ExternBlock = 203,
  ToplevelBlock = 204,
  Type_Block = 205,
  Type_Counter = 206,
  Type_Expression = 207,
  Type_FieldListCalculation = 208,
  Type_Meter = 209,
  Type_Register = 210,
  Type_AnyTable = 211,
  HeaderOrMetadata = 212,
  Header = 213,
  HeaderStack = 214,
  v1HeaderType = 215,
  Metadata = 216,
  HeaderRef = 217,
  ConcreteHeaderRef = 218,
  HeaderStackItemRef = 219,
  If = 220,
  NamedCond = 221,
  Apply = 222,
  Primitive = 223,
  FieldList = 224,
  FieldListCalculation = 225,
  CalculatedField = 226,
  ParserValueSet = 227,
  CaseEntry = 228,
  V1Parser = 229,
  ParserException = 230,
  Attached = 231,
  Stateful = 232,
  CounterOrMeter = 233,
  Counter = 234,
  Meter = 235,
  Register = 236,
  PrimitiveAction = 237,
  NameList = 238,
  ActionArg = 239,
  ActionFunction = 240,
  ActionProfile = 241,
  ActionSelector = 242,
  V1Table = 243,
  V1Control = 244,
  AttribLocal = 245,
  AttribLocals = 246,
  Attribute = 247,
  GlobalRef = 248,
  AttributeRef = 249,
  V1Program = 250,
  IntMod = 251,
  IDPDKNode = 252,
  DpdkDeclaration = 253,
  DpdkExternDeclaration = 254,
  DpdkHeaderType = 255,
  DpdkHeaderInstance = 256,
  DpdkStructType = 257,
  DpdkAsmStatement = 258,
  DpdkAction = 259,
  DpdkTable = 260,
  DpdkSelector = 261,
  DpdkLearner = 262,
  DpdkAsmProgram = 263,
  DpdkListStatement = 264,
  DpdkApplyStatement = 265,
  DpdkLearnStatement = 266,
  DpdkMirrorStatement = 267,
  DpdkEmitStatement = 268,
  DpdkExtractStatement = 269,
  DpdkLookaheadStatement = 270,
  DpdkJmpStatement = 271,
  DpdkJmpLabelStatement = 272,
  DpdkJmpHitStatement = 273,
  DpdkJmpMissStatement = 274,
  DpdkJmpActionStatement = 275,
  DpdkJmpIfActionRunStatement = 276,
  DpdkJmpIfActionNotRunStatement = 277,
  DpdkJmpHeaderStatement = 278,
  DpdkJmpIfInvalidStatement = 279,
  DpdkJmpIfValidStatement = 280,
  DpdkJmpCondStatement = 281,
  DpdkJmpEqualStatement = 282,
  DpdkJmpNotEqualStatement = 283,
  DpdkJmpGreaterEqualStatement = 284,
  DpdkJmpGreaterStatement = 285,
  DpdkJmpLessOrEqualStatement = 286,
  DpdkJmpLessStatement = 287,
  DpdkRxStatement = 288,
  DpdkTxStatement = 289,
  DpdkAssignmentStatement = 290,
  DpdkUnaryStatement = 291,
  DpdkMovStatement = 292,
  DpdkMovhStatement = 293,
  DpdkBinaryStatement = 294,
  DpdkAddStatement = 295,
  DpdkAndStatement = 296,
  DpdkShlStatement = 297,
  DpdkShrStatement = 298,
  DpdkSubStatement = 299,
  DpdkOrStatement = 300,
  DpdkXorStatement = 301,
  DpdkRecircidStatement = 302,
  DpdkReturnStatement = 303,
  DpdkRearmStatement = 304,
  DpdkRecirculateStatement = 305,
  DpdkLabelStatement = 306,
  DpdkChecksumAddStatement = 307,
  DpdkChecksumSubStatement = 308,
  DpdkChecksumClearStatement = 309,
  DpdkHashDeclStatement = 310,
  DpdkGetHashStatement = 311,
  DpdkGetChecksumStatement = 312,
  DpdkCastStatement = 313,
  DpdkVerifyStatement = 314,
  DpdkMeterDeclStatement = 315,
  DpdkMeterExecuteStatement = 316,
  DpdkGetTableEntryIndex = 317,
  DpdkCounterCountStatement = 318,
  DpdkRegisterDeclStatement = 319,
  DpdkRegisterReadStatement = 320,
  DpdkRegisterWriteStatement = 321,
  DpdkValidateStatement = 322,
  DpdkInvalidateStatement = 323,
  DpdkDropStatement = 324,
  TCKernelMetadata = 325,
  TCActionParam = 326,
  TCDefaultActionParam = 327,
  TCAction = 328,
  TCEntry = 329,
  TCTable = 330,
  TCKey = 331,
  TCExternInstance = 332,
  TCExtern = 333,
  TCPipeline = 334,
  StateVariable = 335,
  TaintExpression = 336,
  Extracted_Varbits = 337,
  ConcolicVariable = 338,
  HeaderExpression = 339,
  InOutReference = 340,
  UninitializedTaintExpression = 341,
  BFN_HardwareConstrainedField = 342,
  BFN_Pipe = 343,
  BFN_BridgePath = 344,
  BFN_Toplevel = 345,
  BFN_Unit = 346,
  InstanceRef = 347,
  V1InstanceRef = 348,
  MetadataInfo = 349,
  BFN_Value = 350,
  BFN_Reference = 351,
  TempVar = 352,
  Padding = 353,
  BFN_Type_FixedSizeHeader = 354,
  BFN_ContainerRef = 355,
  BFN_ContainerBitRef = 356,
  BFN_AliasMember = 357,
  BFN_AliasSlice = 358,
  HashListExpression = 359,
  HashStructExpression = 360,
  BFN_ReinterpretCast = 361,
  BFN_SignExtend = 362,
  BFN_TnaControl = 363,
  BFN_TnaDeparser = 364,
  BFN_TnaParser = 365,
  BFN_P4Thread = 366,
  MAU_Table = 367,
  MAU_BackendAttached = 368,
  MAU_AttachedMemory = 369,
  MAU_Synth2Port = 370,
  MAU_Counter = 371,
  MAU_MeterBus2Port = 372,
  MAU_Meter = 373,
  MAU_StatefulAlu = 374,
  MAU_Selector = 375,
  MAU_TernaryIndirect = 376,
  MAU_ActionData = 377,
  MAU_IdleTime = 378,
  MAU_TableSeq = 379,
  MAU_Primitive = 380,
  MAU_TypedPrimitive = 381,
  MAU_Instruction = 382,
  MAU_SaluInstruction = 383,
  MAU_ActionArg = 384,
  MAU_ConditionalArg = 385,
  MAU_StatefulCounter = 386,
  MAU_StatefulCall = 387,
  MAU_VLIWInstruction = 388,
  MAU_Action = 389,
  MAU_SaluAction = 390,
  MAU_FieldListExpression = 391,
  MAU_HashGenExpression = 392,
  MAU_HashDist = 393,
  MAU_IXBarExpression = 394,
  MAU_ActionDataConstant = 395,
  MAU_RandomNumber = 396,
  MAU_AttachedOutput = 397,
  MAU_SaluReg = 398,
  MAU_SaluCmpReg = 399,
  MAU_SaluFunction = 400,
  MAU_SaluRegfileRow = 401,
  MAU_MultiOperand = 402,
  MAU_WrappedSlice = 403,
  MAU_TableKey = 404,
  RangeMatch = 405,
  BFN_UnresolvedHeaderStackIndex = 406,
  BFN_ParserRVal = 407,
  BFN_InputBufferRVal = 408,
  BFN_PacketRVal = 409,
  BFN_MetadataRVal = 410,
  BFN_ConstantRVal = 411,
  BFN_SavedRVal = 412,
  BFN_ParserLVal = 413,
  BFN_FieldLVal = 414,
  BFN_MatchLVal = 415,
  BFN_ChecksumLVal = 416,
  BFN_TotalContainerSize = 417,
  BFN_ParserPrimitive = 418,
  BFN_Extract = 419,
  BFN_ExtractPhv = 420,
  BFN_ExtractClot = 421,
  BFN_SaveToRegister = 422,
  BFN_ParserCounterPrimitive = 423,
  BFN_ParserZeroInit = 424,
  BFN_ParserCounterLoadImm = 425,
  BFN_ParserCounterLoadPkt = 426,
  BFN_ParserCounterIncrement = 427,
  BFN_ParserCounterDecrement = 428,
  BFN_ParserCounterPop = 429,
  BFN_ParserCounterRVal = 430,
  BFN_ParserCounterIsZero = 431,
  BFN_ParserCounterIsNegative = 432,
  BFN_ParserPrioritySet = 433,
  BFN_ParserChecksumPrimitive = 434,
  BFN_ParserChecksumWritePrimitive = 435,
  BFN_ChecksumVerify = 436,
  BFN_ChecksumResidualDeposit = 437,
  BFN_ChecksumDepositToClot = 438,
  BFN_ChecksumAdd = 439,
  BFN_ChecksumSubtract = 440,
  BFN_HdrLenIncStop = 441,
  BFN_ParserMatchValue = 442,
  BFN_ParserConstMatchValue = 443,
  BFN_ParserPvsMatchValue = 444,
  BFN_Phase0 = 445,
  BFN_Transition = 446,
  BFN_Select = 447,
  BFN_ParserState = 448,
  BFN_AbstractParser = 449,
  BFN_Parser = 450,
  BFN_GhostParser = 451,
  BFN_DigestFieldList = 452,
  BFN_Digest = 453,
  BFN_DeparserPrimitive = 454,
  BFN_Emit = 455,
  BFN_EmitField = 456,
  BFN_EmitConstant = 457,
  BFN_EmitClot = 458,
  BFN_ChecksumEntry = 459,
  BFN_EmitChecksum = 460,
  BFN_DeparserParameter = 461,
  BFN_AbstractDeparser = 462,
  BFN_Deparser = 463,
  BFN_LoweredParserRVal = 464,
  BFN_LoweredInputBufferRVal = 465,
  BFN_LoweredPacketRVal = 466,
  BFN_LoweredMetadataRVal = 467,
  BFN_LoweredConstantRVal = 468,
  BFN_LoweredParserPrimitive = 469,
  BFN_LoweredExtractPhv = 470,
  BFN_LoweredExtractClot = 471,
  BFN_LoweredParserChecksum = 472,
  BFN_LoweredSave = 473,
  BFN_LoweredSelect = 474,
  BFN_LoweredParserMatch = 475,
  BFN_LoweredParserState = 476,
  BFN_BaseLoweredParser = 477,
  BFN_LoweredParser = 478,
  BFN_LoweredEmit = 479,
  BFN_LoweredEmitPhv = 480,
  BFN_LoweredEmitChecksum = 481,
  BFN_LoweredEmitClot = 482,
  BFN_LoweredEmitConstant = 483,
  BFN_LoweredDeparserParameter = 484,
  BFN_DigestTableEntry = 485,
  BFN_DigestField = 486,
  BFN_LearningTableEntry = 487,
  BFN_LoweredDigest = 488,
  BFN_ChecksumPhvInput = 489,
  BFN_ChecksumClotInput = 490,
  BFN_PartialChecksumUnitConfig = 491,
  BFN_FullChecksumUnitConfig = 492,
  BFN_LoweredDeparser = 493,
  IDeclaration = 494,
  VectorBase = 495
};
enum class NodeDiscriminator : RTTI::TypeId {
  NodeT = UINT64_C(1),
  VectorT = UINT64_C(1),
  IndexedVectorT = UINT64_C(2),
  Auto = UINT64_C(0xFF)
};
 inline bool operator==(RTTI::TypeId lhs, NodeKind rhs) { return lhs == RTTI::TypeId(rhs); }
 inline bool operator==(NodeKind lhs, RTTI::TypeId rhs) { return RTTI::TypeId(lhs) == rhs; }
 inline bool operator!=(RTTI::TypeId lhs, NodeKind rhs) { return lhs != RTTI::TypeId(rhs); }
 inline bool operator!=(NodeKind lhs, RTTI::TypeId rhs) { return RTTI::TypeId(lhs) != rhs; }
 inline bool operator==(RTTI::TypeId lhs, NodeDiscriminator rhs) { return lhs == RTTI::TypeId(rhs); }
 inline bool operator==(NodeDiscriminator lhs, RTTI::TypeId rhs) { return RTTI::TypeId(lhs) == rhs; }
 inline bool operator!=(RTTI::TypeId lhs, NodeDiscriminator rhs) { return lhs != RTTI::TypeId(rhs); }
 inline bool operator!=(NodeDiscriminator lhs, RTTI::TypeId rhs) { return RTTI::TypeId(lhs) != rhs; }
}  // namespace P4::IR
