/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 18 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"

#define YYDEBUG 1
#include "backends/tofino/bf-asm/asm-types.h"
#include <cinttypes>
#include <string.h>
#include "backends/tofino/bf-asm/sections.h"
#include <map>
#include <string>
static int yylex();
static void yyerror(const char *, ...);
static int lineno;
static std::map<int, std::pair<std::string, int>> line_file_map;

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
/* DANGER -- The value/command functions take non-const references to
 * value_t and MOVE them, so the source should not be used or cleaned
 * up afterwards.  This matches up with how bison  actions work -- in
 * the normal case it does NOT try to destroy stuff on the value stack,
 * but rather just pops it and lets it go.  Do not try to use them
 * outside of bison action code */
static value_t value(int64_t v, int lineno_adj) {
    value_t rv = {tINT, lineno - lineno_adj};
    rv.i = v;
    return rv; }
static value_t value(VECTOR(uintptr_t) &v, int lineno_adj) {
    value_t rv{tBIGINT, lineno - lineno_adj};
    rv.bigi = v;
    return rv; }
static value_t value(int lo, int hi, int lineno_adj) {
    value_t rv{tRANGE, lineno - lineno_adj};
    rv.range.lo = lo;
    rv.range.hi = hi;
    return rv; }
static value_t value(char *v, int lineno_adj) {
    value_t rv{tSTR, lineno - lineno_adj};
    rv.s = v;
    return rv; }
static value_t value(match_t v, int lineno_adj) {
    value_t rv{tMATCH, lineno - lineno_adj};
    rv.m = v;
    return rv; }
static value_t value(VECTOR(match_t) v, int lineno_adj) {
    value_t rv{tBIGMATCH, lineno - lineno_adj};
    rv.bigm = v;
    return rv; }
static value_t value(VECTOR(value_t) &v, int lineno_adj) {
    value_t rv{tVEC, lineno - lineno_adj};
    if (v.size > 0) rv.lineno = v.data[0].lineno;
    rv.vec = v;
    return rv; }
static value_t value(VECTOR(pair_t) &v, int lineno_adj) {
    value_t rv{tMAP, lineno - lineno_adj};
    if (v.size > 0) rv.lineno = v.data[0].key.lineno;
    rv.map = v;
    return rv; }
static value_t empty_vector(int lineno_adj) {
    value_t rv{tVEC, lineno - lineno_adj};
    memset(&rv.vec, 0, sizeof(rv.vec));
    return rv; }
static value_t empty_map(int lineno_adj) {
    value_t rv{tMAP, lineno - lineno_adj};
    memset(&rv.vec, 0, sizeof(rv.vec));
    return rv; }
static value_t singleton_map(const value_t &k, const value_t &v) {
    value_t rv{tMAP, k.lineno};
    VECTOR_init1(rv.map, pair_t(k, v));
    return rv; }
static value_t command(char *cmd, const VECTOR(value_t) &args, int lineno_adj) {
    value_t rv{tCMD, lineno - lineno_adj};
    if (args.size && args.data[0].lineno < rv.lineno)
        rv.lineno = args.data[0].lineno;
    rv.vec = args;
    VECTOR_insert(rv.vec, 0, 1);
    rv[0] = value(cmd, 0);
    rv[0].lineno = rv.lineno;
    return rv; }
static value_t command(char *cmd, value_t &arg, int lineno_adj) {
    value_t rv{tCMD, lineno - lineno_adj};
    if (arg.lineno < rv.lineno)
        rv.lineno = arg.lineno;
    VECTOR_init2(rv.vec, value(cmd, 0), arg);
    rv[0].lineno = rv.lineno;
    return rv; }
static value_t command(char *cmd, value_t &&arg, int lineno_adj) {
    return command(cmd, arg, lineno_adj); }
static value_t command(char *cmd, bool merge, value_t &a1, value_t &a2, int lineno_adj) {
    if (merge && a1.type == tCMD && a1 == cmd && a1.vec.size > 2) {
        free(cmd);
        VECTOR_add(a1.vec, a2);
        return a1; }
    if (merge && a2.type == tCMD && a2 == cmd && a2.vec.size > 2) {
        free(cmd);
        VECTOR_insert(a2.vec, 1);
        a2.vec[1] = a1;
        return a2; }
    value_t rv{tCMD, lineno - lineno_adj};
    if (a1.lineno < rv.lineno)
        rv.lineno = a1.lineno;
    VECTOR_init3(rv.vec, value(cmd, 0), a1, a2);
    rv[0].lineno = rv.lineno;
    return rv; }

#define VAL(...)  value(__VA_ARGS__, yychar == '\n' ? 1 : 0)
#define CMD(...)  command(__VA_ARGS__, yychar == '\n' ? 1 : 0)

#pragma GCC diagnostic pop

#line 180 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "asm-parse.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_LOW_PREC = 3,                   /* LOW_PREC  */
  YYSYMBOL_4_ = 4,                         /* '|'  */
  YYSYMBOL_5_ = 5,                         /* '^'  */
  YYSYMBOL_6_ = 6,                         /* '&'  */
  YYSYMBOL_7_ = 7,                         /* '<'  */
  YYSYMBOL_8_ = 8,                         /* '>'  */
  YYSYMBOL_UNARY = 9,                      /* UNARY  */
  YYSYMBOL_INDENT = 10,                    /* INDENT  */
  YYSYMBOL_UNINDENT = 11,                  /* UNINDENT  */
  YYSYMBOL_DOTDOT = 12,                    /* DOTDOT  */
  YYSYMBOL_INT = 13,                       /* INT  */
  YYSYMBOL_BIGINT = 14,                    /* BIGINT  */
  YYSYMBOL_ID = 15,                        /* ID  */
  YYSYMBOL_STR = 16,                       /* STR  */
  YYSYMBOL_MATCH = 17,                     /* MATCH  */
  YYSYMBOL_BIGMATCH = 18,                  /* BIGMATCH  */
  YYSYMBOL_19_ = 19,                       /* ':'  */
  YYSYMBOL_20_n_ = 20,                     /* '\n'  */
  YYSYMBOL_21_ = 21,                       /* ','  */
  YYSYMBOL_22_ = 22,                       /* '('  */
  YYSYMBOL_23_ = 23,                       /* ')'  */
  YYSYMBOL_24_ = 24,                       /* '-'  */
  YYSYMBOL_25_ = 25,                       /* '!'  */
  YYSYMBOL_26_ = 26,                       /* '?'  */
  YYSYMBOL_27_ = 27,                       /* '['  */
  YYSYMBOL_28_ = 28,                       /* ']'  */
  YYSYMBOL_29_ = 29,                       /* '{'  */
  YYSYMBOL_30_ = 30,                       /* '}'  */
  YYSYMBOL_31_ = 31,                       /* '.'  */
  YYSYMBOL_YYACCEPT = 32,                  /* $accept  */
  YYSYMBOL_start = 33,                     /* start  */
  YYSYMBOL_sections = 34,                  /* sections  */
  YYSYMBOL_section = 35,                   /* section  */
  YYSYMBOL_36_1 = 36,                      /* @1  */
  YYSYMBOL_37_2 = 37,                      /* @2  */
  YYSYMBOL_opt_params = 38,                /* opt_params  */
  YYSYMBOL_params = 39,                    /* params  */
  YYSYMBOL_comma_params = 40,              /* comma_params  */
  YYSYMBOL_param = 41,                     /* param  */
  YYSYMBOL_param_expr = 42,                /* param_expr  */
  YYSYMBOL_opt_indent_elements = 43,       /* opt_indent_elements  */
  YYSYMBOL_indent_elements = 44,           /* indent_elements  */
  YYSYMBOL_45_3 = 45,                      /* @3  */
  YYSYMBOL_elements = 46,                  /* elements  */
  YYSYMBOL_map_elements = 47,              /* map_elements  */
  YYSYMBOL_list_elements = 48,             /* list_elements  */
  YYSYMBOL_map_element = 49,               /* map_element  */
  YYSYMBOL_list_element = 50,              /* list_element  */
  YYSYMBOL_key = 51,                       /* key  */
  YYSYMBOL_value = 52,                     /* value  */
  YYSYMBOL_flow_value = 53,                /* flow_value  */
  YYSYMBOL_value_list = 54,                /* value_list  */
  YYSYMBOL_linewrapped_value_list = 55,    /* linewrapped_value_list  */
  YYSYMBOL_pair_list = 56,                 /* pair_list  */
  YYSYMBOL_pair = 57,                      /* pair  */
  YYSYMBOL_dotvals = 58,                   /* dotvals  */
  YYSYMBOL_error_resync = 59               /* error_resync  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  17
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2945

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  32
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  28
/* YYNRULES -- Number of rules.  */
#define YYNRULES  126
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  242

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   268


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      20,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    25,     2,     2,     2,     2,     6,     2,
      22,    23,     2,     2,    21,    24,    31,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    19,     2,
       7,     2,     8,    26,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    27,     2,    28,     5,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,     4,    30,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   181,   181,   181,   181,   183,   183,   186,   185,   194,
     193,   203,   204,   206,   207,   210,   211,   212,   213,   215,
     216,   217,   218,   219,   220,   221,   222,   225,   226,   227,
     229,   230,   231,   234,   235,   239,   240,   240,   242,   243,
     244,   245,   247,   248,   250,   251,   255,   256,   257,   258,
     259,   260,   261,   262,   266,   267,   271,   272,   276,   277,
     278,   282,   285,   286,   287,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   317,   318,   319,
     320,   322,   323,   324,   325,   326,   327,   331,   332,   335,
     336,   337,   339,   341,   342,   343,   345,   350,   351,   353,
     356,   357,   359,   359,   360,   360,   360,   361,   362,   362,
     362,   363,   363,   363,   363,   364,   364
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "LOW_PREC", "'|'",
  "'^'", "'&'", "'<'", "'>'", "UNARY", "INDENT", "UNINDENT", "DOTDOT",
  "INT", "BIGINT", "ID", "STR", "MATCH", "BIGMATCH", "':'", "'\\n'", "','",
  "'('", "')'", "'-'", "'!'", "'?'", "'['", "']'", "'{'", "'}'", "'.'",
  "$accept", "start", "sections", "section", "@1", "@2", "opt_params",
  "params", "comma_params", "param", "param_expr", "opt_indent_elements",
  "indent_elements", "@3", "elements", "map_elements", "list_elements",
  "map_element", "list_element", "key", "value", "flow_value",
  "value_list", "linewrapped_value_list", "pair_list", "pair", "dotvals",
  "error_resync", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-174)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-127)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      69,     0,  2850,    19,    23,   201,     3,   627,   657,    13,
      32,  1502,   978,    11,  2863,   717,   747,  -174,   235,    70,
     105,  2827,   777,   807,  2377,   271,  1005,   687,  1033,  1061,
    1089,  2827,  2827,  2827,   327,  1117,   198,  1145,    15,   111,
    2314,   357,  2921,     4,     7,  2623,   837,   867,    91,    79,
    2397,   136,   157,  2640,   897,    83,  1173,  1201,  2377,  2827,
    2827,  2827,    73,    75,  2827,   387,  2377,  2827,   417,   299,
    2335,  2827,  2314,  2827,   447,   114,  2827,   927,   957,   171,
    2020,  2041,  2062,  2083,  2104,  2125,  2146,  2167,  2188,  2209,
    2230,  2251,   477,  2272,  2293,  1229,  1257,  1487,   109,  1285,
    2417,  1313,  1341,  1369,  2827,  2827,  1938,  2437,  1963,   158,
     507,   115,  2356,    10,    67,  1968,  2457,    45,  2606,  2827,
     162,  1790,    28,  1809,   297,   159,  1397,  1425,   537,  1453,
    1481,   567,   597,   273,   274,   282,  2477,  1974,  1003,  2827,
    1374,  2588,  1430,   210,  2477,  1828,  2477,  1059,  2657,  2497,
    2640,    55,  2000,   121,  2926,  2674,  1115,  2691,   160,  2517,
    2537,  1522,  2605,   241,  1807,  1171,  2708,  2827,  2827,  2827,
    2725,  2827,  2827,  2827,  2827,  2742,   130,  2889,    93,  2894,
    2827,  1847,  1227,  1866,  1038,  2555,   146,  1043,  1099,  1155,
    2555,  1094,  1211,  1267,  1323,  1150,   130,  2899,  1283,  1542,
    1885,  1339,  1904,  2916,  2827,  2827,  1206,    89,  1395,  1451,
    1581,  1562,  2844,  1923,  1262,  1318,   127,  1600,  2759,  1619,
    2776,  2844,  2572,   165,  2793,   166,  2810,  2555,  2555,  2589,
    1638,  1657,  2555,  1676,  2555,  1695,  1714,  1733,   170,   172,
    1752,  1771
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -174,  -174,   186,   129,  -174,  -174,  -174,   190,  -174,    -8,
    -174,  -174,  -110,  -174,  -174,  -149,  -154,  -118,  -109,   -47,
     -11,    31,    -9,  -173,  -174,   135,  -174,   -31
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     3,     4,     5,    75,    76,    13,    54,   151,    15,
     153,   133,    93,   136,   120,   121,   122,   123,   124,    35,
     206,    37,   207,   208,    43,    44,    39,    50
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,    42,    38,   145,   134,    72,    46,   182,  -108,    70,
      48,  -107,    49,   147,    19,     2,    66,   209,     2,    17,
      55,    56,    57,    -3,   201,    73,    22,   100,  -108,   146,
      45,  -107,   125,    16,    74,   107,    67,  -108,     2,   -38,
    -107,   112,    97,    68,    98,    16,    46,    23,   101,   102,
     103,   181,   118,   106,   235,   236,   108,    51,    16,   238,
     111,   239,    42,   222,   -67,   115,   198,   -33,   200,    -4,
      -2,   140,   229,   147,   125,   165,   166,    79,   -33,     1,
     104,    94,   -33,   105,     2,    16,   210,    59,    60,    61,
      62,    63,   147,   129,   130,    59,    60,    61,    62,    63,
      67,    94,    78,    79,   145,   149,    99,   141,   142,   219,
     220,   145,    64,   159,    77,   160,  -109,   118,    47,    59,
      60,    61,    62,    63,    69,   171,   172,   173,   154,   152,
      67,    94,   127,    18,   114,    18,  -109,   162,    94,   164,
      79,    98,   174,    94,   177,  -109,   179,   225,   226,    95,
      59,    60,    61,    62,    63,   186,   187,   188,   189,   191,
     192,   193,   194,   195,   197,   125,   -16,   -16,    16,   203,
    -111,  -110,   116,   143,   125,   125,   231,   233,   148,   180,
      94,   240,   125,   241,   117,    26,    27,     6,    29,    30,
      94,    94,    14,   214,   215,   118,   216,   119,    11,    58,
      12,    -6,    59,    60,    61,    62,    63,   106,   113,   108,
     -35,   -35,    -6,   106,     0,   108,    -6,     0,     0,    64,
     -35,   -35,   -35,   -35,   -35,   -35,    65,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,    -5,   -35,   -35,   -35,   -35,
     -35,   -37,   -37,     0,     0,     0,    -5,     0,     0,     0,
      -5,   -37,   -37,   -37,   -37,   -37,   -37,     0,   -37,   -37,
     -37,   -37,   -37,   -37,   -37,   -37,     0,   -37,   -37,   -37,
     -37,   -37,   -67,    -8,   -34,   -67,   -67,   -67,   -67,   -67,
       0,     0,   -10,    51,    -8,   -34,     0,     0,    -8,   -34,
     -67,   -67,   -67,   -10,   -67,     0,     0,   -10,   -45,   -67,
     -79,   -67,    52,   -79,   -79,   -79,   -79,   -79,   -45,     0,
     -45,   -45,   -45,     0,   -45,   -45,     0,     0,   -79,   -79,
     -79,   -45,   -79,   -45,   -45,     0,   -45,   -79,   -93,   -79,
     109,   -93,   -93,   -93,   -93,   -93,     0,   -93,   -93,   -93,
     -93,   -93,   -93,     0,   -93,   -93,   -93,   -93,   -93,   -93,
     -93,   -93,   -93,     0,   -93,   -93,   -93,   -93,   -95,     0,
       0,   -95,   -95,   -95,   -95,   -95,     0,   -95,   -95,   -95,
     -95,   -95,   -95,     0,   -95,   -95,   -95,   -95,   -95,   -95,
     -95,   -95,   -95,     0,   -95,   -95,   -95,   -95,   -88,     0,
       0,   -88,   -88,   -88,   -88,   -88,     0,   -88,   -88,   -88,
     -88,   -88,   -88,     0,   -88,   -88,   -88,   -88,   -88,   -88,
     -88,   -88,   -88,     0,   -88,   -88,   -88,   -88,   -87,     0,
       0,   -87,   -87,   -87,   -87,   -87,     0,   -87,   -87,   -87,
     -87,   -87,   -87,     0,   -87,   -87,   -87,   -87,   -87,   -87,
     -87,   -87,   -87,     0,   -87,   -87,   -87,   -87,   -91,     0,
       0,   -91,   -91,   -91,   -91,   -91,     0,   -91,   -91,   -91,
     -91,   -91,   -91,     0,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,     0,   -91,   -91,   -91,   -91,   -94,     0,
       0,   -94,   -94,   -94,   -94,   -94,     0,   -94,   -94,   -94,
     -94,   -94,   -94,     0,   -94,   -94,   -94,   -94,   -94,   -94,
     -94,   -94,   -94,     0,   -94,   -94,   -94,   -94,   -96,     0,
       0,   -96,   -96,   -96,   -96,   -96,     0,   -96,   -96,   -96,
     -96,   -96,   -96,     0,   -96,   -96,   -96,   -96,   -96,   -96,
     -96,   -96,   -96,     0,   -96,   -96,   -96,   -96,   -90,     0,
       0,   -90,   -90,   -90,   -90,   -90,     0,   -90,   -90,   -90,
     -90,   -90,   -90,     0,   -90,   -90,   -90,   -90,   -90,   -90,
     -90,   -90,   -90,     0,   -90,   -90,   -90,   -90,   -89,     0,
       0,   -89,   -89,   -89,   -89,   -89,     0,   -89,   -89,   -89,
     -89,   -89,   -89,     0,   -89,   -89,   -89,   -89,   -89,   -89,
     -89,   -89,   -89,     0,   -89,   -89,   -89,   -89,   -92,     0,
       0,   -92,   -92,   -92,   -92,   -92,     0,   -92,   -92,   -92,
     -92,   -92,   -92,     0,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,     0,   -92,   -92,   -92,   -92,   -19,     0,
       0,   -19,   -19,   -19,   -19,   -19,     0,     0,     0,    20,
     -19,     0,   -19,     0,     0,     0,   -19,   -19,   -19,     0,
     -19,   -19,   -19,     0,   -19,   -19,   -19,   -19,   -20,     0,
       0,   -20,   -20,   -20,   -20,   -20,     0,     0,     0,     0,
     -20,     0,   -20,     0,     0,     0,   -20,   -20,   -20,    21,
     -20,   -20,   -20,     0,   -20,   -20,   -20,   -20,   -65,     0,
       0,   -65,   -65,   -65,   -65,   -65,     0,     0,     0,     0,
       7,     0,     8,     0,     0,     0,   -65,   -65,   -65,    53,
     -65,     9,    10,     0,    11,   -65,    12,   -65,   -13,     0,
       0,   -13,   -13,   -13,   -13,   -13,     0,     0,     0,     0,
     -13,     0,   -13,     0,     0,     0,   -13,   -13,   -13,     0,
     -13,   -13,   -13,     0,   -13,   -13,   -13,   -13,   -26,     0,
       0,   -26,   -26,   -26,   -26,   -26,     0,     0,     0,     0,
     -26,     0,   -26,     0,     0,     0,   -26,   -26,   -26,     0,
     -26,   -26,   -26,     0,   -26,   -26,   -26,   -26,   -21,     0,
       0,   -21,   -21,   -21,   -21,   -21,     0,     0,     0,     0,
     -21,     0,   -21,     0,     0,     0,   -21,   -21,   -21,     0,
     -21,   -21,   -21,     0,   -21,   -21,   -21,   -21,   -22,     0,
       0,   -22,   -22,   -22,   -22,   -22,     0,     0,     0,     0,
     -22,     0,   -22,     0,     0,     0,   -22,   -22,   -22,     0,
     -22,   -22,   -22,     0,   -22,   -22,   -22,   -22,   -14,     0,
       0,   -14,   -14,   -14,   -14,   -14,     0,     0,     0,     0,
     -14,     0,   -14,     0,     0,     0,   -14,   -14,   -14,     0,
     -14,   -14,   -14,     0,   -14,   -14,   -14,   -14,   -23,     0,
       0,   -23,   -23,   -23,   -23,   -23,     0,     0,     0,     0,
     -23,     0,   -23,     0,     0,     0,   -23,   -23,   -23,     0,
     -23,   -23,   -23,     0,   -23,   -23,   -23,   -23,   -66,     0,
       0,   -66,   -66,   -66,   -66,   -66,     0,     0,     0,     0,
       7,     0,     8,     0,     0,     0,   -66,   -66,   -66,     0,
     -66,     9,    10,     0,    11,   -66,    12,   -66,   -24,     0,
       0,   -24,   -24,   -24,   -24,   -24,     0,     0,     0,     0,
     -24,     0,   -24,     0,     0,     0,   -24,   -24,   -24,     0,
     -24,   -24,   -24,     0,   -24,   -24,   -24,   -24,   -25,     0,
       0,   -25,   -25,   -25,   -25,   -25,     0,     0,     0,     0,
     -25,     0,   -25,     0,     0,     0,   -25,   -25,   -25,    40,
     -25,   -25,   -25,     0,   -25,   -25,   -25,   -25,     0,     0,
       0,    25,    26,    27,    28,    29,    30,     0,     0,     0,
      31,     0,    32,    33,   -64,    11,   -68,    12,    41,   -68,
     -68,   -68,   -68,   -68,   -64,     0,   -64,   -64,   -64,     0,
     -64,   -64,     0,     0,   -68,   -68,   -68,   -64,   -68,   -64,
     -64,     0,   -64,   -68,   -86,   -68,     0,   -86,   -86,   -86,
     -86,   -86,   -73,   -73,   -73,   -73,   -73,   -28,   -28,    61,
      62,    63,   -86,   -86,   -86,     0,   -86,   -73,   -73,   204,
     -44,   -86,   -69,   -86,   -28,   -69,   -69,   -69,   -69,   -69,
     -44,     0,   -44,   -44,   -44,     0,   -44,   -44,     0,     0,
     -69,   -69,   -69,   -44,   -69,   -44,   -44,     0,   -44,   -69,
     -70,   -69,     0,   -70,   -70,   -70,   -70,   -70,    59,    60,
      61,    62,    63,   -27,   -27,    61,    62,    63,   -70,   -70,
     -70,     0,   -70,     0,   -15,   -15,   -58,   -70,   -76,   -70,
     -27,   -76,   -76,   -76,   -76,   -76,   -58,     0,   -58,   -58,
     -58,     0,   -58,   -58,     0,     0,   -76,   -76,   -76,   -58,
     -76,   -58,   -58,     0,   -58,   -76,   -75,   -76,     0,   -75,
     -75,   -75,   -75,   -75,    59,    60,    61,    62,    63,   -29,
     -29,   -29,    62,    63,   -75,   -75,   -75,     0,   -75,     0,
     -17,   -17,   -59,   -75,   -77,   -75,   -29,   -77,   -77,   -77,
     -77,   -77,   -59,     0,   -59,   -59,   -59,     0,   -59,   -59,
       0,     0,   -77,   -77,   -77,   -59,   -77,   -59,   -59,     0,
     -59,   -77,   -78,   -77,     0,   -78,   -78,   -78,   -78,   -78,
      59,    60,    61,    62,    63,   -31,   -31,    61,    62,    63,
     -78,   -78,   -78,     0,   -78,     0,   217,   218,   -48,   -78,
     -71,   -78,   -31,   -71,   -71,   -71,   -71,   -71,   -48,     0,
     -48,   -48,   -48,     0,   -48,   -48,     0,     0,   -71,   -71,
     -71,   118,   -71,   -48,   -48,     0,   -48,   -71,   -74,   -71,
       0,   -74,   -74,   -74,   -74,   -74,    59,    60,    61,    62,
      63,   -30,   -30,    61,    62,    63,   -74,   -74,   -74,     0,
     -74,     0,   -18,   -18,   -62,   -74,   -85,   -74,   -30,   -85,
     -85,   -85,   -85,   -85,   -62,     0,   -62,   -62,   -62,     0,
     -62,   -62,     0,     0,   -85,   -85,   -85,   -62,   -85,   -62,
     -62,     0,   -62,   -85,   -81,   -85,     0,   -81,   -81,    61,
      62,    63,    59,    60,    61,    62,    63,   -32,   -32,   -32,
      62,    63,   -81,   -81,   -81,     0,   -81,     0,   223,   224,
     -52,   -81,   -80,   -81,   -32,   -80,   -80,    61,    62,    63,
     -52,     0,   -52,   -52,   -52,     0,   -52,   -52,     0,     0,
     -80,   -80,   -80,   118,   -80,   -52,   -52,     0,   -52,   -80,
     -82,   -80,     0,   -82,   -82,   -82,    62,    63,   -76,   -76,
     -76,   -76,   -76,     0,     0,     0,     0,     0,   -82,   -82,
     -82,     0,   -82,   155,   -76,     0,   -60,   -82,   -73,   -82,
       0,   -73,   -73,   -73,   -73,   -73,   -60,     0,   -60,   -60,
     -60,     0,   -60,   -60,     0,     0,   -73,   -73,   -73,   -60,
     -73,   -60,   -60,     0,   -60,   -73,   -72,   -73,     0,   -72,
     -72,   -72,   -72,   -72,    59,    60,    61,    62,    63,     0,
       0,     0,     0,     0,   -72,   -72,   -72,     0,   -72,   157,
     158,     0,   -61,   -72,   -83,   -72,     0,   -83,   -83,   -83,
     -83,   -83,   -61,     0,   -61,   -61,   -61,     0,   -61,   -61,
       0,     0,   -83,   -83,   -83,   -61,   -83,   -61,   -61,     0,
     -61,   -83,   -84,   -83,     0,   -84,   -84,   -84,   -84,   -84,
       0,    59,    60,    61,    62,    63,     0,     0,     0,     0,
     -84,   -84,   -84,    24,   -84,     0,     0,     0,    64,   -84,
     126,   -84,     0,     0,     0,    25,    26,    27,    28,    29,
      30,     0,     0,   -49,    31,     0,    32,    33,     0,    11,
      34,    12,    79,   -49,     0,   -49,   -49,   -49,     0,   -49,
     -49,     0,     0,   -54,     0,     0,   118,     0,   -49,   -49,
       0,   -49,   212,   -54,     0,   -54,   -54,   -54,     0,   -54,
     -54,     0,     0,   -56,     0,     0,   -54,     0,   -54,   -54,
       0,   -54,   221,   -56,     0,   -56,   -56,   -56,     0,   -56,
     -56,     0,   -63,     0,     0,     0,   -56,     0,   -56,   -56,
       0,   -56,   -63,     0,   -63,   -63,   -63,     0,   -63,   -63,
       0,  -100,     0,     0,     0,   -63,     0,   -63,   -63,     0,
     -63,  -100,     0,  -100,  -100,  -100,     0,  -100,  -100,     0,
     -99,     0,     0,     0,  -100,     0,  -100,  -100,     0,  -100,
     -99,     0,   -99,   -99,   -99,     0,   -99,   -99,     0,   -55,
       0,     0,     0,   -99,     0,   -99,   -99,     0,   -99,   -55,
       0,   -55,   -55,   -55,     0,   -55,   -55,     0,  -104,     0,
       0,     0,   -55,     0,   -55,   -55,     0,   -55,  -104,     0,
    -104,  -104,  -104,     0,  -104,  -104,     0,  -103,     0,     0,
       0,  -104,     0,  -104,  -104,     0,  -104,  -103,     0,  -103,
    -103,  -103,     0,  -103,  -103,     0,  -102,     0,     0,     0,
    -103,     0,  -103,  -103,     0,  -103,  -102,     0,  -102,  -102,
    -102,     0,  -102,  -102,     0,  -101,     0,     0,     0,  -102,
       0,  -102,  -102,     0,  -102,  -101,     0,  -101,  -101,  -101,
       0,  -101,  -101,     0,   -57,     0,     0,     0,  -101,     0,
    -101,  -101,     0,  -101,   -57,     0,   -57,   -57,   -57,     0,
     -57,   -57,     0,  -106,     0,     0,     0,   -57,     0,   -57,
     -57,     0,   -57,  -106,     0,  -106,  -106,  -106,     0,  -106,
    -106,     0,  -105,     0,     0,     0,  -106,     0,  -106,  -106,
       0,  -106,  -105,     0,  -105,  -105,  -105,     0,  -105,  -105,
       0,   144,     0,     0,     0,  -105,     0,  -105,  -105,     0,
    -105,   -40,     0,   117,    26,    27,     0,    29,    30,     0,
     -43,    59,    60,    61,    62,    63,   119,    11,     0,    12,
     -43,     0,   -43,   -43,   -43,     0,   -43,   -43,    64,   -42,
     184,     0,     0,     0,     0,   -43,   -43,     0,   -43,   -42,
       0,   -42,   -42,   -42,     0,   -42,   -42,     0,   -47,     0,
       0,     0,     0,     0,   -42,   -42,     0,   -42,   -47,     0,
     -47,   -47,   -47,     0,   -47,   -47,     0,   -46,     0,     0,
       0,     0,     0,   -47,   -47,     0,   -47,   -46,     0,   -46,
     -46,   -46,     0,   -46,   -46,     0,   -51,     0,     0,     0,
       0,     0,   -46,   -46,     0,   -46,   -51,     0,   -51,   -51,
     -51,     0,   -51,   -51,     0,   -50,     0,     0,     0,     0,
       0,   -51,   -51,     0,   -51,   -50,     0,   -50,   -50,   -50,
       0,   -50,   -50,     0,   -53,     0,     0,     0,     0,     0,
     -50,   -50,     0,   -50,   -53,     0,   -53,   -53,   -53,   -98,
     -53,   -53,    59,    60,    61,    62,    63,     0,     0,   -53,
     -53,     0,   -53,     0,     0,     0,     0,     0,   -98,   -98,
       0,   -98,     0,     0,   -97,     0,   -98,    59,    60,    61,
      62,    63,    59,    60,    61,    62,    63,     0,   -65,   -65,
     -65,   -65,   -65,   -97,   -97,     0,   -97,     7,   135,     8,
       0,   -97,     0,   -65,   -65,     0,   150,     0,     9,    10,
       0,    11,     0,    12,   167,   168,   169,   -13,   -13,     0,
       0,     0,     0,   -13,     0,   -13,     0,     0,     0,   -13,
     -13,   170,     0,     0,   -13,   -13,     0,   -13,     0,   -13,
    -124,  -124,  -124,  -124,  -124,  -124,     0,  -124,  -124,  -124,
    -124,  -124,  -124,  -124,  -124,     0,     0,  -124,  -124,  -124,
    -124,  -114,  -114,  -114,  -114,  -114,  -114,     0,  -114,  -114,
    -114,  -114,  -114,  -114,  -114,  -114,     0,     0,  -114,  -114,
    -114,  -114,  -118,  -118,  -118,  -118,  -118,  -118,     0,  -118,
    -118,  -118,  -118,  -118,  -118,  -118,  -118,     0,     0,  -118,
    -118,  -118,  -118,  -115,  -115,  -115,  -115,  -115,  -115,     0,
    -115,  -115,  -115,  -115,  -115,  -115,  -115,  -115,     0,     0,
    -115,  -115,  -115,  -115,  -116,  -116,  -116,  -116,  -116,  -116,
       0,  -116,  -116,  -116,  -116,  -116,  -116,  -116,  -116,     0,
       0,  -116,  -116,  -116,  -116,  -117,  -117,  -117,  -117,  -117,
    -117,     0,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,
       0,     0,  -117,  -117,  -117,  -117,  -119,  -119,  -119,  -119,
    -119,  -119,     0,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,     0,     0,  -119,  -119,  -119,  -119,  -125,  -125,  -125,
    -125,  -125,  -125,     0,  -125,  -125,  -125,  -125,  -125,  -125,
    -125,  -125,     0,     0,  -125,  -125,  -125,  -125,  -121,  -121,
    -121,  -121,  -121,  -121,     0,  -121,  -121,  -121,  -121,  -121,
    -121,  -121,  -121,     0,     0,  -121,  -121,  -121,  -121,  -122,
    -122,  -122,  -122,  -122,  -122,     0,  -122,  -122,  -122,  -122,
    -122,  -122,  -122,  -122,     0,     0,  -122,  -122,  -122,  -122,
    -123,  -123,  -123,  -123,  -123,  -123,     0,  -123,  -123,  -123,
    -123,  -123,  -123,  -123,  -123,     0,     0,  -123,  -123,  -123,
    -123,  -120,  -120,  -120,  -120,  -120,  -120,     0,  -120,  -120,
    -120,  -120,  -120,  -120,  -120,  -120,     0,     0,  -120,  -120,
    -120,  -120,  -113,  -113,  -113,  -113,  -113,  -113,     0,  -113,
    -113,  -113,  -113,  -113,  -113,  -113,  -113,     0,     0,  -113,
    -113,  -113,  -113,  -126,  -126,  -126,  -126,  -126,  -126,     0,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,     0,     0,
    -126,  -126,  -126,  -126,  -112,     0,  -112,  -112,  -112,  -112,
       0,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,     0,
       0,  -112,     0,  -112,  -112,    79,     0,    80,    81,    82,
      83,     0,    84,    85,    86,    87,    88,    89,    90,    91,
       0,     0,    11,     0,    12,   110,    79,     0,    80,    81,
      82,    83,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,    11,     0,    12,   132,  -112,     0,  -112,
    -112,  -112,  -112,     0,  -112,  -112,  -112,  -112,  -112,  -112,
    -112,  -112,     0,     0,  -112,  -112,  -112,    79,     0,    80,
      81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,    11,    92,    12,    79,     0,    80,
      81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,    11,   128,    12,    79,     0,    80,
      81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,    11,   131,    12,   -36,   -36,   -36,
     -36,   -36,   -36,     0,   -36,   -36,   -36,   -36,   -36,   -36,
     -36,   -36,     0,     0,   -36,     0,   -36,  -112,  -112,  -112,
    -112,  -112,  -112,     0,  -112,  -112,  -112,  -112,  -112,  -112,
    -112,  -112,     0,     0,  -112,     0,  -112,    79,   163,    80,
      81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,    11,     0,    12,    79,   -41,    80,
      81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,    11,     0,    12,    79,   -39,    80,
      81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,    11,   205,    12,     0,    25,    26,
      27,    28,    29,    30,     0,     0,     0,    31,     0,    32,
      33,     0,    11,   230,    12,   117,    26,    27,     0,    29,
      30,     0,    59,    60,    61,    62,    63,     0,   119,    11,
     237,    12,   117,    26,    27,     0,    29,    30,   156,    59,
      60,    61,    62,    63,     0,   119,    11,     0,    12,    25,
      26,   137,    28,    29,    30,   183,   138,     0,    31,     0,
      32,    33,   139,    11,     0,    12,    -9,    -9,    -9,    -9,
      -9,    -9,     0,    -7,     0,    -9,     0,    -9,    -9,     0,
      -9,     0,    -9,    25,    26,    27,    28,    29,    30,     0,
       0,     0,    31,    96,    32,    33,     0,    11,     0,    12,
      25,    26,    27,    28,    29,    30,     0,   161,     0,    31,
       0,    32,    33,     0,    11,     0,    12,    25,    26,    27,
      28,    29,    30,     0,   176,     0,    31,     0,    32,    33,
       0,    11,     0,    12,    25,    26,    27,    28,    29,    30,
       0,   178,     0,    31,     0,    32,    33,     0,    11,     0,
      12,    25,    26,    27,    28,    29,    30,     0,   185,     0,
      31,     0,    32,    33,     0,    11,     0,    12,    25,    26,
      27,    28,    29,    30,     0,   190,     0,    31,     0,    32,
      33,     0,    11,     0,    12,    25,    26,    27,    28,    29,
      30,     0,   196,     0,    31,     0,    32,    33,     0,    11,
       0,    12,    25,    26,    27,    28,    29,    30,     0,   227,
       0,    31,     0,    32,    33,     0,    11,     0,    12,    25,
      26,    27,    28,    29,    30,     0,   228,     0,    31,     0,
      32,    33,     0,    11,     0,    12,    25,    26,    27,    28,
      29,    30,     0,   232,     0,    31,     0,    32,    33,     0,
      11,     0,    12,    25,    26,    27,    28,    29,    30,     0,
     234,     0,    31,     0,    32,    33,     0,    11,     0,    12,
      25,    26,    27,    28,    29,    30,     0,     0,     0,    31,
       0,    32,    33,     0,    11,     0,    12,   117,    26,    27,
       0,    29,    30,     7,     0,     8,     0,     0,     0,   -11,
     119,    11,     0,    12,     9,    10,     7,    11,     8,    12,
       0,     0,   -12,     0,     0,     0,     0,     9,    10,     0,
      11,     0,    12,    59,    60,    61,    62,    63,    59,    60,
      61,    62,    63,    59,    60,    61,    62,    63,     0,   199,
       0,     0,     0,     0,   202,     0,     0,     0,     0,   211,
      59,    60,    61,    62,    63,    59,    60,    61,    62,    63,
      59,    60,    61,    62,    63,     0,   213,     0,     0,     0,
      71,     0,     0,     0,     0,   175
};

static const yytype_int16 yycheck[] =
{
      11,    12,    11,   121,   114,     1,    14,   161,     1,    40,
      21,     1,    21,   122,    11,    15,     1,   190,    15,     0,
      31,    32,    33,     0,   178,    21,    13,    58,    21,     1,
      19,    21,    79,     2,    30,    66,    21,    30,    15,    11,
      30,    72,    53,    28,    53,    14,    54,    15,    59,    60,
      61,   161,    24,    64,   227,   228,    67,    12,    27,   232,
      71,   234,    73,   212,    19,    76,   176,     0,   178,     0,
       0,   118,   221,   182,   121,    20,    21,    10,    11,    10,
       7,    50,    15,     8,    15,    54,   196,     4,     5,     6,
       7,     8,   201,   104,   105,     4,     5,     6,     7,     8,
      21,    70,    23,    10,   222,   136,    23,   118,   119,    20,
      21,   229,    21,   144,    23,   146,     1,    24,    13,     4,
       5,     6,     7,     8,    13,     4,     5,     6,   139,   137,
      21,   100,    23,     4,    20,     6,    21,   148,   107,   150,
      10,   150,    21,   112,   155,    30,   157,    20,    21,    13,
       4,     5,     6,     7,     8,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   212,    20,    21,   137,   180,
      13,    13,     1,    11,   221,   222,    11,    11,    19,    19,
     149,    11,   229,    11,    13,    14,    15,     1,    17,    18,
     159,   160,     2,   204,   205,    24,   205,    26,    27,     1,
      29,     0,     4,     5,     6,     7,     8,   218,    73,   220,
       0,     1,    11,   224,    -1,   226,    15,    -1,    -1,    21,
      10,    11,    12,    13,    14,    15,    28,    17,    18,    19,
      20,    21,    22,    23,    24,     0,    26,    27,    28,    29,
      30,     0,     1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      15,    10,    11,    12,    13,    14,    15,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      29,    30,     1,     0,     0,     4,     5,     6,     7,     8,
      -1,    -1,     0,    12,    11,    11,    -1,    -1,    15,    15,
      19,    20,    21,    11,    23,    -1,    -1,    15,     1,    28,
       1,    30,    31,     4,     5,     6,     7,     8,    11,    -1,
      13,    14,    15,    -1,    17,    18,    -1,    -1,    19,    20,
      21,    24,    23,    26,    27,    -1,    29,    28,     1,    30,
      31,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    12,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    -1,    27,    28,    29,    30,     1,    -1,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    19,    20,    21,     1,
      23,    24,    25,    -1,    27,    28,    29,    30,    -1,    -1,
      -1,    13,    14,    15,    16,    17,    18,    -1,    -1,    -1,
      22,    -1,    24,    25,     1,    27,     1,    29,    30,     4,
       5,     6,     7,     8,    11,    -1,    13,    14,    15,    -1,
      17,    18,    -1,    -1,    19,    20,    21,    24,    23,    26,
      27,    -1,    29,    28,     1,    30,    -1,     4,     5,     6,
       7,     8,     4,     5,     6,     7,     8,     4,     5,     6,
       7,     8,    19,    20,    21,    -1,    23,    19,    20,    21,
       1,    28,     1,    30,    21,     4,     5,     6,     7,     8,
      11,    -1,    13,    14,    15,    -1,    17,    18,    -1,    -1,
      19,    20,    21,    24,    23,    26,    27,    -1,    29,    28,
       1,    30,    -1,     4,     5,     6,     7,     8,     4,     5,
       6,     7,     8,     4,     5,     6,     7,     8,    19,    20,
      21,    -1,    23,    -1,    20,    21,     1,    28,     1,    30,
      21,     4,     5,     6,     7,     8,    11,    -1,    13,    14,
      15,    -1,    17,    18,    -1,    -1,    19,    20,    21,    24,
      23,    26,    27,    -1,    29,    28,     1,    30,    -1,     4,
       5,     6,     7,     8,     4,     5,     6,     7,     8,     4,
       5,     6,     7,     8,    19,    20,    21,    -1,    23,    -1,
      20,    21,     1,    28,     1,    30,    21,     4,     5,     6,
       7,     8,    11,    -1,    13,    14,    15,    -1,    17,    18,
      -1,    -1,    19,    20,    21,    24,    23,    26,    27,    -1,
      29,    28,     1,    30,    -1,     4,     5,     6,     7,     8,
       4,     5,     6,     7,     8,     4,     5,     6,     7,     8,
      19,    20,    21,    -1,    23,    -1,    20,    21,     1,    28,
       1,    30,    21,     4,     5,     6,     7,     8,    11,    -1,
      13,    14,    15,    -1,    17,    18,    -1,    -1,    19,    20,
      21,    24,    23,    26,    27,    -1,    29,    28,     1,    30,
      -1,     4,     5,     6,     7,     8,     4,     5,     6,     7,
       8,     4,     5,     6,     7,     8,    19,    20,    21,    -1,
      23,    -1,    20,    21,     1,    28,     1,    30,    21,     4,
       5,     6,     7,     8,    11,    -1,    13,    14,    15,    -1,
      17,    18,    -1,    -1,    19,    20,    21,    24,    23,    26,
      27,    -1,    29,    28,     1,    30,    -1,     4,     5,     6,
       7,     8,     4,     5,     6,     7,     8,     4,     5,     6,
       7,     8,    19,    20,    21,    -1,    23,    -1,    20,    21,
       1,    28,     1,    30,    21,     4,     5,     6,     7,     8,
      11,    -1,    13,    14,    15,    -1,    17,    18,    -1,    -1,
      19,    20,    21,    24,    23,    26,    27,    -1,    29,    28,
       1,    30,    -1,     4,     5,     6,     7,     8,     4,     5,
       6,     7,     8,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    23,    19,    20,    -1,     1,    28,     1,    30,
      -1,     4,     5,     6,     7,     8,    11,    -1,    13,    14,
      15,    -1,    17,    18,    -1,    -1,    19,    20,    21,    24,
      23,    26,    27,    -1,    29,    28,     1,    30,    -1,     4,
       5,     6,     7,     8,     4,     5,     6,     7,     8,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    23,    19,
      20,    -1,     1,    28,     1,    30,    -1,     4,     5,     6,
       7,     8,    11,    -1,    13,    14,    15,    -1,    17,    18,
      -1,    -1,    19,    20,    21,    24,    23,    26,    27,    -1,
      29,    28,     1,    30,    -1,     4,     5,     6,     7,     8,
      -1,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      19,    20,    21,     1,    23,    -1,    -1,    -1,    21,    28,
      23,    30,    -1,    -1,    -1,    13,    14,    15,    16,    17,
      18,    -1,    -1,     1,    22,    -1,    24,    25,    -1,    27,
      28,    29,    10,    11,    -1,    13,    14,    15,    -1,    17,
      18,    -1,    -1,     1,    -1,    -1,    24,    -1,    26,    27,
      -1,    29,    10,    11,    -1,    13,    14,    15,    -1,    17,
      18,    -1,    -1,     1,    -1,    -1,    24,    -1,    26,    27,
      -1,    29,    10,    11,    -1,    13,    14,    15,    -1,    17,
      18,    -1,     1,    -1,    -1,    -1,    24,    -1,    26,    27,
      -1,    29,    11,    -1,    13,    14,    15,    -1,    17,    18,
      -1,     1,    -1,    -1,    -1,    24,    -1,    26,    27,    -1,
      29,    11,    -1,    13,    14,    15,    -1,    17,    18,    -1,
       1,    -1,    -1,    -1,    24,    -1,    26,    27,    -1,    29,
      11,    -1,    13,    14,    15,    -1,    17,    18,    -1,     1,
      -1,    -1,    -1,    24,    -1,    26,    27,    -1,    29,    11,
      -1,    13,    14,    15,    -1,    17,    18,    -1,     1,    -1,
      -1,    -1,    24,    -1,    26,    27,    -1,    29,    11,    -1,
      13,    14,    15,    -1,    17,    18,    -1,     1,    -1,    -1,
      -1,    24,    -1,    26,    27,    -1,    29,    11,    -1,    13,
      14,    15,    -1,    17,    18,    -1,     1,    -1,    -1,    -1,
      24,    -1,    26,    27,    -1,    29,    11,    -1,    13,    14,
      15,    -1,    17,    18,    -1,     1,    -1,    -1,    -1,    24,
      -1,    26,    27,    -1,    29,    11,    -1,    13,    14,    15,
      -1,    17,    18,    -1,     1,    -1,    -1,    -1,    24,    -1,
      26,    27,    -1,    29,    11,    -1,    13,    14,    15,    -1,
      17,    18,    -1,     1,    -1,    -1,    -1,    24,    -1,    26,
      27,    -1,    29,    11,    -1,    13,    14,    15,    -1,    17,
      18,    -1,     1,    -1,    -1,    -1,    24,    -1,    26,    27,
      -1,    29,    11,    -1,    13,    14,    15,    -1,    17,    18,
      -1,     1,    -1,    -1,    -1,    24,    -1,    26,    27,    -1,
      29,    11,    -1,    13,    14,    15,    -1,    17,    18,    -1,
       1,     4,     5,     6,     7,     8,    26,    27,    -1,    29,
      11,    -1,    13,    14,    15,    -1,    17,    18,    21,     1,
      23,    -1,    -1,    -1,    -1,    26,    27,    -1,    29,    11,
      -1,    13,    14,    15,    -1,    17,    18,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    26,    27,    -1,    29,    11,    -1,
      13,    14,    15,    -1,    17,    18,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    26,    27,    -1,    29,    11,    -1,    13,
      14,    15,    -1,    17,    18,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    26,    27,    -1,    29,    11,    -1,    13,    14,
      15,    -1,    17,    18,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    26,    27,    -1,    29,    11,    -1,    13,    14,    15,
      -1,    17,    18,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      26,    27,    -1,    29,    11,    -1,    13,    14,    15,     1,
      17,    18,     4,     5,     6,     7,     8,    -1,    -1,    26,
      27,    -1,    29,    -1,    -1,    -1,    -1,    -1,    20,    21,
      -1,    23,    -1,    -1,     1,    -1,    28,     4,     5,     6,
       7,     8,     4,     5,     6,     7,     8,    -1,     4,     5,
       6,     7,     8,    20,    21,    -1,    23,    13,    20,    15,
      -1,    28,    -1,    19,    20,    -1,    22,    -1,    24,    25,
      -1,    27,    -1,    29,     4,     5,     6,     7,     8,    -1,
      -1,    -1,    -1,    13,    -1,    15,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    24,    25,    -1,    27,    -1,    29,
      10,    11,    12,    13,    14,    15,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,    27,    28,    29,
      30,    10,    11,    12,    13,    14,    15,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    27,    28,
      29,    30,    10,    11,    12,    13,    14,    15,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    -1,    -1,    27,
      28,    29,    30,    10,    11,    12,    13,    14,    15,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      27,    28,    29,    30,    10,    11,    12,    13,    14,    15,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    27,    28,    29,    30,    10,    11,    12,    13,    14,
      15,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    27,    28,    29,    30,    10,    11,    12,    13,
      14,    15,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    27,    28,    29,    30,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    30,    10,    11,
      12,    13,    14,    15,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    -1,    -1,    27,    28,    29,    30,    10,
      11,    12,    13,    14,    15,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    27,    28,    29,    30,
      10,    11,    12,    13,    14,    15,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,    27,    28,    29,
      30,    10,    11,    12,    13,    14,    15,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    27,    28,
      29,    30,    10,    11,    12,    13,    14,    15,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    -1,    -1,    27,
      28,    29,    30,    10,    11,    12,    13,    14,    15,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      27,    28,    29,    30,    10,    -1,    12,    13,    14,    15,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    27,    -1,    29,    30,    10,    -1,    12,    13,    14,
      15,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    27,    -1,    29,    30,    10,    -1,    12,    13,
      14,    15,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    27,    -1,    29,    30,    10,    -1,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    10,    -1,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    10,    -1,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    10,    -1,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    -1,    29,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    -1,    29,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    -1,    29,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    -1,    29,    10,    11,    12,
      13,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    10,    29,    -1,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    22,    -1,    24,
      25,    -1,    27,    11,    29,    13,    14,    15,    -1,    17,
      18,    -1,     4,     5,     6,     7,     8,    -1,    26,    27,
      11,    29,    13,    14,    15,    -1,    17,    18,    20,     4,
       5,     6,     7,     8,    -1,    26,    27,    -1,    29,    13,
      14,    15,    16,    17,    18,    20,    20,    -1,    22,    -1,
      24,    25,    26,    27,    -1,    29,    13,    14,    15,    16,
      17,    18,    -1,    20,    -1,    22,    -1,    24,    25,    -1,
      27,    -1,    29,    13,    14,    15,    16,    17,    18,    -1,
      -1,    -1,    22,    23,    24,    25,    -1,    27,    -1,    29,
      13,    14,    15,    16,    17,    18,    -1,    20,    -1,    22,
      -1,    24,    25,    -1,    27,    -1,    29,    13,    14,    15,
      16,    17,    18,    -1,    20,    -1,    22,    -1,    24,    25,
      -1,    27,    -1,    29,    13,    14,    15,    16,    17,    18,
      -1,    20,    -1,    22,    -1,    24,    25,    -1,    27,    -1,
      29,    13,    14,    15,    16,    17,    18,    -1,    20,    -1,
      22,    -1,    24,    25,    -1,    27,    -1,    29,    13,    14,
      15,    16,    17,    18,    -1,    20,    -1,    22,    -1,    24,
      25,    -1,    27,    -1,    29,    13,    14,    15,    16,    17,
      18,    -1,    20,    -1,    22,    -1,    24,    25,    -1,    27,
      -1,    29,    13,    14,    15,    16,    17,    18,    -1,    20,
      -1,    22,    -1,    24,    25,    -1,    27,    -1,    29,    13,
      14,    15,    16,    17,    18,    -1,    20,    -1,    22,    -1,
      24,    25,    -1,    27,    -1,    29,    13,    14,    15,    16,
      17,    18,    -1,    20,    -1,    22,    -1,    24,    25,    -1,
      27,    -1,    29,    13,    14,    15,    16,    17,    18,    -1,
      20,    -1,    22,    -1,    24,    25,    -1,    27,    -1,    29,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    24,    25,    -1,    27,    -1,    29,    13,    14,    15,
      -1,    17,    18,    13,    -1,    15,    -1,    -1,    -1,    19,
      26,    27,    -1,    29,    24,    25,    13,    27,    15,    29,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    24,    25,    -1,
      27,    -1,    29,     4,     5,     6,     7,     8,     4,     5,
       6,     7,     8,     4,     5,     6,     7,     8,    -1,    20,
      -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,    20,
       4,     5,     6,     7,     8,     4,     5,     6,     7,     8,
       4,     5,     6,     7,     8,    -1,    20,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    19
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    10,    15,    33,    34,    35,    34,    13,    15,    24,
      25,    27,    29,    38,    39,    41,    53,     0,    35,    11,
      12,    22,    13,    15,     1,    13,    14,    15,    16,    17,
      18,    22,    24,    25,    28,    51,    52,    53,    54,    58,
       1,    30,    52,    56,    57,    19,    41,    13,    52,    54,
      59,    12,    31,    22,    39,    52,    52,    52,     1,     4,
       5,     6,     7,     8,    21,    28,     1,    21,    28,    13,
      59,    19,     1,    21,    30,    36,    37,    23,    23,    10,
      12,    13,    14,    15,    17,    18,    19,    20,    21,    22,
      23,    24,    28,    44,    53,    13,    23,    52,    54,    23,
      59,    52,    52,    52,     7,     8,    52,    59,    52,    31,
      30,    52,    59,    57,    20,    52,     1,    13,    24,    26,
      46,    47,    48,    49,    50,    51,    23,    23,    28,    52,
      52,    28,    30,    43,    44,    20,    45,    15,    20,    26,
      51,    52,    52,    11,     1,    49,     1,    50,    19,    59,
      22,    40,    41,    42,    52,    19,    20,    19,    20,    59,
      59,    20,    52,    11,    52,    20,    21,     4,     5,     6,
      21,     4,     5,     6,    21,    19,    20,    52,    20,    52,
      19,    44,    48,    20,    23,    20,    52,    52,    52,    52,
      20,    52,    52,    52,    52,    52,    20,    52,    44,    20,
      44,    48,    20,    52,    21,    10,    52,    54,    55,    55,
      44,    20,    10,    20,    52,    52,    54,    20,    21,    20,
      21,    10,    47,    20,    21,    20,    21,    20,    20,    47,
      11,    11,    20,    11,    20,    55,    55,    11,    55,    55,
      11,    11
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    32,    33,    33,    33,    34,    34,    36,    35,    37,
      35,    38,    38,    39,    39,    40,    40,    40,    40,    41,
      41,    41,    41,    41,    41,    41,    41,    42,    42,    42,
      42,    42,    42,    43,    43,    44,    45,    44,    46,    46,
      46,    46,    47,    47,    48,    48,    49,    49,    49,    49,
      49,    49,    49,    49,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    54,    54,    55,
      55,    55,    55,    55,    55,    55,    55,    56,    56,    57,
      58,    58,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     1,     0,     2,     1,     0,     6,     0,
       6,     0,     1,     1,     2,     3,     3,     3,     5,     1,
       1,     2,     2,     3,     4,     4,     1,     3,     3,     3,
       3,     3,     3,     0,     1,     3,     0,     5,     1,     3,
       1,     3,     2,     1,     2,     1,     4,     4,     4,     3,
       5,     5,     5,     6,     5,     8,     6,     9,     3,     4,
       6,     6,     5,     6,     2,     1,     2,     1,     1,     1,
       1,     3,     4,     4,     3,     1,     1,     2,     2,     2,
       3,     3,     3,     4,     4,     3,     1,     3,     3,     5,
       5,     3,     5,     2,     4,     2,     4,     3,     3,     2,
       2,     4,     4,     4,     4,     6,     6,     3,     1,     3,
       3,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_INT: /* INT  */
#line 169 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%" PRId64, ((*yyvaluep).i)); }
#line 1541 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_BIGINT: /* BIGINT  */
#line 170 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "0x%" PRIuPTR, ((*yyvaluep).bigi).data[((*yyvaluep).bigi).size-1]);
            for (int i = ((*yyvaluep).bigi).size-2; i >= 0; i--)
                fprintf(yyoutput, "%016" PRIuPTR, ((*yyvaluep).bigi).data[i]); }
#line 1549 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_ID: /* ID  */
#line 173 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { if (((*yyvaluep).str)) fprintf(yyoutput, "'%s'", ((*yyvaluep).str)); else fprintf(yyoutput, "null"); }
#line 1555 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_STR: /* STR  */
#line 173 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { if (((*yyvaluep).str)) fprintf(yyoutput, "'%s'", ((*yyvaluep).str)); else fprintf(yyoutput, "null"); }
#line 1561 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_MATCH: /* MATCH  */
#line 174 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { print_match(yyoutput, ((*yyvaluep).match)); }
#line 1567 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_opt_params: /* opt_params  */
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "vec of size %d", ((*yyvaluep).vec).size); }
#line 1573 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_params: /* params  */
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "vec of size %d", ((*yyvaluep).vec).size); }
#line 1579 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_comma_params: /* comma_params  */
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "vec of size %d", ((*yyvaluep).vec).size); }
#line 1585 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_param: /* param  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1591 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_param_expr: /* param_expr  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1597 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_opt_indent_elements: /* opt_indent_elements  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1603 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_indent_elements: /* indent_elements  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1609 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_elements: /* elements  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1615 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_map_elements: /* map_elements  */
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "map of size %d", ((*yyvaluep).map).size); }
#line 1621 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_list_elements: /* list_elements  */
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "vec of size %d", ((*yyvaluep).vec).size); }
#line 1627 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_list_element: /* list_element  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1633 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_key: /* key  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1639 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_value: /* value  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1645 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_flow_value: /* flow_value  */
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "%s", value_desc(&((*yyvaluep).value))); }
#line 1651 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_value_list: /* value_list  */
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "vec of size %d", ((*yyvaluep).vec).size); }
#line 1657 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_linewrapped_value_list: /* linewrapped_value_list  */
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "vec of size %d", ((*yyvaluep).vec).size); }
#line 1663 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_pair_list: /* pair_list  */
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "map of size %d", ((*yyvaluep).map).size); }
#line 1669 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_dotvals: /* dotvals  */
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { fprintf(yyoutput, "vec of size %d", ((*yyvaluep).vec).size); }
#line 1675 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_BIGINT: /* BIGINT  */
#line 163 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_fini(((*yyvaluep).bigi)); }
#line 2072 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_ID: /* ID  */
#line 162 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free(((*yyvaluep).str)); }
#line 2078 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_STR: /* STR  */
#line 162 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free(((*yyvaluep).str)); }
#line 2084 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_opt_params: /* opt_params  */
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).vec), free_value); VECTOR_fini(((*yyvaluep).vec)); }
#line 2090 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_params: /* params  */
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).vec), free_value); VECTOR_fini(((*yyvaluep).vec)); }
#line 2096 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_comma_params: /* comma_params  */
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).vec), free_value); VECTOR_fini(((*yyvaluep).vec)); }
#line 2102 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_param: /* param  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2108 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_param_expr: /* param_expr  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2114 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_opt_indent_elements: /* opt_indent_elements  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2120 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_indent_elements: /* indent_elements  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2126 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_elements: /* elements  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2132 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_map_elements: /* map_elements  */
#line 167 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).map), free_pair); VECTOR_fini(((*yyvaluep).map)); }
#line 2138 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_list_elements: /* list_elements  */
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).vec), free_value); VECTOR_fini(((*yyvaluep).vec)); }
#line 2144 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_map_element: /* map_element  */
#line 166 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_pair(&((*yyvaluep).pair)); }
#line 2150 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_list_element: /* list_element  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2156 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_key: /* key  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2162 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_value: /* value  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2168 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_flow_value: /* flow_value  */
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_value(&((*yyvaluep).value)); }
#line 2174 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_value_list: /* value_list  */
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).vec), free_value); VECTOR_fini(((*yyvaluep).vec)); }
#line 2180 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_linewrapped_value_list: /* linewrapped_value_list  */
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).vec), free_value); VECTOR_fini(((*yyvaluep).vec)); }
#line 2186 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_pair_list: /* pair_list  */
#line 167 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).map), free_pair); VECTOR_fini(((*yyvaluep).map)); }
#line 2192 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_pair: /* pair  */
#line 166 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { free_pair(&((*yyvaluep).pair)); }
#line 2198 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

    case YYSYMBOL_dotvals: /* dotvals  */
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_foreach(((*yyvaluep).vec), free_value); VECTOR_fini(((*yyvaluep).vec)); }
#line 2204 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 7: /* @1: %empty  */
#line 186 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
            { (yyval.i) = Section::start_section(lineno, (yyvsp[-2].str), (yyvsp[-1].vec)); }
#line 2477 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 8: /* section: ID opt_params ':' @1 '\n' opt_indent_elements  */
#line 188 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
            { if (!(yyvsp[-2].i)) Section::asm_section((yyvsp[-5].str), (yyvsp[-4].vec), (yyvsp[0].value));
              VECTOR_foreach((yyvsp[-4].vec), free_value);
              VECTOR_fini((yyvsp[-4].vec));
              free_value(&(yyvsp[0].value));
              free((yyvsp[-5].str)); }
#line 2487 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 9: /* @2: %empty  */
#line 194 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
            { (yyval.i) = Section::start_section(lineno, (yyvsp[-2].str), (yyvsp[-1].vec)); }
#line 2493 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 10: /* section: ID opt_params ':' @2 value '\n'  */
#line 196 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
            { if (!(yyvsp[-2].i)) Section::asm_section((yyvsp[-5].str), (yyvsp[-4].vec), (yyvsp[-1].value));
              VECTOR_foreach((yyvsp[-4].vec), free_value);
              VECTOR_fini((yyvsp[-4].vec));
              free_value(&(yyvsp[-1].value));
              free((yyvsp[-5].str)); }
#line 2503 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 11: /* opt_params: %empty  */
#line 203 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                        { memset(&(yyval.vec), 0, sizeof((yyval.vec))); }
#line 2509 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 13: /* params: param  */
#line 206 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                               { VECTOR_init1((yyval.vec), (yyvsp[0].value)); }
#line 2515 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 14: /* params: params param  */
#line 207 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                        { (yyval.vec) = (yyvsp[-1].vec); VECTOR_add((yyval.vec), (yyvsp[0].value)); }
#line 2521 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 15: /* comma_params: param ',' value  */
#line 210 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { VECTOR_init2((yyval.vec), (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2527 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 16: /* comma_params: comma_params ',' value  */
#line 211 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                 { (yyval.vec) = (yyvsp[-2].vec); VECTOR_add((yyval.vec), (yyvsp[0].value)); }
#line 2533 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 17: /* comma_params: param_expr ',' value  */
#line 212 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                               { VECTOR_init2((yyval.vec), (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2539 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 18: /* comma_params: '(' value ')' ',' value  */
#line 213 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                  { VECTOR_init2((yyval.vec), (yyvsp[-3].value), (yyvsp[0].value)); }
#line 2545 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 19: /* param: INT  */
#line 215 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { (yyval.value) = VAL((yyvsp[0].i)); }
#line 2551 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 20: /* param: ID  */
#line 216 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
             { (yyval.value) = VAL((yyvsp[0].str)); }
#line 2557 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 21: /* param: '-' INT  */
#line 217 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                  { (yyval.value) = VAL(-(yyvsp[0].i)); }
#line 2563 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 22: /* param: '!' ID  */
#line 218 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                 { (yyval.value) = CMD(strdup("!"), VAL((yyvsp[0].str))); }
#line 2569 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 23: /* param: INT DOTDOT INT  */
#line 219 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                         { (yyval.value) = VAL((yyvsp[-2].i), (yyvsp[0].i)); }
#line 2575 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 24: /* param: ID '(' value ')'  */
#line 220 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                           { (yyval.value) = CMD((yyvsp[-3].str), (yyvsp[-1].value)); }
#line 2581 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 25: /* param: ID '(' value_list ')'  */
#line 221 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                { (yyval.value) = CMD((yyvsp[-3].str), (yyvsp[-1].vec)); }
#line 2587 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 26: /* param: flow_value  */
#line 222 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                     { (yyval.value) = (yyvsp[0].value); }
#line 2593 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 27: /* param_expr: param '^' value  */
#line 225 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { (yyval.value) = CMD(strdup("^"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2599 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 28: /* param_expr: param '|' value  */
#line 226 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { (yyval.value) = CMD(strdup("|"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2605 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 29: /* param_expr: param '&' value  */
#line 227 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { (yyval.value) = CMD(strdup("&"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2611 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 30: /* param_expr: param_expr '^' value  */
#line 229 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                               { (yyval.value) = CMD(strdup("^"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2617 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 31: /* param_expr: param_expr '|' value  */
#line 230 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                               { (yyval.value) = CMD(strdup("|"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2623 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 32: /* param_expr: param_expr '&' value  */
#line 231 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                               { (yyval.value) = CMD(strdup("&"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2629 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 33: /* opt_indent_elements: %empty  */
#line 234 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                     { (yyval.value) = empty_map(1); }
#line 2635 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 35: /* indent_elements: INDENT elements UNINDENT  */
#line 239 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                   { (yyval.value) = (yyvsp[-1].value); }
#line 2641 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 36: /* @3: %empty  */
#line 240 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                       { (yyval.i) = lineno; }
#line 2647 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 37: /* indent_elements: INDENT error @3 error_resync UNINDENT  */
#line 240 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                                                 { (yyval.value) = empty_map(lineno-(yyvsp[-2].i)); }
#line 2653 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 38: /* elements: list_elements  */
#line 242 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                        { (yyval.value) = VAL((yyvsp[0].vec)); }
#line 2659 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 39: /* elements: list_elements error error_resync  */
#line 243 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                           { (yyval.value) = VAL((yyvsp[-2].vec)); }
#line 2665 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 40: /* elements: map_elements  */
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                       { (yyval.value) = VAL((yyvsp[0].map)); }
#line 2671 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 41: /* elements: map_elements error error_resync  */
#line 245 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                          { (yyval.value) = VAL((yyvsp[-2].map)); }
#line 2677 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 42: /* map_elements: map_elements map_element  */
#line 247 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                       { (yyval.map) = (yyvsp[-1].map); VECTOR_add((yyval.map), (yyvsp[0].pair)); }
#line 2683 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 43: /* map_elements: map_element  */
#line 248 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                      { VECTOR_init1((yyval.map), (yyvsp[0].pair)); }
#line 2689 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 44: /* list_elements: list_elements list_element  */
#line 250 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                          { (yyval.vec) = (yyvsp[-1].vec); VECTOR_add((yyval.vec), (yyvsp[0].value)); }
#line 2695 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 45: /* list_elements: list_element  */
#line 251 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                       { VECTOR_init1((yyval.vec), (yyvsp[0].value)); }
#line 2701 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 46: /* map_element: key ':' value '\n'  */
#line 255 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                             { (yyval.pair) = pair_t((yyvsp[-3].value), (yyvsp[-1].value)); }
#line 2707 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 47: /* map_element: key ':' '\n' indent_elements  */
#line 256 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                       { (yyval.pair) = pair_t((yyvsp[-3].value), (yyvsp[0].value)); }
#line 2713 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 48: /* map_element: key ':' '\n' list_elements  */
#line 257 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                     { (yyval.pair) = pair_t((yyvsp[-3].value), VAL((yyvsp[0].vec))); }
#line 2719 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 49: /* map_element: key ':' '\n'  */
#line 258 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                       { (yyval.pair) = pair_t((yyvsp[-2].value), empty_map(1)); }
#line 2725 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 50: /* map_element: '?' value ':' value '\n'  */
#line 259 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                   { (yyval.pair) = pair_t((yyvsp[-3].value), (yyvsp[-1].value)); }
#line 2731 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 51: /* map_element: '?' value ':' '\n' indent_elements  */
#line 260 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                             { (yyval.pair) = pair_t((yyvsp[-3].value), (yyvsp[0].value)); }
#line 2737 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 52: /* map_element: '?' value ':' '\n' list_elements  */
#line 261 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                           { (yyval.pair) = pair_t((yyvsp[-3].value), VAL((yyvsp[0].vec))); }
#line 2743 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 53: /* map_element: '?' value '\n' ':' value '\n'  */
#line 262 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                        { (yyval.pair) = pair_t((yyvsp[-4].value), (yyvsp[-1].value)); }
#line 2749 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 54: /* list_element: '-' key ':' value '\n'  */
#line 266 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                 { (yyval.value) = singleton_map((yyvsp[-3].value), (yyvsp[-1].value)); }
#line 2755 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 55: /* list_element: '-' key ':' value '\n' INDENT map_elements UNINDENT  */
#line 267 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                                              {
            VECTOR_insert((yyvsp[-1].map), 0);
            (yyvsp[-1].map).data[0] = pair_t((yyvsp[-6].value), (yyvsp[-4].value));
            (yyval.value) = VAL((yyvsp[-1].map)); }
#line 2764 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 56: /* list_element: '-' '?' value ':' value '\n'  */
#line 271 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                       { (yyval.value) = singleton_map((yyvsp[-3].value), (yyvsp[-1].value)); }
#line 2770 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 57: /* list_element: '-' '?' value ':' value '\n' INDENT map_elements UNINDENT  */
#line 272 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                                                    {
            VECTOR_insert((yyvsp[-1].map), 0);
            (yyvsp[-1].map).data[0] = pair_t((yyvsp[-6].value), (yyvsp[-4].value));
            (yyval.value) = VAL((yyvsp[-1].map)); }
#line 2779 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 58: /* list_element: '-' value '\n'  */
#line 276 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                         { (yyval.value) = (yyvsp[-1].value); }
#line 2785 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 59: /* list_element: '-' ID comma_params '\n'  */
#line 277 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                   { (yyval.value) = command((yyvsp[-2].str), (yyvsp[-1].vec), yychar == '\n' ? 2 : 1); }
#line 2791 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 60: /* list_element: '-' ID comma_params ',' '\n' linewrapped_value_list  */
#line 279 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_addcopy((yyvsp[-3].vec), (yyvsp[0].vec).data, (yyvsp[0].vec).size);
                (yyval.value) = command((yyvsp[-4].str), (yyvsp[-3].vec), yychar == '\n' ? 2 : 1);
                VECTOR_fini((yyvsp[0].vec)); }
#line 2799 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 61: /* list_element: '-' ID param ',' '\n' linewrapped_value_list  */
#line 283 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { VECTOR_insert((yyvsp[0].vec), 0); (yyvsp[0].vec).data[0] = (yyvsp[-3].value);
                (yyval.value) = command((yyvsp[-4].str), (yyvsp[0].vec), yychar == '\n' ? 2 : 1); }
#line 2806 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 62: /* list_element: '-' key ':' '\n' indent_elements  */
#line 285 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                           { (yyval.value) = singleton_map((yyvsp[-3].value), (yyvsp[0].value)); }
#line 2812 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 63: /* list_element: '-' '?' value ':' '\n' indent_elements  */
#line 286 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                                 { (yyval.value) = singleton_map((yyvsp[-3].value), (yyvsp[0].value)); }
#line 2818 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 64: /* list_element: '-' '\n'  */
#line 287 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                   { (yyval.value) = value(strdup(""), yychar == '\n' ? 2 : 1); }
#line 2824 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 65: /* key: ID  */
#line 290 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
         { (yyval.value) = VAL((yyvsp[0].str)); }
#line 2830 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 66: /* key: ID params  */
#line 291 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                { (yyval.value) = CMD((yyvsp[-1].str), (yyvsp[0].vec)); }
#line 2836 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 67: /* key: INT  */
#line 292 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { (yyval.value) = VAL((yyvsp[0].i)); }
#line 2842 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 68: /* key: BIGINT  */
#line 293 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
             { (yyval.value) = VAL((yyvsp[0].bigi)); }
#line 2848 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 69: /* key: MATCH  */
#line 294 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
            { (yyval.value) = VAL((yyvsp[0].match)); }
#line 2854 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 70: /* key: BIGMATCH  */
#line 295 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
               { (yyval.value) = VAL((yyvsp[0].bigm)); }
#line 2860 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 71: /* key: INT DOTDOT INT  */
#line 296 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                     { (yyval.value) = VAL((yyvsp[-2].i), (yyvsp[0].i)); }
#line 2866 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 72: /* key: ID '(' value_list ')'  */
#line 297 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                            { (yyval.value) = CMD((yyvsp[-3].str), (yyvsp[-1].vec)); }
#line 2872 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 73: /* key: ID '(' value ')'  */
#line 298 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                       { (yyval.value) = CMD((yyvsp[-3].str), (yyvsp[-1].value)); }
#line 2878 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 74: /* key: ID '(' ')'  */
#line 299 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                 { (yyval.value) = VAL((yyvsp[-2].str)); }
#line 2884 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 77: /* value: '-' value  */
#line 304 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                            { if (((yyval.value)=(yyvsp[0].value)).type == tINT) (yyval.value).i = -(yyval.value).i; else (yyval.value) = CMD(strdup("-"), (yyvsp[0].value)); }
#line 2890 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 78: /* value: '!' value  */
#line 305 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                            { (yyval.value) = CMD(strdup("!"), (yyvsp[0].value)); }
#line 2896 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 79: /* value: dotvals INT  */
#line 306 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                  { VECTOR_add((yyvsp[-1].vec), VAL((yyvsp[0].i))); (yyval.value) = VAL((yyvsp[-1].vec)); }
#line 2902 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 80: /* value: value '^' value  */
#line 307 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                      { (yyval.value) = CMD(strdup("^"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2908 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 81: /* value: value '|' value  */
#line 308 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                      { (yyval.value) = CMD(strdup("|"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2914 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 82: /* value: value '&' value  */
#line 309 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                      { (yyval.value) = CMD(strdup("&"), true, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 2920 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 83: /* value: value '<' '<' value  */
#line 310 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { (yyval.value) = CMD(strdup("<<"), false, (yyvsp[-3].value), (yyvsp[0].value)); }
#line 2926 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 84: /* value: value '>' '>' value  */
#line 311 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { (yyval.value) = CMD(strdup(">>"), false, (yyvsp[-3].value), (yyvsp[0].value)); }
#line 2932 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 85: /* value: '(' value ')'  */
#line 312 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                    { (yyval.value) = (yyvsp[-1].value); }
#line 2938 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 86: /* value: STR  */
#line 313 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { (yyval.value) = VAL((yyvsp[0].str)); }
#line 2944 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 87: /* flow_value: '[' value_list ']'  */
#line 317 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                         { (yyval.value) = VAL((yyvsp[-1].vec)); }
#line 2950 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 88: /* flow_value: '[' value ']'  */
#line 318 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                    { VECTOR(value_t) tmp; VECTOR_init1(tmp, (yyvsp[-1].value)); (yyval.value) = VAL(tmp); }
#line 2956 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 89: /* flow_value: '[' value_list error error_resync ']'  */
#line 319 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                            { (yyval.value) = VAL((yyvsp[-3].vec)); }
#line 2962 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 90: /* flow_value: '[' value error error_resync ']'  */
#line 320 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                       {
            VECTOR(value_t) tmp; VECTOR_init1(tmp, (yyvsp[-3].value)); (yyval.value) = VAL(tmp); }
#line 2969 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 91: /* flow_value: '{' pair_list '}'  */
#line 322 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                        { (yyval.value) = VAL((yyvsp[-1].map)); }
#line 2975 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 92: /* flow_value: '{' pair_list error error_resync '}'  */
#line 323 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                           { (yyval.value) = VAL((yyvsp[-3].map)); }
#line 2981 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 93: /* flow_value: '[' ']'  */
#line 324 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { (yyval.value) = empty_vector(yychar == '\n' ? 1 : 0); }
#line 2987 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 94: /* flow_value: '[' error error_resync ']'  */
#line 325 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                 { (yyval.value) = empty_vector(yychar == '\n' ? 1 : 0); }
#line 2993 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 95: /* flow_value: '{' '}'  */
#line 326 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
              { (yyval.value) = empty_map(yychar == '\n' ? 1 : 0); }
#line 2999 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 96: /* flow_value: '{' error error_resync '}'  */
#line 327 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                 { (yyval.value) = empty_map(yychar == '\n' ? 1 : 0); }
#line 3005 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 97: /* value_list: value_list ',' value  */
#line 331 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                           { (yyval.vec) = (yyvsp[-2].vec); VECTOR_add((yyval.vec), (yyvsp[0].value)); }
#line 3011 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 98: /* value_list: value ',' value  */
#line 332 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                      { VECTOR_init2((yyval.vec), (yyvsp[-2].value), (yyvsp[0].value)); }
#line 3017 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 99: /* linewrapped_value_list: value_list '\n'  */
#line 335 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                      { (yyval.vec) = (yyvsp[-1].vec); }
#line 3023 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 100: /* linewrapped_value_list: value '\n'  */
#line 336 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                 { VECTOR_init1((yyval.vec), (yyvsp[-1].value)); }
#line 3029 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 101: /* linewrapped_value_list: value_list ',' '\n' linewrapped_value_list  */
#line 338 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { (yyval.vec) = (yyvsp[-3].vec); VECTOR_addcopy((yyval.vec), (yyvsp[0].vec).data, (yyvsp[0].vec).size); VECTOR_fini((yyvsp[0].vec)); }
#line 3035 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 102: /* linewrapped_value_list: value ',' '\n' linewrapped_value_list  */
#line 340 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { VECTOR_init1((yyval.vec), (yyvsp[-3].value)); VECTOR_addcopy((yyval.vec), (yyvsp[0].vec).data, (yyvsp[0].vec).size); VECTOR_fini((yyvsp[0].vec)); }
#line 3041 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 103: /* linewrapped_value_list: INDENT value_list '\n' UNINDENT  */
#line 341 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                      { (yyval.vec) = (yyvsp[-2].vec); }
#line 3047 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 104: /* linewrapped_value_list: INDENT value '\n' UNINDENT  */
#line 342 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                 { VECTOR_init1((yyval.vec), (yyvsp[-2].value)); }
#line 3053 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 105: /* linewrapped_value_list: INDENT value_list ',' '\n' linewrapped_value_list UNINDENT  */
#line 344 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { (yyval.vec) = (yyvsp[-4].vec); VECTOR_addcopy((yyval.vec), (yyvsp[-1].vec).data, (yyvsp[-1].vec).size); VECTOR_fini((yyvsp[-1].vec)); }
#line 3059 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 106: /* linewrapped_value_list: INDENT value ',' '\n' linewrapped_value_list UNINDENT  */
#line 346 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
          { VECTOR_init1((yyval.vec), (yyvsp[-4].value)); VECTOR_addcopy((yyval.vec), (yyvsp[-1].vec).data, (yyvsp[-1].vec).size); VECTOR_fini((yyvsp[-1].vec)); }
#line 3065 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 107: /* pair_list: pair_list ',' pair  */
#line 350 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                         { (yyval.map) = (yyvsp[-2].map); VECTOR_add((yyval.map), (yyvsp[0].pair)); }
#line 3071 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 108: /* pair_list: pair  */
#line 351 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
           { VECTOR_init1((yyval.map), (yyvsp[0].pair)); }
#line 3077 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 109: /* pair: value ':' value  */
#line 353 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                      { (yyval.pair) = pair_t((yyvsp[-2].value), (yyvsp[0].value)); }
#line 3083 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 110: /* dotvals: dotvals INT '.'  */
#line 356 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { (yyval.vec) = (yyvsp[-2].vec); VECTOR_add((yyval.vec), VAL((yyvsp[-1].i))); }
#line 3089 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 111: /* dotvals: INT '.'  */
#line 357 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                  { VECTOR_init1((yyval.vec), VAL((yyvsp[-1].i))); }
#line 3095 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 113: /* error_resync: error_resync indent_elements  */
#line 359 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                                           { free_value(&(yyvsp[0].value)); }
#line 3101 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 115: /* error_resync: error_resync ID  */
#line 360 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                         { free((yyvsp[0].str)); }
#line 3107 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 117: /* error_resync: error_resync BIGMATCH  */
#line 361 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                            { VECTOR_fini((yyvsp[0].bigm)); }
#line 3113 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 118: /* error_resync: error_resync BIGINT  */
#line 362 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                          { VECTOR_fini((yyvsp[0].bigi)); }
#line 3119 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;

  case 126: /* error_resync: error_resync flow_value  */
#line 364 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"
                                                  { free_value(&(yyvsp[0].value)); }
#line 3125 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"
    break;


#line 3129 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/backends/tofino/bf-asm/gen/asm-parse.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 367 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-asm/asm-parse.ypp"


#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wpragmas"
#pragma GCC diagnostic ignored "-Wdeprecated-register"
#pragma GCC diagnostic ignored "-Wsign-compare"
#include "backends/tofino/bf-asm/gen/lex-yaml.c"
#pragma GCC diagnostic pop

int error_count = 0;
int warn_count = 0;

std::ostream &operator<<(std::ostream &out, const SrcInfo &s) {
    auto it = line_file_map.upper_bound(s.lineno);
    it--;
    out << it->second.first << ':' << (s.lineno - it->first + it->second.second);
    return out;
}

void warning(int lineno, const char *fmt, va_list args) {
    auto it = line_file_map.upper_bound(lineno);
    if (it == line_file_map.begin()) {
        fprintf(stderr, "<unknown location>: warning: ");
    } else {
        --it;
        fprintf(stderr, "%s:%d: warning: ", it->second.first.c_str(),
                lineno - it->first + it->second.second); }
    vfprintf(stderr, fmt, args);
    fprintf(stderr, "\n");
    fflush(stderr);
    warn_count++; }

void error(int lineno, const char *fmt, va_list args) {
    auto it = line_file_map.upper_bound(lineno);
    if (it == line_file_map.begin()) {
        fprintf(stderr, "<unknown location>: error: ");
    } else {
        --it;
        fprintf(stderr, "%s:%d: error: ", it->second.first.c_str(),
                lineno - it->first + it->second.second); }
    vfprintf(stderr, fmt, args);
    fprintf(stderr, "\n");
    fflush(stderr);
    error_count++; }

static void yyerror(const char *fmt, ...) {
    va_list     args;
    va_start(args, fmt);
    error(lineno, fmt, args);
    va_end(args);
}

int asm_parse_file(const char *name, FILE *in) {
#ifdef YYDEBUG
    if (const char *p = getenv("YYDEBUG"))
        yydebug = atoi(p);
#endif /* YYDEBUG */
    yyrestart(in);
    line_file_map[lineno++] = std::make_pair(name, 0);
    if (yyparse())
        error_count++;
    return error_count;
}

int asm_parse_string(const char* in) {
    YY_BUFFER_STATE buf;
#ifdef YYDEBUG
    if (const char *p = getenv("YYDEBUG"))
        yydebug = atoi(p);
#endif /* YYDEBUG */
    // Reset state in case func is called multiple times
    BEGIN(INITIAL);
    buf = yy_scan_string(in);
    if (yyparse())
        error_count++;
    yy_delete_buffer(buf);
    return error_count;
}

std::map<std::string, Section *> *Section::sections = 0;
