// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
 ** \file /builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/frontends/parsers/p4/p4parser.hpp
 ** Define the P4::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

#ifndef YY_YY_BUILDDIR_BUILD_BUILD_P4C_1_2_5_8_REDHAT_LINUX_BUILD_FRONTENDS_PARSERS_P4_P4PARSER_HPP_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_P4C_1_2_5_8_REDHAT_LINUX_BUILD_FRONTENDS_PARSERS_P4_P4PARSER_HPP_INCLUDED
// "%code requires" blocks.
#line 39 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/parsers/p4/p4parser.ypp"

#include <cassert>   // NOLINT(build/include_order)
#include <iostream>  // NOLINT(build/include_order)

#include "frontends/common/constantParsing.h"
#include "frontends/common/options.h"
#include "ir/ir.h"
#include "lib/cstring.h"
#include "lib/source_file.h"

// Ignore a warning caused by autogenerated code.
// The #if pragma is a little awkward because some preprocessors do not like ||
#pragma GCC diagnostic push
#if defined(__has_warning)
#if __has_warning("-Wunused-but-set-variable")
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
#if __has_warning("-Wswitch-enum")
#pragma GCC diagnostic ignored "-Wswitch-enum"
#endif
#else
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#pragma GCC diagnostic ignored "-Wswitch-enum"
#endif

namespace P4 {
class AbstractP4Lexer;
class P4ParserDriver;

// This is a workaround for an UndefinedBehaviorSanitizer issue triggered by
// Bison's variant implementation. When variant::move() is used to move a value
// from an initialized instance of variant to an uninitialized instance, it uses
// placement new to initialize the uninitialized instance, then calls
// variant::swap(), then destroys the moved-from instance. The problem is that
// placement new does not perform any initialization for primitive types, and
// for bool or enum types that can result in a value that isn't a valid element
// of those types, which UndefinedBehaviorSanitizer doesn't like.
struct OptionalConst {
    OptionalConst() = default;
    explicit OptionalConst(bool isConst) : isConst(isConst) { }
    bool isConst = false;
};

inline std::ostream& operator<<(std::ostream& out, const OptionalConst& oc) {
    out << "OptionalConst(" << oc.isConst << ')';
    return out;
}

// Bison uses the types you provide to %type to make constructors for the
// variant type it uses under the hood, but its code generation is a little
// naive and it always prepends 'const' to the type. This is problematic when
// the symbol type we want is itself const, since duplicate const qualifiers are
// forbidden in C++. We avoid the problem using a typedef.
typedef const IR::Type ConstType;

struct NameTypePair {
    const IR::ID *name;
    const IR::Type *type;
};

inline std::ostream &operator<<(std::ostream &out, const NameTypePair &nt) {
    return out << nt.name << ":" << nt.type;
}

}  // namespace P4

#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#define YY_NULLPTR nullptr

namespace P4 {
using namespace literals;

class Token {
 public:
    int type;
    cstring text;
    UnparsedConstant* unparsedConstant;

    Token() : Token(0, cstring::empty, nullptr) { }
    Token(int type, cstring text) : Token(type, text, nullptr) { }
    Token(int type, const char* text) : Token(type, cstring(text), nullptr) { }    
    Token(int type, UnparsedConstant unparsedConstant)
            : Token(type, unparsedConstant.text,
                    new UnparsedConstant(unparsedConstant)) { }

 private:
    Token(int type, cstring text, UnparsedConstant* unparsedConstant)
            : type(type), text(text), unparsedConstant(unparsedConstant) { }
};

inline std::ostream& operator<<(std::ostream& out, const Token& t) {
    out << t.text;
    return out;
}

}  // namespace P4


#line 151 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/frontends/parsers/p4/p4parser.hpp"

# include <cassert>
# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif

#include <typeinfo>
#ifndef YY_ASSERT
# include <cassert>
# define YY_ASSERT assert
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/parsers/p4/p4parser.ypp"
namespace P4 {
#line 292 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/frontends/parsers/p4/p4parser.hpp"




  /// A Bison parser.
  class P4Parser
  {
  public:
#ifdef YYSTYPE
# ifdef __GNUC__
#  pragma GCC message "bison: do not #define YYSTYPE in C++, use %define api.value.type"
# endif
    typedef YYSTYPE value_type;
#else
  /// A buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current parser state.
  class value_type
  {
  public:
    /// Type of *this.
    typedef value_type self_type;

    /// Empty construction.
    value_type () YY_NOEXCEPT
      : yyraw_ ()
      , yytypeid_ (YY_NULLPTR)
    {}

    /// Construct and fill.
    template <typename T>
    value_type (YY_RVREF (T) t)
      : yytypeid_ (&typeid (T))
    {
      YY_ASSERT (sizeof (T) <= size);
      new (yyas_<T> ()) T (YY_MOVE (t));
    }

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    value_type (const self_type&) = delete;
    /// Non copyable.
    self_type& operator= (const self_type&) = delete;
#endif

    /// Destruction, allowed only if empty.
    ~value_type () YY_NOEXCEPT
    {
      YY_ASSERT (!yytypeid_);
    }

# if 201103L <= YY_CPLUSPLUS
    /// Instantiate a \a T in here from \a t.
    template <typename T, typename... U>
    T&
    emplace (U&&... u)
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T (std::forward <U>(u)...);
    }
# else
    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    emplace ()
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T ();
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    emplace (const T& t)
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T (t);
    }
# endif

    /// Instantiate an empty \a T in here.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build ()
    {
      return emplace<T> ();
    }

    /// Instantiate a \a T in here from \a t.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build (const T& t)
    {
      return emplace<T> (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as () YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == typeid (T));
      YY_ASSERT (sizeof (T) <= size);
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == typeid (T));
      YY_ASSERT (sizeof (T) <= size);
      return *yyas_<T> ();
    }

    /// Swap the content with \a that, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsibility.
    /// Swapping between built and (possibly) non-built is done with
    /// self_type::move ().
    template <typename T>
    void
    swap (self_type& that) YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == *that.yytypeid_);
      std::swap (as<T> (), that.as<T> ());
    }

    /// Move the content of \a that to this.
    ///
    /// Destroys \a that.
    template <typename T>
    void
    move (self_type& that)
    {
# if 201103L <= YY_CPLUSPLUS
      emplace<T> (std::move (that.as<T> ()));
# else
      emplace<T> ();
      swap<T> (that);
# endif
      that.destroy<T> ();
    }

# if 201103L <= YY_CPLUSPLUS
    /// Move the content of \a that to this.
    template <typename T>
    void
    move (self_type&& that)
    {
      emplace<T> (std::move (that.as<T> ()));
      that.destroy<T> ();
    }
#endif

    /// Copy the content of \a that to this.
    template <typename T>
    void
    copy (const self_type& that)
    {
      emplace<T> (that.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
      yytypeid_ = YY_NULLPTR;
    }

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    value_type (const self_type&);
    /// Non copyable.
    self_type& operator= (const self_type&);
#endif

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ () YY_NOEXCEPT
    {
      void *yyp = yyraw_;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const YY_NOEXCEPT
    {
      const void *yyp = yyraw_;
      return static_cast<const T*> (yyp);
     }

    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // typeRef
      // namedType
      // p4listType
      // tupleType
      // headerStackType
      // specializedType
      // baseType
      // typeOrVoid
      // typeArg
      // realTypeArg
      // derivedTypeDeclarationAsType
      char dummy1[sizeof (ConstType*)];

      // annotation
      char dummy2[sizeof (IR::Annotation*)];

      // argument
      char dummy3[sizeof (IR::Argument*)];

      // objInitializer
      // parserBlockStatement
      // controlBody
      // blockStatement
      char dummy4[sizeof (IR::BlockStatement*)];

      // instantiation
      // objDeclaration
      // parserLocalElement
      // valueSetDeclaration
      // controlLocalDeclaration
      // tableDeclaration
      // actionDeclaration
      // variableDeclaration
      // variableDeclarationWithoutSemicolon
      // constantDeclaration
      // functionDeclaration
      char dummy5[sizeof (IR::Declaration*)];

      // direction
      char dummy6[sizeof (IR::Direction)];

      // entry
      char dummy7[sizeof (IR::Entry*)];

      // p4rtControllerType
      // transitionStatement
      // stateExpression
      // selectExpression
      // keysetExpression
      // reducedSimpleKeysetExpression
      // simpleKeysetExpression
      // switchLabel
      // forCollectionExpr
      // actionRef
      // entryPriority
      // optInitializer
      // initializer
      // lvalue
      // expression
      // nonBraceExpression
      // intOrStr
      char dummy8[sizeof (IR::Expression*)];

      // nonTypeName
      // name
      // nonTableKwName
      // annotationName
      // dot_name
      char dummy9[sizeof (IR::ID*)];

      // actionList
      char dummy10[sizeof (IR::IndexedVector<IR::ActionListElement>*)];

      // parserLocalElements
      // controlLocalDeclarations
      char dummy11[sizeof (IR::IndexedVector<IR::Declaration>*)];

      // identifierList
      char dummy12[sizeof (IR::IndexedVector<IR::Declaration_ID>*)];

      // kvList
      char dummy13[sizeof (IR::IndexedVector<IR::NamedExpression>*)];

      // parameterList
      // nonEmptyParameterList
      // optConstructorParameters
      char dummy14[sizeof (IR::IndexedVector<IR::Parameter>*)];

      // parserStates
      char dummy15[sizeof (IR::IndexedVector<IR::ParserState>*)];

      // tablePropertyList
      char dummy16[sizeof (IR::IndexedVector<IR::Property>*)];

      // specifiedIdentifierList
      char dummy17[sizeof (IR::IndexedVector<IR::SerEnumMember>*)];

      // objDeclarations
      // parserStatements
      // statOrDeclList
      // forInitStatements
      // forInitStatementsNonEmpty
      // forUpdateStatements
      // forUpdateStatementsNonEmpty
      char dummy18[sizeof (IR::IndexedVector<IR::StatOrDecl>*)];

      // structFieldList
      char dummy19[sizeof (IR::IndexedVector<IR::StructField>*)];

      // typeParameterList
      char dummy20[sizeof (IR::IndexedVector<IR::Type_Var>*)];

      // keyElement
      char dummy21[sizeof (IR::KeyElement*)];

      // functionPrototype
      // methodPrototype
      char dummy22[sizeof (IR::Method*)];

      // kvPair
      char dummy23[sizeof (IR::NamedExpression*)];

      // fragment
      // declaration
      // externDeclaration
      // matchKindDeclaration
      char dummy24[sizeof (IR::Node*)];

      // parameter
      char dummy25[sizeof (IR::Parameter*)];

      // parserState
      char dummy26[sizeof (IR::ParserState*)];

      // prefixedType
      // prefixedNonTypeName
      char dummy27[sizeof (IR::Path*)];

      // tableProperty
      char dummy28[sizeof (IR::Property*)];

      // selectCase
      char dummy29[sizeof (IR::SelectCase*)];

      // specifiedIdentifier
      char dummy30[sizeof (IR::SerEnumMember*)];

      // parserStatement
      // statementOrDeclaration
      // declOrAssignmentOrMethodCallStatement
      char dummy31[sizeof (IR::StatOrDecl*)];

      // assignmentOrMethodCallStatement
      // assignmentOrMethodCallStatementWithoutSemicolon
      // emptyStatement
      // exitStatement
      // returnStatement
      // conditionalStatement
      // breakStatement
      // continueStatement
      // directApplication
      // statement
      // switchStatement
      // forStatement
      char dummy32[sizeof (IR::Statement*)];

      // structField
      char dummy33[sizeof (IR::StructField*)];

      // switchCase
      char dummy34[sizeof (IR::SwitchCase*)];

      // optTypeParameters
      // typeParameters
      char dummy35[sizeof (IR::TypeParameters*)];

      // controlTypeDeclaration
      char dummy36[sizeof (IR::Type_Control*)];

      // packageTypeDeclaration
      // parserDeclaration
      // controlDeclaration
      // typeDeclaration
      // derivedTypeDeclaration
      // headerTypeDeclaration
      // structTypeDeclaration
      // headerUnionDeclaration
      // enumDeclaration
      // typedefDeclaration
      char dummy37[sizeof (IR::Type_Declaration*)];

      // errorDeclaration
      char dummy38[sizeof (IR::Type_Error*)];

      // typeName
      char dummy39[sizeof (IR::Type_Name*)];

      // parserTypeDeclaration
      char dummy40[sizeof (IR::Type_Parser*)];

      // optAnnotations
      // annotations
      char dummy41[sizeof (IR::Vector<IR::Annotation>*)];

      // annotationBody
      char dummy42[sizeof (IR::Vector<IR::AnnotationToken>*)];

      // argumentList
      // nonEmptyArgList
      char dummy43[sizeof (IR::Vector<IR::Argument>*)];

      // entriesList
      char dummy44[sizeof (IR::Vector<IR::Entry>*)];

      // tupleKeysetExpression
      // simpleExpressionList
      // expressionList
      // intList
      // intOrStrList
      // strList
      char dummy45[sizeof (IR::Vector<IR::Expression>*)];

      // keyElementList
      char dummy46[sizeof (IR::Vector<IR::KeyElement>*)];

      // methodPrototypes
      char dummy47[sizeof (IR::Vector<IR::Method>*)];

      // selectCaseList
      char dummy48[sizeof (IR::Vector<IR::SelectCase>*)];

      // switchCases
      char dummy49[sizeof (IR::Vector<IR::SwitchCase>*)];

      // typeArgumentList
      // realTypeArgumentList
      char dummy50[sizeof (IR::Vector<IR::Type>*)];

      // declarator
      char dummy51[sizeof (NameTypePair)];

      // optCONST
      char dummy52[sizeof (OptionalConst)];

      // UNEXPECTED_TOKEN
      // END_PRAGMA
      // "<="
      // ">="
      // "<<"
      // "&&"
      // "||"
      // "!="
      // "=="
      // "+"
      // "-"
      // "|+|"
      // "|-|"
      // "*"
      // "{#}"
      // "/"
      // "%"
      // "|"
      // "&"
      // "^"
      // "~"
      // "["
      // "]"
      // "{"
      // "}"
      // "<"
      // L_ANGLE_ARGS
      // ">"
      // R_ANGLE_SHIFT
      // "("
      // ")"
      // "!"
      // ":"
      // ","
      // "?"
      // "."
      // "="
      // "+="
      // "-="
      // "*="
      // "/="
      // "%="
      // "&="
      // "|="
      // "^="
      // "<<="
      // ">>="
      // "|+|="
      // "|-|="
      // ";"
      // "@"
      // "++"
      // "_"
      // "&&&"
      // "..."
      // ".."
      // TRUE
      // FALSE
      // THIS
      // ABSTRACT
      // ACTION
      // ACTIONS
      // APPLY
      // BOOL
      // BIT
      // BREAK
      // CONST
      // CONTINUE
      // CONTROL
      // DEFAULT
      // ELSE
      // ENTRIES
      // ENUM
      // ERROR
      // EXIT
      // EXTERN
      // FOR
      // HEADER
      // HEADER_UNION
      // IF
      // IN
      // INOUT
      // INT
      // KEY
      // LIST
      // SELECT
      // MATCH_KIND
      // TYPE
      // OUT
      // PACKAGE
      // PARSER
      // PRAGMA
      // PRIORITY
      // RETURN
      // STATE
      // STRING
      // STRUCT
      // SWITCH
      // TABLE
      // TRANSITION
      // TUPLE
      // TYPEDEF
      // VARBIT
      // VALUESET
      // VOID
      // annotationToken
      char dummy53[sizeof (Token)];

      // INTEGER
      char dummy54[sizeof (UnparsedConstant)];

      // IDENTIFIER
      // TYPE_IDENTIFIER
      // STRING_LITERAL
      char dummy55[sizeof (cstring)];
    };

    /// The size of the largest semantic type.
    enum { size = sizeof (union_type) };

    /// A buffer to store semantic values.
    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me_;
      /// A buffer large enough to store any of the semantic values.
      char yyraw_[size];
    };

    /// Whether the content is built: if defined, the name of the stored type.
    const std::type_info *yytypeid_;
  };

#endif
    /// Backward compatibility (Bison 3.8).
    typedef value_type semantic_type;

    /// Symbol locations.
    typedef Util::SourceInfo location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m)
        : std::runtime_error (m)
        , location (l)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
        , location (s.location)
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;

      location_type location;
    };

    /// Token kinds.
    struct token
    {
      enum token_kind_type
      {
        TOK_YYEMPTY = -2,
    TOK_YYEOF = 0,                 // "end of file"
    TOK_YYerror = 256,             // error
    TOK_YYUNDEF = 257,             // "invalid token"
    TOK_START_PROGRAM = 258,       // START_PROGRAM
    TOK_START_EXPRESSION_LIST = 259, // START_EXPRESSION_LIST
    TOK_START_KV_LIST = 260,       // START_KV_LIST
    TOK_START_INTEGER_LIST = 261,  // START_INTEGER_LIST
    TOK_START_INTEGER_OR_STRING_LITERAL_LIST = 262, // START_INTEGER_OR_STRING_LITERAL_LIST
    TOK_START_STRING_LITERAL_LIST = 263, // START_STRING_LITERAL_LIST
    TOK_START_EXPRESSION = 264,    // START_EXPRESSION
    TOK_START_INTEGER = 265,       // START_INTEGER
    TOK_START_INTEGER_OR_STRING_LITERAL = 266, // START_INTEGER_OR_STRING_LITERAL
    TOK_START_STRING_LITERAL = 267, // START_STRING_LITERAL
    TOK_START_EXPRESSION_PAIR = 268, // START_EXPRESSION_PAIR
    TOK_START_INTEGER_PAIR = 269,  // START_INTEGER_PAIR
    TOK_START_STRING_LITERAL_PAIR = 270, // START_STRING_LITERAL_PAIR
    TOK_START_EXPRESSION_TRIPLE = 271, // START_EXPRESSION_TRIPLE
    TOK_START_INTEGER_TRIPLE = 272, // START_INTEGER_TRIPLE
    TOK_START_STRING_LITERAL_TRIPLE = 273, // START_STRING_LITERAL_TRIPLE
    TOK_START_P4RT_TRANSLATION_ANNOTATION = 274, // START_P4RT_TRANSLATION_ANNOTATION
    TOK_END = 275,                 // END
    TOK_END_ANNOTATION = 276,      // END_ANNOTATION
    TOK_UNEXPECTED_TOKEN = 277,    // UNEXPECTED_TOKEN
    TOK_END_PRAGMA = 278,          // END_PRAGMA
    TOK_LE = 279,                  // "<="
    TOK_GE = 280,                  // ">="
    TOK_SHL = 281,                 // "<<"
    TOK_AND = 282,                 // "&&"
    TOK_OR = 283,                  // "||"
    TOK_NE = 284,                  // "!="
    TOK_EQ = 285,                  // "=="
    TOK_PLUS = 286,                // "+"
    TOK_MINUS = 287,               // "-"
    TOK_PLUS_SAT = 288,            // "|+|"
    TOK_MINUS_SAT = 289,           // "|-|"
    TOK_MUL = 290,                 // "*"
    TOK_INVALID = 291,             // "{#}"
    TOK_DIV = 292,                 // "/"
    TOK_MOD = 293,                 // "%"
    TOK_BIT_OR = 294,              // "|"
    TOK_BIT_AND = 295,             // "&"
    TOK_BIT_XOR = 296,             // "^"
    TOK_COMPLEMENT = 297,          // "~"
    TOK_L_BRACKET = 298,           // "["
    TOK_R_BRACKET = 299,           // "]"
    TOK_L_BRACE = 300,             // "{"
    TOK_R_BRACE = 301,             // "}"
    TOK_L_ANGLE = 302,             // "<"
    TOK_L_ANGLE_ARGS = 303,        // L_ANGLE_ARGS
    TOK_R_ANGLE = 304,             // ">"
    TOK_R_ANGLE_SHIFT = 305,       // R_ANGLE_SHIFT
    TOK_L_PAREN = 306,             // "("
    TOK_R_PAREN = 307,             // ")"
    TOK_NOT = 308,                 // "!"
    TOK_COLON = 309,               // ":"
    TOK_COMMA = 310,               // ","
    TOK_QUESTION = 311,            // "?"
    TOK_DOT = 312,                 // "."
    TOK_ASSIGN = 313,              // "="
    TOK_ASSIGN_PLUS = 314,         // "+="
    TOK_ASSIGN_MINUS = 315,        // "-="
    TOK_ASSIGN_MUL = 316,          // "*="
    TOK_ASSIGN_DIV = 317,          // "/="
    TOK_ASSIGN_MOD = 318,          // "%="
    TOK_ASSIGN_BIT_AND = 319,      // "&="
    TOK_ASSIGN_BIT_OR = 320,       // "|="
    TOK_ASSIGN_XOR = 321,          // "^="
    TOK_ASSIGN_SHL = 322,          // "<<="
    TOK_ASSIGN_SHR = 323,          // ">>="
    TOK_ASSIGN_PLUS_SAT = 324,     // "|+|="
    TOK_ASSIGN_MINUS_SAT = 325,    // "|-|="
    TOK_SEMICOLON = 326,           // ";"
    TOK_AT = 327,                  // "@"
    TOK_PP = 328,                  // "++"
    TOK_DONTCARE = 329,            // "_"
    TOK_MASK = 330,                // "&&&"
    TOK_DOTS = 331,                // "..."
    TOK_RANGE = 332,               // ".."
    TOK_TRUE = 333,                // TRUE
    TOK_FALSE = 334,               // FALSE
    TOK_THIS = 335,                // THIS
    TOK_ABSTRACT = 336,            // ABSTRACT
    TOK_ACTION = 337,              // ACTION
    TOK_ACTIONS = 338,             // ACTIONS
    TOK_APPLY = 339,               // APPLY
    TOK_BOOL = 340,                // BOOL
    TOK_BIT = 341,                 // BIT
    TOK_BREAK = 342,               // BREAK
    TOK_CONST = 343,               // CONST
    TOK_CONTINUE = 344,            // CONTINUE
    TOK_CONTROL = 345,             // CONTROL
    TOK_DEFAULT = 346,             // DEFAULT
    TOK_ELSE = 347,                // ELSE
    TOK_ENTRIES = 348,             // ENTRIES
    TOK_ENUM = 349,                // ENUM
    TOK_ERROR = 350,               // ERROR
    TOK_EXIT = 351,                // EXIT
    TOK_EXTERN = 352,              // EXTERN
    TOK_FOR = 353,                 // FOR
    TOK_HEADER = 354,              // HEADER
    TOK_HEADER_UNION = 355,        // HEADER_UNION
    TOK_IF = 356,                  // IF
    TOK_IN = 357,                  // IN
    TOK_INOUT = 358,               // INOUT
    TOK_INT = 359,                 // INT
    TOK_KEY = 360,                 // KEY
    TOK_LIST = 361,                // LIST
    TOK_SELECT = 362,              // SELECT
    TOK_MATCH_KIND = 363,          // MATCH_KIND
    TOK_TYPE = 364,                // TYPE
    TOK_OUT = 365,                 // OUT
    TOK_PACKAGE = 366,             // PACKAGE
    TOK_PARSER = 367,              // PARSER
    TOK_PRAGMA = 368,              // PRAGMA
    TOK_PRIORITY = 369,            // PRIORITY
    TOK_RETURN = 370,              // RETURN
    TOK_STATE = 371,               // STATE
    TOK_STRING = 372,              // STRING
    TOK_STRUCT = 373,              // STRUCT
    TOK_SWITCH = 374,              // SWITCH
    TOK_TABLE = 375,               // TABLE
    TOK_TRANSITION = 376,          // TRANSITION
    TOK_TUPLE = 377,               // TUPLE
    TOK_TYPEDEF = 378,             // TYPEDEF
    TOK_VARBIT = 379,              // VARBIT
    TOK_VALUESET = 380,            // VALUESET
    TOK_VOID = 381,                // VOID
    TOK_IDENTIFIER = 382,          // IDENTIFIER
    TOK_TYPE_IDENTIFIER = 383,     // TYPE_IDENTIFIER
    TOK_STRING_LITERAL = 384,      // STRING_LITERAL
    TOK_INTEGER = 385,             // INTEGER
    TOK_PREFIX = 386,              // PREFIX
    TOK_THEN = 387                 // THEN
      };
      /// Backward compatibility alias (Bison 3.6).
      typedef token_kind_type yytokentype;
    };

    /// Token kind, as returned by yylex.
    typedef token::token_kind_type token_kind_type;

    /// Backward compatibility alias (Bison 3.6).
    typedef token_kind_type token_type;

    /// Symbol kinds.
    struct symbol_kind
    {
      enum symbol_kind_type
      {
        YYNTOKENS = 133, ///< Number of tokens.
        S_YYEMPTY = -2,
        S_YYEOF = 0,                             // "end of file"
        S_YYerror = 1,                           // error
        S_YYUNDEF = 2,                           // "invalid token"
        S_START_PROGRAM = 3,                     // START_PROGRAM
        S_START_EXPRESSION_LIST = 4,             // START_EXPRESSION_LIST
        S_START_KV_LIST = 5,                     // START_KV_LIST
        S_START_INTEGER_LIST = 6,                // START_INTEGER_LIST
        S_START_INTEGER_OR_STRING_LITERAL_LIST = 7, // START_INTEGER_OR_STRING_LITERAL_LIST
        S_START_STRING_LITERAL_LIST = 8,         // START_STRING_LITERAL_LIST
        S_START_EXPRESSION = 9,                  // START_EXPRESSION
        S_START_INTEGER = 10,                    // START_INTEGER
        S_START_INTEGER_OR_STRING_LITERAL = 11,  // START_INTEGER_OR_STRING_LITERAL
        S_START_STRING_LITERAL = 12,             // START_STRING_LITERAL
        S_START_EXPRESSION_PAIR = 13,            // START_EXPRESSION_PAIR
        S_START_INTEGER_PAIR = 14,               // START_INTEGER_PAIR
        S_START_STRING_LITERAL_PAIR = 15,        // START_STRING_LITERAL_PAIR
        S_START_EXPRESSION_TRIPLE = 16,          // START_EXPRESSION_TRIPLE
        S_START_INTEGER_TRIPLE = 17,             // START_INTEGER_TRIPLE
        S_START_STRING_LITERAL_TRIPLE = 18,      // START_STRING_LITERAL_TRIPLE
        S_START_P4RT_TRANSLATION_ANNOTATION = 19, // START_P4RT_TRANSLATION_ANNOTATION
        S_END = 20,                              // END
        S_END_ANNOTATION = 21,                   // END_ANNOTATION
        S_UNEXPECTED_TOKEN = 22,                 // UNEXPECTED_TOKEN
        S_END_PRAGMA = 23,                       // END_PRAGMA
        S_LE = 24,                               // "<="
        S_GE = 25,                               // ">="
        S_SHL = 26,                              // "<<"
        S_AND = 27,                              // "&&"
        S_OR = 28,                               // "||"
        S_NE = 29,                               // "!="
        S_EQ = 30,                               // "=="
        S_PLUS = 31,                             // "+"
        S_MINUS = 32,                            // "-"
        S_PLUS_SAT = 33,                         // "|+|"
        S_MINUS_SAT = 34,                        // "|-|"
        S_MUL = 35,                              // "*"
        S_INVALID = 36,                          // "{#}"
        S_DIV = 37,                              // "/"
        S_MOD = 38,                              // "%"
        S_BIT_OR = 39,                           // "|"
        S_BIT_AND = 40,                          // "&"
        S_BIT_XOR = 41,                          // "^"
        S_COMPLEMENT = 42,                       // "~"
        S_L_BRACKET = 43,                        // "["
        S_R_BRACKET = 44,                        // "]"
        S_L_BRACE = 45,                          // "{"
        S_R_BRACE = 46,                          // "}"
        S_L_ANGLE = 47,                          // "<"
        S_L_ANGLE_ARGS = 48,                     // L_ANGLE_ARGS
        S_R_ANGLE = 49,                          // ">"
        S_R_ANGLE_SHIFT = 50,                    // R_ANGLE_SHIFT
        S_L_PAREN = 51,                          // "("
        S_R_PAREN = 52,                          // ")"
        S_NOT = 53,                              // "!"
        S_COLON = 54,                            // ":"
        S_COMMA = 55,                            // ","
        S_QUESTION = 56,                         // "?"
        S_DOT = 57,                              // "."
        S_ASSIGN = 58,                           // "="
        S_ASSIGN_PLUS = 59,                      // "+="
        S_ASSIGN_MINUS = 60,                     // "-="
        S_ASSIGN_MUL = 61,                       // "*="
        S_ASSIGN_DIV = 62,                       // "/="
        S_ASSIGN_MOD = 63,                       // "%="
        S_ASSIGN_BIT_AND = 64,                   // "&="
        S_ASSIGN_BIT_OR = 65,                    // "|="
        S_ASSIGN_XOR = 66,                       // "^="
        S_ASSIGN_SHL = 67,                       // "<<="
        S_ASSIGN_SHR = 68,                       // ">>="
        S_ASSIGN_PLUS_SAT = 69,                  // "|+|="
        S_ASSIGN_MINUS_SAT = 70,                 // "|-|="
        S_SEMICOLON = 71,                        // ";"
        S_AT = 72,                               // "@"
        S_PP = 73,                               // "++"
        S_DONTCARE = 74,                         // "_"
        S_MASK = 75,                             // "&&&"
        S_DOTS = 76,                             // "..."
        S_RANGE = 77,                            // ".."
        S_TRUE = 78,                             // TRUE
        S_FALSE = 79,                            // FALSE
        S_THIS = 80,                             // THIS
        S_ABSTRACT = 81,                         // ABSTRACT
        S_ACTION = 82,                           // ACTION
        S_ACTIONS = 83,                          // ACTIONS
        S_APPLY = 84,                            // APPLY
        S_BOOL = 85,                             // BOOL
        S_BIT = 86,                              // BIT
        S_BREAK = 87,                            // BREAK
        S_CONST = 88,                            // CONST
        S_CONTINUE = 89,                         // CONTINUE
        S_CONTROL = 90,                          // CONTROL
        S_DEFAULT = 91,                          // DEFAULT
        S_ELSE = 92,                             // ELSE
        S_ENTRIES = 93,                          // ENTRIES
        S_ENUM = 94,                             // ENUM
        S_ERROR = 95,                            // ERROR
        S_EXIT = 96,                             // EXIT
        S_EXTERN = 97,                           // EXTERN
        S_FOR = 98,                              // FOR
        S_HEADER = 99,                           // HEADER
        S_HEADER_UNION = 100,                    // HEADER_UNION
        S_IF = 101,                              // IF
        S_IN = 102,                              // IN
        S_INOUT = 103,                           // INOUT
        S_INT = 104,                             // INT
        S_KEY = 105,                             // KEY
        S_LIST = 106,                            // LIST
        S_SELECT = 107,                          // SELECT
        S_MATCH_KIND = 108,                      // MATCH_KIND
        S_TYPE = 109,                            // TYPE
        S_OUT = 110,                             // OUT
        S_PACKAGE = 111,                         // PACKAGE
        S_PARSER = 112,                          // PARSER
        S_PRAGMA = 113,                          // PRAGMA
        S_PRIORITY = 114,                        // PRIORITY
        S_RETURN = 115,                          // RETURN
        S_STATE = 116,                           // STATE
        S_STRING = 117,                          // STRING
        S_STRUCT = 118,                          // STRUCT
        S_SWITCH = 119,                          // SWITCH
        S_TABLE = 120,                           // TABLE
        S_TRANSITION = 121,                      // TRANSITION
        S_TUPLE = 122,                           // TUPLE
        S_TYPEDEF = 123,                         // TYPEDEF
        S_VARBIT = 124,                          // VARBIT
        S_VALUESET = 125,                        // VALUESET
        S_VOID = 126,                            // VOID
        S_IDENTIFIER = 127,                      // IDENTIFIER
        S_TYPE_IDENTIFIER = 128,                 // TYPE_IDENTIFIER
        S_STRING_LITERAL = 129,                  // STRING_LITERAL
        S_INTEGER = 130,                         // INTEGER
        S_PREFIX = 131,                          // PREFIX
        S_THEN = 132,                            // THEN
        S_YYACCEPT = 133,                        // $accept
        S_start = 134,                           // start
        S_fragment = 135,                        // fragment
        S_p4rtControllerType = 136,              // p4rtControllerType
        S_program = 137,                         // program
        S_input = 138,                           // input
        S_declaration = 139,                     // declaration
        S_nonTypeName = 140,                     // nonTypeName
        S_name = 141,                            // name
        S_nonTableKwName = 142,                  // nonTableKwName
        S_optCONST = 143,                        // optCONST
        S_optAnnotations = 144,                  // optAnnotations
        S_annotations = 145,                     // annotations
        S_annotation = 146,                      // annotation
        S_annotationBody = 147,                  // annotationBody
        S_annotationName = 148,                  // annotationName
        S_annotationToken = 149,                 // annotationToken
        S_kvList = 150,                          // kvList
        S_kvPair = 151,                          // kvPair
        S_parameterList = 152,                   // parameterList
        S_nonEmptyParameterList = 153,           // nonEmptyParameterList
        S_parameter = 154,                       // parameter
        S_direction = 155,                       // direction
        S_packageTypeDeclaration = 156,          // packageTypeDeclaration
        S_157_1 = 157,                           // $@1
        S_158_2 = 158,                           // $@2
        S_instantiation = 159,                   // instantiation
        S_objInitializer = 160,                  // objInitializer
        S_161_3 = 161,                           // $@3
        S_objDeclarations = 162,                 // objDeclarations
        S_objDeclaration = 163,                  // objDeclaration
        S_optConstructorParameters = 164,        // optConstructorParameters
        S_dotPrefix = 165,                       // dotPrefix
        S_parserDeclaration = 166,               // parserDeclaration
        S_parserLocalElements = 167,             // parserLocalElements
        S_parserLocalElement = 168,              // parserLocalElement
        S_parserTypeDeclaration = 169,           // parserTypeDeclaration
        S_170_4 = 170,                           // $@4
        S_171_5 = 171,                           // $@5
        S_parserStates = 172,                    // parserStates
        S_parserState = 173,                     // parserState
        S_174_6 = 174,                           // $@6
        S_parserStatements = 175,                // parserStatements
        S_parserStatement = 176,                 // parserStatement
        S_parserBlockStatement = 177,            // parserBlockStatement
        S_178_7 = 178,                           // $@7
        S_transitionStatement = 179,             // transitionStatement
        S_stateExpression = 180,                 // stateExpression
        S_selectExpression = 181,                // selectExpression
        S_selectCaseList = 182,                  // selectCaseList
        S_selectCase = 183,                      // selectCase
        S_keysetExpression = 184,                // keysetExpression
        S_tupleKeysetExpression = 185,           // tupleKeysetExpression
        S_optTrailingComma = 186,                // optTrailingComma
        S_simpleExpressionList = 187,            // simpleExpressionList
        S_reducedSimpleKeysetExpression = 188,   // reducedSimpleKeysetExpression
        S_simpleKeysetExpression = 189,          // simpleKeysetExpression
        S_valueSetDeclaration = 190,             // valueSetDeclaration
        S_controlDeclaration = 191,              // controlDeclaration
        S_controlTypeDeclaration = 192,          // controlTypeDeclaration
        S_193_8 = 193,                           // $@8
        S_194_9 = 194,                           // $@9
        S_controlLocalDeclarations = 195,        // controlLocalDeclarations
        S_controlLocalDeclaration = 196,         // controlLocalDeclaration
        S_controlBody = 197,                     // controlBody
        S_externDeclaration = 198,               // externDeclaration
        S_199_10 = 199,                          // $@10
        S_200_11 = 200,                          // $@11
        S_methodPrototypes = 201,                // methodPrototypes
        S_functionPrototype = 202,               // functionPrototype
        S_203_12 = 203,                          // $@12
        S_methodPrototype = 204,                 // methodPrototype
        S_typeRef = 205,                         // typeRef
        S_namedType = 206,                       // namedType
        S_prefixedType = 207,                    // prefixedType
        S_typeName = 208,                        // typeName
        S_p4listType = 209,                      // p4listType
        S_tupleType = 210,                       // tupleType
        S_headerStackType = 211,                 // headerStackType
        S_specializedType = 212,                 // specializedType
        S_baseType = 213,                        // baseType
        S_typeOrVoid = 214,                      // typeOrVoid
        S_optTypeParameters = 215,               // optTypeParameters
        S_typeParameters = 216,                  // typeParameters
        S_typeParameterList = 217,               // typeParameterList
        S_typeArg = 218,                         // typeArg
        S_typeArgumentList = 219,                // typeArgumentList
        S_realTypeArg = 220,                     // realTypeArg
        S_realTypeArgumentList = 221,            // realTypeArgumentList
        S_typeDeclaration = 222,                 // typeDeclaration
        S_derivedTypeDeclaration = 223,          // derivedTypeDeclaration
        S_derivedTypeDeclarationAsType = 224,    // derivedTypeDeclarationAsType
        S_headerTypeDeclaration = 225,           // headerTypeDeclaration
        S_226_13 = 226,                          // $@13
        S_227_14 = 227,                          // $@14
        S_structTypeDeclaration = 228,           // structTypeDeclaration
        S_229_15 = 229,                          // $@15
        S_230_16 = 230,                          // $@16
        S_headerUnionDeclaration = 231,          // headerUnionDeclaration
        S_232_17 = 232,                          // $@17
        S_233_18 = 233,                          // $@18
        S_structFieldList = 234,                 // structFieldList
        S_structField = 235,                     // structField
        S_enumDeclaration = 236,                 // enumDeclaration
        S_237_19 = 237,                          // $@19
        S_238_20 = 238,                          // $@20
        S_specifiedIdentifierList = 239,         // specifiedIdentifierList
        S_specifiedIdentifier = 240,             // specifiedIdentifier
        S_errorDeclaration = 241,                // errorDeclaration
        S_matchKindDeclaration = 242,            // matchKindDeclaration
        S_identifierList = 243,                  // identifierList
        S_typedefDeclaration = 244,              // typedefDeclaration
        S_assignmentOrMethodCallStatement = 245, // assignmentOrMethodCallStatement
        S_assignmentOrMethodCallStatementWithoutSemicolon = 246, // assignmentOrMethodCallStatementWithoutSemicolon
        S_emptyStatement = 247,                  // emptyStatement
        S_exitStatement = 248,                   // exitStatement
        S_returnStatement = 249,                 // returnStatement
        S_conditionalStatement = 250,            // conditionalStatement
        S_breakStatement = 251,                  // breakStatement
        S_continueStatement = 252,               // continueStatement
        S_directApplication = 253,               // directApplication
        S_statement = 254,                       // statement
        S_blockStatement = 255,                  // blockStatement
        S_256_21 = 256,                          // $@21
        S_statOrDeclList = 257,                  // statOrDeclList
        S_switchStatement = 258,                 // switchStatement
        S_switchCases = 259,                     // switchCases
        S_switchCase = 260,                      // switchCase
        S_switchLabel = 261,                     // switchLabel
        S_statementOrDeclaration = 262,          // statementOrDeclaration
        S_forStatement = 263,                    // forStatement
        S_forInitStatements = 264,               // forInitStatements
        S_forInitStatementsNonEmpty = 265,       // forInitStatementsNonEmpty
        S_declOrAssignmentOrMethodCallStatement = 266, // declOrAssignmentOrMethodCallStatement
        S_forUpdateStatements = 267,             // forUpdateStatements
        S_forUpdateStatementsNonEmpty = 268,     // forUpdateStatementsNonEmpty
        S_forCollectionExpr = 269,               // forCollectionExpr
        S_tableDeclaration = 270,                // tableDeclaration
        S_tablePropertyList = 271,               // tablePropertyList
        S_tableProperty = 272,                   // tableProperty
        S_keyElementList = 273,                  // keyElementList
        S_keyElement = 274,                      // keyElement
        S_actionList = 275,                      // actionList
        S_actionRef = 276,                       // actionRef
        S_entry = 277,                           // entry
        S_entryPriority = 278,                   // entryPriority
        S_entriesList = 279,                     // entriesList
        S_actionDeclaration = 280,               // actionDeclaration
        S_variableDeclaration = 281,             // variableDeclaration
        S_variableDeclarationWithoutSemicolon = 282, // variableDeclarationWithoutSemicolon
        S_constantDeclaration = 283,             // constantDeclaration
        S_declarator = 284,                      // declarator
        S_optInitializer = 285,                  // optInitializer
        S_initializer = 286,                     // initializer
        S_functionDeclaration = 287,             // functionDeclaration
        S_argumentList = 288,                    // argumentList
        S_nonEmptyArgList = 289,                 // nonEmptyArgList
        S_argument = 290,                        // argument
        S_expressionList = 291,                  // expressionList
        S_prefixedNonTypeName = 292,             // prefixedNonTypeName
        S_dot_name = 293,                        // dot_name
        S_294_22 = 294,                          // $@22
        S_lvalue = 295,                          // lvalue
        S_expression = 296,                      // expression
        S_nonBraceExpression = 297,              // nonBraceExpression
        S_intOrStr = 298,                        // intOrStr
        S_intList = 299,                         // intList
        S_intOrStrList = 300,                    // intOrStrList
        S_strList = 301,                         // strList
        S_l_angle = 302,                         // l_angle
        S_r_angle = 303                          // r_angle
      };
    };

    /// (Internal) symbol kind.
    typedef symbol_kind::symbol_kind_type symbol_kind_type;

    /// The number of tokens.
    static const symbol_kind_type YYNTOKENS = symbol_kind::YYNTOKENS;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol kind
    /// via kind ().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol () YY_NOEXCEPT
        : value ()
        , location ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that)
        : Base (std::move (that))
        , value ()
        , location (std::move (that.location))
      {
        switch (this->kind ())
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
      case symbol_kind::S_derivedTypeDeclarationAsType: // derivedTypeDeclarationAsType
        value.move< ConstType* > (std::move (that.value));
        break;

      case symbol_kind::S_annotation: // annotation
        value.move< IR::Annotation* > (std::move (that.value));
        break;

      case symbol_kind::S_argument: // argument
        value.move< IR::Argument* > (std::move (that.value));
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.move< IR::BlockStatement* > (std::move (that.value));
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.move< IR::Declaration* > (std::move (that.value));
        break;

      case symbol_kind::S_direction: // direction
        value.move< IR::Direction > (std::move (that.value));
        break;

      case symbol_kind::S_entry: // entry
        value.move< IR::Entry* > (std::move (that.value));
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.move< IR::Expression* > (std::move (that.value));
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.move< IR::ID* > (std::move (that.value));
        break;

      case symbol_kind::S_actionList: // actionList
        value.move< IR::IndexedVector<IR::ActionListElement>* > (std::move (that.value));
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.move< IR::IndexedVector<IR::Declaration>* > (std::move (that.value));
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.move< IR::IndexedVector<IR::Declaration_ID>* > (std::move (that.value));
        break;

      case symbol_kind::S_kvList: // kvList
        value.move< IR::IndexedVector<IR::NamedExpression>* > (std::move (that.value));
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.move< IR::IndexedVector<IR::Parameter>* > (std::move (that.value));
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.move< IR::IndexedVector<IR::ParserState>* > (std::move (that.value));
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.move< IR::IndexedVector<IR::Property>* > (std::move (that.value));
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.move< IR::IndexedVector<IR::SerEnumMember>* > (std::move (that.value));
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.move< IR::IndexedVector<IR::StatOrDecl>* > (std::move (that.value));
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.move< IR::IndexedVector<IR::StructField>* > (std::move (that.value));
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.move< IR::IndexedVector<IR::Type_Var>* > (std::move (that.value));
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.move< IR::KeyElement* > (std::move (that.value));
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.move< IR::Method* > (std::move (that.value));
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.move< IR::NamedExpression* > (std::move (that.value));
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.move< IR::Node* > (std::move (that.value));
        break;

      case symbol_kind::S_parameter: // parameter
        value.move< IR::Parameter* > (std::move (that.value));
        break;

      case symbol_kind::S_parserState: // parserState
        value.move< IR::ParserState* > (std::move (that.value));
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.move< IR::Path* > (std::move (that.value));
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.move< IR::Property* > (std::move (that.value));
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.move< IR::SelectCase* > (std::move (that.value));
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.move< IR::SerEnumMember* > (std::move (that.value));
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.move< IR::StatOrDecl* > (std::move (that.value));
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.move< IR::Statement* > (std::move (that.value));
        break;

      case symbol_kind::S_structField: // structField
        value.move< IR::StructField* > (std::move (that.value));
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.move< IR::SwitchCase* > (std::move (that.value));
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.move< IR::TypeParameters* > (std::move (that.value));
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.move< IR::Type_Control* > (std::move (that.value));
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.move< IR::Type_Declaration* > (std::move (that.value));
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.move< IR::Type_Error* > (std::move (that.value));
        break;

      case symbol_kind::S_typeName: // typeName
        value.move< IR::Type_Name* > (std::move (that.value));
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.move< IR::Type_Parser* > (std::move (that.value));
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.move< IR::Vector<IR::Annotation>* > (std::move (that.value));
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.move< IR::Vector<IR::AnnotationToken>* > (std::move (that.value));
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.move< IR::Vector<IR::Argument>* > (std::move (that.value));
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.move< IR::Vector<IR::Entry>* > (std::move (that.value));
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.move< IR::Vector<IR::Expression>* > (std::move (that.value));
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.move< IR::Vector<IR::KeyElement>* > (std::move (that.value));
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.move< IR::Vector<IR::Method>* > (std::move (that.value));
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.move< IR::Vector<IR::SelectCase>* > (std::move (that.value));
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.move< IR::Vector<IR::SwitchCase>* > (std::move (that.value));
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.move< IR::Vector<IR::Type>* > (std::move (that.value));
        break;

      case symbol_kind::S_declarator: // declarator
        value.move< NameTypePair > (std::move (that.value));
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.move< OptionalConst > (std::move (that.value));
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.move< Token > (std::move (that.value));
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.move< UnparsedConstant > (std::move (that.value));
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.move< cstring > (std::move (that.value));
        break;

      default:
        break;
    }

      }
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);

      /// Constructors for typed symbols.
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, location_type&& l)
        : Base (t)
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const location_type& l)
        : Base (t)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, ConstType*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const ConstType*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Annotation*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Annotation*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Argument*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Argument*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::BlockStatement*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::BlockStatement*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Declaration*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Declaration*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Direction&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Direction& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Entry*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Entry*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Expression*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Expression*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::ID*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::ID*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::ActionListElement>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::ActionListElement>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::Declaration>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::Declaration>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::Declaration_ID>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::Declaration_ID>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::NamedExpression>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::NamedExpression>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::Parameter>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::Parameter>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::ParserState>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::ParserState>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::Property>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::Property>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::SerEnumMember>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::SerEnumMember>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::StatOrDecl>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::StatOrDecl>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::StructField>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::StructField>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::IndexedVector<IR::Type_Var>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::IndexedVector<IR::Type_Var>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::KeyElement*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::KeyElement*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Method*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Method*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::NamedExpression*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::NamedExpression*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Node*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Node*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Parameter*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Parameter*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::ParserState*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::ParserState*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Path*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Path*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Property*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Property*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::SelectCase*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::SelectCase*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::SerEnumMember*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::SerEnumMember*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::StatOrDecl*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::StatOrDecl*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Statement*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Statement*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::StructField*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::StructField*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::SwitchCase*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::SwitchCase*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::TypeParameters*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::TypeParameters*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Type_Control*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Type_Control*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Type_Declaration*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Type_Declaration*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Type_Error*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Type_Error*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Type_Name*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Type_Name*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Type_Parser*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Type_Parser*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::Annotation>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::Annotation>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::AnnotationToken>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::AnnotationToken>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::Argument>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::Argument>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::Entry>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::Entry>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::Expression>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::Expression>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::KeyElement>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::KeyElement>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::Method>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::Method>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::SelectCase>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::SelectCase>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::SwitchCase>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::SwitchCase>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, IR::Vector<IR::Type>*&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const IR::Vector<IR::Type>*& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, NameTypePair&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const NameTypePair& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, OptionalConst&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const OptionalConst& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Token&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Token& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, UnparsedConstant&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const UnparsedConstant& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, cstring&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const cstring& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }



      /// Destroy contents, and record that is empty.
      void clear () YY_NOEXCEPT
      {
        // User destructor.
        symbol_kind_type yykind = this->kind ();
        basic_symbol<Base>& yysym = *this;
        (void) yysym;
        switch (yykind)
        {
       default:
          break;
        }

        // Value type destructor.
switch (yykind)
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
      case symbol_kind::S_derivedTypeDeclarationAsType: // derivedTypeDeclarationAsType
        value.template destroy< ConstType* > ();
        break;

      case symbol_kind::S_annotation: // annotation
        value.template destroy< IR::Annotation* > ();
        break;

      case symbol_kind::S_argument: // argument
        value.template destroy< IR::Argument* > ();
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.template destroy< IR::BlockStatement* > ();
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.template destroy< IR::Declaration* > ();
        break;

      case symbol_kind::S_direction: // direction
        value.template destroy< IR::Direction > ();
        break;

      case symbol_kind::S_entry: // entry
        value.template destroy< IR::Entry* > ();
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.template destroy< IR::Expression* > ();
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.template destroy< IR::ID* > ();
        break;

      case symbol_kind::S_actionList: // actionList
        value.template destroy< IR::IndexedVector<IR::ActionListElement>* > ();
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.template destroy< IR::IndexedVector<IR::Declaration>* > ();
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.template destroy< IR::IndexedVector<IR::Declaration_ID>* > ();
        break;

      case symbol_kind::S_kvList: // kvList
        value.template destroy< IR::IndexedVector<IR::NamedExpression>* > ();
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.template destroy< IR::IndexedVector<IR::Parameter>* > ();
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.template destroy< IR::IndexedVector<IR::ParserState>* > ();
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.template destroy< IR::IndexedVector<IR::Property>* > ();
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.template destroy< IR::IndexedVector<IR::SerEnumMember>* > ();
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.template destroy< IR::IndexedVector<IR::StatOrDecl>* > ();
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.template destroy< IR::IndexedVector<IR::StructField>* > ();
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.template destroy< IR::IndexedVector<IR::Type_Var>* > ();
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.template destroy< IR::KeyElement* > ();
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.template destroy< IR::Method* > ();
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.template destroy< IR::NamedExpression* > ();
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.template destroy< IR::Node* > ();
        break;

      case symbol_kind::S_parameter: // parameter
        value.template destroy< IR::Parameter* > ();
        break;

      case symbol_kind::S_parserState: // parserState
        value.template destroy< IR::ParserState* > ();
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.template destroy< IR::Path* > ();
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.template destroy< IR::Property* > ();
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.template destroy< IR::SelectCase* > ();
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.template destroy< IR::SerEnumMember* > ();
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.template destroy< IR::StatOrDecl* > ();
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.template destroy< IR::Statement* > ();
        break;

      case symbol_kind::S_structField: // structField
        value.template destroy< IR::StructField* > ();
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.template destroy< IR::SwitchCase* > ();
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.template destroy< IR::TypeParameters* > ();
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.template destroy< IR::Type_Control* > ();
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.template destroy< IR::Type_Declaration* > ();
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.template destroy< IR::Type_Error* > ();
        break;

      case symbol_kind::S_typeName: // typeName
        value.template destroy< IR::Type_Name* > ();
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.template destroy< IR::Type_Parser* > ();
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.template destroy< IR::Vector<IR::Annotation>* > ();
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.template destroy< IR::Vector<IR::AnnotationToken>* > ();
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.template destroy< IR::Vector<IR::Argument>* > ();
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.template destroy< IR::Vector<IR::Entry>* > ();
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.template destroy< IR::Vector<IR::Expression>* > ();
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.template destroy< IR::Vector<IR::KeyElement>* > ();
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.template destroy< IR::Vector<IR::Method>* > ();
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.template destroy< IR::Vector<IR::SelectCase>* > ();
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.template destroy< IR::Vector<IR::SwitchCase>* > ();
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.template destroy< IR::Vector<IR::Type>* > ();
        break;

      case symbol_kind::S_declarator: // declarator
        value.template destroy< NameTypePair > ();
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.template destroy< OptionalConst > ();
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.template destroy< Token > ();
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.template destroy< UnparsedConstant > ();
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.template destroy< cstring > ();
        break;

      default:
        break;
    }

        Base::clear ();
      }

      /// The user-facing name of this symbol.
      std::string name () const YY_NOEXCEPT
      {
        return P4Parser::symbol_name (this->kind ());
      }

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      value_type value;

      /// The location.
      location_type location;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_kind
    {
      /// The symbol kind as needed by the constructor.
      typedef token_kind_type kind_type;

      /// Default constructor.
      by_kind () YY_NOEXCEPT;

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_kind (by_kind&& that) YY_NOEXCEPT;
#endif

      /// Copy constructor.
      by_kind (const by_kind& that) YY_NOEXCEPT;

      /// Constructor from (external) token numbers.
      by_kind (kind_type t) YY_NOEXCEPT;



      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_kind& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// The symbol kind.
      /// \a S_YYEMPTY when empty.
      symbol_kind_type kind_;
    };

    /// Backward compatibility for a private implementation detail (Bison 3.6).
    typedef by_kind by_type;

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_kind>
    {
      /// Superclass.
      typedef basic_symbol<by_kind> super_type;

      /// Empty symbol.
      symbol_type () YY_NOEXCEPT {}

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, location_type l)
        : super_type (token_kind_type (tok), std::move (l))
#else
      symbol_type (int tok, const location_type& l)
        : super_type (token_kind_type (tok), l)
#endif
      {
#if !defined _MSC_VER || defined __clang__
        YY_ASSERT (tok == token::TOK_YYEOF
                   || (token::TOK_YYerror <= tok && tok <= token::TOK_END_ANNOTATION)
                   || (token::TOK_PREFIX <= tok && tok <= token::TOK_THEN));
#endif
      }
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, Token v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const Token& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {
#if !defined _MSC_VER || defined __clang__
        YY_ASSERT ((token::TOK_UNEXPECTED_TOKEN <= tok && tok <= token::TOK_VOID));
#endif
      }
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, UnparsedConstant v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const UnparsedConstant& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {
#if !defined _MSC_VER || defined __clang__
        YY_ASSERT (tok == token::TOK_INTEGER);
#endif
      }
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, cstring v, location_type l)
        : super_type (token_kind_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const cstring& v, const location_type& l)
        : super_type (token_kind_type (tok), v, l)
#endif
      {
#if !defined _MSC_VER || defined __clang__
        YY_ASSERT ((token::TOK_IDENTIFIER <= tok && tok <= token::TOK_STRING_LITERAL));
#endif
      }
    };

    /// Build a parser object.
    P4Parser (P4::P4ParserDriver& driver_yyarg, P4::AbstractP4Lexer& lexer_yyarg);
    virtual ~P4Parser ();

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    P4Parser (const P4Parser&) = delete;
    /// Non copyable.
    P4Parser& operator= (const P4Parser&) = delete;
#endif

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

    /// The user-facing name of the symbol whose (internal) number is
    /// YYSYMBOL.  No bounds checking.
    static std::string symbol_name (symbol_kind_type yysymbol);

    // Implementation of make_symbol for each token kind.
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYEOF (location_type l)
      {
        return symbol_type (token::TOK_YYEOF, std::move (l));
      }
#else
      static
      symbol_type
      make_YYEOF (const location_type& l)
      {
        return symbol_type (token::TOK_YYEOF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYerror (location_type l)
      {
        return symbol_type (token::TOK_YYerror, std::move (l));
      }
#else
      static
      symbol_type
      make_YYerror (const location_type& l)
      {
        return symbol_type (token::TOK_YYerror, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYUNDEF (location_type l)
      {
        return symbol_type (token::TOK_YYUNDEF, std::move (l));
      }
#else
      static
      symbol_type
      make_YYUNDEF (const location_type& l)
      {
        return symbol_type (token::TOK_YYUNDEF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_PROGRAM (location_type l)
      {
        return symbol_type (token::TOK_START_PROGRAM, std::move (l));
      }
#else
      static
      symbol_type
      make_START_PROGRAM (const location_type& l)
      {
        return symbol_type (token::TOK_START_PROGRAM, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_EXPRESSION_LIST (location_type l)
      {
        return symbol_type (token::TOK_START_EXPRESSION_LIST, std::move (l));
      }
#else
      static
      symbol_type
      make_START_EXPRESSION_LIST (const location_type& l)
      {
        return symbol_type (token::TOK_START_EXPRESSION_LIST, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_KV_LIST (location_type l)
      {
        return symbol_type (token::TOK_START_KV_LIST, std::move (l));
      }
#else
      static
      symbol_type
      make_START_KV_LIST (const location_type& l)
      {
        return symbol_type (token::TOK_START_KV_LIST, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_INTEGER_LIST (location_type l)
      {
        return symbol_type (token::TOK_START_INTEGER_LIST, std::move (l));
      }
#else
      static
      symbol_type
      make_START_INTEGER_LIST (const location_type& l)
      {
        return symbol_type (token::TOK_START_INTEGER_LIST, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_INTEGER_OR_STRING_LITERAL_LIST (location_type l)
      {
        return symbol_type (token::TOK_START_INTEGER_OR_STRING_LITERAL_LIST, std::move (l));
      }
#else
      static
      symbol_type
      make_START_INTEGER_OR_STRING_LITERAL_LIST (const location_type& l)
      {
        return symbol_type (token::TOK_START_INTEGER_OR_STRING_LITERAL_LIST, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_STRING_LITERAL_LIST (location_type l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL_LIST, std::move (l));
      }
#else
      static
      symbol_type
      make_START_STRING_LITERAL_LIST (const location_type& l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL_LIST, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_EXPRESSION (location_type l)
      {
        return symbol_type (token::TOK_START_EXPRESSION, std::move (l));
      }
#else
      static
      symbol_type
      make_START_EXPRESSION (const location_type& l)
      {
        return symbol_type (token::TOK_START_EXPRESSION, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_INTEGER (location_type l)
      {
        return symbol_type (token::TOK_START_INTEGER, std::move (l));
      }
#else
      static
      symbol_type
      make_START_INTEGER (const location_type& l)
      {
        return symbol_type (token::TOK_START_INTEGER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_INTEGER_OR_STRING_LITERAL (location_type l)
      {
        return symbol_type (token::TOK_START_INTEGER_OR_STRING_LITERAL, std::move (l));
      }
#else
      static
      symbol_type
      make_START_INTEGER_OR_STRING_LITERAL (const location_type& l)
      {
        return symbol_type (token::TOK_START_INTEGER_OR_STRING_LITERAL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_STRING_LITERAL (location_type l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL, std::move (l));
      }
#else
      static
      symbol_type
      make_START_STRING_LITERAL (const location_type& l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_EXPRESSION_PAIR (location_type l)
      {
        return symbol_type (token::TOK_START_EXPRESSION_PAIR, std::move (l));
      }
#else
      static
      symbol_type
      make_START_EXPRESSION_PAIR (const location_type& l)
      {
        return symbol_type (token::TOK_START_EXPRESSION_PAIR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_INTEGER_PAIR (location_type l)
      {
        return symbol_type (token::TOK_START_INTEGER_PAIR, std::move (l));
      }
#else
      static
      symbol_type
      make_START_INTEGER_PAIR (const location_type& l)
      {
        return symbol_type (token::TOK_START_INTEGER_PAIR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_STRING_LITERAL_PAIR (location_type l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL_PAIR, std::move (l));
      }
#else
      static
      symbol_type
      make_START_STRING_LITERAL_PAIR (const location_type& l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL_PAIR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_EXPRESSION_TRIPLE (location_type l)
      {
        return symbol_type (token::TOK_START_EXPRESSION_TRIPLE, std::move (l));
      }
#else
      static
      symbol_type
      make_START_EXPRESSION_TRIPLE (const location_type& l)
      {
        return symbol_type (token::TOK_START_EXPRESSION_TRIPLE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_INTEGER_TRIPLE (location_type l)
      {
        return symbol_type (token::TOK_START_INTEGER_TRIPLE, std::move (l));
      }
#else
      static
      symbol_type
      make_START_INTEGER_TRIPLE (const location_type& l)
      {
        return symbol_type (token::TOK_START_INTEGER_TRIPLE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_STRING_LITERAL_TRIPLE (location_type l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL_TRIPLE, std::move (l));
      }
#else
      static
      symbol_type
      make_START_STRING_LITERAL_TRIPLE (const location_type& l)
      {
        return symbol_type (token::TOK_START_STRING_LITERAL_TRIPLE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_START_P4RT_TRANSLATION_ANNOTATION (location_type l)
      {
        return symbol_type (token::TOK_START_P4RT_TRANSLATION_ANNOTATION, std::move (l));
      }
#else
      static
      symbol_type
      make_START_P4RT_TRANSLATION_ANNOTATION (const location_type& l)
      {
        return symbol_type (token::TOK_START_P4RT_TRANSLATION_ANNOTATION, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_END (location_type l)
      {
        return symbol_type (token::TOK_END, std::move (l));
      }
#else
      static
      symbol_type
      make_END (const location_type& l)
      {
        return symbol_type (token::TOK_END, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_END_ANNOTATION (location_type l)
      {
        return symbol_type (token::TOK_END_ANNOTATION, std::move (l));
      }
#else
      static
      symbol_type
      make_END_ANNOTATION (const location_type& l)
      {
        return symbol_type (token::TOK_END_ANNOTATION, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNEXPECTED_TOKEN (Token v, location_type l)
      {
        return symbol_type (token::TOK_UNEXPECTED_TOKEN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_UNEXPECTED_TOKEN (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_UNEXPECTED_TOKEN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_END_PRAGMA (Token v, location_type l)
      {
        return symbol_type (token::TOK_END_PRAGMA, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_END_PRAGMA (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_END_PRAGMA, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LE (Token v, location_type l)
      {
        return symbol_type (token::TOK_LE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_LE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GE (Token v, location_type l)
      {
        return symbol_type (token::TOK_GE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_GE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_GE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SHL (Token v, location_type l)
      {
        return symbol_type (token::TOK_SHL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_SHL (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_SHL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AND (Token v, location_type l)
      {
        return symbol_type (token::TOK_AND, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_AND (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_AND, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OR (Token v, location_type l)
      {
        return symbol_type (token::TOK_OR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_OR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NE (Token v, location_type l)
      {
        return symbol_type (token::TOK_NE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_NE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EQ (Token v, location_type l)
      {
        return symbol_type (token::TOK_EQ, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_EQ (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_EQ, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLUS (Token v, location_type l)
      {
        return symbol_type (token::TOK_PLUS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PLUS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_PLUS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINUS (Token v, location_type l)
      {
        return symbol_type (token::TOK_MINUS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_MINUS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_MINUS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLUS_SAT (Token v, location_type l)
      {
        return symbol_type (token::TOK_PLUS_SAT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PLUS_SAT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_PLUS_SAT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINUS_SAT (Token v, location_type l)
      {
        return symbol_type (token::TOK_MINUS_SAT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_MINUS_SAT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_MINUS_SAT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MUL (Token v, location_type l)
      {
        return symbol_type (token::TOK_MUL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_MUL (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_MUL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INVALID (Token v, location_type l)
      {
        return symbol_type (token::TOK_INVALID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_INVALID (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_INVALID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DIV (Token v, location_type l)
      {
        return symbol_type (token::TOK_DIV, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_DIV (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_DIV, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MOD (Token v, location_type l)
      {
        return symbol_type (token::TOK_MOD, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_MOD (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_MOD, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BIT_OR (Token v, location_type l)
      {
        return symbol_type (token::TOK_BIT_OR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_BIT_OR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_BIT_OR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BIT_AND (Token v, location_type l)
      {
        return symbol_type (token::TOK_BIT_AND, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_BIT_AND (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_BIT_AND, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BIT_XOR (Token v, location_type l)
      {
        return symbol_type (token::TOK_BIT_XOR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_BIT_XOR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_BIT_XOR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COMPLEMENT (Token v, location_type l)
      {
        return symbol_type (token::TOK_COMPLEMENT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_COMPLEMENT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_COMPLEMENT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_BRACKET (Token v, location_type l)
      {
        return symbol_type (token::TOK_L_BRACKET, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_L_BRACKET (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_L_BRACKET, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_R_BRACKET (Token v, location_type l)
      {
        return symbol_type (token::TOK_R_BRACKET, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_R_BRACKET (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_R_BRACKET, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_BRACE (Token v, location_type l)
      {
        return symbol_type (token::TOK_L_BRACE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_L_BRACE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_L_BRACE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_R_BRACE (Token v, location_type l)
      {
        return symbol_type (token::TOK_R_BRACE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_R_BRACE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_R_BRACE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_ANGLE (Token v, location_type l)
      {
        return symbol_type (token::TOK_L_ANGLE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_L_ANGLE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_L_ANGLE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_ANGLE_ARGS (Token v, location_type l)
      {
        return symbol_type (token::TOK_L_ANGLE_ARGS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_L_ANGLE_ARGS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_L_ANGLE_ARGS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_R_ANGLE (Token v, location_type l)
      {
        return symbol_type (token::TOK_R_ANGLE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_R_ANGLE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_R_ANGLE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_R_ANGLE_SHIFT (Token v, location_type l)
      {
        return symbol_type (token::TOK_R_ANGLE_SHIFT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_R_ANGLE_SHIFT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_R_ANGLE_SHIFT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_PAREN (Token v, location_type l)
      {
        return symbol_type (token::TOK_L_PAREN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_L_PAREN (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_L_PAREN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_R_PAREN (Token v, location_type l)
      {
        return symbol_type (token::TOK_R_PAREN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_R_PAREN (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_R_PAREN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NOT (Token v, location_type l)
      {
        return symbol_type (token::TOK_NOT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NOT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_NOT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COLON (Token v, location_type l)
      {
        return symbol_type (token::TOK_COLON, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_COLON (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_COLON, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COMMA (Token v, location_type l)
      {
        return symbol_type (token::TOK_COMMA, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_COMMA (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_COMMA, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_QUESTION (Token v, location_type l)
      {
        return symbol_type (token::TOK_QUESTION, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_QUESTION (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_QUESTION, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOT (Token v, location_type l)
      {
        return symbol_type (token::TOK_DOT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_DOT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_DOT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_PLUS (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_PLUS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_PLUS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_PLUS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_MINUS (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_MINUS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_MINUS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_MINUS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_MUL (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_MUL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_MUL (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_MUL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_DIV (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_DIV, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_DIV (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_DIV, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_MOD (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_MOD, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_MOD (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_MOD, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_BIT_AND (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_BIT_AND, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_BIT_AND (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_BIT_AND, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_BIT_OR (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_BIT_OR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_BIT_OR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_BIT_OR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_XOR (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_XOR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_XOR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_XOR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_SHL (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_SHL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_SHL (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_SHL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_SHR (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_SHR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_SHR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_SHR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_PLUS_SAT (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_PLUS_SAT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_PLUS_SAT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_PLUS_SAT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ASSIGN_MINUS_SAT (Token v, location_type l)
      {
        return symbol_type (token::TOK_ASSIGN_MINUS_SAT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ASSIGN_MINUS_SAT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ASSIGN_MINUS_SAT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SEMICOLON (Token v, location_type l)
      {
        return symbol_type (token::TOK_SEMICOLON, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_SEMICOLON (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_SEMICOLON, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AT (Token v, location_type l)
      {
        return symbol_type (token::TOK_AT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_AT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_AT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PP (Token v, location_type l)
      {
        return symbol_type (token::TOK_PP, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PP (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_PP, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DONTCARE (Token v, location_type l)
      {
        return symbol_type (token::TOK_DONTCARE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_DONTCARE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_DONTCARE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MASK (Token v, location_type l)
      {
        return symbol_type (token::TOK_MASK, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_MASK (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_MASK, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOTS (Token v, location_type l)
      {
        return symbol_type (token::TOK_DOTS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_DOTS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_DOTS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RANGE (Token v, location_type l)
      {
        return symbol_type (token::TOK_RANGE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_RANGE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_RANGE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TRUE (Token v, location_type l)
      {
        return symbol_type (token::TOK_TRUE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TRUE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_TRUE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FALSE (Token v, location_type l)
      {
        return symbol_type (token::TOK_FALSE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_FALSE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_FALSE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_THIS (Token v, location_type l)
      {
        return symbol_type (token::TOK_THIS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_THIS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_THIS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ABSTRACT (Token v, location_type l)
      {
        return symbol_type (token::TOK_ABSTRACT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ABSTRACT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ABSTRACT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ACTION (Token v, location_type l)
      {
        return symbol_type (token::TOK_ACTION, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ACTION (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ACTION, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ACTIONS (Token v, location_type l)
      {
        return symbol_type (token::TOK_ACTIONS, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ACTIONS (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ACTIONS, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_APPLY (Token v, location_type l)
      {
        return symbol_type (token::TOK_APPLY, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_APPLY (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_APPLY, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BOOL (Token v, location_type l)
      {
        return symbol_type (token::TOK_BOOL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_BOOL (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_BOOL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BIT (Token v, location_type l)
      {
        return symbol_type (token::TOK_BIT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_BIT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_BIT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BREAK (Token v, location_type l)
      {
        return symbol_type (token::TOK_BREAK, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_BREAK (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_BREAK, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONST (Token v, location_type l)
      {
        return symbol_type (token::TOK_CONST, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_CONST (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_CONST, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONTINUE (Token v, location_type l)
      {
        return symbol_type (token::TOK_CONTINUE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_CONTINUE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_CONTINUE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONTROL (Token v, location_type l)
      {
        return symbol_type (token::TOK_CONTROL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_CONTROL (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_CONTROL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DEFAULT (Token v, location_type l)
      {
        return symbol_type (token::TOK_DEFAULT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_DEFAULT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_DEFAULT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ELSE (Token v, location_type l)
      {
        return symbol_type (token::TOK_ELSE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ELSE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ELSE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ENTRIES (Token v, location_type l)
      {
        return symbol_type (token::TOK_ENTRIES, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ENTRIES (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ENTRIES, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ENUM (Token v, location_type l)
      {
        return symbol_type (token::TOK_ENUM, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ENUM (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ENUM, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ERROR (Token v, location_type l)
      {
        return symbol_type (token::TOK_ERROR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ERROR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_ERROR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXIT (Token v, location_type l)
      {
        return symbol_type (token::TOK_EXIT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_EXIT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_EXIT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXTERN (Token v, location_type l)
      {
        return symbol_type (token::TOK_EXTERN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_EXTERN (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_EXTERN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FOR (Token v, location_type l)
      {
        return symbol_type (token::TOK_FOR, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_FOR (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_FOR, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_HEADER (Token v, location_type l)
      {
        return symbol_type (token::TOK_HEADER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_HEADER (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_HEADER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_HEADER_UNION (Token v, location_type l)
      {
        return symbol_type (token::TOK_HEADER_UNION, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_HEADER_UNION (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_HEADER_UNION, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IF (Token v, location_type l)
      {
        return symbol_type (token::TOK_IF, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_IF (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_IF, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IN (Token v, location_type l)
      {
        return symbol_type (token::TOK_IN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_IN (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_IN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INOUT (Token v, location_type l)
      {
        return symbol_type (token::TOK_INOUT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_INOUT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_INOUT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INT (Token v, location_type l)
      {
        return symbol_type (token::TOK_INT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_INT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_INT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_KEY (Token v, location_type l)
      {
        return symbol_type (token::TOK_KEY, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_KEY (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_KEY, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LIST (Token v, location_type l)
      {
        return symbol_type (token::TOK_LIST, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_LIST (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_LIST, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SELECT (Token v, location_type l)
      {
        return symbol_type (token::TOK_SELECT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_SELECT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_SELECT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MATCH_KIND (Token v, location_type l)
      {
        return symbol_type (token::TOK_MATCH_KIND, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_MATCH_KIND (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_MATCH_KIND, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPE (Token v, location_type l)
      {
        return symbol_type (token::TOK_TYPE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TYPE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_TYPE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OUT (Token v, location_type l)
      {
        return symbol_type (token::TOK_OUT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_OUT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_OUT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PACKAGE (Token v, location_type l)
      {
        return symbol_type (token::TOK_PACKAGE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PACKAGE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_PACKAGE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PARSER (Token v, location_type l)
      {
        return symbol_type (token::TOK_PARSER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PARSER (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_PARSER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PRAGMA (Token v, location_type l)
      {
        return symbol_type (token::TOK_PRAGMA, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PRAGMA (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_PRAGMA, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PRIORITY (Token v, location_type l)
      {
        return symbol_type (token::TOK_PRIORITY, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_PRIORITY (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_PRIORITY, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RETURN (Token v, location_type l)
      {
        return symbol_type (token::TOK_RETURN, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_RETURN (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_RETURN, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STATE (Token v, location_type l)
      {
        return symbol_type (token::TOK_STATE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_STATE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_STATE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRING (Token v, location_type l)
      {
        return symbol_type (token::TOK_STRING, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_STRING (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_STRING, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRUCT (Token v, location_type l)
      {
        return symbol_type (token::TOK_STRUCT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_STRUCT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_STRUCT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SWITCH (Token v, location_type l)
      {
        return symbol_type (token::TOK_SWITCH, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_SWITCH (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_SWITCH, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TABLE (Token v, location_type l)
      {
        return symbol_type (token::TOK_TABLE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TABLE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_TABLE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TRANSITION (Token v, location_type l)
      {
        return symbol_type (token::TOK_TRANSITION, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TRANSITION (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_TRANSITION, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TUPLE (Token v, location_type l)
      {
        return symbol_type (token::TOK_TUPLE, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TUPLE (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_TUPLE, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPEDEF (Token v, location_type l)
      {
        return symbol_type (token::TOK_TYPEDEF, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TYPEDEF (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_TYPEDEF, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_VARBIT (Token v, location_type l)
      {
        return symbol_type (token::TOK_VARBIT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_VARBIT (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_VARBIT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_VALUESET (Token v, location_type l)
      {
        return symbol_type (token::TOK_VALUESET, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_VALUESET (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_VALUESET, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_VOID (Token v, location_type l)
      {
        return symbol_type (token::TOK_VOID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_VOID (const Token& v, const location_type& l)
      {
        return symbol_type (token::TOK_VOID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IDENTIFIER (cstring v, location_type l)
      {
        return symbol_type (token::TOK_IDENTIFIER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_IDENTIFIER (const cstring& v, const location_type& l)
      {
        return symbol_type (token::TOK_IDENTIFIER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPE_IDENTIFIER (cstring v, location_type l)
      {
        return symbol_type (token::TOK_TYPE_IDENTIFIER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_TYPE_IDENTIFIER (const cstring& v, const location_type& l)
      {
        return symbol_type (token::TOK_TYPE_IDENTIFIER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRING_LITERAL (cstring v, location_type l)
      {
        return symbol_type (token::TOK_STRING_LITERAL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_STRING_LITERAL (const cstring& v, const location_type& l)
      {
        return symbol_type (token::TOK_STRING_LITERAL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INTEGER (UnparsedConstant v, location_type l)
      {
        return symbol_type (token::TOK_INTEGER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_INTEGER (const UnparsedConstant& v, const location_type& l)
      {
        return symbol_type (token::TOK_INTEGER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PREFIX (location_type l)
      {
        return symbol_type (token::TOK_PREFIX, std::move (l));
      }
#else
      static
      symbol_type
      make_PREFIX (const location_type& l)
      {
        return symbol_type (token::TOK_PREFIX, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_THEN (location_type l)
      {
        return symbol_type (token::TOK_THEN, std::move (l));
      }
#else
      static
      symbol_type
      make_THEN (const location_type& l)
      {
        return symbol_type (token::TOK_THEN, l);
      }
#endif


    class context
    {
    public:
      context (const P4Parser& yyparser, const symbol_type& yyla);
      const symbol_type& lookahead () const YY_NOEXCEPT { return yyla_; }
      symbol_kind_type token () const YY_NOEXCEPT { return yyla_.kind (); }
      const location_type& location () const YY_NOEXCEPT { return yyla_.location; }

      /// Put in YYARG at most YYARGN of the expected tokens, and return the
      /// number of tokens stored in YYARG.  If YYARG is null, return the
      /// number of expected tokens (guaranteed to be less than YYNTOKENS).
      int expected_tokens (symbol_kind_type yyarg[], int yyargn) const;

    private:
      const P4Parser& yyparser_;
      const symbol_type& yyla_;
    };

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    P4Parser (const P4Parser&);
    /// Non copyable.
    P4Parser& operator= (const P4Parser&);
#endif


    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// The arguments of the error message.
    int yy_syntax_error_arguments_ (const context& yyctx,
                                    symbol_kind_type yyarg[], int yyargn) const;

    /// Generate an error message.
    /// \param yyctx     the context in which the error occurred.
    virtual std::string yysyntax_error_ (const context& yyctx) const;
    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT;

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT;

    static const short yypact_ninf_;
    static const short yytable_ninf_;

    /// Convert a scanner token kind \a t to a symbol kind.
    /// In theory \a t should be a token_kind_type, but character literals
    /// are valid, yet not members of the token_kind_type enum.
    static symbol_kind_type yytranslate_ (int t) YY_NOEXCEPT;

    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *yystr);

    /// For a symbol, its name in clear.
    static const char* const yytname_[];


    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const short yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
    // state STATE-NUM.
    static const short yystos_[];

    // YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.
    static const short yyr1_[];

    // YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.
    static const signed char yyr2_[];


#if YYDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r) const;
    /// Print the state stack on the debug stream.
    virtual void yy_stack_print_ () const;

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol kind, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state () YY_NOEXCEPT;

      /// The symbol kind as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s) YY_NOEXCEPT;

      /// Copy constructor.
      by_state (const by_state& that) YY_NOEXCEPT;

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_state& that);

      /// The symbol kind (corresponding to \a state).
      /// \a symbol_kind::S_YYEMPTY when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// The state number used to denote an empty symbol.
      /// We use the initial state, as it does not have a value.
      enum { empty_state = 0 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Move or copy construction.
      stack_symbol_type (YY_RVREF (stack_symbol_type) that);
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) sym);
#if YY_CPLUSPLUS < 201103L
      /// Assignment, needed by push_back by some old implementations.
      /// Moves the contents of that.
      stack_symbol_type& operator= (stack_symbol_type& that);

      /// Assignment, needed by push_back by other implementations.
      /// Needed by some other old implementations.
      stack_symbol_type& operator= (const stack_symbol_type& that);
#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
    public:
      // Hide our reversed order.
      typedef typename S::iterator iterator;
      typedef typename S::const_iterator const_iterator;
      typedef typename S::size_type size_type;
      typedef typename std::ptrdiff_t index_type;

      stack (size_type n = 200) YY_NOEXCEPT
        : seq_ (n)
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Non copyable.
      stack (const stack&) = delete;
      /// Non copyable.
      stack& operator= (const stack&) = delete;
#endif

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      const T&
      operator[] (index_type i) const
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      T&
      operator[] (index_type i)
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Steal the contents of \a t.
      ///
      /// Close to move-semantics.
      void
      push (YY_MOVE_REF (T) t)
      {
        seq_.push_back (T ());
        operator[] (0).move (t);
      }

      /// Pop elements from the stack.
      void
      pop (std::ptrdiff_t n = 1) YY_NOEXCEPT
      {
        for (; 0 < n; --n)
          seq_.pop_back ();
      }

      /// Pop all elements from the stack.
      void
      clear () YY_NOEXCEPT
      {
        seq_.clear ();
      }

      /// Number of elements on the stack.
      index_type
      size () const YY_NOEXCEPT
      {
        return index_type (seq_.size ());
      }

      /// Iterator on top of the stack (going downwards).
      const_iterator
      begin () const YY_NOEXCEPT
      {
        return seq_.begin ();
      }

      /// Bottom of the stack.
      const_iterator
      end () const YY_NOEXCEPT
      {
        return seq_.end ();
      }

      /// Present a slice of the top of a stack.
      class slice
      {
      public:
        slice (const stack& stack, index_type range) YY_NOEXCEPT
          : stack_ (stack)
          , range_ (range)
        {}

        const T&
        operator[] (index_type i) const
        {
          return stack_[range_ - i];
        }

      private:
        const stack& stack_;
        index_type range_;
      };

    private:
#if YY_CPLUSPLUS < 201103L
      /// Non copyable.
      stack (const stack&);
      /// Non copyable.
      stack& operator= (const stack&);
#endif
      /// The wrapped container.
      S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym);

    /// Pop \a n symbols from the stack.
    void yypop_ (int n = 1) YY_NOEXCEPT;

    /// Constants.
    enum
    {
      yylast_ = 5310,     ///< Last index in yytable_.
      yynnts_ = 171,  ///< Number of nonterminal symbols.
      yyfinal_ = 80 ///< Termination state number.
    };


    // User arguments.
    P4::P4ParserDriver& driver;
    P4::AbstractP4Lexer& lexer;

  };

  inline
  P4Parser::symbol_kind_type
  P4Parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132
    };
    // Last valid token kind.
    const int code_max = 387;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

  // basic_symbol.
  template <typename Base>
  P4Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
      case symbol_kind::S_derivedTypeDeclarationAsType: // derivedTypeDeclarationAsType
        value.copy< ConstType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_annotation: // annotation
        value.copy< IR::Annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_argument: // argument
        value.copy< IR::Argument* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.copy< IR::BlockStatement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.copy< IR::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_direction: // direction
        value.copy< IR::Direction > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_entry: // entry
        value.copy< IR::Entry* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.copy< IR::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.copy< IR::ID* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_actionList: // actionList
        value.copy< IR::IndexedVector<IR::ActionListElement>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.copy< IR::IndexedVector<IR::Declaration>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.copy< IR::IndexedVector<IR::Declaration_ID>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_kvList: // kvList
        value.copy< IR::IndexedVector<IR::NamedExpression>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.copy< IR::IndexedVector<IR::Parameter>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.copy< IR::IndexedVector<IR::ParserState>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.copy< IR::IndexedVector<IR::Property>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.copy< IR::IndexedVector<IR::SerEnumMember>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.copy< IR::IndexedVector<IR::StatOrDecl>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.copy< IR::IndexedVector<IR::StructField>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.copy< IR::IndexedVector<IR::Type_Var>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.copy< IR::KeyElement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.copy< IR::Method* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.copy< IR::NamedExpression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.copy< IR::Node* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parameter: // parameter
        value.copy< IR::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserState: // parserState
        value.copy< IR::ParserState* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.copy< IR::Path* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.copy< IR::Property* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.copy< IR::SelectCase* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.copy< IR::SerEnumMember* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.copy< IR::StatOrDecl* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.copy< IR::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_structField: // structField
        value.copy< IR::StructField* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.copy< IR::SwitchCase* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.copy< IR::TypeParameters* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.copy< IR::Type_Control* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.copy< IR::Type_Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.copy< IR::Type_Error* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeName: // typeName
        value.copy< IR::Type_Name* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.copy< IR::Type_Parser* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.copy< IR::Vector<IR::Annotation>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.copy< IR::Vector<IR::AnnotationToken>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.copy< IR::Vector<IR::Argument>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.copy< IR::Vector<IR::Entry>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.copy< IR::Vector<IR::Expression>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.copy< IR::Vector<IR::KeyElement>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.copy< IR::Vector<IR::Method>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.copy< IR::Vector<IR::SelectCase>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.copy< IR::Vector<IR::SwitchCase>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.copy< IR::Vector<IR::Type>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_declarator: // declarator
        value.copy< NameTypePair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.copy< OptionalConst > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.copy< Token > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.copy< UnparsedConstant > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.copy< cstring > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  P4Parser::symbol_kind_type
  P4Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  P4Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  P4Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
      case symbol_kind::S_derivedTypeDeclarationAsType: // derivedTypeDeclarationAsType
        value.move< ConstType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_annotation: // annotation
        value.move< IR::Annotation* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_argument: // argument
        value.move< IR::Argument* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.move< IR::BlockStatement* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.move< IR::Declaration* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_direction: // direction
        value.move< IR::Direction > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_entry: // entry
        value.move< IR::Entry* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.move< IR::Expression* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.move< IR::ID* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_actionList: // actionList
        value.move< IR::IndexedVector<IR::ActionListElement>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.move< IR::IndexedVector<IR::Declaration>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.move< IR::IndexedVector<IR::Declaration_ID>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_kvList: // kvList
        value.move< IR::IndexedVector<IR::NamedExpression>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.move< IR::IndexedVector<IR::Parameter>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.move< IR::IndexedVector<IR::ParserState>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.move< IR::IndexedVector<IR::Property>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.move< IR::IndexedVector<IR::SerEnumMember>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.move< IR::IndexedVector<IR::StatOrDecl>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.move< IR::IndexedVector<IR::StructField>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.move< IR::IndexedVector<IR::Type_Var>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.move< IR::KeyElement* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.move< IR::Method* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.move< IR::NamedExpression* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.move< IR::Node* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_parameter: // parameter
        value.move< IR::Parameter* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_parserState: // parserState
        value.move< IR::ParserState* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.move< IR::Path* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.move< IR::Property* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.move< IR::SelectCase* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.move< IR::SerEnumMember* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.move< IR::StatOrDecl* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.move< IR::Statement* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_structField: // structField
        value.move< IR::StructField* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.move< IR::SwitchCase* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.move< IR::TypeParameters* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.move< IR::Type_Control* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.move< IR::Type_Declaration* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.move< IR::Type_Error* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_typeName: // typeName
        value.move< IR::Type_Name* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.move< IR::Type_Parser* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.move< IR::Vector<IR::Annotation>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.move< IR::Vector<IR::AnnotationToken>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.move< IR::Vector<IR::Argument>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.move< IR::Vector<IR::Entry>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.move< IR::Vector<IR::Expression>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.move< IR::Vector<IR::KeyElement>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.move< IR::Vector<IR::Method>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.move< IR::Vector<IR::SelectCase>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.move< IR::Vector<IR::SwitchCase>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.move< IR::Vector<IR::Type>* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_declarator: // declarator
        value.move< NameTypePair > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.move< OptionalConst > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.move< Token > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.move< UnparsedConstant > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.move< cstring > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  inline
  P4Parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  inline
  P4Parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  inline
  P4Parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  inline
  P4Parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  inline
  void
  P4Parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  inline
  void
  P4Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  inline
  P4Parser::symbol_kind_type
  P4Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  inline
  P4Parser::symbol_kind_type
  P4Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/parsers/p4/p4parser.ypp"
} // P4
#line 6578 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/frontends/parsers/p4/p4parser.hpp"




#endif // !YY_YY_BUILDDIR_BUILD_BUILD_P4C_1_2_5_8_REDHAT_LINUX_BUILD_FRONTENDS_PARSERS_P4_P4PARSER_HPP_INCLUDED
