#ifndef IR_GENERATED_H_
#define IR_GENERATED_H_

#include <functional>
#include <map>

#include "lib/big_int.h"        // IWYU pragma: keep
// Special IR classes and types
#include "ir/dbprint.h"         // IWYU pragma: keep
#include "ir/id.h"              // IWYU pragma: keep
#include "ir/indexed_vector.h"  // IWYU pragma: keep
#include "ir/namemap.h"         // IWYU pragma: keep
#include "ir/node.h"            // IWYU pragma: keep
#include "ir/nodemap.h"         // IWYU pragma: keep
#include "ir/vector.h"          // IWYU pragma: keep
#include "lib/ordered_map.h"    // IWYU pragma: keep

namespace P4 {

class JSONLoader;
using NodeFactoryFn = IR::Node*(*)(JSONLoader&);

namespace IR {
extern std::map<cstring, NodeFactoryFn> unpacker_table;
using namespace P4::literals;
}
extern template class IR::Vector<IR::Node>;
extern template class IR::IndexedVector<IR::Node>;
extern template class IR::Vector<IR::Type>;
extern template class IR::Vector<IR::StatOrDecl>;
extern template class IR::IndexedVector<IR::StatOrDecl>;
extern template class IR::Vector<IR::Declaration>;
extern template class IR::IndexedVector<IR::Declaration>;
extern template class IR::Vector<IR::Expression>;
extern template class IR::Vector<IR::NamedExpression>;
extern template class IR::IndexedVector<IR::NamedExpression>;
extern template class IR::Vector<IR::AnnotationToken>;
extern template class IR::Vector<IR::Annotation>;
extern template class IR::Vector<IR::Argument>;
extern template class IR::Vector<IR::Parameter>;
extern template class IR::IndexedVector<IR::Parameter>;
extern template class IR::Vector<IR::Type_Var>;
extern template class IR::IndexedVector<IR::Type_Var>;
extern template class IR::Vector<IR::StructField>;
extern template class IR::IndexedVector<IR::StructField>;
extern template class IR::Vector<IR::Declaration_ID>;
extern template class IR::IndexedVector<IR::Declaration_ID>;
extern template class IR::Vector<IR::SerEnumMember>;
extern template class IR::IndexedVector<IR::SerEnumMember>;
extern template class IR::Vector<IR::ArgumentInfo>;
extern template class IR::Vector<IR::Method>;
extern template class IR::Vector<IR::SelectCase>;
extern template class IR::Vector<IR::ParserState>;
extern template class IR::IndexedVector<IR::ParserState>;
extern template class IR::Vector<IR::P4Parser>;
extern template class IR::Vector<IR::ActionListElement>;
extern template class IR::IndexedVector<IR::ActionListElement>;
extern template class IR::Vector<IR::KeyElement>;
extern template class IR::Vector<IR::Entry>;
extern template class IR::Vector<IR::Property>;
extern template class IR::IndexedVector<IR::Property>;
extern template class IR::Vector<IR::SwitchCase>;
extern template class IR::Vector<IR::Primitive>;
extern template class IR::Vector<IR::CaseEntry>;
extern template class IR::Vector<IR::DpdkDeclaration>;
extern template class IR::IndexedVector<IR::DpdkDeclaration>;
extern template class IR::Vector<IR::DpdkExternDeclaration>;
extern template class IR::IndexedVector<IR::DpdkExternDeclaration>;
extern template class IR::Vector<IR::DpdkHeaderType>;
extern template class IR::IndexedVector<IR::DpdkHeaderType>;
extern template class IR::Vector<IR::DpdkHeaderInstance>;
extern template class IR::IndexedVector<IR::DpdkHeaderInstance>;
extern template class IR::Vector<IR::DpdkStructType>;
extern template class IR::IndexedVector<IR::DpdkStructType>;
extern template class IR::Vector<IR::DpdkAsmStatement>;
extern template class IR::IndexedVector<IR::DpdkAsmStatement>;
extern template class IR::Vector<IR::DpdkAction>;
extern template class IR::IndexedVector<IR::DpdkAction>;
extern template class IR::Vector<IR::DpdkTable>;
extern template class IR::IndexedVector<IR::DpdkTable>;
extern template class IR::Vector<IR::DpdkSelector>;
extern template class IR::IndexedVector<IR::DpdkSelector>;
extern template class IR::Vector<IR::DpdkLearner>;
extern template class IR::IndexedVector<IR::DpdkLearner>;
extern template class IR::Vector<IR::BFN::HardwareConstrainedField>;
extern template class IR::Vector<IR::BFN::Pipe>;
extern template class IR::Vector<IR::BFN::ContainerRef>;
extern template class IR::Vector<IR::MAU::Table>;
extern template class IR::Vector<IR::MAU::BackendAttached>;
extern template class IR::Vector<IR::MAU::Primitive>;
extern template class IR::Vector<IR::MAU::SaluInstruction>;
extern template class IR::Vector<IR::MAU::StatefulCall>;
extern template class IR::Vector<IR::MAU::TableKey>;
extern template class IR::Vector<IR::BFN::FieldLVal>;
extern template class IR::Vector<IR::BFN::ParserPrimitive>;
extern template class IR::Vector<IR::BFN::SaveToRegister>;
extern template class IR::Vector<IR::BFN::ParserCounterPrimitive>;
extern template class IR::Vector<IR::BFN::Transition>;
extern template class IR::Vector<IR::BFN::Select>;
extern template class IR::Vector<IR::BFN::AbstractParser>;
extern template class IR::Vector<IR::BFN::DigestFieldList>;
extern template class IR::Vector<IR::BFN::Emit>;
extern template class IR::Vector<IR::BFN::ChecksumEntry>;
extern template class IR::Vector<IR::BFN::EmitChecksum>;
extern template class IR::Vector<IR::BFN::DeparserParameter>;
extern template class IR::Vector<IR::BFN::LoweredParserPrimitive>;
extern template class IR::Vector<IR::BFN::LoweredParserChecksum>;
extern template class IR::Vector<IR::BFN::LoweredSave>;
extern template class IR::Vector<IR::BFN::LoweredParserMatch>;
extern template class IR::Vector<IR::BFN::LoweredEmit>;
extern template class IR::Vector<IR::BFN::LoweredDeparserParameter>;
extern template class IR::Vector<IR::BFN::DigestTableEntry>;
extern template class IR::Vector<IR::BFN::LoweredDigest>;
extern template class IR::Vector<IR::BFN::ChecksumPhvInput>;
extern template class IR::Vector<IR::BFN::ChecksumClotInput>;
extern template class IR::Vector<IR::BFN::PartialChecksumUnitConfig>;
extern template class IR::Vector<IR::BFN::FullChecksumUnitConfig>;
}  // namespace P4

#line 16 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
#include "absl/strings/str_cat.h"
#line 123 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 17 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
#include "absl/strings/str_join.h"
#line 126 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 18 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
#include "frontends/common/constantParsing.h"
#line 129 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 19 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
#include "ir/annotations.h"
#line 132 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
/// a value that can be evaluated at compile-time
class CompileTimeValue : public virtual INode {
 public:
#line 22 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool equiv(IR::CompileTimeValue const & other) const;
#line 139 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(CompileTimeValue, NodeKind::CompileTimeValue, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// Base class for P4 types
class Type : public Node {
 public:
    static const cstring minSizeInBits;
    static const cstring minSizeInBytes;
    static const cstring maxSizeInBits;
    static const cstring maxSizeInBytes;
#line 34 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    typedef Type_Unknown        Unknown;
    typedef Type_Boolean        Boolean;
    typedef Type_Bits           Bits;
    typedef Type_String         String;
    typedef Type_Varbits        Varbits;
    typedef Type_Void           Void;
#line 158 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Well-defined only for types with fixed width
#line 42 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual int width_bits() const;
#line 162 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// When possible returns the corresponding type that can be inserted
/// in a P4 program; may return a Type_Name
#line 45 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual IR::Type const * getP4Type() const = 0;
#line 167 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type"_cs; }
    static cstring static_type_name() { return "Type"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    Type(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    Type() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Type)
    DECLARE_TYPEINFO_WITH_TYPEID(Type, NodeKind::Type, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// Implemented by all types that may be generic:
/// Control, Extern, Method, Package, and Parser
class IMayBeGenericType : public virtual INode {
 public:
/// Allows the retrieval of type parameters
#line 52 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual IR::TypeParameters const * getTypeParameters() const = 0;
#line 193 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IMayBeGenericType, NodeKind::IMayBeGenericType, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// Implemented by objects with an 'apply' method: Parser, Control, Table
class IApply : public virtual INode {
 public:
    static const cstring applyMethodName;
/// @returns the type signature of the apply method
#line 59 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual IR::Type_Method const * getApplyMethodType() const = 0;
#line 205 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 60 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual IR::ParameterList const * getApplyParameters() const = 0;
#line 208 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IApply, NodeKind::IApply, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// base class for namespaces
class INamespace : public virtual INode {
 public:
#line 65 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const = 0;
#line 218 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(INamespace, NodeKind::INamespace, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// Does not allow two declarations with the same name
class ISimpleNamespace : public virtual INode, public virtual INamespace {
 public:
#line 70 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual const IR::IDeclaration *getDeclByName(cstring name) const = 0;
#line 228 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 71 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual const IR::IDeclaration *getDeclByName(std::string_view name) const = 0;
#line 231 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(ISimpleNamespace, NodeKind::ISimpleNamespace, INode, INamespace);
};
}  // namespace P4::IR
namespace P4::IR {
/// A general namespace can have multiple declarations with the same name
/// E.g., an extern can have multiple methods with the same name.
class IGeneralNamespace : public virtual INode, public virtual INamespace {
 public:
#line 77 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual Util::Enumerator<const IR::IDeclaration *> * getDeclsByName(cstring name) const;
#line 242 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// prints an error if it finds duplicate names
#line 79 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void checkDuplicateDeclarations() const;
#line 246 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 80 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void validate() const override;
#line 249 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IGeneralNamespace, NodeKind::IGeneralNamespace, INode, INamespace);
};
}  // namespace P4::IR
namespace P4::IR {

class INestedNamespace : public virtual INode, public virtual INamespace {
 public:
#line 86 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual std::vector<const IR::INamespace *> getNestedNamespaces() const = 0;
#line 259 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 87 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 262 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(INestedNamespace, NodeKind::INestedNamespace, INode, INamespace);
};
}  // namespace P4::IR
namespace P4::IR {
/// Interface implemented by something that can be called
/// like a function.
class IFunctional : public virtual INode {
 public:
/// The parameters of the functional object
#line 94 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual const IR::ParameterList *getParameters() const = 0;
#line 274 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Returns true if the parameters can be matched with the
/// supplied arguments.
#line 97 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool callMatches(const IR::Vector<IR::Argument>* arguments) const;
#line 279 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IFunctional, NodeKind::IFunctional, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// Implemented by things that look like type variables
class ITypeVar : public virtual INode {
 public:
#line 102 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual cstring getVarName() const = 0;
#line 289 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 103 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    const IR::Type *asType() const { return to<Type>(); }
#line 292 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 104 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual int getDeclId() const = 0;
#line 295 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(ITypeVar, NodeKind::ITypeVar, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// Implemented by P4Parser, P4Control and Type_Package
class IContainer : public virtual INode, public virtual IMayBeGenericType, public virtual IDeclaration, public virtual IFunctional {
 public:
#line 109 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual const IR::Type *getType() const = 0;
#line 305 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The type of the constructor as a method
#line 111 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual const IR::Type_Method *getConstructorMethodType() const = 0;
#line 309 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 112 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual const IR::ParameterList *getConstructorParameters() const = 0;
#line 312 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 114 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    const IR::ParameterList *getParameters() const override;
#line 316 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IContainer, NodeKind::IContainer, INode, IMayBeGenericType, IDeclaration, IFunctional);
};
}  // namespace P4::IR
namespace P4::IR {
/// This represents a primitive type
/// (called base type in the spec)
class Type_Base : public Type {
 public:
#line 120 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    IR::Type const * getP4Type() const override;
#line 327 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Base const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Base"_cs; }
    static cstring static_type_name() { return "Type_Base"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Base(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Type_Base(Util::SourceInfo srcInfo) :
    Type(srcInfo)
    { validate(); }
    Type_Base() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Type_Base)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Base, NodeKind::Type_Base, Type);
};
}  // namespace P4::IR
namespace P4::IR {
/// This is needed by Expression
class Type_Unknown : public Type_Base {
 public:
#line 126 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    static const IR::Type_Unknown *get();
#line 352 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 127 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    static const IR::Type_Unknown *get(Util::SourceInfo const & si);
#line 355 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 128 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring toString() const override;
#line 358 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Unknown const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Unknown"_cs; }
    static cstring static_type_name() { return "Type_Unknown"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Unknown(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Unknown(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Unknown() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Unknown)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Unknown, NodeKind::Type_Unknown, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
/// A statement or a declaration
class StatOrDecl : public Node {
 public:
    bool operator==(IR::StatOrDecl const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "StatOrDecl"_cs; }
    static cstring static_type_name() { return "StatOrDecl"_cs; }
    void toJSON(JSONGenerator & json) const override;
    StatOrDecl(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    StatOrDecl(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    StatOrDecl() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(StatOrDecl)
    DECLARE_TYPEINFO_WITH_TYPEID(StatOrDecl, NodeKind::StatOrDecl, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// Two declarations with the same name are not necessarily the same declaration.
/// That's why declid is used to distinguish them.
class Declaration : public StatOrDecl, public virtual IDeclaration {
 public:
    IR::ID name;
    long declid = nextId++;
#line 139 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    IR::ID getName() const override;
#line 408 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 140 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool equiv(IR::Node const & a_) const override;
#line 411 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 private:
    static long nextId;
 public:
#line 144 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring toString() const override;
#line 417 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Declaration const & a) const override;
    cstring node_type_name() const override { return "Declaration"_cs; }
    static cstring static_type_name() { return "Declaration"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Declaration(JSONLoader & json);
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Declaration(Util::SourceInfo srcInfo, IR::ID name) :
    StatOrDecl(srcInfo), name(name)
    { validate(); }
    Declaration(IR::ID name) :
    name(name)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Declaration)
    DECLARE_TYPEINFO_WITH_TYPEID(Declaration, NodeKind::Declaration, StatOrDecl, IDeclaration);
};
}  // namespace P4::IR
namespace P4::IR {
/// A declaration which introduces a type.
/// Two declarations with the same name are not the same declaration
/// That's why declid is used to distinguish them.
/// (We don't use multiple inheritance, so we can't
/// inherit both Type and Declaration.)
class Type_Declaration : public Type, public virtual IDeclaration {
 public:
    IR::ID name;
    long declid = nextId++;
#line 155 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    IR::ID getName() const override;
#line 449 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool equiv(IR::Node const & a_) const override;
#line 452 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 private:
    static long nextId;
 public:
#line 160 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring toString() const override;
#line 458 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 161 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    IR::Type const * getP4Type() const override;
#line 461 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Declaration const & a) const override;
    cstring node_type_name() const override { return "Type_Declaration"_cs; }
    static cstring static_type_name() { return "Type_Declaration"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Declaration(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Type_Declaration(Util::SourceInfo srcInfo, IR::ID name) :
    Type(srcInfo), name(name)
    { validate(); }
    Type_Declaration(IR::ID name) :
    name(name)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Type_Declaration)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Declaration, NodeKind::Type_Declaration, Type, IDeclaration);
};
}  // namespace P4::IR
namespace P4::IR {
/// base class for expressions
class Expression : public Node {
 public:
/// Note that the type field is not visited.
/// Most P4_16 passes don't use this field.
/// It is a used to hold the result of TypeInferencing for the expression.
/// It is used by the P4_14 front-end and by some back-ends.
/// It is not visited by the visitors by default (can be visited explicitly in preorder)
    const IR::Type* type = Type::Unknown::get();
#line 172 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 494 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Expression)
    bool operator==(IR::Expression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Expression"_cs; }
    static cstring static_type_name() { return "Expression"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Expression(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    Expression(Util::SourceInfo srcInfo, const IR::Type* type) :
    Node(srcInfo), type(type)
    { validate(); }
    Expression(const IR::Type* type) :
    type(type)
    { validate(); }
    Expression(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    Expression() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Expression)
    DECLARE_TYPEINFO_WITH_TYPEID(Expression, NodeKind::Expression, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class Operation : public Expression {
 public:
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual int getPrecedence() const = 0;
#line 525 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 178 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual cstring getStringOp() const = 0;
#line 528 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 180 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    typedef Operation_Unary Unary;
    typedef Operation_Binary Binary;
    typedef Operation_Relation Relation;
#line 533 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 184 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring toString() const override;
#line 536 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Operation const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Operation"_cs; }
    static cstring static_type_name() { return "Operation"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Operation(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Operation(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    Operation(const IR::Type* type) :
    Expression(type)
    { validate(); }
    Operation(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    Operation() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Operation)
    DECLARE_TYPEINFO_WITH_TYPEID(Operation, NodeKind::Operation, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// Currently paths can be absolute (starting with a dot) or relative
/// (just an identifier).  In a previous design paths could have
/// multiple components.
class Path : public Node {
 public:
    IR::ID name;
    bool absolute = false;
#line 194 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool isDontCare() const { return name.isDontCare(); }
#line 571 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 195 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring toString() const override;
#line 574 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 199 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring asString() const {
        // The CURRENT internal name
        return absl::StrCat(absolute ? "." : "", name);
    }
#line 580 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 203 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void dbprint(std::ostream & out) const override;
#line 583 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 204 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void validate() const override;
#line 586 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Path const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Path"_cs; }
    static cstring static_type_name() { return "Path"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Path(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Path(Util::SourceInfo srcInfo, IR::ID name, bool absolute) :
    Node(srcInfo), name(name), absolute(absolute)
    {
#line 193 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 601 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Path(IR::ID name, bool absolute) :
    name(name), absolute(absolute)
    {
#line 193 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 608 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Path(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    {
#line 193 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 615 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Path(IR::ID name) :
    name(name)
    {
#line 193 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 622 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Path)
    DECLARE_TYPEINFO_WITH_TYPEID(Path, NodeKind::Path, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// Handy class used in several NamedMaps
class NamedExpression : public Declaration {
 public:
    const IR::Expression* expression = nullptr;
    bool operator==(IR::NamedExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "NamedExpression"_cs; }
    static cstring static_type_name() { return "NamedExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    NamedExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    NamedExpression(Util::SourceInfo srcInfo, IR::ID name, const IR::Expression* expression) :
    Declaration(srcInfo, name), expression(expression)
    { validate(); }
    NamedExpression(IR::ID name, const IR::Expression* expression) :
    Declaration(name), expression(expression)
    { validate(); }
    IRNODE_SUBCLASS(NamedExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(NamedExpression, NodeKind::NamedExpression, Declaration);
};
}  // namespace P4::IR
namespace P4::IR {
/// A token in an unparsed annotation.
/// This should really be P4::P4Parser::symbol_type, but p4parser.hpp depends
/// on the IR in a way that makes it difficult to #include in this file.
class AnnotationToken : public Node {
 public:
    int token_type;

    cstring text;
    UnparsedConstant * constInfo = nullptr;
#line 219 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void dbprint(std::ostream & out) const override;
#line 669 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::AnnotationToken const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "AnnotationToken"_cs; }
    static cstring static_type_name() { return "AnnotationToken"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AnnotationToken(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    AnnotationToken(Util::SourceInfo srcInfo, int token_type, cstring text, UnparsedConstant * constInfo) :
    Node(srcInfo), token_type(token_type), text(text), constInfo(constInfo)
    { validate(); }
    AnnotationToken(int token_type, cstring text, UnparsedConstant * constInfo) :
    token_type(token_type), text(text), constInfo(constInfo)
    { validate(); }
    AnnotationToken(Util::SourceInfo srcInfo, int token_type, cstring text) :
    Node(srcInfo), token_type(token_type), text(text)
    { validate(); }
    AnnotationToken(int token_type, cstring text) :
    token_type(token_type), text(text)
    { validate(); }
    IRNODE_SUBCLASS(AnnotationToken)
    DECLARE_TYPEINFO_WITH_TYPEID(AnnotationToken, NodeKind::AnnotationToken, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// Annotations are used to provide additional information to the compiler
/// Most P4 entities can be optionally annotated
class Annotation : public Node {
 public:
    IR::ID name;
#line 228 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    using UnparsedAnnotation = IR::Vector<IR::AnnotationToken>;
    using ExpressionAnnotation = IR::Vector<IR::Expression>;
    using KVAnnotation = IR::IndexedVector<IR::NamedExpression>;
#line 705 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// For annotations parsed from P4-16 source.
#line 235 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(Util::SourceInfo si, IR::ID n, IR::Vector<IR::AnnotationToken> const & a) : Node(si), name(n), body(a), structured(false) {}
#line 709 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 238 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(Util::SourceInfo si, IR::ID n, IR::Vector<IR::AnnotationToken> const & a, bool structured) : Node(si), name(n), body(a), structured(structured) {}
#line 713 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 242 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(Util::SourceInfo si, IR::ID n, std::initializer_list<IR::Expression const *> a, bool structured = false) : Node(si), name(n), body(a), structured(structured) {}
#line 717 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 245 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(Util::SourceInfo si, IR::ID n, IR::Expression const * a, bool structured = false) : Node(si), name(n), body(), structured(structured) {
        body.emplace<ExpressionAnnotation>(a);
    }
#line 722 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 250 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(Util::SourceInfo si, IR::ID n, IR::Vector<IR::Expression> const & a, bool structured = false) : Node(si), name(n), body(a), structured(structured) {}
#line 725 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 252 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(Util::SourceInfo si, IR::ID n, IR::IndexedVector<IR::NamedExpression> const & kv, bool structured = false) : Node(si), name(n), body(kv), structured(structured) {}
#line 728 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 255 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(IR::ID n, IR::Expression const * a, bool structured = false) : name(n), body(), structured(structured) {
        body.emplace<ExpressionAnnotation>(a);
    }
#line 733 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 259 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(IR::ID n, std::initializer_list<IR::Expression const *> a, bool structured = false) : name(n), body(a), structured(structured) {}
#line 736 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 261 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(IR::ID n, IR::Vector<IR::Expression> const & a, bool structured = false) : name(n), body(a), structured(structured) {}
#line 739 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 263 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(IR::ID n, intmax_t v, bool structured = false);
#line 742 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"


#line 269 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    Annotation(IR::ID n, cstring v, bool structured = false);
#line 747 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

    static const cstring nameAnnotation;
/// Indicates the control-plane name.
    static const cstring tableOnlyAnnotation;
/// Action cannot be a default_action.
    static const cstring defaultOnlyAnnotation;
/// action can only be a default_action.
    static const cstring atomicAnnotation;
/// Code should be executed atomically.
    static const cstring hiddenAnnotation;
/// Object should not be exposed to the control-plane.
    static const cstring lengthAnnotation;
/// P4-14 annotation for varbit fields.
    static const cstring maxLengthAnnotation;
/// P4-14 annotation for varbit fields.
    static const cstring optionalAnnotation;
/// Optional parameter annotation
    static const cstring pkginfoAnnotation;
/// Package documentation annotation.
    static const cstring deprecatedAnnotation;
/// Deprecation annotation.
    static const cstring synchronousAnnotation;
/// Synchronous annotation.
    static const cstring pureAnnotation;
/// extern function/method annotation.
    static const cstring noSideEffectsAnnotation;
/// extern function/method annotation.
    static const cstring noWarnAnnotation;
/// noWarn annotation.
    static const cstring matchAnnotation;
/// Match annotation (for value sets).
    static const cstring fieldListAnnotation;
/// Used for recirculate, etc.
    static const cstring debugLoggingAnnotation;
/// Used by compiler implementer to limit debug log to the annotated IR context.
    static const cstring disableOptimizationAnnotation;
/// annotation to disable certain optimization
    static const cstring inlinedFromAnnotation;
/// annotation to mark block of inlined function
    static const cstring likelyAnnotation;
/// annotation for likely taken blocks/branchs
    static const cstring unlikelyAnnotation;
/// annotation for likely not taken blocks/branchs
#line 296 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring toString() const override;
#line 793 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 297 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void validate() const override;
#line 796 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Extracts name value from a name annotation
#line 302 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring getName() const;
#line 800 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Extracts a single string argument; error if the argument is not a string
#line 304 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring getSingleString() const;
#line 804 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Whether the annotation body needs to be parsed.
#line 306 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool needsParsing() const {
        return std::holds_alternative<UnparsedAnnotation>(body);
    }
#line 810 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
enum class Kind
#line 311 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{
        Unparsed,
        Unstructured,
        StructuredKVList,
        StructuredExpressionList
    };
#line 819 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 317 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    IR::Annotation::Kind annotationKind() const {
        if (needsParsing())
            return Kind::Unparsed;
        if (!structured)
            return Kind::Unstructured;
        if (std::holds_alternative<ExpressionAnnotation>(body))
            return Kind::StructuredExpressionList;
        if (std::holds_alternative<KVAnnotation>(body))
            return Kind::StructuredKVList;

        BUG("Invalid annotation kind");
    }
#line 833 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"



    using body_variant = std::variant<IR::Vector<IR::AnnotationToken>, IR::Vector<IR::Expression>, IR::IndexedVector<IR::NamedExpression>>;
    body_variant body;
#line 337 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    auto & getUnparsed() {
        try {
            return std::get<UnparsedAnnotation>(body);
        } catch (const std::bad_variant_access &) {
            BUG("Annotation has been parsed already.");
        }
    }
#line 847 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 344 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    auto const & getUnparsed() const {
        try {
            return std::get<UnparsedAnnotation>(body);
        } catch (const std::bad_variant_access &) {
            BUG("Annotation has been parsed already.");
        }
    }
#line 856 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 351 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    auto & getExpr() {
        try {
            return std::get<ExpressionAnnotation>(body);
        } catch (const std::bad_variant_access &) {
            BUG("Annotation does not contain an expression list.");
        }
     }
#line 865 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 358 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    auto const & getExpr() const {
        try {
            return std::get<ExpressionAnnotation>(body);
        } catch (const std::bad_variant_access &) {
            BUG("Annotation does not contain an expression list.");
        }
    }
#line 874 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 365 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    const IR::Expression *getExpr(size_t idx) const {
        try {
            const auto &expr = getExpr();
            return expr[idx];
        } catch (const std::out_of_range &) {
            BUG("invalid annotation expression index");
        } catch (const std::bad_variant_access &) {
            BUG("Annotation does not contain an expression list.");
        }
    }
#line 886 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 375 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    auto & getKV() {
        try {
            return std::get<KVAnnotation>(body);
        } catch (const std::bad_variant_access &) {
            BUG("Annotation does not contain a key-value list.");
        }
    }
#line 895 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 382 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    auto const & getKV() const {
        try {
            return std::get<KVAnnotation>(body);
        } catch (const std::bad_variant_access &) {
            BUG("Annotation does not contain a key-value list.");
        }
    }
#line 904 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// If this is true this is a structured annotation, and there are some
/// constraints on its contents.
    bool structured;
    bool operator==(IR::Annotation const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Annotation"_cs; }
    static cstring static_type_name() { return "Annotation"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Annotation(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Annotation(Util::SourceInfo srcInfo, IR::ID name, body_variant body, bool structured) :
    Node(srcInfo), name(name), body(body), structured(structured)
    {
#line 232 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 925 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Annotation(IR::ID name, body_variant body, bool structured) :
    name(name), body(body), structured(structured)
    {
#line 232 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 932 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Annotation)
    DECLARE_TYPEINFO_WITH_TYPEID(Annotation, NodeKind::Annotation, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// Implemented by all objects that can have annotations
// FIXME: Use CRTP to get access to the fields directly
class IAnnotated : public virtual INode {
 public:
#line 398 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual IR::Vector<IR::Annotation> const & getAnnotations() const = 0;
#line 945 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 399 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual IR::Vector<IR::Annotation> & getAnnotations() = 0;
#line 948 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 401 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    const IR::Annotation *getAnnotation(cstring name) const {
        const auto &annotations = getAnnotations();
        return get(annotations, name);
    }
#line 954 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Checks if there is annotation @name
#line 406 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool hasAnnotation(cstring name) const {
        const auto &annotations = getAnnotations();
        return get(annotations, name) != nullptr;
    }
#line 961 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Checks if there is annotation @name and it is the only annotation on the
/// node
#line 412 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool hasOnlyAnnotation(cstring name) const {
        const auto &annotations = getAnnotations();
        return annotations.size() == 1 && get(annotations, name) != nullptr;
    }
#line 969 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Check if there are any annotations
#line 417 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    bool hasAnnotations() const {
        const auto &annotations = getAnnotations();
        return !annotations.empty();
    }
#line 976 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 421 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void addAnnotation(const IR::Annotation* annot) {
        auto &annotations = getAnnotations();
        annotations.push_back(annot);
    }
#line 982 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 425 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void addAnnotation(cstring name, const IR::Expression* expr, bool structured = false) {
        addAnnotation(new Annotation(name, { expr }, structured));
    }
#line 987 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Add annotation if another annotation with the same name is not
/// already present.
#line 431 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void addAnnotationIfNew(cstring name, const IR::Expression* expr, bool structured = false) {
        Annotations::addIfNew(getAnnotations(), name, expr, structured);
    }
#line 994 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 435 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void addAnnotationIfNew(const IR::Annotation* ann) {
        Annotations::addIfNew(getAnnotations(), ann);
    }
#line 999 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// If annotations with the same name are already present, remove them;
/// add this annotation.
#line 441 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void addOrReplaceAnnotation(cstring name, const IR::Expression* expr, bool structured = false) {
        Annotations::addOrReplace(getAnnotations(), name, expr, structured);
    }
#line 1006 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 445 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void addOrReplaceAnnotation(const IR::Annotation* ann) {
        Annotations::addOrReplace(getAnnotations(), ann);
    }
#line 1011 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IAnnotated, NodeKind::IAnnotated, INode);
};
}  // namespace P4::IR
namespace P4::IR {
class IInstance : public virtual INode {
 public:
#line 451 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual IR::ID Name() const = 0;
#line 1020 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 452 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    virtual const IR::Type *getType() const = 0;
#line 1023 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IInstance, NodeKind::IInstance, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// An argument to a function call (or constructor call)
/// Arguments may have optional names
class Argument : public Node {
 public:
/// If an argument has no name the name.name is nullptr.
    IR::ID name;
    const IR::Expression* expression = nullptr;
#line 462 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void dbprint(std::ostream & out) const override;
#line 1037 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 463 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    void validate() const override;
#line 1040 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 464 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
    cstring toString() const override;
#line 1043 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Argument const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Argument"_cs; }
    static cstring static_type_name() { return "Argument"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Argument(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Argument(Util::SourceInfo srcInfo, IR::ID name, const IR::Expression* expression) :
    Node(srcInfo), name(name), expression(expression)
    {
#line 461 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo && expression) srcInfo = expression->srcInfo; }
#line 1060 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Argument(IR::ID name, const IR::Expression* expression) :
    name(name), expression(expression)
    {
#line 461 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo && expression) srcInfo = expression->srcInfo; }
#line 1067 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Argument(Util::SourceInfo srcInfo, const IR::Expression* expression) :
    Node(srcInfo), expression(expression)
    {
#line 461 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo && expression) srcInfo = expression->srcInfo; }
#line 1074 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Argument(const IR::Expression* expression) :
    expression(expression)
    {
#line 461 "/builddir/build/BUILD/p4c-1.2.5.8/ir/base.def"
{ if (!srcInfo && expression) srcInfo = expression->srcInfo; }
#line 1081 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Argument)
    DECLARE_TYPEINFO_WITH_TYPEID(Argument, NodeKind::Argument, Node);
};
}  // namespace P4::IR
/** @} */
/* end group irdefs */
/* -*-C++-*- */
/** \addtogroup irdefs
  * @{
  */
/*
   This file contains IR related to representating the type hierarchy.
   Some of these classes never appear in the IR tree, they are just
   synthesized by the type-checker.
*/
#line 12 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
namespace P4 {
namespace IR {
enum class Direction {
    None,
    In,
    Out,
    InOut
};

inline cstring directionToString(IR::Direction direction) {
    switch (direction) {
        case IR::Direction::None:
            return "<none>"_cs;
        case IR::Direction::In:
            return "in"_cs;
        case IR::Direction::Out:
            return "out"_cs;
        case IR::Direction::InOut:
            return "inout"_cs;
        default:
            BUG("Unhandled case");
    }
}
}  // namespace IR

inline std::ostream& operator<<(std::ostream &out, IR::Direction d) {
    switch (d) {
        case IR::Direction::None:
            break;
        case IR::Direction::In:
            out << "in";
            break;
        case IR::Direction::Out:
            out << "out";
            break;
        case IR::Direction::InOut:
            out << "inout";
            break;
        default:
            BUG("Unhandled case");
    }
    return out;
}

// FIXME: should accept string_view
inline bool operator>>(cstring s, IR::Direction &d) {
    if (!s || s == cstring::empty) d = IR::Direction::None;
    else if (s == "in") d = IR::Direction::In;
    else if (s == "out") d = IR::Direction::Out;
    else if (s == "inout") d = IR::Direction::InOut;
    else return false;
    return true;
}

}  // namespace P4

#line 1155 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
/// This represents a type that can unify with any other type.
/// It is the original type of Dots (...) expressions.
/// There is no syntax to represent this type.
/// Treated like a type variable so that unification can assign it a value.
class Type_Any : public Type, public virtual ITypeVar {
 protected:
#line 77 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1171 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    static long nextId;
 public:
    long declid = nextId++;
#line 88 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring getVarName() const override;
#line 1177 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 89 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int getDeclId() const override;
#line 1180 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 90 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1183 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 91 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1186 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 92 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool operator==(IR::Type_Any const & a) const override;
#line 1189 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 93 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Any *get();
#line 1192 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 94 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Any *get(Util::SourceInfo const & si);
#line 1195 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 95 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 1198 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 96 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool equiv(IR::Node const & a_) const override;
#line 1201 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring node_type_name() const override { return "Type_Any"_cs; }
    static cstring static_type_name() { return "Type_Any"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Any(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Any(Util::SourceInfo srcInfo) :
    Type(srcInfo)
    { validate(); }
    Type_Any() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Any)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Any, NodeKind::Type_Any, Type, ITypeVar);
};
}  // namespace P4::IR
namespace P4::IR {
/// This type is a fragment of another type.
/// This is used in conjunction with Type_Any to typecheck
/// expressions containing ... (Dots).
/// After unification this type replaces Type_Any.
/// For example:
/// struct S { bit<32> s; bit<16> t; }
/// S s = { s = 2, ... };
/// The type assigned to 'type' by unification will be
/// Type_Fragment { type = Type_UnknownStruct { t: Type_Bits<15> } }.
/// In other words, the type of the ... expression is a
/// fragment of a struct that contains just the field t.
class Type_Fragment : public Type {
 public:
    const IR::Type* type = nullptr;
#line 115 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1236 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 116 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1239 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 117 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 1242 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Fragment const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Fragment"_cs; }
    static cstring static_type_name() { return "Type_Fragment"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Fragment(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Fragment(Util::SourceInfo srcInfo, const IR::Type* type) :
    Type(srcInfo), type(type)
    { validate(); }
    Type_Fragment(const IR::Type* type) :
    type(type)
    { validate(); }
    IRNODE_SUBCLASS(Type_Fragment)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Fragment, NodeKind::Type_Fragment, Type);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents the type of a type.
/// For example, in a declaration like
/// bit<32> x;
/// The type of x is Type_Bits(32);
/// The type of 'bit<32>' is Type_Type(Type_Bits(32))
/// TypeType should not appear in the program IR, just in the TypeMap produced
/// by type-checking.
class Type_Type : public Type {
 public:
    const IR::Type* type = nullptr;
#line 129 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1278 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 130 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1281 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 131 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 1284 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 132 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 1287 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Type const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_Type"_cs; }
    static cstring static_type_name() { return "Type_Type"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Type(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Type(Util::SourceInfo srcInfo, const IR::Type* type) :
    Type(srcInfo), type(type)
    { validate(); }
    Type_Type(const IR::Type* type) :
    type(type)
    { validate(); }
    IRNODE_SUBCLASS(Type_Type)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Type, NodeKind::Type_Type, Type);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Boolean : public Type_Base {
 protected:
#line 138 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1320 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
#line 147 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Boolean *get();
#line 1324 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 148 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Boolean *get(Util::SourceInfo const & si);
#line 1327 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 149 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 1330 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 150 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1333 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 151 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1336 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Boolean const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Boolean"_cs; }
    static cstring static_type_name() { return "Type_Boolean"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Boolean(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Boolean(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Boolean() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Boolean)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Boolean, NodeKind::Type_Boolean, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
/// The type of a parser state
class Type_State : public Type_Base {
 protected:
#line 158 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1368 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
#line 167 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_State *get();
#line 1372 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 168 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_State *get(Util::SourceInfo const & si);
#line 1375 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 169 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1378 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 170 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1381 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_State const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_State"_cs; }
    static cstring static_type_name() { return "Type_State"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_State(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_State(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_State() 
    { validate(); }
    IRNODE_SUBCLASS(Type_State)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_State, NodeKind::Type_State, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents both bit<> and int<> types in P4-14 and P4-16
class Type_Bits : public Type_Base {
 protected:
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1413 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
    int size = 0;

    const IR::Expression* expression = nullptr;

    bool isSigned;
#line 189 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Bits *get(Util::SourceInfo const & si, const IR::Expression* expression, bool isSigned = false);
#line 1422 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 190 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Bits *get(Util::SourceInfo const & si, int sz, bool isSigned = false);
#line 1425 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 191 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Bits *get(int sz, bool isSigned = false);
#line 1428 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 192 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring baseName() const { return isSigned ? "int"_cs : "bit"_cs; }
#line 1431 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 193 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 1434 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 195 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1437 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 196 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1440 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Bits const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_Bits"_cs; }
    static cstring static_type_name() { return "Type_Bits"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Bits(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Bits(Util::SourceInfo srcInfo, int size, const IR::Expression* expression, bool isSigned) :
    Type_Base(srcInfo), size(size), expression(expression), isSigned(isSigned)
    { validate(); }
    Type_Bits(int size, const IR::Expression* expression, bool isSigned) :
    size(size), expression(expression), isSigned(isSigned)
    { validate(); }
    Type_Bits(Util::SourceInfo srcInfo, const IR::Expression* expression, bool isSigned) :
    Type_Base(srcInfo), expression(expression), isSigned(isSigned)
    { validate(); }
    Type_Bits(const IR::Expression* expression, bool isSigned) :
    expression(expression), isSigned(isSigned)
    { validate(); }
    Type_Bits(Util::SourceInfo srcInfo, int size, bool isSigned) :
    Type_Base(srcInfo), size(size), isSigned(isSigned)
    { validate(); }
    Type_Bits(int size, bool isSigned) :
    size(size), isSigned(isSigned)
    { validate(); }
    Type_Bits(Util::SourceInfo srcInfo, bool isSigned) :
    Type_Base(srcInfo), isSigned(isSigned)
    { validate(); }
    Type_Bits(bool isSigned) :
    isSigned(isSigned)
    { validate(); }
    IRNODE_SUBCLASS(Type_Bits)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Bits, NodeKind::Type_Bits, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Varbits : public Type_Base {
 protected:
#line 202 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1493 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
    int size = 0;

    const IR::Expression* expression = nullptr;

#line 213 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Varbits *get(Util::SourceInfo const & si, const IR::Expression* expr);
#line 1501 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 214 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Varbits *get(Util::SourceInfo const & si, int size);
#line 1504 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 215 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Varbits *get(int size);
#line 1507 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 216 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Varbits *get();
#line 1510 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 217 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1513 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 218 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1516 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 219 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 1519 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Varbits const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_Varbits"_cs; }
    static cstring static_type_name() { return "Type_Varbits"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Varbits(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Varbits(Util::SourceInfo srcInfo, int size, const IR::Expression* expression) :
    Type_Base(srcInfo), size(size), expression(expression)
    { validate(); }
    Type_Varbits(int size, const IR::Expression* expression) :
    size(size), expression(expression)
    { validate(); }
    Type_Varbits(Util::SourceInfo srcInfo, const IR::Expression* expression) :
    Type_Base(srcInfo), expression(expression)
    { validate(); }
    Type_Varbits(const IR::Expression* expression) :
    expression(expression)
    { validate(); }
    Type_Varbits(Util::SourceInfo srcInfo, int size) :
    Type_Base(srcInfo), size(size)
    { validate(); }
    Type_Varbits(int size) :
    size(size)
    { validate(); }
    Type_Varbits(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Varbits() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Varbits)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Varbits, NodeKind::Type_Varbits, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Parameter : public Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    Direction direction;
    const IR::Type* type = nullptr;
    const IR::Expression* defaultValue = nullptr;
#line 227 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 1569 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 228 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 1572 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 229 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool hasOut() const { return direction == IR::Direction::Out || direction == IR::Direction::InOut; }
#line 1575 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 231 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool isOptional() const {
        return getAnnotation(Annotation::optionalAnnotation) != nullptr; }
#line 1579 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 233 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1582 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Parameter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Parameter"_cs; }
    static cstring static_type_name() { return "Parameter"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Parameter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Parameter(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, Direction direction, const IR::Type* type, const IR::Expression* defaultValue) :
    Declaration(srcInfo, name), annotations(annotations), direction(direction), type(type), defaultValue(defaultValue)
    { validate(); }
    Parameter(IR::ID name, IR::Vector<IR::Annotation> annotations, Direction direction, const IR::Type* type, const IR::Expression* defaultValue) :
    Declaration(name), annotations(annotations), direction(direction), type(type), defaultValue(defaultValue)
    { validate(); }
    Parameter(Util::SourceInfo srcInfo, IR::ID name, Direction direction, const IR::Type* type, const IR::Expression* defaultValue) :
    Declaration(srcInfo, name), direction(direction), type(type), defaultValue(defaultValue)
    { validate(); }
    Parameter(IR::ID name, Direction direction, const IR::Type* type, const IR::Expression* defaultValue) :
    Declaration(name), direction(direction), type(type), defaultValue(defaultValue)
    { validate(); }
    Parameter(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, Direction direction, const IR::Type* type) :
    Declaration(srcInfo, name), annotations(annotations), direction(direction), type(type)
    { validate(); }
    Parameter(IR::ID name, IR::Vector<IR::Annotation> annotations, Direction direction, const IR::Type* type) :
    Declaration(name), annotations(annotations), direction(direction), type(type)
    { validate(); }
    Parameter(Util::SourceInfo srcInfo, IR::ID name, Direction direction, const IR::Type* type) :
    Declaration(srcInfo, name), direction(direction), type(type)
    { validate(); }
    Parameter(IR::ID name, Direction direction, const IR::Type* type) :
    Declaration(name), direction(direction), type(type)
    { validate(); }
    IRNODE_SUBCLASS(Parameter)
    DECLARE_TYPEINFO_WITH_TYPEID(Parameter, NodeKind::Parameter, Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class ParameterList : public Node, public virtual ISimpleNamespace {
 public:
    IR::IndexedVector<IR::Parameter> parameters;
#line 239 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 1631 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 240 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::Parameter *> * getEnumerator() const {
        return parameters.getEnumerator(); }
#line 1635 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 242 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 1638 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t size() const { return parameters.size(); }
#line 1641 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 245 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool empty() const { return size() == 0; }
#line 1644 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 246 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Parameter *getParameter(cstring name) const {
        return parameters.getDeclaration<Parameter>(name); }
#line 1648 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 248 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Parameter *getParameter(std::string_view name) const {
        return parameters.getDeclaration<Parameter>(name); }
#line 1652 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 250 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Parameter *getParameter(unsigned index) const {
        for (auto &param : parameters)
            if (0 == index--) return param;
        BUG("Only %1% parameters; index #%2% requested", size(), size()+index); }
#line 1658 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 254 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 1661 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 255 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 1664 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 256 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void push_back(IR::Parameter const * p) { parameters.push_back(p); }
#line 1667 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 257 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1670 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 264 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    auto begin() const -> decltype(parameters.begin()) { return parameters.begin(); }
    auto end() const -> decltype(parameters.end()) { return parameters.end(); }
#line 1674 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ParameterList const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ParameterList"_cs; }
    static cstring static_type_name() { return "ParameterList"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParameterList(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ParameterList(Util::SourceInfo srcInfo, IR::IndexedVector<IR::Parameter> parameters) :
    Node(srcInfo), parameters(parameters)
    { validate(); }
    ParameterList(IR::IndexedVector<IR::Parameter> parameters) :
    parameters(parameters)
    { validate(); }
    ParameterList(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    ParameterList() 
    { validate(); }
    IRNODE_SUBCLASS(ParameterList)
    DECLARE_TYPEINFO_WITH_TYPEID(ParameterList, NodeKind::ParameterList, Node, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents a type variable written by the user
class Type_Var : public Type_Declaration, public virtual ITypeVar {
 public:
#line 271 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring getVarName() const override;
#line 1707 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 272 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int getDeclId() const override;
#line 1710 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 273 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1713 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 274 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1716 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Var const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Var"_cs; }
    static cstring static_type_name() { return "Type_Var"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Var(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Var(Util::SourceInfo srcInfo, IR::ID name) :
    Type_Declaration(srcInfo, name)
    { validate(); }
    Type_Var(IR::ID name) :
    Type_Declaration(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_Var)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Var, NodeKind::Type_Var, Type_Declaration, ITypeVar);
};
}  // namespace P4::IR
namespace P4::IR {
/// Stands for the 'int' type: infinite precision constant
/// However, we represent it as a type variable, because we use
/// type unification to discover the correct type for the constants
/// in some contexts.
class Type_InfInt : public Type, public virtual ITypeVar {
 protected:
#line 284 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1752 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    long declid = nextId++;
 private:
    static long nextId;
 public:
#line 296 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring getVarName() const override;
#line 1759 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 297 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int getDeclId() const override;
#line 1762 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 298 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1765 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 299 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1768 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 300 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool operator==(IR::Type_InfInt const & a) const override;
#line 1771 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 301 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_InfInt *get();
#line 1774 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 302 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_InfInt *get(Util::SourceInfo const & si);
#line 1777 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 303 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool equiv(IR::Node const & a_) const override;
#line 1780 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 307 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 1783 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 308 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 1786 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring node_type_name() const override { return "Type_InfInt"_cs; }
    static cstring static_type_name() { return "Type_InfInt"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_InfInt(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_InfInt(Util::SourceInfo srcInfo) :
    Type(srcInfo)
    { validate(); }
    Type_InfInt() 
    { validate(); }
    IRNODE_SUBCLASS(Type_InfInt)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_InfInt, NodeKind::Type_InfInt, Type, ITypeVar);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Dontcare : public Type_Base {
 protected:
#line 314 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1815 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
#line 323 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1819 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 324 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Dontcare *get();
#line 1822 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 325 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Dontcare *get(Util::SourceInfo const & si);
#line 1825 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 326 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1828 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Dontcare const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Dontcare"_cs; }
    static cstring static_type_name() { return "Type_Dontcare"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Dontcare(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Dontcare(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Dontcare() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Dontcare)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Dontcare, NodeKind::Type_Dontcare, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Void : public Type_Base {
 protected:
#line 332 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1859 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
#line 341 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1863 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 342 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Void *get();
#line 1866 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 343 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_Void *get(Util::SourceInfo const & si);
#line 1869 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 344 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1872 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Void const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Void"_cs; }
    static cstring static_type_name() { return "Type_Void"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Void(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Void(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Void() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Void)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Void, NodeKind::Type_Void, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_MatchKind : public Type_Base {
 protected:
#line 350 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 1903 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
#line 359 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1907 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 360 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_MatchKind *get();
#line 1910 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 361 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_MatchKind *get(Util::SourceInfo const & si);
#line 1913 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 362 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 1916 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_MatchKind const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_MatchKind"_cs; }
    static cstring static_type_name() { return "Type_MatchKind"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_MatchKind(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_MatchKind(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_MatchKind() 
    { validate(); }
    IRNODE_SUBCLASS(Type_MatchKind)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_MatchKind, NodeKind::Type_MatchKind, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class TypeParameters : public Node, public virtual ISimpleNamespace {
 public:
    IR::IndexedVector<IR::Type_Var> parameters;
#line 367 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 1942 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 369 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool empty() const { return parameters.empty(); }
#line 1945 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 370 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t size() const { return parameters.size(); }
#line 1948 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 371 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 1951 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 373 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 1954 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 375 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void push_back(const IR::Type_Var* tv) { parameters.push_back(tv); }
#line 1957 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 376 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 1960 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 377 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 1963 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TypeParameters const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "TypeParameters"_cs; }
    static cstring static_type_name() { return "TypeParameters"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TypeParameters(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TypeParameters(Util::SourceInfo srcInfo, IR::IndexedVector<IR::Type_Var> parameters) :
    Node(srcInfo), parameters(parameters)
    { validate(); }
    TypeParameters(IR::IndexedVector<IR::Type_Var> parameters) :
    parameters(parameters)
    { validate(); }
    TypeParameters(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    TypeParameters() 
    { validate(); }
    IRNODE_SUBCLASS(TypeParameters)
    DECLARE_TYPEINFO_WITH_TYPEID(TypeParameters, NodeKind::TypeParameters, Node, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
class StructField : public Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* type = nullptr;
#line 392 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 1997 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 393 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 2000 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::StructField const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "StructField"_cs; }
    static cstring static_type_name() { return "StructField"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    StructField(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    StructField(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Declaration(srcInfo, name), annotations(annotations), type(type)
    { validate(); }
    StructField(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Declaration(name), annotations(annotations), type(type)
    { validate(); }
    StructField(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type) :
    Declaration(srcInfo, name), type(type)
    { validate(); }
    StructField(IR::ID name, const IR::Type* type) :
    Declaration(name), type(type)
    { validate(); }
    IRNODE_SUBCLASS(StructField)
    DECLARE_TYPEINFO_WITH_TYPEID(StructField, NodeKind::StructField, Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_StructLike : public Type_Declaration, public virtual INestedNamespace, public virtual ISimpleNamespace, public virtual IAnnotated, public virtual IMayBeGenericType {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::TypeParameters* typeParameters = new TypeParameters();
    IR::IndexedVector<IR::StructField> fields;
#line 400 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::TypeParameters *getTypeParameters() const override;
#line 2039 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 401 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    std::vector<const IR::INamespace *> getNestedNamespaces() const override;
#line 2042 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 402 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 2045 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 403 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 2048 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 404 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 2051 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 406 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::StructField *getField(cstring name) const {
        return fields.getDeclaration<StructField>(name); }
#line 2055 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 408 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int getFieldIndex(cstring name) const {
        int index_pos = 0;
        for (auto f : fields) {
            if (f->name == name)
                return index_pos;
            index_pos++;
        }
        return -1;
    }
#line 2066 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// This function returns start offset of the given field name in bits.
/// If the given name is not a valid field name, -1 is returned.
/// The given offset may not be correct if varbit field(s) present in between.
/// Offset for all fields will be correct if:
///  - the type has only fixed width fields
///  - the type has fixed width fields with only one varbit field as a last member.
#line 423 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int getFieldBitOffset(cstring name) const {
        int offset = 0;
        for (auto f : fields) {
            if (f->name == name) {
                return offset;
            }
            offset += f->type->width_bits();
        }
        return -1;
    }
#line 2084 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 433 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 2087 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 439 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 2090 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 441 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 2093 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 443 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 2096 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 444 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 2099 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Type_StructLike)
    bool operator==(IR::Type_StructLike const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_StructLike"_cs; }
    static cstring static_type_name() { return "Type_StructLike"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_StructLike(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(srcInfo, name), annotations(annotations), typeParameters(typeParameters), fields(fields)
    { validate(); }
    Type_StructLike(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(name), annotations(annotations), typeParameters(typeParameters), fields(fields)
    { validate(); }
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), fields(fields)
    { validate(); }
    Type_StructLike(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(name), typeParameters(typeParameters), fields(fields)
    { validate(); }
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(srcInfo, name), annotations(annotations), fields(fields)
    { validate(); }
    Type_StructLike(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(name), annotations(annotations), fields(fields)
    { validate(); }
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(srcInfo, name), fields(fields)
    { validate(); }
    Type_StructLike(IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_Declaration(name), fields(fields)
    { validate(); }
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Declaration(srcInfo, name), annotations(annotations), typeParameters(typeParameters)
    { validate(); }
    Type_StructLike(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Declaration(name), annotations(annotations), typeParameters(typeParameters)
    { validate(); }
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters)
    { validate(); }
    Type_StructLike(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Declaration(name), typeParameters(typeParameters)
    { validate(); }
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), annotations(annotations)
    { validate(); }
    Type_StructLike(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), annotations(annotations)
    { validate(); }
    Type_StructLike(Util::SourceInfo srcInfo, IR::ID name) :
    Type_Declaration(srcInfo, name)
    { validate(); }
    Type_StructLike(IR::ID name) :
    Type_Declaration(name)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Type_StructLike)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_StructLike, NodeKind::Type_StructLike, Type_Declaration, INestedNamespace, ISimpleNamespace, IAnnotated, IMayBeGenericType);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Struct : public Type_StructLike {
 public:
#line 450 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2170 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Struct const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Struct"_cs; }
    static cstring static_type_name() { return "Type_Struct"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Struct(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_StructLike const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, typeParameters, fields)
    { validate(); }
    Type_Struct(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, typeParameters, fields)
    { validate(); }
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, typeParameters, fields)
    { validate(); }
    Type_Struct(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, typeParameters, fields)
    { validate(); }
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, fields)
    { validate(); }
    Type_Struct(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, fields)
    { validate(); }
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, fields)
    { validate(); }
    Type_Struct(IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, fields)
    { validate(); }
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, annotations, typeParameters)
    { validate(); }
    Type_Struct(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, annotations, typeParameters)
    { validate(); }
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, typeParameters)
    { validate(); }
    Type_Struct(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, typeParameters)
    { validate(); }
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(srcInfo, name, annotations)
    { validate(); }
    Type_Struct(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(name, annotations)
    { validate(); }
    Type_Struct(Util::SourceInfo srcInfo, IR::ID name) :
    Type_StructLike(srcInfo, name)
    { validate(); }
    Type_Struct(IR::ID name) :
    Type_StructLike(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_Struct)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Struct, NodeKind::Type_Struct, Type_StructLike);
};
}  // namespace P4::IR
namespace P4::IR {
/// This is the type of a struct-valued expression whose
/// exact struct type is yet unknown; we only know the field names
/// and some information about their types.
class Type_UnknownStruct : public Type_StructLike {
 public:
    bool operator==(IR::Type_UnknownStruct const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_UnknownStruct"_cs; }
    static cstring static_type_name() { return "Type_UnknownStruct"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_UnknownStruct(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_StructLike const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, typeParameters, fields)
    { validate(); }
    Type_UnknownStruct(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, typeParameters, fields)
    { validate(); }
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, typeParameters, fields)
    { validate(); }
    Type_UnknownStruct(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, typeParameters, fields)
    { validate(); }
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, fields)
    { validate(); }
    Type_UnknownStruct(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, fields)
    { validate(); }
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, fields)
    { validate(); }
    Type_UnknownStruct(IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, fields)
    { validate(); }
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, annotations, typeParameters)
    { validate(); }
    Type_UnknownStruct(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, annotations, typeParameters)
    { validate(); }
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, typeParameters)
    { validate(); }
    Type_UnknownStruct(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, typeParameters)
    { validate(); }
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(srcInfo, name, annotations)
    { validate(); }
    Type_UnknownStruct(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(name, annotations)
    { validate(); }
    Type_UnknownStruct(Util::SourceInfo srcInfo, IR::ID name) :
    Type_StructLike(srcInfo, name)
    { validate(); }
    Type_UnknownStruct(IR::ID name) :
    Type_StructLike(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_UnknownStruct)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_UnknownStruct, NodeKind::Type_UnknownStruct, Type_StructLike);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_HeaderUnion : public Type_StructLike {
 public:
#line 462 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2308 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 464 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 2312 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// start offset of any field in a union is 0
#line 470 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int getFieldBitOffset(cstring name) const {
        for (auto f : fields) {
            if (f->name == name) {
                return 0;
            }
        }
        return -1; }
#line 2322 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_HeaderUnion const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_HeaderUnion"_cs; }
    static cstring static_type_name() { return "Type_HeaderUnion"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_HeaderUnion(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_StructLike const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, typeParameters, fields)
    { validate(); }
    Type_HeaderUnion(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, typeParameters, fields)
    { validate(); }
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, typeParameters, fields)
    { validate(); }
    Type_HeaderUnion(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, typeParameters, fields)
    { validate(); }
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, fields)
    { validate(); }
    Type_HeaderUnion(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, fields)
    { validate(); }
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, fields)
    { validate(); }
    Type_HeaderUnion(IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, fields)
    { validate(); }
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, annotations, typeParameters)
    { validate(); }
    Type_HeaderUnion(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, annotations, typeParameters)
    { validate(); }
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, typeParameters)
    { validate(); }
    Type_HeaderUnion(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, typeParameters)
    { validate(); }
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(srcInfo, name, annotations)
    { validate(); }
    Type_HeaderUnion(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(name, annotations)
    { validate(); }
    Type_HeaderUnion(Util::SourceInfo srcInfo, IR::ID name) :
    Type_StructLike(srcInfo, name)
    { validate(); }
    Type_HeaderUnion(IR::ID name) :
    Type_StructLike(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_HeaderUnion)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_HeaderUnion, NodeKind::Type_HeaderUnion, Type_StructLike);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Header : public Type_StructLike {
 public:
    static const cstring setValid;
    static const cstring setInvalid;
    static const cstring isValid;
#line 484 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2394 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Header const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Header"_cs; }
    static cstring static_type_name() { return "Type_Header"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Header(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_StructLike const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Header(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, typeParameters, fields)
    { validate(); }
    Type_Header(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, typeParameters, fields)
    { validate(); }
    Type_Header(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, typeParameters, fields)
    { validate(); }
    Type_Header(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, typeParameters, fields)
    { validate(); }
    Type_Header(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, annotations, fields)
    { validate(); }
    Type_Header(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, annotations, fields)
    { validate(); }
    Type_Header(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(srcInfo, name, fields)
    { validate(); }
    Type_Header(IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_StructLike(name, fields)
    { validate(); }
    Type_Header(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, annotations, typeParameters)
    { validate(); }
    Type_Header(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, annotations, typeParameters)
    { validate(); }
    Type_Header(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(srcInfo, name, typeParameters)
    { validate(); }
    Type_Header(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_StructLike(name, typeParameters)
    { validate(); }
    Type_Header(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(srcInfo, name, annotations)
    { validate(); }
    Type_Header(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_StructLike(name, annotations)
    { validate(); }
    Type_Header(Util::SourceInfo srcInfo, IR::ID name) :
    Type_StructLike(srcInfo, name)
    { validate(); }
    Type_Header(IR::ID name) :
    Type_StructLike(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_Header)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Header, NodeKind::Type_Header, Type_StructLike);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Set : public Type {
 public:
    const IR::Type* elementType = nullptr;
#line 489 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 2464 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 490 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2467 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 491 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 2470 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 492 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 2473 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Set const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Set"_cs; }
    static cstring static_type_name() { return "Type_Set"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Set(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Set(Util::SourceInfo srcInfo, const IR::Type* elementType) :
    Type(srcInfo), elementType(elementType)
    { validate(); }
    Type_Set(const IR::Type* elementType) :
    elementType(elementType)
    { validate(); }
    IRNODE_SUBCLASS(Type_Set)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Set, NodeKind::Type_Set, Type);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Indexed : public virtual INode {
 public:


#line 501 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    virtual size_t getSize() const = 0;
#line 2503 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 502 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    virtual const IR::Type *at(size_t index) const = 0;
#line 2506 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Indexed, NodeKind::Type_Indexed, INode);
};
}  // namespace P4::IR
namespace P4::IR {
/// Base class for Type_List, and Type_Tuple
class Type_BaseList : public Type, public virtual Type_Indexed {
 public:
    IR::Vector<IR::Type> components;
#line 508 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 2517 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 509 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t getSize() const override;
#line 2520 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 510 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Type *at(size_t index) const override;
#line 2523 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 511 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 2526 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 518 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring asString(char const * name) const;
#line 2529 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 528 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2532 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_BaseList const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_BaseList"_cs; }
    static cstring static_type_name() { return "Type_BaseList"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_BaseList(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Type_BaseList(Util::SourceInfo srcInfo, IR::Vector<IR::Type> components) :
    Type(srcInfo), components(components)
    { validate(); }
    Type_BaseList(IR::Vector<IR::Type> components) :
    components(components)
    { validate(); }
    Type_BaseList(Util::SourceInfo srcInfo) :
    Type(srcInfo)
    { validate(); }
    Type_BaseList() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Type_BaseList)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_BaseList, NodeKind::Type_BaseList, Type, Type_Indexed);
};
}  // namespace P4::IR
namespace P4::IR {
/// The type of an expressionList; can be unified with both Type_Tuple and Type_Struct
class Type_List : public Type_BaseList {
 public:
#line 535 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 2565 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 537 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2569 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_List const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_List"_cs; }
    static cstring static_type_name() { return "Type_List"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_List(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_BaseList const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_List(Util::SourceInfo srcInfo, IR::Vector<IR::Type> components) :
    Type_BaseList(srcInfo, components)
    { validate(); }
    Type_List(IR::Vector<IR::Type> components) :
    Type_BaseList(components)
    { validate(); }
    Type_List(Util::SourceInfo srcInfo) :
    Type_BaseList(srcInfo)
    { validate(); }
    Type_List() 
    { validate(); }
    IRNODE_SUBCLASS(Type_List)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_List, NodeKind::Type_List, Type_BaseList);
};
}  // namespace P4::IR
namespace P4::IR {
/// The type of a tuple.
class Type_Tuple : public Type_BaseList {
 public:
#line 544 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 2602 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 545 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2605 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Tuple const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Tuple"_cs; }
    static cstring static_type_name() { return "Type_Tuple"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Tuple(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_BaseList const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Tuple(Util::SourceInfo srcInfo, IR::Vector<IR::Type> components) :
    Type_BaseList(srcInfo, components)
    { validate(); }
    Type_Tuple(IR::Vector<IR::Type> components) :
    Type_BaseList(components)
    { validate(); }
    Type_Tuple(Util::SourceInfo srcInfo) :
    Type_BaseList(srcInfo)
    { validate(); }
    Type_Tuple() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Tuple)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Tuple, NodeKind::Type_Tuple, Type_BaseList);
};
}  // namespace P4::IR
namespace P4::IR {
/// The type of a P4ListExpression.
class Type_P4List : public Type {
 public:
    const IR::Type* elementType = nullptr;
#line 553 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 2639 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 554 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2642 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_P4List const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_P4List"_cs; }
    static cstring static_type_name() { return "Type_P4List"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_P4List(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_P4List(Util::SourceInfo srcInfo, const IR::Type* elementType) :
    Type(srcInfo), elementType(elementType)
    { validate(); }
    Type_P4List(const IR::Type* elementType) :
    elementType(elementType)
    { validate(); }
    IRNODE_SUBCLASS(Type_P4List)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_P4List, NodeKind::Type_P4List, Type);
};
}  // namespace P4::IR
namespace P4::IR {
/// The type of an architectural block.
/// Abstract base for Type_Control, Type_Parser and Type_Package
class Type_ArchBlock : public Type_Declaration, public virtual IMayBeGenericType, public virtual IAnnotated, public virtual ISimpleNamespace {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::TypeParameters* typeParameters = new TypeParameters;
#line 564 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 2675 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 565 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 2678 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 566 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::TypeParameters *getTypeParameters() const override;
#line 2681 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 567 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 2684 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 569 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 2687 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 571 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 2690 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_ArchBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_ArchBlock"_cs; }
    static cstring static_type_name() { return "Type_ArchBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_ArchBlock(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Type_ArchBlock(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Declaration(srcInfo, name), annotations(annotations), typeParameters(typeParameters)
    { validate(); }
    Type_ArchBlock(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Declaration(name), annotations(annotations), typeParameters(typeParameters)
    { validate(); }
    Type_ArchBlock(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters)
    { validate(); }
    Type_ArchBlock(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Declaration(name), typeParameters(typeParameters)
    { validate(); }
    Type_ArchBlock(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), annotations(annotations)
    { validate(); }
    Type_ArchBlock(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), annotations(annotations)
    { validate(); }
    Type_ArchBlock(Util::SourceInfo srcInfo, IR::ID name) :
    Type_Declaration(srcInfo, name)
    { validate(); }
    Type_ArchBlock(IR::ID name) :
    Type_Declaration(name)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Type_ArchBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_ArchBlock, NodeKind::Type_ArchBlock, Type_Declaration, IMayBeGenericType, IAnnotated, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Package : public Type_ArchBlock, public virtual IContainer, public virtual ISimpleNamespace {
 public:
#line 576 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Type *getType() const override;
#line 2737 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::ParameterList* constructorParams = nullptr;
#line 578 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Type_Method *getConstructorMethodType() const override;
#line 2741 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 579 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::ParameterList *getConstructorParameters() const override;
#line 2744 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 580 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2747 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 581 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 2750 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 583 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 2753 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 587 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 2756 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Package const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Package"_cs; }
    static cstring static_type_name() { return "Type_Package"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Package(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_ArchBlock const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Package(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(srcInfo, name, annotations, typeParameters), constructorParams(constructorParams)
    { validate(); }
    Type_Package(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(name, annotations, typeParameters), constructorParams(constructorParams)
    { validate(); }
    Type_Package(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(srcInfo, name, typeParameters), constructorParams(constructorParams)
    { validate(); }
    Type_Package(IR::ID name, const IR::TypeParameters* typeParameters, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(name, typeParameters), constructorParams(constructorParams)
    { validate(); }
    Type_Package(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(srcInfo, name, annotations), constructorParams(constructorParams)
    { validate(); }
    Type_Package(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(name, annotations), constructorParams(constructorParams)
    { validate(); }
    Type_Package(Util::SourceInfo srcInfo, IR::ID name, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(srcInfo, name), constructorParams(constructorParams)
    { validate(); }
    Type_Package(IR::ID name, const IR::ParameterList* constructorParams) :
    Type_ArchBlock(name), constructorParams(constructorParams)
    { validate(); }
    IRNODE_SUBCLASS(Type_Package)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Package, NodeKind::Type_Package, Type_ArchBlock, IContainer, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Parser : public Type_ArchBlock, public virtual IApply {
 public:
    const IR::ParameterList* applyParams = nullptr;
#line 595 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Type_Method *getApplyMethodType() const override;
#line 2806 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 596 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::ParameterList *getApplyParameters() const override;
#line 2809 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 597 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2812 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Parser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Parser"_cs; }
    static cstring static_type_name() { return "Type_Parser"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Parser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_ArchBlock const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Parser(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name, annotations, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Parser(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name, annotations, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Parser(IR::ID name, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Parser(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name, annotations), applyParams(applyParams)
    { validate(); }
    Type_Parser(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name, annotations), applyParams(applyParams)
    { validate(); }
    Type_Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name), applyParams(applyParams)
    { validate(); }
    Type_Parser(IR::ID name, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name), applyParams(applyParams)
    { validate(); }
    IRNODE_SUBCLASS(Type_Parser)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Parser, NodeKind::Type_Parser, Type_ArchBlock, IApply);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Control : public Type_ArchBlock, public virtual IApply {
 public:
    const IR::ParameterList* applyParams = nullptr;
#line 602 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Type_Method *getApplyMethodType() const override;
#line 2862 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 603 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::ParameterList *getApplyParameters() const override;
#line 2865 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 604 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2868 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Control const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Control"_cs; }
    static cstring static_type_name() { return "Type_Control"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Control(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_ArchBlock const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Control(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name, annotations, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Control(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name, annotations, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Control(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Control(IR::ID name, const IR::TypeParameters* typeParameters, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name, typeParameters), applyParams(applyParams)
    { validate(); }
    Type_Control(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name, annotations), applyParams(applyParams)
    { validate(); }
    Type_Control(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name, annotations), applyParams(applyParams)
    { validate(); }
    Type_Control(Util::SourceInfo srcInfo, IR::ID name, const IR::ParameterList* applyParams) :
    Type_ArchBlock(srcInfo, name), applyParams(applyParams)
    { validate(); }
    Type_Control(IR::ID name, const IR::ParameterList* applyParams) :
    Type_ArchBlock(name), applyParams(applyParams)
    { validate(); }
    IRNODE_SUBCLASS(Type_Control)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Control, NodeKind::Type_Control, Type_ArchBlock, IApply);
};
}  // namespace P4::IR
namespace P4::IR {
/// A type referred by name
class Type_Name : public Type {
 public:
    const IR::Path* path = nullptr;
#line 610 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Type_Name(IR::ID id);
#line 2919 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 611 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2922 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 612 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 2925 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 613 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 2928 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 614 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 2931 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Name const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Name"_cs; }
    static cstring static_type_name() { return "Type_Name"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Name(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Name(Util::SourceInfo srcInfo, const IR::Path* path) :
    Type(srcInfo), path(path)
    { validate(); }
    Type_Name(const IR::Path* path) :
    path(path)
    { validate(); }
    IRNODE_SUBCLASS(Type_Name)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Name, NodeKind::Type_Name, Type);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Array : public virtual Type_Indexed, public Type {
 public:
    const IR::Type* elementType = nullptr;
    const IR::Expression* size = nullptr;
#line 623 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 2961 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 629 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 2964 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 630 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool sizeKnown() const;
#line 2967 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 631 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t getSize() const override;
#line 2970 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 632 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Type *at(size_t index) const override;
#line 2973 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    static const cstring next;
    static const cstring last;
    static const cstring arraySize;
    static const cstring lastIndex;
    static const cstring push_front;
    static const cstring pop_front;
#line 639 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 2982 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 641 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 2985 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Array const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Array"_cs; }
    static cstring static_type_name() { return "Type_Array"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Array(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Array(Util::SourceInfo srcInfo, const IR::Type* elementType, const IR::Expression* size) :
    Type(srcInfo), elementType(elementType), size(size)
    { validate(); }
    Type_Array(const IR::Type* elementType, const IR::Expression* size) :
    elementType(elementType), size(size)
    { validate(); }
    IRNODE_SUBCLASS(Type_Array)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Array, NodeKind::Type_Array, Type_Indexed, Type);
};
}  // namespace P4::IR
namespace P4::IR {
/** Given a declaration
   extern E<T> { ... }
   Type_Specialized represents a type such
   E<bit<32>>
   baseType is Type_Name E, arguments is a vector containing Type_Bits(32) */
class Type_Specialized : public Type {
 public:
    const IR::Type_Name* baseType = nullptr;
    const IR::Vector<IR::Type>* arguments = nullptr;
#line 652 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 3020 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 653 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 3023 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 654 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 3026 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 664 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Type_Specialized(cstring bt, std::initializer_list<const IR::Type *> args);
#line 3029 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Specialized const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_Specialized"_cs; }
    static cstring static_type_name() { return "Type_Specialized"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Specialized(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Specialized(Util::SourceInfo srcInfo, const IR::Type_Name* baseType, const IR::Vector<IR::Type>* arguments) :
    Type(srcInfo), baseType(baseType), arguments(arguments)
    { validate(); }
    Type_Specialized(const IR::Type_Name* baseType, const IR::Vector<IR::Type>* arguments) :
    baseType(baseType), arguments(arguments)
    { validate(); }
    IRNODE_SUBCLASS(Type_Specialized)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Specialized, NodeKind::Type_Specialized, Type);
};
}  // namespace P4::IR
namespace P4::IR {
/** Canonical representation of a Type_Specialized;
   only used by the type-checker, never in the IR tree. */
class Type_SpecializedCanonical : public Type {
 public:
    const IR::Type* baseType = nullptr;
/// canonical baseType; always IMayBeGenericType
    const IR::Vector<IR::Type>* arguments = nullptr;
/// canonical type arguments
/// 'substituted' is baseType with all type
/// variables substituted with the arguments.
    const IR::Type* substituted = nullptr;

#line 677 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 3067 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 682 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 3070 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 683 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 3073 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_SpecializedCanonical const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_SpecializedCanonical"_cs; }
    static cstring static_type_name() { return "Type_SpecializedCanonical"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_SpecializedCanonical(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_SpecializedCanonical(Util::SourceInfo srcInfo, const IR::Type* baseType, const IR::Vector<IR::Type>* arguments, const IR::Type* substituted) :
    Type(srcInfo), baseType(baseType), arguments(arguments), substituted(substituted)
    { validate(); }
    Type_SpecializedCanonical(const IR::Type* baseType, const IR::Vector<IR::Type>* arguments, const IR::Type* substituted) :
    baseType(baseType), arguments(arguments), substituted(substituted)
    { validate(); }
    IRNODE_SUBCLASS(Type_SpecializedCanonical)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_SpecializedCanonical, NodeKind::Type_SpecializedCanonical, Type);
};
}  // namespace P4::IR
namespace P4::IR {
/// A declaration that consists of just an identifier, e.g., an enum member
class Declaration_ID : public Declaration, public virtual CompileTimeValue {
 public:
    bool operator==(IR::Declaration_ID const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Declaration_ID"_cs; }
    static cstring static_type_name() { return "Declaration_ID"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Declaration_ID(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Declaration_ID(Util::SourceInfo srcInfo, IR::ID name) :
    Declaration(srcInfo, name)
    { validate(); }
    Declaration_ID(IR::ID name) :
    Declaration(name)
    { validate(); }
    IRNODE_SUBCLASS(Declaration_ID)
    DECLARE_TYPEINFO_WITH_TYPEID(Declaration_ID, NodeKind::Declaration_ID, Declaration, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
/// The type of a string literal
class Type_String : public Type_Base {
 public:
 protected:
#line 696 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 3132 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
#line 705 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_String *get();
#line 3136 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 706 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    static const IR::Type_String *get(Util::SourceInfo const & si);
#line 3139 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 707 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 3142 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_String const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_String"_cs; }
    static cstring static_type_name() { return "Type_String"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_String(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_String(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_String() 
    { validate(); }
    IRNODE_SUBCLASS(Type_String)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_String, NodeKind::Type_String, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Enum : public Type_Declaration, public virtual ISimpleNamespace, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    IR::IndexedVector<IR::Declaration_ID> members;
#line 713 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 3169 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 714 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 3172 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 715 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 3175 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 717 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 3178 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 719 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 3181 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 722 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 3184 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Enum const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_Enum"_cs; }
    static cstring static_type_name() { return "Type_Enum"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Enum(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Enum(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::Declaration_ID> members) :
    Type_Declaration(srcInfo, name), annotations(annotations), members(members)
    { validate(); }
    Type_Enum(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::Declaration_ID> members) :
    Type_Declaration(name), annotations(annotations), members(members)
    { validate(); }
    Type_Enum(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::Declaration_ID> members) :
    Type_Declaration(srcInfo, name), members(members)
    { validate(); }
    Type_Enum(IR::ID name, IR::IndexedVector<IR::Declaration_ID> members) :
    Type_Declaration(name), members(members)
    { validate(); }
    IRNODE_SUBCLASS(Type_Enum)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Enum, NodeKind::Type_Enum, Type_Declaration, ISimpleNamespace, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
/// A member of a serializable enum with a backing value
class SerEnumMember : public Declaration, public virtual CompileTimeValue {
 public:
    const IR::Expression* value = nullptr;
#line 728 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 3220 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::SerEnumMember const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "SerEnumMember"_cs; }
    static cstring static_type_name() { return "SerEnumMember"_cs; }
    void toJSON(JSONGenerator & json) const override;
    SerEnumMember(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SerEnumMember(Util::SourceInfo srcInfo, IR::ID name, const IR::Expression* value) :
    Declaration(srcInfo, name), value(value)
    { validate(); }
    SerEnumMember(IR::ID name, const IR::Expression* value) :
    Declaration(name), value(value)
    { validate(); }
    IRNODE_SUBCLASS(SerEnumMember)
    DECLARE_TYPEINFO_WITH_TYPEID(SerEnumMember, NodeKind::SerEnumMember, Declaration, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
/** A serializable enumeration with a backing type */
class Type_SerEnum : public Type_Declaration, public virtual ISimpleNamespace, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* type = nullptr;
    IR::IndexedVector<IR::SerEnumMember> members;
#line 737 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 3252 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 738 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 3255 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 739 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 3258 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 741 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 3261 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 743 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 3264 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 746 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 3267 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 747 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 3270 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_SerEnum const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_SerEnum"_cs; }
    static cstring static_type_name() { return "Type_SerEnum"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_SerEnum(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_SerEnum(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, IR::IndexedVector<IR::SerEnumMember> members) :
    Type_Declaration(srcInfo, name), annotations(annotations), type(type), members(members)
    { validate(); }
    Type_SerEnum(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, IR::IndexedVector<IR::SerEnumMember> members) :
    Type_Declaration(name), annotations(annotations), type(type), members(members)
    { validate(); }
    Type_SerEnum(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type, IR::IndexedVector<IR::SerEnumMember> members) :
    Type_Declaration(srcInfo, name), type(type), members(members)
    { validate(); }
    Type_SerEnum(IR::ID name, const IR::Type* type, IR::IndexedVector<IR::SerEnumMember> members) :
    Type_Declaration(name), type(type), members(members)
    { validate(); }
    IRNODE_SUBCLASS(Type_SerEnum)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_SerEnum, NodeKind::Type_SerEnum, Type_Declaration, ISimpleNamespace, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Table : public Type, public virtual IApply {
 public:
    const IR::P4Table* table = nullptr;
#line 752 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Type_Method *getApplyMethodType() const override;
#line 3305 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 753 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::ParameterList *getApplyParameters() const override;
#line 3308 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// names for the fields of the struct returned
/// by applying a table
    static const IR::ID hit;
    static const IR::ID miss;
    static const IR::ID action_run;
#line 759 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 3316 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 760 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 3319 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Table const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Table"_cs; }
    static cstring static_type_name() { return "Type_Table"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Table(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Table(Util::SourceInfo srcInfo, const IR::P4Table* table) :
    Type(srcInfo), table(table)
    { validate(); }
    Type_Table(const IR::P4Table* table) :
    table(table)
    { validate(); }
    IRNODE_SUBCLASS(Type_Table)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Table, NodeKind::Type_Table, Type, IApply);
};
}  // namespace P4::IR
namespace P4::IR {
/// A special enum-like anonymous type that
/// represents all actions in a table's action list.
/// Used for 'switch' statements.
class Type_ActionEnum : public Type {
 public:
    const IR::ActionList* actionList = nullptr;
#line 768 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    bool contains(cstring name) const;
#line 3351 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 769 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 3354 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_ActionEnum const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_ActionEnum"_cs; }
    static cstring static_type_name() { return "Type_ActionEnum"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_ActionEnum(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_ActionEnum(Util::SourceInfo srcInfo, const IR::ActionList* actionList) :
    Type(srcInfo), actionList(actionList)
    { validate(); }
    Type_ActionEnum(const IR::ActionList* actionList) :
    actionList(actionList)
    { validate(); }
    IRNODE_SUBCLASS(Type_ActionEnum)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_ActionEnum, NodeKind::Type_ActionEnum, Type);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_MethodBase : public Type, public virtual IMayBeGenericType, public virtual ISimpleNamespace {
 public:

    const IR::TypeParameters* typeParameters = new TypeParameters();
    const IR::Type* returnType = nullptr;

    const IR::ParameterList* parameters = nullptr;
#line 779 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t maxParameterCount() const { return parameters->size(); }
#line 3388 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 780 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t minParameterCount() const {
        size_t rv = 0;
        for (auto p : *parameters)
            if (!p->isOptional()) ++rv;
        return rv;
    }
#line 3396 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 786 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::TypeParameters *getTypeParameters() const override;
#line 3399 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 787 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void dbprint(std::ostream & out) const override;
#line 3402 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 788 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 3405 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 789 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 3408 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 790 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 3411 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 792 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 3414 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 796 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 3417 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_MethodBase const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_MethodBase"_cs; }
    static cstring static_type_name() { return "Type_MethodBase"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_MethodBase(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Type_MethodBase(Util::SourceInfo srcInfo, const IR::TypeParameters* typeParameters, const IR::Type* returnType, const IR::ParameterList* parameters) :
    Type(srcInfo), typeParameters(typeParameters), returnType(returnType), parameters(parameters)
    { validate(); }
    Type_MethodBase(const IR::TypeParameters* typeParameters, const IR::Type* returnType, const IR::ParameterList* parameters) :
    typeParameters(typeParameters), returnType(returnType), parameters(parameters)
    { validate(); }
    Type_MethodBase(Util::SourceInfo srcInfo, const IR::Type* returnType, const IR::ParameterList* parameters) :
    Type(srcInfo), returnType(returnType), parameters(parameters)
    { validate(); }
    Type_MethodBase(const IR::Type* returnType, const IR::ParameterList* parameters) :
    returnType(returnType), parameters(parameters)
    { validate(); }
    Type_MethodBase(Util::SourceInfo srcInfo, const IR::TypeParameters* typeParameters, const IR::ParameterList* parameters) :
    Type(srcInfo), typeParameters(typeParameters), parameters(parameters)
    { validate(); }
    Type_MethodBase(const IR::TypeParameters* typeParameters, const IR::ParameterList* parameters) :
    typeParameters(typeParameters), parameters(parameters)
    { validate(); }
    Type_MethodBase(Util::SourceInfo srcInfo, const IR::ParameterList* parameters) :
    Type(srcInfo), parameters(parameters)
    { validate(); }
    Type_MethodBase(const IR::ParameterList* parameters) :
    parameters(parameters)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Type_MethodBase)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_MethodBase, NodeKind::Type_MethodBase, Type, IMayBeGenericType, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
/// Type for a method or function.
class Type_Method : public Type_MethodBase {
 public:

    cstring name;
#line 807 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 3466 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Method const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Method"_cs; }
    static cstring static_type_name() { return "Type_Method"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Method(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_MethodBase const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Method(Util::SourceInfo srcInfo, const IR::TypeParameters* typeParameters, const IR::Type* returnType, const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(srcInfo, typeParameters, returnType, parameters), name(name)
    { validate(); }
    Type_Method(const IR::TypeParameters* typeParameters, const IR::Type* returnType, const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(typeParameters, returnType, parameters), name(name)
    { validate(); }
    Type_Method(Util::SourceInfo srcInfo, const IR::Type* returnType, const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(srcInfo, returnType, parameters), name(name)
    { validate(); }
    Type_Method(const IR::Type* returnType, const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(returnType, parameters), name(name)
    { validate(); }
    Type_Method(Util::SourceInfo srcInfo, const IR::TypeParameters* typeParameters, const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(srcInfo, typeParameters, parameters), name(name)
    { validate(); }
    Type_Method(const IR::TypeParameters* typeParameters, const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(typeParameters, parameters), name(name)
    { validate(); }
    Type_Method(Util::SourceInfo srcInfo, const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(srcInfo, parameters), name(name)
    { validate(); }
    Type_Method(const IR::ParameterList* parameters, cstring name) :
    Type_MethodBase(parameters), name(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_Method)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Method, NodeKind::Type_Method, Type_MethodBase);
};
}  // namespace P4::IR
namespace P4::IR {
/// Describes an argument of a MethodCall
/// Never used in the program IR; only used by typechecker.
class ArgumentInfo : public Node {
 public:
    bool leftValue;
    bool compileTimeConstant;
    const IR::Type* type = nullptr;
    const IR::Argument* argument = nullptr;
#line 817 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 3517 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ArgumentInfo const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ArgumentInfo"_cs; }
    static cstring static_type_name() { return "ArgumentInfo"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ArgumentInfo(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ArgumentInfo(Util::SourceInfo srcInfo, bool leftValue, bool compileTimeConstant, const IR::Type* type, const IR::Argument* argument) :
    Node(srcInfo), leftValue(leftValue), compileTimeConstant(compileTimeConstant), type(type), argument(argument)
    { validate(); }
    ArgumentInfo(bool leftValue, bool compileTimeConstant, const IR::Type* type, const IR::Argument* argument) :
    leftValue(leftValue), compileTimeConstant(compileTimeConstant), type(type), argument(argument)
    { validate(); }
    IRNODE_SUBCLASS(ArgumentInfo)
    DECLARE_TYPEINFO_WITH_TYPEID(ArgumentInfo, NodeKind::ArgumentInfo, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// Used to represent the type of a MethodCallExpression
/// for unification.
/// Never appears in the program IR; only used by the typechecker.
class Type_MethodCall : public Type {
 public:
    const IR::Vector<IR::Type>* typeArguments = nullptr;
    const IR::Type_Var* returnType = nullptr;
    const IR::Vector<IR::ArgumentInfo>* arguments = nullptr;
#line 828 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 3551 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 829 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Type const * getP4Type() const override;
#line 3554 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 830 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    cstring toString() const override;
#line 3557 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_MethodCall const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_MethodCall"_cs; }
    static cstring static_type_name() { return "Type_MethodCall"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_MethodCall(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_MethodCall(Util::SourceInfo srcInfo, const IR::Vector<IR::Type>* typeArguments, const IR::Type_Var* returnType, const IR::Vector<IR::ArgumentInfo>* arguments) :
    Type(srcInfo), typeArguments(typeArguments), returnType(returnType), arguments(arguments)
    { validate(); }
    Type_MethodCall(const IR::Vector<IR::Type>* typeArguments, const IR::Type_Var* returnType, const IR::Vector<IR::ArgumentInfo>* arguments) :
    typeArguments(typeArguments), returnType(returnType), arguments(arguments)
    { validate(); }
    IRNODE_SUBCLASS(Type_MethodCall)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_MethodCall, NodeKind::Type_MethodCall, Type);
};
}  // namespace P4::IR
namespace P4::IR {
/// Actions look a lot like methods in many respects.
/// However, invoking an action returns another action
/// Having different IR nodes allows performing different transforms in visitors
class Type_Action : public Type_MethodBase {
 public:
    bool operator==(IR::Type_Action const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Action"_cs; }
    static cstring static_type_name() { return "Type_Action"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Action(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_MethodBase const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Action(Util::SourceInfo srcInfo, const IR::TypeParameters* typeParameters, const IR::Type* returnType, const IR::ParameterList* parameters) :
    Type_MethodBase(srcInfo, typeParameters, returnType, parameters)
    { validate(); }
    Type_Action(const IR::TypeParameters* typeParameters, const IR::Type* returnType, const IR::ParameterList* parameters) :
    Type_MethodBase(typeParameters, returnType, parameters)
    { validate(); }
    Type_Action(Util::SourceInfo srcInfo, const IR::Type* returnType, const IR::ParameterList* parameters) :
    Type_MethodBase(srcInfo, returnType, parameters)
    { validate(); }
    Type_Action(const IR::Type* returnType, const IR::ParameterList* parameters) :
    Type_MethodBase(returnType, parameters)
    { validate(); }
    Type_Action(Util::SourceInfo srcInfo, const IR::TypeParameters* typeParameters, const IR::ParameterList* parameters) :
    Type_MethodBase(srcInfo, typeParameters, parameters)
    { validate(); }
    Type_Action(const IR::TypeParameters* typeParameters, const IR::ParameterList* parameters) :
    Type_MethodBase(typeParameters, parameters)
    { validate(); }
    Type_Action(Util::SourceInfo srcInfo, const IR::ParameterList* parameters) :
    Type_MethodBase(srcInfo, parameters)
    { validate(); }
    Type_Action(const IR::ParameterList* parameters) :
    Type_MethodBase(parameters)
    { validate(); }
    IRNODE_SUBCLASS(Type_Action)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Action, NodeKind::Type_Action, Type_MethodBase);
};
}  // namespace P4::IR
namespace P4::IR {
class Method : public Declaration, public virtual IAnnotated, public virtual IFunctional, public virtual ISimpleNamespace {
 public:
    const IR::Type_Method* type = nullptr;
    bool isAbstract = false;
    IR::Vector<IR::Annotation> annotations;
#line 844 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t maxParameterCount() const { return type->maxParameterCount(); }
#line 3632 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 845 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    size_t minParameterCount() const { return type->minParameterCount(); }
#line 3635 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 846 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void setAbstract() { isAbstract = true; }
#line 3638 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 847 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 3641 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 848 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 3644 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 849 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::ParameterList *getParameters() const override;
#line 3647 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 851 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 3651 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 853 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 3654 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 855 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 3657 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Method const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Method"_cs; }
    static cstring static_type_name() { return "Method"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Method(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Method(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Method* type, bool isAbstract, IR::Vector<IR::Annotation> annotations) :
    Declaration(srcInfo, name), type(type), isAbstract(isAbstract), annotations(annotations)
    { validate(); }
    Method(IR::ID name, const IR::Type_Method* type, bool isAbstract, IR::Vector<IR::Annotation> annotations) :
    Declaration(name), type(type), isAbstract(isAbstract), annotations(annotations)
    { validate(); }
    Method(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Method* type, IR::Vector<IR::Annotation> annotations) :
    Declaration(srcInfo, name), type(type), annotations(annotations)
    { validate(); }
    Method(IR::ID name, const IR::Type_Method* type, IR::Vector<IR::Annotation> annotations) :
    Declaration(name), type(type), annotations(annotations)
    { validate(); }
    Method(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Method* type, bool isAbstract) :
    Declaration(srcInfo, name), type(type), isAbstract(isAbstract)
    { validate(); }
    Method(IR::ID name, const IR::Type_Method* type, bool isAbstract) :
    Declaration(name), type(type), isAbstract(isAbstract)
    { validate(); }
    Method(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Method* type) :
    Declaration(srcInfo, name), type(type)
    { validate(); }
    Method(IR::ID name, const IR::Type_Method* type) :
    Declaration(name), type(type)
    { validate(); }
    IRNODE_SUBCLASS(Method)
    DECLARE_TYPEINFO_WITH_TYPEID(Method, NodeKind::Method, Declaration, IAnnotated, IFunctional, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Typedef : public Type_Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* type = nullptr;
#line 862 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 3708 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 863 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 3711 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 864 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 3714 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Typedef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Typedef"_cs; }
    static cstring static_type_name() { return "Type_Typedef"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Typedef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Typedef(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Type_Declaration(srcInfo, name), annotations(annotations), type(type)
    { validate(); }
    Type_Typedef(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Type_Declaration(name), annotations(annotations), type(type)
    { validate(); }
    Type_Typedef(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type) :
    Type_Declaration(srcInfo, name), type(type)
    { validate(); }
    Type_Typedef(IR::ID name, const IR::Type* type) :
    Type_Declaration(name), type(type)
    { validate(); }
    IRNODE_SUBCLASS(Type_Typedef)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Typedef, NodeKind::Type_Typedef, Type_Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
/// A newtype is similar to typedef, but it introduces a new type; the
/// the new type does not inherit any
/// of the operations of the original type.  The new type has
/// assignment, equality, and casts to/from the original type.
/// The keyword for newtype is actually `type'.
class Type_Newtype : public Type_Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* type = nullptr;
#line 876 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    int width_bits() const override;
#line 3756 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 877 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 3759 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 878 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 3762 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Newtype const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Type_Newtype"_cs; }
    static cstring static_type_name() { return "Type_Newtype"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Newtype(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Newtype(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Type_Declaration(srcInfo, name), annotations(annotations), type(type)
    { validate(); }
    Type_Newtype(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Type_Declaration(name), annotations(annotations), type(type)
    { validate(); }
    Type_Newtype(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type) :
    Type_Declaration(srcInfo, name), type(type)
    { validate(); }
    Type_Newtype(IR::ID name, const IR::Type* type) :
    Type_Declaration(name), type(type)
    { validate(); }
    IRNODE_SUBCLASS(Type_Newtype)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Newtype, NodeKind::Type_Newtype, Type_Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
/// An 'extern' black-box (not a function)
class Type_Extern : public Type_Declaration, public virtual INestedNamespace, public virtual IGeneralNamespace, public virtual IMayBeGenericType, public virtual IAnnotated {
 public:
    const IR::TypeParameters* typeParameters = new TypeParameters;
    IR::Vector<IR::Method> methods;

    IR::NameMap<IR::Attribute, ordered_map> attributes;

    IR::Vector<IR::Annotation> annotations;
#line 890 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    std::vector<const IR::INamespace *> getNestedNamespaces() const override;
#line 3804 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 891 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 3807 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 894 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::TypeParameters *getTypeParameters() const override;
#line 3810 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 895 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    void validate() const override;
#line 3813 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 896 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 3816 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 897 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 3819 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Returns the method that matches the specified arguments.
/// Returns nullptr if no method or more than one method match.
/// In the latter case it also reports an error.
#line 901 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Method *lookupMethod(IR::ID name, const IR::Vector<IR::Argument>* arguments) const;
#line 3825 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Returns the constructor that matches the specified arguments.
/// Returns nullptr if no constructor or more than one constructor matches.
/// In the latter case it also reports an error.
#line 905 "/builddir/build/BUILD/p4c-1.2.5.8/ir/type.def"
    const IR::Method *lookupConstructor(const IR::Vector<IR::Argument>* arguments) const;
#line 3831 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Extern const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_Extern"_cs; }
    static cstring static_type_name() { return "Type_Extern"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Extern(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), methods(methods), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), typeParameters(typeParameters), methods(methods), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), methods(methods), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), methods(methods), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), typeParameters(typeParameters), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, IR::NameMap<IR::Attribute, ordered_map> attributes, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), attributes(attributes), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), methods(methods), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), typeParameters(typeParameters), methods(methods), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Method> methods, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), methods(methods), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, IR::Vector<IR::Method> methods, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), methods(methods), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), typeParameters(typeParameters), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(srcInfo, name), annotations(annotations)
    { validate(); }
    Type_Extern(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Declaration(name), annotations(annotations)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), methods(methods), attributes(attributes)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(name), typeParameters(typeParameters), methods(methods), attributes(attributes)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(srcInfo, name), methods(methods), attributes(attributes)
    { validate(); }
    Type_Extern(IR::ID name, IR::Vector<IR::Method> methods, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(name), methods(methods), attributes(attributes)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), attributes(attributes)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(name), typeParameters(typeParameters), attributes(attributes)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(srcInfo, name), attributes(attributes)
    { validate(); }
    Type_Extern(IR::ID name, IR::NameMap<IR::Attribute, ordered_map> attributes) :
    Type_Declaration(name), attributes(attributes)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters), methods(methods)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters, IR::Vector<IR::Method> methods) :
    Type_Declaration(name), typeParameters(typeParameters), methods(methods)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Method> methods) :
    Type_Declaration(srcInfo, name), methods(methods)
    { validate(); }
    Type_Extern(IR::ID name, IR::Vector<IR::Method> methods) :
    Type_Declaration(name), methods(methods)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Declaration(srcInfo, name), typeParameters(typeParameters)
    { validate(); }
    Type_Extern(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Declaration(name), typeParameters(typeParameters)
    { validate(); }
    Type_Extern(Util::SourceInfo srcInfo, IR::ID name) :
    Type_Declaration(srcInfo, name)
    { validate(); }
    Type_Extern(IR::ID name) :
    Type_Declaration(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_Extern)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Extern, NodeKind::Type_Extern, Type_Declaration, INestedNamespace, IGeneralNamespace, IMayBeGenericType, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
/** @} */
/* end group irdefs */
/* -*-C++-*- */
/* This file contains the IR classes for all expressions.
   The base classes are in base.def */
/** \addtogroup irdefs
  * @{
  */
class Operation_Unary : public Operation {
 public:
    const IR::Expression* expr = nullptr;
    int getPrecedence() const override { return DBPrint::Prec_Prefix; }
#line 15 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 3960 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Operation_Unary const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Operation_Unary"_cs; }
    static cstring static_type_name() { return "Operation_Unary"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Operation_Unary(JSONLoader & json);
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Operation_Unary(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Operation(srcInfo, type), expr(expr)
    {
#line 11 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && expr) srcInfo = expr->srcInfo;
        if (type->is<Type::Unknown>() && expr) type = expr->type; }
#line 3981 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Unary(const IR::Type* type, const IR::Expression* expr) :
    Operation(type), expr(expr)
    {
#line 11 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && expr) srcInfo = expr->srcInfo;
        if (type->is<Type::Unknown>() && expr) type = expr->type; }
#line 3990 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Unary(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Operation(srcInfo), expr(expr)
    {
#line 11 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && expr) srcInfo = expr->srcInfo;
        if (type->is<Type::Unknown>() && expr) type = expr->type; }
#line 3999 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Unary(const IR::Expression* expr) :
    expr(expr)
    {
#line 11 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && expr) srcInfo = expr->srcInfo;
        if (type->is<Type::Unknown>() && expr) type = expr->type; }
#line 4008 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Operation_Unary)
    DECLARE_TYPEINFO_WITH_TYPEID(Operation_Unary, NodeKind::Operation_Unary, Operation);
};
}  // namespace P4::IR
namespace P4::IR {
class Neg : public Operation_Unary {
 public:
    cstring getStringOp() const override { return cstring("-"); }
    bool operator==(IR::Neg const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Neg"_cs; }
    static cstring static_type_name() { return "Neg"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Neg(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Neg(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(srcInfo, type, expr)
    { validate(); }
    Neg(const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(type, expr)
    { validate(); }
    Neg(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Operation_Unary(srcInfo, expr)
    { validate(); }
    Neg(const IR::Expression* expr) :
    Operation_Unary(expr)
    { validate(); }
    IRNODE_SUBCLASS(Neg)
    DECLARE_TYPEINFO_WITH_TYPEID(Neg, NodeKind::Neg, Operation_Unary);
};
}  // namespace P4::IR
namespace P4::IR {
class UPlus : public Operation_Unary {
 public:
    cstring getStringOp() const override { return cstring("+"); }
    bool operator==(IR::UPlus const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "UPlus"_cs; }
    static cstring static_type_name() { return "UPlus"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    UPlus(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    UPlus(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(srcInfo, type, expr)
    { validate(); }
    UPlus(const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(type, expr)
    { validate(); }
    UPlus(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Operation_Unary(srcInfo, expr)
    { validate(); }
    UPlus(const IR::Expression* expr) :
    Operation_Unary(expr)
    { validate(); }
    IRNODE_SUBCLASS(UPlus)
    DECLARE_TYPEINFO_WITH_TYPEID(UPlus, NodeKind::UPlus, Operation_Unary);
};
}  // namespace P4::IR
namespace P4::IR {
class Cmpl : public Operation_Unary {
 public:
    cstring getStringOp() const override { return cstring("~"); }
    bool operator==(IR::Cmpl const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Cmpl"_cs; }
    static cstring static_type_name() { return "Cmpl"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Cmpl(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Cmpl(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(srcInfo, type, expr)
    { validate(); }
    Cmpl(const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(type, expr)
    { validate(); }
    Cmpl(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Operation_Unary(srcInfo, expr)
    { validate(); }
    Cmpl(const IR::Expression* expr) :
    Operation_Unary(expr)
    { validate(); }
    IRNODE_SUBCLASS(Cmpl)
    DECLARE_TYPEINFO_WITH_TYPEID(Cmpl, NodeKind::Cmpl, Operation_Unary);
};
}  // namespace P4::IR
namespace P4::IR {
class LNot : public Operation_Unary {
 public:
    cstring getStringOp() const override { return cstring("!"); }
    bool operator==(IR::LNot const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "LNot"_cs; }
    static cstring static_type_name() { return "LNot"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LNot(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LNot(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(srcInfo, type, expr)
    {
#line 32 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4136 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LNot(const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(type, expr)
    {
#line 32 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4148 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LNot(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Operation_Unary(srcInfo, expr)
    {
#line 32 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4160 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LNot(const IR::Expression* expr) :
    Operation_Unary(expr)
    {
#line 32 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4172 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(LNot)
    DECLARE_TYPEINFO_WITH_TYPEID(LNot, NodeKind::LNot, Operation_Unary);
};
}  // namespace P4::IR
namespace P4::IR {
class Operation_Binary : public Operation {
 public:
    const IR::Expression* left = nullptr;
    const IR::Expression* right = nullptr;
#line 47 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 4185 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Operation_Binary const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Operation_Binary"_cs; }
    static cstring static_type_name() { return "Operation_Binary"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Operation_Binary(JSONLoader & json);
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Operation_Binary(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation(srcInfo, type), left(left), right(right)
    {
#line 43 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && left && right) srcInfo = left->srcInfo + right->srcInfo;
        if (type->is<Type::Unknown>() && left && right && left->type == right->type)
            type = left->type; }
#line 4207 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Binary(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation(type), left(left), right(right)
    {
#line 43 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && left && right) srcInfo = left->srcInfo + right->srcInfo;
        if (type->is<Type::Unknown>() && left && right && left->type == right->type)
            type = left->type; }
#line 4217 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Binary(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation(srcInfo), left(left), right(right)
    {
#line 43 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && left && right) srcInfo = left->srcInfo + right->srcInfo;
        if (type->is<Type::Unknown>() && left && right && left->type == right->type)
            type = left->type; }
#line 4227 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Binary(const IR::Expression* left, const IR::Expression* right) :
    left(left), right(right)
    {
#line 43 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (!srcInfo && left && right) srcInfo = left->srcInfo + right->srcInfo;
        if (type->is<Type::Unknown>() && left && right && left->type == right->type)
            type = left->type; }
#line 4237 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Operation_Binary)
    DECLARE_TYPEINFO_WITH_TYPEID(Operation_Binary, NodeKind::Operation_Binary, Operation);
};
}  // namespace P4::IR
namespace P4::IR {
class Operation_Ternary : public Operation {
 public:
    const IR::Expression* e0 = nullptr;
    const IR::Expression* e1 = nullptr;
    const IR::Expression* e2 = nullptr;
    bool operator==(IR::Operation_Ternary const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Operation_Ternary"_cs; }
    static cstring static_type_name() { return "Operation_Ternary"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Operation_Ternary(JSONLoader & json);
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Operation_Ternary(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation(srcInfo, type), e0(e0), e1(e1), e2(e2)
    {
#line 60 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && e0 && e2) srcInfo = e0->srcInfo + e2->srcInfo; }
#line 4267 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Ternary(const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation(type), e0(e0), e1(e1), e2(e2)
    {
#line 60 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && e0 && e2) srcInfo = e0->srcInfo + e2->srcInfo; }
#line 4274 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Ternary(Util::SourceInfo srcInfo, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation(srcInfo), e0(e0), e1(e1), e2(e2)
    {
#line 60 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && e0 && e2) srcInfo = e0->srcInfo + e2->srcInfo; }
#line 4281 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Ternary(const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    e0(e0), e1(e1), e2(e2)
    {
#line 60 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && e0 && e2) srcInfo = e0->srcInfo + e2->srcInfo; }
#line 4288 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Operation_Ternary)
    DECLARE_TYPEINFO_WITH_TYPEID(Operation_Ternary, NodeKind::Operation_Ternary, Operation);
};
}  // namespace P4::IR
namespace P4::IR {
class Operation_Relation : public Operation_Binary {
 public:
    bool operator==(IR::Operation_Relation const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Operation_Relation"_cs; }
    static cstring static_type_name() { return "Operation_Relation"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Operation_Relation(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Operation_Relation(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 64 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4318 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Relation(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 64 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4330 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Relation(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 64 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4342 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Operation_Relation(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 64 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 4354 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Operation_Relation)
    DECLARE_TYPEINFO_WITH_TYPEID(Operation_Relation, NodeKind::Operation_Relation, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class Mul : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("*"); }
    int getPrecedence() const override { return DBPrint::Prec_Mul; }
    bool operator==(IR::Mul const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Mul"_cs; }
    static cstring static_type_name() { return "Mul"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Mul(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Mul(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    Mul(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    Mul(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    Mul(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Mul)
    DECLARE_TYPEINFO_WITH_TYPEID(Mul, NodeKind::Mul, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
///////////////////////////// Statements //////////////////////////
class Statement : public StatOrDecl {
 public:
    IRNODE_DECLARE_APPLY_OVERLOAD(Statement)
    bool operator==(IR::Statement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Statement"_cs; }
    static cstring static_type_name() { return "Statement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Statement(JSONLoader & json);
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Statement(Util::SourceInfo srcInfo) :
    StatOrDecl(srcInfo)
    { validate(); }
    Statement() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Statement)
    DECLARE_TYPEINFO_WITH_TYPEID(Statement, NodeKind::Statement, StatOrDecl);
};
}  // namespace P4::IR
namespace P4::IR {
class BaseAssignmentStatement : public Statement {
 public:
    const IR::Expression* left = nullptr;
    const IR::Expression* right = nullptr;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BaseAssignmentStatement"_cs; }
    static cstring static_type_name() { return "BaseAssignmentStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    BaseAssignmentStatement(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    BaseAssignmentStatement(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Statement(srcInfo), left(left), right(right)
    { validate(); }
    BaseAssignmentStatement(const IR::Expression* left, const IR::Expression* right) :
    left(left), right(right)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(BaseAssignmentStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(BaseAssignmentStatement, NodeKind::BaseAssignmentStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class OpAssignmentStatement : public BaseAssignmentStatement {
 public:
#line 481 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    virtual cstring getStringOp() const = 0;
#line 4449 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 482 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 4452 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 483 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 4455 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "OpAssignmentStatement"_cs; }
    static cstring static_type_name() { return "OpAssignmentStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    OpAssignmentStatement(JSONLoader & json);
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    OpAssignmentStatement(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    BaseAssignmentStatement(srcInfo, left, right)
    { validate(); }
    OpAssignmentStatement(const IR::Expression* left, const IR::Expression* right) :
    BaseAssignmentStatement(left, right)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(OpAssignmentStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(OpAssignmentStatement, NodeKind::OpAssignmentStatement, BaseAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class MulAssign : public OpAssignmentStatement {
 public:
#line 78 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef Mul BinOp;
#line 4482 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("*"); }
    bool operator==(IR::MulAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MulAssign"_cs; }
    static cstring static_type_name() { return "MulAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    MulAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    MulAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    MulAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(MulAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(MulAssign, NodeKind::MulAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class Div : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("/"); }
    int getPrecedence() const override { return DBPrint::Prec_Div; }
    bool operator==(IR::Div const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Div"_cs; }
    static cstring static_type_name() { return "Div"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Div(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Div(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    Div(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    Div(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    Div(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Div)
    DECLARE_TYPEINFO_WITH_TYPEID(Div, NodeKind::Div, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class DivAssign : public OpAssignmentStatement {
 public:
#line 90 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef Div BinOp;
#line 4544 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("/"); }
    bool operator==(IR::DivAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DivAssign"_cs; }
    static cstring static_type_name() { return "DivAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DivAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DivAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    DivAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(DivAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(DivAssign, NodeKind::DivAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class Mod : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("%"); }
    int getPrecedence() const override { return DBPrint::Prec_Mod; }
    bool operator==(IR::Mod const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Mod"_cs; }
    static cstring static_type_name() { return "Mod"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Mod(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Mod(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    Mod(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    Mod(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    Mod(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Mod)
    DECLARE_TYPEINFO_WITH_TYPEID(Mod, NodeKind::Mod, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class ModAssign : public OpAssignmentStatement {
 public:
#line 101 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef Mod BinOp;
#line 4606 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("%"); }
    bool operator==(IR::ModAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ModAssign"_cs; }
    static cstring static_type_name() { return "ModAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ModAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ModAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    ModAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(ModAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(ModAssign, NodeKind::ModAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class Add : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("+"); }
    int getPrecedence() const override { return DBPrint::Prec_Add; }
    bool operator==(IR::Add const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Add"_cs; }
    static cstring static_type_name() { return "Add"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Add(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Add(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    Add(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    Add(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    Add(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Add)
    DECLARE_TYPEINFO_WITH_TYPEID(Add, NodeKind::Add, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class AddAssign : public OpAssignmentStatement {
 public:
#line 112 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef Add BinOp;
#line 4668 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("+"); }
    bool operator==(IR::AddAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "AddAssign"_cs; }
    static cstring static_type_name() { return "AddAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    AddAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AddAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    AddAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(AddAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(AddAssign, NodeKind::AddAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class Sub : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("-"); }
    int getPrecedence() const override { return DBPrint::Prec_Sub; }
    bool operator==(IR::Sub const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Sub"_cs; }
    static cstring static_type_name() { return "Sub"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Sub(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Sub(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    Sub(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    Sub(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    Sub(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Sub)
    DECLARE_TYPEINFO_WITH_TYPEID(Sub, NodeKind::Sub, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class SubAssign : public OpAssignmentStatement {
 public:
#line 123 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef Sub BinOp;
#line 4730 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("-"); }
    bool operator==(IR::SubAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "SubAssign"_cs; }
    static cstring static_type_name() { return "SubAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    SubAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SubAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    SubAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(SubAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(SubAssign, NodeKind::SubAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class AddSat : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("|+|"); }
    int getPrecedence() const override { return DBPrint::Prec_AddSat; }
    bool operator==(IR::AddSat const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "AddSat"_cs; }
    static cstring static_type_name() { return "AddSat"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AddSat(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AddSat(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    AddSat(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    AddSat(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    AddSat(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(AddSat)
    DECLARE_TYPEINFO_WITH_TYPEID(AddSat, NodeKind::AddSat, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class AddSatAssign : public OpAssignmentStatement {
 public:
#line 134 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef AddSat BinOp;
#line 4792 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("|+|"); }
    bool operator==(IR::AddSatAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "AddSatAssign"_cs; }
    static cstring static_type_name() { return "AddSatAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    AddSatAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AddSatAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    AddSatAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(AddSatAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(AddSatAssign, NodeKind::AddSatAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class SubSat : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("|-|"); }
    int getPrecedence() const override { return DBPrint::Prec_SubSat; }
    bool operator==(IR::SubSat const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "SubSat"_cs; }
    static cstring static_type_name() { return "SubSat"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SubSat(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SubSat(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    SubSat(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    SubSat(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    SubSat(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(SubSat)
    DECLARE_TYPEINFO_WITH_TYPEID(SubSat, NodeKind::SubSat, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class SubSatAssign : public OpAssignmentStatement {
 public:
#line 145 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef SubSat BinOp;
#line 4854 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("|-|"); }
    bool operator==(IR::SubSatAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "SubSatAssign"_cs; }
    static cstring static_type_name() { return "SubSatAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    SubSatAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SubSatAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    SubSatAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(SubSatAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(SubSatAssign, NodeKind::SubSatAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class Shl : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("<<"); }
    int getPrecedence() const override { return DBPrint::Prec_Shl; }
    bool operator==(IR::Shl const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Shl"_cs; }
    static cstring static_type_name() { return "Shl"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Shl(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Shl(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 153 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4900 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Shl(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 153 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4907 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Shl(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 153 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4914 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Shl(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 153 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4921 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Shl)
    DECLARE_TYPEINFO_WITH_TYPEID(Shl, NodeKind::Shl, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class ShlAssign : public OpAssignmentStatement {
 public:
#line 157 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef Shl BinOp;
#line 4932 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("<<"); }
    bool operator==(IR::ShlAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ShlAssign"_cs; }
    static cstring static_type_name() { return "ShlAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ShlAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ShlAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    ShlAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(ShlAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(ShlAssign, NodeKind::ShlAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class Shr : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring(">>"); }
    int getPrecedence() const override { return DBPrint::Prec_Shr; }
    bool operator==(IR::Shr const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Shr"_cs; }
    static cstring static_type_name() { return "Shr"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Shr(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Shr(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4978 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Shr(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4985 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Shr(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4992 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Shr(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && left) type = left->type; }
#line 4999 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Shr)
    DECLARE_TYPEINFO_WITH_TYPEID(Shr, NodeKind::Shr, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class ShrAssign : public OpAssignmentStatement {
 public:
#line 169 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef Shr BinOp;
#line 5010 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring(">>"); }
    bool operator==(IR::ShrAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ShrAssign"_cs; }
    static cstring static_type_name() { return "ShrAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ShrAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ShrAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    ShrAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(ShrAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(ShrAssign, NodeKind::ShrAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class Equ : public Operation_Relation {
 public:
    cstring getStringOp() const override { return cstring("=="); }
    int getPrecedence() const override { return DBPrint::Prec_Equ; }
    bool operator==(IR::Equ const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Equ"_cs; }
    static cstring static_type_name() { return "Equ"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Equ(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Relation const & a) const override;
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Equ(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, type, left, right)
    { validate(); }
    Equ(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(type, left, right)
    { validate(); }
    Equ(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, left, right)
    { validate(); }
    Equ(const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Equ)
    DECLARE_TYPEINFO_WITH_TYPEID(Equ, NodeKind::Equ, Operation_Relation);
};
}  // namespace P4::IR
namespace P4::IR {
class Neq : public Operation_Relation {
 public:
    cstring getStringOp() const override { return cstring("!="); }
    int getPrecedence() const override { return DBPrint::Prec_Neq; }
    bool operator==(IR::Neq const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Neq"_cs; }
    static cstring static_type_name() { return "Neq"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Neq(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Relation const & a) const override;
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Neq(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, type, left, right)
    { validate(); }
    Neq(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(type, left, right)
    { validate(); }
    Neq(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, left, right)
    { validate(); }
    Neq(const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Neq)
    DECLARE_TYPEINFO_WITH_TYPEID(Neq, NodeKind::Neq, Operation_Relation);
};
}  // namespace P4::IR
namespace P4::IR {
class Lss : public Operation_Relation {
 public:
    cstring getStringOp() const override { return cstring("<"); }
    int getPrecedence() const override { return DBPrint::Prec_Lss; }
    bool operator==(IR::Lss const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Lss"_cs; }
    static cstring static_type_name() { return "Lss"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Lss(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Relation const & a) const override;
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Lss(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, type, left, right)
    { validate(); }
    Lss(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(type, left, right)
    { validate(); }
    Lss(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, left, right)
    { validate(); }
    Lss(const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Lss)
    DECLARE_TYPEINFO_WITH_TYPEID(Lss, NodeKind::Lss, Operation_Relation);
};
}  // namespace P4::IR
namespace P4::IR {
class Leq : public Operation_Relation {
 public:
    cstring getStringOp() const override { return cstring("<="); }
    int getPrecedence() const override { return DBPrint::Prec_Leq; }
    bool operator==(IR::Leq const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Leq"_cs; }
    static cstring static_type_name() { return "Leq"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Leq(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Relation const & a) const override;
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Leq(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, type, left, right)
    { validate(); }
    Leq(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(type, left, right)
    { validate(); }
    Leq(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, left, right)
    { validate(); }
    Leq(const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Leq)
    DECLARE_TYPEINFO_WITH_TYPEID(Leq, NodeKind::Leq, Operation_Relation);
};
}  // namespace P4::IR
namespace P4::IR {
class Grt : public Operation_Relation {
 public:
    cstring getStringOp() const override { return cstring(">"); }
    int getPrecedence() const override { return DBPrint::Prec_Grt; }
    bool operator==(IR::Grt const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Grt"_cs; }
    static cstring static_type_name() { return "Grt"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Grt(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Relation const & a) const override;
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Grt(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, type, left, right)
    { validate(); }
    Grt(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(type, left, right)
    { validate(); }
    Grt(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, left, right)
    { validate(); }
    Grt(const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Grt)
    DECLARE_TYPEINFO_WITH_TYPEID(Grt, NodeKind::Grt, Operation_Relation);
};
}  // namespace P4::IR
namespace P4::IR {
class Geq : public Operation_Relation {
 public:
    cstring getStringOp() const override { return cstring(">="); }
    int getPrecedence() const override { return DBPrint::Prec_Geq; }
    bool operator==(IR::Geq const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Geq"_cs; }
    static cstring static_type_name() { return "Geq"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Geq(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Relation const & a) const override;
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Geq(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, type, left, right)
    { validate(); }
    Geq(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(type, left, right)
    { validate(); }
    Geq(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(srcInfo, left, right)
    { validate(); }
    Geq(const IR::Expression* left, const IR::Expression* right) :
    Operation_Relation(left, right)
    { validate(); }
    IRNODE_SUBCLASS(Geq)
    DECLARE_TYPEINFO_WITH_TYPEID(Geq, NodeKind::Geq, Operation_Relation);
};
}  // namespace P4::IR
namespace P4::IR {
class BAnd : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("&"); }
    int getPrecedence() const override { return DBPrint::Prec_BAnd; }
    bool operator==(IR::BAnd const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BAnd"_cs; }
    static cstring static_type_name() { return "BAnd"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    BAnd(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BAnd(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    BAnd(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    BAnd(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    BAnd(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(BAnd)
    DECLARE_TYPEINFO_WITH_TYPEID(BAnd, NodeKind::BAnd, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class BAndAssign : public OpAssignmentStatement {
 public:
#line 204 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef BAnd BinOp;
#line 5276 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("&"); }
    bool operator==(IR::BAndAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BAndAssign"_cs; }
    static cstring static_type_name() { return "BAndAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    BAndAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BAndAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    BAndAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(BAndAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(BAndAssign, NodeKind::BAndAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class BOr : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("|"); }
    int getPrecedence() const override { return DBPrint::Prec_BOr; }
    bool operator==(IR::BOr const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BOr"_cs; }
    static cstring static_type_name() { return "BOr"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    BOr(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BOr(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    BOr(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    BOr(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    BOr(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(BOr)
    DECLARE_TYPEINFO_WITH_TYPEID(BOr, NodeKind::BOr, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class BOrAssign : public OpAssignmentStatement {
 public:
#line 215 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef BOr BinOp;
#line 5338 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("|"); }
    bool operator==(IR::BOrAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BOrAssign"_cs; }
    static cstring static_type_name() { return "BOrAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    BOrAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BOrAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    BOrAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(BOrAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(BOrAssign, NodeKind::BOrAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class BXor : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("^"); }
    int getPrecedence() const override { return DBPrint::Prec_BXor; }
    bool operator==(IR::BXor const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BXor"_cs; }
    static cstring static_type_name() { return "BXor"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    BXor(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BXor(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    { validate(); }
    BXor(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    { validate(); }
    BXor(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    { validate(); }
    BXor(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    { validate(); }
    IRNODE_SUBCLASS(BXor)
    DECLARE_TYPEINFO_WITH_TYPEID(BXor, NodeKind::BXor, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class BXorAssign : public OpAssignmentStatement {
 public:
#line 226 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    typedef BXor BinOp;
#line 5400 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("^"); }
    bool operator==(IR::BXorAssign const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BXorAssign"_cs; }
    static cstring static_type_name() { return "BXorAssign"_cs; }
    void toJSON(JSONGenerator & json) const override;
    BXorAssign(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::OpAssignmentStatement const & a) const override;
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BXorAssign(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(srcInfo, left, right)
    { validate(); }
    BXorAssign(const IR::Expression* left, const IR::Expression* right) :
    OpAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(BXorAssign)
    DECLARE_TYPEINFO_WITH_TYPEID(BXorAssign, NodeKind::BXorAssign, OpAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class LAnd : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("&&"); }
    int getPrecedence() const override { return DBPrint::Prec_LAnd; }
    bool operator==(IR::LAnd const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "LAnd"_cs; }
    static cstring static_type_name() { return "LAnd"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LAnd(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LAnd(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 234 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5451 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LAnd(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 234 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5463 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LAnd(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 234 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5475 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LAnd(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 234 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5487 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(LAnd)
    DECLARE_TYPEINFO_WITH_TYPEID(LAnd, NodeKind::LAnd, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class LOr : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("||"); }
    int getPrecedence() const override { return DBPrint::Prec_LOr; }
    bool operator==(IR::LOr const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "LOr"_cs; }
    static cstring static_type_name() { return "LOr"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LOr(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LOr(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5520 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LOr(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5532 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LOr(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5544 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    LOr(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        // This sets the type only when no type is explicitly provided in the constructor.
        // If a type is provided in the constructor this assignment has no effect
        // because the type member is shadowed by the type parameter.
        type = Type::Boolean::get();
    }
#line 5556 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(LOr)
    DECLARE_TYPEINFO_WITH_TYPEID(LOr, NodeKind::LOr, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents the ... default initializer expression
class Dots : public Expression {
 public:
#line 253 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void dbprint(std::ostream & out) const override;
#line 5568 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 254 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 5571 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Dots const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Dots"_cs; }
    static cstring static_type_name() { return "Dots"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Dots(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Dots(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    Dots(const IR::Type* type) :
    Expression(type)
    { validate(); }
    Dots(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    Dots() 
    { validate(); }
    IRNODE_SUBCLASS(Dots)
    DECLARE_TYPEINFO_WITH_TYPEID(Dots, NodeKind::Dots, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents the ... default initializer expression
/// when used in a StructExpression.
class NamedDots : public NamedExpression {
 public:
#line 260 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    NamedDots() : NamedExpression("...", new Dots()) {}
#line 5603 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 261 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    NamedDots(Util::SourceInfo srcInfo, const IR::Dots* dots) : NamedExpression(srcInfo, "..."_cs, dots) { CHECK_NULL(dots); }
#line 5606 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 262 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    NamedDots(Util::SourceInfo srcInfo) : NamedExpression(srcInfo, "...", new Dots()) {}
#line 5609 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 263 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void dbprint(std::ostream & out) const override;
#line 5612 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 264 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 5615 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::NamedDots const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "NamedDots"_cs; }
    static cstring static_type_name() { return "NamedDots"_cs; }
    void toJSON(JSONGenerator & json) const override;
    NamedDots(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::NamedExpression const & a) const override;
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    NamedDots(Util::SourceInfo srcInfo, IR::ID name, const IR::Expression* expression) :
    NamedExpression(srcInfo, name, expression)
    { validate(); }
    NamedDots(IR::ID name, const IR::Expression* expression) :
    NamedExpression(name, expression)
    { validate(); }
    IRNODE_SUBCLASS(NamedDots)
    DECLARE_TYPEINFO_WITH_TYPEID(NamedDots, NodeKind::NamedDots, NamedExpression);
};
}  // namespace P4::IR
namespace P4::IR {
class Literal : public Expression, public virtual CompileTimeValue {
 public:
    bool operator==(IR::Literal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Literal"_cs; }
    static cstring static_type_name() { return "Literal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Literal(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Literal(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    Literal(const IR::Type* type) :
    Expression(type)
    { validate(); }
    Literal(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    Literal() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Literal)
    DECLARE_TYPEINFO_WITH_TYPEID(Literal, NodeKind::Literal, Expression, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
/// This is an integer literal on arbitrary-precision.
class Constant : public Literal {
 public:
    big_int value;
    unsigned base;
/// base used when reading/writing
/// if noWarning is true, no warning is emitted
#line 275 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void handleOverflow(bool noWarning);
#line 5674 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"



#line 279 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant(int v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
#line 5681 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 281 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant(unsigned v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
#line 5685 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 284 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
#if __WORDSIZE == 64
    Constant(intmax_t v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
#else
    Constant(long v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
    Constant(unsigned long v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
    Constant(intmax_t v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
#endif
#line 5698 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 296 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant(uint64_t v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
#line 5702 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 298 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant(big_int v, unsigned base = 10) :
        Literal(Type_InfInt::get()), value(v), base(base) {}
#line 5706 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 300 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant(Util::SourceInfo si, big_int v, unsigned base = 10) :
        Literal(si, Type_InfInt::get()), value(v), base(base) {}
#line 5710 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 302 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant(IR::Type const * t, big_int v, unsigned base = 10, bool noWarning = false) :
        Literal(t), value(v), base(base) { CHECK_NULL(t); handleOverflow(noWarning); }
#line 5714 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 304 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant(Util::SourceInfo si, IR::Type const * t, big_int v, unsigned base = 10, bool noWarning = false) :
        Literal(si, t), value(v), base(base) { CHECK_NULL(t); handleOverflow(noWarning); }
#line 5718 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 308 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    static Constant GetMask(unsigned width);
#line 5721 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// @return a constant. Any constant returned here is interned. Base is always 10.
#line 312 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    static IR::Constant const * get(IR::Type const * t, big_int v, Util::SourceInfo si = {});
#line 5725 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 314 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool fitsInt() const { return value >= INT_MIN && value <= INT_MAX; }
#line 5728 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 315 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool fitsLong() const { return value >= LONG_MIN && value <= LONG_MAX; }
#line 5731 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 316 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool fitsUint() const { return value >= 0 && value <= UINT_MAX; }
#line 5734 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 317 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool fitsUint64() const { return value >= 0 && value <= UINT64_MAX; }
#line 5737 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 318 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool fitsInt64() const { return value >= INT64_MIN && value <= INT64_MAX; }
#line 5740 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 319 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    long asLong() const {
        if (!fitsLong())
            ::P4::error(ErrorType::ERR_OVERLIMIT, "%1$x: Value too large for long", this);
        return static_cast<long>(value); }
#line 5746 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 323 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    int asInt() const {
        if (!fitsInt())
            ::P4::error(ErrorType::ERR_OVERLIMIT, "%1$x: Value too large for int", this);
        return static_cast<int>(value); }
#line 5752 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 327 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    unsigned asUnsigned() const {
        if (!fitsUint())
            ::P4::error(ErrorType::ERR_OVERLIMIT, "%1$x: Value too large for unsigned int", this);
        return static_cast<unsigned>(value);
    }
#line 5759 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 332 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    uint64_t asUint64() const {
        if (!fitsUint64())
            ::P4::error(ErrorType::ERR_OVERLIMIT, "%1$x: Value too large for uint64", this);
        return static_cast<uint64_t>(value);
    }
#line 5766 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 337 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    int64_t asInt64() const {
        if (!fitsInt64())
            ::P4::error(ErrorType::ERR_OVERLIMIT, "%1$x: Value too large for int64", this);
        return static_cast<int64_t>(value);
    }
#line 5773 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"



#line 346 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Constant operator<<(const unsigned &shift) const;
    Constant operator>>(const unsigned &shift) const;
    Constant operator&(const Constant &c) const;
    Constant operator|(const Constant &c) const;
    Constant operator^(const Constant &c) const;
    Constant operator-(const Constant &c) const;
    Constant operator-() const;
#line 5785 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 354 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 5788 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 366 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 5792 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Constant const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Constant"_cs; }
    static cstring static_type_name() { return "Constant"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Constant(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Literal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(Constant)
    DECLARE_TYPEINFO_WITH_TYPEID(Constant, NodeKind::Constant, Literal);
};
}  // namespace P4::IR
namespace P4::IR {
class BoolLiteral : public Literal {
 public:
    bool value;
#line 371 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 5815 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// @return a bool literal. Both booleans are interned.
#line 374 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    static IR::BoolLiteral const * get(bool value, Util::SourceInfo const & si = {});
#line 5819 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BoolLiteral const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BoolLiteral"_cs; }
    static cstring static_type_name() { return "BoolLiteral"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    BoolLiteral(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Literal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BoolLiteral(Util::SourceInfo srcInfo, const IR::Type* type, bool value) :
    Literal(srcInfo, type), value(value)
    { validate(); }
    BoolLiteral(const IR::Type* type, bool value) :
    Literal(type), value(value)
    { validate(); }
    BoolLiteral(Util::SourceInfo srcInfo, bool value) :
    Literal(srcInfo), value(value)
    { validate(); }
    BoolLiteral(bool value) :
    value(value)
    { validate(); }
    IRNODE_SUBCLASS(BoolLiteral)
    DECLARE_TYPEINFO_WITH_TYPEID(BoolLiteral, NodeKind::BoolLiteral, Literal);
};
}  // namespace P4::IR
namespace P4::IR {
class StringLiteral : public Literal {
 public:
    cstring value;
#line 379 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 5854 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 380 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 5857 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 381 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    StringLiteral(IR::ID v) : Literal(v.srcInfo), value(v.name) {}
#line 5860 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 383 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    operator IR::ID() const { return IR::ID(srcInfo, value); }
#line 5863 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// @returns a string literal. The value is cached.
#line 387 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    static IR::StringLiteral const * get(cstring value, IR::Type const * t = Type_String::get(), Util::SourceInfo const & si = {});
#line 5867 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::StringLiteral const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "StringLiteral"_cs; }
    static cstring static_type_name() { return "StringLiteral"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    StringLiteral(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Literal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    StringLiteral(Util::SourceInfo srcInfo, const IR::Type* type, cstring value) :
    Literal(srcInfo, type), value(value)
    { validate(); }
    StringLiteral(const IR::Type* type, cstring value) :
    Literal(type), value(value)
    { validate(); }
    StringLiteral(Util::SourceInfo srcInfo, cstring value) :
    Literal(srcInfo), value(value)
    { validate(); }
    StringLiteral(cstring value) :
    value(value)
    { validate(); }
    IRNODE_SUBCLASS(StringLiteral)
    DECLARE_TYPEINFO_WITH_TYPEID(StringLiteral, NodeKind::StringLiteral, Literal);
};
}  // namespace P4::IR
namespace P4::IR {
class PathExpression : public Expression {
 public:
    const IR::Path* path = nullptr;
#line 393 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    PathExpression(const IR::Type* t, IR::ID id) : Expression(id.srcInfo, t), path(new IR::Path(id)) {}
#line 5902 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 394 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    PathExpression(IR::ID id) : Expression(id.srcInfo), path(new IR::Path(id)) {}
#line 5905 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 395 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 5908 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::PathExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "PathExpression"_cs; }
    static cstring static_type_name() { return "PathExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    PathExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    PathExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Path* path) :
    Expression(srcInfo, type), path(path)
    {
#line 392 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && path) srcInfo = path->srcInfo; }
#line 5927 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    PathExpression(const IR::Type* type, const IR::Path* path) :
    Expression(type), path(path)
    {
#line 392 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && path) srcInfo = path->srcInfo; }
#line 5934 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    PathExpression(Util::SourceInfo srcInfo, const IR::Path* path) :
    Expression(srcInfo), path(path)
    {
#line 392 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && path) srcInfo = path->srcInfo; }
#line 5941 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    PathExpression(const IR::Path* path) :
    path(path)
    {
#line 392 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && path) srcInfo = path->srcInfo; }
#line 5948 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(PathExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(PathExpression, NodeKind::PathExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {

class TypeNameExpression : public Expression {
 public:
    const IR::Type* typeName = nullptr;
#line 404 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    TypeNameExpression(IR::ID id) : Expression(id.srcInfo),
                                typeName(new IR::Type_Name(new IR::Path(id))) {}
#line 5962 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 406 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void dbprint(std::ostream & out) const override;
#line 5965 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 407 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 5968 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 408 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 5971 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TypeNameExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "TypeNameExpression"_cs; }
    static cstring static_type_name() { return "TypeNameExpression"_cs; }
    void toJSON(JSONGenerator & json) const override;
    TypeNameExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TypeNameExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Type* typeName) :
    Expression(srcInfo, type), typeName(typeName)
    {
#line 403 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && typeName) srcInfo = typeName->srcInfo; }
#line 5988 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    TypeNameExpression(const IR::Type* type, const IR::Type* typeName) :
    Expression(type), typeName(typeName)
    {
#line 403 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && typeName) srcInfo = typeName->srcInfo; }
#line 5995 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    TypeNameExpression(Util::SourceInfo srcInfo, const IR::Type* typeName) :
    Expression(srcInfo), typeName(typeName)
    {
#line 403 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && typeName) srcInfo = typeName->srcInfo; }
#line 6002 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    TypeNameExpression(const IR::Type* typeName) :
    typeName(typeName)
    {
#line 403 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (!srcInfo && typeName) srcInfo = typeName->srcInfo; }
#line 6009 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(TypeNameExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(TypeNameExpression, NodeKind::TypeNameExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class AbstractSlice : public Operation_Ternary {
 public:
#line 413 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    virtual unsigned getH() const = 0;
#line 6020 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 414 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    virtual unsigned getL() const = 0;
#line 6023 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::AbstractSlice const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "AbstractSlice"_cs; }
    static cstring static_type_name() { return "AbstractSlice"_cs; }
    void toJSON(JSONGenerator & json) const override;
    AbstractSlice(JSONLoader & json);
    bool operator==(IR::Operation_Ternary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    AbstractSlice(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(srcInfo, type, e0, e1, e2)
    { validate(); }
    AbstractSlice(const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(type, e0, e1, e2)
    { validate(); }
    AbstractSlice(Util::SourceInfo srcInfo, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(srcInfo, e0, e1, e2)
    { validate(); }
    AbstractSlice(const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(e0, e1, e2)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(AbstractSlice)
    DECLARE_TYPEINFO_WITH_TYPEID(AbstractSlice, NodeKind::AbstractSlice, Operation_Ternary);
};
}  // namespace P4::IR
namespace P4::IR {
class Slice : public AbstractSlice {
 public:
    int getPrecedence() const override { return DBPrint::Prec_Postfix; }
    cstring getStringOp() const override { return cstring("[:]"); }
#line 420 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6058 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 422 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    unsigned getH() const override;
#line 6062 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 423 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    unsigned getL() const override;
#line 6065 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 424 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Slice(const IR::Expression* a, int hi, int lo) : AbstractSlice(IR::Type::Bits::get(hi-lo+1), a, new Constant(hi), new Constant(lo)) {}
#line 6068 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 426 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    Slice(Util::SourceInfo si, const IR::Expression* a, int hi, int lo) : AbstractSlice(si, IR::Type::Bits::get(hi-lo+1), a, new Constant(hi), new Constant(lo)) {}
#line 6071 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 432 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    static const IR::Expression *make(const IR::Expression* a, unsigned hi, unsigned lo);
#line 6075 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Slice const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Slice"_cs; }
    static cstring static_type_name() { return "Slice"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Slice(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::AbstractSlice const & a) const override;
    bool operator==(IR::Operation_Ternary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Slice(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(srcInfo, type, e0, e1, e2)
    {
#line 428 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e1 && e1->is<Constant>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(getH() - getL() + 1); }
#line 6096 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Slice(const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(type, e0, e1, e2)
    {
#line 428 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e1 && e1->is<Constant>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(getH() - getL() + 1); }
#line 6105 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Slice(Util::SourceInfo srcInfo, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(srcInfo, e0, e1, e2)
    {
#line 428 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e1 && e1->is<Constant>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(getH() - getL() + 1); }
#line 6114 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Slice(const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(e0, e1, e2)
    {
#line 428 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e1 && e1->is<Constant>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(getH() - getL() + 1); }
#line 6123 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Slice)
    DECLARE_TYPEINFO_WITH_TYPEID(Slice, NodeKind::Slice, AbstractSlice);
};
}  // namespace P4::IR
namespace P4::IR {
class PlusSlice : public AbstractSlice {
 public:
    int getPrecedence() const override { return DBPrint::Prec_Postfix; }
    cstring getStringOp() const override { return cstring("[+:]"); }
#line 438 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6136 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 439 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    unsigned getH() const override;
#line 6139 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 442 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    unsigned getL() const override;
#line 6142 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 445 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    PlusSlice(const IR::Expression* a, const IR::Expression* lo, int width) : AbstractSlice(IR::Type::Bits::get(width), a, lo, new Constant(width)) {}
#line 6145 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::PlusSlice const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "PlusSlice"_cs; }
    static cstring static_type_name() { return "PlusSlice"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    PlusSlice(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::AbstractSlice const & a) const override;
    bool operator==(IR::Operation_Ternary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    PlusSlice(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(srcInfo, type, e0, e1, e2)
    {
#line 447 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(e2->to<IR::Constant>()->asUnsigned()); }
#line 6166 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    PlusSlice(const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(type, e0, e1, e2)
    {
#line 447 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(e2->to<IR::Constant>()->asUnsigned()); }
#line 6175 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    PlusSlice(Util::SourceInfo srcInfo, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(srcInfo, e0, e1, e2)
    {
#line 447 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(e2->to<IR::Constant>()->asUnsigned()); }
#line 6184 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    PlusSlice(const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    AbstractSlice(e0, e1, e2)
    {
#line 447 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (type->is<Type::Unknown>() && e2 && e2->is<Constant>())
            type = IR::Type::Bits::get(e2->to<IR::Constant>()->asUnsigned()); }
#line 6193 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(PlusSlice)
    DECLARE_TYPEINFO_WITH_TYPEID(PlusSlice, NodeKind::PlusSlice, AbstractSlice);
};
}  // namespace P4::IR
namespace P4::IR {
class Member : public Operation_Unary {
 public:
    int getPrecedence() const override { return DBPrint::Prec_Postfix; }
    IR::ID member;
#line 455 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    virtual int offset_bits() const;
#line 6206 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 456 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    int lsb() const;
#line 6209 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 457 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    int msb() const;
#line 6212 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("."); }
#line 459 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6216 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Member const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Member"_cs; }
    static cstring static_type_name() { return "Member"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Member(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Member(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, IR::ID member) :
    Operation_Unary(srcInfo, type, expr), member(member)
    { validate(); }
    Member(const IR::Type* type, const IR::Expression* expr, IR::ID member) :
    Operation_Unary(type, expr), member(member)
    { validate(); }
    Member(Util::SourceInfo srcInfo, const IR::Expression* expr, IR::ID member) :
    Operation_Unary(srcInfo, expr), member(member)
    { validate(); }
    Member(const IR::Expression* expr, IR::ID member) :
    Operation_Unary(expr), member(member)
    { validate(); }
    IRNODE_SUBCLASS(Member)
    DECLARE_TYPEINFO_WITH_TYPEID(Member, NodeKind::Member, Operation_Unary);
};
}  // namespace P4::IR
namespace P4::IR {
class Concat : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("++"); }
    int getPrecedence() const override { return DBPrint::Prec_Add; }
    bool operator==(IR::Concat const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Concat"_cs; }
    static cstring static_type_name() { return "Concat"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Concat(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Concat(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 465 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (left && right) {
            auto lt = left->type->to<IR::Type::Bits>();
            auto rt = right->type->to<IR::Type::Bits>();
            if (lt && rt)
                type = IR::Type::Bits::get(lt->size + rt->size, lt->isSigned); } }
#line 6273 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Concat(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 465 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (left && right) {
            auto lt = left->type->to<IR::Type::Bits>();
            auto rt = right->type->to<IR::Type::Bits>();
            if (lt && rt)
                type = IR::Type::Bits::get(lt->size + rt->size, lt->isSigned); } }
#line 6285 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Concat(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 465 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (left && right) {
            auto lt = left->type->to<IR::Type::Bits>();
            auto rt = right->type->to<IR::Type::Bits>();
            if (lt && rt)
                type = IR::Type::Bits::get(lt->size + rt->size, lt->isSigned); } }
#line 6297 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Concat(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 465 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (left && right) {
            auto lt = left->type->to<IR::Type::Bits>();
            auto rt = right->type->to<IR::Type::Bits>();
            if (lt && rt)
                type = IR::Type::Bits::get(lt->size + rt->size, lt->isSigned); } }
#line 6309 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Concat)
    DECLARE_TYPEINFO_WITH_TYPEID(Concat, NodeKind::Concat, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class ArrayIndex : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("[]"); }
    int getPrecedence() const override { return DBPrint::Prec_Postfix; }
#line 479 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6322 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ArrayIndex const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ArrayIndex"_cs; }
    static cstring static_type_name() { return "ArrayIndex"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ArrayIndex(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ArrayIndex(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 476 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (auto st = left ? left->type->to<IR::Type_Array>() : nullptr)
            type = st->elementType; }
#line 6342 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ArrayIndex(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 476 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (auto st = left ? left->type->to<IR::Type_Array>() : nullptr)
            type = st->elementType; }
#line 6351 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ArrayIndex(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 476 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (auto st = left ? left->type->to<IR::Type_Array>() : nullptr)
            type = st->elementType; }
#line 6360 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ArrayIndex(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 476 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        if (auto st = left ? left->type->to<IR::Type_Array>() : nullptr)
            type = st->elementType; }
#line 6369 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(ArrayIndex)
    DECLARE_TYPEINFO_WITH_TYPEID(ArrayIndex, NodeKind::ArrayIndex, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class Range : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring(".."); }
    int getPrecedence() const override { return DBPrint::Prec_Low; }
    bool operator==(IR::Range const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Range"_cs; }
    static cstring static_type_name() { return "Range"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Range(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Range(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 485 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6398 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Range(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 485 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6406 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Range(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 485 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6414 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Range(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 485 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6422 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Range)
    DECLARE_TYPEINFO_WITH_TYPEID(Range, NodeKind::Range, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class Mask : public Operation_Binary {
 public:
    cstring getStringOp() const override { return cstring("&&&"); }
    int getPrecedence() const override { return DBPrint::Prec_Low; }
    bool operator==(IR::Mask const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Mask"_cs; }
    static cstring static_type_name() { return "Mask"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Mask(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Binary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Mask(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, type, left, right)
    {
#line 492 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6451 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Mask(const IR::Type* type, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(type, left, right)
    {
#line 492 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6459 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Mask(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(srcInfo, left, right)
    {
#line 492 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6467 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Mask(const IR::Expression* left, const IR::Expression* right) :
    Operation_Binary(left, right)
    {
#line 492 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (left && type == left->type && !left->type->is<Type::Unknown>())
                type = new Type_Set(left->type); }
#line 6475 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Mask)
    DECLARE_TYPEINFO_WITH_TYPEID(Mask, NodeKind::Mask, Operation_Binary);
};
}  // namespace P4::IR
namespace P4::IR {
class Mux : public Operation_Ternary {
 public:
    cstring getStringOp() const override { return cstring("?:"); }
    int getPrecedence() const override { return DBPrint::Prec_Low; }
#line 499 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 6489 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Mux const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Mux"_cs; }
    static cstring static_type_name() { return "Mux"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Mux(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Ternary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Mux(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(srcInfo, type, e0, e1, e2)
    {
#line 503 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && e1 && e2 && e1->type == e2->type) type = e1->type; }
#line 6507 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Mux(const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(type, e0, e1, e2)
    {
#line 503 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && e1 && e2 && e1->type == e2->type) type = e1->type; }
#line 6514 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Mux(Util::SourceInfo srcInfo, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(srcInfo, e0, e1, e2)
    {
#line 503 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && e1 && e2 && e1->type == e2->type) type = e1->type; }
#line 6521 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    Mux(const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(e0, e1, e2)
    {
#line 503 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{ if (type->is<Type::Unknown>() && e1 && e2 && e1->type == e2->type) type = e1->type; }
#line 6528 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(Mux)
    DECLARE_TYPEINFO_WITH_TYPEID(Mux, NodeKind::Mux, Operation_Ternary);
};
}  // namespace P4::IR
namespace P4::IR {
class DefaultExpression : public Expression {
 public:
    bool operator==(IR::DefaultExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DefaultExpression"_cs; }
    static cstring static_type_name() { return "DefaultExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DefaultExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DefaultExpression(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    DefaultExpression(const IR::Type* type) :
    Expression(type)
    { validate(); }
    DefaultExpression(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    DefaultExpression() 
    { validate(); }
    IRNODE_SUBCLASS(DefaultExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(DefaultExpression, NodeKind::DefaultExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {

class This : public Expression {
 public:
    long id = nextId++;
#line 512 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6569 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 private:
    static long nextId;
 public:
    bool operator==(IR::This const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "This"_cs; }
    static cstring static_type_name() { return "This"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    This(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    This(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    This(const IR::Type* type) :
    Expression(type)
    { validate(); }
    This(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    This() 
    { validate(); }
    IRNODE_SUBCLASS(This)
    DECLARE_TYPEINFO_WITH_TYPEID(This, NodeKind::This, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class Cast : public Operation_Unary {
 public:
/// These will generally always be the same, except when a cast to a type argument of
/// a generic occurs.  Then at some point, the 'destType' will be specialized to a concrete
/// type, and 'type' will only be updated later when type inferencing occurs
    const IR::Type* destType = type;
    bool implicit = false;
    int getPrecedence() const override { return DBPrint::Prec_Prefix; }
    cstring getStringOp() const override { return cstring("(cast)"); }
#line 525 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6611 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 526 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 6614 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Cast const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Cast"_cs; }
    static cstring static_type_name() { return "Cast"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Cast(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Cast(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, bool implicit) :
    Operation_Unary(srcInfo, type, expr), implicit(implicit)
    { validate(); }
    Cast(const IR::Type* type, const IR::Expression* expr, bool implicit) :
    Operation_Unary(type, expr), implicit(implicit)
    { validate(); }
    Cast(Util::SourceInfo srcInfo, const IR::Expression* expr, bool implicit) :
    Operation_Unary(srcInfo, expr), implicit(implicit)
    { validate(); }
    Cast(const IR::Expression* expr, bool implicit) :
    Operation_Unary(expr), implicit(implicit)
    { validate(); }
    Cast(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(srcInfo, type, expr)
    { validate(); }
    Cast(const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(type, expr)
    { validate(); }
    Cast(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Operation_Unary(srcInfo, expr)
    { validate(); }
    Cast(const IR::Expression* expr) :
    Operation_Unary(expr)
    { validate(); }
    IRNODE_SUBCLASS(Cast)
    DECLARE_TYPEINFO_WITH_TYPEID(Cast, NodeKind::Cast, Operation_Unary);
};
}  // namespace P4::IR
namespace P4::IR {
class SelectCase : public Node {
 public:
    const IR::Expression* keyset = nullptr;
    const IR::PathExpression* state = nullptr;
#line 532 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void dbprint(std::ostream & out) const override;
#line 6665 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::SelectCase const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "SelectCase"_cs; }
    static cstring static_type_name() { return "SelectCase"_cs; }
    void toJSON(JSONGenerator & json) const override;
    SelectCase(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    SelectCase(Util::SourceInfo srcInfo, const IR::Expression* keyset, const IR::PathExpression* state) :
    Node(srcInfo), keyset(keyset), state(state)
    { validate(); }
    SelectCase(const IR::Expression* keyset, const IR::PathExpression* state) :
    keyset(keyset), state(state)
    { validate(); }
    IRNODE_SUBCLASS(SelectCase)
    DECLARE_TYPEINFO_WITH_TYPEID(SelectCase, NodeKind::SelectCase, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class SelectExpression : public Expression {
 public:
    const IR::ListExpression* select = nullptr;
    IR::Vector<IR::SelectCase> selectCases;
#line 538 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 6695 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::SelectExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "SelectExpression"_cs; }
    static cstring static_type_name() { return "SelectExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SelectExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SelectExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::ListExpression* select, IR::Vector<IR::SelectCase> selectCases) :
    Expression(srcInfo, type), select(select), selectCases(selectCases)
    { validate(); }
    SelectExpression(const IR::Type* type, const IR::ListExpression* select, IR::Vector<IR::SelectCase> selectCases) :
    Expression(type), select(select), selectCases(selectCases)
    { validate(); }
    SelectExpression(Util::SourceInfo srcInfo, const IR::ListExpression* select, IR::Vector<IR::SelectCase> selectCases) :
    Expression(srcInfo), select(select), selectCases(selectCases)
    { validate(); }
    SelectExpression(const IR::ListExpression* select, IR::Vector<IR::SelectCase> selectCases) :
    select(select), selectCases(selectCases)
    { validate(); }
    IRNODE_SUBCLASS(SelectExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(SelectExpression, NodeKind::SelectExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class MethodCallExpression : public Expression {
 public:
    const IR::Expression* method = nullptr;
    const IR::Vector<IR::Type>* typeArguments = new Vector<Type>;
    const IR::Vector<IR::Argument>* arguments = new Vector<Argument>;
#line 548 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6731 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 557 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 6734 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 558 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    MethodCallExpression(Util::SourceInfo si, IR::ID m, std::initializer_list<const IR::Argument *> a) : Expression(si), method(new PathExpression(m)), arguments(new Vector<Argument>(a)) {}
#line 6737 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 560 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    MethodCallExpression(Util::SourceInfo si, const IR::Expression* m, std::initializer_list<const IR::Argument *> const & a) : Expression(si), method(m), arguments(new Vector<Argument>(a)) {}
#line 6740 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 563 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    MethodCallExpression(const IR::Expression* m, std::initializer_list<IR::Expression const *> const & a);
#line 6743 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MethodCallExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "MethodCallExpression"_cs; }
    static cstring static_type_name() { return "MethodCallExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    MethodCallExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    Expression(srcInfo, type), method(method), typeArguments(typeArguments), arguments(arguments)
    { validate(); }
    MethodCallExpression(const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    Expression(type), method(method), typeArguments(typeArguments), arguments(arguments)
    { validate(); }
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    Expression(srcInfo), method(method), typeArguments(typeArguments), arguments(arguments)
    { validate(); }
    MethodCallExpression(const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    method(method), typeArguments(typeArguments), arguments(arguments)
    { validate(); }
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    Expression(srcInfo, type), method(method), arguments(arguments)
    { validate(); }
    MethodCallExpression(const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    Expression(type), method(method), arguments(arguments)
    { validate(); }
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    Expression(srcInfo), method(method), arguments(arguments)
    { validate(); }
    MethodCallExpression(const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    method(method), arguments(arguments)
    { validate(); }
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    Expression(srcInfo, type), method(method), typeArguments(typeArguments)
    { validate(); }
    MethodCallExpression(const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    Expression(type), method(method), typeArguments(typeArguments)
    { validate(); }
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    Expression(srcInfo), method(method), typeArguments(typeArguments)
    { validate(); }
    MethodCallExpression(const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    method(method), typeArguments(typeArguments)
    { validate(); }
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method) :
    Expression(srcInfo, type), method(method)
    { validate(); }
    MethodCallExpression(const IR::Type* type, const IR::Expression* method) :
    Expression(type), method(method)
    { validate(); }
    MethodCallExpression(Util::SourceInfo srcInfo, const IR::Expression* method) :
    Expression(srcInfo), method(method)
    { validate(); }
    MethodCallExpression(const IR::Expression* method) :
    method(method)
    { validate(); }
    IRNODE_SUBCLASS(MethodCallExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(MethodCallExpression, NodeKind::MethodCallExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class ConstructorCallExpression : public Expression {
 public:
    const IR::Type* constructedType = type;

    const IR::Vector<IR::Argument>* arguments = nullptr;
#line 573 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6816 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 574 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 6819 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ConstructorCallExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ConstructorCallExpression"_cs; }
    static cstring static_type_name() { return "ConstructorCallExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ConstructorCallExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ConstructorCallExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Expression(srcInfo, type), arguments(arguments)
    { validate(); }
    ConstructorCallExpression(const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Expression(type), arguments(arguments)
    { validate(); }
    ConstructorCallExpression(Util::SourceInfo srcInfo, const IR::Vector<IR::Argument>* arguments) :
    Expression(srcInfo), arguments(arguments)
    { validate(); }
    ConstructorCallExpression(const IR::Vector<IR::Argument>* arguments) :
    arguments(arguments)
    { validate(); }
    IRNODE_SUBCLASS(ConstructorCallExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(ConstructorCallExpression, NodeKind::ConstructorCallExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class BaseListExpression : public Expression {
 public:
    IR::Vector<IR::Expression> components;
#line 582 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 6854 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 583 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    size_t size() const { return components.size(); }
#line 6857 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 584 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void push_back(const IR::Expression* e) { components.push_back(e); }
#line 6860 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 585 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool containsDots() const {
        if (components.empty())
            return false;
        size_t size = components.size();
        return components.at(size - 1)->is<IR::Dots>();
    }
#line 6868 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 591 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 6871 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BaseListExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BaseListExpression"_cs; }
    static cstring static_type_name() { return "BaseListExpression"_cs; }
    void toJSON(JSONGenerator & json) const override;
    BaseListExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BaseListExpression(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::Expression> components) :
    Expression(srcInfo, type), components(components)
    { validate(); }
    BaseListExpression(const IR::Type* type, IR::Vector<IR::Expression> components) :
    Expression(type), components(components)
    { validate(); }
    BaseListExpression(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> components) :
    Expression(srcInfo), components(components)
    { validate(); }
    BaseListExpression(IR::Vector<IR::Expression> components) :
    components(components)
    { validate(); }
    IRNODE_SUBCLASS(BaseListExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(BaseListExpression, NodeKind::BaseListExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents a list of expressions separated by commas
class ListExpression : public BaseListExpression {
 public:
    bool operator==(IR::ListExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ListExpression"_cs; }
    static cstring static_type_name() { return "ListExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ListExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BaseListExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ListExpression(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::Expression> components) :
    BaseListExpression(srcInfo, type, components)
    {
#line 605 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            Vector<Type> tuple;
            for (auto e : components)
                tuple.push_back(e->type);
            type = new Type_List(tuple); } }
#line 6925 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ListExpression(const IR::Type* type, IR::Vector<IR::Expression> components) :
    BaseListExpression(type, components)
    {
#line 605 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            Vector<Type> tuple;
            for (auto e : components)
                tuple.push_back(e->type);
            type = new Type_List(tuple); } }
#line 6938 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ListExpression(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> components) :
    BaseListExpression(srcInfo, components)
    {
#line 605 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            Vector<Type> tuple;
            for (auto e : components)
                tuple.push_back(e->type);
            type = new Type_List(tuple); } }
#line 6951 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ListExpression(IR::Vector<IR::Expression> components) :
    BaseListExpression(components)
    {
#line 605 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            Vector<Type> tuple;
            for (auto e : components)
                tuple.push_back(e->type);
            type = new Type_List(tuple); } }
#line 6964 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(ListExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(ListExpression, NodeKind::ListExpression, BaseListExpression);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents P4 list expression, not to be confused with
/// ListExpression from above.
class P4ListExpression : public BaseListExpression {
 public:
    const IR::Type* elementType = nullptr;
    bool operator==(IR::P4ListExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "P4ListExpression"_cs; }
    static cstring static_type_name() { return "P4ListExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    P4ListExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BaseListExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    P4ListExpression(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::Expression> components, const IR::Type* elementType) :
    BaseListExpression(srcInfo, type, components), elementType(elementType)
    {
#line 618 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            type = new Type_P4List(elementType); } }
#line 6998 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    P4ListExpression(const IR::Type* type, IR::Vector<IR::Expression> components, const IR::Type* elementType) :
    BaseListExpression(type, components), elementType(elementType)
    {
#line 618 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            type = new Type_P4List(elementType); } }
#line 7008 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    P4ListExpression(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> components, const IR::Type* elementType) :
    BaseListExpression(srcInfo, components), elementType(elementType)
    {
#line 618 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            type = new Type_P4List(elementType); } }
#line 7018 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    P4ListExpression(IR::Vector<IR::Expression> components, const IR::Type* elementType) :
    BaseListExpression(components), elementType(elementType)
    {
#line 618 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
{
        validate();
        if (type->is<Type::Unknown>()) {
            type = new Type_P4List(elementType); } }
#line 7028 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(P4ListExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(P4ListExpression, NodeKind::P4ListExpression, BaseListExpression);
};
}  // namespace P4::IR
namespace P4::IR {
/// An expression that evaluates to a struct.
class StructExpression : public Expression {
 public:
/// The struct or header type that is being intialized.
/// May only be known after type checking; so it can be nullptr.
    const IR::Type* structType = nullptr;
    IR::IndexedVector<IR::NamedExpression> components;
#line 630 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 7044 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 636 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    size_t size() const { return components.size(); }
#line 7047 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 637 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    const IR::NamedExpression *getField(cstring name) const {
        return components.getDeclaration<NamedExpression>(name); }
#line 7051 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 639 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool containsDots() const {
        if (components.empty())
            return false;
        size_t size = components.size();
        return components.at(size - 1)->is<IR::NamedDots>();
    }
#line 7059 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 645 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 7062 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::StructExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "StructExpression"_cs; }
    static cstring static_type_name() { return "StructExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    StructExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    StructExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components) :
    Expression(srcInfo, type), structType(structType), components(components)
    { validate(); }
    StructExpression(const IR::Type* type, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components) :
    Expression(type), structType(structType), components(components)
    { validate(); }
    StructExpression(Util::SourceInfo srcInfo, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components) :
    Expression(srcInfo), structType(structType), components(components)
    { validate(); }
    StructExpression(const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components) :
    structType(structType), components(components)
    { validate(); }
    IRNODE_SUBCLASS(StructExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(StructExpression, NodeKind::StructExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// Can be an invalid header or header_union
class Invalid : public Expression {
 public:
    bool operator==(IR::Invalid const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Invalid"_cs; }
    static cstring static_type_name() { return "Invalid"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Invalid(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Invalid(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    Invalid(const IR::Type* type) :
    Expression(type)
    { validate(); }
    Invalid(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    Invalid() 
    { validate(); }
    IRNODE_SUBCLASS(Invalid)
    DECLARE_TYPEINFO_WITH_TYPEID(Invalid, NodeKind::Invalid, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// An expression that evaluates to an invalid header with the specified type.
class InvalidHeader : public Expression {
 public:
    const IR::Type* headerType = nullptr;
    bool operator==(IR::InvalidHeader const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "InvalidHeader"_cs; }
    static cstring static_type_name() { return "InvalidHeader"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    InvalidHeader(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    InvalidHeader(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Type* headerType) :
    Expression(srcInfo, type), headerType(headerType)
    { validate(); }
    InvalidHeader(const IR::Type* type, const IR::Type* headerType) :
    Expression(type), headerType(headerType)
    { validate(); }
    InvalidHeader(Util::SourceInfo srcInfo, const IR::Type* headerType) :
    Expression(srcInfo), headerType(headerType)
    { validate(); }
    InvalidHeader(const IR::Type* headerType) :
    headerType(headerType)
    { validate(); }
    IRNODE_SUBCLASS(InvalidHeader)
    DECLARE_TYPEINFO_WITH_TYPEID(InvalidHeader, NodeKind::InvalidHeader, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// An expression that evaluates to an invalid header union with the specified type.
class InvalidHeaderUnion : public Expression {
 public:
    const IR::Type* headerUnionType = nullptr;
    bool operator==(IR::InvalidHeaderUnion const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "InvalidHeaderUnion"_cs; }
    static cstring static_type_name() { return "InvalidHeaderUnion"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    InvalidHeaderUnion(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    InvalidHeaderUnion(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Type* headerUnionType) :
    Expression(srcInfo, type), headerUnionType(headerUnionType)
    { validate(); }
    InvalidHeaderUnion(const IR::Type* type, const IR::Type* headerUnionType) :
    Expression(type), headerUnionType(headerUnionType)
    { validate(); }
    InvalidHeaderUnion(Util::SourceInfo srcInfo, const IR::Type* headerUnionType) :
    Expression(srcInfo), headerUnionType(headerUnionType)
    { validate(); }
    InvalidHeaderUnion(const IR::Type* headerUnionType) :
    headerUnionType(headerUnionType)
    { validate(); }
    IRNODE_SUBCLASS(InvalidHeaderUnion)
    DECLARE_TYPEINFO_WITH_TYPEID(InvalidHeaderUnion, NodeKind::InvalidHeaderUnion, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// An expression that evaluates to a header stack
class HeaderStackExpression : public BaseListExpression {
 public:
/// May only be known after type checking; so it can be nullptr.
    const IR::Type* headerStackType = nullptr;
#line 674 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 7196 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::HeaderStackExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "HeaderStackExpression"_cs; }
    static cstring static_type_name() { return "HeaderStackExpression"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HeaderStackExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BaseListExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HeaderStackExpression(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::Expression> components, const IR::Type* headerStackType) :
    BaseListExpression(srcInfo, type, components), headerStackType(headerStackType)
    { validate(); }
    HeaderStackExpression(const IR::Type* type, IR::Vector<IR::Expression> components, const IR::Type* headerStackType) :
    BaseListExpression(type, components), headerStackType(headerStackType)
    { validate(); }
    HeaderStackExpression(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> components, const IR::Type* headerStackType) :
    BaseListExpression(srcInfo, components), headerStackType(headerStackType)
    { validate(); }
    HeaderStackExpression(IR::Vector<IR::Expression> components, const IR::Type* headerStackType) :
    BaseListExpression(components), headerStackType(headerStackType)
    { validate(); }
    IRNODE_SUBCLASS(HeaderStackExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(HeaderStackExpression, NodeKind::HeaderStackExpression, BaseListExpression);
};
}  // namespace P4::IR
namespace P4::IR {
/// A ListExpression where all the components are compile-time values.
/// This is used by the evaluator pass.
class ListCompileTimeValue : public Node, public virtual CompileTimeValue {
 public:
    IR::Vector<IR::Node> components;
#line 683 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 7234 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ListCompileTimeValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ListCompileTimeValue"_cs; }
    static cstring static_type_name() { return "ListCompileTimeValue"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ListCompileTimeValue(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ListCompileTimeValue(Util::SourceInfo srcInfo, IR::Vector<IR::Node> components) :
    Node(srcInfo), components(components)
    { validate(); }
    ListCompileTimeValue(IR::Vector<IR::Node> components) :
    components(components)
    { validate(); }
    IRNODE_SUBCLASS(ListCompileTimeValue)
    DECLARE_TYPEINFO_WITH_TYPEID(ListCompileTimeValue, NodeKind::ListCompileTimeValue, Node, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
/// A P4ListExpression where all the components are compile-time values.
/// This is used by the evaluator pass.
class P4ListCompileTimeValue : public Node, public virtual CompileTimeValue {
 public:
    IR::Vector<IR::Node> components;
#line 693 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 7263 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::P4ListCompileTimeValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "P4ListCompileTimeValue"_cs; }
    static cstring static_type_name() { return "P4ListCompileTimeValue"_cs; }
    void toJSON(JSONGenerator & json) const override;
    P4ListCompileTimeValue(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    P4ListCompileTimeValue(Util::SourceInfo srcInfo, IR::Vector<IR::Node> components) :
    Node(srcInfo), components(components)
    { validate(); }
    P4ListCompileTimeValue(IR::Vector<IR::Node> components) :
    components(components)
    { validate(); }
    IRNODE_SUBCLASS(P4ListCompileTimeValue)
    DECLARE_TYPEINFO_WITH_TYPEID(P4ListCompileTimeValue, NodeKind::P4ListCompileTimeValue, Node, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
/// A StructExpression where all the components are compile-time values.
/// This is used by the evaluator pass.
class StructCompileTimeValue : public Node, public virtual CompileTimeValue {
 public:
    IR::Vector<IR::Node> components;
#line 703 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 7292 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::StructCompileTimeValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "StructCompileTimeValue"_cs; }
    static cstring static_type_name() { return "StructCompileTimeValue"_cs; }
    void toJSON(JSONGenerator & json) const override;
    StructCompileTimeValue(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    StructCompileTimeValue(Util::SourceInfo srcInfo, IR::Vector<IR::Node> components) :
    Node(srcInfo), components(components)
    { validate(); }
    StructCompileTimeValue(IR::Vector<IR::Node> components) :
    components(components)
    { validate(); }
    IRNODE_SUBCLASS(StructCompileTimeValue)
    DECLARE_TYPEINFO_WITH_TYPEID(StructCompileTimeValue, NodeKind::StructCompileTimeValue, Node, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
/// Experimental: an extern methond/function call with constant arguments to be
/// evaluated at compile time
class CompileTimeMethodCall : public MethodCallExpression, public virtual CompileTimeValue {
 public:
#line 712 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    CompileTimeMethodCall(const IR::MethodCallExpression* e) : MethodCallExpression(*e) {}
#line 7320 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 713 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void validate() const override;
#line 7323 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::CompileTimeMethodCall const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "CompileTimeMethodCall"_cs; }
    static cstring static_type_name() { return "CompileTimeMethodCall"_cs; }
    void toJSON(JSONGenerator & json) const override;
    CompileTimeMethodCall(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MethodCallExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(srcInfo, type, method, typeArguments, arguments)
    { validate(); }
    CompileTimeMethodCall(const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(type, method, typeArguments, arguments)
    { validate(); }
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(srcInfo, method, typeArguments, arguments)
    { validate(); }
    CompileTimeMethodCall(const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(method, typeArguments, arguments)
    { validate(); }
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(srcInfo, type, method, arguments)
    { validate(); }
    CompileTimeMethodCall(const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(type, method, arguments)
    { validate(); }
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(srcInfo, method, arguments)
    { validate(); }
    CompileTimeMethodCall(const IR::Expression* method, const IR::Vector<IR::Argument>* arguments) :
    MethodCallExpression(method, arguments)
    { validate(); }
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    MethodCallExpression(srcInfo, type, method, typeArguments)
    { validate(); }
    CompileTimeMethodCall(const IR::Type* type, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    MethodCallExpression(type, method, typeArguments)
    { validate(); }
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    MethodCallExpression(srcInfo, method, typeArguments)
    { validate(); }
    CompileTimeMethodCall(const IR::Expression* method, const IR::Vector<IR::Type>* typeArguments) :
    MethodCallExpression(method, typeArguments)
    { validate(); }
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* method) :
    MethodCallExpression(srcInfo, type, method)
    { validate(); }
    CompileTimeMethodCall(const IR::Type* type, const IR::Expression* method) :
    MethodCallExpression(type, method)
    { validate(); }
    CompileTimeMethodCall(Util::SourceInfo srcInfo, const IR::Expression* method) :
    MethodCallExpression(srcInfo, method)
    { validate(); }
    CompileTimeMethodCall(const IR::Expression* method) :
    MethodCallExpression(method)
    { validate(); }
    IRNODE_SUBCLASS(CompileTimeMethodCall)
    DECLARE_TYPEINFO_WITH_TYPEID(CompileTimeMethodCall, NodeKind::CompileTimeMethodCall, MethodCallExpression, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
/// Signifies that a particular expression is a symbolic variable with a label.
/// These variables are intended to be consumed by SMT/SAT solvers.
class SymbolicVariable : public Expression {
 public:
/// The label of the symbolic variable.
    cstring label;
/// A symbolic variable always has a type and no source info.
#line 728 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    SymbolicVariable(const IR::Type* type, cstring label) : Expression(type), label(label) {}
#line 7396 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Implements comparisons so that SymbolicVariables can be used as map keys.
#line 731 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    bool operator<(IR::SymbolicVariable const & other) const {
        return label < other.label;
    }
#line 7402 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 735 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    cstring toString() const override;
#line 7405 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 737 "/builddir/build/BUILD/p4c-1.2.5.8/ir/expression.def"
    void dbprint(std::ostream & out) const override;
#line 7408 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::SymbolicVariable const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "SymbolicVariable"_cs; }
    static cstring static_type_name() { return "SymbolicVariable"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SymbolicVariable(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(SymbolicVariable)
    DECLARE_TYPEINFO_WITH_TYPEID(SymbolicVariable, NodeKind::SymbolicVariable, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/** @} */
/* end group irdefs */
/* -*-C++-*- */
/** \addtogroup irdefs
  * @{
  */
/**
  P4 compiler IR definition file.
  To understand this you really have to understand the shape of the generated IR code.

  The IR builder "knows" the following methods for a class T:

  cstring toString() const override;
  void dbprint(std::ostream &out) const override;
  bool operator==(const T &a) const;
  void validate() const;
  const char *node_type_name() const;
  void visit_children(Visitor &v, const char *name);
  void dump_fields(std::ostream& out) const;

  C comments are ignored.
  C++ line comments can appear in some places and are emitted in the output.

  #emit/#end      -> copy text literally to output header file
  #emit_impl/#end -> copy text literally to output C++ file
  #noXXX          -> do not emit the specified implementation for the XXX method
                     e.g., #noconstructor, #nodbprint, #novisit_children, #nomethod_constructor
  #apply          -> generate apply overload for visitors
  method{ ... }   -> specifies an implementation for a default method
                     method can be 'operator=='

  Some assignments are turned into methods returning constant values:
  stringOp     -> cstring getStringOp() const
  precedence   -> int getPrecedence() const

  When defining fields and methods in an IR class, all fields and arguments of any IR
  class type are automatically converted into const IR::class * fields or arguments, unless
  they are identified as 'inline'.  It is not possible to create a non-const pointer to
  an IR class in any other IR class.

  There are some special keywords that can be applied (as decl modifiers) to fields that
  affect how they are created, checked, and initialized.

  inline      The field (of IR class type) should be defined directly in the object
              rather than being converted to a const T * as described above.
  NullOK      The field is a pointer and may be null (verify will check that it is not otherwise)
  optional    The field may be provided as an argument to the constructor but need not be.
              (overloaded constructors will be created as needed)

  Unless there is a '#noconstructor' tag in the class, a constructor
  will automatically be generated that takes as arguments values to
  initialize all fields of the IR class and its bases that do not have
  explicit initializers. There are some special method constructors which ignore #noconstructor, such as Class(JSONLoader &json). #nomethod_constructor will prevent these files from being generated. Fields marked 'optional' will create multiple constructors both with and without an argument for that field.
 */
class ParserState : public virtual ISimpleNamespace, public Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    IR::IndexedVector<IR::StatOrDecl> components;

    const IR::Expression* selectExpression = nullptr;
#line 63 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 7486 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 64 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 7489 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 65 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 7492 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 67 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::IDeclaration const * getDeclByName(cstring name) const override;
#line 7495 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 69 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::IDeclaration const * getDeclByName(std::string_view name) const override;
#line 7498 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    static const cstring accept;
    static const cstring reject;
    static const cstring start;
    static const cstring verify;
#line 76 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    bool isBuiltin() const { return name == ParserState::accept || name == ParserState::reject; }
#line 7505 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 77 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 7508 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ParserState const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ParserState"_cs; }
    static cstring static_type_name() { return "ParserState"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserState(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserState(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StatOrDecl> components, const IR::Expression* selectExpression) :
    Declaration(srcInfo, name), annotations(annotations), components(components), selectExpression(selectExpression)
    { validate(); }
    ParserState(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StatOrDecl> components, const IR::Expression* selectExpression) :
    Declaration(name), annotations(annotations), components(components), selectExpression(selectExpression)
    { validate(); }
    ParserState(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StatOrDecl> components, const IR::Expression* selectExpression) :
    Declaration(srcInfo, name), components(components), selectExpression(selectExpression)
    { validate(); }
    ParserState(IR::ID name, IR::IndexedVector<IR::StatOrDecl> components, const IR::Expression* selectExpression) :
    Declaration(name), components(components), selectExpression(selectExpression)
    { validate(); }
    ParserState(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Expression* selectExpression) :
    Declaration(srcInfo, name), annotations(annotations), selectExpression(selectExpression)
    { validate(); }
    ParserState(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Expression* selectExpression) :
    Declaration(name), annotations(annotations), selectExpression(selectExpression)
    { validate(); }
    ParserState(Util::SourceInfo srcInfo, IR::ID name, const IR::Expression* selectExpression) :
    Declaration(srcInfo, name), selectExpression(selectExpression)
    { validate(); }
    ParserState(IR::ID name, const IR::Expression* selectExpression) :
    Declaration(name), selectExpression(selectExpression)
    { validate(); }
    IRNODE_SUBCLASS(ParserState)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserState, NodeKind::ParserState, ISimpleNamespace, Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {

class P4Parser : public Type_Declaration, public virtual INestedNamespace, public virtual ISimpleNamespace, public virtual IApply, public virtual IContainer, public virtual IAnnotated {
 public:
    const IR::Type_Parser* type = nullptr;
    const IR::ParameterList* constructorParams = new ParameterList;
    IR::IndexedVector<IR::Declaration> parserLocals;
    IR::IndexedVector<IR::ParserState> states;
#line 92 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 7560 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 93 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 7563 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 94 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::TypeParameters *getTypeParameters() const override;
#line 7566 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 95 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    std::vector<const IR::INamespace *> getNestedNamespaces() const override;
#line 7569 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 97 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 7572 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 99 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 7575 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 103 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 7578 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 108 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type_Method *getApplyMethodType() const override;
#line 7581 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 109 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getApplyParameters() const override;
#line 7584 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 110 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type_Method *getConstructorMethodType() const override;
#line 7587 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 111 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getConstructorParameters() const override;
#line 7590 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 112 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void checkDuplicates() const;
#line 7593 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 113 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type *getType() const override;
#line 7596 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(P4Parser)
#line 115 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 7600 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 124 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 7603 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::P4Parser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "P4Parser"_cs; }
    static cstring static_type_name() { return "P4Parser"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    P4Parser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(srcInfo, name), type(type), constructorParams(constructorParams), parserLocals(parserLocals), states(states)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(name), type(type), constructorParams(constructorParams), parserLocals(parserLocals), states(states)
    { validate(); }
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(srcInfo, name), type(type), parserLocals(parserLocals), states(states)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(name), type(type), parserLocals(parserLocals), states(states)
    { validate(); }
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(srcInfo, name), type(type), constructorParams(constructorParams), states(states)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(name), type(type), constructorParams(constructorParams), states(states)
    { validate(); }
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(srcInfo, name), type(type), states(states)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states) :
    Type_Declaration(name), type(type), states(states)
    { validate(); }
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals) :
    Type_Declaration(srcInfo, name), type(type), constructorParams(constructorParams), parserLocals(parserLocals)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals) :
    Type_Declaration(name), type(type), constructorParams(constructorParams), parserLocals(parserLocals)
    { validate(); }
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals) :
    Type_Declaration(srcInfo, name), type(type), parserLocals(parserLocals)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals) :
    Type_Declaration(name), type(type), parserLocals(parserLocals)
    { validate(); }
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams) :
    Type_Declaration(srcInfo, name), type(type), constructorParams(constructorParams)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams) :
    Type_Declaration(name), type(type), constructorParams(constructorParams)
    { validate(); }
    P4Parser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type) :
    Type_Declaration(srcInfo, name), type(type)
    { validate(); }
    P4Parser(IR::ID name, const IR::Type_Parser* type) :
    Type_Declaration(name), type(type)
    { validate(); }
    IRNODE_SUBCLASS(P4Parser)
    DECLARE_TYPEINFO_WITH_TYPEID(P4Parser, NodeKind::P4Parser, Type_Declaration, INestedNamespace, ISimpleNamespace, IApply, IContainer, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class P4Control : public Type_Declaration, public virtual INestedNamespace, public virtual ISimpleNamespace, public virtual IApply, public virtual IContainer, public virtual IAnnotated {
 public:
    const IR::Type_Control* type = nullptr;
    const IR::ParameterList* constructorParams = new ParameterList;
    IR::IndexedVector<IR::Declaration> controlLocals;
    const IR::BlockStatement* body = nullptr;
#line 133 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 7678 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 134 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 7681 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 135 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::TypeParameters *getTypeParameters() const override;
#line 7684 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 136 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    std::vector<const IR::INamespace *> getNestedNamespaces() const override;
#line 7687 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 138 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 7690 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 140 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type_Method *getApplyMethodType() const override;
#line 7693 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 141 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getApplyParameters() const override;
#line 7696 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 142 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type_Method *getConstructorMethodType() const override;
#line 7699 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 143 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 7702 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 145 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 7705 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 147 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getConstructorParameters() const override;
#line 7708 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 148 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type *getType() const override;
#line 7711 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(P4Control)
#line 150 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 7715 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 155 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 7718 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::P4Control const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "P4Control"_cs; }
    static cstring static_type_name() { return "P4Control"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    P4Control(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    P4Control(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body) :
    Type_Declaration(srcInfo, name), type(type), constructorParams(constructorParams), controlLocals(controlLocals), body(body)
    { validate(); }
    P4Control(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body) :
    Type_Declaration(name), type(type), constructorParams(constructorParams), controlLocals(controlLocals), body(body)
    { validate(); }
    P4Control(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body) :
    Type_Declaration(srcInfo, name), type(type), controlLocals(controlLocals), body(body)
    { validate(); }
    P4Control(IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body) :
    Type_Declaration(name), type(type), controlLocals(controlLocals), body(body)
    { validate(); }
    P4Control(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body) :
    Type_Declaration(srcInfo, name), type(type), constructorParams(constructorParams), body(body)
    { validate(); }
    P4Control(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body) :
    Type_Declaration(name), type(type), constructorParams(constructorParams), body(body)
    { validate(); }
    P4Control(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body) :
    Type_Declaration(srcInfo, name), type(type), body(body)
    { validate(); }
    P4Control(IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body) :
    Type_Declaration(name), type(type), body(body)
    { validate(); }
    IRNODE_SUBCLASS(P4Control)
    DECLARE_TYPEINFO_WITH_TYPEID(P4Control, NodeKind::P4Control, Type_Declaration, INestedNamespace, ISimpleNamespace, IApply, IContainer, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
/// A P4-16 action
class P4Action : public Declaration, public virtual ISimpleNamespace, public virtual IAnnotated, public virtual IFunctional {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::ParameterList* parameters = nullptr;
    const IR::BlockStatement* body = nullptr;
#line 163 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 7769 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 7772 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 167 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 7775 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 169 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 7778 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 170 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 7781 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 171 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getParameters() const override;
#line 7784 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::P4Action const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "P4Action"_cs; }
    static cstring static_type_name() { return "P4Action"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    P4Action(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    P4Action(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* parameters, const IR::BlockStatement* body) :
    Declaration(srcInfo, name), annotations(annotations), parameters(parameters), body(body)
    { validate(); }
    P4Action(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::ParameterList* parameters, const IR::BlockStatement* body) :
    Declaration(name), annotations(annotations), parameters(parameters), body(body)
    { validate(); }
    P4Action(Util::SourceInfo srcInfo, IR::ID name, const IR::ParameterList* parameters, const IR::BlockStatement* body) :
    Declaration(srcInfo, name), parameters(parameters), body(body)
    { validate(); }
    P4Action(IR::ID name, const IR::ParameterList* parameters, const IR::BlockStatement* body) :
    Declaration(name), parameters(parameters), body(body)
    { validate(); }
    IRNODE_SUBCLASS(P4Action)
    DECLARE_TYPEINFO_WITH_TYPEID(P4Action, NodeKind::P4Action, Declaration, ISimpleNamespace, IAnnotated, IFunctional);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Error : public virtual ISimpleNamespace, public Type_Declaration {
 public:
    static const cstring error;
    IR::IndexedVector<IR::Declaration_ID> members;
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 7822 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 179 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 7825 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 181 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 7828 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 183 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 7831 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Error const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Type_Error"_cs; }
    static cstring static_type_name() { return "Type_Error"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_Error(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Error(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::Declaration_ID> members) :
    Type_Declaration(srcInfo, name), members(members)
    { validate(); }
    Type_Error(IR::ID name, IR::IndexedVector<IR::Declaration_ID> members) :
    Type_Declaration(name), members(members)
    { validate(); }
    Type_Error(Util::SourceInfo srcInfo, IR::ID name) :
    Type_Declaration(srcInfo, name)
    { validate(); }
    Type_Error(IR::ID name) :
    Type_Declaration(name)
    { validate(); }
    IRNODE_SUBCLASS(Type_Error)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Error, NodeKind::Type_Error, ISimpleNamespace, Type_Declaration);
};
}  // namespace P4::IR
namespace P4::IR {

class Declaration_MatchKind : public Node, public virtual ISimpleNamespace {
 public:
    IR::IndexedVector<IR::Declaration_ID> members;
#line 189 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 7868 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 191 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 7871 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 193 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 7874 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 195 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 7877 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Declaration_MatchKind const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Declaration_MatchKind"_cs; }
    static cstring static_type_name() { return "Declaration_MatchKind"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Declaration_MatchKind(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Declaration_MatchKind(Util::SourceInfo srcInfo, IR::IndexedVector<IR::Declaration_ID> members) :
    Node(srcInfo), members(members)
    { validate(); }
    Declaration_MatchKind(IR::IndexedVector<IR::Declaration_ID> members) :
    members(members)
    { validate(); }
    Declaration_MatchKind(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    Declaration_MatchKind() 
    { validate(); }
    IRNODE_SUBCLASS(Declaration_MatchKind)
    DECLARE_TYPEINFO_WITH_TYPEID(Declaration_MatchKind, NodeKind::Declaration_MatchKind, Node, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
/// Table property value abstract base class
class PropertyValue : public Node {
 public:
    bool operator==(IR::PropertyValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "PropertyValue"_cs; }
    static cstring static_type_name() { return "PropertyValue"_cs; }
    void toJSON(JSONGenerator & json) const override;
    PropertyValue(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    PropertyValue(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    PropertyValue() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(PropertyValue)
    DECLARE_TYPEINFO_WITH_TYPEID(PropertyValue, NodeKind::PropertyValue, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// A table property whose value is an expression
class ExpressionValue : public PropertyValue {
 public:
    const IR::Expression* expression = nullptr;
#line 204 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 7932 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ExpressionValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ExpressionValue"_cs; }
    static cstring static_type_name() { return "ExpressionValue"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ExpressionValue(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::PropertyValue const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ExpressionValue(Util::SourceInfo srcInfo, const IR::Expression* expression) :
    PropertyValue(srcInfo), expression(expression)
    { validate(); }
    ExpressionValue(const IR::Expression* expression) :
    expression(expression)
    { validate(); }
    IRNODE_SUBCLASS(ExpressionValue)
    DECLARE_TYPEINFO_WITH_TYPEID(ExpressionValue, NodeKind::ExpressionValue, PropertyValue);
};
}  // namespace P4::IR
namespace P4::IR {
class ExpressionListValue : public PropertyValue {
 public:
    IR::Vector<IR::Expression> expressions;
#line 209 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 7961 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ExpressionListValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ExpressionListValue"_cs; }
    static cstring static_type_name() { return "ExpressionListValue"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ExpressionListValue(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::PropertyValue const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ExpressionListValue(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> expressions) :
    PropertyValue(srcInfo), expressions(expressions)
    { validate(); }
    ExpressionListValue(IR::Vector<IR::Expression> expressions) :
    expressions(expressions)
    { validate(); }
    IRNODE_SUBCLASS(ExpressionListValue)
    DECLARE_TYPEINFO_WITH_TYPEID(ExpressionListValue, NodeKind::ExpressionListValue, PropertyValue);
};
}  // namespace P4::IR
namespace P4::IR {

class ActionListElement : public Node, public virtual IAnnotated, public virtual IDeclaration {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Expression* expression = nullptr;

#line 216 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 7993 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 217 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::ID getName() const override;
#line 7996 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 218 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Path *getPath() const;
#line 7999 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 219 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8002 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 220 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8005 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 221 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 8008 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 226 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8011 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ActionListElement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ActionListElement"_cs; }
    static cstring static_type_name() { return "ActionListElement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ActionListElement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ActionListElement(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, const IR::Expression* expression) :
    Node(srcInfo), annotations(annotations), expression(expression)
    { validate(); }
    ActionListElement(IR::Vector<IR::Annotation> annotations, const IR::Expression* expression) :
    annotations(annotations), expression(expression)
    { validate(); }
    ActionListElement(Util::SourceInfo srcInfo, const IR::Expression* expression) :
    Node(srcInfo), expression(expression)
    { validate(); }
    ActionListElement(const IR::Expression* expression) :
    expression(expression)
    { validate(); }
    IRNODE_SUBCLASS(ActionListElement)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionListElement, NodeKind::ActionListElement, Node, IAnnotated, IDeclaration);
};
}  // namespace P4::IR
namespace P4::IR {

class ActionList : public PropertyValue {
 public:
    IR::IndexedVector<IR::ActionListElement> actionList;
#line 232 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 8045 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 233 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    size_t size() const { return actionList.size(); }
#line 8048 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 234 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void push_back(const IR::ActionListElement* e) { actionList.push_back(e); }
#line 8051 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 235 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ActionListElement *getDeclaration(cstring n) const {
        return actionList.getDeclaration<ActionListElement>(n); }
#line 8055 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ActionList const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ActionList"_cs; }
    static cstring static_type_name() { return "ActionList"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ActionList(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::PropertyValue const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ActionList(Util::SourceInfo srcInfo, IR::IndexedVector<IR::ActionListElement> actionList) :
    PropertyValue(srcInfo), actionList(actionList)
    { validate(); }
    ActionList(IR::IndexedVector<IR::ActionListElement> actionList) :
    actionList(actionList)
    { validate(); }
    IRNODE_SUBCLASS(ActionList)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionList, NodeKind::ActionList, PropertyValue);
};
}  // namespace P4::IR
namespace P4::IR {
class KeyElement : public Node, public virtual IAnnotated {
 public:
    const IR::Expression* expression = nullptr;
    const IR::PathExpression* matchType = nullptr;
    IR::Vector<IR::Annotation> annotations;
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8086 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 245 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8089 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 246 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Node const * transform_visit(Transform & v);
#line 8092 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::KeyElement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "KeyElement"_cs; }
    static cstring static_type_name() { return "KeyElement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    KeyElement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    KeyElement(Util::SourceInfo srcInfo, const IR::Expression* expression, const IR::PathExpression* matchType, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), expression(expression), matchType(matchType), annotations(annotations)
    { validate(); }
    KeyElement(const IR::Expression* expression, const IR::PathExpression* matchType, IR::Vector<IR::Annotation> annotations) :
    expression(expression), matchType(matchType), annotations(annotations)
    { validate(); }
    KeyElement(Util::SourceInfo srcInfo, const IR::Expression* expression, const IR::PathExpression* matchType) :
    Node(srcInfo), expression(expression), matchType(matchType)
    { validate(); }
    KeyElement(const IR::Expression* expression, const IR::PathExpression* matchType) :
    expression(expression), matchType(matchType)
    { validate(); }
    IRNODE_SUBCLASS(KeyElement)
    DECLARE_TYPEINFO_WITH_TYPEID(KeyElement, NodeKind::KeyElement, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {

class Key : public PropertyValue {
 public:
    IR::Vector<IR::KeyElement> keyElements;
#line 269 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 8128 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 270 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void push_back(const IR::KeyElement* ke) { keyElements.push_back(ke); }
#line 8131 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Key const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Key"_cs; }
    static cstring static_type_name() { return "Key"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Key(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::PropertyValue const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Key(Util::SourceInfo srcInfo, IR::Vector<IR::KeyElement> keyElements) :
    PropertyValue(srcInfo), keyElements(keyElements)
    { validate(); }
    Key(IR::Vector<IR::KeyElement> keyElements) :
    keyElements(keyElements)
    { validate(); }
    IRNODE_SUBCLASS(Key)
    DECLARE_TYPEINFO_WITH_TYPEID(Key, NodeKind::Key, PropertyValue);
};
}  // namespace P4::IR
namespace P4::IR {
/// Pre-defined entry in a table
class Entry : public Node, public virtual IAnnotated {
 public:
/// annotations are optional (supported annotations: @priority(value))
    IR::Vector<IR::Annotation> annotations;
    bool isConst;
/// optional const annotation
    const IR::Expression* priority = nullptr;
/// optional entry priority
    const IR::ListExpression* keys = nullptr;
/// must be a tuple expression
    const IR::Expression* action = nullptr;
/// typically a MethodCallExpression.
/// The action must be defined in action list
    bool singleton;
/// True if the entry is not a list.
#line 284 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8173 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 285 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8176 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 286 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ListExpression *getKeys() const { return keys; }
#line 8179 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 287 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Expression *getAction() const { return action; }
#line 8182 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 288 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8185 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Entry const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Entry"_cs; }
    static cstring static_type_name() { return "Entry"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Entry(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Entry(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, bool isConst, const IR::Expression* priority, const IR::ListExpression* keys, const IR::Expression* action, bool singleton) :
    Node(srcInfo), annotations(annotations), isConst(isConst), priority(priority), keys(keys), action(action), singleton(singleton)
    { validate(); }
    Entry(IR::Vector<IR::Annotation> annotations, bool isConst, const IR::Expression* priority, const IR::ListExpression* keys, const IR::Expression* action, bool singleton) :
    annotations(annotations), isConst(isConst), priority(priority), keys(keys), action(action), singleton(singleton)
    { validate(); }
    Entry(Util::SourceInfo srcInfo, bool isConst, const IR::Expression* priority, const IR::ListExpression* keys, const IR::Expression* action, bool singleton) :
    Node(srcInfo), isConst(isConst), priority(priority), keys(keys), action(action), singleton(singleton)
    { validate(); }
    Entry(bool isConst, const IR::Expression* priority, const IR::ListExpression* keys, const IR::Expression* action, bool singleton) :
    isConst(isConst), priority(priority), keys(keys), action(action), singleton(singleton)
    { validate(); }
    IRNODE_SUBCLASS(Entry)
    DECLARE_TYPEINFO_WITH_TYPEID(Entry, NodeKind::Entry, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
/// List of predefined entries. Part of table properties
class EntriesList : public PropertyValue {
 public:
    IR::Vector<IR::Entry> entries;
#line 294 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    size_t size() const { return entries.size(); }
#line 8221 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 295 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8224 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::EntriesList const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "EntriesList"_cs; }
    static cstring static_type_name() { return "EntriesList"_cs; }
    void toJSON(JSONGenerator & json) const override;
    EntriesList(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::PropertyValue const & a) const override;
    bool operator==(IR::Node const & a) const override;
    EntriesList(Util::SourceInfo srcInfo, IR::Vector<IR::Entry> entries) :
    PropertyValue(srcInfo), entries(entries)
    { validate(); }
    EntriesList(IR::Vector<IR::Entry> entries) :
    entries(entries)
    { validate(); }
    IRNODE_SUBCLASS(EntriesList)
    DECLARE_TYPEINFO_WITH_TYPEID(EntriesList, NodeKind::EntriesList, PropertyValue);
};
}  // namespace P4::IR
namespace P4::IR {
class Property : public Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::PropertyValue* value = nullptr;
    bool isConstant;
#line 302 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8255 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 303 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8258 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 304 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8261 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Property const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Property"_cs; }
    static cstring static_type_name() { return "Property"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Property(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Property(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::PropertyValue* value, bool isConstant) :
    Declaration(srcInfo, name), annotations(annotations), value(value), isConstant(isConstant)
    { validate(); }
    Property(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::PropertyValue* value, bool isConstant) :
    Declaration(name), annotations(annotations), value(value), isConstant(isConstant)
    { validate(); }
    Property(Util::SourceInfo srcInfo, IR::ID name, const IR::PropertyValue* value, bool isConstant) :
    Declaration(srcInfo, name), value(value), isConstant(isConstant)
    { validate(); }
    Property(IR::ID name, const IR::PropertyValue* value, bool isConstant) :
    Declaration(name), value(value), isConstant(isConstant)
    { validate(); }
    IRNODE_SUBCLASS(Property)
    DECLARE_TYPEINFO_WITH_TYPEID(Property, NodeKind::Property, Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class TableProperties : public Node, public virtual ISimpleNamespace {
 public:
    IR::IndexedVector<IR::Property> properties;
#line 309 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8298 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 310 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 8301 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 312 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Property *getProperty(cstring name) const {
        return properties.getDeclaration<Property>(name); }
#line 8305 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 314 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 8308 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 316 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Property *getProperty(std::string_view name) const {
        return properties.getDeclaration<Property>(name); }
#line 8312 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 318 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 8315 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 320 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void push_back(const IR::Property* prop) { properties.push_back(prop); }
#line 8318 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    static const cstring actionsPropertyName;
    static const cstring keyPropertyName;
    static const cstring defaultActionPropertyName;
    static const cstring entriesPropertyName;
    static const cstring sizePropertyName;
#line 328 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 8326 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TableProperties const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "TableProperties"_cs; }
    static cstring static_type_name() { return "TableProperties"_cs; }
    void toJSON(JSONGenerator & json) const override;
    TableProperties(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TableProperties(Util::SourceInfo srcInfo, IR::IndexedVector<IR::Property> properties) :
    Node(srcInfo), properties(properties)
    { validate(); }
    TableProperties(IR::IndexedVector<IR::Property> properties) :
    properties(properties)
    { validate(); }
    TableProperties(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    TableProperties() 
    { validate(); }
    IRNODE_SUBCLASS(TableProperties)
    DECLARE_TYPEINFO_WITH_TYPEID(TableProperties, NodeKind::TableProperties, Node, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
class P4Table : public Declaration, public virtual IAnnotated, public virtual IApply {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::TableProperties* properties = nullptr;
#line 335 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8359 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 336 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8362 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 337 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type_Method *getApplyMethodType() const override;
#line 8365 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 338 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getApplyParameters() const override;
#line 8368 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 339 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ActionList *getActionList() const {
        if (auto ap = properties->getProperty(TableProperties::actionsPropertyName)) {
            if (auto al = ap->value->to<IR::ActionList>()) return al;
            ::P4::error(ErrorType::ERR_INVALID, "%1%: must be an action list", ap);
        }
        return nullptr;
    }
#line 8377 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 346 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Key *getKey() const {
        if (auto kp = properties->getProperty(TableProperties::keyPropertyName)) {
            if (auto k = kp->value->to<IR::Key>()) return k;
            ::P4::error(ErrorType::ERR_INVALID, "%1%: must be a key", kp);
        }
        return nullptr;
    }
#line 8386 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 353 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Expression *getDefaultAction() const {
        if (auto d = properties->getProperty(TableProperties::defaultActionPropertyName)) {
            if (auto ev = d->value->to<IR::ExpressionValue>()) return ev->expression;
            ::P4::error(ErrorType::ERR_INVALID, "%1%: must be an expression", d);
        }
        return nullptr;
    }
#line 8395 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 360 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Constant *getConstantProperty(cstring name) const {
        if (auto d = properties->getProperty(name)) {
            if (auto ev = d->value->to<IR::ExpressionValue>()) {
                if (auto k = ev->expression->to<IR::Constant>()) {
                    return k; } }
            error(ErrorType::ERR_INVALID, "%1% must be a constant numeric expression", d); }
        return nullptr; }
#line 8404 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 367 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::BoolLiteral *getBooleanProperty(cstring name) const {
        if (auto d = properties->getProperty(name)) {
            if (auto ev = d->value->to<IR::ExpressionValue>()) {
                if (auto k = ev->expression->to<IR::BoolLiteral>()) {
                    return k; } }
            error(ErrorType::ERR_INVALID, "%1% must be a boolean expression", d); }
        return nullptr; }
#line 8413 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 374 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Constant *getSizeProperty() const {
        return getConstantProperty(TableProperties::sizePropertyName);
    }
#line 8418 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 377 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::EntriesList *getEntries() const {
        if (auto ep = properties->getProperty(TableProperties::entriesPropertyName)) {
            if (auto el = ep->value->to<IR::EntriesList>()) return el;
            ::P4::error(ErrorType::ERR_INVALID, "%1%: must be a list of entries", ep);
        }
        return nullptr;
    }
#line 8427 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::P4Table const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "P4Table"_cs; }
    static cstring static_type_name() { return "P4Table"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    P4Table(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    P4Table(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TableProperties* properties) :
    Declaration(srcInfo, name), annotations(annotations), properties(properties)
    { validate(); }
    P4Table(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TableProperties* properties) :
    Declaration(name), annotations(annotations), properties(properties)
    { validate(); }
    P4Table(Util::SourceInfo srcInfo, IR::ID name, const IR::TableProperties* properties) :
    Declaration(srcInfo, name), properties(properties)
    { validate(); }
    P4Table(IR::ID name, const IR::TableProperties* properties) :
    Declaration(name), properties(properties)
    { validate(); }
    IRNODE_SUBCLASS(P4Table)
    DECLARE_TYPEINFO_WITH_TYPEID(P4Table, NodeKind::P4Table, Declaration, IAnnotated, IApply);
};
}  // namespace P4::IR
namespace P4::IR {
class P4ValueSet : public Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* elementType = nullptr;
    const IR::Expression* size = nullptr;

#line 390 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8467 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 391 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8470 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::P4ValueSet const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "P4ValueSet"_cs; }
    static cstring static_type_name() { return "P4ValueSet"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    P4ValueSet(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    P4ValueSet(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* elementType, const IR::Expression* size) :
    Declaration(srcInfo, name), annotations(annotations), elementType(elementType), size(size)
    { validate(); }
    P4ValueSet(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* elementType, const IR::Expression* size) :
    Declaration(name), annotations(annotations), elementType(elementType), size(size)
    { validate(); }
    P4ValueSet(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* elementType, const IR::Expression* size) :
    Declaration(srcInfo, name), elementType(elementType), size(size)
    { validate(); }
    P4ValueSet(IR::ID name, const IR::Type* elementType, const IR::Expression* size) :
    Declaration(name), elementType(elementType), size(size)
    { validate(); }
    IRNODE_SUBCLASS(P4ValueSet)
    DECLARE_TYPEINFO_WITH_TYPEID(P4ValueSet, NodeKind::P4ValueSet, Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class Declaration_Variable : public Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* type = nullptr;
    const IR::Expression* initializer = nullptr;
#line 399 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8509 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 400 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8512 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 401 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8515 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Declaration_Variable const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Declaration_Variable"_cs; }
    static cstring static_type_name() { return "Declaration_Variable"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Declaration_Variable(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Declaration_Variable(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(srcInfo, name), annotations(annotations), type(type), initializer(initializer)
    { validate(); }
    Declaration_Variable(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(name), annotations(annotations), type(type), initializer(initializer)
    { validate(); }
    Declaration_Variable(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(srcInfo, name), type(type), initializer(initializer)
    { validate(); }
    Declaration_Variable(IR::ID name, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(name), type(type), initializer(initializer)
    { validate(); }
    Declaration_Variable(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Declaration(srcInfo, name), annotations(annotations), type(type)
    { validate(); }
    Declaration_Variable(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type) :
    Declaration(name), annotations(annotations), type(type)
    { validate(); }
    Declaration_Variable(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type) :
    Declaration(srcInfo, name), type(type)
    { validate(); }
    Declaration_Variable(IR::ID name, const IR::Type* type) :
    Declaration(name), type(type)
    { validate(); }
    IRNODE_SUBCLASS(Declaration_Variable)
    DECLARE_TYPEINFO_WITH_TYPEID(Declaration_Variable, NodeKind::Declaration_Variable, Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class Declaration_Constant : public Declaration, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* type = nullptr;
    const IR::Expression* initializer = nullptr;
#line 411 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8565 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 412 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8568 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 413 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8571 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 414 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8574 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Declaration_Constant const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Declaration_Constant"_cs; }
    static cstring static_type_name() { return "Declaration_Constant"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Declaration_Constant(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Declaration_Constant(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(srcInfo, name), annotations(annotations), type(type), initializer(initializer)
    { validate(); }
    Declaration_Constant(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(name), annotations(annotations), type(type), initializer(initializer)
    { validate(); }
    Declaration_Constant(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(srcInfo, name), type(type), initializer(initializer)
    { validate(); }
    Declaration_Constant(IR::ID name, const IR::Type* type, const IR::Expression* initializer) :
    Declaration(name), type(type), initializer(initializer)
    { validate(); }
    IRNODE_SUBCLASS(Declaration_Constant)
    DECLARE_TYPEINFO_WITH_TYPEID(Declaration_Constant, NodeKind::Declaration_Constant, Declaration, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
/// Like a variable, but for a statically allocated instance.
/// The syntax is Contructor(args) name = initializer;
/// Initializers are an experimental features, used for externs with
/// abstract methods.
class Declaration_Instance : public Declaration, public virtual IAnnotated, public virtual IInstance {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type* type = nullptr;

    const IR::Vector<IR::Argument>* arguments = nullptr;
    IR::NameMap<IR::Property> properties = {};

    const IR::BlockStatement* initializer = nullptr;

#line 429 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8621 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 430 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8624 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 431 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::Type *getType() const override;
#line 8627 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 432 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::ID Name() const override;
#line 8630 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 433 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 8633 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Declaration_Instance const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Declaration_Instance"_cs; }
    static cstring static_type_name() { return "Declaration_Instance"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Declaration_Instance(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Declaration_Instance(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration(srcInfo, name), annotations(annotations), type(type), arguments(arguments), initializer(initializer)
    { validate(); }
    Declaration_Instance(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration(name), annotations(annotations), type(type), arguments(arguments), initializer(initializer)
    { validate(); }
    Declaration_Instance(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration(srcInfo, name), type(type), arguments(arguments), initializer(initializer)
    { validate(); }
    Declaration_Instance(IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration(name), type(type), arguments(arguments), initializer(initializer)
    { validate(); }
    Declaration_Instance(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration(srcInfo, name), annotations(annotations), type(type), arguments(arguments)
    { validate(); }
    Declaration_Instance(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration(name), annotations(annotations), type(type), arguments(arguments)
    { validate(); }
    Declaration_Instance(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration(srcInfo, name), type(type), arguments(arguments)
    { validate(); }
    Declaration_Instance(IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration(name), type(type), arguments(arguments)
    { validate(); }
    IRNODE_SUBCLASS(Declaration_Instance)
    DECLARE_TYPEINFO_WITH_TYPEID(Declaration_Instance, NodeKind::Declaration_Instance, Declaration, IAnnotated, IInstance);
};
}  // namespace P4::IR
namespace P4::IR {
/// Toplevel program representation
class P4Program : public Node, public virtual IGeneralNamespace {
 public:
/// Top-level program objects.
/// This is not an IndexedVector because:
/// - we allow overloaded function-like objects.
/// - not all objects in a P4Program are declarations (e.g., match_kind is not).
    IR::Vector<IR::Node> objects;
#line 443 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 8686 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 444 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 8689 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    static const cstring main;
    IRNODE_DECLARE_APPLY_OVERLOAD(P4Program)
    bool operator==(IR::P4Program const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "P4Program"_cs; }
    static cstring static_type_name() { return "P4Program"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    P4Program(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    P4Program(Util::SourceInfo srcInfo, IR::Vector<IR::Node> objects) :
    Node(srcInfo), objects(objects)
    { validate(); }
    P4Program(IR::Vector<IR::Node> objects) :
    objects(objects)
    { validate(); }
    P4Program(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    P4Program() 
    { validate(); }
    IRNODE_SUBCLASS(P4Program)
    DECLARE_TYPEINFO_WITH_TYPEID(P4Program, NodeKind::P4Program, Node, IGeneralNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
class ExitStatement : public Statement {
 public:
#line 456 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8723 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 457 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8726 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ExitStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ExitStatement"_cs; }
    static cstring static_type_name() { return "ExitStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ExitStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ExitStatement(Util::SourceInfo srcInfo) :
    Statement(srcInfo)
    { validate(); }
    ExitStatement() 
    { validate(); }
    IRNODE_SUBCLASS(ExitStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(ExitStatement, NodeKind::ExitStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class ReturnStatement : public Statement {
 public:
    const IR::Expression* expression = nullptr;
#line 462 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8752 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ReturnStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ReturnStatement"_cs; }
    static cstring static_type_name() { return "ReturnStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ReturnStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ReturnStatement(Util::SourceInfo srcInfo, const IR::Expression* expression) :
    Statement(srcInfo), expression(expression)
    { validate(); }
    ReturnStatement(const IR::Expression* expression) :
    expression(expression)
    { validate(); }
    IRNODE_SUBCLASS(ReturnStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(ReturnStatement, NodeKind::ReturnStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class EmptyStatement : public Statement {
 public:
#line 468 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8781 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::EmptyStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "EmptyStatement"_cs; }
    static cstring static_type_name() { return "EmptyStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    EmptyStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    EmptyStatement(Util::SourceInfo srcInfo) :
    Statement(srcInfo)
    { validate(); }
    EmptyStatement() 
    { validate(); }
    IRNODE_SUBCLASS(EmptyStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(EmptyStatement, NodeKind::EmptyStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class AssignmentStatement : public BaseAssignmentStatement {
 public:
#line 477 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8806 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::AssignmentStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "AssignmentStatement"_cs; }
    static cstring static_type_name() { return "AssignmentStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AssignmentStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BaseAssignmentStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AssignmentStatement(Util::SourceInfo srcInfo, const IR::Expression* left, const IR::Expression* right) :
    BaseAssignmentStatement(srcInfo, left, right)
    { validate(); }
    AssignmentStatement(const IR::Expression* left, const IR::Expression* right) :
    BaseAssignmentStatement(left, right)
    { validate(); }
    IRNODE_SUBCLASS(AssignmentStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(AssignmentStatement, NodeKind::AssignmentStatement, BaseAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class IfStatement : public Statement {
 public:
    const IR::Expression* condition = nullptr;
    const IR::Statement* ifTrue = nullptr;
    const IR::Statement* ifFalse = nullptr;
#line 490 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 8838 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::IfStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "IfStatement"_cs; }
    static cstring static_type_name() { return "IfStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    IfStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IfStatement(Util::SourceInfo srcInfo, const IR::Expression* condition, const IR::Statement* ifTrue, const IR::Statement* ifFalse) :
    Statement(srcInfo), condition(condition), ifTrue(ifTrue), ifFalse(ifFalse)
    { validate(); }
    IfStatement(const IR::Expression* condition, const IR::Statement* ifTrue, const IR::Statement* ifFalse) :
    condition(condition), ifTrue(ifTrue), ifFalse(ifFalse)
    { validate(); }
    IRNODE_SUBCLASS(IfStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(IfStatement, NodeKind::IfStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class BreakStatement : public Statement {
 public:
#line 497 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8866 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 498 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8869 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 499 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 8873 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

    bool operator==(IR::BreakStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BreakStatement"_cs; }
    static cstring static_type_name() { return "BreakStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    BreakStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BreakStatement(Util::SourceInfo srcInfo) :
    Statement(srcInfo)
    { validate(); }
    BreakStatement() 
    { validate(); }
    IRNODE_SUBCLASS(BreakStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(BreakStatement, NodeKind::BreakStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class ContinueStatement : public Statement {
 public:
#line 503 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 8899 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 504 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void dbprint(std::ostream & out) const override;
#line 8902 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 505 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 8906 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

    bool operator==(IR::ContinueStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ContinueStatement"_cs; }
    static cstring static_type_name() { return "ContinueStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ContinueStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ContinueStatement(Util::SourceInfo srcInfo) :
    Statement(srcInfo)
    { validate(); }
    ContinueStatement() 
    { validate(); }
    IRNODE_SUBCLASS(ContinueStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(ContinueStatement, NodeKind::ContinueStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class BlockStatement : public Statement, public virtual ISimpleNamespace, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    IR::IndexedVector<IR::StatOrDecl> components;
#line 511 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 8934 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 513 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 8937 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 515 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 8940 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 517 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void push_back(const IR::StatOrDecl* st);
#line 8943 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 518 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 8946 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 519 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 8949 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 520 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    bool empty() const { return components.empty(); }
#line 8952 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 521 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void append(const IR::StatOrDecl* stmt);
#line 8955 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 522 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    BlockStatement(std::initializer_list<const IR::StatOrDecl *> il) { for (auto el : il) append(el); }
#line 8958 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BlockStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BlockStatement"_cs; }
    static cstring static_type_name() { return "BlockStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    BlockStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    BlockStatement(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StatOrDecl> components) :
    Statement(srcInfo), annotations(annotations), components(components)
    { validate(); }
    BlockStatement(IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StatOrDecl> components) :
    annotations(annotations), components(components)
    { validate(); }
    BlockStatement(Util::SourceInfo srcInfo, IR::IndexedVector<IR::StatOrDecl> components) :
    Statement(srcInfo), components(components)
    { validate(); }
    BlockStatement(IR::IndexedVector<IR::StatOrDecl> components) :
    components(components)
    { validate(); }
    BlockStatement(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Statement(srcInfo), annotations(annotations)
    { validate(); }
    BlockStatement(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    BlockStatement(Util::SourceInfo srcInfo) :
    Statement(srcInfo)
    { validate(); }
    BlockStatement() 
    { validate(); }
    IRNODE_SUBCLASS(BlockStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(BlockStatement, NodeKind::BlockStatement, Statement, ISimpleNamespace, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class MethodCallStatement : public Statement {
 public:
    const IR::MethodCallExpression* methodCall = nullptr;
#line 528 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    MethodCallStatement(Util::SourceInfo si, IR::ID m, std::initializer_list<const IR::Argument *> const & a) : Statement(si), methodCall(new MethodCallExpression(si, m, a)) {}
#line 9006 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 530 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    MethodCallStatement(Util::SourceInfo si, const IR::Expression* m, std::initializer_list<const IR::Argument *> const & a) : Statement(si), methodCall(new MethodCallExpression(si, m, a)) {}
#line 9009 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 533 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 9012 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MethodCallStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MethodCallStatement"_cs; }
    static cstring static_type_name() { return "MethodCallStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    MethodCallStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    MethodCallStatement(Util::SourceInfo srcInfo, const IR::MethodCallExpression* methodCall) :
    Statement(srcInfo), methodCall(methodCall)
    {
#line 527 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
{ if (!srcInfo) srcInfo = methodCall->srcInfo; }
#line 9032 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    MethodCallStatement(const IR::MethodCallExpression* methodCall) :
    methodCall(methodCall)
    {
#line 527 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
{ if (!srcInfo) srcInfo = methodCall->srcInfo; }
#line 9039 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(MethodCallStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(MethodCallStatement, NodeKind::MethodCallStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {
class SwitchCase : public Node {
 public:
    const IR::Expression* label = nullptr;
    const IR::Statement* statement = nullptr;

#line 540 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 9053 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::SwitchCase const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "SwitchCase"_cs; }
    static cstring static_type_name() { return "SwitchCase"_cs; }
    void toJSON(JSONGenerator & json) const override;
    SwitchCase(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    SwitchCase(Util::SourceInfo srcInfo, const IR::Expression* label, const IR::Statement* statement) :
    Node(srcInfo), label(label), statement(statement)
    { validate(); }
    SwitchCase(const IR::Expression* label, const IR::Statement* statement) :
    label(label), statement(statement)
    { validate(); }
    IRNODE_SUBCLASS(SwitchCase)
    DECLARE_TYPEINFO_WITH_TYPEID(SwitchCase, NodeKind::SwitchCase, Node);
};
}  // namespace P4::IR
namespace P4::IR {

class SwitchStatement : public Statement {
 public:
    const IR::Expression* expression = nullptr;
    IR::Vector<IR::SwitchCase> cases;
#line 552 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 9083 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::SwitchStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "SwitchStatement"_cs; }
    static cstring static_type_name() { return "SwitchStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SwitchStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SwitchStatement(Util::SourceInfo srcInfo, const IR::Expression* expression, IR::Vector<IR::SwitchCase> cases) :
    Statement(srcInfo), expression(expression), cases(cases)
    { validate(); }
    SwitchStatement(const IR::Expression* expression, IR::Vector<IR::SwitchCase> cases) :
    expression(expression), cases(cases)
    { validate(); }
    IRNODE_SUBCLASS(SwitchStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(SwitchStatement, NodeKind::SwitchStatement, Statement);
};
}  // namespace P4::IR
namespace P4::IR {

class LoopStatement : public Statement, public virtual ISimpleNamespace, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
#line 563 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 9113 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 564 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 9116 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::LoopStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "LoopStatement"_cs; }
    static cstring static_type_name() { return "LoopStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoopStatement(JSONLoader & json);
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    LoopStatement(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Statement(srcInfo), annotations(annotations)
    { validate(); }
    LoopStatement(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    LoopStatement(Util::SourceInfo srcInfo) :
    Statement(srcInfo)
    { validate(); }
    LoopStatement() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(LoopStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(LoopStatement, NodeKind::LoopStatement, Statement, ISimpleNamespace, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class ForStatement : public LoopStatement {
 public:
    IR::IndexedVector<IR::StatOrDecl> init;
    const IR::Expression* condition = nullptr;
    IR::IndexedVector<IR::StatOrDecl> updates;
    const IR::Statement* body = nullptr;
#line 572 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 9154 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 574 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 9157 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 576 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 9160 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 578 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 9164 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 580 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    // template single implementation of const vs non-const ForStatement
    template<class THIS> static void visit_children(THIS *, Visitor &v);
#line 9168 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ForStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ForStatement"_cs; }
    static cstring static_type_name() { return "ForStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ForStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::LoopStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ForStatement(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StatOrDecl> init, const IR::Expression* condition, IR::IndexedVector<IR::StatOrDecl> updates, const IR::Statement* body) :
    LoopStatement(srcInfo, annotations), init(init), condition(condition), updates(updates), body(body)
    { validate(); }
    ForStatement(IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StatOrDecl> init, const IR::Expression* condition, IR::IndexedVector<IR::StatOrDecl> updates, const IR::Statement* body) :
    LoopStatement(annotations), init(init), condition(condition), updates(updates), body(body)
    { validate(); }
    ForStatement(Util::SourceInfo srcInfo, IR::IndexedVector<IR::StatOrDecl> init, const IR::Expression* condition, IR::IndexedVector<IR::StatOrDecl> updates, const IR::Statement* body) :
    LoopStatement(srcInfo), init(init), condition(condition), updates(updates), body(body)
    { validate(); }
    ForStatement(IR::IndexedVector<IR::StatOrDecl> init, const IR::Expression* condition, IR::IndexedVector<IR::StatOrDecl> updates, const IR::Statement* body) :
    init(init), condition(condition), updates(updates), body(body)
    { validate(); }
    IRNODE_SUBCLASS(ForStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(ForStatement, NodeKind::ForStatement, LoopStatement);
};
}  // namespace P4::IR
namespace P4::IR {

class ForInStatement : public LoopStatement {
 public:
    const IR::Declaration_Variable* decl = nullptr;


    const IR::PathExpression* ref = nullptr;
    const IR::Expression* collection = nullptr;
    const IR::Statement* body = nullptr;
#line 594 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    ForInStatement(Util::SourceInfo si, const IR::Vector<IR::Annotation>* a, const IR::PathExpression* pe, const IR::Expression* c, const IR::Statement* b);
#line 9210 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 596 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 9213 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 598 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 9216 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 600 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 9219 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 603 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 9223 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 605 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    // template single implementation of const vs non-const ForInStatement
    template<class THIS> static void visit_children(THIS *, Visitor &v);
#line 9227 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ForInStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ForInStatement"_cs; }
    static cstring static_type_name() { return "ForInStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ForInStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::LoopStatement const & a) const override;
    bool operator==(IR::Statement const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ForInStatement(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, const IR::Declaration_Variable* decl, const IR::Expression* collection, const IR::Statement* body) :
    LoopStatement(srcInfo, annotations), decl(decl), collection(collection), body(body)
    {
#line 593 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
{ ref = new PathExpression(decl->name); }
#line 9246 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ForInStatement(IR::Vector<IR::Annotation> annotations, const IR::Declaration_Variable* decl, const IR::Expression* collection, const IR::Statement* body) :
    LoopStatement(annotations), decl(decl), collection(collection), body(body)
    {
#line 593 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
{ ref = new PathExpression(decl->name); }
#line 9253 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ForInStatement(Util::SourceInfo srcInfo, const IR::Declaration_Variable* decl, const IR::Expression* collection, const IR::Statement* body) :
    LoopStatement(srcInfo), decl(decl), collection(collection), body(body)
    {
#line 593 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
{ ref = new PathExpression(decl->name); }
#line 9260 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ForInStatement(const IR::Declaration_Variable* decl, const IR::Expression* collection, const IR::Statement* body) :
    decl(decl), collection(collection), body(body)
    {
#line 593 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
{ ref = new PathExpression(decl->name); }
#line 9267 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(ForInStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(ForInStatement, NodeKind::ForInStatement, LoopStatement);
};
}  // namespace P4::IR
namespace P4::IR {
/////////////////////////////////////////////////////////////
class Function : public Declaration, public virtual IFunctional, public virtual IAnnotated, public virtual ISimpleNamespace, public virtual INestedNamespace {
 public:
    IR::Vector<IR::Annotation> annotations;
    const IR::Type_Method* type = nullptr;
    const IR::BlockStatement* body = nullptr;
#line 616 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getParameters() const override;
#line 9282 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 619 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 9285 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 621 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 9288 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 623 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 9291 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 625 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    std::vector<const IR::INamespace *> getNestedNamespaces() const override;
#line 9294 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 627 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 9297 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 628 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 9300 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Function const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Function"_cs; }
    static cstring static_type_name() { return "Function"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Function(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Function(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type_Method* type, const IR::BlockStatement* body) :
    Declaration(srcInfo, name), annotations(annotations), type(type), body(body)
    { validate(); }
    Function(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type_Method* type, const IR::BlockStatement* body) :
    Declaration(name), annotations(annotations), type(type), body(body)
    { validate(); }
    Function(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Method* type, const IR::BlockStatement* body) :
    Declaration(srcInfo, name), type(type), body(body)
    { validate(); }
    Function(IR::ID name, const IR::Type_Method* type, const IR::BlockStatement* body) :
    Declaration(name), type(type), body(body)
    { validate(); }
    IRNODE_SUBCLASS(Function)
    DECLARE_TYPEINFO_WITH_TYPEID(Function, NodeKind::Function, Declaration, IFunctional, IAnnotated, ISimpleNamespace, INestedNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
/////////////////////////////////////////////////////////////
/**
 * Block is the base class for IR nodes produced by the evaluator.
 * A block represents a compile-time allocated resource.
 * Blocks are not visited using visitors, so the visit_children()
 * method is empty.  Users have to write custom visitors to
 * traverse the constantValue map.
 */
class Block : public Node, public virtual CompileTimeValue {
 public:
    const IR::Node* node = nullptr;
/// Node that evaluates to this block.
/// This is either a Declaration_Instance or a ConstructorCallExpression.
/// One value for each Node inside that evaluates to a compile-time constant.
/// This includes all constructor parameters, and all inner nested blocks.
    ordered_map<const IR::Node *, const IR::CompileTimeValue *> constantValue = {};
#line 648 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    virtual void dbprint(std::ostream & out) const override;
#line 9350 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 649 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    virtual void dbprint_recursive(std::ostream & out) const;
#line 9353 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// value can be null for parameters which are optional
#line 651 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void setValue(const IR::Node* node, const IR::CompileTimeValue* value);
#line 9357 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 652 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    bool hasValue(const IR::Node* node) const {
        return constantValue.find(node) != constantValue.end();
    }
#line 9362 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 655 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::CompileTimeValue *getValue(const IR::Node* node) const {
        CHECK_NULL(node);
        auto it = constantValue.find(node);
        BUG_CHECK(it != constantValue.end(), "%1%: No such node %2%", this, node);
        return it->second; }
#line 9369 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 660 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 9373 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 661 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    virtual IR::IDeclaration const * getContainer() const;
#line 9376 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Block const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Block"_cs; }
    static cstring static_type_name() { return "Block"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Block(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    Block(Util::SourceInfo srcInfo, const IR::Node* node) :
    Node(srcInfo), node(node)
    { validate(); }
    Block(const IR::Node* node) :
    node(node)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Block)
    DECLARE_TYPEINFO_WITH_TYPEID(Block, NodeKind::Block, Node, CompileTimeValue);
};
}  // namespace P4::IR
namespace P4::IR {
class TableBlock : public Block {
 public:
    const IR::P4Table* container = nullptr;
#line 666 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::IDeclaration const * getContainer() const override;
#line 9402 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TableBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "TableBlock"_cs; }
    static cstring static_type_name() { return "TableBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    TableBlock(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Block const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TableBlock(Util::SourceInfo srcInfo, const IR::Node* node, const IR::P4Table* container) :
    Block(srcInfo, node), container(container)
    { validate(); }
    TableBlock(const IR::Node* node, const IR::P4Table* container) :
    Block(node), container(container)
    { validate(); }
    IRNODE_SUBCLASS(TableBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(TableBlock, NodeKind::TableBlock, Block);
};
}  // namespace P4::IR
namespace P4::IR {
/// An object that has been instantiated
class InstantiatedBlock : public Block, public virtual IDeclaration {
 public:
    const IR::Type* instanceType = nullptr;

#line 674 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    virtual const IR::ParameterList *getConstructorParameters() const = 0;
#line 9433 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 675 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void instantiate(std::vector<const IR::CompileTimeValue *> * args);
#line 9436 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// @return the argument that the given parameter was instantiated with.
/// It's a fatal error if no such parameter exists.
#line 679 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::CompileTimeValue *getParameterValue(cstring paramName) const;
#line 9441 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// @return the argument that the given parameter was instantiated with, or
/// null if no such parameter exists.
#line 683 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::CompileTimeValue *findParameterValue(cstring paramName) const;
#line 9446 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 685 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    virtual void dbprint(std::ostream & out) const override;
#line 9449 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::InstantiatedBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "InstantiatedBlock"_cs; }
    static cstring static_type_name() { return "InstantiatedBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    InstantiatedBlock(JSONLoader & json);
    bool operator==(IR::Block const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    InstantiatedBlock(Util::SourceInfo srcInfo, const IR::Node* node, const IR::Type* instanceType) :
    Block(srcInfo, node), instanceType(instanceType)
    { validate(); }
    InstantiatedBlock(const IR::Node* node, const IR::Type* instanceType) :
    Block(node), instanceType(instanceType)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(InstantiatedBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(InstantiatedBlock, NodeKind::InstantiatedBlock, Block, IDeclaration);
};
}  // namespace P4::IR
namespace P4::IR {
class ParserBlock : public InstantiatedBlock {
 public:
    const IR::P4Parser* container = nullptr;
#line 690 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getConstructorParameters() const override;
#line 9478 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 692 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 9481 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 693 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::ID getName() const override;
#line 9484 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 694 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::IDeclaration const * getContainer() const override;
#line 9487 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ParserBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ParserBlock"_cs; }
    static cstring static_type_name() { return "ParserBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserBlock(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::InstantiatedBlock const & a) const override;
    bool operator==(IR::Block const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserBlock(Util::SourceInfo srcInfo, const IR::Node* node, const IR::Type* instanceType, const IR::P4Parser* container) :
    InstantiatedBlock(srcInfo, node, instanceType), container(container)
    { validate(); }
    ParserBlock(const IR::Node* node, const IR::Type* instanceType, const IR::P4Parser* container) :
    InstantiatedBlock(node, instanceType), container(container)
    { validate(); }
    IRNODE_SUBCLASS(ParserBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserBlock, NodeKind::ParserBlock, InstantiatedBlock);
};
}  // namespace P4::IR
namespace P4::IR {
class ControlBlock : public InstantiatedBlock {
 public:
    const IR::P4Control* container = nullptr;
#line 700 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getConstructorParameters() const override;
#line 9517 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 702 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 9520 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 703 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::ID getName() const override;
#line 9523 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 704 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::IDeclaration const * getContainer() const override;
#line 9526 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ControlBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ControlBlock"_cs; }
    static cstring static_type_name() { return "ControlBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ControlBlock(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::InstantiatedBlock const & a) const override;
    bool operator==(IR::Block const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ControlBlock(Util::SourceInfo srcInfo, const IR::Node* node, const IR::Type* instanceType, const IR::P4Control* container) :
    InstantiatedBlock(srcInfo, node, instanceType), container(container)
    { validate(); }
    ControlBlock(const IR::Node* node, const IR::Type* instanceType, const IR::P4Control* container) :
    InstantiatedBlock(node, instanceType), container(container)
    { validate(); }
    IRNODE_SUBCLASS(ControlBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(ControlBlock, NodeKind::ControlBlock, InstantiatedBlock);
};
}  // namespace P4::IR
namespace P4::IR {
class PackageBlock : public InstantiatedBlock {
 public:
    const IR::Type_Package* type = nullptr;
#line 710 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getConstructorParameters() const override;
#line 9556 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 711 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 9559 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 712 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::ID getName() const override;
#line 9562 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::PackageBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "PackageBlock"_cs; }
    static cstring static_type_name() { return "PackageBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    PackageBlock(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::InstantiatedBlock const & a) const override;
    bool operator==(IR::Block const & a) const override;
    bool operator==(IR::Node const & a) const override;
    PackageBlock(Util::SourceInfo srcInfo, const IR::Node* node, const IR::Type* instanceType, const IR::Type_Package* type) :
    InstantiatedBlock(srcInfo, node, instanceType), type(type)
    { validate(); }
    PackageBlock(const IR::Node* node, const IR::Type* instanceType, const IR::Type_Package* type) :
    InstantiatedBlock(node, instanceType), type(type)
    { validate(); }
    IRNODE_SUBCLASS(PackageBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(PackageBlock, NodeKind::PackageBlock, InstantiatedBlock);
};
}  // namespace P4::IR
namespace P4::IR {
class ExternBlock : public InstantiatedBlock {
 public:
    const IR::Type_Extern* type = nullptr;
    const IR::Method* constructor = nullptr;

#line 719 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::ParameterList *getConstructorParameters() const override;
#line 9594 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 721 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    cstring toString() const override;
#line 9597 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 722 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::ID getName() const override;
#line 9600 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ExternBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ExternBlock"_cs; }
    static cstring static_type_name() { return "ExternBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ExternBlock(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::InstantiatedBlock const & a) const override;
    bool operator==(IR::Block const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ExternBlock(Util::SourceInfo srcInfo, const IR::Node* node, const IR::Type* instanceType, const IR::Type_Extern* type, const IR::Method* constructor) :
    InstantiatedBlock(srcInfo, node, instanceType), type(type), constructor(constructor)
    { validate(); }
    ExternBlock(const IR::Node* node, const IR::Type* instanceType, const IR::Type_Extern* type, const IR::Method* constructor) :
    InstantiatedBlock(node, instanceType), type(type), constructor(constructor)
    { validate(); }
    IRNODE_SUBCLASS(ExternBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(ExternBlock, NodeKind::ExternBlock, InstantiatedBlock);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents the program as a whole
class ToplevelBlock : public Block, public virtual IDeclaration {
 public:
#line 728 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::P4Program *getProgram() const;
#line 9630 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 729 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    const IR::PackageBlock *getMain() const;
#line 9633 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 730 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    IR::ID getName() const override;
#line 9636 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 732 "/builddir/build/BUILD/p4c-1.2.5.8/ir/ir.def"
    void validate() const override;
#line 9639 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ToplevelBlock const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ToplevelBlock"_cs; }
    static cstring static_type_name() { return "ToplevelBlock"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ToplevelBlock(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Block const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ToplevelBlock(Util::SourceInfo srcInfo, const IR::Node* node) :
    Block(srcInfo, node)
    { validate(); }
    ToplevelBlock(const IR::Node* node) :
    Block(node)
    { validate(); }
    IRNODE_SUBCLASS(ToplevelBlock)
    DECLARE_TYPEINFO_WITH_TYPEID(ToplevelBlock, NodeKind::ToplevelBlock, Block, IDeclaration);
};
}  // namespace P4::IR
/** @} */
/* end group irdefs */
/* -*-C++-*- */
/*
  This file contains IR classes needed just for the P4 v1.0/v1.1 front-end.
*/
/** \addtogroup irdefs
  * @{
  */
#line 11 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
namespace P4 {

namespace IR {
enum class CounterType { NONE, PACKETS, BYTES, BOTH };
}

inline std::ostream& operator<<(std::ostream &out, IR::CounterType d) {
    switch (d) {
        case IR::CounterType::NONE:
            out << "NONE";
            break;
        case IR::CounterType::PACKETS:
            out << "PACKETS";
            break;
        case IR::CounterType::BYTES:
            out << "BYTES";
            break;
        case IR::CounterType::BOTH:
            out << "BOTH";
            break;
        default:
            BUG("Unhandled case");
    }
    return out;
}

inline bool operator>>(cstring s, IR::CounterType &ctr) {
    if (!s || s == "" || s == "NONE") ctr = IR::CounterType::NONE;
    else if (s == "PACKETS") ctr = IR::CounterType::PACKETS;
    else if (s == "BYTES") ctr = IR::CounterType::BYTES;
    else if (s == "BOTH") ctr = IR::CounterType::BOTH;
    else return false;
    return true;
}

}  // namespace P4

#line 9706 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
class Type_Block : public Type_Base {
 public:
#line 51 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 9712 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 52 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static const IR::Type_Block *get();
#line 9715 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 53 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9718 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Block const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Block"_cs; }
    static cstring static_type_name() { return "Type_Block"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Block(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Block(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Block() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Block)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Block, NodeKind::Type_Block, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Counter : public Type_Base {
 public:
#line 56 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 9743 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 57 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static const IR::Type_Counter *get();
#line 9746 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 58 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9749 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Counter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Counter"_cs; }
    static cstring static_type_name() { return "Type_Counter"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Counter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Counter(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Counter() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Counter)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Counter, NodeKind::Type_Counter, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Expression : public Type_Base {
 public:
#line 61 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 9774 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 62 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static const IR::Type_Expression *get();
#line 9777 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 63 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9780 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Expression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Expression"_cs; }
    static cstring static_type_name() { return "Type_Expression"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Expression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Expression(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Expression() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Expression)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Expression, NodeKind::Type_Expression, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_FieldListCalculation : public Type_Base {
 public:
#line 66 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 9805 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 67 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static const IR::Type_FieldListCalculation *get();
#line 9808 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 68 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9811 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_FieldListCalculation const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_FieldListCalculation"_cs; }
    static cstring static_type_name() { return "Type_FieldListCalculation"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_FieldListCalculation(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_FieldListCalculation(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_FieldListCalculation() 
    { validate(); }
    IRNODE_SUBCLASS(Type_FieldListCalculation)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_FieldListCalculation, NodeKind::Type_FieldListCalculation, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Meter : public Type_Base {
 public:
#line 71 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 9836 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 72 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static const IR::Type_Meter *get();
#line 9839 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 73 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9842 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Meter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Meter"_cs; }
    static cstring static_type_name() { return "Type_Meter"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Meter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Meter(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Meter() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Meter)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Meter, NodeKind::Type_Meter, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_Register : public Type_Base {
 public:
#line 76 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 9867 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 77 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static const IR::Type_Register *get();
#line 9870 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 78 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9873 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_Register const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_Register"_cs; }
    static cstring static_type_name() { return "Type_Register"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_Register(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_Register(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_Register() 
    { validate(); }
    IRNODE_SUBCLASS(Type_Register)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_Register, NodeKind::Type_Register, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class Type_AnyTable : public Type_Base {
 public:
#line 81 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 9898 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 82 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static const IR::Type_AnyTable *get();
#line 9901 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 83 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9904 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Type_AnyTable const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Type_AnyTable"_cs; }
    static cstring static_type_name() { return "Type_AnyTable"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Type_AnyTable(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_AnyTable(Util::SourceInfo srcInfo) :
    Type_Base(srcInfo)
    { validate(); }
    Type_AnyTable() 
    { validate(); }
    IRNODE_SUBCLASS(Type_AnyTable)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_AnyTable, NodeKind::Type_AnyTable, Type_Base);
};
}  // namespace P4::IR
namespace P4::IR {
class HeaderOrMetadata : public Node, public virtual IAnnotated {
 public:
    IR::ID type_name;
    IR::ID name;
    IR::Vector<IR::Annotation> annotations;
    const IR::Type_StructLike* type = nullptr;
#line 92 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 9933 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 93 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 9936 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 94 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    HeaderOrMetadata(IR::ID n, const IR::Type_StructLike* t);
#line 9939 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 96 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 9942 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::HeaderOrMetadata const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "HeaderOrMetadata"_cs; }
    static cstring static_type_name() { return "HeaderOrMetadata"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HeaderOrMetadata(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    HeaderOrMetadata(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), type_name(type_name), name(name), annotations(annotations)
    { validate(); }
    HeaderOrMetadata(IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    type_name(type_name), name(name), annotations(annotations)
    { validate(); }
    HeaderOrMetadata(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name) :
    Node(srcInfo), type_name(type_name), name(name)
    { validate(); }
    HeaderOrMetadata(IR::ID type_name, IR::ID name) :
    type_name(type_name), name(name)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(HeaderOrMetadata)
    DECLARE_TYPEINFO_WITH_TYPEID(HeaderOrMetadata, NodeKind::HeaderOrMetadata, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class Header : public HeaderOrMetadata {
 public:
#line 100 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Header(IR::ID n, const IR::Type_Header* t);
#line 9976 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Header const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Header"_cs; }
    static cstring static_type_name() { return "Header"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Header(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::HeaderOrMetadata const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Header(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    HeaderOrMetadata(srcInfo, type_name, name, annotations)
    { validate(); }
    Header(IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    HeaderOrMetadata(type_name, name, annotations)
    { validate(); }
    Header(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name) :
    HeaderOrMetadata(srcInfo, type_name, name)
    { validate(); }
    Header(IR::ID type_name, IR::ID name) :
    HeaderOrMetadata(type_name, name)
    { validate(); }
    IRNODE_SUBCLASS(Header)
    DECLARE_TYPEINFO_WITH_TYPEID(Header, NodeKind::Header, HeaderOrMetadata);
};
}  // namespace P4::IR
namespace P4::IR {
class HeaderStack : public HeaderOrMetadata {
 public:
    int size;
#line 106 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    HeaderStack(IR::ID n, const IR::Type_Header* t, int sz);
#line 10008 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::HeaderStack const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "HeaderStack"_cs; }
    static cstring static_type_name() { return "HeaderStack"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HeaderStack(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::HeaderOrMetadata const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HeaderStack(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations, int size) :
    HeaderOrMetadata(srcInfo, type_name, name, annotations), size(size)
    { validate(); }
    HeaderStack(IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations, int size) :
    HeaderOrMetadata(type_name, name, annotations), size(size)
    { validate(); }
    HeaderStack(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name, int size) :
    HeaderOrMetadata(srcInfo, type_name, name), size(size)
    { validate(); }
    HeaderStack(IR::ID type_name, IR::ID name, int size) :
    HeaderOrMetadata(type_name, name), size(size)
    { validate(); }
    IRNODE_SUBCLASS(HeaderStack)
    DECLARE_TYPEINFO_WITH_TYPEID(HeaderStack, NodeKind::HeaderStack, HeaderOrMetadata);
};
}  // namespace P4::IR
namespace P4::IR {
class v1HeaderType : public Node {
 public:
    IR::ID name;
    const IR::Type_Struct* as_metadata = nullptr;
    const IR::Type_Header* as_header = nullptr;
#line 115 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    v1HeaderType(IR::Type_Struct const * m, IR::Type_Header const * h = nullptr);
#line 10043 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 117 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 10046 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::v1HeaderType const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "v1HeaderType"_cs; }
    static cstring static_type_name() { return "v1HeaderType"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    v1HeaderType(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    v1HeaderType(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Struct* as_metadata, const IR::Type_Header* as_header) :
    Node(srcInfo), name(name), as_metadata(as_metadata), as_header(as_header)
    { validate(); }
    v1HeaderType(IR::ID name, const IR::Type_Struct* as_metadata, const IR::Type_Header* as_header) :
    name(name), as_metadata(as_metadata), as_header(as_header)
    { validate(); }
    IRNODE_SUBCLASS(v1HeaderType)
    DECLARE_TYPEINFO_WITH_TYPEID(v1HeaderType, NodeKind::v1HeaderType, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class Metadata : public HeaderOrMetadata {
 public:
#line 121 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Metadata(IR::ID n, const IR::Type_StructLike* t);
#line 10074 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Metadata const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Metadata"_cs; }
    static cstring static_type_name() { return "Metadata"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Metadata(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::HeaderOrMetadata const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Metadata(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    HeaderOrMetadata(srcInfo, type_name, name, annotations)
    { validate(); }
    Metadata(IR::ID type_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    HeaderOrMetadata(type_name, name, annotations)
    { validate(); }
    Metadata(Util::SourceInfo srcInfo, IR::ID type_name, IR::ID name) :
    HeaderOrMetadata(srcInfo, type_name, name)
    { validate(); }
    Metadata(IR::ID type_name, IR::ID name) :
    HeaderOrMetadata(type_name, name)
    { validate(); }
    IRNODE_SUBCLASS(Metadata)
    DECLARE_TYPEINFO_WITH_TYPEID(Metadata, NodeKind::Metadata, HeaderOrMetadata);
};
}  // namespace P4::IR
namespace P4::IR {
class HeaderRef : public Expression {
 public:
#line 126 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual const IR::HeaderOrMetadata *baseRef() const = 0;
#line 10105 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::HeaderRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "HeaderRef"_cs; }
    static cstring static_type_name() { return "HeaderRef"_cs; }
    void toJSON(JSONGenerator & json) const override;
    HeaderRef(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    HeaderRef(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    HeaderRef(const IR::Type* type) :
    Expression(type)
    { validate(); }
    HeaderRef(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    HeaderRef() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(HeaderRef)
    DECLARE_TYPEINFO_WITH_TYPEID(HeaderRef, NodeKind::HeaderRef, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class ConcreteHeaderRef : public HeaderRef {
 public:
    const IR::HeaderOrMetadata* ref = nullptr;
#line 132 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::HeaderOrMetadata *baseRef() const override;
#line 10136 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 133 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 10139 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 134 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 10142 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ConcreteHeaderRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ConcreteHeaderRef"_cs; }
    static cstring static_type_name() { return "ConcreteHeaderRef"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ConcreteHeaderRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::HeaderRef const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ConcreteHeaderRef(Util::SourceInfo srcInfo, const IR::Type* type, const IR::HeaderOrMetadata* ref) :
    HeaderRef(srcInfo, type), ref(ref)
    {
#line 131 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (type->is<Type::Unknown>() && ref) type = ref->type; }
#line 10161 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ConcreteHeaderRef(const IR::Type* type, const IR::HeaderOrMetadata* ref) :
    HeaderRef(type), ref(ref)
    {
#line 131 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (type->is<Type::Unknown>() && ref) type = ref->type; }
#line 10168 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ConcreteHeaderRef(Util::SourceInfo srcInfo, const IR::HeaderOrMetadata* ref) :
    HeaderRef(srcInfo), ref(ref)
    {
#line 131 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (type->is<Type::Unknown>() && ref) type = ref->type; }
#line 10175 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ConcreteHeaderRef(const IR::HeaderOrMetadata* ref) :
    ref(ref)
    {
#line 131 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (type->is<Type::Unknown>() && ref) type = ref->type; }
#line 10182 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(ConcreteHeaderRef)
    DECLARE_TYPEINFO_WITH_TYPEID(ConcreteHeaderRef, NodeKind::ConcreteHeaderRef, HeaderRef);
};
}  // namespace P4::IR
namespace P4::IR {
class HeaderStackItemRef : public HeaderRef {
 public:
    const IR::Expression* base_ = nullptr;
    const IR::Expression* index_ = nullptr;
#line 144 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::Expression *base() const;
#line 10195 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Returns `nullptr` if the base is not `HeaderOrMetadata` (e.g. when this
/// is stack ref of an expression such as `lookahead`).
#line 147 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::HeaderOrMetadata *baseRef() const override;
#line 10200 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 151 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::Expression *index() const;
#line 10203 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 152 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void set_base(const IR::Expression* b);
#line 10206 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 153 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 10209 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::HeaderStackItemRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "HeaderStackItemRef"_cs; }
    static cstring static_type_name() { return "HeaderStackItemRef"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HeaderStackItemRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::HeaderRef const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HeaderStackItemRef(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* base_, const IR::Expression* index_) :
    HeaderRef(srcInfo, type), base_(base_), index_(index_)
    {
#line 140 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{
        if (type->is<Type::Unknown>() && base_)
            if (auto *hr = base_->to<HeaderRef>())
                type = hr->baseRef()->type; }
#line 10232 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    HeaderStackItemRef(const IR::Type* type, const IR::Expression* base_, const IR::Expression* index_) :
    HeaderRef(type), base_(base_), index_(index_)
    {
#line 140 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{
        if (type->is<Type::Unknown>() && base_)
            if (auto *hr = base_->to<HeaderRef>())
                type = hr->baseRef()->type; }
#line 10242 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    HeaderStackItemRef(Util::SourceInfo srcInfo, const IR::Expression* base_, const IR::Expression* index_) :
    HeaderRef(srcInfo), base_(base_), index_(index_)
    {
#line 140 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{
        if (type->is<Type::Unknown>() && base_)
            if (auto *hr = base_->to<HeaderRef>())
                type = hr->baseRef()->type; }
#line 10252 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    HeaderStackItemRef(const IR::Expression* base_, const IR::Expression* index_) :
    base_(base_), index_(index_)
    {
#line 140 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{
        if (type->is<Type::Unknown>() && base_)
            if (auto *hr = base_->to<HeaderRef>())
                type = hr->baseRef()->type; }
#line 10262 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(HeaderStackItemRef)
    DECLARE_TYPEINFO_WITH_TYPEID(HeaderStackItemRef, NodeKind::HeaderStackItemRef, HeaderRef);
};
}  // namespace P4::IR
namespace P4::IR {
class If : public Expression {
 public:
    const IR::Expression* pred = nullptr;
    const IR::Vector<IR::Expression>* ifTrue = nullptr;
    const IR::Vector<IR::Expression>* ifFalse = nullptr;
#line 160 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 10277 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::If const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "If"_cs; }
    static cstring static_type_name() { return "If"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    If(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    If(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* pred, const IR::Vector<IR::Expression>* ifTrue, const IR::Vector<IR::Expression>* ifFalse) :
    Expression(srcInfo, type), pred(pred), ifTrue(ifTrue), ifFalse(ifFalse)
    { validate(); }
    If(const IR::Type* type, const IR::Expression* pred, const IR::Vector<IR::Expression>* ifTrue, const IR::Vector<IR::Expression>* ifFalse) :
    Expression(type), pred(pred), ifTrue(ifTrue), ifFalse(ifFalse)
    { validate(); }
    If(Util::SourceInfo srcInfo, const IR::Expression* pred, const IR::Vector<IR::Expression>* ifTrue, const IR::Vector<IR::Expression>* ifFalse) :
    Expression(srcInfo), pred(pred), ifTrue(ifTrue), ifFalse(ifFalse)
    { validate(); }
    If(const IR::Expression* pred, const IR::Vector<IR::Expression>* ifTrue, const IR::Vector<IR::Expression>* ifFalse) :
    pred(pred), ifTrue(ifTrue), ifFalse(ifFalse)
    { validate(); }
    IRNODE_SUBCLASS(If)
    DECLARE_TYPEINFO_WITH_TYPEID(If, NodeKind::If, Expression);
};
}  // namespace P4::IR
namespace P4::IR {

class NamedCond : public If {
 public:
    cstring name = unique_name();
#line 171 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    static cstring unique_name();
#line 10312 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 172 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    NamedCond(IR::If const & i);
#line 10315 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 173 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    bool operator==(IR::NamedCond const & a) const override;
#line 10318 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "NamedCond"_cs; }
    static cstring static_type_name() { return "NamedCond"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    NamedCond(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::If const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(NamedCond)
    DECLARE_TYPEINFO_WITH_TYPEID(NamedCond, NodeKind::NamedCond, If);
};
}  // namespace P4::IR
namespace P4::IR {
class Apply : public Expression {
 public:
    IR::ID name;

    IR::NameMap<IR::Vector<IR::Expression>, ordered_map> actions = {};

    IR::NameMap<IR::Path> position = {};
    bool operator==(IR::Apply const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Apply"_cs; }
    static cstring static_type_name() { return "Apply"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Apply(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Apply(Util::SourceInfo srcInfo, const IR::Type* type, IR::ID name) :
    Expression(srcInfo, type), name(name)
    { validate(); }
    Apply(const IR::Type* type, IR::ID name) :
    Expression(type), name(name)
    { validate(); }
    Apply(Util::SourceInfo srcInfo, IR::ID name) :
    Expression(srcInfo), name(name)
    { validate(); }
    Apply(IR::ID name) :
    name(name)
    { validate(); }
    Apply(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    Apply(const IR::Type* type) :
    Expression(type)
    { validate(); }
    Apply(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    Apply() 
    { validate(); }
    IRNODE_SUBCLASS(Apply)
    DECLARE_TYPEINFO_WITH_TYPEID(Apply, NodeKind::Apply, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class Primitive : public Operation {
 public:
    cstring name;
    IR::Vector<IR::Expression> operands = {};
#line 190 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(cstring n, const IR::Vector<IR::Expression>* l);
#line 10389 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 192 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(Util::SourceInfo si, cstring n, const IR::Vector<IR::Expression>* l);
#line 10392 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 194 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(cstring n, const IR::Expression* a1);
#line 10395 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 196 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(Util::SourceInfo si, cstring n, const IR::Expression* a1);
#line 10398 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 198 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(cstring n, const IR::Expression* a1, const IR::Expression* a2);
#line 10401 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 200 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(Util::SourceInfo si, cstring n, const IR::Expression* a1, const IR::Expression* a2);
#line 10404 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 203 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(cstring n, const IR::Expression* a1, const IR::Vector<IR::Expression>* a2);
#line 10407 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 206 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(Util::SourceInfo si, cstring n, const IR::Expression* a1, const IR::Vector<IR::Expression>* a2);
#line 10410 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 210 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(cstring n, const IR::Expression* a1, const IR::Expression* a2, const IR::Expression* a3);
#line 10413 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 212 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Primitive(Util::SourceInfo si, cstring n, const IR::Expression* a1, const IR::Expression* a2, const IR::Expression* a3);
#line 10416 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 215 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual bool isOutput(int operand_index) const;
#line 10419 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 216 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual unsigned inferOperandTypes() const;
#line 10422 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 217 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual const IR::Type *inferOperandType(int operand) const;
#line 10425 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 218 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual void typecheck() const;
#line 10428 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Primitive)
    cstring getStringOp() const override { return cstring(name); }
    int getPrecedence() const override { return DBPrint::Prec_Postfix; }
    bool operator==(IR::Primitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Primitive"_cs; }
    static cstring static_type_name() { return "Primitive"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Primitive(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Primitive(Util::SourceInfo srcInfo, const IR::Type* type, cstring name) :
    Operation(srcInfo, type), name(name)
    { validate(); }
    Primitive(const IR::Type* type, cstring name) :
    Operation(type), name(name)
    { validate(); }
    Primitive(Util::SourceInfo srcInfo, cstring name) :
    Operation(srcInfo), name(name)
    { validate(); }
    Primitive(cstring name) :
    name(name)
    { validate(); }
    IRNODE_SUBCLASS(Primitive)
    DECLARE_TYPEINFO_WITH_TYPEID(Primitive, NodeKind::Primitive, Operation);
};
}  // namespace P4::IR
namespace P4::IR {
class FieldList : public Node, public virtual IAnnotated {
 public:
    IR::ID name;
    bool payload = false;
    IR::Vector<IR::Annotation> annotations;
    IR::Vector<IR::Expression> fields = {};
#line 229 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 10472 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 230 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 10475 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::FieldList const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "FieldList"_cs; }
    static cstring static_type_name() { return "FieldList"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    FieldList(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    FieldList(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), annotations(annotations)
    { validate(); }
    FieldList(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    FieldList(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), annotations(annotations)
    { validate(); }
    FieldList(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    FieldList(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    { validate(); }
    FieldList(IR::ID name) :
    name(name)
    { validate(); }
    FieldList(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    FieldList() 
    { validate(); }
    IRNODE_SUBCLASS(FieldList)
    DECLARE_TYPEINFO_WITH_TYPEID(FieldList, NodeKind::FieldList, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class FieldListCalculation : public Node, public virtual IAnnotated {
 public:
    IR::ID name;
    const IR::NameList* input = nullptr;
    const IR::FieldList* input_fields = nullptr;
    const IR::NameList* algorithm = nullptr;
    int output_width = 0;
    IR::Vector<IR::Annotation> annotations;
#line 240 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 10527 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 241 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 10530 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::FieldListCalculation const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "FieldListCalculation"_cs; }
    static cstring static_type_name() { return "FieldListCalculation"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    FieldListCalculation(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    FieldListCalculation(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), annotations(annotations)
    { validate(); }
    FieldListCalculation(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    FieldListCalculation(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), annotations(annotations)
    { validate(); }
    FieldListCalculation(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    FieldListCalculation(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    { validate(); }
    FieldListCalculation(IR::ID name) :
    name(name)
    { validate(); }
    FieldListCalculation(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    FieldListCalculation() 
    { validate(); }
    IRNODE_SUBCLASS(FieldListCalculation)
    DECLARE_TYPEINFO_WITH_TYPEID(FieldListCalculation, NodeKind::FieldListCalculation, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class CalculatedField : public Node, public virtual IAnnotated {
 public:
    const IR::Expression* field = nullptr;
class update_or_verify {
 public:
    Util::SourceInfo srcInfo;
    bool update = false;
    IR::ID name;
    const IR::Expression* cond = nullptr;
#line 251 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    update_or_verify();
#line 10583 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

    bool operator==(IR::CalculatedField::update_or_verify const & a) const;
    void toJSON(JSONGenerator & json) const;
    update_or_verify(JSONLoader & json);
    static IR::CalculatedField::update_or_verify * fromJSON(JSONLoader & json);
    update_or_verify(Util::SourceInfo srcInfo, bool update, IR::ID name, const IR::Expression* cond) :
    srcInfo(srcInfo), update(update), name(name), cond(cond)
    {}
    update_or_verify(Util::SourceInfo srcInfo, IR::ID name, const IR::Expression* cond) :
    srcInfo(srcInfo), name(name), cond(cond)
    {}
};
    safe_vector<update_or_verify> specs = {};
    IR::Vector<IR::Annotation> annotations;
#line 255 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 10600 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 256 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 10603 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 257 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 10607 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::CalculatedField const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "CalculatedField"_cs; }
    static cstring static_type_name() { return "CalculatedField"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    CalculatedField(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    CalculatedField(Util::SourceInfo srcInfo, const IR::Expression* field, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), field(field), annotations(annotations)
    { validate(); }
    CalculatedField(const IR::Expression* field, IR::Vector<IR::Annotation> annotations) :
    field(field), annotations(annotations)
    { validate(); }
    CalculatedField(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), annotations(annotations)
    { validate(); }
    CalculatedField(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    CalculatedField(Util::SourceInfo srcInfo, const IR::Expression* field) :
    Node(srcInfo), field(field)
    { validate(); }
    CalculatedField(const IR::Expression* field) :
    field(field)
    { validate(); }
    CalculatedField(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    CalculatedField() 
    { validate(); }
    IRNODE_SUBCLASS(CalculatedField)
    DECLARE_TYPEINFO_WITH_TYPEID(CalculatedField, NodeKind::CalculatedField, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class ParserValueSet : public Node, public virtual IAnnotated {
 public:
    IR::ID name;
    IR::Vector<IR::Annotation> annotations;
#line 267 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 10652 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 268 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 10655 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 269 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 10658 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 270 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 10661 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ParserValueSet const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ParserValueSet"_cs; }
    static cstring static_type_name() { return "ParserValueSet"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserValueSet(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ParserValueSet(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), annotations(annotations)
    { validate(); }
    ParserValueSet(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    ParserValueSet(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    { validate(); }
    ParserValueSet(IR::ID name) :
    name(name)
    { validate(); }
    IRNODE_SUBCLASS(ParserValueSet)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserValueSet, NodeKind::ParserValueSet, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class CaseEntry : public Node {
 public:
    safe_vector<std::pair<const IR::Expression *, const IR::Constant *>> values = {};
    IR::ID action;
    bool operator==(IR::CaseEntry const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "CaseEntry"_cs; }
    static cstring static_type_name() { return "CaseEntry"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    CaseEntry(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    CaseEntry(Util::SourceInfo srcInfo, IR::ID action) :
    Node(srcInfo), action(action)
    { validate(); }
    CaseEntry(IR::ID action) :
    action(action)
    { validate(); }
    CaseEntry(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    CaseEntry() 
    { validate(); }
    IRNODE_SUBCLASS(CaseEntry)
    DECLARE_TYPEINFO_WITH_TYPEID(CaseEntry, NodeKind::CaseEntry, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class V1Parser : public Node, public virtual IAnnotated {
 public:
    IR::ID name;
    IR::Vector<IR::Expression> stmts = {};
    const IR::Vector<IR::Expression>* select = nullptr;
    const IR::Vector<IR::CaseEntry>* cases = nullptr;
    IR::ID default_return = {};
    IR::ID parse_error = {};
    bool drop = false;
    IR::Vector<IR::Annotation> annotations;
#line 287 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 10733 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 288 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 10736 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 289 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 10739 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::V1Parser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "V1Parser"_cs; }
    static cstring static_type_name() { return "V1Parser"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    V1Parser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    V1Parser(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), annotations(annotations)
    { validate(); }
    V1Parser(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    V1Parser(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), annotations(annotations)
    { validate(); }
    V1Parser(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    V1Parser(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    { validate(); }
    V1Parser(IR::ID name) :
    name(name)
    { validate(); }
    V1Parser(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    V1Parser() 
    { validate(); }
    IRNODE_SUBCLASS(V1Parser)
    DECLARE_TYPEINFO_WITH_TYPEID(V1Parser, NodeKind::V1Parser, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class ParserException : public Node {
 public:
    bool operator==(IR::ParserException const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ParserException"_cs; }
    static cstring static_type_name() { return "ParserException"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserException(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ParserException(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    ParserException() 
    { validate(); }
    IRNODE_SUBCLASS(ParserException)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserException, NodeKind::ParserException, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class Attached : public Node, public virtual IInstance, public virtual IAnnotated {
 public:
    IR::ID name;
    IR::Vector<IR::Annotation> annotations;
#line 297 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::ID Name() const override;
#line 10808 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 298 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual char const * kind() const = 0;
#line 10811 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 299 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::Type *getType() const override;
#line 10814 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 300 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 10817 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 301 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 10820 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 302 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual bool indexed() const;
#line 10823 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 303 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Attached * clone_rename(char const * ext) const;
#line 10826 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 307 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 10829 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 308 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 10832 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Attached const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "Attached"_cs; }
    static cstring static_type_name() { return "Attached"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Attached(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    Attached(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), annotations(annotations)
    { validate(); }
    Attached(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    Attached(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), annotations(annotations)
    { validate(); }
    Attached(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    Attached(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    { validate(); }
    Attached(IR::ID name) :
    name(name)
    { validate(); }
    Attached(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    Attached() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Attached)
    DECLARE_TYPEINFO_WITH_TYPEID(Attached, NodeKind::Attached, Node, IInstance, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class Stateful : public Attached {
 public:
    IR::ID table = {};
    bool direct = false;
    bool saturating = false;
    int instance_count = -1;
#line 316 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    virtual bool indexed() const override;
#line 10881 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 317 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    int index_width() const;
#line 10884 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

    bool operator==(IR::Stateful const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Stateful"_cs; }
    static cstring static_type_name() { return "Stateful"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Stateful(JSONLoader & json);
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Stateful(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, name, annotations)
    { validate(); }
    Stateful(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(name, annotations)
    { validate(); }
    Stateful(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, annotations)
    { validate(); }
    Stateful(IR::Vector<IR::Annotation> annotations) :
    Attached(annotations)
    { validate(); }
    Stateful(Util::SourceInfo srcInfo, IR::ID name) :
    Attached(srcInfo, name)
    { validate(); }
    Stateful(IR::ID name) :
    Attached(name)
    { validate(); }
    Stateful(Util::SourceInfo srcInfo) :
    Attached(srcInfo)
    { validate(); }
    Stateful() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Stateful)
    DECLARE_TYPEINFO_WITH_TYPEID(Stateful, NodeKind::Stateful, Attached);
};
}  // namespace P4::IR
namespace P4::IR {
class CounterOrMeter : public Stateful {
 public:
    CounterType type = CounterType::NONE;
#line 322 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void settype(cstring t);
#line 10929 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

    bool operator==(IR::CounterOrMeter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "CounterOrMeter"_cs; }
    static cstring static_type_name() { return "CounterOrMeter"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    CounterOrMeter(JSONLoader & json);
    bool operator==(IR::Stateful const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    CounterOrMeter(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Stateful(srcInfo, name, annotations)
    { validate(); }
    CounterOrMeter(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Stateful(name, annotations)
    { validate(); }
    CounterOrMeter(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Stateful(srcInfo, annotations)
    { validate(); }
    CounterOrMeter(IR::Vector<IR::Annotation> annotations) :
    Stateful(annotations)
    { validate(); }
    CounterOrMeter(Util::SourceInfo srcInfo, IR::ID name) :
    Stateful(srcInfo, name)
    { validate(); }
    CounterOrMeter(IR::ID name) :
    Stateful(name)
    { validate(); }
    CounterOrMeter(Util::SourceInfo srcInfo) :
    Stateful(srcInfo)
    { validate(); }
    CounterOrMeter() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(CounterOrMeter)
    DECLARE_TYPEINFO_WITH_TYPEID(CounterOrMeter, NodeKind::CounterOrMeter, Stateful);
};
}  // namespace P4::IR
namespace P4::IR {
class Counter : public CounterOrMeter {
 public:
    int max_width = -1;
    int min_width = -1;
#line 333 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    char const * kind() const override;
#line 10976 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 334 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Type const * getType() const override;
#line 10979 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Counter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Counter"_cs; }
    static cstring static_type_name() { return "Counter"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Counter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::CounterOrMeter const & a) const override;
    bool operator==(IR::Stateful const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Counter(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(srcInfo, name, annotations)
    { validate(); }
    Counter(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(name, annotations)
    { validate(); }
    Counter(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(srcInfo, annotations)
    { validate(); }
    Counter(IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(annotations)
    { validate(); }
    Counter(Util::SourceInfo srcInfo, IR::ID name) :
    CounterOrMeter(srcInfo, name)
    { validate(); }
    Counter(IR::ID name) :
    CounterOrMeter(name)
    { validate(); }
    Counter(Util::SourceInfo srcInfo) :
    CounterOrMeter(srcInfo)
    { validate(); }
    Counter() 
    { validate(); }
    IRNODE_SUBCLASS(Counter)
    DECLARE_TYPEINFO_WITH_TYPEID(Counter, NodeKind::Counter, CounterOrMeter);
};
}  // namespace P4::IR
namespace P4::IR {
class Meter : public CounterOrMeter {
 public:
    const IR::Expression* result = nullptr;
    const IR::Expression* pre_color = nullptr;
    IR::ID implementation = {};
#line 341 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    char const * kind() const override;
#line 11028 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 342 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::Type *getType() const override;
#line 11031 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Meter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Meter"_cs; }
    static cstring static_type_name() { return "Meter"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Meter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::CounterOrMeter const & a) const override;
    bool operator==(IR::Stateful const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Meter(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(srcInfo, name, annotations)
    { validate(); }
    Meter(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(name, annotations)
    { validate(); }
    Meter(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(srcInfo, annotations)
    { validate(); }
    Meter(IR::Vector<IR::Annotation> annotations) :
    CounterOrMeter(annotations)
    { validate(); }
    Meter(Util::SourceInfo srcInfo, IR::ID name) :
    CounterOrMeter(srcInfo, name)
    { validate(); }
    Meter(IR::ID name) :
    CounterOrMeter(name)
    { validate(); }
    Meter(Util::SourceInfo srcInfo) :
    CounterOrMeter(srcInfo)
    { validate(); }
    Meter() 
    { validate(); }
    IRNODE_SUBCLASS(Meter)
    DECLARE_TYPEINFO_WITH_TYPEID(Meter, NodeKind::Meter, CounterOrMeter);
};
}  // namespace P4::IR
namespace P4::IR {
class Register : public Stateful {
 public:
    IR::ID layout = {};
    int width = -1;
    bool signed_ = false;

#line 350 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    char const * kind() const override;
#line 11083 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 351 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::Type *getType() const override;
#line 11086 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Register const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Register"_cs; }
    static cstring static_type_name() { return "Register"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Register(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Stateful const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Register(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Stateful(srcInfo, name, annotations)
    { validate(); }
    Register(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Stateful(name, annotations)
    { validate(); }
    Register(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Stateful(srcInfo, annotations)
    { validate(); }
    Register(IR::Vector<IR::Annotation> annotations) :
    Stateful(annotations)
    { validate(); }
    Register(Util::SourceInfo srcInfo, IR::ID name) :
    Stateful(srcInfo, name)
    { validate(); }
    Register(IR::ID name) :
    Stateful(name)
    { validate(); }
    Register(Util::SourceInfo srcInfo) :
    Stateful(srcInfo)
    { validate(); }
    Register() 
    { validate(); }
    IRNODE_SUBCLASS(Register)
    DECLARE_TYPEINFO_WITH_TYPEID(Register, NodeKind::Register, Stateful);
};
}  // namespace P4::IR
namespace P4::IR {
class PrimitiveAction : public Node {
 public:
    bool operator==(IR::PrimitiveAction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "PrimitiveAction"_cs; }
    static cstring static_type_name() { return "PrimitiveAction"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    PrimitiveAction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    PrimitiveAction(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    PrimitiveAction() 
    { validate(); }
    IRNODE_SUBCLASS(PrimitiveAction)
    DECLARE_TYPEINFO_WITH_TYPEID(PrimitiveAction, NodeKind::PrimitiveAction, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class NameList : public Node {
 public:
    safe_vector<IR::ID> names = {};
#line 358 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    NameList(Util::SourceInfo si, cstring n);
#line 11153 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 359 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    NameList(Util::SourceInfo si, IR::ID n);
#line 11156 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 360 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dump_fields(std::ostream & out) const override;
#line 11159 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::NameList const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "NameList"_cs; }
    static cstring static_type_name() { return "NameList"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    NameList(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    NameList(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    NameList() 
    { validate(); }
    IRNODE_SUBCLASS(NameList)
    DECLARE_TYPEINFO_WITH_TYPEID(NameList, NodeKind::NameList, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class ActionArg : public Expression {
 public:
    cstring action_name;
    IR::ID name;
    bool read = false;
    bool write = false;
#line 369 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 11187 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 370 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 11190 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ActionArg const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ActionArg"_cs; }
    static cstring static_type_name() { return "ActionArg"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ActionArg(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ActionArg(Util::SourceInfo srcInfo, const IR::Type* type, cstring action_name, IR::ID name) :
    Expression(srcInfo, type), action_name(action_name), name(name)
    {
#line 368 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 11206 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(const IR::Type* type, cstring action_name, IR::ID name) :
    Expression(type), action_name(action_name), name(name)
    {
#line 368 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 11213 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(Util::SourceInfo srcInfo, cstring action_name, IR::ID name) :
    Expression(srcInfo), action_name(action_name), name(name)
    {
#line 368 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 11220 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(cstring action_name, IR::ID name) :
    action_name(action_name), name(name)
    {
#line 368 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 11227 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(ActionArg)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionArg, NodeKind::ActionArg, Expression);
};
}  // namespace P4::IR
namespace P4::IR {

class ActionFunction : public Node, public virtual IAnnotated {
 public:
    IR::ID name;
    IR::Vector<IR::Primitive> action = {};
    safe_vector<const IR::ActionArg *> args = {};
    IR::Vector<IR::Annotation> annotations;
#line 380 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 11243 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 381 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 11246 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 382 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::ActionArg *arg(cstring n) const;
#line 11249 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 387 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 11253 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 395 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 11256 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ActionFunction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ActionFunction"_cs; }
    static cstring static_type_name() { return "ActionFunction"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ActionFunction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ActionFunction(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), annotations(annotations)
    { validate(); }
    ActionFunction(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    ActionFunction(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), annotations(annotations)
    { validate(); }
    ActionFunction(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    ActionFunction(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    { validate(); }
    ActionFunction(IR::ID name) :
    name(name)
    { validate(); }
    ActionFunction(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    ActionFunction() 
    { validate(); }
    IRNODE_SUBCLASS(ActionFunction)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionFunction, NodeKind::ActionFunction, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class ActionProfile : public Attached {
 public:
    IR::ID selector = {};
    safe_vector<IR::ID> actions = {};
    int size = 0;
#line 405 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    char const * kind() const override;
#line 11303 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 406 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    bool indexed() const override;
#line 11306 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ActionProfile const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "ActionProfile"_cs; }
    static cstring static_type_name() { return "ActionProfile"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ActionProfile(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ActionProfile(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, name, annotations)
    { validate(); }
    ActionProfile(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(name, annotations)
    { validate(); }
    ActionProfile(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, annotations)
    { validate(); }
    ActionProfile(IR::Vector<IR::Annotation> annotations) :
    Attached(annotations)
    { validate(); }
    ActionProfile(Util::SourceInfo srcInfo, IR::ID name) :
    Attached(srcInfo, name)
    { validate(); }
    ActionProfile(IR::ID name) :
    Attached(name)
    { validate(); }
    ActionProfile(Util::SourceInfo srcInfo) :
    Attached(srcInfo)
    { validate(); }
    ActionProfile() 
    { validate(); }
    IRNODE_SUBCLASS(ActionProfile)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionProfile, NodeKind::ActionProfile, Attached);
};
}  // namespace P4::IR
namespace P4::IR {
class ActionSelector : public Attached {
 public:
    IR::ID key = {};
    const IR::FieldListCalculation* key_fields = nullptr;
    IR::ID mode = {};
    IR::ID type = {};
#line 414 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    char const * kind() const override;
#line 11354 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ActionSelector const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "ActionSelector"_cs; }
    static cstring static_type_name() { return "ActionSelector"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ActionSelector(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ActionSelector(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, name, annotations)
    { validate(); }
    ActionSelector(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(name, annotations)
    { validate(); }
    ActionSelector(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, annotations)
    { validate(); }
    ActionSelector(IR::Vector<IR::Annotation> annotations) :
    Attached(annotations)
    { validate(); }
    ActionSelector(Util::SourceInfo srcInfo, IR::ID name) :
    Attached(srcInfo, name)
    { validate(); }
    ActionSelector(IR::ID name) :
    Attached(name)
    { validate(); }
    ActionSelector(Util::SourceInfo srcInfo) :
    Attached(srcInfo)
    { validate(); }
    ActionSelector() 
    { validate(); }
    IRNODE_SUBCLASS(ActionSelector)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionSelector, NodeKind::ActionSelector, Attached);
};
}  // namespace P4::IR
namespace P4::IR {
class V1Table : public Node, public virtual IInstance, public virtual IAnnotated {
 public:
    IR::ID name;
    const IR::Vector<IR::Expression>* reads = 0;
    safe_vector<IR::ID> reads_types = {};
    int min_size = 0;
    int max_size = 0;
    int size = 0;
    IR::ID action_profile = {};
    safe_vector<IR::ID> actions = {};
    IR::ID default_action = {};
    bool default_action_is_const = false;
    const IR::Vector<IR::Expression>* default_action_args = 0;
    IR::TableProperties properties = {};

    IR::Vector<IR::Annotation> annotations;
#line 432 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void addProperty(const IR::Property* prop);
#line 11414 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 433 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 11417 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 434 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 11420 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 435 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 11423 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 436 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::ID Name() const override;
#line 11426 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 437 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::Type *getType() const override;
#line 11429 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::V1Table const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "V1Table"_cs; }
    static cstring static_type_name() { return "V1Table"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    V1Table(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    V1Table(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), annotations(annotations)
    { validate(); }
    V1Table(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    V1Table(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), annotations(annotations)
    { validate(); }
    V1Table(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    V1Table(Util::SourceInfo srcInfo, IR::ID name) :
    Node(srcInfo), name(name)
    { validate(); }
    V1Table(IR::ID name) :
    name(name)
    { validate(); }
    V1Table(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    V1Table() 
    { validate(); }
    IRNODE_SUBCLASS(V1Table)
    DECLARE_TYPEINFO_WITH_TYPEID(V1Table, NodeKind::V1Table, Node, IInstance, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class V1Control : public Node, public virtual IAnnotated {
 public:
    IR::ID name;
    const IR::Vector<IR::Expression>* code = nullptr;
    IR::Vector<IR::Annotation> annotations;
#line 445 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    V1Control(IR::ID n);
#line 11478 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 446 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    V1Control(Util::SourceInfo si, IR::ID n);
#line 11481 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(V1Control)
#line 448 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 11485 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 449 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 11488 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 450 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 11491 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::V1Control const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "V1Control"_cs; }
    static cstring static_type_name() { return "V1Control"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    V1Control(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    V1Control(Util::SourceInfo srcInfo, IR::ID name, const IR::Vector<IR::Expression>* code, IR::Vector<IR::Annotation> annotations) :
    Node(srcInfo), name(name), code(code), annotations(annotations)
    { validate(); }
    V1Control(IR::ID name, const IR::Vector<IR::Expression>* code, IR::Vector<IR::Annotation> annotations) :
    name(name), code(code), annotations(annotations)
    { validate(); }
    V1Control(Util::SourceInfo srcInfo, IR::ID name, const IR::Vector<IR::Expression>* code) :
    Node(srcInfo), name(name), code(code)
    { validate(); }
    V1Control(IR::ID name, const IR::Vector<IR::Expression>* code) :
    name(name), code(code)
    { validate(); }
    IRNODE_SUBCLASS(V1Control)
    DECLARE_TYPEINFO_WITH_TYPEID(V1Control, NodeKind::V1Control, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class AttribLocal : public Expression, public virtual IDeclaration {
 public:
    IR::ID name;
#line 455 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::ID getName() const override;
#line 11527 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 456 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 11530 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::AttribLocal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "AttribLocal"_cs; }
    static cstring static_type_name() { return "AttribLocal"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AttribLocal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AttribLocal(Util::SourceInfo srcInfo, const IR::Type* type, IR::ID name) :
    Expression(srcInfo, type), name(name)
    { validate(); }
    AttribLocal(const IR::Type* type, IR::ID name) :
    Expression(type), name(name)
    { validate(); }
    AttribLocal(Util::SourceInfo srcInfo, IR::ID name) :
    Expression(srcInfo), name(name)
    { validate(); }
    AttribLocal(IR::ID name) :
    name(name)
    { validate(); }
    IRNODE_SUBCLASS(AttribLocal)
    DECLARE_TYPEINFO_WITH_TYPEID(AttribLocal, NodeKind::AttribLocal, Expression, IDeclaration);
};
}  // namespace P4::IR
namespace P4::IR {
class AttribLocals : public Node, public virtual ISimpleNamespace {
 public:
    IR::NameMap<IR::AttribLocal> locals = {};
#line 462 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    Util::Enumerator<const IR::IDeclaration *> * getDeclarations() const override;
#line 11563 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 464 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::IDeclaration *getDeclByName(cstring name) const override;
#line 11566 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 465 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    const IR::IDeclaration *getDeclByName(std::string_view name) const override;
#line 11569 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::AttribLocals const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "AttribLocals"_cs; }
    static cstring static_type_name() { return "AttribLocals"_cs; }
    void toJSON(JSONGenerator & json) const override;
    AttribLocals(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    AttribLocals(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    AttribLocals() 
    { validate(); }
    IRNODE_SUBCLASS(AttribLocals)
    DECLARE_TYPEINFO_WITH_TYPEID(AttribLocals, NodeKind::AttribLocals, Node, ISimpleNamespace);
};
}  // namespace P4::IR
namespace P4::IR {
class Attribute : public Declaration {
 public:
    const IR::Type* type = nullptr;
    const IR::AttribLocals* locals = nullptr;
    bool optional = false;
#line 472 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 11598 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Attribute const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "Attribute"_cs; }
    static cstring static_type_name() { return "Attribute"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Attribute(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Attribute(Util::SourceInfo srcInfo, IR::ID name) :
    Declaration(srcInfo, name)
    { validate(); }
    Attribute(IR::ID name) :
    Declaration(name)
    { validate(); }
    IRNODE_SUBCLASS(Attribute)
    DECLARE_TYPEINFO_WITH_TYPEID(Attribute, NodeKind::Attribute, Declaration);
};
}  // namespace P4::IR
namespace P4::IR {
class GlobalRef : public Expression {
 public:
    const IR::Node* obj = nullptr;


#line 479 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void validate() const override;
#line 11630 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 480 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 11633 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 481 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    IR::ID Name() const;
#line 11636 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 482 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 11639 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::GlobalRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "GlobalRef"_cs; }
    static cstring static_type_name() { return "GlobalRef"_cs; }
    void toJSON(JSONGenerator & json) const override;
    GlobalRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    GlobalRef(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Node* obj) :
    Expression(srcInfo, type), obj(obj)
    {
#line 478 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = obj->to<IInstance>()->getType(); }
#line 11656 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    GlobalRef(const IR::Type* type, const IR::Node* obj) :
    Expression(type), obj(obj)
    {
#line 478 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = obj->to<IInstance>()->getType(); }
#line 11663 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    GlobalRef(Util::SourceInfo srcInfo, const IR::Node* obj) :
    Expression(srcInfo), obj(obj)
    {
#line 478 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = obj->to<IInstance>()->getType(); }
#line 11670 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    GlobalRef(const IR::Node* obj) :
    obj(obj)
    {
#line 478 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = obj->to<IInstance>()->getType(); }
#line 11677 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(GlobalRef)
    DECLARE_TYPEINFO_WITH_TYPEID(GlobalRef, NodeKind::GlobalRef, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class AttributeRef : public Expression {
 public:
    cstring extern_name;
    const IR::Type_Extern* extern_type = nullptr;
    const IR::Attribute* attrib = nullptr;
#line 490 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    cstring toString() const override;
#line 11691 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 491 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void dbprint(std::ostream & out) const override;
#line 11694 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::AttributeRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "AttributeRef"_cs; }
    static cstring static_type_name() { return "AttributeRef"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AttributeRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AttributeRef(Util::SourceInfo srcInfo, const IR::Type* type, cstring extern_name, const IR::Type_Extern* extern_type, const IR::Attribute* attrib) :
    Expression(srcInfo, type), extern_name(extern_name), extern_type(extern_type), attrib(attrib)
    {
#line 489 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = attrib->type; }
#line 11713 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    AttributeRef(const IR::Type* type, cstring extern_name, const IR::Type_Extern* extern_type, const IR::Attribute* attrib) :
    Expression(type), extern_name(extern_name), extern_type(extern_type), attrib(attrib)
    {
#line 489 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = attrib->type; }
#line 11720 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    AttributeRef(Util::SourceInfo srcInfo, cstring extern_name, const IR::Type_Extern* extern_type, const IR::Attribute* attrib) :
    Expression(srcInfo), extern_name(extern_name), extern_type(extern_type), attrib(attrib)
    {
#line 489 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = attrib->type; }
#line 11727 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    AttributeRef(cstring extern_name, const IR::Type_Extern* extern_type, const IR::Attribute* attrib) :
    extern_name(extern_name), extern_type(extern_type), attrib(attrib)
    {
#line 489 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
{ type = attrib->type; }
#line 11734 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(AttributeRef)
    DECLARE_TYPEINFO_WITH_TYPEID(AttributeRef, NodeKind::AttributeRef, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
class V1Program : public Node {
 public:
    IR::NameMap<IR::Node, std::multimap> scope;
#line 498 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    explicit V1Program();
#line 11746 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 500 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    template<class T> const T *get(cstring name) const { return scope.get<T>(name); }
#line 11749 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 502 "/builddir/build/BUILD/p4c-1.2.5.8/frontends/p4-14/ir-v1.def"
    void add(cstring name, IR::Node const * n);
#line 11752 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(V1Program)
    bool operator==(IR::V1Program const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "V1Program"_cs; }
    static cstring static_type_name() { return "V1Program"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    V1Program(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(V1Program)
    DECLARE_TYPEINFO_WITH_TYPEID(V1Program, NodeKind::V1Program, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/** @} */
/* end group irdefs */
// Represent a signed integer value using just 'width' bits.
// Special operation provided by BMv2
class IntMod : public Operation_Unary {
 public:
    unsigned width;
    cstring getStringOp() const override { return cstring("><"); }
    int getPrecedence() const override { return DBPrint::Prec_Low; }
    bool operator==(IR::IntMod const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "IntMod"_cs; }
    static cstring static_type_name() { return "IntMod"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    IntMod(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IntMod(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, unsigned width) :
    Operation_Unary(srcInfo, type, expr), width(width)
    { validate(); }
    IntMod(const IR::Type* type, const IR::Expression* expr, unsigned width) :
    Operation_Unary(type, expr), width(width)
    { validate(); }
    IntMod(Util::SourceInfo srcInfo, const IR::Expression* expr, unsigned width) :
    Operation_Unary(srcInfo, expr), width(width)
    { validate(); }
    IntMod(const IR::Expression* expr, unsigned width) :
    Operation_Unary(expr), width(width)
    { validate(); }
    IRNODE_SUBCLASS(IntMod)
    DECLARE_TYPEINFO_WITH_TYPEID(IntMod, NodeKind::IntMod, Operation_Unary);
};
}  // namespace P4::IR
namespace P4::IR {
class IDPDKNode : public virtual INode {
 public:
#line 2 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    virtual std::ostream & toSpec(std::ostream & out) const = 0;
#line 11813 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    DECLARE_TYPEINFO_WITH_TYPEID(IDPDKNode, NodeKind::IDPDKNode, INode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkDeclaration : public Node, public virtual IDPDKNode {
 public:
    const IR::Declaration* global = nullptr;
#line 7 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 11823 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkDeclaration const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkDeclaration"_cs; }
    static cstring static_type_name() { return "DpdkDeclaration"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkDeclaration(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DpdkDeclaration(Util::SourceInfo srcInfo, const IR::Declaration* global) :
    Node(srcInfo), global(global)
    { validate(); }
    DpdkDeclaration(const IR::Declaration* global) :
    global(global)
    { validate(); }
    IRNODE_SUBCLASS(DpdkDeclaration)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkDeclaration, NodeKind::DpdkDeclaration, Node, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkExternDeclaration : public Declaration_Instance, public virtual IDPDKNode {
 public:
#line 12 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 11850 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkExternDeclaration const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkExternDeclaration"_cs; }
    static cstring static_type_name() { return "DpdkExternDeclaration"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkExternDeclaration(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Declaration_Instance const & a) const override;
    bool operator==(IR::Declaration const & a) const override;
    bool operator==(IR::StatOrDecl const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkExternDeclaration(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration_Instance(srcInfo, name, annotations, type, arguments, initializer)
    { validate(); }
    DpdkExternDeclaration(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration_Instance(name, annotations, type, arguments, initializer)
    { validate(); }
    DpdkExternDeclaration(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration_Instance(srcInfo, name, type, arguments, initializer)
    { validate(); }
    DpdkExternDeclaration(IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments, const IR::BlockStatement* initializer) :
    Declaration_Instance(name, type, arguments, initializer)
    { validate(); }
    DpdkExternDeclaration(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration_Instance(srcInfo, name, annotations, type, arguments)
    { validate(); }
    DpdkExternDeclaration(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration_Instance(name, annotations, type, arguments)
    { validate(); }
    DpdkExternDeclaration(Util::SourceInfo srcInfo, IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration_Instance(srcInfo, name, type, arguments)
    { validate(); }
    DpdkExternDeclaration(IR::ID name, const IR::Type* type, const IR::Vector<IR::Argument>* arguments) :
    Declaration_Instance(name, type, arguments)
    { validate(); }
    IRNODE_SUBCLASS(DpdkExternDeclaration)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkExternDeclaration, NodeKind::DpdkExternDeclaration, Declaration_Instance, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkHeaderType : public Type_Header, public virtual IDPDKNode {
 public:
#line 17 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 11895 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkHeaderType const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkHeaderType"_cs; }
    static cstring static_type_name() { return "DpdkHeaderType"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkHeaderType(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Header const & a) const override;
    bool operator==(IR::Type_StructLike const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(srcInfo, name, annotations, typeParameters, fields)
    { validate(); }
    DpdkHeaderType(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(name, annotations, typeParameters, fields)
    { validate(); }
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(srcInfo, name, typeParameters, fields)
    { validate(); }
    DpdkHeaderType(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(name, typeParameters, fields)
    { validate(); }
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(srcInfo, name, annotations, fields)
    { validate(); }
    DpdkHeaderType(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(name, annotations, fields)
    { validate(); }
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(srcInfo, name, fields)
    { validate(); }
    DpdkHeaderType(IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_Header(name, fields)
    { validate(); }
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Header(srcInfo, name, annotations, typeParameters)
    { validate(); }
    DpdkHeaderType(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Header(name, annotations, typeParameters)
    { validate(); }
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Header(srcInfo, name, typeParameters)
    { validate(); }
    DpdkHeaderType(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Header(name, typeParameters)
    { validate(); }
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Header(srcInfo, name, annotations)
    { validate(); }
    DpdkHeaderType(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Header(name, annotations)
    { validate(); }
    DpdkHeaderType(Util::SourceInfo srcInfo, IR::ID name) :
    Type_Header(srcInfo, name)
    { validate(); }
    DpdkHeaderType(IR::ID name) :
    Type_Header(name)
    { validate(); }
    IRNODE_SUBCLASS(DpdkHeaderType)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkHeaderType, NodeKind::DpdkHeaderType, Type_Header, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkHeaderInstance : public Node, public virtual IDPDKNode {
 public:
    const IR::Declaration_Variable* name = nullptr;
    const IR::Type_Header* headerType = nullptr;
#line 24 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 11967 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkHeaderInstance const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkHeaderInstance"_cs; }
    static cstring static_type_name() { return "DpdkHeaderInstance"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkHeaderInstance(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DpdkHeaderInstance(Util::SourceInfo srcInfo, const IR::Declaration_Variable* name, const IR::Type_Header* headerType) :
    Node(srcInfo), name(name), headerType(headerType)
    { validate(); }
    DpdkHeaderInstance(const IR::Declaration_Variable* name, const IR::Type_Header* headerType) :
    name(name), headerType(headerType)
    { validate(); }
    IRNODE_SUBCLASS(DpdkHeaderInstance)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkHeaderInstance, NodeKind::DpdkHeaderInstance, Node, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkStructType : public Type_Struct, public virtual IDPDKNode {
 public:
#line 29 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 11994 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkStructType const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkStructType"_cs; }
    static cstring static_type_name() { return "DpdkStructType"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkStructType(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Struct const & a) const override;
    bool operator==(IR::Type_StructLike const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(srcInfo, name, annotations, typeParameters, fields)
    { validate(); }
    DpdkStructType(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(name, annotations, typeParameters, fields)
    { validate(); }
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(srcInfo, name, typeParameters, fields)
    { validate(); }
    DpdkStructType(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(name, typeParameters, fields)
    { validate(); }
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(srcInfo, name, annotations, fields)
    { validate(); }
    DpdkStructType(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(name, annotations, fields)
    { validate(); }
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(srcInfo, name, fields)
    { validate(); }
    DpdkStructType(IR::ID name, IR::IndexedVector<IR::StructField> fields) :
    Type_Struct(name, fields)
    { validate(); }
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Struct(srcInfo, name, annotations, typeParameters)
    { validate(); }
    DpdkStructType(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters) :
    Type_Struct(name, annotations, typeParameters)
    { validate(); }
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Struct(srcInfo, name, typeParameters)
    { validate(); }
    DpdkStructType(IR::ID name, const IR::TypeParameters* typeParameters) :
    Type_Struct(name, typeParameters)
    { validate(); }
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Struct(srcInfo, name, annotations)
    { validate(); }
    DpdkStructType(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Type_Struct(name, annotations)
    { validate(); }
    DpdkStructType(Util::SourceInfo srcInfo, IR::ID name) :
    Type_Struct(srcInfo, name)
    { validate(); }
    DpdkStructType(IR::ID name) :
    Type_Struct(name)
    { validate(); }
    IRNODE_SUBCLASS(DpdkStructType)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkStructType, NodeKind::DpdkStructType, Type_Struct, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkAsmStatement : public Node, public virtual IDPDKNode {
 public:
#line 34 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12064 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkAsmStatement"_cs; }
    static cstring static_type_name() { return "DpdkAsmStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkAsmStatement(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    DpdkAsmStatement(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    DpdkAsmStatement() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(DpdkAsmStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkAsmStatement, NodeKind::DpdkAsmStatement, Node, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkAction : public Node, public virtual IAnnotated {
 public:
    IR::Vector<IR::Annotation> annotations;
    IR::IndexedVector<IR::DpdkAsmStatement> statements;
    IR::ID name;
    IR::ParameterList para;
#line 42 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const;
#line 12091 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 43 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 12094 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 44 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 12097 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkAction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkAction"_cs; }
    static cstring static_type_name() { return "DpdkAction"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkAction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DpdkAction(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::DpdkAsmStatement> statements, IR::ID name, IR::ParameterList para) :
    Node(srcInfo), annotations(annotations), statements(statements), name(name), para(para)
    { validate(); }
    DpdkAction(IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::DpdkAsmStatement> statements, IR::ID name, IR::ParameterList para) :
    annotations(annotations), statements(statements), name(name), para(para)
    { validate(); }
    DpdkAction(Util::SourceInfo srcInfo, IR::IndexedVector<IR::DpdkAsmStatement> statements, IR::ID name, IR::ParameterList para) :
    Node(srcInfo), statements(statements), name(name), para(para)
    { validate(); }
    DpdkAction(IR::IndexedVector<IR::DpdkAsmStatement> statements, IR::ID name, IR::ParameterList para) :
    statements(statements), name(name), para(para)
    { validate(); }
    IRNODE_SUBCLASS(DpdkAction)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkAction, NodeKind::DpdkAction, Node, IAnnotated);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkTable : public Node {
 public:
    cstring name;
    const IR::Key* match_keys = nullptr;
    const IR::ActionList* actions = nullptr;
    const IR::Expression* default_action = nullptr;
    const IR::TableProperties* properties = nullptr;
    IR::ParameterList default_action_paraList;
#line 55 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    const IR::Key *getKey() const;
#line 12137 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 63 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    const IR::EntriesList *getEntries() const;
#line 12140 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 73 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const;
#line 12143 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkTable const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "DpdkTable"_cs; }
    static cstring static_type_name() { return "DpdkTable"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkTable(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DpdkTable(Util::SourceInfo srcInfo, cstring name, const IR::Key* match_keys, const IR::ActionList* actions, const IR::Expression* default_action, const IR::TableProperties* properties, IR::ParameterList default_action_paraList) :
    Node(srcInfo), name(name), match_keys(match_keys), actions(actions), default_action(default_action), properties(properties), default_action_paraList(default_action_paraList)
    { validate(); }
    DpdkTable(cstring name, const IR::Key* match_keys, const IR::ActionList* actions, const IR::Expression* default_action, const IR::TableProperties* properties, IR::ParameterList default_action_paraList) :
    name(name), match_keys(match_keys), actions(actions), default_action(default_action), properties(properties), default_action_paraList(default_action_paraList)
    { validate(); }
    IRNODE_SUBCLASS(DpdkTable)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkTable, NodeKind::DpdkTable, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkSelector : public Node {
 public:
    cstring name;
    const IR::Expression* group_id = nullptr;
    const IR::Expression* member_id = nullptr;
    const IR::Key* selectors = nullptr;
    int n_groups_max;
    int n_members_per_group_max;
#line 86 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const;
#line 12176 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkSelector const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "DpdkSelector"_cs; }
    static cstring static_type_name() { return "DpdkSelector"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkSelector(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DpdkSelector(Util::SourceInfo srcInfo, cstring name, const IR::Expression* group_id, const IR::Expression* member_id, const IR::Key* selectors, int n_groups_max, int n_members_per_group_max) :
    Node(srcInfo), name(name), group_id(group_id), member_id(member_id), selectors(selectors), n_groups_max(n_groups_max), n_members_per_group_max(n_members_per_group_max)
    { validate(); }
    DpdkSelector(cstring name, const IR::Expression* group_id, const IR::Expression* member_id, const IR::Key* selectors, int n_groups_max, int n_members_per_group_max) :
    name(name), group_id(group_id), member_id(member_id), selectors(selectors), n_groups_max(n_groups_max), n_members_per_group_max(n_members_per_group_max)
    { validate(); }
    IRNODE_SUBCLASS(DpdkSelector)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkSelector, NodeKind::DpdkSelector, Node);
};
}  // namespace P4::IR
namespace P4::IR {

class DpdkLearner : public Node {
 public:
    cstring name;
    const IR::Key* match_keys = nullptr;
    const IR::ActionList* actions = nullptr;
    const IR::Expression* default_action = nullptr;
    const IR::TableProperties* properties = nullptr;
#line 102 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const;
#line 12209 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkLearner const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "DpdkLearner"_cs; }
    static cstring static_type_name() { return "DpdkLearner"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkLearner(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DpdkLearner(Util::SourceInfo srcInfo, cstring name, const IR::Key* match_keys, const IR::ActionList* actions, const IR::Expression* default_action, const IR::TableProperties* properties) :
    Node(srcInfo), name(name), match_keys(match_keys), actions(actions), default_action(default_action), properties(properties)
    { validate(); }
    DpdkLearner(cstring name, const IR::Key* match_keys, const IR::ActionList* actions, const IR::Expression* default_action, const IR::TableProperties* properties) :
    name(name), match_keys(match_keys), actions(actions), default_action(default_action), properties(properties)
    { validate(); }
    IRNODE_SUBCLASS(DpdkLearner)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkLearner, NodeKind::DpdkLearner, Node);
};
}  // namespace P4::IR
namespace P4::IR {

class DpdkAsmProgram : public Node {
 public:
    IR::IndexedVector<IR::DpdkHeaderType> headerType;
    IR::IndexedVector<IR::DpdkStructType> structType;
    IR::IndexedVector<IR::DpdkHeaderInstance> headerInstance;
    IR::IndexedVector<IR::DpdkExternDeclaration> externDeclarations;
    IR::IndexedVector<IR::DpdkAction> actions;
    IR::IndexedVector<IR::DpdkTable> tables;
    IR::IndexedVector<IR::DpdkSelector> selectors;
    IR::IndexedVector<IR::DpdkLearner> learners;
    IR::IndexedVector<IR::DpdkAsmStatement> statements;
    IR::IndexedVector<IR::DpdkDeclaration> globals;
#line 119 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const;
#line 12247 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkAsmProgram const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkAsmProgram"_cs; }
    static cstring static_type_name() { return "DpdkAsmProgram"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkAsmProgram(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DpdkAsmProgram(Util::SourceInfo srcInfo, IR::IndexedVector<IR::DpdkHeaderType> headerType, IR::IndexedVector<IR::DpdkStructType> structType, IR::IndexedVector<IR::DpdkHeaderInstance> headerInstance, IR::IndexedVector<IR::DpdkExternDeclaration> externDeclarations, IR::IndexedVector<IR::DpdkAction> actions, IR::IndexedVector<IR::DpdkTable> tables, IR::IndexedVector<IR::DpdkSelector> selectors, IR::IndexedVector<IR::DpdkLearner> learners, IR::IndexedVector<IR::DpdkAsmStatement> statements, IR::IndexedVector<IR::DpdkDeclaration> globals) :
    Node(srcInfo), headerType(headerType), structType(structType), headerInstance(headerInstance), externDeclarations(externDeclarations), actions(actions), tables(tables), selectors(selectors), learners(learners), statements(statements), globals(globals)
    { validate(); }
    DpdkAsmProgram(IR::IndexedVector<IR::DpdkHeaderType> headerType, IR::IndexedVector<IR::DpdkStructType> structType, IR::IndexedVector<IR::DpdkHeaderInstance> headerInstance, IR::IndexedVector<IR::DpdkExternDeclaration> externDeclarations, IR::IndexedVector<IR::DpdkAction> actions, IR::IndexedVector<IR::DpdkTable> tables, IR::IndexedVector<IR::DpdkSelector> selectors, IR::IndexedVector<IR::DpdkLearner> learners, IR::IndexedVector<IR::DpdkAsmStatement> statements, IR::IndexedVector<IR::DpdkDeclaration> globals) :
    headerType(headerType), structType(structType), headerInstance(headerInstance), externDeclarations(externDeclarations), actions(actions), tables(tables), selectors(selectors), learners(learners), statements(statements), globals(globals)
    { validate(); }
    IRNODE_SUBCLASS(DpdkAsmProgram)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkAsmProgram, NodeKind::DpdkAsmProgram, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkListStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    IR::IndexedVector<IR::DpdkAsmStatement> statements;
#line 124 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12276 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkListStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkListStatement"_cs; }
    static cstring static_type_name() { return "DpdkListStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkListStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkListStatement(Util::SourceInfo srcInfo, IR::IndexedVector<IR::DpdkAsmStatement> statements) :
    DpdkAsmStatement(srcInfo), statements(statements)
    { validate(); }
    DpdkListStatement(IR::IndexedVector<IR::DpdkAsmStatement> statements) :
    statements(statements)
    { validate(); }
    DpdkListStatement(Util::SourceInfo srcInfo) :
    DpdkAsmStatement(srcInfo)
    { validate(); }
    DpdkListStatement() 
    { validate(); }
    IRNODE_SUBCLASS(DpdkListStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkListStatement, NodeKind::DpdkListStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkApplyStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring table;
#line 129 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12311 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkApplyStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkApplyStatement"_cs; }
    static cstring static_type_name() { return "DpdkApplyStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkApplyStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkApplyStatement(Util::SourceInfo srcInfo, cstring table) :
    DpdkAsmStatement(srcInfo), table(table)
    { validate(); }
    DpdkApplyStatement(cstring table) :
    table(table)
    { validate(); }
    IRNODE_SUBCLASS(DpdkApplyStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkApplyStatement, NodeKind::DpdkApplyStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkLearnStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    IR::ID action;
    const IR::Expression* timeout = nullptr;
    const IR::Expression* argument = nullptr;
#line 136 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12341 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkLearnStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkLearnStatement"_cs; }
    static cstring static_type_name() { return "DpdkLearnStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkLearnStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkLearnStatement(Util::SourceInfo srcInfo, IR::ID action, const IR::Expression* timeout, const IR::Expression* argument) :
    DpdkAsmStatement(srcInfo), action(action), timeout(timeout), argument(argument)
    { validate(); }
    DpdkLearnStatement(IR::ID action, const IR::Expression* timeout, const IR::Expression* argument) :
    action(action), timeout(timeout), argument(argument)
    { validate(); }
    DpdkLearnStatement(Util::SourceInfo srcInfo, IR::ID action, const IR::Expression* timeout) :
    DpdkAsmStatement(srcInfo), action(action), timeout(timeout)
    { validate(); }
    DpdkLearnStatement(IR::ID action, const IR::Expression* timeout) :
    action(action), timeout(timeout)
    { validate(); }
    IRNODE_SUBCLASS(DpdkLearnStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkLearnStatement, NodeKind::DpdkLearnStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkMirrorStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* slotId = nullptr;
    const IR::Expression* sessionId = nullptr;
#line 142 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12379 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkMirrorStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkMirrorStatement"_cs; }
    static cstring static_type_name() { return "DpdkMirrorStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkMirrorStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkMirrorStatement(Util::SourceInfo srcInfo, const IR::Expression* slotId, const IR::Expression* sessionId) :
    DpdkAsmStatement(srcInfo), slotId(slotId), sessionId(sessionId)
    { validate(); }
    DpdkMirrorStatement(const IR::Expression* slotId, const IR::Expression* sessionId) :
    slotId(slotId), sessionId(sessionId)
    { validate(); }
    IRNODE_SUBCLASS(DpdkMirrorStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkMirrorStatement, NodeKind::DpdkMirrorStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkEmitStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* header = nullptr;
#line 147 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12409 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkEmitStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkEmitStatement"_cs; }
    static cstring static_type_name() { return "DpdkEmitStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkEmitStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkEmitStatement(Util::SourceInfo srcInfo, const IR::Expression* header) :
    DpdkAsmStatement(srcInfo), header(header)
    { validate(); }
    DpdkEmitStatement(const IR::Expression* header) :
    header(header)
    { validate(); }
    IRNODE_SUBCLASS(DpdkEmitStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkEmitStatement, NodeKind::DpdkEmitStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkExtractStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* header = nullptr;
    const IR::Expression* length = nullptr;
#line 153 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12440 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkExtractStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkExtractStatement"_cs; }
    static cstring static_type_name() { return "DpdkExtractStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkExtractStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkExtractStatement(Util::SourceInfo srcInfo, const IR::Expression* header, const IR::Expression* length) :
    DpdkAsmStatement(srcInfo), header(header), length(length)
    { validate(); }
    DpdkExtractStatement(const IR::Expression* header, const IR::Expression* length) :
    header(header), length(length)
    { validate(); }
    DpdkExtractStatement(Util::SourceInfo srcInfo, const IR::Expression* header) :
    DpdkAsmStatement(srcInfo), header(header)
    { validate(); }
    DpdkExtractStatement(const IR::Expression* header) :
    header(header)
    { validate(); }
    IRNODE_SUBCLASS(DpdkExtractStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkExtractStatement, NodeKind::DpdkExtractStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkLookaheadStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* header = nullptr;
#line 158 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12476 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkLookaheadStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkLookaheadStatement"_cs; }
    static cstring static_type_name() { return "DpdkLookaheadStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkLookaheadStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkLookaheadStatement(Util::SourceInfo srcInfo, const IR::Expression* header) :
    DpdkAsmStatement(srcInfo), header(header)
    { validate(); }
    DpdkLookaheadStatement(const IR::Expression* header) :
    header(header)
    { validate(); }
    IRNODE_SUBCLASS(DpdkLookaheadStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkLookaheadStatement, NodeKind::DpdkLookaheadStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpStatement : public DpdkAsmStatement {
 public:
    cstring instruction;
    cstring label;
#line 164 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12507 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 166 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpStatement(cstring instruction, cstring l);
#line 12510 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpStatement(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_ABSTRACT_SUBCLASS(DpdkJmpStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpStatement, NodeKind::DpdkJmpStatement, DpdkAsmStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpLabelStatement : public DpdkJmpStatement {
 public:
#line 172 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpLabelStatement(cstring label);
#line 12529 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpLabelStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpLabelStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpLabelStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpLabelStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpLabelStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpLabelStatement, NodeKind::DpdkJmpLabelStatement, DpdkJmpStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpHitStatement : public DpdkJmpStatement {
 public:
#line 179 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpHitStatement(cstring label);
#line 12550 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpHitStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpHitStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpHitStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpHitStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpHitStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpHitStatement, NodeKind::DpdkJmpHitStatement, DpdkJmpStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpMissStatement : public DpdkJmpStatement {
 public:
#line 186 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpMissStatement(cstring label);
#line 12570 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpMissStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpMissStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpMissStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpMissStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpMissStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpMissStatement, NodeKind::DpdkJmpMissStatement, DpdkJmpStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpActionStatement : public DpdkJmpStatement {
 public:
    IR::ID action;
#line 192 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12591 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 195 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpActionStatement(cstring instruction, cstring label, IR::ID action);
#line 12594 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpActionStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpActionStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpActionStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpActionStatement(JSONLoader & json);
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_ABSTRACT_SUBCLASS(DpdkJmpActionStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpActionStatement, NodeKind::DpdkJmpActionStatement, DpdkJmpStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpIfActionRunStatement : public DpdkJmpActionStatement {
 public:
#line 202 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpIfActionRunStatement(cstring label, cstring act);
#line 12614 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpIfActionRunStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpIfActionRunStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpIfActionRunStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpIfActionRunStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpActionStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpIfActionRunStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpIfActionRunStatement, NodeKind::DpdkJmpIfActionRunStatement, DpdkJmpActionStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpIfActionNotRunStatement : public DpdkJmpActionStatement {
 public:
#line 209 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpIfActionNotRunStatement(cstring label, cstring act);
#line 12635 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpIfActionNotRunStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpIfActionNotRunStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpIfActionNotRunStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpIfActionNotRunStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpActionStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpIfActionNotRunStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpIfActionNotRunStatement, NodeKind::DpdkJmpIfActionNotRunStatement, DpdkJmpActionStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpHeaderStatement : public DpdkJmpStatement {
 public:
    const IR::Expression* header = nullptr;
#line 215 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12657 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 217 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpHeaderStatement(cstring instruction, cstring label, const IR::Expression* hdr);
#line 12660 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpHeaderStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkJmpHeaderStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpHeaderStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpHeaderStatement(JSONLoader & json);
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_ABSTRACT_SUBCLASS(DpdkJmpHeaderStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpHeaderStatement, NodeKind::DpdkJmpHeaderStatement, DpdkJmpStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpIfInvalidStatement : public DpdkJmpHeaderStatement {
 public:
#line 223 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpIfInvalidStatement(cstring label, const IR::Expression* hdr);
#line 12682 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpIfInvalidStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpIfInvalidStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpIfInvalidStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpIfInvalidStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpHeaderStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpIfInvalidStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpIfInvalidStatement, NodeKind::DpdkJmpIfInvalidStatement, DpdkJmpHeaderStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpIfValidStatement : public DpdkJmpHeaderStatement {
 public:
#line 230 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpIfValidStatement(cstring label, const IR::Expression* hdr);
#line 12704 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpIfValidStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpIfValidStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpIfValidStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpIfValidStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpHeaderStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpIfValidStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpIfValidStatement, NodeKind::DpdkJmpIfValidStatement, DpdkJmpHeaderStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpCondStatement : public DpdkJmpStatement {
 public:
    const IR::Expression* src1 = nullptr;
    const IR::Expression* src2 = nullptr;
#line 237 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12727 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 239 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpCondStatement(cstring instruction, cstring label, const IR::Expression* src1, const IR::Expression* src2);
#line 12730 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpCondStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkJmpCondStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpCondStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpCondStatement(JSONLoader & json);
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_ABSTRACT_SUBCLASS(DpdkJmpCondStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpCondStatement, NodeKind::DpdkJmpCondStatement, DpdkJmpStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpEqualStatement : public DpdkJmpCondStatement, public virtual IDPDKNode {
 public:
#line 244 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpEqualStatement(cstring label, const IR::Expression* src1, const IR::Expression* src2);
#line 12752 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpEqualStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpEqualStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpEqualStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpEqualStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpCondStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpEqualStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpEqualStatement, NodeKind::DpdkJmpEqualStatement, DpdkJmpCondStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpNotEqualStatement : public DpdkJmpCondStatement, public virtual IDPDKNode {
 public:
#line 251 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpNotEqualStatement(cstring label, const IR::Expression* src1, const IR::Expression* src2);
#line 12774 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpNotEqualStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpNotEqualStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpNotEqualStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpNotEqualStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpCondStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpNotEqualStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpNotEqualStatement, NodeKind::DpdkJmpNotEqualStatement, DpdkJmpCondStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpGreaterEqualStatement : public DpdkJmpCondStatement, public virtual IDPDKNode {
 public:
#line 258 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpGreaterEqualStatement(cstring label, const IR::Expression* src1, const IR::Expression* src2);
#line 12796 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpGreaterEqualStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpGreaterEqualStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpGreaterEqualStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpGreaterEqualStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpCondStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpGreaterEqualStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpGreaterEqualStatement, NodeKind::DpdkJmpGreaterEqualStatement, DpdkJmpCondStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpGreaterStatement : public DpdkJmpCondStatement, public virtual IDPDKNode {
 public:
#line 265 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpGreaterStatement(cstring label, const IR::Expression* src1, const IR::Expression* src2);
#line 12817 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpGreaterStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpGreaterStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpGreaterStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpGreaterStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpCondStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpGreaterStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpGreaterStatement, NodeKind::DpdkJmpGreaterStatement, DpdkJmpCondStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpLessOrEqualStatement : public DpdkJmpCondStatement, public virtual IDPDKNode {
 public:
#line 272 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpLessOrEqualStatement(cstring label, const IR::Expression* src1, const IR::Expression* src2);
#line 12838 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpLessOrEqualStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpLessOrEqualStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpLessOrEqualStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpLessOrEqualStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpCondStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpLessOrEqualStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpLessOrEqualStatement, NodeKind::DpdkJmpLessOrEqualStatement, DpdkJmpCondStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkJmpLessStatement : public DpdkJmpCondStatement, public virtual IDPDKNode {
 public:
#line 279 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkJmpLessStatement(cstring label, const IR::Expression* src1, const IR::Expression* src2);
#line 12859 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkJmpLessStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkJmpLessStatement"_cs; }
    static cstring static_type_name() { return "DpdkJmpLessStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkJmpLessStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkJmpCondStatement const & a) const override;
    bool operator==(IR::DpdkJmpStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkJmpLessStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkJmpLessStatement, NodeKind::DpdkJmpLessStatement, DpdkJmpCondStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkRxStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* port = nullptr;
#line 285 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12881 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkRxStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkRxStatement"_cs; }
    static cstring static_type_name() { return "DpdkRxStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkRxStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkRxStatement(Util::SourceInfo srcInfo, const IR::Expression* port) :
    DpdkAsmStatement(srcInfo), port(port)
    { validate(); }
    DpdkRxStatement(const IR::Expression* port) :
    port(port)
    { validate(); }
    IRNODE_SUBCLASS(DpdkRxStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkRxStatement, NodeKind::DpdkRxStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkTxStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* port = nullptr;
#line 291 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12910 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkTxStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkTxStatement"_cs; }
    static cstring static_type_name() { return "DpdkTxStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkTxStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkTxStatement(Util::SourceInfo srcInfo, const IR::Expression* port) :
    DpdkAsmStatement(srcInfo), port(port)
    { validate(); }
    DpdkTxStatement(const IR::Expression* port) :
    port(port)
    { validate(); }
    IRNODE_SUBCLASS(DpdkTxStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkTxStatement, NodeKind::DpdkTxStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkAssignmentStatement : public DpdkAsmStatement {
 public:
    cstring instruction;
    const IR::Expression* dst = nullptr;
#line 299 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkAssignmentStatement(cstring instruction, const IR::Expression* dst);
#line 12940 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkAssignmentStatement"_cs; }
    static cstring static_type_name() { return "DpdkAssignmentStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkAssignmentStatement(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_ABSTRACT_SUBCLASS(DpdkAssignmentStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkAssignmentStatement, NodeKind::DpdkAssignmentStatement, DpdkAsmStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkUnaryStatement : public DpdkAssignmentStatement {
 public:
    const IR::Expression* src = nullptr;
#line 305 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 12963 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 307 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkUnaryStatement(cstring instruction, const IR::Expression* dst, const IR::Expression* src);
#line 12966 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkUnaryStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkUnaryStatement"_cs; }
    static cstring static_type_name() { return "DpdkUnaryStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkUnaryStatement(JSONLoader & json);
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_ABSTRACT_SUBCLASS(DpdkUnaryStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkUnaryStatement, NodeKind::DpdkUnaryStatement, DpdkAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkMovStatement : public DpdkUnaryStatement {
 public:
#line 312 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkMovStatement(const IR::Expression* dst, const IR::Expression* src);
#line 12988 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkMovStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkMovStatement"_cs; }
    static cstring static_type_name() { return "DpdkMovStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkMovStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkUnaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkMovStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkMovStatement, NodeKind::DpdkMovStatement, DpdkUnaryStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkMovhStatement : public DpdkUnaryStatement {
 public:
#line 318 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkMovhStatement(const IR::Expression* dst, const IR::Expression* src);
#line 13010 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkMovhStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkMovhStatement"_cs; }
    static cstring static_type_name() { return "DpdkMovhStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkMovhStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkUnaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkMovhStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkMovhStatement, NodeKind::DpdkMovhStatement, DpdkUnaryStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkBinaryStatement : public DpdkAssignmentStatement {
 public:
    const IR::Expression* src1 = nullptr;
    const IR::Expression* src2 = nullptr;
#line 326 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13034 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 328 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkBinaryStatement(cstring instruction, const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13037 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkBinaryStatement"_cs; }
    static cstring static_type_name() { return "DpdkBinaryStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkBinaryStatement(JSONLoader & json);
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_ABSTRACT_SUBCLASS(DpdkBinaryStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkBinaryStatement, NodeKind::DpdkBinaryStatement, DpdkAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkAddStatement : public DpdkBinaryStatement {
 public:
#line 335 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkAddStatement(const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13059 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkAddStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkAddStatement"_cs; }
    static cstring static_type_name() { return "DpdkAddStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkAddStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkAddStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkAddStatement, NodeKind::DpdkAddStatement, DpdkBinaryStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkAndStatement : public DpdkBinaryStatement, public virtual IDPDKNode {
 public:
#line 342 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkAndStatement(const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13080 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkAndStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkAndStatement"_cs; }
    static cstring static_type_name() { return "DpdkAndStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkAndStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkAndStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkAndStatement, NodeKind::DpdkAndStatement, DpdkBinaryStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkShlStatement : public DpdkBinaryStatement, public virtual IDPDKNode {
 public:
#line 349 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkShlStatement(const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13101 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkShlStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkShlStatement"_cs; }
    static cstring static_type_name() { return "DpdkShlStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkShlStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkShlStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkShlStatement, NodeKind::DpdkShlStatement, DpdkBinaryStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkShrStatement : public DpdkBinaryStatement, public virtual IDPDKNode {
 public:
#line 356 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkShrStatement(const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13122 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkShrStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkShrStatement"_cs; }
    static cstring static_type_name() { return "DpdkShrStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkShrStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkShrStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkShrStatement, NodeKind::DpdkShrStatement, DpdkBinaryStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkSubStatement : public DpdkBinaryStatement, public virtual IDPDKNode {
 public:
#line 363 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkSubStatement(const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13143 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkSubStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkSubStatement"_cs; }
    static cstring static_type_name() { return "DpdkSubStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkSubStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkSubStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkSubStatement, NodeKind::DpdkSubStatement, DpdkBinaryStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkOrStatement : public DpdkBinaryStatement, public virtual IDPDKNode {
 public:
#line 370 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkOrStatement(const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13164 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkOrStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkOrStatement"_cs; }
    static cstring static_type_name() { return "DpdkOrStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkOrStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkOrStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkOrStatement, NodeKind::DpdkOrStatement, DpdkBinaryStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkXorStatement : public DpdkBinaryStatement, public virtual IDPDKNode {
 public:
#line 377 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkXorStatement(const IR::Expression* dst, const IR::Expression* src1, const IR::Expression* src2);
#line 13185 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkXorStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkXorStatement"_cs; }
    static cstring static_type_name() { return "DpdkXorStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkXorStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkBinaryStatement const & a) const override;
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkXorStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkXorStatement, NodeKind::DpdkXorStatement, DpdkBinaryStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkRecircidStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* pass = nullptr;
#line 383 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13207 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkRecircidStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkRecircidStatement"_cs; }
    static cstring static_type_name() { return "DpdkRecircidStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkRecircidStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkRecircidStatement(Util::SourceInfo srcInfo, const IR::Expression* pass) :
    DpdkAsmStatement(srcInfo), pass(pass)
    { validate(); }
    DpdkRecircidStatement(const IR::Expression* pass) :
    pass(pass)
    { validate(); }
    IRNODE_SUBCLASS(DpdkRecircidStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkRecircidStatement, NodeKind::DpdkRecircidStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkReturnStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
#line 388 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13235 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkReturnStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkReturnStatement"_cs; }
    static cstring static_type_name() { return "DpdkReturnStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkReturnStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkReturnStatement(Util::SourceInfo srcInfo) :
    DpdkAsmStatement(srcInfo)
    { validate(); }
    DpdkReturnStatement() 
    { validate(); }
    IRNODE_SUBCLASS(DpdkReturnStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkReturnStatement, NodeKind::DpdkReturnStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkRearmStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* timeout = nullptr;
#line 394 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13260 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkRearmStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "DpdkRearmStatement"_cs; }
    static cstring static_type_name() { return "DpdkRearmStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkRearmStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkRearmStatement(Util::SourceInfo srcInfo, const IR::Expression* timeout) :
    DpdkAsmStatement(srcInfo), timeout(timeout)
    { validate(); }
    DpdkRearmStatement(const IR::Expression* timeout) :
    timeout(timeout)
    { validate(); }
    DpdkRearmStatement(Util::SourceInfo srcInfo) :
    DpdkAsmStatement(srcInfo)
    { validate(); }
    DpdkRearmStatement() 
    { validate(); }
    IRNODE_SUBCLASS(DpdkRearmStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkRearmStatement, NodeKind::DpdkRearmStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkRecirculateStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
#line 399 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13292 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkRecirculateStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkRecirculateStatement"_cs; }
    static cstring static_type_name() { return "DpdkRecirculateStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkRecirculateStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkRecirculateStatement(Util::SourceInfo srcInfo) :
    DpdkAsmStatement(srcInfo)
    { validate(); }
    DpdkRecirculateStatement() 
    { validate(); }
    IRNODE_SUBCLASS(DpdkRecirculateStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkRecirculateStatement, NodeKind::DpdkRecirculateStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkLabelStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring label;
#line 405 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13317 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 407 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkLabelStatement(cstring l);
#line 13320 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkLabelStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkLabelStatement"_cs; }
    static cstring static_type_name() { return "DpdkLabelStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkLabelStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkLabelStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkLabelStatement, NodeKind::DpdkLabelStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkChecksumAddStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring csum;
    cstring intermediate_value;
    const IR::Expression* field = nullptr;
#line 414 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13344 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkChecksumAddStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkChecksumAddStatement"_cs; }
    static cstring static_type_name() { return "DpdkChecksumAddStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkChecksumAddStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkChecksumAddStatement(Util::SourceInfo srcInfo, cstring csum, cstring intermediate_value, const IR::Expression* field) :
    DpdkAsmStatement(srcInfo), csum(csum), intermediate_value(intermediate_value), field(field)
    { validate(); }
    DpdkChecksumAddStatement(cstring csum, cstring intermediate_value, const IR::Expression* field) :
    csum(csum), intermediate_value(intermediate_value), field(field)
    { validate(); }
    IRNODE_SUBCLASS(DpdkChecksumAddStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkChecksumAddStatement, NodeKind::DpdkChecksumAddStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkChecksumSubStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring csum;
    cstring intermediate_value;
    const IR::Expression* field = nullptr;
#line 422 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13376 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkChecksumSubStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkChecksumSubStatement"_cs; }
    static cstring static_type_name() { return "DpdkChecksumSubStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkChecksumSubStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkChecksumSubStatement(Util::SourceInfo srcInfo, cstring csum, cstring intermediate_value, const IR::Expression* field) :
    DpdkAsmStatement(srcInfo), csum(csum), intermediate_value(intermediate_value), field(field)
    { validate(); }
    DpdkChecksumSubStatement(cstring csum, cstring intermediate_value, const IR::Expression* field) :
    csum(csum), intermediate_value(intermediate_value), field(field)
    { validate(); }
    IRNODE_SUBCLASS(DpdkChecksumSubStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkChecksumSubStatement, NodeKind::DpdkChecksumSubStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkChecksumClearStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring csum;
    cstring intermediate_value;
#line 429 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13407 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkChecksumClearStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkChecksumClearStatement"_cs; }
    static cstring static_type_name() { return "DpdkChecksumClearStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkChecksumClearStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkChecksumClearStatement(Util::SourceInfo srcInfo, cstring csum, cstring intermediate_value) :
    DpdkAsmStatement(srcInfo), csum(csum), intermediate_value(intermediate_value)
    { validate(); }
    DpdkChecksumClearStatement(cstring csum, cstring intermediate_value) :
    csum(csum), intermediate_value(intermediate_value)
    { validate(); }
    IRNODE_SUBCLASS(DpdkChecksumClearStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkChecksumClearStatement, NodeKind::DpdkChecksumClearStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkHashDeclStatement : public DpdkAsmStatement {
 public:
    cstring hash;
#line 435 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13434 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkHashDeclStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkHashDeclStatement"_cs; }
    static cstring static_type_name() { return "DpdkHashDeclStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkHashDeclStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkHashDeclStatement(Util::SourceInfo srcInfo, cstring hash) :
    DpdkAsmStatement(srcInfo), hash(hash)
    { validate(); }
    DpdkHashDeclStatement(cstring hash) :
    hash(hash)
    { validate(); }
    IRNODE_SUBCLASS(DpdkHashDeclStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkHashDeclStatement, NodeKind::DpdkHashDeclStatement, DpdkAsmStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkGetHashStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring instr;
    cstring hash;
    const IR::Expression* fields = nullptr;
    const IR::Expression* dst = nullptr;
#line 445 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13464 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkGetHashStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkGetHashStatement"_cs; }
    static cstring static_type_name() { return "DpdkGetHashStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkGetHashStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkGetHashStatement(Util::SourceInfo srcInfo, cstring instr, cstring hash, const IR::Expression* fields, const IR::Expression* dst) :
    DpdkAsmStatement(srcInfo), instr(instr), hash(hash), fields(fields), dst(dst)
    { validate(); }
    DpdkGetHashStatement(cstring instr, cstring hash, const IR::Expression* fields, const IR::Expression* dst) :
    instr(instr), hash(hash), fields(fields), dst(dst)
    { validate(); }
    IRNODE_SUBCLASS(DpdkGetHashStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkGetHashStatement, NodeKind::DpdkGetHashStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkGetChecksumStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* dst = nullptr;
    cstring checksum;
    cstring intermediate_value;
#line 453 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13496 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkGetChecksumStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkGetChecksumStatement"_cs; }
    static cstring static_type_name() { return "DpdkGetChecksumStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkGetChecksumStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkGetChecksumStatement(Util::SourceInfo srcInfo, const IR::Expression* dst, cstring checksum, cstring intermediate_value) :
    DpdkAsmStatement(srcInfo), dst(dst), checksum(checksum), intermediate_value(intermediate_value)
    { validate(); }
    DpdkGetChecksumStatement(const IR::Expression* dst, cstring checksum, cstring intermediate_value) :
    dst(dst), checksum(checksum), intermediate_value(intermediate_value)
    { validate(); }
    IRNODE_SUBCLASS(DpdkGetChecksumStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkGetChecksumStatement, NodeKind::DpdkGetChecksumStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkCastStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* dst = nullptr;
    const IR::Expression* src = nullptr;
    const IR::Type* type = nullptr;
#line 461 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13528 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkCastStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkCastStatement"_cs; }
    static cstring static_type_name() { return "DpdkCastStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkCastStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkCastStatement(Util::SourceInfo srcInfo, const IR::Expression* dst, const IR::Expression* src, const IR::Type* type) :
    DpdkAsmStatement(srcInfo), dst(dst), src(src), type(type)
    { validate(); }
    DpdkCastStatement(const IR::Expression* dst, const IR::Expression* src, const IR::Type* type) :
    dst(dst), src(src), type(type)
    { validate(); }
    IRNODE_SUBCLASS(DpdkCastStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkCastStatement, NodeKind::DpdkCastStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkVerifyStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* condition = nullptr;
    const IR::Expression* error = nullptr;
#line 468 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13558 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkVerifyStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkVerifyStatement"_cs; }
    static cstring static_type_name() { return "DpdkVerifyStatement"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkVerifyStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkVerifyStatement(Util::SourceInfo srcInfo, const IR::Expression* condition, const IR::Expression* error) :
    DpdkAsmStatement(srcInfo), condition(condition), error(error)
    { validate(); }
    DpdkVerifyStatement(const IR::Expression* condition, const IR::Expression* error) :
    condition(condition), error(error)
    { validate(); }
    IRNODE_SUBCLASS(DpdkVerifyStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkVerifyStatement, NodeKind::DpdkVerifyStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkMeterDeclStatement : public DpdkAsmStatement {
 public:
    cstring meter;
    const IR::Expression* size = nullptr;
#line 475 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13588 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkMeterDeclStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkMeterDeclStatement"_cs; }
    static cstring static_type_name() { return "DpdkMeterDeclStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkMeterDeclStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkMeterDeclStatement(Util::SourceInfo srcInfo, cstring meter, const IR::Expression* size) :
    DpdkAsmStatement(srcInfo), meter(meter), size(size)
    { validate(); }
    DpdkMeterDeclStatement(cstring meter, const IR::Expression* size) :
    meter(meter), size(size)
    { validate(); }
    IRNODE_SUBCLASS(DpdkMeterDeclStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkMeterDeclStatement, NodeKind::DpdkMeterDeclStatement, DpdkAsmStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkMeterExecuteStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring meter;
    const IR::Expression* index = nullptr;
    const IR::Expression* length = nullptr;
    const IR::Expression* color_in = nullptr;
    const IR::Expression* color_out = nullptr;
#line 485 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13622 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkMeterExecuteStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkMeterExecuteStatement"_cs; }
    static cstring static_type_name() { return "DpdkMeterExecuteStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkMeterExecuteStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkMeterExecuteStatement(Util::SourceInfo srcInfo, cstring meter, const IR::Expression* index, const IR::Expression* length, const IR::Expression* color_in, const IR::Expression* color_out) :
    DpdkAsmStatement(srcInfo), meter(meter), index(index), length(length), color_in(color_in), color_out(color_out)
    { validate(); }
    DpdkMeterExecuteStatement(cstring meter, const IR::Expression* index, const IR::Expression* length, const IR::Expression* color_in, const IR::Expression* color_out) :
    meter(meter), index(index), length(length), color_in(color_in), color_out(color_out)
    { validate(); }
    IRNODE_SUBCLASS(DpdkMeterExecuteStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkMeterExecuteStatement, NodeKind::DpdkMeterExecuteStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkGetTableEntryIndex : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* index = nullptr;
#line 491 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13652 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkGetTableEntryIndex const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkGetTableEntryIndex"_cs; }
    static cstring static_type_name() { return "DpdkGetTableEntryIndex"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DpdkGetTableEntryIndex(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkGetTableEntryIndex(Util::SourceInfo srcInfo, const IR::Expression* index) :
    DpdkAsmStatement(srcInfo), index(index)
    { validate(); }
    DpdkGetTableEntryIndex(const IR::Expression* index) :
    index(index)
    { validate(); }
    IRNODE_SUBCLASS(DpdkGetTableEntryIndex)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkGetTableEntryIndex, NodeKind::DpdkGetTableEntryIndex, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkCounterCountStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring counter;
    const IR::Expression* index = nullptr;
    const IR::Expression* incr = nullptr;
#line 499 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13683 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkCounterCountStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkCounterCountStatement"_cs; }
    static cstring static_type_name() { return "DpdkCounterCountStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkCounterCountStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkCounterCountStatement(Util::SourceInfo srcInfo, cstring counter, const IR::Expression* index, const IR::Expression* incr) :
    DpdkAsmStatement(srcInfo), counter(counter), index(index), incr(incr)
    { validate(); }
    DpdkCounterCountStatement(cstring counter, const IR::Expression* index, const IR::Expression* incr) :
    counter(counter), index(index), incr(incr)
    { validate(); }
    DpdkCounterCountStatement(Util::SourceInfo srcInfo, cstring counter, const IR::Expression* index) :
    DpdkAsmStatement(srcInfo), counter(counter), index(index)
    { validate(); }
    DpdkCounterCountStatement(cstring counter, const IR::Expression* index) :
    counter(counter), index(index)
    { validate(); }
    IRNODE_SUBCLASS(DpdkCounterCountStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkCounterCountStatement, NodeKind::DpdkCounterCountStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkRegisterDeclStatement : public DpdkAsmStatement {
 public:
    cstring reg;
    const IR::Expression* size = nullptr;
    const IR::Expression* init_val = nullptr;
#line 507 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13721 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkRegisterDeclStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkRegisterDeclStatement"_cs; }
    static cstring static_type_name() { return "DpdkRegisterDeclStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkRegisterDeclStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkRegisterDeclStatement(Util::SourceInfo srcInfo, cstring reg, const IR::Expression* size, const IR::Expression* init_val) :
    DpdkAsmStatement(srcInfo), reg(reg), size(size), init_val(init_val)
    { validate(); }
    DpdkRegisterDeclStatement(cstring reg, const IR::Expression* size, const IR::Expression* init_val) :
    reg(reg), size(size), init_val(init_val)
    { validate(); }
    DpdkRegisterDeclStatement(Util::SourceInfo srcInfo, cstring reg, const IR::Expression* size) :
    DpdkAsmStatement(srcInfo), reg(reg), size(size)
    { validate(); }
    DpdkRegisterDeclStatement(cstring reg, const IR::Expression* size) :
    reg(reg), size(size)
    { validate(); }
    IRNODE_SUBCLASS(DpdkRegisterDeclStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkRegisterDeclStatement, NodeKind::DpdkRegisterDeclStatement, DpdkAsmStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkRegisterReadStatement : public DpdkAssignmentStatement {
 public:
    cstring reg;
    const IR::Expression* index = nullptr;
#line 514 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13758 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 517 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    DpdkRegisterReadStatement(const IR::Expression* dst, cstring reg, const IR::Expression* index);
#line 13761 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkRegisterReadStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkRegisterReadStatement"_cs; }
    static cstring static_type_name() { return "DpdkRegisterReadStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkRegisterReadStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAssignmentStatement const & a) const override;
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(DpdkRegisterReadStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkRegisterReadStatement, NodeKind::DpdkRegisterReadStatement, DpdkAssignmentStatement);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkRegisterWriteStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    cstring reg;
    const IR::Expression* index = nullptr;
    const IR::Expression* src = nullptr;
#line 525 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13788 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkRegisterWriteStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkRegisterWriteStatement"_cs; }
    static cstring static_type_name() { return "DpdkRegisterWriteStatement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkRegisterWriteStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkRegisterWriteStatement(Util::SourceInfo srcInfo, cstring reg, const IR::Expression* index, const IR::Expression* src) :
    DpdkAsmStatement(srcInfo), reg(reg), index(index), src(src)
    { validate(); }
    DpdkRegisterWriteStatement(cstring reg, const IR::Expression* index, const IR::Expression* src) :
    reg(reg), index(index), src(src)
    { validate(); }
    IRNODE_SUBCLASS(DpdkRegisterWriteStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkRegisterWriteStatement, NodeKind::DpdkRegisterWriteStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkValidateStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* header = nullptr;
#line 531 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13818 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkValidateStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkValidateStatement"_cs; }
    static cstring static_type_name() { return "DpdkValidateStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkValidateStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkValidateStatement(Util::SourceInfo srcInfo, const IR::Expression* header) :
    DpdkAsmStatement(srcInfo), header(header)
    { validate(); }
    DpdkValidateStatement(const IR::Expression* header) :
    header(header)
    { validate(); }
    IRNODE_SUBCLASS(DpdkValidateStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkValidateStatement, NodeKind::DpdkValidateStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkInvalidateStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
    const IR::Expression* header = nullptr;
#line 536 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13848 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkInvalidateStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "DpdkInvalidateStatement"_cs; }
    static cstring static_type_name() { return "DpdkInvalidateStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkInvalidateStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkInvalidateStatement(Util::SourceInfo srcInfo, const IR::Expression* header) :
    DpdkAsmStatement(srcInfo), header(header)
    { validate(); }
    DpdkInvalidateStatement(const IR::Expression* header) :
    header(header)
    { validate(); }
    IRNODE_SUBCLASS(DpdkInvalidateStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkInvalidateStatement, NodeKind::DpdkInvalidateStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR
namespace P4::IR {
class DpdkDropStatement : public DpdkAsmStatement, public virtual IDPDKNode {
 public:
#line 540 "/builddir/build/BUILD/p4c-1.2.5.8/backends/dpdk/dpdk.def"
    std::ostream & toSpec(std::ostream & out) const override;
#line 13877 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::DpdkDropStatement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "DpdkDropStatement"_cs; }
    static cstring static_type_name() { return "DpdkDropStatement"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DpdkDropStatement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::DpdkAsmStatement const & a) const override;
    bool operator==(IR::Node const & a) const override;
    DpdkDropStatement(Util::SourceInfo srcInfo) :
    DpdkAsmStatement(srcInfo)
    { validate(); }
    DpdkDropStatement() 
    { validate(); }
    IRNODE_SUBCLASS(DpdkDropStatement)
    DECLARE_TYPEINFO_WITH_TYPEID(DpdkDropStatement, NodeKind::DpdkDropStatement, DpdkAsmStatement, IDPDKNode);
};
}  // namespace P4::IR

#line 18 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
#include "backends/tc/tc_defines.h"
#include "absl/strings/str_cat.h"
#include "absl/strings/str_join.h"
#line 13902 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
class TCKernelMetadata : public Node {
 public:
    unsigned metaField;
#line 25 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 13909 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 47 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 13912 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCKernelMetadata const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TCKernelMetadata"_cs; }
    static cstring static_type_name() { return "TCKernelMetadata"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCKernelMetadata(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCKernelMetadata(Util::SourceInfo srcInfo, unsigned metaField) :
    Node(srcInfo), metaField(metaField)
    { validate(); }
    TCKernelMetadata(unsigned metaField) :
    metaField(metaField)
    { validate(); }
    IRNODE_SUBCLASS(TCKernelMetadata)
    DECLARE_TYPEINFO_WITH_TYPEID(TCKernelMetadata, NodeKind::TCKernelMetadata, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCActionParam : public Node {
 public:
    cstring paramName;
    unsigned dataType;
    unsigned bitSize;
    unsigned direction;
#line 55 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setParamName(cstring pN);
#line 13941 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 58 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setBitSize(unsigned bS);
#line 13944 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 61 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDataType(unsigned d);
#line 13947 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 64 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDirection(unsigned d);
#line 13950 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 67 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCActionParam();
#line 13953 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 71 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring getParamName() const;
#line 13956 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 74 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring getName() const;
#line 13959 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 77 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    unsigned getDirection() const;
#line 13962 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 80 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring getParamDecl(cstring placeholderName) const;
#line 13965 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 116 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 13968 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 146 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 13971 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCActionParam const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TCActionParam"_cs; }
    static cstring static_type_name() { return "TCActionParam"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCActionParam(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCActionParam(Util::SourceInfo srcInfo, cstring paramName, unsigned dataType, unsigned bitSize, unsigned direction) :
    Node(srcInfo), paramName(paramName), dataType(dataType), bitSize(bitSize), direction(direction)
    { validate(); }
    TCActionParam(cstring paramName, unsigned dataType, unsigned bitSize, unsigned direction) :
    paramName(paramName), dataType(dataType), bitSize(bitSize), direction(direction)
    { validate(); }
    IRNODE_SUBCLASS(TCActionParam)
    DECLARE_TYPEINFO_WITH_TYPEID(TCActionParam, NodeKind::TCActionParam, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCDefaultActionParam : public Node {
 public:
    const IR::TCActionParam* paramDetail = nullptr;
    cstring defaultValue;
#line 152 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setParamDetail(const IR::TCActionParam* pN);
#line 13998 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 155 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDefaultValue(cstring dV);
#line 14001 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 158 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCDefaultActionParam();
#line 14004 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 162 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14007 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 168 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14010 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCDefaultActionParam const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "TCDefaultActionParam"_cs; }
    static cstring static_type_name() { return "TCDefaultActionParam"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCDefaultActionParam(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCDefaultActionParam(Util::SourceInfo srcInfo, const IR::TCActionParam* paramDetail, cstring defaultValue) :
    Node(srcInfo), paramDetail(paramDetail), defaultValue(defaultValue)
    { validate(); }
    TCDefaultActionParam(const IR::TCActionParam* paramDetail, cstring defaultValue) :
    paramDetail(paramDetail), defaultValue(defaultValue)
    { validate(); }
    IRNODE_SUBCLASS(TCDefaultActionParam)
    DECLARE_TYPEINFO_WITH_TYPEID(TCDefaultActionParam, NodeKind::TCDefaultActionParam, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCAction : public Node {
 public:
    cstring actionName;
    cstring pipelineName;
    unsigned actId;
    safe_vector<const IR::TCActionParam *> actionParams;
#line 176 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring getName() const;
#line 14042 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 182 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring getActionName() const;
#line 14045 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 185 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setPipelineName(cstring pN);
#line 14048 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 188 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addActionParams(const IR::TCActionParam* tca);
#line 14051 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 191 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setActionId(unsigned id);
#line 14054 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 194 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCAction(cstring aN);
#line 14057 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 199 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14060 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 213 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14063 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCAction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TCAction"_cs; }
    static cstring static_type_name() { return "TCAction"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCAction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCAction(Util::SourceInfo srcInfo, cstring actionName, cstring pipelineName, unsigned actId, safe_vector<const IR::TCActionParam *> actionParams) :
    Node(srcInfo), actionName(actionName), pipelineName(pipelineName), actId(actId), actionParams(actionParams)
    { validate(); }
    TCAction(cstring actionName, cstring pipelineName, unsigned actId, safe_vector<const IR::TCActionParam *> actionParams) :
    actionName(actionName), pipelineName(pipelineName), actId(actId), actionParams(actionParams)
    { validate(); }
    TCAction(Util::SourceInfo srcInfo, cstring actionName, cstring pipelineName, unsigned actId) :
    Node(srcInfo), actionName(actionName), pipelineName(pipelineName), actId(actId)
    { validate(); }
    TCAction(cstring actionName, cstring pipelineName, unsigned actId) :
    actionName(actionName), pipelineName(pipelineName), actId(actId)
    { validate(); }
    IRNODE_SUBCLASS(TCAction)
    DECLARE_TYPEINFO_WITH_TYPEID(TCAction, NodeKind::TCAction, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCEntry : public Node {
 public:
    cstring action;
    ordered_map<cstring, cstring> keys;
#line 219 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring getActionName() const;
#line 14096 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 222 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14099 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 229 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14102 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCEntry const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TCEntry"_cs; }
    static cstring static_type_name() { return "TCEntry"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCEntry(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCEntry(Util::SourceInfo srcInfo, cstring action, ordered_map<cstring, cstring> keys) :
    Node(srcInfo), action(action), keys(keys)
    { validate(); }
    TCEntry(cstring action, ordered_map<cstring, cstring> keys) :
    action(action), keys(keys)
    { validate(); }
    IRNODE_SUBCLASS(TCEntry)
    DECLARE_TYPEINFO_WITH_TYPEID(TCEntry, NodeKind::TCEntry, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCTable : public Node {
 public:
    unsigned tableID;
    cstring tableName;
    cstring controlName;
    cstring pipelineName;
    cstring permissions;
    cstring directCounterInstance;
    cstring directMeterInstance;
    unsigned keySize;
    unsigned tableEntriesCount;
    unsigned numMask;
    unsigned matchType;
    unsigned timerProfiles;
    unsigned defaultTimerProfiles = 4;
    const IR::TCAction* defaultHitAction = nullptr;
    bool isDefaultHitConst;
    bool isTcMayOverrideHit;
    safe_vector<const IR::TCDefaultActionParam *> defaultHitActionParams;
    const IR::TCAction* defaultMissAction = nullptr;
    bool isDefaultMissConst;
    bool isTcMayOverrideMiss;
    safe_vector<const IR::TCDefaultActionParam *> defaultMissActionParams;
    bool isTableAddOnMiss;
    bool isTcMayOverride;
    bool isDirectCounter;
    bool isDirectMeter;
    ordered_map<const IR::TCAction *, unsigned> actionList;
    safe_vector<const IR::TCEntry *> const_entries;
#line 261 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setTablePermission(cstring p);
#line 14154 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 264 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDirectCounter(cstring counter);
#line 14157 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 268 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDirectMeter(cstring meter);
#line 14160 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 272 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setKeySize(unsigned k);
#line 14163 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 275 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setTableEntriesCount(unsigned t);
#line 14166 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 278 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setNumMask(unsigned n);
#line 14169 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 281 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setMatchType(unsigned m);
#line 14172 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 284 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDefaultHitAction(const IR::TCAction* d);
#line 14175 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 287 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDefaultMissAction(const IR::TCAction* d);
#line 14178 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 290 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDefaultHitConst(bool i);
#line 14181 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 293 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setDefaultMissConst(bool i);
#line 14184 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 296 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setTcMayOverrideHit();
#line 14187 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 299 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setTcMayOverrideMiss();
#line 14190 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 302 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setTableAddOnMiss();
#line 14193 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 305 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addAction(const IR::TCAction* action, unsigned flag);
#line 14196 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 308 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addConstEntries(const IR::TCEntry* entry);
#line 14199 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 311 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addTimerProfiles(unsigned tp);
#line 14202 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 314 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring getTableName() const;
#line 14205 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 317 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring printMatchType(unsigned matchType) const;
#line 14208 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 332 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCTable(unsigned tId, cstring tN, cstring cN, cstring pN);
#line 14211 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 353 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14214 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 433 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14217 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCTable const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "TCTable"_cs; }
    static cstring static_type_name() { return "TCTable"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCTable(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCTable(Util::SourceInfo srcInfo, unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, safe_vector<const IR::TCDefaultActionParam *> defaultHitActionParams, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, safe_vector<const IR::TCDefaultActionParam *> defaultMissActionParams, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    Node(srcInfo), tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultHitActionParams(defaultHitActionParams), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), defaultMissActionParams(defaultMissActionParams), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    TCTable(unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, safe_vector<const IR::TCDefaultActionParam *> defaultHitActionParams, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, safe_vector<const IR::TCDefaultActionParam *> defaultMissActionParams, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultHitActionParams(defaultHitActionParams), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), defaultMissActionParams(defaultMissActionParams), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    TCTable(Util::SourceInfo srcInfo, unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, safe_vector<const IR::TCDefaultActionParam *> defaultMissActionParams, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    Node(srcInfo), tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), defaultMissActionParams(defaultMissActionParams), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    TCTable(unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, safe_vector<const IR::TCDefaultActionParam *> defaultMissActionParams, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), defaultMissActionParams(defaultMissActionParams), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    TCTable(Util::SourceInfo srcInfo, unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, safe_vector<const IR::TCDefaultActionParam *> defaultHitActionParams, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    Node(srcInfo), tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultHitActionParams(defaultHitActionParams), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    TCTable(unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, safe_vector<const IR::TCDefaultActionParam *> defaultHitActionParams, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultHitActionParams(defaultHitActionParams), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    TCTable(Util::SourceInfo srcInfo, unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    Node(srcInfo), tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    TCTable(unsigned tableID, cstring tableName, cstring controlName, cstring pipelineName, cstring permissions, cstring directCounterInstance, cstring directMeterInstance, unsigned keySize, unsigned tableEntriesCount, unsigned numMask, unsigned matchType, unsigned timerProfiles, const IR::TCAction* defaultHitAction, bool isDefaultHitConst, bool isTcMayOverrideHit, const IR::TCAction* defaultMissAction, bool isDefaultMissConst, bool isTcMayOverrideMiss, bool isTableAddOnMiss, bool isTcMayOverride, bool isDirectCounter, bool isDirectMeter, ordered_map<const IR::TCAction *, unsigned> actionList, safe_vector<const IR::TCEntry *> const_entries) :
    tableID(tableID), tableName(tableName), controlName(controlName), pipelineName(pipelineName), permissions(permissions), directCounterInstance(directCounterInstance), directMeterInstance(directMeterInstance), keySize(keySize), tableEntriesCount(tableEntriesCount), numMask(numMask), matchType(matchType), timerProfiles(timerProfiles), defaultHitAction(defaultHitAction), isDefaultHitConst(isDefaultHitConst), isTcMayOverrideHit(isTcMayOverrideHit), defaultMissAction(defaultMissAction), isDefaultMissConst(isDefaultMissConst), isTcMayOverrideMiss(isTcMayOverrideMiss), isTableAddOnMiss(isTableAddOnMiss), isTcMayOverride(isTcMayOverride), isDirectCounter(isDirectCounter), isDirectMeter(isDirectMeter), actionList(actionList), const_entries(const_entries)
    { validate(); }
    IRNODE_SUBCLASS(TCTable)
    DECLARE_TYPEINFO_WITH_TYPEID(TCTable, NodeKind::TCTable, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCKey : public Node {
 public:
    unsigned keyID;
    unsigned bitwidth;
    cstring type;
    cstring keyName;
    cstring keyAttribute;
    bool emitID;
    bool emitValue;
    unsigned value;
#line 445 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCKey(unsigned id, unsigned width, cstring ptype, cstring name, cstring attr, bool isID);
#line 14271 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 454 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setValue(unsigned v);
#line 14274 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 458 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14277 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 468 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14280 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCKey const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TCKey"_cs; }
    static cstring static_type_name() { return "TCKey"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCKey(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCKey(Util::SourceInfo srcInfo, unsigned keyID, unsigned bitwidth, cstring type, cstring keyName, cstring keyAttribute, bool emitID, bool emitValue, unsigned value) :
    Node(srcInfo), keyID(keyID), bitwidth(bitwidth), type(type), keyName(keyName), keyAttribute(keyAttribute), emitID(emitID), emitValue(emitValue), value(value)
    { validate(); }
    TCKey(unsigned keyID, unsigned bitwidth, cstring type, cstring keyName, cstring keyAttribute, bool emitID, bool emitValue, unsigned value) :
    keyID(keyID), bitwidth(bitwidth), type(type), keyName(keyName), keyAttribute(keyAttribute), emitID(emitID), emitValue(emitValue), value(value)
    { validate(); }
    IRNODE_SUBCLASS(TCKey)
    DECLARE_TYPEINFO_WITH_TYPEID(TCKey, NodeKind::TCKey, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCExternInstance : public Node {
 public:
    unsigned instanceID;
    cstring instanceName;
    bool isNumelemns;
    unsigned numelemns;
    bool isControlPath;
    bool isTablBindable;
    bool isInstanceType;
    bool isConstructorKeys;
    cstring instanceType;
    safe_vector<const IR::TCKey *> controlKeys;
    safe_vector<const IR::TCKey *> constructorKeys;
#line 484 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCExternInstance(unsigned id, cstring name, bool isNe, unsigned ne);
#line 14316 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 494 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addControlPathKeys(safe_vector<const IR::TCKey *> k);
#line 14319 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 500 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addConstructorKeys(safe_vector<const IR::TCKey *> k);
#line 14322 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 506 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setExternTypeInstance(cstring type);
#line 14325 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 510 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setExternTableBindable(bool flag);
#line 14328 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 513 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setNumElements(unsigned ne);
#line 14331 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 517 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14334 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 540 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14337 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCExternInstance const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TCExternInstance"_cs; }
    static cstring static_type_name() { return "TCExternInstance"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCExternInstance(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCExternInstance(Util::SourceInfo srcInfo, unsigned instanceID, cstring instanceName, bool isNumelemns, unsigned numelemns, bool isControlPath, bool isTablBindable, bool isInstanceType, bool isConstructorKeys, cstring instanceType, safe_vector<const IR::TCKey *> controlKeys, safe_vector<const IR::TCKey *> constructorKeys) :
    Node(srcInfo), instanceID(instanceID), instanceName(instanceName), isNumelemns(isNumelemns), numelemns(numelemns), isControlPath(isControlPath), isTablBindable(isTablBindable), isInstanceType(isInstanceType), isConstructorKeys(isConstructorKeys), instanceType(instanceType), controlKeys(controlKeys), constructorKeys(constructorKeys)
    { validate(); }
    TCExternInstance(unsigned instanceID, cstring instanceName, bool isNumelemns, unsigned numelemns, bool isControlPath, bool isTablBindable, bool isInstanceType, bool isConstructorKeys, cstring instanceType, safe_vector<const IR::TCKey *> controlKeys, safe_vector<const IR::TCKey *> constructorKeys) :
    instanceID(instanceID), instanceName(instanceName), isNumelemns(isNumelemns), numelemns(numelemns), isControlPath(isControlPath), isTablBindable(isTablBindable), isInstanceType(isInstanceType), isConstructorKeys(isConstructorKeys), instanceType(instanceType), controlKeys(controlKeys), constructorKeys(constructorKeys)
    { validate(); }
    IRNODE_SUBCLASS(TCExternInstance)
    DECLARE_TYPEINFO_WITH_TYPEID(TCExternInstance, NodeKind::TCExternInstance, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCExtern : public Node {
 public:
    cstring externName;
    cstring pipelineName;
    cstring acl_permisson;
    cstring externID;
    unsigned numinstances;
    safe_vector<const IR::TCExternInstance *> externInstances;
    bool has_exec_method;
#line 551 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCExtern(cstring eId, cstring eN, cstring pN, unsigned inst, cstring p, bool exec_method);
#line 14369 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 559 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addExternInstance(const IR::TCExternInstance* tei);
#line 14372 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 562 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    const IR::TCExternInstance *getExternInstance(cstring inst_name) const;
#line 14375 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 570 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14378 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 584 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14381 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCExtern const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TCExtern"_cs; }
    static cstring static_type_name() { return "TCExtern"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCExtern(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCExtern(Util::SourceInfo srcInfo, cstring externName, cstring pipelineName, cstring acl_permisson, cstring externID, unsigned numinstances, safe_vector<const IR::TCExternInstance *> externInstances, bool has_exec_method) :
    Node(srcInfo), externName(externName), pipelineName(pipelineName), acl_permisson(acl_permisson), externID(externID), numinstances(numinstances), externInstances(externInstances), has_exec_method(has_exec_method)
    { validate(); }
    TCExtern(cstring externName, cstring pipelineName, cstring acl_permisson, cstring externID, unsigned numinstances, safe_vector<const IR::TCExternInstance *> externInstances, bool has_exec_method) :
    externName(externName), pipelineName(pipelineName), acl_permisson(acl_permisson), externID(externID), numinstances(numinstances), externInstances(externInstances), has_exec_method(has_exec_method)
    { validate(); }
    IRNODE_SUBCLASS(TCExtern)
    DECLARE_TYPEINFO_WITH_TYPEID(TCExtern, NodeKind::TCExtern, Node);
};
}  // namespace P4::IR
namespace P4::IR {
class TCPipeline : public Node {
 public:
    cstring pipelineName;
    unsigned numTables;
    const IR::TCAction* NoAction = nullptr;
    safe_vector<const IR::TCAction *> actionDefs;
    safe_vector<const IR::TCTable *> tableDefs;
    safe_vector<const IR::TCExtern *> externDefs;
    const IR::TCAction* preaction = nullptr;
    const IR::TCAction* postaction = nullptr;
#line 596 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setPipelineName(cstring pName);
#line 14414 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 599 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setNumTables(unsigned n);
#line 14417 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 602 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addNoActionDefinition(const IR::TCAction* actionDef);
#line 14420 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 605 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addActionDefinition(const IR::TCAction* actionDef);
#line 14423 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 608 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addTableDefinition(const IR::TCTable* tableDef);
#line 14426 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 611 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setPipelinePreAction(const IR::TCAction* action);
#line 14429 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 614 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void setPipelinePostAction(const IR::TCAction* action);
#line 14432 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 617 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void addExternDefinition(const IR::TCExtern* externDef);
#line 14435 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 620 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    const IR::TCExtern *getExternDefinition(cstring eName) const;
#line 14438 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 628 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    TCPipeline();
#line 14441 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 633 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    cstring toString() const override;
#line 14444 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 666 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tc/tc.def"
    void dbprint(std::ostream & out) const override;
#line 14447 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TCPipeline const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "TCPipeline"_cs; }
    static cstring static_type_name() { return "TCPipeline"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TCPipeline(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    TCPipeline(Util::SourceInfo srcInfo, cstring pipelineName, unsigned numTables, const IR::TCAction* NoAction, safe_vector<const IR::TCAction *> actionDefs, safe_vector<const IR::TCTable *> tableDefs, safe_vector<const IR::TCExtern *> externDefs, const IR::TCAction* preaction, const IR::TCAction* postaction) :
    Node(srcInfo), pipelineName(pipelineName), numTables(numTables), NoAction(NoAction), actionDefs(actionDefs), tableDefs(tableDefs), externDefs(externDefs), preaction(preaction), postaction(postaction)
    { validate(); }
    TCPipeline(cstring pipelineName, unsigned numTables, const IR::TCAction* NoAction, safe_vector<const IR::TCAction *> actionDefs, safe_vector<const IR::TCTable *> tableDefs, safe_vector<const IR::TCExtern *> externDefs, const IR::TCAction* preaction, const IR::TCAction* postaction) :
    pipelineName(pipelineName), numTables(numTables), NoAction(NoAction), actionDefs(actionDefs), tableDefs(tableDefs), externDefs(externDefs), preaction(preaction), postaction(postaction)
    { validate(); }
    IRNODE_SUBCLASS(TCPipeline)
    DECLARE_TYPEINFO_WITH_TYPEID(TCPipeline, NodeKind::TCPipeline, Node);
};
}  // namespace P4::IR
namespace P4::IR {
/// Represents a reference to an object in a P4 program.
///
/// This is a thin wrapper around a 'const Member*' to (1) enforce invariants on which forms of
/// Members can represent state variables and (2) enable the use of StateVariables as map keys.
class StateVariable : public Expression {
 public:
/// The wrapped reference.
    IR::Expression const * ref;
/// The expression type is derived from the member.
/// Implicit conversions to allow implementations to be treated like a Member*.
#line 14 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    operator const Expression *() const { return ref; }
#line 14483 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 16 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    IR::Expression const & operator*() const;
#line 14486 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 17 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    const IR::Expression *operator->() const;
#line 14489 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// StateVariables can be Members, PathExpressions, or ArrayIndices.
#line 20 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    StateVariable(const IR::Member* member);
#line 14493 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The expression type is derived from the path.
#line 22 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    StateVariable(const IR::PathExpression* path);
#line 14497 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    StateVariable(const IR::ArrayIndex* arr);
#line 14500 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Implements comparisons so that StateVariables can be used as map keys.

#line 27 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    bool operator==(IR::StateVariable const & other) const override;
#line 14505 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Implements comparisons so that StateVariables can be used as map keys.
/// Note that we ignore the type of the variable in the comparison.
#line 33 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    bool equiv(IR::Node const & a_) const override;
#line 14510 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Implements comparisons so that StateVariables can be used as map keys.
/// Note that we ignore the type of the variable in the comparison.
#line 41 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    bool operator<(IR::StateVariable const & other) const;
#line 14515 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 47 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    int compare(IR::Expression const * e1, IR::Expression const * e2) const;
#line 14518 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 87 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    int compare(IR::Member const * m1, IR::Member const * m2) const;
#line 14521 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 101 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    int compare(IR::PathExpression const * p1, IR::PathExpression const * p2) const;
#line 14524 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 111 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    int compare(IR::ArrayIndex const * a1, IR::ArrayIndex const * a2) const;
#line 14527 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 129 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    cstring toString() const override;
#line 14530 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 131 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void dbprint(std::ostream & out) const override;
#line 14533 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring node_type_name() const override { return "StateVariable"_cs; }
    static cstring static_type_name() { return "StateVariable"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    StateVariable(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(StateVariable)
    DECLARE_TYPEINFO_WITH_TYPEID(StateVariable, NodeKind::StateVariable, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// Signifies that a particular expression is tainted.
/// This tainted expression must be resolved explicitly.
class TaintExpression : public Expression {
 public:
#line 137 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    cstring toString() const override;
#line 14553 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 139 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void dbprint(std::ostream & out) const override;
#line 14556 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TaintExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TaintExpression"_cs; }
    static cstring static_type_name() { return "TaintExpression"_cs; }
    void toJSON(JSONGenerator & json) const override;
    TaintExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TaintExpression(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    TaintExpression(const IR::Type* type) :
    Expression(type)
    { validate(); }
    TaintExpression(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    TaintExpression() 
    { validate(); }
    IRNODE_SUBCLASS(TaintExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(TaintExpression, NodeKind::TaintExpression, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// This type replaces Type_Varbits and can store information about the current size
class Extracted_Varbits : public Type_Bits {
 public:
#line 146 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void *operator new(size_t size) { return ::operator new(size); }
// FIXME: Remove this #ifdefine check once we switch to C++20
#if defined(__cpp_sized_deallocation) && __cpp_sized_deallocation >= 201309L
    void operator delete(void *p, size_t size) { return ::operator delete(p, size); }
#else
    void operator delete(void *p) { return ::operator delete(p); }
#endif
#line 14593 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The assigned size of this varbit (assigned by extract calls).
    int assignedSize;
/// Returns the current width this variable bit type has.
#line 158 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    int width_bits() const override;
#line 14599 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 160 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    bool equiv(IR::Node const & a_) const override;
#line 14602 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 165 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    bool operator==(IR::Extracted_Varbits const & a) const override;
#line 14605 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 170 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    cstring baseName() const;
#line 14608 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 172 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    cstring toString() const override;
#line 14611 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void dbprint(std::ostream & out) const override;
#line 14614 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring node_type_name() const override { return "Extracted_Varbits"_cs; }
    static cstring static_type_name() { return "Extracted_Varbits"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Extracted_Varbits(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Bits const & a) const override;
    bool operator==(IR::Type_Base const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Extracted_Varbits(Util::SourceInfo srcInfo, int size, const IR::Expression* expression, bool isSigned, int assignedSize) :
    Type_Bits(srcInfo, size, expression, isSigned), assignedSize(assignedSize)
    { validate(); }
    Extracted_Varbits(int size, const IR::Expression* expression, bool isSigned, int assignedSize) :
    Type_Bits(size, expression, isSigned), assignedSize(assignedSize)
    { validate(); }
    Extracted_Varbits(Util::SourceInfo srcInfo, const IR::Expression* expression, bool isSigned, int assignedSize) :
    Type_Bits(srcInfo, expression, isSigned), assignedSize(assignedSize)
    { validate(); }
    Extracted_Varbits(const IR::Expression* expression, bool isSigned, int assignedSize) :
    Type_Bits(expression, isSigned), assignedSize(assignedSize)
    { validate(); }
    Extracted_Varbits(Util::SourceInfo srcInfo, int size, bool isSigned, int assignedSize) :
    Type_Bits(srcInfo, size, isSigned), assignedSize(assignedSize)
    { validate(); }
    Extracted_Varbits(int size, bool isSigned, int assignedSize) :
    Type_Bits(size, isSigned), assignedSize(assignedSize)
    { validate(); }
    Extracted_Varbits(Util::SourceInfo srcInfo, bool isSigned, int assignedSize) :
    Type_Bits(srcInfo, isSigned), assignedSize(assignedSize)
    { validate(); }
    Extracted_Varbits(bool isSigned, int assignedSize) :
    Type_Bits(isSigned), assignedSize(assignedSize)
    { validate(); }
    IRNODE_SUBCLASS(Extracted_Varbits)
    DECLARE_TYPEINFO_WITH_TYPEID(Extracted_Varbits, NodeKind::Extracted_Varbits, Type_Bits);
};
}  // namespace P4::IR
namespace P4::IR {
/// Defines a concolic variable that may be part of expressions.
/// This variable must later be resolved and is converted into a symbolic expression.
class ConcolicVariable : public SymbolicVariable {
 public:
 private:
#line 186 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    static cstring produceLabel(cstring methodName, int srcIdentifier, int concolicId);
#line 14661 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 public:
/// Arguments to the concolic method.
    const IR::Vector<IR::Argument>* arguments = nullptr;
/// The unique identifier of the source the produces this concolic variable.
    int srcIdentifier;
/// Some identifiers produce multiple concolic variables. This ID keeps track of the offsets.
    int concolicId;
/// Nodes that are associated with this concolic variable. This may be declarations.
    IR::IndexedVector<IR::Node> associatedNodes;
/// The name of the concolic method that this variable targets.
    cstring concolicMethodName = cstring::empty;
#line 208 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    cstring toString() const override;
#line 14675 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 218 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void dbprint(std::ostream & out) const override;
#line 14678 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 222 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 14682 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 224 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    ConcolicVariable(IR::Type const * type, cstring methodName, IR::Vector<IR::Argument> const * arguments, int srcIdentifier, int concolicId, IR::IndexedVector<IR::Node> const & associatedNodes);
#line 14685 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 234 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    ConcolicVariable(IR::Type const * type, cstring methodName, IR::Vector<IR::Argument> const * arguments, int srcIdentifier, int concolicId);
#line 14688 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::ConcolicVariable const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "ConcolicVariable"_cs; }
    static cstring static_type_name() { return "ConcolicVariable"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ConcolicVariable(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::SymbolicVariable const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(ConcolicVariable)
    DECLARE_TYPEINFO_WITH_TYPEID(ConcolicVariable, NodeKind::ConcolicVariable, SymbolicVariable);
};
}  // namespace P4::IR
namespace P4::IR {
/// An extension of a struct expression. Also tracks validity as an expression.
class HeaderExpression : public StructExpression {
 public:
/// Whether this struct expression is valid. Mostly relevant to header expressions.
    const IR::Expression* validity = nullptr;
#line 248 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void dbprint(std::ostream & out) const override;
#line 14713 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 257 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void validate() const override;
#line 14716 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::HeaderExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "HeaderExpression"_cs; }
    static cstring static_type_name() { return "HeaderExpression"_cs; }
    void toJSON(JSONGenerator & json) const override;
    HeaderExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::StructExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HeaderExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, const IR::Expression* validity) :
    StructExpression(srcInfo, type, structType, components), validity(validity)
    { validate(); }
    HeaderExpression(const IR::Type* type, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, const IR::Expression* validity) :
    StructExpression(type, structType, components), validity(validity)
    { validate(); }
    HeaderExpression(Util::SourceInfo srcInfo, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, const IR::Expression* validity) :
    StructExpression(srcInfo, structType, components), validity(validity)
    { validate(); }
    HeaderExpression(const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, const IR::Expression* validity) :
    StructExpression(structType, components), validity(validity)
    { validate(); }
    IRNODE_SUBCLASS(HeaderExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(HeaderExpression, NodeKind::HeaderExpression, StructExpression);
};
}  // namespace P4::IR
namespace P4::IR {
/// An wrapper which models an InOut argument.
/// Contains both a copy of the original reference as well as the resolved value of that reference.
class InOutReference : public Expression {
 public:
/// Because we do not use a reference for "ref" and also inline the member the irgenerator produces
/// a constructor that does not compile. We need to write the constructor manually instead.
/// The original reference.
    IR::StateVariable ref;
/// The value of the reference after it was resolved.
    const IR::Expression* resolvedRef = nullptr;
#line 275 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    InOutReference(JSONLoader & json);
#line 14758 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 279 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    InOutReference(Util::SourceInfo srcInfo, IR::StateVariable & ref, IR::Expression const * resolvedRef);
#line 14761 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 283 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    InOutReference(IR::StateVariable & ref, IR::Expression const * resolvedRef);
#line 14764 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 287 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    cstring toString() const override;
#line 14767 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 289 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/p4tools.def"
    void dbprint(std::ostream & out) const override;
#line 14770 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::InOutReference const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "InOutReference"_cs; }
    static cstring static_type_name() { return "InOutReference"_cs; }
    void toJSON(JSONGenerator & json) const override;
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(InOutReference)
    DECLARE_TYPEINFO_WITH_TYPEID(InOutReference, NodeKind::InOutReference, Expression);
};
}  // namespace P4::IR
namespace P4::IR {
/// An extension of TaintExpression. This class is used for variables that exhibit special behavior
/// when not initialized. For example, in Tofino, if the port variable has not been written to, the
/// packet will be dropped. However, reading from this uninitialized variable will still produce
/// taint. This behavior must be modeled. So we use this uninitialized IR class, which acts like
/// taint, but is its own type that can be checked for.
class UninitializedTaintExpression : public TaintExpression {
 public:
#line 7 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/modules/testgen/targets/tofino/testgen_tofino.def"
    cstring toString() const override;
#line 14796 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 9 "/builddir/build/BUILD/p4c-1.2.5.8/backends/p4tools/modules/testgen/targets/tofino/testgen_tofino.def"
    void dbprint(std::ostream & out) const override;
#line 14799 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::UninitializedTaintExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "UninitializedTaintExpression"_cs; }
    static cstring static_type_name() { return "UninitializedTaintExpression"_cs; }
    void toJSON(JSONGenerator & json) const override;
    UninitializedTaintExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::TaintExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    UninitializedTaintExpression(Util::SourceInfo srcInfo, const IR::Type* type) :
    TaintExpression(srcInfo, type)
    { validate(); }
    UninitializedTaintExpression(const IR::Type* type) :
    TaintExpression(type)
    { validate(); }
    UninitializedTaintExpression(Util::SourceInfo srcInfo) :
    TaintExpression(srcInfo)
    { validate(); }
    UninitializedTaintExpression() 
    { validate(); }
    IRNODE_SUBCLASS(UninitializedTaintExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(UninitializedTaintExpression, NodeKind::UninitializedTaintExpression, TaintExpression);
};
}  // namespace P4::IR
/**
 * Copyright (C) 2024 Intel Corporation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * 
 * SPDX-License-Identifier: Apache-2.0
 */
/* -*-C++-*- */
#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"

#include "lib/bitvec.h"
#include "backends/tofino/bf-p4c/common/debug_info.h"
#include "backends/tofino/bf-p4c/ir/bitrange.h"
#include "backends/tofino/bf-p4c/ir/gress.h"
#include "backends/tofino/bf-p4c/parde/clot/clot.h"
#include "backends/tofino/bf-p4c/phv/phv.h"
#include "backends/tofino/bf-p4c/lib/error_macros.h"

struct StageUse {
    static constexpr int MAX_LOGICAL_IDS = 16;
    static constexpr int MAX_SRAMS = 80;
    static constexpr int MAX_TCAMS = 24;
    static constexpr int MAX_MAPRAMS = 48;
    static constexpr int MAX_IXBAR_BYTES = 128;
    static constexpr int MAX_TERNARY_GROUPS = 12;
};

/**
 * @namespace IR::BFN
 * @brief The namespace encapsulating Tofino 1/2-specific %IR nodes.
 */
namespace BFN {
struct HeaderStackInfo;
}  // namespace BFN
#line 14869 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
namespace BFN {

class HardwareConstrainedField : public Node {
 public:
    const IR::Expression* expr = nullptr;
    bitvec constraint_type = {};
#line 61 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    enum {
        // see phv_fields.cpp
        INVALIDATE_FROM_ARCH,
        // see phv_fields.cpp
        DEPARSED_BOTTOM_BITS,
        // see auto_init_metadata.cpp
        INIT_BY_ARCH
    };
#line 14886 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::HardwareConstrainedField const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::HardwareConstrainedField"_cs; }
    static cstring static_type_name() { return "BFN::HardwareConstrainedField"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HardwareConstrainedField(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    HardwareConstrainedField(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Node(srcInfo), expr(expr)
    { validate(); }
    HardwareConstrainedField(const IR::Expression* expr) :
    expr(expr)
    { validate(); }
    IRNODE_SUBCLASS(HardwareConstrainedField)
    DECLARE_TYPEINFO_WITH_TYPEID(HardwareConstrainedField, NodeKind::BFN_HardwareConstrainedField, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class Pipe : public Node {
 public:

    std::vector<cstring> names;

    std::vector<int> ids;
    IR::NameMap<IR::HeaderOrMetadata> metadata;

    std::vector<const IR::Annotation *> global_pragmas;

#line 81 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    Pipe();
#line 14924 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 85 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    Pipe(std::vector<cstring> names, std::vector<int> ids);
#line 14927 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
class thread_t {
 public:


    IR::Vector<IR::BFN::HardwareConstrainedField> hw_constrained_fields = {};
    IR::Vector<IR::BFN::AbstractParser> parsers = {};
    const IR::MAU::TableSeq* mau = nullptr;
    const IR::BFN::AbstractDeparser* deparser = nullptr;
#line 94 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    bool operator==(IR::BFN::Pipe::thread_t const & a) const;
#line 14938 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 98 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void toJSON(JSONGenerator & json) const;
#line 14941 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 103 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    static IR::BFN::Pipe::thread_t * fromJSON(JSONLoader & json);
#line 14944 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    thread_t(JSONLoader & json);
    thread_t() 
    {}
};
    thread_t thread[2] = {};
class ghost_thread_t {
 public:
    const IR::MAU::TableSeq* ghost_mau = nullptr;
    const IR::BFN::GhostParser* ghost_parser = nullptr;

#line 117 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    bool operator==(IR::BFN::Pipe::ghost_thread_t const & a) const;
#line 14957 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 119 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dump_fields(std::ostream & out) const;
#line 14960 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 121 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const;
#line 14963 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 124 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
        friend std::ostream &operator<<(std::ostream &out, const ghost_thread_t &gt) {
            out << "ghost_mau=" << gt.ghost_mau << " "
                << "ghost_parser=" << gt.ghost_parser;
            return out;
        }
#line 14970 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    void toJSON(JSONGenerator & json) const;
    ghost_thread_t(JSONLoader & json);
    static IR::BFN::Pipe::ghost_thread_t * fromJSON(JSONLoader & json);
    ghost_thread_t() 
    {}
};
    ghost_thread_t ghost_thread;
#line 134 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    /// If non-null, information about header stack usage in this pipe.
    ::BFN::HeaderStackInfo* headerStackInfo = nullptr;
#line 14981 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 139 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    bool has_pragma(const char *pragma) const;

    // Returns canonical pipeline id. A single backend pipeline instance can represent
    // multiple equivalent pipelines in the P4 program, in that case this function
    // picks consistently one selected pipeline index. Particularly useful for logging,
    // using the same pipeline id helps to keep all logs attached to a single pipeline.
    int canon_id() const { return ids.front(); }
    cstring canon_name() const { return names.front(); }
#line 14991 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Pipe)
#line 150 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    bool operator==(IR::BFN::Pipe const & a) const override;
#line 14995 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 157 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 14999 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Pipe"_cs; }
    static cstring static_type_name() { return "BFN::Pipe"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Pipe(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(Pipe)
    DECLARE_TYPEINFO_WITH_TYPEID(Pipe, NodeKind::BFN_Pipe, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {

class BridgePath : public Pipe {
 public:
    ordered_map<gress_t, std::vector<thread_t>> threads;
#line 195 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    BridgePath();
#line 15023 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 196 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 15027 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::BridgePath const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::BridgePath"_cs; }
    static cstring static_type_name() { return "BFN::BridgePath"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    BridgePath(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Pipe const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(BridgePath)
    DECLARE_TYPEINFO_WITH_TYPEID(BridgePath, NodeKind::BFN_BridgePath, Pipe);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {

class Toplevel : public Node {
 public:


    const IR::P4Program* program = nullptr;


    const IR::Vector<IR::BFN::Pipe>* pipes = nullptr;


    std::vector<const IR::BFN::BridgePath *> bridge_pipes;
    IRNODE_DECLARE_APPLY_OVERLOAD(Toplevel)
#line 233 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 15061 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::Toplevel const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Toplevel"_cs; }
    static cstring static_type_name() { return "BFN::Toplevel"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Toplevel(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Toplevel(Util::SourceInfo srcInfo, const IR::P4Program* program, const IR::Vector<IR::BFN::Pipe>* pipes, std::vector<const IR::BFN::BridgePath *> bridge_pipes) :
    Node(srcInfo), program(program), pipes(pipes), bridge_pipes(bridge_pipes)
    { validate(); }
    Toplevel(const IR::P4Program* program, const IR::Vector<IR::BFN::Pipe>* pipes, std::vector<const IR::BFN::BridgePath *> bridge_pipes) :
    program(program), pipes(pipes), bridge_pipes(bridge_pipes)
    { validate(); }
    IRNODE_SUBCLASS(Toplevel)
    DECLARE_TYPEINFO_WITH_TYPEID(Toplevel, NodeKind::BFN_Toplevel, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class Unit : public Node {
 public:

#line 246 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    virtual gress_t thread() const = 0;
#line 15089 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 247 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    virtual int stage() const = 0;
#line 15092 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::Unit const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::Unit"_cs; }
    static cstring static_type_name() { return "BFN::Unit"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Unit(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    Unit(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    Unit() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Unit)
    DECLARE_TYPEINFO_WITH_TYPEID(Unit, NodeKind::BFN_Unit, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
class InstanceRef : public HeaderRef {
 public:
    IR::ID name;
    const IR::HeaderOrMetadata* obj = nullptr;
    IR::NameMap<IR::InstanceRef> nested;
#line 255 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    InstanceRef(cstring prefix, IR::ID n, const IR::Type* t, const IR::Vector<IR::Annotation>* ann = nullptr);
#line 15119 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 256 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    InstanceRef(IR::ID n, const IR::Type* t, const IR::Vector<IR::Annotation>* ann = nullptr);
#line 15122 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 258 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    InstanceRef(const IR::Type* t);
#line 15125 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 259 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    const IR::HeaderOrMetadata *baseRef() const override;
#line 15128 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 260 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15131 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 261 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15134 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::InstanceRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "InstanceRef"_cs; }
    static cstring static_type_name() { return "InstanceRef"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    InstanceRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::HeaderRef const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(InstanceRef)
    DECLARE_TYPEINFO_WITH_TYPEID(InstanceRef, NodeKind::InstanceRef, HeaderRef);
};
}  // namespace P4::IR
namespace P4::IR {
/** A normal InstanceRef preserves the instance structure in the name of the
 * object it constructs, eg. struct.hdr.field becomes three nested
 * InstanceRefs, with names "struct", "struct.hdr", and "struct.hdr.field".
 * This preserves the name qualifications and prevents name conflicts.
 *
 * These fully-qualified names are also exposed to the control plane in a few
 * places:
 *
 *  - In table match keys, unless a @name annotation removes the qualification.
 *  - In PHV field names, which impacts digests as well as the snapshot
 *    mechanism.
 *
 * Unfortunately, existing P4_14 control-plane code was written to assume that
 * all of the prefix up to "hdr.field" would be removed.  For now, we use
 * V1InstanceRef to preserve that behavior.
 */
class V1InstanceRef : public InstanceRef {
 public:
#line 282 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    V1InstanceRef(cstring prefix, IR::ID n, const IR::Type* t, const IR::Vector<IR::Annotation>* ann = nullptr);
#line 15174 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 283 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    V1InstanceRef(IR::ID n, const IR::Type* t, const IR::Vector<IR::Annotation>* ann = nullptr);
#line 15177 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 285 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15180 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 286 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15183 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::V1InstanceRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "V1InstanceRef"_cs; }
    static cstring static_type_name() { return "V1InstanceRef"_cs; }
    void toJSON(JSONGenerator & json) const override;
    V1InstanceRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::InstanceRef const & a) const override;
    bool operator==(IR::HeaderRef const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(V1InstanceRef)
    DECLARE_TYPEINFO_WITH_TYPEID(V1InstanceRef, NodeKind::V1InstanceRef, InstanceRef);
};
}  // namespace P4::IR
namespace P4::IR {
class MetadataInfo : public Node {
 public:
    bool forTM;
    gress_t gress;
    cstring type_name;
    cstring instance_name;
    cstring field_name;
#line 295 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15209 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MetadataInfo const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MetadataInfo"_cs; }
    static cstring static_type_name() { return "MetadataInfo"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    MetadataInfo(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    MetadataInfo(Util::SourceInfo srcInfo, bool forTM, gress_t gress, cstring type_name, cstring instance_name, cstring field_name) :
    Node(srcInfo), forTM(forTM), gress(gress), type_name(type_name), instance_name(instance_name), field_name(field_name)
    { validate(); }
    MetadataInfo(bool forTM, gress_t gress, cstring type_name, cstring instance_name, cstring field_name) :
    forTM(forTM), gress(gress), type_name(type_name), instance_name(instance_name), field_name(field_name)
    { validate(); }
    IRNODE_SUBCLASS(MetadataInfo)
    DECLARE_TYPEINFO_WITH_TYPEID(MetadataInfo, NodeKind::MetadataInfo, Node);
};
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/** An abstract class that represents values in the back end, including header
 * and struct fields, slices, temporary variables, literals, etc.
 *
 * NB: This is a work in progress, as we slowly transition from using
 * IR::Expression (which is a v1.def IR node) to IR::BFN::Value.
 *
 * In the back end, all expressions are converted to values and instructions.
 * For example,
 *
 *    ipv4.ttl = ipv4.ttl - 1
 *
 * becomes
 *
 *    sub(ipv4.ttl, ipv4.ttl, 1)
 *
 * where `sub` is an instruction, and `ipv4.ttl` and `1` are values.
 */
class Value : public Expression {
 public:
    bool operator==(IR::BFN::Value const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::Value"_cs; }
    static cstring static_type_name() { return "BFN::Value"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Value(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Value(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    Value(const IR::Type* type) :
    Expression(type)
    { validate(); }
    Value(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    Value() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Value)
    DECLARE_TYPEINFO_WITH_TYPEID(Value, NodeKind::BFN_Value, Expression);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/** An abstract class that represents references to values that must be stored
 * in PHV containers or other sundry types of memory in Barefoot hardware.
 *
 * This includes fields of header and metadata instances as well as temporary
 * variables.  It also includes PHV containers themselves, as some back end
 * transformations replace collections of references to field instances with
 * the PHV containers in which they reside. */
class Reference : public Value {
 public:
#line 328 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    /// Debugging information about the object referred to by this reference.
    ::BFN::DebugInfo debug;
#line 15289 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::Reference const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::Reference"_cs; }
    static cstring static_type_name() { return "BFN::Reference"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Reference(JSONLoader & json);
    bool operator==(IR::BFN::Value const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Reference(Util::SourceInfo srcInfo, const IR::Type* type) :
    Value(srcInfo, type)
    { validate(); }
    Reference(const IR::Type* type) :
    Value(type)
    { validate(); }
    Reference(Util::SourceInfo srcInfo) :
    Value(srcInfo)
    { validate(); }
    Reference() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Reference)
    DECLARE_TYPEINFO_WITH_TYPEID(Reference, NodeKind::BFN_Reference, Value);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
/** A temporary variable introduced by the compiler, which must be assigned to
 * a PHV container. */
class TempVar : public BFN::Reference {
 public:
    bool POV;


    bool deparsed_zero;
    cstring name;
    static int uid;
#line 344 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    TempVar(const IR::Type* t, bool p = false, cstring n = cstring());
#line 15329 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 350 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    TempVar(const IR::Type* t, cstring n);
#line 15332 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 353 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15335 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 354 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15338 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::TempVar const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "TempVar"_cs; }
    static cstring static_type_name() { return "TempVar"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TempVar(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Reference const & a) const override;
    bool operator==(IR::BFN::Value const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(TempVar)
    DECLARE_TYPEINFO_WITH_TYPEID(TempVar, NodeKind::TempVar, BFN::Reference);
};
}  // namespace P4::IR
namespace P4::IR {
/** A dummy padding to represent a "hole" in the container to enforce
 *  alignment constraint in a container, but okay to not have an phv allocation
 *  if unused. Note this is different from TempVar, a TempVar must be allocated
 *  to a phv container.
 */
class Padding : public BFN::Reference {
 public:
    cstring name;
    static int uid;
#line 366 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    Padding(const IR::Type* t, cstring n = cstring());
#line 15367 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 372 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15370 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 373 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15373 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::Padding const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "Padding"_cs; }
    static cstring static_type_name() { return "Padding"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Padding(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Reference const & a) const override;
    bool operator==(IR::BFN::Value const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(Padding)
    DECLARE_TYPEINFO_WITH_TYPEID(Padding, NodeKind::Padding, BFN::Reference);
};
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/**
 * Used to represent resubmit header which is always 64 bits in size.
 * This is used in flexible packing to pad resubmit header.
 * TODO: we need to ensure Phase0 to use the same IR class.
 */
class Type_FixedSizeHeader : public Type_Header {
 public:
    int fixed_size;
#line 383 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15402 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::Type_FixedSizeHeader const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::Type_FixedSizeHeader"_cs; }
    static cstring static_type_name() { return "BFN::Type_FixedSizeHeader"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Type_FixedSizeHeader(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Type_Header const & a) const override;
    bool operator==(IR::Type_StructLike const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(srcInfo, name, annotations, typeParameters, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(name, annotations, typeParameters, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(srcInfo, name, typeParameters, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, const IR::TypeParameters* typeParameters, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(name, typeParameters, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(srcInfo, name, annotations, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, IR::Vector<IR::Annotation> annotations, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(name, annotations, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(srcInfo, name, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, IR::IndexedVector<IR::StructField> fields, int fixed_size) :
    Type_Header(name, fields), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, int fixed_size) :
    Type_Header(srcInfo, name, annotations, typeParameters), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::TypeParameters* typeParameters, int fixed_size) :
    Type_Header(name, annotations, typeParameters), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, const IR::TypeParameters* typeParameters, int fixed_size) :
    Type_Header(srcInfo, name, typeParameters), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, const IR::TypeParameters* typeParameters, int fixed_size) :
    Type_Header(name, typeParameters), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, int fixed_size) :
    Type_Header(srcInfo, name, annotations), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, IR::Vector<IR::Annotation> annotations, int fixed_size) :
    Type_Header(name, annotations), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(Util::SourceInfo srcInfo, IR::ID name, int fixed_size) :
    Type_Header(srcInfo, name), fixed_size(fixed_size)
    { validate(); }
    Type_FixedSizeHeader(IR::ID name, int fixed_size) :
    Type_Header(name), fixed_size(fixed_size)
    { validate(); }
    IRNODE_SUBCLASS(Type_FixedSizeHeader)
    DECLARE_TYPEINFO_WITH_TYPEID(Type_FixedSizeHeader, NodeKind::BFN_Type_FixedSizeHeader, Type_Header);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/** A reference to a PHV container.  At the hardware level, Barefoot switches
 * operate over PHV containers, not header/metadata fields, and the back end
 * eventually lowers operations to work on PHV containers directly.
 *
 * NB: This is a work in progress; not all operations are lowered to operate on
 * containers directly.  See parde-lowered.def for examples.
 */
class ContainerRef : public Reference {
 public:
#line 396 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    // We tag ContainerRefs with unique identifiers to structurally distinguish
    // different references to the same container.
    static size_t nextId;
#line 15484 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    PHV::Container container;
    std::optional<nw_bitrange> range;
    size_t id;
#line 408 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    ContainerRef(PHV::Container c);
#line 15490 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 409 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    ContainerRef(Util::SourceInfo si, PHV::Container c);
#line 15493 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 412 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void validate() const override;
#line 15496 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 415 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15499 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 429 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15502 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// @return a clone of this ContainerRef which does not compare equal
/// to the original or to any other existing ContainerRef.
#line 433 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    const IR::BFN::ContainerRef *makeFresh() const;
#line 15507 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ContainerRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ContainerRef"_cs; }
    static cstring static_type_name() { return "BFN::ContainerRef"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ContainerRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Reference const & a) const override;
    bool operator==(IR::BFN::Value const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(ContainerRef)
    DECLARE_TYPEINFO_WITH_TYPEID(ContainerRef, NodeKind::BFN_ContainerRef, Reference);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A reference to a single bit within a PHV container. (e.g., a POV bit)
class ContainerBitRef : public Reference {
 public:
#line 442 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15532 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 443 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15535 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The container containing the bit.
    const IR::BFN::ContainerRef* container = nullptr;
    unsigned bit;
    bool operator==(IR::BFN::ContainerBitRef const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ContainerBitRef"_cs; }
    static cstring static_type_name() { return "BFN::ContainerBitRef"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ContainerBitRef(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Reference const & a) const override;
    bool operator==(IR::BFN::Value const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ContainerBitRef(Util::SourceInfo srcInfo, const IR::Type* type, const IR::BFN::ContainerRef* container, unsigned bit) :
    Reference(srcInfo, type), container(container), bit(bit)
    { validate(); }
    ContainerBitRef(const IR::Type* type, const IR::BFN::ContainerRef* container, unsigned bit) :
    Reference(type), container(container), bit(bit)
    { validate(); }
    ContainerBitRef(Util::SourceInfo srcInfo, const IR::BFN::ContainerRef* container, unsigned bit) :
    Reference(srcInfo), container(container), bit(bit)
    { validate(); }
    ContainerBitRef(const IR::BFN::ContainerRef* container, unsigned bit) :
    container(container), bit(bit)
    { validate(); }
    IRNODE_SUBCLASS(ContainerBitRef)
    DECLARE_TYPEINFO_WITH_TYPEID(ContainerBitRef, NodeKind::BFN_ContainerBitRef, Reference);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/** When two fields are aliased, we replace one with the other during
 * compilation.  We call the one being removed the alias "source" and the one
 * being inserted in its place the "destination".
 *
 * An AliasMember node represents such a replacement.  The IR::Member part of
 * the node holds the alias destination, but the extra `source` field points to
 * the original alias source.
 */
class AliasMember : public Member {
 public:
/// The original expression (i.e. the alias source) that has been replaced
/// by this AliasMember.  Not visited in IR traversals.
    const IR::Expression* source = nullptr;
#line 464 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15588 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 469 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 15592 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// do not use the auto-generated equiv function.
/// do not compare the 'source' field of the AliasMember.
#line 476 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    bool equiv(IR::Node const & a_) const override;
#line 15597 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 479 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    /// A convenience method to construct an AliasMember with source info from
    /// the alias source.
    AliasMember(const IR::Member* destination, const IR::Expression* source)
    : IR::Member(source->srcInfo, destination->type, destination->expr, destination->member),
      source(source) { }
#line 15604 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::AliasMember const & a) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::AliasMember"_cs; }
    static cstring static_type_name() { return "BFN::AliasMember"_cs; }
    void toJSON(JSONGenerator & json) const override;
    AliasMember(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Member const & a) const override;
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AliasMember(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, IR::ID member, const IR::Expression* source) :
    Member(srcInfo, type, expr, member), source(source)
    { validate(); }
    AliasMember(const IR::Type* type, const IR::Expression* expr, IR::ID member, const IR::Expression* source) :
    Member(type, expr, member), source(source)
    { validate(); }
    AliasMember(Util::SourceInfo srcInfo, const IR::Expression* expr, IR::ID member, const IR::Expression* source) :
    Member(srcInfo, expr, member), source(source)
    { validate(); }
    AliasMember(const IR::Expression* expr, IR::ID member, const IR::Expression* source) :
    Member(expr, member), source(source)
    { validate(); }
    IRNODE_SUBCLASS(AliasMember)
    DECLARE_TYPEINFO_WITH_TYPEID(AliasMember, NodeKind::BFN_AliasMember, Member);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/** When two fields are aliased, we replace one with the other during
 * compilation.  We call the one being removed the alias "source" and the one
 * being inserted in its place the "destination".
 *
 * An AliasSlice node represents such a replacement, in the case when an alias
 * source is a field, but the alias destination is a slice of another field.
 * The IR::Slice part of the node holds the alias destination, but the extra
 * `source` field points to the original alias source.
 */
class AliasSlice : public Slice {
 public:
/// The original expression (i.e. the alias source) that has been replaced
/// by this AliasSlice.  Not visited in IR traversals.
    const IR::Expression* source = nullptr;
#line 501 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void dbprint(std::ostream & out) const override;
#line 15652 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 506 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 15656 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 511 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    /// A convenience method to construct an AliasSlice with source info from
    /// the alias source.
    AliasSlice(const IR::Slice* dest, const IR::Expression* source)
    : IR::Slice(source->srcInfo, dest->type, dest->e0, dest->e1, dest->e2), source(source) { }
#line 15662 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::AliasSlice const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::AliasSlice"_cs; }
    static cstring static_type_name() { return "BFN::AliasSlice"_cs; }
    void toJSON(JSONGenerator & json) const override;
    AliasSlice(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Slice const & a) const override;
    bool operator==(IR::AbstractSlice const & a) const override;
    bool operator==(IR::Operation_Ternary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AliasSlice(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2, const IR::Expression* source) :
    Slice(srcInfo, type, e0, e1, e2), source(source)
    { validate(); }
    AliasSlice(const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2, const IR::Expression* source) :
    Slice(type, e0, e1, e2), source(source)
    { validate(); }
    AliasSlice(Util::SourceInfo srcInfo, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2, const IR::Expression* source) :
    Slice(srcInfo, e0, e1, e2), source(source)
    { validate(); }
    AliasSlice(const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2, const IR::Expression* source) :
    Slice(e0, e1, e2), source(source)
    { validate(); }
    IRNODE_SUBCLASS(AliasSlice)
    DECLARE_TYPEINFO_WITH_TYPEID(AliasSlice, NodeKind::BFN_AliasSlice, Slice);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
/** This class adds the convenience of specifying field list, field list
 *  calculation and algorithm names specified in a p4 program to a ListExpression
 *  which carries the field list
 */
class HashListExpression : public ListExpression {
 public:
    cstring fieldListCalcName;
    int outputWidth;
    const IR::NameList* fieldListNames = nullptr;
    const IR::NameList* algorithms = nullptr;
    bool operator==(IR::HashListExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "HashListExpression"_cs; }
    static cstring static_type_name() { return "HashListExpression"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HashListExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::ListExpression const & a) const override;
    bool operator==(IR::BaseListExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HashListExpression(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::Expression> components, cstring fieldListCalcName, int outputWidth) :
    ListExpression(srcInfo, type, components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    HashListExpression(const IR::Type* type, IR::Vector<IR::Expression> components, cstring fieldListCalcName, int outputWidth) :
    ListExpression(type, components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    HashListExpression(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> components, cstring fieldListCalcName, int outputWidth) :
    ListExpression(srcInfo, components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    HashListExpression(IR::Vector<IR::Expression> components, cstring fieldListCalcName, int outputWidth) :
    ListExpression(components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    IRNODE_SUBCLASS(HashListExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(HashListExpression, NodeKind::HashListExpression, ListExpression);
};
}  // namespace P4::IR
namespace P4::IR {
/** This class adds the convenience of specifying field list, field list
 *  calculation and algorithm names specified in a p4 program to a StructExpression
 *  which carries the field list
 */
class HashStructExpression : public StructExpression {
 public:
    cstring fieldListCalcName;
    int outputWidth;
    const IR::NameList* fieldListNames = nullptr;
    const IR::NameList* algorithms = nullptr;
    bool operator==(IR::HashStructExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "HashStructExpression"_cs; }
    static cstring static_type_name() { return "HashStructExpression"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HashStructExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::StructExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HashStructExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, cstring fieldListCalcName, int outputWidth) :
    StructExpression(srcInfo, type, structType, components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    HashStructExpression(const IR::Type* type, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, cstring fieldListCalcName, int outputWidth) :
    StructExpression(type, structType, components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    HashStructExpression(Util::SourceInfo srcInfo, const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, cstring fieldListCalcName, int outputWidth) :
    StructExpression(srcInfo, structType, components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    HashStructExpression(const IR::Type* structType, IR::IndexedVector<IR::NamedExpression> components, cstring fieldListCalcName, int outputWidth) :
    StructExpression(structType, components), fieldListCalcName(fieldListCalcName), outputWidth(outputWidth)
    { validate(); }
    IRNODE_SUBCLASS(HashStructExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(HashStructExpression, NodeKind::HashStructExpression, StructExpression);
};
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/**
 * We specialize the cast that only perform sign conversion to a separate
 * reinterpret_cast class. Reinterpreset_cast is handled in the backend. Other
 * types of cast are eliminated in the midend. */
class ReinterpretCast : public Cast {
 public:
    cstring getStringOp() const override { return cstring("(reinterpret_cast)"); }
#line 548 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15786 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 549 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void validate() const override;
#line 15789 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ReinterpretCast const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ReinterpretCast"_cs; }
    static cstring static_type_name() { return "BFN::ReinterpretCast"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ReinterpretCast(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Cast const & a) const override;
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ReinterpretCast(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, bool implicit) :
    Cast(srcInfo, type, expr, implicit)
    { validate(); }
    ReinterpretCast(const IR::Type* type, const IR::Expression* expr, bool implicit) :
    Cast(type, expr, implicit)
    { validate(); }
    ReinterpretCast(Util::SourceInfo srcInfo, const IR::Expression* expr, bool implicit) :
    Cast(srcInfo, expr, implicit)
    { validate(); }
    ReinterpretCast(const IR::Expression* expr, bool implicit) :
    Cast(expr, implicit)
    { validate(); }
    ReinterpretCast(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Cast(srcInfo, type, expr)
    { validate(); }
    ReinterpretCast(const IR::Type* type, const IR::Expression* expr) :
    Cast(type, expr)
    { validate(); }
    ReinterpretCast(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Cast(srcInfo, expr)
    { validate(); }
    ReinterpretCast(const IR::Expression* expr) :
    Cast(expr)
    { validate(); }
    IRNODE_SUBCLASS(ReinterpretCast)
    DECLARE_TYPEINFO_WITH_TYPEID(ReinterpretCast, NodeKind::BFN_ReinterpretCast, Cast);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/** We specialize the cast that perform sign extension with a separate sign_extend_cast
 * class. Sign_extend is handled in the backend. */
class SignExtend : public Cast {
 public:
    cstring getStringOp() const override { return cstring("(sign_extend)"); }
#line 556 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    cstring toString() const override;
#line 15841 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 557 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/tofino.def"
    void validate() const override;
#line 15844 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::SignExtend const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::SignExtend"_cs; }
    static cstring static_type_name() { return "BFN::SignExtend"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SignExtend(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Cast const & a) const override;
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SignExtend(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, bool implicit) :
    Cast(srcInfo, type, expr, implicit)
    { validate(); }
    SignExtend(const IR::Type* type, const IR::Expression* expr, bool implicit) :
    Cast(type, expr, implicit)
    { validate(); }
    SignExtend(Util::SourceInfo srcInfo, const IR::Expression* expr, bool implicit) :
    Cast(srcInfo, expr, implicit)
    { validate(); }
    SignExtend(const IR::Expression* expr, bool implicit) :
    Cast(expr, implicit)
    { validate(); }
    SignExtend(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Cast(srcInfo, type, expr)
    { validate(); }
    SignExtend(const IR::Type* type, const IR::Expression* expr) :
    Cast(type, expr)
    { validate(); }
    SignExtend(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Cast(srcInfo, expr)
    { validate(); }
    SignExtend(const IR::Expression* expr) :
    Cast(expr)
    { validate(); }
    IRNODE_SUBCLASS(SignExtend)
    DECLARE_TYPEINFO_WITH_TYPEID(SignExtend, NodeKind::BFN_SignExtend, Cast);
};
}  // namespace BFN
}  // namespace P4::IR
/**
 * Copyright (C) 2024 Intel Corporation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * 
 * SPDX-License-Identifier: Apache-2.0
 */
/* -*-C++-*- */
#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
#include "backends/tofino/bf-p4c/ir/gress.h"
#include "lib/ordered_map.h"
#line 15908 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
namespace BFN {
/// A P4Control produced by TNA translation; contains some additional useful
/// metadata.
class TnaControl : public P4Control {
 public:
#line 32 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    cstring toString() const override;
#line 15917 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// A map from standard TNA parameter names to the names actually used in
/// the P4 program. For example, a TNA control prototype may include a
/// parameter "inout M ig_md", but the user program instantiating the
/// control may use "inout M user_metadata"; this map would include a
/// mapping from "ig_md" to "user_metadata".
    ordered_map<cstring, cstring> tnaParams;
/// The thread this control is associated with.
    gress_t thread;
/// The pipe name this control belongs to
    cstring pipeName;
    bool operator==(IR::BFN::TnaControl const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::TnaControl"_cs; }
    static cstring static_type_name() { return "BFN::TnaControl"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TnaControl(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::P4Control const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, constructorParams, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, constructorParams, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, constructorParams, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, constructorParams, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaControl(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaControl(IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    IRNODE_SUBCLASS(TnaControl)
    DECLARE_TYPEINFO_WITH_TYPEID(TnaControl, NodeKind::BFN_TnaControl, P4Control);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A P4Deparser produced by TNA translation; contains some additional useful
/// metadata.
class TnaDeparser : public P4Control {
 public:
#line 52 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    cstring toString() const override;
#line 16001 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// A map from standard TNA parameter names to the names actually used in
/// the P4 program. For example, a TNA control prototype may include a
/// parameter "inout M ig_md", but the user program instantiating the
/// control may use "inout M user_metadata"; this map would include a
/// mapping from "ig_md" to "user_metadata".
    ordered_map<cstring, cstring> tnaParams;
/// The thread this control is associated with.
    gress_t thread;
/// The pipe name this control belongs to
    cstring pipeName;
    bool operator==(IR::BFN::TnaDeparser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::TnaDeparser"_cs; }
    static cstring static_type_name() { return "BFN::TnaDeparser"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TnaDeparser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::P4Control const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, controlLocals, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, constructorParams, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, constructorParams, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(srcInfo, name, type, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Control(name, type, body), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, constructorParams, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, IR::IndexedVector<IR::Declaration> controlLocals, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, controlLocals, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, constructorParams, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, const IR::ParameterList* constructorParams, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, constructorParams, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaDeparser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(srcInfo, name, type, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaDeparser(IR::ID name, const IR::Type_Control* type, const IR::BlockStatement* body, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Control(name, type, body), tnaParams(tnaParams), thread(thread)
    { validate(); }
    IRNODE_SUBCLASS(TnaDeparser)
    DECLARE_TYPEINFO_WITH_TYPEID(TnaDeparser, NodeKind::BFN_TnaDeparser, P4Control);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A P4Parser produced by TNA translation; contains some additional useful
/// metadata.
class TnaParser : public P4Parser {
 public:
#line 72 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    cstring toString() const override;
#line 16085 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 73 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    void dbprint(std::ostream & out) const override;
#line 16088 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// A map from standard TNA parameter names to the names actually used in
/// the P4 program. @see TnaControl::tnaParams.
    ordered_map<cstring, cstring> tnaParams;
/// The thread this parser is associated with.
    gress_t thread;
/// Phase0 Info
    const IR::BFN::Phase0* phase0 = nullptr;
/// The pipe name this parser belongs to
    cstring pipeName;
/// The port to configure at initialization time.
    std::vector<int> portmap;
    bool operator==(IR::BFN::TnaParser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::TnaParser"_cs; }
    static cstring static_type_name() { return "BFN::TnaParser"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TnaParser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::P4Parser const & a) const override;
    bool operator==(IR::Type_Declaration const & a) const override;
    bool operator==(IR::Type const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName, std::vector<int> portmap) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread), pipeName(pipeName), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread), phase0(phase0), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, std::vector<int> portmap) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread), portmap(portmap)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0, cstring pipeName) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread), phase0(phase0), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, cstring pipeName) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread), pipeName(pipeName)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread, const IR::BFN::Phase0* phase0) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread), phase0(phase0)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type, constructorParams, parserLocals, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type, parserLocals, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type, parserLocals, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type, constructorParams, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type, constructorParams, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::ParserState> states, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type, states), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type, constructorParams, parserLocals), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type, parserLocals), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, IR::IndexedVector<IR::Declaration> parserLocals, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type, parserLocals), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type, constructorParams), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, const IR::ParameterList* constructorParams, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type, constructorParams), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(Util::SourceInfo srcInfo, IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(srcInfo, name, type), tnaParams(tnaParams), thread(thread)
    { validate(); }
    TnaParser(IR::ID name, const IR::Type_Parser* type, ordered_map<cstring, cstring> tnaParams, gress_t thread) :
    P4Parser(name, type), tnaParams(tnaParams), thread(thread)
    { validate(); }
    IRNODE_SUBCLASS(TnaParser)
    DECLARE_TYPEINFO_WITH_TYPEID(TnaParser, NodeKind::BFN_TnaParser, P4Parser);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A thread of P4 execution expressed in frontend IR;
/// Used to identify the parser/mau/deparser block from
/// architecture PackageBlock.
class P4Thread : public Node {
 public:
#line 96 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    cstring toString() const override;
#line 16512 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 97 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    void dbprint(std::ostream & out) const override;
#line 16515 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 99 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    P4Thread();
#line 16518 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IR::Vector<IR::P4Parser> parsers = {};
    IR::P4Control const * mau = nullptr;
    IR::P4Control const * deparser = nullptr;
#line 103 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    void toJSON(JSONGenerator & json) const override;
#line 16524 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 107 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    static IR::Node * fromJSON(JSONLoader & json);
#line 16527 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(P4Thread)
#line 115 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/arch.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 16532 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::P4Thread const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::P4Thread"_cs; }
    static cstring static_type_name() { return "BFN::P4Thread"_cs; }
    void dump_fields(std::ostream & out) const override;
    P4Thread(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(P4Thread)
    DECLARE_TYPEINFO_WITH_TYPEID(P4Thread, NodeKind::BFN_P4Thread, Node);
};
}  // namespace BFN
}  // namespace P4::IR

#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
struct TableResourceAlloc;
#include <optional>
#include "lib/bitvec.h"
#include "lib/ltbitmatrix.h"
#include "backends/tofino/bf-p4c/ir/ir_enums.h"
#include "backends/tofino/bf-p4c/ir/unique_id.h"
#include "backends/tofino/bf-p4c/mau/hash_function.h"
#include "backends/tofino/bf-p4c/lib/error_macros.h"
#line 16556 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
namespace MAU {
/** A Tofino logical table (group) -- a gateway and/or match table
 * along with whatever attached tables are run.  The basic scheduling
 * unit for tofino; there are 16 such 'logical' tables available in
 * each stage, which will run simultaneously and have their results
 * predicated by the predicate mask calculated from the next tables */
class Table : public BFN::Unit, public virtual IAnnotated {
 public:



    cstring name;
    gress_t gress;
    cstring gateway_name;
    cstring gateway_cond;


    cstring gateway_result_tag;
/// The stage to which this table is assigned, if any.
    std::optional<unsigned> stage_ = std::nullopt;
/// The logical ID within the stage to which this table is assigned.
    std::optional<unsigned> logical_id = std::nullopt;

    int stage_split = -1;
    int logical_split = -1;
    int logical_tables_in_stage = -1;
    int atcam_entries_in_stage = -1;
/**
     * each gateway_row is an expression for a single row of the gateway,
     * with the string being a tag to run in 'next' for next table, or null
     * if the match_table should run.  The last row (only) may have a NULL
     * expression for 'always' -- corresponding to the gateway miss action
     * (taken if no gateway rows match).  If this last row NULL expression
     * is not present, the default action is to run the table.
     */
    safe_vector<std::pair<const IR::Expression *, cstring>> gateway_rows;
/**
     * If the gateway inhibits the match_table (gateway_row.second != NULL), then the gateway
     * can also run an action directly, via the payload.  All rows must be the same action on
     * tofino1, but tofino2 allows different actions for different rows.
     *
     * The gateway payload key value pair is:
     *     the key corresponds to gateway_row.second which inhibits the table.  These also
     *     appear as the keys in the next map.
     *     the value is a pair of two items.  The first item is the key of the corresponding
     *     action in the actions map.  The vector of Constants is the value of parameters
     *     of the action
     */
    std::map<cstring, std::pair<cstring, std::vector<const IR::Constant *>>> gateway_payload;


    IR::Vector<IR::MAU::TableKey> gateway_constant_entries_key;

    const IR::P4Table* match_table = nullptr;
    IR::Vector<IR::MAU::BackendAttached> attached;


    ordered_map<cstring, const IR::MAU::Action *> actions;
    ordered_map<cstring, const IR::MAU::TableSeq *> next;
    IR::Vector<IR::MAU::TableKey> match_key;

    LTBitMatrix sel_symmetric_keys = {};
    int random_seed = -1;
    bool dynamic_key_masks = false;
    const IR::EntriesList* entries_list = nullptr;
    int first_entry_list_priority = 0;

    bool created_during_tp = false;



    bool is_compiler_generated = false;


    bool has_dark_init = false;
    AlwaysRun always_run = AlwaysRun::NONE;
    bool suppress_context_json = false;
    bool run_before_exit = false;
    bool is_detached_attached_tbl = false;
class IndirectAddress {
 public:
    bool shifter_enabled = false;
    int address_bits = 0;
    bool per_flow_enable = false;
    int meter_type_bits = 0;
#line 125 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
        IndirectAddress &operator+=(const IndirectAddress &a);
#line 16645 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 127 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int total_bits() const;
#line 16648 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::Table::IndirectAddress const & a) const;
    void toJSON(JSONGenerator & json) const;
    IndirectAddress(JSONLoader & json);
    static IR::MAU::Table::IndirectAddress * fromJSON(JSONLoader & json);
    IndirectAddress() 
    {}
};
class Layout {
 public:

    int entries = 0;
    bool pre_classifier = false;
    bool gateway = false;
    bool exact = false;
    bool ternary = false;
    bool hash_action = false;
    bool gateway_match = false;

    bool atcam = false;
    bool alpm = false;
    bool has_range = false;
    bool proxy_hash = false;
    bool requires_versioning = true;
    bool is_lamb = false;
    bool is_direct = false;
    bool is_local_tind = false;
    int entries_per_set = 0;
    int sets_per_word = 0;
    int ixbar_bytes = 0;
    int match_bytes = 0;
    int ixbar_width_bits = 0;
    int match_width_bits = 0;
    int ghost_bytes = 0;
    int action_data_bytes = 0;
    int action_data_bytes_in_table = 0;
    int pre_classifer_number_entries = 0;
    int overhead_bits = 0;
    int immediate_bits = 0;
    int valid_bits = 0;
    int partition_bits = 0;
    int partition_count = 0;
    int subtrees_per_partition = 0;
    int atcam_subset_width = 0;
    int shift_granularity = 0;
    int total_actions = 0;
    int sel_len_bits = 0;
    int proxy_hash_width = 0;
    HashFunction proxy_hash_algorithm = {};
    IR::MAU::Table::IndirectAddress meter_addr = {};
    IR::MAU::Table::IndirectAddress stats_addr = {};
    IR::MAU::Table::IndirectAddress action_addr = {};
    std::map<cstring, int> excluded_field_msb_bits = {};
#line 178 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool is_lamb_direct() const;
#line 16703 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 179 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_subword_bits() const;
#line 16706 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 184 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_sram_depth() const;
#line 16709 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/**
         * @brief Equivalent to get_sram_depth() for non-ATCAM tables.
         *
         * @return min(partition_count, get_sram_depth()) for ATCAM tables
         */
#line 194 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int words_per_sram() const;
#line 16717 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 198 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_ram_line_select_bits() const;
#line 16720 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 203 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_ram_ghost_bits() const;
#line 16723 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 207 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool direct_ad_required() const;
#line 16726 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 214 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool ternary_indirect_required() const;
#line 16729 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 215 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool no_match_data() const;
#line 16732 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 218 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool no_match_rams() const;
#line 16735 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/** no match tables that need hash_dist need to go through the hit path; all others
         *  can use the miss path
         */
#line 224 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool no_match_hit_path() const;
#line 16741 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/** Any keyless table that has parameters that can be adjusted during runtime, such
         *  as action or action data must go through the miss pathway, as those are the registers
         *  configured by the driver when the control plane requests a change
         */
#line 231 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool no_match_miss_path() const;
#line 16748 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 235 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
        friend std::ostream &operator<<(std::ostream &out, Layout&layout) {
            Log::TempIndent indent;
            out << "layout: " << layout.entries << indent;
            if (layout.pre_classifier) out << 'c';
            if (layout.gateway) out << 'g';
            if (layout.exact) out << 'e';
            if (layout.ternary) out << 't';
            if (layout.hash_action) out << 'h';
            if (layout.gateway_match) out << 'G';
            if (layout.atcam) out << 'T';
            if (layout.alpm) out << 'L';
            if (layout.has_range) out << 'r';
            if (layout.proxy_hash) out << 'P';
            if (layout.requires_versioning) out << 'V';
            out << " ixbar:" << layout.ixbar_bytes << "B/" << layout.ixbar_width_bits << "b";
            out << " match:" << layout.match_bytes << "B/" << layout.match_width_bits << "b";
            if (layout.ghost_bytes) out << " gh:" << layout.ghost_bytes;
            if (layout.action_data_bytes || layout.action_data_bytes_in_table) {
                out << " adb:" << layout.action_data_bytes;
                if (layout.action_data_bytes_in_table)
                    out << "/" << layout.action_data_bytes_in_table; }
            if (layout.overhead_bits) out << " ov:" << layout.overhead_bits;
            if (layout.immediate_bits) out << " imm:" << layout.immediate_bits;
            if (layout.partition_bits) out << " part:" << layout.partition_bits;
            return out;
        }
        friend std::ostream &operator<<(std::ostream &out, const Layout&layout) {
            Log::TempIndent indent;
            out << "layout: " << layout.entries << indent;
            if (layout.pre_classifier) out << 'c';
            if (layout.gateway) out << 'g';
            if (layout.exact) out << 'e';
            if (layout.ternary) out << 't';
            if (layout.hash_action) out << 'h';
            if (layout.gateway_match) out << 'G';
            if (layout.atcam) out << 'T';
            if (layout.alpm) out << 'L';
            if (layout.has_range) out << 'r';
            if (layout.proxy_hash) out << 'P';
            if (layout.requires_versioning) out << 'V';
            out << " ixbar:" << layout.ixbar_bytes << "B/" << layout.ixbar_width_bits << "b";
            out << " match:" << layout.match_bytes << "B/" << layout.match_width_bits << "b";
            if (layout.ghost_bytes) out << " gh:" << layout.ghost_bytes;
            if (layout.action_data_bytes || layout.action_data_bytes_in_table) {
                out << " adb:" << layout.action_data_bytes;
                if (layout.action_data_bytes_in_table)
                    out << "/" << layout.action_data_bytes_in_table; }
            if (layout.overhead_bits) out << " ov:" << layout.overhead_bits;
            if (layout.immediate_bits) out << " imm:" << layout.immediate_bits;
            if (layout.partition_bits) out << " part:" << layout.partition_bits;
            return out;
        }
        Layout &operator+=(const Layout &a);
#line 16803 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::Table::Layout const & a) const;
    void toJSON(JSONGenerator & json) const;
    Layout(JSONLoader & json);
    static IR::MAU::Table::Layout * fromJSON(JSONLoader & json);
    Layout() 
    {}
};
    Layout layout;
class Way {
 public:

    int match_groups = 0;
    int entries = 0;
    int width = 0;
    bool operator==(IR::MAU::Table::Way const & a) const;
    void toJSON(JSONGenerator & json) const;
    Way(JSONLoader & json);
    static IR::MAU::Table::Way * fromJSON(JSONLoader & json);
    Way() 
    {}
};
    safe_vector<Way> ways;
    TableResourceAlloc const * resources = nullptr;
#line 299 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool is_placed() const;
#line 16829 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 300 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool hit_miss_p4() const;
#line 16832 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 301 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool action_chain() const;
#line 16835 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 302 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool has_default_path() const;
#line 16838 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 303 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int action_next_paths() const;
#line 16841 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 304 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_placement_priority_int() const;
#line 16844 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 305 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    std::set<cstring> get_placement_priority_string() const;
#line 16847 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 306 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_provided_stage(int geq_stage = -1, int * req_entries = 0, int * flags = 0) const;
#line 16850 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 307 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int hit_actions() const;
#line 16853 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 308 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool has_exit_action() const;
#line 16856 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 309 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::MAU::Action *get_default_action() const;
#line 16859 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 310 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    std::vector<const IR::MAU::Action *> get_exit_actions() const;
#line 16862 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 311 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool has_non_exit_action() const;
#line 16865 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 312 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool is_exit_table() const;
#line 16868 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 313 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool has_exit_recursive() const;
#line 16872 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 314 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_random_seed() const;
#line 16876 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 315 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_pragma_max_actions() const;
#line 16879 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 316 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    unsigned get_match_key_width() const;
#line 16882 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 318 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    // Two pragmas can be used to control the usage of the immediate usage. "immediate" pragma
    // can be set as 0 to force the usage of action data table. "force_immediate" pragma can be
    // set to 1 to pack action data in match overhead. The combination of both result in 3 possible
    // configuration as listed by this enum.
    enum ImmediateControl_t { COMPILER, FORCE_IMMEDIATE, FORCE_NON_IMMEDIATE };
#line 16889 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 324 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    ImmediateControl_t get_immediate_ctrl() const;
#line 16892 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 325 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool has_match_data() const;
#line 16895 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 326 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_dleft() const;
#line 16898 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 327 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool is_always_run_action() const;
#line 16901 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 329 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 16904 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 330 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 16907 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 332 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::Expression *getExprAnnotation(cstring name) const;
#line 16910 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 334 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    using IAnnotated::getAnnotation;
#line 16913 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 336 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool getAnnotation(cstring name, int & val) const;
#line 16916 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 337 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool getAnnotation(cstring name, bool & val) const;
#line 16919 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 338 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool getAnnotation(cstring name, IR::ID & val) const;
#line 16922 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 339 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool getAnnotation(cstring name, std::vector<IR::ID> & val) const;
#line 16925 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 340 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externalName() const;
#line 16928 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 341 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void remove_gateway();
#line 16932 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 343 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueId pp_unique_id(const IR::MAU::AttachedMemory* at = nullptr, bool is_gw = false, int stage_table = -1, int logical_table = -1, UniqueAttachedId::pre_placed_type_t ppt = UniqueAttachedId::NO_PP) const;
#line 16935 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 347 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueId unique_id(const IR::MAU::AttachedMemory* at = nullptr, bool is_gw = false) const;
#line 16938 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 348 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueId get_uid(const IR::MAU::AttachedMemory* at = nullptr, bool is_gw = false) const;
#line 16941 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 349 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::MAU::BackendAttached *get_attached(UniqueId id) const;
#line 16944 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 350 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::MAU::BackendAttached *get_attached(const IR::MAU::AttachedMemory* am) const;
#line 16947 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 352 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    template<class T> const T *get_attached() const;
#line 16950 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 357 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    Table(cstring n, gress_t gr);
#line 16953 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 358 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    Table(cstring n, gress_t gr, const IR::P4Table* t);
#line 16956 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 361 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    Table(cstring n, gress_t gr, const Expression *gw)
    : BFN::Unit(gw->srcInfo), name(n), gress(gr),
      gateway_rows{ std::make_pair(gw, "$true"_cs), std::make_pair(nullptr, "$false"_cs) } {}
    // ir-generator can't parse {}-initializer (thinks it is the ctor body
#line 16962 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/** Returns the global logical ID for this table. Each stage has 16 slots
     * for tables.  Global logical IDs are numbered from 0 (Stage 0, Slot 0) to
     * N * 16 + 15 (Stage N, Slot 15).
     */
#line 371 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    std::optional<int> global_id() const;
#line 16969 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 375 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void set_global_id(int id);
#line 16972 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 379 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int logical_order() const;
#line 16975 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 380 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::MAU::Table * clone_rename(cstring ext) const;
#line 16978 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 386 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool operator==(const Table &a) const override;
    bool operator==(const IR::BFN::Unit &a) const override { return a == *this; }
    bool operator==(const IR::Node &a) const override { return a == *this; }
#line 16983 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 390 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring get_table_type_string() const;
#line 16986 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 391 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool uses_gateway() const;
#line 16989 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 392 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool uses_gateway_payload() const;
#line 16992 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 399 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool conditional_gateway_only() const;
#line 16995 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 400 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool is_a_gateway_table_only() const;
#line 16998 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 401 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring build_gateway_name() const;
#line 17001 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 406 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool uses_idletime() const;
#line 17004 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 410 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int stage() const override;
#line 17007 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 411 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    gress_t thread() const override;
#line 17010 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 412 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring toString() const override;
#line 17013 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 413 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void validate() const override;
#line 17016 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"



#line 487 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 17023 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 490 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    // We use a template to obtain polymorphism on the constness of `this`.
    template<class THIS>
    static void visit_children(THIS*, Visitor& v, const char *n);

    struct payload_info_t; // data to pass between the below helper methods
    /// Helper for visit_children. Visits the match table for when it is not
    /// gateway-inhibited.
    // We use a template to obtain polymorphism on the constness of `this`.
    template<class THIS>
    static void visit_match_table(THIS* self, Visitor& v, const char *n, payload_info_t &);

    /// Helper for visit_children. Visits the gateway payload, for when the
    /// match table is gateway-inhibited.
    // We use a template to obtain polymorphism on the constness of `this`.
    template<class THIS>
    static void visit_gateway_inhibited(THIS* self, Visitor& v, const char *n, payload_info_t &);
#line 17041 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Table)
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::Table"_cs; }
    static cstring static_type_name() { return "MAU::Table"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Table(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    IRNODE_SUBCLASS(Table)
    DECLARE_TYPEINFO_WITH_TYPEID(Table, NodeKind::MAU_Table, BFN::Unit, IAnnotated);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {

class BackendAttached : public Node {
 public:
    const IR::MAU::HashDist* hash_dist = nullptr;
    int entries = -1;
    StatefulUse use = StatefulUse::NO_USE;
    AddrLocation addr_location = AddrLocation::NOT_SET;
    PfeLocation pfe_location = PfeLocation::NOT_SET;
    TypeLocation type_location = TypeLocation::NOT_SET;
    const IR::MAU::AttachedMemory* attached = nullptr;
    bool chain_vpn = false;
    bool operator==(IR::MAU::BackendAttached const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::BackendAttached"_cs; }
    static cstring static_type_name() { return "MAU::BackendAttached"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    BackendAttached(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    BackendAttached(Util::SourceInfo srcInfo, const IR::MAU::AttachedMemory* attached) :
    Node(srcInfo), attached(attached)
    { validate(); }
    BackendAttached(const IR::MAU::AttachedMemory* attached) :
    attached(attached)
    { validate(); }
    IRNODE_SUBCLASS(BackendAttached)
    DECLARE_TYPEINFO_WITH_TYPEID(BackendAttached, NodeKind::MAU_BackendAttached, Node);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class AttachedMemory : public Attached {
 public:
    bool direct = false;
    int size = 0;
#line 528 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    virtual bool indexed() const override;
#line 17101 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 529 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    virtual UniqueAttachedId::type_t get_id_type() const = 0;
#line 17104 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 530 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId unique_id() const;
#line 17107 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 531 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    virtual cstring externType() const = 0;
#line 17110 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 532 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring toString() const override;
#line 17113 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 533 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    virtual bool usesMeterBus() const;
#line 17116 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 534 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    virtual bool usesStatsBus() const;
#line 17119 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 535 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    virtual int get_min_size() const;
#line 17122 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::AttachedMemory"_cs; }
    static cstring static_type_name() { return "MAU::AttachedMemory"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AttachedMemory(JSONLoader & json);
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    AttachedMemory(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, name, annotations)
    { validate(); }
    AttachedMemory(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Attached(name, annotations)
    { validate(); }
    AttachedMemory(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Attached(srcInfo, annotations)
    { validate(); }
    AttachedMemory(IR::Vector<IR::Annotation> annotations) :
    Attached(annotations)
    { validate(); }
    AttachedMemory(Util::SourceInfo srcInfo, IR::ID name) :
    Attached(srcInfo, name)
    { validate(); }
    AttachedMemory(IR::ID name) :
    Attached(name)
    { validate(); }
    AttachedMemory(Util::SourceInfo srcInfo) :
    Attached(srcInfo)
    { validate(); }
    AttachedMemory() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(AttachedMemory)
    DECLARE_TYPEINFO_WITH_TYPEID(AttachedMemory, NodeKind::MAU_AttachedMemory, Attached);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/** Any attached table that has a keeps stateful information about flows.
 */
class Synth2Port : public AttachedMemory {
 public:
    IR::ID table = {};
    bool saturating = false;
    int width = 0;
    int bytecount_adjust = 0;
    DataAggregation type = DataAggregation::NONE;
#line 546 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void settype(cstring t);
#line 17174 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 552 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_bytecount_adjust() const;
#line 17178 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 557 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_min_size() const override;
#line 17181 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::Synth2Port const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::Synth2Port"_cs; }
    static cstring static_type_name() { return "MAU::Synth2Port"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Synth2Port(JSONLoader & json);
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Synth2Port(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(srcInfo, name, annotations)
    { validate(); }
    Synth2Port(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(name, annotations)
    { validate(); }
    Synth2Port(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(srcInfo, annotations)
    { validate(); }
    Synth2Port(IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(annotations)
    { validate(); }
    Synth2Port(Util::SourceInfo srcInfo, IR::ID name) :
    AttachedMemory(srcInfo, name)
    { validate(); }
    Synth2Port(IR::ID name) :
    AttachedMemory(name)
    { validate(); }
    Synth2Port(Util::SourceInfo srcInfo) :
    AttachedMemory(srcInfo)
    { validate(); }
    Synth2Port() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Synth2Port)
    DECLARE_TYPEINFO_WITH_TYPEID(Synth2Port, NodeKind::MAU_Synth2Port, AttachedMemory);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class Counter : public Synth2Port {
 public:
    int min_width = -1;
    int max_width = -1;

    int threshold = -1;
    int interval = -1;
    bool true_egress_accounting = false;
#line 569 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    char const * kind() const override;
#line 17233 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 571 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Type const * getType() const override;
#line 17236 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 572 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId::type_t get_id_type() const override;
#line 17239 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 573 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externType() const override;
#line 17242 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 574 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool usesStatsBus() const override;
#line 17245 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::Counter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::Counter"_cs; }
    static cstring static_type_name() { return "MAU::Counter"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Counter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::Synth2Port const & a) const override;
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Counter(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Synth2Port(srcInfo, name, annotations)
    { validate(); }
    Counter(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Synth2Port(name, annotations)
    { validate(); }
    Counter(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Synth2Port(srcInfo, annotations)
    { validate(); }
    Counter(IR::Vector<IR::Annotation> annotations) :
    Synth2Port(annotations)
    { validate(); }
    Counter(Util::SourceInfo srcInfo, IR::ID name) :
    Synth2Port(srcInfo, name)
    { validate(); }
    Counter(IR::ID name) :
    Synth2Port(name)
    { validate(); }
    Counter(Util::SourceInfo srcInfo) :
    Synth2Port(srcInfo)
    { validate(); }
    Counter() 
    { validate(); }
    IRNODE_SUBCLASS(Counter)
    DECLARE_TYPEINFO_WITH_TYPEID(Counter, NodeKind::MAU_Counter, Synth2Port);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class MeterBus2Port : public Synth2Port {
 public:

#line 578 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool usesMeterBus() const override;
#line 17293 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::MeterBus2Port const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::MeterBus2Port"_cs; }
    static cstring static_type_name() { return "MAU::MeterBus2Port"_cs; }
    void toJSON(JSONGenerator & json) const override;
    MeterBus2Port(JSONLoader & json);
    bool operator==(IR::MAU::Synth2Port const & a) const override;
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    MeterBus2Port(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Synth2Port(srcInfo, name, annotations)
    { validate(); }
    MeterBus2Port(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Synth2Port(name, annotations)
    { validate(); }
    MeterBus2Port(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    Synth2Port(srcInfo, annotations)
    { validate(); }
    MeterBus2Port(IR::Vector<IR::Annotation> annotations) :
    Synth2Port(annotations)
    { validate(); }
    MeterBus2Port(Util::SourceInfo srcInfo, IR::ID name) :
    Synth2Port(srcInfo, name)
    { validate(); }
    MeterBus2Port(IR::ID name) :
    Synth2Port(name)
    { validate(); }
    MeterBus2Port(Util::SourceInfo srcInfo) :
    Synth2Port(srcInfo)
    { validate(); }
    MeterBus2Port() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(MeterBus2Port)
    DECLARE_TYPEINFO_WITH_TYPEID(MeterBus2Port, NodeKind::MAU_MeterBus2Port, Synth2Port);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class Meter : public MeterBus2Port {
 public:
    int red_drop_value = -1;
    int red_nodrop_value = -1;
    int green_value = -1;
    int yellow_value = -1;
    int red_value = -1;
    int profile = -1;
    int sweep_interval = -1;
    bool true_egress_accounting = false;
    const IR::Expression* result = nullptr;


    const IR::MAU::HashDist* pre_color = nullptr;


    const IR::Expression* input = nullptr;

    IR::ID implementation = {};

    unsigned possible_mapram_address = 0;
#line 599 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    char const * kind() const override;
#line 17358 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 600 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Type const * getType() const override;
#line 17361 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 601 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId::type_t get_id_type() const override;
#line 17364 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 602 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool alu_output() const;
#line 17367 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 604 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool color_output() const;
#line 17370 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 606 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool mapram_possible(IR::MAU::ColorMapramAddress cma) const;
#line 17373 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 609 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externType() const override;
#line 17376 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::Meter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "MAU::Meter"_cs; }
    static cstring static_type_name() { return "MAU::Meter"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Meter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::MeterBus2Port const & a) const override;
    bool operator==(IR::MAU::Synth2Port const & a) const override;
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Meter(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(srcInfo, name, annotations)
    { validate(); }
    Meter(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(name, annotations)
    { validate(); }
    Meter(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(srcInfo, annotations)
    { validate(); }
    Meter(IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(annotations)
    { validate(); }
    Meter(Util::SourceInfo srcInfo, IR::ID name) :
    MeterBus2Port(srcInfo, name)
    { validate(); }
    Meter(IR::ID name) :
    MeterBus2Port(name)
    { validate(); }
    Meter(Util::SourceInfo srcInfo) :
    MeterBus2Port(srcInfo)
    { validate(); }
    Meter() 
    { validate(); }
    IRNODE_SUBCLASS(Meter)
    DECLARE_TYPEINFO_WITH_TYPEID(Meter, NodeKind::MAU_Meter, MeterBus2Port);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/** Configuration for a stateful table -- a register object (for the memory) plus
 * the associated stateful alu instructions and config */
class StatefulAlu : public MeterBus2Port {
 public:

    const IR::Declaration_Instance* reg = nullptr;
    const IR::MAU::Selector* selector = nullptr;
    bool dual = false;





    IR::NameMap<IR::MAU::SaluAction, ordered_map> instruction = {};



    ordered_map<cstring, cstring> action_map = {};


    ordered_map<cstring, const IR::MAU::SaluRegfileRow *> regfile = {};

    cstring overflow = {};
    cstring underflow = {};


    bool chain_vpn = false;
    int chain_total_size = size;
    big_int init_reg_lo = 0;
    big_int init_reg_hi = 0;
    cstring reduction_or_group = {};
    bool learn_action = false;

    bool synthetic_for_selector = false;

    int pred_shift = -1;
    int pred_comb_shift = -1;

    bitvec clear_value = {};
    uint32_t busy_value = 0;
class MathUnit {
 public:
    bool valid = false;
    bool exp_invert = false;
    int exp_shift = 0;
    int scale = 0;
    int table[16] = { 0 };
#line 657 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const;
#line 17471 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 659 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
        friend std::ostream &operator<<(std::ostream &out, const MathUnit &mu) {
            out << mu.valid;
            return out;
        }
#line 17477 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::StatefulAlu::MathUnit const & a) const;
    void toJSON(JSONGenerator & json) const;
    MathUnit(JSONLoader & json);
    static IR::MAU::StatefulAlu::MathUnit * fromJSON(JSONLoader & json);
    MathUnit() 
    {}
};
    MathUnit math = MathUnit();
#line 667 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    char const * kind() const override;
#line 17488 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 668 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Type const * getType() const override;
#line 17491 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 669 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId::type_t get_id_type() const override;
#line 17494 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 670 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool alu_output() const;
#line 17497 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 671 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::MAU::SaluAction *calledAction(const IR::MAU::Table* tbl, const IR::MAU::Action* act) const;
#line 17501 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 672 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_dleft() const;
#line 17504 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 677 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int source_width() const;
#line 17507 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 678 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int alu_width() const;
#line 17510 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 679 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externType() const override;
#line 17513 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::StatefulAlu const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::StatefulAlu"_cs; }
    static cstring static_type_name() { return "MAU::StatefulAlu"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    StatefulAlu(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::MeterBus2Port const & a) const override;
    bool operator==(IR::MAU::Synth2Port const & a) const override;
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo, name, annotations), reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    MeterBus2Port(name, annotations), reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo, annotations), reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    MeterBus2Port(annotations), reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name, const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo, name), reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(IR::ID name, const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    MeterBus2Port(name), reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo), reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(const IR::Declaration_Instance* reg, const IR::MAU::Selector* selector) :
    reg(reg), selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo, name, annotations), selector(selector)
    { validate(); }
    StatefulAlu(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::MAU::Selector* selector) :
    MeterBus2Port(name, annotations), selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo, annotations), selector(selector)
    { validate(); }
    StatefulAlu(IR::Vector<IR::Annotation> annotations, const IR::MAU::Selector* selector) :
    MeterBus2Port(annotations), selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo, name), selector(selector)
    { validate(); }
    StatefulAlu(IR::ID name, const IR::MAU::Selector* selector) :
    MeterBus2Port(name), selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, const IR::MAU::Selector* selector) :
    MeterBus2Port(srcInfo), selector(selector)
    { validate(); }
    StatefulAlu(const IR::MAU::Selector* selector) :
    selector(selector)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg) :
    MeterBus2Port(srcInfo, name, annotations), reg(reg)
    { validate(); }
    StatefulAlu(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg) :
    MeterBus2Port(name, annotations), reg(reg)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg) :
    MeterBus2Port(srcInfo, annotations), reg(reg)
    { validate(); }
    StatefulAlu(IR::Vector<IR::Annotation> annotations, const IR::Declaration_Instance* reg) :
    MeterBus2Port(annotations), reg(reg)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name, const IR::Declaration_Instance* reg) :
    MeterBus2Port(srcInfo, name), reg(reg)
    { validate(); }
    StatefulAlu(IR::ID name, const IR::Declaration_Instance* reg) :
    MeterBus2Port(name), reg(reg)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, const IR::Declaration_Instance* reg) :
    MeterBus2Port(srcInfo), reg(reg)
    { validate(); }
    StatefulAlu(const IR::Declaration_Instance* reg) :
    reg(reg)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(srcInfo, name, annotations)
    { validate(); }
    StatefulAlu(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(name, annotations)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(srcInfo, annotations)
    { validate(); }
    StatefulAlu(IR::Vector<IR::Annotation> annotations) :
    MeterBus2Port(annotations)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo, IR::ID name) :
    MeterBus2Port(srcInfo, name)
    { validate(); }
    StatefulAlu(IR::ID name) :
    MeterBus2Port(name)
    { validate(); }
    StatefulAlu(Util::SourceInfo srcInfo) :
    MeterBus2Port(srcInfo)
    { validate(); }
    StatefulAlu() 
    { validate(); }
    IRNODE_SUBCLASS(StatefulAlu)
    DECLARE_TYPEINFO_WITH_TYPEID(StatefulAlu, NodeKind::MAU_StatefulAlu, MeterBus2Port);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class Selector : public AttachedMemory {
 public:
    IR::ID type = {};
    SelectorMode mode = SelectorMode::FAIR;
    HashFunction algorithm = {};
#line 686 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    char const * kind() const override;
#line 17640 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 687 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId::type_t get_id_type() const override;
#line 17643 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    int num_pools = 0;
    int max_pool_size = 0;
    bool sps_scramble = true;

    const IR::MAU::HashDist* hash_mod = nullptr;
#line 692 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externType() const override;
#line 17651 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 693 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool usesMeterBus() const override;
#line 17654 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::Selector const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "MAU::Selector"_cs; }
    static cstring static_type_name() { return "MAU::Selector"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Selector(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Selector(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(srcInfo, name, annotations)
    { validate(); }
    Selector(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(name, annotations)
    { validate(); }
    Selector(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(srcInfo, annotations)
    { validate(); }
    Selector(IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(annotations)
    { validate(); }
    Selector(Util::SourceInfo srcInfo, IR::ID name) :
    AttachedMemory(srcInfo, name)
    { validate(); }
    Selector(IR::ID name) :
    AttachedMemory(name)
    { validate(); }
    Selector(Util::SourceInfo srcInfo) :
    AttachedMemory(srcInfo)
    { validate(); }
    Selector() 
    { validate(); }
    IRNODE_SUBCLASS(Selector)
    DECLARE_TYPEINFO_WITH_TYPEID(Selector, NodeKind::MAU_Selector, AttachedMemory);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/** Tofino-specific attached table type **/
/** Ternary indirect table used to hold overhead (adressing pointers and next table info)
 * of ternary match tables */
class TernaryIndirect : public AttachedMemory {
 public:
#line 705 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    TernaryIndirect(cstring tbl_name);
#line 17705 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 706 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    char const * kind() const override;
#line 17708 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 707 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId::type_t get_id_type() const override;
#line 17711 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 710 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externType() const override;
#line 17714 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::TernaryIndirect const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::TernaryIndirect"_cs; }
    static cstring static_type_name() { return "MAU::TernaryIndirect"_cs; }
    void toJSON(JSONGenerator & json) const override;
    TernaryIndirect(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(TernaryIndirect)
    DECLARE_TYPEINFO_WITH_TYPEID(TernaryIndirect, NodeKind::MAU_TernaryIndirect, AttachedMemory);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/** Action data table used to hold action parameters */
class ActionData : public AttachedMemory {
 public:
#line 716 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    char const * kind() const override;
#line 17737 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 717 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool indexed() const override;
#line 17740 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 718 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId::type_t get_id_type() const override;
#line 17743 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 721 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externType() const override;
#line 17746 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::ActionData const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::ActionData"_cs; }
    static cstring static_type_name() { return "MAU::ActionData"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ActionData(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ActionData(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(srcInfo, name, annotations)
    { validate(); }
    ActionData(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(name, annotations)
    { validate(); }
    ActionData(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(srcInfo, annotations)
    { validate(); }
    ActionData(IR::Vector<IR::Annotation> annotations) :
    AttachedMemory(annotations)
    { validate(); }
    ActionData(Util::SourceInfo srcInfo, IR::ID name) :
    AttachedMemory(srcInfo, name)
    { validate(); }
    ActionData(IR::ID name) :
    AttachedMemory(name)
    { validate(); }
    ActionData(Util::SourceInfo srcInfo) :
    AttachedMemory(srcInfo)
    { validate(); }
    ActionData() 
    { validate(); }
    IRNODE_SUBCLASS(ActionData)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionData, NodeKind::MAU_ActionData, AttachedMemory);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/** Idletime table **/
class IdleTime : public AttachedMemory {
 public:
    int precision = 3;
    int interval = 7;
#line 729 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring two_way_notification = "enable"_cs;
#line 17794 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool per_flow_idletime = true;
#line 734 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IdleTime(cstring tbl_name);
#line 17798 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 735 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    char const * kind() const override;
#line 17801 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 736 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    UniqueAttachedId::type_t get_id_type() const override;
#line 17804 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 739 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externType() const override;
#line 17807 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::IdleTime const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::IdleTime"_cs; }
    static cstring static_type_name() { return "MAU::IdleTime"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    IdleTime(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::AttachedMemory const & a) const override;
    bool operator==(IR::Attached const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(IdleTime)
    DECLARE_TYPEINFO_WITH_TYPEID(IdleTime, NodeKind::MAU_IdleTime, AttachedMemory);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {

class TableSeq : public Node {
 public:
    static int uid_ctr;
    IR::Vector<IR::MAU::Table> tables;
    LTBitMatrix deps;
    int seq_uid;

#line 751 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    TableSeq();
#line 17836 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 752 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    TableSeq(const IR::MAU::Table* a);
#line 17839 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 755 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    TableSeq(const IR::MAU::Table* a, const IR::MAU::Table* b);
#line 17842 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 759 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    TableSeq(const IR::MAU::TableSeq* a, const IR::MAU::Table* b);
#line 17845 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 763 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool empty() const;
#line 17848 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 764 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::MAU::Table *front() const;
#line 17851 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 765 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::MAU::Table *back() const;
#line 17854 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 766 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    size_t size() const;
#line 17857 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 767 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void validate() const override;
#line 17860 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"


#line 777 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool operator==(IR::MAU::TableSeq const & a) const override;
#line 17865 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 778 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool equiv(IR::Node const & a_) const override;
#line 17868 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(TableSeq)
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "MAU::TableSeq"_cs; }
    static cstring static_type_name() { return "MAU::TableSeq"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TableSeq(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(TableSeq)
    DECLARE_TYPEINFO_WITH_TYPEID(TableSeq, NodeKind::MAU_TableSeq, Node);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class Primitive : public IR::Primitive {
 public:
    bool in_hash = false;
#line 785 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    using IR::Primitive::Primitive;
#line 17892 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Primitive)
    bool operator==(IR::MAU::Primitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::Primitive"_cs; }
    static cstring static_type_name() { return "MAU::Primitive"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Primitive(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Primitive const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Primitive(Util::SourceInfo srcInfo, const IR::Type* type, cstring name) :
    IR::Primitive(srcInfo, type, name)
    { validate(); }
    Primitive(const IR::Type* type, cstring name) :
    IR::Primitive(type, name)
    { validate(); }
    Primitive(Util::SourceInfo srcInfo, cstring name) :
    IR::Primitive(srcInfo, name)
    { validate(); }
    Primitive(cstring name) :
    IR::Primitive(name)
    { validate(); }
    IRNODE_SUBCLASS(Primitive)
    DECLARE_TYPEINFO_WITH_TYPEID(Primitive, NodeKind::MAU_Primitive, IR::Primitive);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// A primitive function, optionally annotated with its front end type.
class TypedPrimitive : public Primitive {
 public:
    const IR::Type* method_type = nullptr;
    std::map<unsigned, cstring> op_names;
#line 798 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    TypedPrimitive(cstring name);
#line 17932 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 800 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    TypedPrimitive(Util::SourceInfo srcInfo, IR::Type const * return_type, IR::Type const * m_type, cstring name);
#line 17935 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 803 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 17939 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::TypedPrimitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::TypedPrimitive"_cs; }
    static cstring static_type_name() { return "MAU::TypedPrimitive"_cs; }
    void toJSON(JSONGenerator & json) const override;
    TypedPrimitive(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::Primitive const & a) const override;
    bool operator==(IR::Primitive const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(TypedPrimitive)
    DECLARE_TYPEINFO_WITH_TYPEID(TypedPrimitive, NodeKind::MAU_TypedPrimitive, Primitive);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// A single MAU instruction.  For the most part instructions look exactly like Primitives,
/// just with more constraints applied.  For example, an "add" instruction has the same
/// destination and two sources as an "add" primitive, with the additional constraints that
/// the dest and first source are PHV while second source can be PHV, action bus, or constant.
/// We convert the primitive into an instruction when we check those constraints
class Instruction : public Primitive {
 public:
#line 814 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    using Primitive::Primitive;
#line 17969 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"



    bitvec copy_propagated = {};
#line 820 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    Instruction(IR::MAU::Primitive const & p);
#line 17976 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 821 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    Instruction(cstring op, std::vector<const IR::Expression *> const & args);
#line 17979 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 823 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    Instruction(Util::SourceInfo si, cstring op, std::vector<const IR::Expression *> const & args);
#line 17982 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 825 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool isOutput(int operand_index) const override;
#line 17985 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 826 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    virtual const IR::Expression *getOutput() const;
#line 17988 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 827 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void validate() const override;
#line 17991 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::Instruction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::Instruction"_cs; }
    static cstring static_type_name() { return "MAU::Instruction"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Instruction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::Primitive const & a) const override;
    bool operator==(IR::Primitive const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Instruction(Util::SourceInfo srcInfo, const IR::Type* type, cstring name) :
    Primitive(srcInfo, type, name)
    { validate(); }
    Instruction(const IR::Type* type, cstring name) :
    Primitive(type, name)
    { validate(); }
    Instruction(Util::SourceInfo srcInfo, cstring name) :
    Primitive(srcInfo, name)
    { validate(); }
    Instruction(cstring name) :
    Primitive(name)
    { validate(); }
    IRNODE_SUBCLASS(Instruction)
    DECLARE_TYPEINFO_WITH_TYPEID(Instruction, NodeKind::MAU_Instruction, Primitive);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {

class SaluInstruction : public Instruction {
 public:
    int output_operand;




#line 839 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(cstring op);
#line 18034 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 840 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(cstring op, int out, std::vector<const IR::Expression *> const & args);
#line 18037 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 842 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(cstring op, int out, const IR::Vector<IR::Expression>* args);
#line 18040 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 844 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(Util::SourceInfo si, cstring op, int out, std::vector<const IR::Expression *> const & args);
#line 18043 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 846 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(Util::SourceInfo si, cstring op, int out, const IR::Vector<IR::Expression>* args);
#line 18046 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 848 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(cstring op, int out, const IR::Expression* a1);
#line 18049 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 850 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(cstring op, int out, const IR::Expression* a1, const IR::Expression* a2);
#line 18052 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 852 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluInstruction(cstring op, int out, const IR::Expression* a1, const IR::Expression* a2, const IR::Expression* a3);
#line 18055 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 855 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool isOutput(int operand_index) const override;
#line 18058 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 856 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    const IR::Expression *getOutput() const override;
#line 18061 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::SaluInstruction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::SaluInstruction"_cs; }
    static cstring static_type_name() { return "MAU::SaluInstruction"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SaluInstruction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::Instruction const & a) const override;
    bool operator==(IR::MAU::Primitive const & a) const override;
    bool operator==(IR::Primitive const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(SaluInstruction)
    DECLARE_TYPEINFO_WITH_TYPEID(SaluInstruction, NodeKind::MAU_SaluInstruction, Instruction);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// The IR::MAU::Action argument.
class ActionArg : public Expression, public virtual IAnnotated {
 public:
    cstring action_name;
    IR::ID name;
    IR::Vector<IR::Annotation> annotations;
#line 866 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 18091 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 867 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 18094 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 869 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18097 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 870 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring toString() const override;
#line 18100 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::ActionArg const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::ActionArg"_cs; }
    static cstring static_type_name() { return "MAU::ActionArg"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ActionArg(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ActionArg(Util::SourceInfo srcInfo, const IR::Type* type, cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Expression(srcInfo, type), action_name(action_name), name(name), annotations(annotations)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18119 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(const IR::Type* type, cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Expression(type), action_name(action_name), name(name), annotations(annotations)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18126 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(Util::SourceInfo srcInfo, cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    Expression(srcInfo), action_name(action_name), name(name), annotations(annotations)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18133 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    action_name(action_name), name(name), annotations(annotations)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18140 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(Util::SourceInfo srcInfo, const IR::Type* type, cstring action_name, IR::ID name) :
    Expression(srcInfo, type), action_name(action_name), name(name)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18147 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(const IR::Type* type, cstring action_name, IR::ID name) :
    Expression(type), action_name(action_name), name(name)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18154 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(Util::SourceInfo srcInfo, cstring action_name, IR::ID name) :
    Expression(srcInfo), action_name(action_name), name(name)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18161 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionArg(cstring action_name, IR::ID name) :
    action_name(action_name), name(name)
    {
#line 868 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ if (!srcInfo) srcInfo = name.srcInfo; }
#line 18168 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(ActionArg)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionArg, NodeKind::MAU_ActionArg, Expression, IAnnotated);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class ConditionalArg : public ActionArg {
 public:
    const IR::MAU::ActionArg* orig_arg = nullptr;
#line 875 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18182 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool one_on_true = true;
    bool operator==(IR::MAU::ConditionalArg const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::ConditionalArg"_cs; }
    static cstring static_type_name() { return "MAU::ConditionalArg"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ConditionalArg(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::ActionArg const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ConditionalArg(Util::SourceInfo srcInfo, const IR::Type* type, cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(srcInfo, type, action_name, name, annotations), orig_arg(orig_arg)
    { validate(); }
    ConditionalArg(const IR::Type* type, cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(type, action_name, name, annotations), orig_arg(orig_arg)
    { validate(); }
    ConditionalArg(Util::SourceInfo srcInfo, cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(srcInfo, action_name, name, annotations), orig_arg(orig_arg)
    { validate(); }
    ConditionalArg(cstring action_name, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(action_name, name, annotations), orig_arg(orig_arg)
    { validate(); }
    ConditionalArg(Util::SourceInfo srcInfo, const IR::Type* type, cstring action_name, IR::ID name, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(srcInfo, type, action_name, name), orig_arg(orig_arg)
    { validate(); }
    ConditionalArg(const IR::Type* type, cstring action_name, IR::ID name, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(type, action_name, name), orig_arg(orig_arg)
    { validate(); }
    ConditionalArg(Util::SourceInfo srcInfo, cstring action_name, IR::ID name, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(srcInfo, action_name, name), orig_arg(orig_arg)
    { validate(); }
    ConditionalArg(cstring action_name, IR::ID name, const IR::MAU::ActionArg* orig_arg) :
    ActionArg(action_name, name), orig_arg(orig_arg)
    { validate(); }
    IRNODE_SUBCLASS(ConditionalArg)
    DECLARE_TYPEINFO_WITH_TYPEID(ConditionalArg, NodeKind::MAU_ConditionalArg, ActionArg);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class StatefulCounter : public Expression {
 public:
    const IR::MAU::AttachedMemory* attached = nullptr;
#line 881 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18234 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::StatefulCounter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::StatefulCounter"_cs; }
    static cstring static_type_name() { return "MAU::StatefulCounter"_cs; }
    void toJSON(JSONGenerator & json) const override;
    StatefulCounter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    StatefulCounter(Util::SourceInfo srcInfo, const IR::Type* type, const IR::MAU::AttachedMemory* attached) :
    Expression(srcInfo, type), attached(attached)
    { validate(); }
    StatefulCounter(const IR::Type* type, const IR::MAU::AttachedMemory* attached) :
    Expression(type), attached(attached)
    { validate(); }
    StatefulCounter(Util::SourceInfo srcInfo, const IR::MAU::AttachedMemory* attached) :
    Expression(srcInfo), attached(attached)
    { validate(); }
    StatefulCounter(const IR::MAU::AttachedMemory* attached) :
    attached(attached)
    { validate(); }
    IRNODE_SUBCLASS(StatefulCounter)
    DECLARE_TYPEINFO_WITH_TYPEID(StatefulCounter, NodeKind::MAU_StatefulCounter, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class StatefulCall : public Node {
 public:


    const IR::MAU::Primitive* prim = nullptr;
    const IR::MAU::AttachedMemory* attached_callee = nullptr;
    const IR::Expression* index = nullptr;
    bool operator==(IR::MAU::StatefulCall const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::StatefulCall"_cs; }
    static cstring static_type_name() { return "MAU::StatefulCall"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    StatefulCall(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    StatefulCall(Util::SourceInfo srcInfo, const IR::MAU::Primitive* prim, const IR::MAU::AttachedMemory* attached_callee, const IR::Expression* index) :
    Node(srcInfo), prim(prim), attached_callee(attached_callee), index(index)
    { validate(); }
    StatefulCall(const IR::MAU::Primitive* prim, const IR::MAU::AttachedMemory* attached_callee, const IR::Expression* index) :
    prim(prim), attached_callee(attached_callee), index(index)
    { validate(); }
    StatefulCall(Util::SourceInfo srcInfo, const IR::MAU::AttachedMemory* attached_callee, const IR::Expression* index) :
    Node(srcInfo), attached_callee(attached_callee), index(index)
    { validate(); }
    StatefulCall(const IR::MAU::AttachedMemory* attached_callee, const IR::Expression* index) :
    attached_callee(attached_callee), index(index)
    { validate(); }
    StatefulCall(Util::SourceInfo srcInfo, const IR::MAU::Primitive* prim, const IR::MAU::AttachedMemory* attached_callee) :
    Node(srcInfo), prim(prim), attached_callee(attached_callee)
    { validate(); }
    StatefulCall(const IR::MAU::Primitive* prim, const IR::MAU::AttachedMemory* attached_callee) :
    prim(prim), attached_callee(attached_callee)
    { validate(); }
    StatefulCall(Util::SourceInfo srcInfo, const IR::MAU::AttachedMemory* attached_callee) :
    Node(srcInfo), attached_callee(attached_callee)
    { validate(); }
    StatefulCall(const IR::MAU::AttachedMemory* attached_callee) :
    attached_callee(attached_callee)
    { validate(); }
    IRNODE_SUBCLASS(StatefulCall)
    DECLARE_TYPEINFO_WITH_TYPEID(StatefulCall, NodeKind::MAU_StatefulCall, Node);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// The base class for MAU::Action and MAU::SaluAction, both represent a wide VLIW action.
class VLIWInstruction : public Node {
 public:
    bool operator==(IR::MAU::VLIWInstruction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::VLIWInstruction"_cs; }
    static cstring static_type_name() { return "MAU::VLIWInstruction"_cs; }
    void toJSON(JSONGenerator & json) const override;
    VLIWInstruction(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    VLIWInstruction(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    VLIWInstruction() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(VLIWInstruction)
    DECLARE_TYPEINFO_WITH_TYPEID(VLIWInstruction, NodeKind::MAU_VLIWInstruction, Node);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// The Action part of an action table -- basically a single VLIW instruction, which is a
/// set of instructions on different PHV containers that all run simultaneously
class Action : public VLIWInstruction, public virtual IAnnotated {
 public:
    IR::ID name;
    unsigned handle = 0;
    IR::Vector<IR::MAU::Primitive> action = {};
    safe_vector<const IR::MAU::ActionArg *> args = {};
    IR::Vector<IR::Annotation> annotations;
    bool init_default = false;
    bool hit_allowed = true;

    bool default_allowed = false;

    bool is_constant_action = false;




    bool hit_path_imp_only = false;
#line 914 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring hit_disallowed_reason = "none"_cs;
    cstring disallowed_reason = "none"_cs;
#line 18362 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IR::Vector<IR::Argument> default_params = {};
    bool exitAction = false;

    bool parallel = false;



    std::set<UniqueAttachedId> per_flow_enables = {};
    std::map<UniqueAttachedId, MeterType> meter_types = {};
    IR::Vector<IR::MAU::StatefulCall> stateful_calls = {};
#line 928 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::MAU::StatefulCall const * stateful_call(cstring name) const;
#line 18375 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 934 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring externalName() const;
#line 18378 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 935 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool hit_only() const;
#line 18381 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 936 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool miss_only() const;
#line 18384 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 938 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 18387 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 939 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 18390 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 941 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring toString() const override;
#line 18393 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 942 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void validate() const override;
#line 18396 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 947 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 18400 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Action)
    bool operator==(IR::MAU::Action const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::Action"_cs; }
    static cstring static_type_name() { return "MAU::Action"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Action(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::VLIWInstruction const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Action(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    VLIWInstruction(srcInfo), name(name), annotations(annotations)
    { validate(); }
    Action(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    Action(Util::SourceInfo srcInfo, IR::Vector<IR::Annotation> annotations) :
    VLIWInstruction(srcInfo), annotations(annotations)
    { validate(); }
    Action(IR::Vector<IR::Annotation> annotations) :
    annotations(annotations)
    { validate(); }
    Action(Util::SourceInfo srcInfo, IR::ID name) :
    VLIWInstruction(srcInfo), name(name)
    { validate(); }
    Action(IR::ID name) :
    name(name)
    { validate(); }
    Action(Util::SourceInfo srcInfo) :
    VLIWInstruction(srcInfo)
    { validate(); }
    Action() 
    { validate(); }
    IRNODE_SUBCLASS(Action)
    DECLARE_TYPEINFO_WITH_TYPEID(Action, NodeKind::MAU_Action, VLIWInstruction, IAnnotated);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// A stateful ALU VLIW instruction -- multiple instructions that all run together
/// "simultaneously" in different ALUs (certain ALUs are actually later in the pipeline)
/// in the stateful ALU block (there are 2 comparison, 4 "normal" and 1 output alus)
class SaluAction : public VLIWInstruction, public virtual IAnnotated {
 public:
    IR::ID name;
    int inst_code = -1;
    IR::Vector<IR::MAU::SaluInstruction> action = {};
    safe_vector<const IR::MAU::ActionArg *> args = {};
    IR::Vector<IR::Annotation> annotations;
#line 969 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 18455 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 970 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 18458 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::Expression* output_dst = nullptr;

    bool learn_action = false;











    const IR::Function* p4func = nullptr;




class ReturnEnumEncoding {
 public:
    const IR::Type_Enum* return_type = nullptr;
    std::map<cstring, unsigned> tag_used = {};

    unsigned cmp_used = 0;

#line 994 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool operator<=(IR::MAU::SaluAction::ReturnEnumEncoding const & a) const;
#line 18487 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

#line 995 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::MAU::SaluAction::ReturnEnumEncoding const * merge(IR::MAU::SaluAction::ReturnEnumEncoding const * a) const;
#line 18491 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::SaluAction::ReturnEnumEncoding const & a) const;
    void toJSON(JSONGenerator & json) const;
    ReturnEnumEncoding(JSONLoader & json);
    static IR::MAU::SaluAction::ReturnEnumEncoding * fromJSON(JSONLoader & json);
    ReturnEnumEncoding(const IR::Type_Enum* return_type) :
    return_type(return_type)
    {}
};
    ReturnEnumEncoding const * return_encoding = nullptr;
    unsigned return_predicate_words = 0;





    std::map<int, int> output_param_to_alu = {};
#line 1006 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 18511 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1013 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring toString() const override;
#line 18514 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::SaluAction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::SaluAction"_cs; }
    static cstring static_type_name() { return "MAU::SaluAction"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SaluAction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::VLIWInstruction const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SaluAction(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Function* p4func) :
    VLIWInstruction(srcInfo), name(name), annotations(annotations), p4func(p4func)
    { validate(); }
    SaluAction(IR::ID name, IR::Vector<IR::Annotation> annotations, const IR::Function* p4func) :
    name(name), annotations(annotations), p4func(p4func)
    { validate(); }
    SaluAction(Util::SourceInfo srcInfo, IR::ID name, const IR::Function* p4func) :
    VLIWInstruction(srcInfo), name(name), p4func(p4func)
    { validate(); }
    SaluAction(IR::ID name, const IR::Function* p4func) :
    name(name), p4func(p4func)
    { validate(); }
    SaluAction(Util::SourceInfo srcInfo, IR::ID name, IR::Vector<IR::Annotation> annotations) :
    VLIWInstruction(srcInfo), name(name), annotations(annotations)
    { validate(); }
    SaluAction(IR::ID name, IR::Vector<IR::Annotation> annotations) :
    name(name), annotations(annotations)
    { validate(); }
    SaluAction(Util::SourceInfo srcInfo, IR::ID name) :
    VLIWInstruction(srcInfo), name(name)
    { validate(); }
    SaluAction(IR::ID name) :
    name(name)
    { validate(); }
    IRNODE_SUBCLASS(SaluAction)
    DECLARE_TYPEINFO_WITH_TYPEID(SaluAction, NodeKind::MAU_SaluAction, VLIWInstruction, IAnnotated);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class FieldListExpression : public ListExpression {
 public:
    IR::ID id;
    bool rotateable = false;
    bool permutable = false;
    LTBitMatrix symmetric_keys = {};
#line 1026 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18566 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::FieldListExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::FieldListExpression"_cs; }
    static cstring static_type_name() { return "MAU::FieldListExpression"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    FieldListExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::ListExpression const & a) const override;
    bool operator==(IR::BaseListExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    FieldListExpression(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::Expression> components, IR::ID id) :
    ListExpression(srcInfo, type, components), id(id)
    { validate(); }
    FieldListExpression(const IR::Type* type, IR::Vector<IR::Expression> components, IR::ID id) :
    ListExpression(type, components), id(id)
    { validate(); }
    FieldListExpression(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> components, IR::ID id) :
    ListExpression(srcInfo, components), id(id)
    { validate(); }
    FieldListExpression(IR::Vector<IR::Expression> components, IR::ID id) :
    ListExpression(components), id(id)
    { validate(); }
    IRNODE_SUBCLASS(FieldListExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(FieldListExpression, NodeKind::MAU_FieldListExpression, ListExpression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/**
 * An expression that goes through the match ixbar and generates a hash function.  The eventual
 * goal is to extend this function to the entirety of any thing that goes through the hash
 * pathway in Tofino, i.e. Selectors, Inputs to Stateful ALU, and Table Keys, and obsolete
 * IXBarExpression and TableKey.  But that is future work.
 */
class HashGenExpression : public Expression {
 public:
    const IR::Expression* expr = nullptr;
    IR::ID id;
    bool dynamic = false;
    HashFunction algorithm;
    bool any_alg_allowed = false;
    const IR::NameList* alg_names = nullptr;

    int hash_output_width = 0;
#line 1045 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    HashGenExpression(Util::SourceInfo si, IR::Type const * type, const IR::Expression* e, HashFunction a);
#line 18616 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1047 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    HashGenExpression(const IR::Expression* e, HashFunction a = IR::MAU::HashFunction::identity());
#line 18619 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1050 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18622 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1052 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool equiv(IR::Node const & a_) const override;
#line 18625 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
 private:
/**
     * For static hashes, each hash call is a unique ID, in order potentially for later
     * comparisons and tracking.  With each statc HashGeneExpression created, the nextId
     * increases
     */
    static int nextId;
 public:
    bool operator==(IR::MAU::HashGenExpression const & a) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::HashGenExpression"_cs; }
    static cstring static_type_name() { return "MAU::HashGenExpression"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    HashGenExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HashGenExpression(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, IR::ID id, HashFunction algorithm) :
    Expression(srcInfo, type), expr(expr), id(id), algorithm(algorithm)
    { validate(); }
    HashGenExpression(const IR::Type* type, const IR::Expression* expr, IR::ID id, HashFunction algorithm) :
    Expression(type), expr(expr), id(id), algorithm(algorithm)
    { validate(); }
    HashGenExpression(Util::SourceInfo srcInfo, const IR::Expression* expr, IR::ID id, HashFunction algorithm) :
    Expression(srcInfo), expr(expr), id(id), algorithm(algorithm)
    { validate(); }
    HashGenExpression(const IR::Expression* expr, IR::ID id, HashFunction algorithm) :
    expr(expr), id(id), algorithm(algorithm)
    { validate(); }
    IRNODE_SUBCLASS(HashGenExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(HashGenExpression, NodeKind::MAU_HashGenExpression, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/** Hash Distribution Unit, used to bring PHV information directly into Match Central for
 *  action data lookup or action data itself.  Uses include addressing a table by a PHV field
 *  as well as a calculated hash to be used by PHV
 */
class HashDist : public Operation_Unary {
 public:

    safe_vector<int> units = {};
#line 1079 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool allocated() const;
#line 18675 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1080 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18678 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring getStringOp() const override { return cstring("hash_dist "); }
    bool operator==(IR::MAU::HashDist const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::HashDist"_cs; }
    static cstring static_type_name() { return "MAU::HashDist"_cs; }
    void toJSON(JSONGenerator & json) const override;
    HashDist(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HashDist(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(srcInfo, type, expr)
    { validate(); }
    HashDist(const IR::Type* type, const IR::Expression* expr) :
    Operation_Unary(type, expr)
    { validate(); }
    HashDist(Util::SourceInfo srcInfo, const IR::Expression* expr) :
    Operation_Unary(srcInfo, expr)
    { validate(); }
    HashDist(const IR::Expression* expr) :
    Operation_Unary(expr)
    { validate(); }
    IRNODE_SUBCLASS(HashDist)
    DECLARE_TYPEINFO_WITH_TYPEID(HashDist, NodeKind::MAU_HashDist, Operation_Unary);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/** Expression computed in the input xbar, generally in the GF matrix
 * These can be used in VLIW instructions, passed to the VLIW alus via the immediate path
 * and the Action Data bus, or in SaluAction instructions.  They are useful for 'breaking'
 * constraint violations on fields that are needed in two different sized MAU PHV groups, as
 * well as computing various things (concatenations, sign extension, bit twiddling) that
 * can't be easily done in an ALU.  They can also be used for things that could be in an ALU,
 * but doing so would require an extra stage of dependency.
 *
 * TODO: Hopefully will be obsoleted by the HashGenExpression
 */
class IXBarExpression : public Expression {
 public:
    const IR::Expression* expr = nullptr;
    int bit;

#line 1103 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IXBarExpression(const IR::Expression* e, int b = 0);
#line 18727 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1104 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18730 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::IXBarExpression const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::IXBarExpression"_cs; }
    static cstring static_type_name() { return "MAU::IXBarExpression"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    IXBarExpression(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(IXBarExpression)
    DECLARE_TYPEINFO_WITH_TYPEID(IXBarExpression, NodeKind::MAU_IXBarExpression, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class ActionDataConstant : public Expression {
 public:
    cstring name;
    const IR::Constant* constant = nullptr;
#line 1112 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18757 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::ActionDataConstant const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::ActionDataConstant"_cs; }
    static cstring static_type_name() { return "MAU::ActionDataConstant"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ActionDataConstant(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ActionDataConstant(Util::SourceInfo srcInfo, const IR::Type* type, cstring name, const IR::Constant* constant) :
    Expression(srcInfo, type), name(name), constant(constant)
    {
#line 1111 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = constant->type; }
#line 18776 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionDataConstant(const IR::Type* type, cstring name, const IR::Constant* constant) :
    Expression(type), name(name), constant(constant)
    {
#line 1111 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = constant->type; }
#line 18783 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionDataConstant(Util::SourceInfo srcInfo, cstring name, const IR::Constant* constant) :
    Expression(srcInfo), name(name), constant(constant)
    {
#line 1111 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = constant->type; }
#line 18790 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    ActionDataConstant(cstring name, const IR::Constant* constant) :
    name(name), constant(constant)
    {
#line 1111 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = constant->type; }
#line 18797 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(ActionDataConstant)
    DECLARE_TYPEINFO_WITH_TYPEID(ActionDataConstant, NodeKind::MAU_ActionDataConstant, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class RandomNumber : public Expression {
 public:
    cstring name;
/**
     * 2 units per stage, one per logical table, on a byte by byte basis
     */
    int rng_unit = -1;
#line 1121 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool allocated() const;
#line 18815 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1122 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18818 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::RandomNumber const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::RandomNumber"_cs; }
    static cstring static_type_name() { return "MAU::RandomNumber"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    RandomNumber(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    RandomNumber(Util::SourceInfo srcInfo, const IR::Type* type, cstring name) :
    Expression(srcInfo, type), name(name)
    { validate(); }
    RandomNumber(const IR::Type* type, cstring name) :
    Expression(type), name(name)
    { validate(); }
    RandomNumber(Util::SourceInfo srcInfo, cstring name) :
    Expression(srcInfo), name(name)
    { validate(); }
    RandomNumber(cstring name) :
    name(name)
    { validate(); }
    IRNODE_SUBCLASS(RandomNumber)
    DECLARE_TYPEINFO_WITH_TYPEID(RandomNumber, NodeKind::MAU_RandomNumber, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// A use of an attached table output; an operand of an instruction
class AttachedOutput : public Expression {
 public:
    const IR::MAU::AttachedMemory* attached = nullptr;
#line 1128 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18854 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::AttachedOutput const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::AttachedOutput"_cs; }
    static cstring static_type_name() { return "MAU::AttachedOutput"_cs; }
    void toJSON(JSONGenerator & json) const override;
    AttachedOutput(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    AttachedOutput(Util::SourceInfo srcInfo, const IR::Type* type, const IR::MAU::AttachedMemory* attached) :
    Expression(srcInfo, type), attached(attached)
    { validate(); }
    AttachedOutput(const IR::Type* type, const IR::MAU::AttachedMemory* attached) :
    Expression(type), attached(attached)
    { validate(); }
    AttachedOutput(Util::SourceInfo srcInfo, const IR::MAU::AttachedMemory* attached) :
    Expression(srcInfo), attached(attached)
    { validate(); }
    AttachedOutput(const IR::MAU::AttachedMemory* attached) :
    attached(attached)
    { validate(); }
    IRNODE_SUBCLASS(AttachedOutput)
    DECLARE_TYPEINFO_WITH_TYPEID(AttachedOutput, NodeKind::MAU_AttachedOutput, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/// reference to a fixed Stateful ALU resource -- these can only appear in SALU Instructions
class SaluReg : public Expression {
 public:
    cstring name;
    bool hi;

    const IR::Expression* phv_src = nullptr;
#line 1136 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18895 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1137 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    cstring toString() const override;
#line 18898 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::SaluReg const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "MAU::SaluReg"_cs; }
    static cstring static_type_name() { return "MAU::SaluReg"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SaluReg(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SaluReg(Util::SourceInfo srcInfo, const IR::Type* type, cstring name, bool hi) :
    Expression(srcInfo, type), name(name), hi(hi)
    { validate(); }
    SaluReg(const IR::Type* type, cstring name, bool hi) :
    Expression(type), name(name), hi(hi)
    { validate(); }
    SaluReg(Util::SourceInfo srcInfo, cstring name, bool hi) :
    Expression(srcInfo), name(name), hi(hi)
    { validate(); }
    SaluReg(cstring name, bool hi) :
    name(name), hi(hi)
    { validate(); }
    IRNODE_SUBCLASS(SaluReg)
    DECLARE_TYPEINFO_WITH_TYPEID(SaluReg, NodeKind::MAU_SaluReg, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class SaluCmpReg : public SaluReg {
 public:
    int index;
#line 1141 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    SaluCmpReg(cstring name, int idx);
#line 18935 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::SaluCmpReg const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::SaluCmpReg"_cs; }
    static cstring static_type_name() { return "MAU::SaluCmpReg"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SaluCmpReg(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::MAU::SaluReg const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SaluCmpReg(Util::SourceInfo srcInfo, const IR::Type* type, cstring name, bool hi, int index) :
    SaluReg(srcInfo, type, name, hi), index(index)
    { validate(); }
    SaluCmpReg(const IR::Type* type, cstring name, bool hi, int index) :
    SaluReg(type, name, hi), index(index)
    { validate(); }
    SaluCmpReg(Util::SourceInfo srcInfo, cstring name, bool hi, int index) :
    SaluReg(srcInfo, name, hi), index(index)
    { validate(); }
    SaluCmpReg(cstring name, bool hi, int index) :
    SaluReg(name, hi), index(index)
    { validate(); }
    IRNODE_SUBCLASS(SaluCmpReg)
    DECLARE_TYPEINFO_WITH_TYPEID(SaluCmpReg, NodeKind::MAU_SaluCmpReg, SaluReg);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class SaluFunction : public Operation_Unary {
 public:
    cstring name;
    cstring getStringOp() const override { return cstring("function"); }

#line 1148 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 18973 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::SaluFunction const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::SaluFunction"_cs; }
    static cstring static_type_name() { return "MAU::SaluFunction"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SaluFunction(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SaluFunction(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, cstring name) :
    Operation_Unary(srcInfo, type, expr), name(name)
    { validate(); }
    SaluFunction(const IR::Type* type, const IR::Expression* expr, cstring name) :
    Operation_Unary(type, expr), name(name)
    { validate(); }
    SaluFunction(Util::SourceInfo srcInfo, const IR::Expression* expr, cstring name) :
    Operation_Unary(srcInfo, expr), name(name)
    { validate(); }
    SaluFunction(const IR::Expression* expr, cstring name) :
    Operation_Unary(expr), name(name)
    { validate(); }
    IRNODE_SUBCLASS(SaluFunction)
    DECLARE_TYPEINFO_WITH_TYPEID(SaluFunction, NodeKind::MAU_SaluFunction, Operation_Unary);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/**
 * Represents constants configurable at run time from control plane
 * stored in the register file of a SALU. They are represented by
 * RegisterParam externs in P4 code.
 */
class SaluRegfileRow : public Expression {
 public:
    int index;

    int64_t initial_value;

    IR::ID name;

    cstring externalName;

#line 1161 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 19022 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::SaluRegfileRow const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::SaluRegfileRow"_cs; }
    static cstring static_type_name() { return "MAU::SaluRegfileRow"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SaluRegfileRow(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SaluRegfileRow(Util::SourceInfo srcInfo, const IR::Type* type, int index, int64_t initial_value, IR::ID name, cstring externalName) :
    Expression(srcInfo, type), index(index), initial_value(initial_value), name(name), externalName(externalName)
    { validate(); }
    SaluRegfileRow(const IR::Type* type, int index, int64_t initial_value, IR::ID name, cstring externalName) :
    Expression(type), index(index), initial_value(initial_value), name(name), externalName(externalName)
    { validate(); }
    SaluRegfileRow(Util::SourceInfo srcInfo, int index, int64_t initial_value, IR::ID name, cstring externalName) :
    Expression(srcInfo), index(index), initial_value(initial_value), name(name), externalName(externalName)
    { validate(); }
    SaluRegfileRow(int index, int64_t initial_value, IR::ID name, cstring externalName) :
    index(index), initial_value(initial_value), name(name), externalName(externalName)
    { validate(); }
    SaluRegfileRow(Util::SourceInfo srcInfo, const IR::Type* type, int index, int64_t initial_value, cstring externalName) :
    Expression(srcInfo, type), index(index), initial_value(initial_value), externalName(externalName)
    { validate(); }
    SaluRegfileRow(const IR::Type* type, int index, int64_t initial_value, cstring externalName) :
    Expression(type), index(index), initial_value(initial_value), externalName(externalName)
    { validate(); }
    SaluRegfileRow(Util::SourceInfo srcInfo, int index, int64_t initial_value, cstring externalName) :
    Expression(srcInfo), index(index), initial_value(initial_value), externalName(externalName)
    { validate(); }
    SaluRegfileRow(int index, int64_t initial_value, cstring externalName) :
    index(index), initial_value(initial_value), externalName(externalName)
    { validate(); }
    SaluRegfileRow(Util::SourceInfo srcInfo, const IR::Type* type, int index, int64_t initial_value, IR::ID name) :
    Expression(srcInfo, type), index(index), initial_value(initial_value), name(name)
    { validate(); }
    SaluRegfileRow(const IR::Type* type, int index, int64_t initial_value, IR::ID name) :
    Expression(type), index(index), initial_value(initial_value), name(name)
    { validate(); }
    SaluRegfileRow(Util::SourceInfo srcInfo, int index, int64_t initial_value, IR::ID name) :
    Expression(srcInfo), index(index), initial_value(initial_value), name(name)
    { validate(); }
    SaluRegfileRow(int index, int64_t initial_value, IR::ID name) :
    index(index), initial_value(initial_value), name(name)
    { validate(); }
    SaluRegfileRow(Util::SourceInfo srcInfo, const IR::Type* type, int index, int64_t initial_value) :
    Expression(srcInfo, type), index(index), initial_value(initial_value)
    { validate(); }
    SaluRegfileRow(const IR::Type* type, int index, int64_t initial_value) :
    Expression(type), index(index), initial_value(initial_value)
    { validate(); }
    SaluRegfileRow(Util::SourceInfo srcInfo, int index, int64_t initial_value) :
    Expression(srcInfo), index(index), initial_value(initial_value)
    { validate(); }
    SaluRegfileRow(int index, int64_t initial_value) :
    index(index), initial_value(initial_value)
    { validate(); }
    IRNODE_SUBCLASS(SaluRegfileRow)
    DECLARE_TYPEINFO_WITH_TYPEID(SaluRegfileRow, NodeKind::MAU_SaluRegfileRow, Expression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class MultiOperand : public ListExpression {
 public:
#line 1168 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 19092 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring name;
    bool is_phv;
#line 1171 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    MultiOperand(IR::ListExpression & le, cstring n, bool ip);
#line 19097 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::MultiOperand const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::MultiOperand"_cs; }
    static cstring static_type_name() { return "MAU::MultiOperand"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    MultiOperand(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::ListExpression const & a) const override;
    bool operator==(IR::BaseListExpression const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    MultiOperand(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::Expression> components, cstring name, bool is_phv) :
    ListExpression(srcInfo, type, components), name(name), is_phv(is_phv)
    { validate(); }
    MultiOperand(const IR::Type* type, IR::Vector<IR::Expression> components, cstring name, bool is_phv) :
    ListExpression(type, components), name(name), is_phv(is_phv)
    { validate(); }
    MultiOperand(Util::SourceInfo srcInfo, IR::Vector<IR::Expression> components, cstring name, bool is_phv) :
    ListExpression(srcInfo, components), name(name), is_phv(is_phv)
    { validate(); }
    MultiOperand(IR::Vector<IR::Expression> components, cstring name, bool is_phv) :
    ListExpression(components), name(name), is_phv(is_phv)
    { validate(); }
    IRNODE_SUBCLASS(MultiOperand)
    DECLARE_TYPEINFO_WITH_TYPEID(MultiOperand, NodeKind::MAU_MultiOperand, ListExpression);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
class WrappedSlice : public Operation_Ternary {
 public:
    int getPrecedence() const override { return DBPrint::Prec_Postfix; }
    cstring getStringOp() const override { return cstring("[:]"); }
#line 1178 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void validate() const override;
#line 19135 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1188 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    WrappedSlice(const IR::Expression* a, int hi, int lo, int wrap_size);
#line 19138 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1191 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int getL() const;
#line 19141 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1192 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 19144 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::WrappedSlice const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "MAU::WrappedSlice"_cs; }
    static cstring static_type_name() { return "MAU::WrappedSlice"_cs; }
    void toJSON(JSONGenerator & json) const override;
    WrappedSlice(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Ternary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    WrappedSlice(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(srcInfo, type, e0, e1, e2)
    { validate(); }
    WrappedSlice(const IR::Type* type, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(type, e0, e1, e2)
    { validate(); }
    WrappedSlice(Util::SourceInfo srcInfo, const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(srcInfo, e0, e1, e2)
    { validate(); }
    WrappedSlice(const IR::Expression* e0, const IR::Expression* e1, const IR::Expression* e2) :
    Operation_Ternary(e0, e1, e2)
    { validate(); }
    IRNODE_SUBCLASS(WrappedSlice)
    DECLARE_TYPEINFO_WITH_TYPEID(WrappedSlice, NodeKind::MAU_WrappedSlice, Operation_Ternary);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {
namespace MAU {
/**
 * TODO: Obsoleted by the HashGenExpression eventually
 */
class TableKey : public Expression, public virtual IAnnotated {
 public:
    const IR::Expression* expr = nullptr;
    IR::ID match_type;
    int p4_param_order = -1;
    bool from_mask = false;
    bool partition_index = false;
    bool used_in_alpm = false;

    int ixbar_group_num = -1;
#line 1209 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_selection() const;
#line 19190 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1210 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_dleft() const;
#line 19193 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1211 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_atcam_partition_index() const;
#line 19196 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1212 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_alpm_partition_index() const;
#line 19199 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1214 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_range() const;
#line 19202 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1215 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    bool for_match() const;
#line 19205 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1216 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    int get_ixbar_group_num() const;
#line 19208 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1218 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    void dbprint(std::ostream & out) const override;
#line 19211 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IR::Vector<IR::Annotation> annotations;
#line 1221 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> const & getAnnotations() const override;
#line 19215 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 1222 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
    IR::Vector<IR::Annotation> & getAnnotations() override;
#line 19218 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::MAU::TableKey const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "MAU::TableKey"_cs; }
    static cstring static_type_name() { return "MAU::TableKey"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    TableKey(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TableKey(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, IR::ID match_type, IR::Vector<IR::Annotation> annotations) :
    Expression(srcInfo, type), expr(expr), match_type(match_type), annotations(annotations)
    { validate(); }
    TableKey(const IR::Type* type, const IR::Expression* expr, IR::ID match_type, IR::Vector<IR::Annotation> annotations) :
    Expression(type), expr(expr), match_type(match_type), annotations(annotations)
    { validate(); }
    TableKey(Util::SourceInfo srcInfo, const IR::Expression* expr, IR::ID match_type, IR::Vector<IR::Annotation> annotations) :
    Expression(srcInfo), expr(expr), match_type(match_type), annotations(annotations)
    { validate(); }
    TableKey(const IR::Expression* expr, IR::ID match_type, IR::Vector<IR::Annotation> annotations) :
    expr(expr), match_type(match_type), annotations(annotations)
    { validate(); }
    TableKey(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, IR::ID match_type) :
    Expression(srcInfo, type), expr(expr), match_type(match_type)
    { validate(); }
    TableKey(const IR::Type* type, const IR::Expression* expr, IR::ID match_type) :
    Expression(type), expr(expr), match_type(match_type)
    { validate(); }
    TableKey(Util::SourceInfo srcInfo, const IR::Expression* expr, IR::ID match_type) :
    Expression(srcInfo), expr(expr), match_type(match_type)
    { validate(); }
    TableKey(const IR::Expression* expr, IR::ID match_type) :
    expr(expr), match_type(match_type)
    { validate(); }
    IRNODE_SUBCLASS(TableKey)
    DECLARE_TYPEINFO_WITH_TYPEID(TableKey, NodeKind::MAU_TableKey, Expression, IAnnotated);
};
}  // namespace MAU
}  // namespace P4::IR
namespace P4::IR {

class RangeMatch : public Operation_Unary {
 public:


    unsigned data;
    int getPrecedence() const override { return DBPrint::Prec_Equ; }
    cstring getStringOp() const override { return cstring(" in "); }
    bool operator==(IR::RangeMatch const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "RangeMatch"_cs; }
    static cstring static_type_name() { return "RangeMatch"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    RangeMatch(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Operation_Unary const & a) const override;
    bool operator==(IR::Operation const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    RangeMatch(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* expr, unsigned data) :
    Operation_Unary(srcInfo, type, expr), data(data)
    {
#line 1231 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = Type::Boolean::get(); }
#line 19288 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    RangeMatch(const IR::Type* type, const IR::Expression* expr, unsigned data) :
    Operation_Unary(type, expr), data(data)
    {
#line 1231 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = Type::Boolean::get(); }
#line 19295 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    RangeMatch(Util::SourceInfo srcInfo, const IR::Expression* expr, unsigned data) :
    Operation_Unary(srcInfo, expr), data(data)
    {
#line 1231 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = Type::Boolean::get(); }
#line 19302 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    RangeMatch(const IR::Expression* expr, unsigned data) :
    Operation_Unary(expr), data(data)
    {
#line 1231 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
{ type = Type::Boolean::get(); }
#line 19309 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
     validate(); }
    IRNODE_SUBCLASS(RangeMatch)
    DECLARE_TYPEINFO_WITH_TYPEID(RangeMatch, NodeKind::RangeMatch, Operation_Unary);
};
}  // namespace P4::IR
#line 1237 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/mau.def"
// defined down here to resolve order of declaration issues
template<class T> inline const T *IR::MAU::Table::get_attached() const {
    for (auto *at : attached)
        if (auto rv = at->attached->to<T>())
            return rv;
    return nullptr; }
#line 19322 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/**
 * Copyright (C) 2024 Intel Corporation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * 
 * SPDX-License-Identifier: Apache-2.0
 */
/* -*-C++-*- */
#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
#include "lib/match.h"
#include <optional>
#include "backends/tofino/bf-p4c/common/debug_info.h"
#include "backends/tofino/bf-p4c/ir/bitrange.h"
#include "backends/tofino/bf-p4c/parde/marshal.h"
#include "backends/tofino/bf-p4c/parde/match_register.h"
#line 19348 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
namespace BFN {
class UnresolvedHeaderStackIndex : public Expression {
 public:
    IR::ID index;
#line 36 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void validate() const override;
#line 19356 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 41 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19359 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::UnresolvedHeaderStackIndex const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::UnresolvedHeaderStackIndex"_cs; }
    static cstring static_type_name() { return "BFN::UnresolvedHeaderStackIndex"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    UnresolvedHeaderStackIndex(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    UnresolvedHeaderStackIndex(Util::SourceInfo srcInfo, const IR::Type* type, IR::ID index) :
    Expression(srcInfo, type), index(index)
    { validate(); }
    UnresolvedHeaderStackIndex(const IR::Type* type, IR::ID index) :
    Expression(type), index(index)
    { validate(); }
    UnresolvedHeaderStackIndex(Util::SourceInfo srcInfo, IR::ID index) :
    Expression(srcInfo), index(index)
    { validate(); }
    UnresolvedHeaderStackIndex(IR::ID index) :
    index(index)
    { validate(); }
    IRNODE_SUBCLASS(UnresolvedHeaderStackIndex)
    DECLARE_TYPEINFO_WITH_TYPEID(UnresolvedHeaderStackIndex, NodeKind::BFN_UnresolvedHeaderStackIndex, Expression);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A value that can *conceptually* be read from in the parser. This is a
/// superset of the values that can actually be read from on the hardware.
class ParserRVal : public Expression {
 public:
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserRVal"_cs; }
    static cstring static_type_name() { return "BFN::ParserRVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserRVal(JSONLoader & json);
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserRVal(Util::SourceInfo srcInfo, const IR::Type* type) :
    Expression(srcInfo, type)
    { validate(); }
    ParserRVal(const IR::Type* type) :
    Expression(type)
    { validate(); }
    ParserRVal(Util::SourceInfo srcInfo) :
    Expression(srcInfo)
    { validate(); }
    ParserRVal() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserRVal, NodeKind::BFN_ParserRVal, Expression);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An r-value that represents a read from a range of bits in the input buffer.
/// The coordinate system used will depend on the specific type of
/// `InputBufferRVal`.
class InputBufferRVal : public ParserRVal {
 public:
/// @return this buffer range as a half-open range of bits in network order.
#line 53 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    nw_bitinterval interval() const;
#line 19428 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The region represented by this `InputBufferRVal`, expressed as a range of
/// bits in network order.
    nw_bitrange range;
    bool operator==(IR::BFN::InputBufferRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::InputBufferRVal"_cs; }
    static cstring static_type_name() { return "BFN::InputBufferRVal"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    InputBufferRVal(JSONLoader & json);
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    InputBufferRVal(Util::SourceInfo srcInfo, const IR::Type* type, nw_bitrange range) :
    ParserRVal(srcInfo, type), range(range)
    { validate(); }
    InputBufferRVal(const IR::Type* type, nw_bitrange range) :
    ParserRVal(type), range(range)
    { validate(); }
    InputBufferRVal(Util::SourceInfo srcInfo, nw_bitrange range) :
    ParserRVal(srcInfo), range(range)
    { validate(); }
    InputBufferRVal(nw_bitrange range) :
    range(range)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(InputBufferRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(InputBufferRVal, NodeKind::BFN_InputBufferRVal, ParserRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// location in the packet data section of the input buffer
class PacketRVal : public InputBufferRVal {
 public:
/// Enables and disables the partial_hdr_err_proc bit in the parser
/// transition.  Controls the extraction behavior when packets
/// with incomplete headers are received (i.e. greedy extract).
    bool partial_hdr_err_proc;
#line 68 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19471 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::PacketRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::PacketRVal"_cs; }
    static cstring static_type_name() { return "BFN::PacketRVal"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    PacketRVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::InputBufferRVal const & a) const override;
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    PacketRVal(Util::SourceInfo srcInfo, const IR::Type* type, nw_bitrange range, bool partial_hdr_err_proc) :
    InputBufferRVal(srcInfo, type, range), partial_hdr_err_proc(partial_hdr_err_proc)
    { validate(); }
    PacketRVal(const IR::Type* type, nw_bitrange range, bool partial_hdr_err_proc) :
    InputBufferRVal(type, range), partial_hdr_err_proc(partial_hdr_err_proc)
    { validate(); }
    PacketRVal(Util::SourceInfo srcInfo, nw_bitrange range, bool partial_hdr_err_proc) :
    InputBufferRVal(srcInfo, range), partial_hdr_err_proc(partial_hdr_err_proc)
    { validate(); }
    PacketRVal(nw_bitrange range, bool partial_hdr_err_proc) :
    InputBufferRVal(range), partial_hdr_err_proc(partial_hdr_err_proc)
    { validate(); }
    IRNODE_SUBCLASS(PacketRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(PacketRVal, NodeKind::BFN_PacketRVal, InputBufferRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// location in the metadata secion of the input buffer
class MetadataRVal : public InputBufferRVal {
 public:
#line 75 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19508 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::MetadataRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::MetadataRVal"_cs; }
    static cstring static_type_name() { return "BFN::MetadataRVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    MetadataRVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::InputBufferRVal const & a) const override;
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    MetadataRVal(Util::SourceInfo srcInfo, const IR::Type* type, nw_bitrange range) :
    InputBufferRVal(srcInfo, type, range)
    { validate(); }
    MetadataRVal(const IR::Type* type, nw_bitrange range) :
    InputBufferRVal(type, range)
    { validate(); }
    MetadataRVal(Util::SourceInfo srcInfo, nw_bitrange range) :
    InputBufferRVal(srcInfo, range)
    { validate(); }
    MetadataRVal(nw_bitrange range) :
    InputBufferRVal(range)
    { validate(); }
    IRNODE_SUBCLASS(MetadataRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(MetadataRVal, NodeKind::BFN_MetadataRVal, InputBufferRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A constant used as an r-value in the parser.
class ConstantRVal : public ParserRVal {
 public:
#line 82 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    ConstantRVal(big_int value);
#line 19544 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 83 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    ConstantRVal(int value);
#line 19547 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 84 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    ConstantRVal(IR::Type const * type, big_int value);
#line 19550 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 86 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    ConstantRVal(Util::SourceInfo si, IR::Type const * type, big_int value);
#line 19553 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 89 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19556 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::Constant* constant = nullptr;
    bool operator==(IR::BFN::ConstantRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ConstantRVal"_cs; }
    static cstring static_type_name() { return "BFN::ConstantRVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ConstantRVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ConstantRVal(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Constant* constant) :
    ParserRVal(srcInfo, type), constant(constant)
    { validate(); }
    ConstantRVal(const IR::Type* type, const IR::Constant* constant) :
    ParserRVal(type), constant(constant)
    { validate(); }
    ConstantRVal(Util::SourceInfo srcInfo, const IR::Constant* constant) :
    ParserRVal(srcInfo), constant(constant)
    { validate(); }
    ConstantRVal(const IR::Constant* constant) :
    constant(constant)
    { validate(); }
    IRNODE_SUBCLASS(ConstantRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(ConstantRVal, NodeKind::BFN_ConstantRVal, ParserRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An r-value which is saved from input buffer to the match register.
class SavedRVal : public ParserRVal {
 public:
#line 96 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19595 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// An expression which should evaluate to an r-value usable in the parser.
    const IR::Expression* source = nullptr;
/// The registers to match on.
    std::vector<std::pair<MatchRegister, nw_bitrange>> reg_slices;
    bool operator==(IR::BFN::SavedRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::SavedRVal"_cs; }
    static cstring static_type_name() { return "BFN::SavedRVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    SavedRVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SavedRVal(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* source, std::vector<std::pair<MatchRegister, nw_bitrange>> reg_slices) :
    ParserRVal(srcInfo, type), source(source), reg_slices(reg_slices)
    { validate(); }
    SavedRVal(const IR::Type* type, const IR::Expression* source, std::vector<std::pair<MatchRegister, nw_bitrange>> reg_slices) :
    ParserRVal(type), source(source), reg_slices(reg_slices)
    { validate(); }
    SavedRVal(Util::SourceInfo srcInfo, const IR::Expression* source, std::vector<std::pair<MatchRegister, nw_bitrange>> reg_slices) :
    ParserRVal(srcInfo), source(source), reg_slices(reg_slices)
    { validate(); }
    SavedRVal(const IR::Expression* source, std::vector<std::pair<MatchRegister, nw_bitrange>> reg_slices) :
    source(source), reg_slices(reg_slices)
    { validate(); }
    SavedRVal(Util::SourceInfo srcInfo, const IR::Type* type, const IR::Expression* source) :
    ParserRVal(srcInfo, type), source(source)
    { validate(); }
    SavedRVal(const IR::Type* type, const IR::Expression* source) :
    ParserRVal(type), source(source)
    { validate(); }
    SavedRVal(Util::SourceInfo srcInfo, const IR::Expression* source) :
    ParserRVal(srcInfo), source(source)
    { validate(); }
    SavedRVal(const IR::Expression* source) :
    source(source)
    { validate(); }
    IRNODE_SUBCLASS(SavedRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(SavedRVal, NodeKind::BFN_SavedRVal, ParserRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Common base class for parser write destination
class ParserLVal : public Node {
 public:
#line 116 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 19649 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 118 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    int size() const;
#line 19652 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 120 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void validate() const override;
#line 19655 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::Expression* field = nullptr;
    bool operator==(IR::BFN::ParserLVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::ParserLVal"_cs; }
    static cstring static_type_name() { return "BFN::ParserLVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserLVal(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserLVal(Util::SourceInfo srcInfo, const IR::Expression* field) :
    Node(srcInfo), field(field)
    { validate(); }
    ParserLVal(const IR::Expression* field) :
    field(field)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserLVal)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserLVal, NodeKind::BFN_ParserLVal, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Parser write dest that will ultimately be backed by a PHV container.
class FieldLVal : public ParserLVal {
 public:
#line 133 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19685 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::FieldLVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::FieldLVal"_cs; }
    static cstring static_type_name() { return "BFN::FieldLVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    FieldLVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserLVal const & a) const override;
    bool operator==(IR::Node const & a) const override;
    FieldLVal(Util::SourceInfo srcInfo, const IR::Expression* field) :
    ParserLVal(srcInfo, field)
    { validate(); }
    FieldLVal(const IR::Expression* field) :
    ParserLVal(field)
    { validate(); }
    IRNODE_SUBCLASS(FieldLVal)
    DECLARE_TYPEINFO_WITH_TYPEID(FieldLVal, NodeKind::BFN_FieldLVal, ParserLVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class MatchLVal : public ParserLVal {
 public:
#line 137 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19712 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::MatchLVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::MatchLVal"_cs; }
    static cstring static_type_name() { return "BFN::MatchLVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    MatchLVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserLVal const & a) const override;
    bool operator==(IR::Node const & a) const override;
    MatchLVal(Util::SourceInfo srcInfo, const IR::Expression* field) :
    ParserLVal(srcInfo, field)
    { validate(); }
    MatchLVal(const IR::Expression* field) :
    ParserLVal(field)
    { validate(); }
    IRNODE_SUBCLASS(MatchLVal)
    DECLARE_TYPEINFO_WITH_TYPEID(MatchLVal, NodeKind::BFN_MatchLVal, ParserLVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Parser write dest that will be backed by non-PHV container.
class ChecksumLVal : public FieldLVal {
 public:
#line 142 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19740 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ChecksumLVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ChecksumLVal"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumLVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ChecksumLVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::FieldLVal const & a) const override;
    bool operator==(IR::BFN::ParserLVal const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ChecksumLVal(Util::SourceInfo srcInfo, const IR::Expression* field) :
    FieldLVal(srcInfo, field)
    { validate(); }
    ChecksumLVal(const IR::Expression* field) :
    FieldLVal(field)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumLVal)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumLVal, NodeKind::BFN_ChecksumLVal, FieldLVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {

class TotalContainerSize : public ParserRVal {
 public:
#line 148 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19769 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 149 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 19772 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IR::Vector<IR::BFN::FieldLVal> fields;
    bool operator==(IR::BFN::TotalContainerSize const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::TotalContainerSize"_cs; }
    static cstring static_type_name() { return "BFN::TotalContainerSize"_cs; }
    void toJSON(JSONGenerator & json) const override;
    TotalContainerSize(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    TotalContainerSize(Util::SourceInfo srcInfo, const IR::Type* type, IR::Vector<IR::BFN::FieldLVal> fields) :
    ParserRVal(srcInfo, type), fields(fields)
    { validate(); }
    TotalContainerSize(const IR::Type* type, IR::Vector<IR::BFN::FieldLVal> fields) :
    ParserRVal(type), fields(fields)
    { validate(); }
    TotalContainerSize(Util::SourceInfo srcInfo, IR::Vector<IR::BFN::FieldLVal> fields) :
    ParserRVal(srcInfo), fields(fields)
    { validate(); }
    TotalContainerSize(IR::Vector<IR::BFN::FieldLVal> fields) :
    fields(fields)
    { validate(); }
    IRNODE_SUBCLASS(TotalContainerSize)
    DECLARE_TYPEINFO_WITH_TYPEID(TotalContainerSize, NodeKind::BFN_TotalContainerSize, ParserRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Supertype for all parser primitives - i.e., actions that can be executed in
/// parser states.
class ParserPrimitive : public Node {
 public:
#line 158 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    /// Get destination out of a parser write primitive -- either Emit, or
    /// ParserChecksumWritePrimitive. Fails if input is not a write primitive.
    virtual const ParserLVal* getWriteDest() const {
        BUG("%1%: Write is neither extract nor checksum write", this);
    }

    /// Get parser write mode out of a parser write primitive -- either Emit, or
    /// ParserChecksumWritePrimitive. Fails if input is not a write primitive.
    virtual ParserWriteMode getWriteMode() const {
        BUG("%1%: Write is neither extract nor checksum write", this);
    }
#line 19822 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserPrimitive"_cs; }
    static cstring static_type_name() { return "BFN::ParserPrimitive"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserPrimitive(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserPrimitive(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    ParserPrimitive() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserPrimitive)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserPrimitive, NodeKind::BFN_ParserPrimitive, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A parser extraction operation, representing a write by the parser into some
/// l-value.
class Extract : public ParserPrimitive {
 public:
#line 175 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Extract(const IR::Expression* dest, const IR::BFN::ParserRVal* source);
#line 19849 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Extract(Util::SourceInfo si, const IR::Expression* dest, const IR::BFN::ParserRVal* source);
#line 19852 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 180 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19855 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 184 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    const IR::BFN::ParserLVal *getWriteDest() const override;
#line 19858 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 185 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    IR::BFN::ParserWriteMode getWriteMode() const override;
#line 19861 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The location to be written to.
    const IR::BFN::ParserLVal* dest = nullptr;
/// The location that will be read from.
    const IR::BFN::ParserRVal* source = nullptr;
    ParserWriteMode write_mode = ParserWriteMode::SINGLE_WRITE;
/// The original state this extract originated from (before parser state splitting).
    IR::BFN::ParserState const * original_state = nullptr;
/// This extract expects that data on the wire is marshaled from a `field`.
    std::optional<MarshaledFrom> marshaled_from;

#line 201 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dump_fields(std::ostream & out) const override;
#line 19874 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::Extract const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Extract"_cs; }
    static cstring static_type_name() { return "BFN::Extract"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Extract(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Extract(Util::SourceInfo srcInfo, const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source, std::optional<MarshaledFrom> marshaled_from) :
    ParserPrimitive(srcInfo), dest(dest), source(source), marshaled_from(marshaled_from)
    { validate(); }
    Extract(const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source, std::optional<MarshaledFrom> marshaled_from) :
    dest(dest), source(source), marshaled_from(marshaled_from)
    { validate(); }
    Extract(Util::SourceInfo srcInfo, const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source) :
    ParserPrimitive(srcInfo), dest(dest), source(source)
    { validate(); }
    Extract(const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source) :
    dest(dest), source(source)
    { validate(); }
    IRNODE_SUBCLASS(Extract)
    DECLARE_TYPEINFO_WITH_TYPEID(Extract, NodeKind::BFN_Extract, ParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An Extract node that is destined to become a LoweredExtractPhv. This is a
/// short-lived type, used internally by the parser IR lowering passes.
/// Instances are introduced during state splitting, and are eliminated once
/// the parser IR is lowered.
class ExtractPhv : public Extract {
 public:
#line 212 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19914 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ExtractPhv const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ExtractPhv"_cs; }
    static cstring static_type_name() { return "BFN::ExtractPhv"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ExtractPhv(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Extract const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ExtractPhv(Util::SourceInfo srcInfo, const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source, std::optional<MarshaledFrom> marshaled_from) :
    Extract(srcInfo, dest, source, marshaled_from)
    { validate(); }
    ExtractPhv(const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source, std::optional<MarshaledFrom> marshaled_from) :
    Extract(dest, source, marshaled_from)
    { validate(); }
    ExtractPhv(Util::SourceInfo srcInfo, const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source) :
    Extract(srcInfo, dest, source)
    { validate(); }
    ExtractPhv(const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source) :
    Extract(dest, source)
    { validate(); }
    IRNODE_SUBCLASS(ExtractPhv)
    DECLARE_TYPEINFO_WITH_TYPEID(ExtractPhv, NodeKind::BFN_ExtractPhv, Extract);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An Extract node that is destined to become a LoweredExtractClot. This is a
/// short-lived type, used internally by the parser IR lowering passes.
/// Instances are introduced during state splitting, and are eliminated once
/// the parser IR is lowered.
class ExtractClot : public Extract {
 public:
#line 220 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19952 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 225 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void validate() const override;
#line 19955 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ExtractClot const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ExtractClot"_cs; }
    static cstring static_type_name() { return "BFN::ExtractClot"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ExtractClot(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Extract const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ExtractClot(Util::SourceInfo srcInfo, const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source, std::optional<MarshaledFrom> marshaled_from) :
    Extract(srcInfo, dest, source, marshaled_from)
    { validate(); }
    ExtractClot(const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source, std::optional<MarshaledFrom> marshaled_from) :
    Extract(dest, source, marshaled_from)
    { validate(); }
    ExtractClot(Util::SourceInfo srcInfo, const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source) :
    Extract(srcInfo, dest, source)
    { validate(); }
    ExtractClot(const IR::BFN::ParserLVal* dest, const IR::BFN::ParserRVal* source) :
    Extract(dest, source)
    { validate(); }
    IRNODE_SUBCLASS(ExtractClot)
    DECLARE_TYPEINFO_WITH_TYPEID(ExtractClot, NodeKind::BFN_ExtractClot, Extract);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Save data from input buffer to a match register.
class SaveToRegister : public ParserPrimitive {
 public:
#line 235 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    SaveToRegister(const MatchRegister& reg, nw_byterange source)
      : source(new PacketRVal(source.toUnit<RangeUnit::Bit>(), false)), dest(reg) { }
#line 19991 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 238 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 19994 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The location that will be read from.
    const IR::BFN::InputBufferRVal* source = nullptr;
/// The register this save writes to.
    MatchRegister dest;
    bool operator==(IR::BFN::SaveToRegister const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::SaveToRegister"_cs; }
    static cstring static_type_name() { return "BFN::SaveToRegister"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    SaveToRegister(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    SaveToRegister(Util::SourceInfo srcInfo, const IR::BFN::InputBufferRVal* source, MatchRegister dest) :
    ParserPrimitive(srcInfo), source(source), dest(dest)
    { validate(); }
    SaveToRegister(const IR::BFN::InputBufferRVal* source, MatchRegister dest) :
    source(source), dest(dest)
    { validate(); }
    IRNODE_SUBCLASS(SaveToRegister)
    DECLARE_TYPEINFO_WITH_TYPEID(SaveToRegister, NodeKind::BFN_SaveToRegister, ParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterPrimitive : public ParserPrimitive {
 public:
    cstring declName;
    bool operator==(IR::BFN::ParserCounterPrimitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterPrimitive"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterPrimitive"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserCounterPrimitive(JSONLoader & json);
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserCounterPrimitive(Util::SourceInfo srcInfo, cstring declName) :
    ParserPrimitive(srcInfo), declName(declName)
    { validate(); }
    ParserCounterPrimitive(cstring declName) :
    declName(declName)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserCounterPrimitive)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterPrimitive, NodeKind::BFN_ParserCounterPrimitive, ParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserZeroInit : public ParserPrimitive {
 public:
    const IR::BFN::ParserLVal* field = nullptr;
#line 253 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20056 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ParserZeroInit const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ParserZeroInit"_cs; }
    static cstring static_type_name() { return "BFN::ParserZeroInit"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserZeroInit(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserZeroInit(Util::SourceInfo srcInfo, const IR::BFN::ParserLVal* field) :
    ParserPrimitive(srcInfo), field(field)
    { validate(); }
    ParserZeroInit(const IR::BFN::ParserLVal* field) :
    field(field)
    { validate(); }
    IRNODE_SUBCLASS(ParserZeroInit)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserZeroInit, NodeKind::BFN_ParserZeroInit, ParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterLoadImm : public ParserCounterPrimitive {
 public:
#line 257 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20086 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    int imm = 0;
    bool push = false;
    bool update_with_top = false;
    bool operator==(IR::BFN::ParserCounterLoadImm const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterLoadImm"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterLoadImm"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserCounterLoadImm(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserCounterPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserCounterLoadImm(Util::SourceInfo srcInfo, cstring declName) :
    ParserCounterPrimitive(srcInfo, declName)
    { validate(); }
    ParserCounterLoadImm(cstring declName) :
    ParserCounterPrimitive(declName)
    { validate(); }
    IRNODE_SUBCLASS(ParserCounterLoadImm)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterLoadImm, NodeKind::BFN_ParserCounterLoadImm, ParserCounterPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterLoadPkt : public ParserCounterPrimitive {
 public:
#line 266 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    ParserCounterLoadPkt(cstring n, IR::BFN::SavedRVal const * s);
#line 20118 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 269 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20121 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::SavedRVal* source = nullptr;
    std::optional<int> max;
    std::optional<int> rotate;
    std::optional<int> mask;
    std::optional<int> add;
    bool push = false;
    bool update_with_top = false;
    bool operator==(IR::BFN::ParserCounterLoadPkt const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ParserCounterLoadPkt"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterLoadPkt"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserCounterLoadPkt(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserCounterPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(ParserCounterLoadPkt)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterLoadPkt, NodeKind::BFN_ParserCounterLoadPkt, ParserCounterPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterIncrement : public ParserCounterPrimitive {
 public:
#line 283 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20154 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    int value = 0;
    bool operator==(IR::BFN::ParserCounterIncrement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterIncrement"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterIncrement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserCounterIncrement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserCounterPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserCounterIncrement(Util::SourceInfo srcInfo, cstring declName) :
    ParserCounterPrimitive(srcInfo, declName)
    { validate(); }
    ParserCounterIncrement(cstring declName) :
    ParserCounterPrimitive(declName)
    { validate(); }
    IRNODE_SUBCLASS(ParserCounterIncrement)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterIncrement, NodeKind::BFN_ParserCounterIncrement, ParserCounterPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterDecrement : public ParserCounterPrimitive {
 public:
#line 288 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20184 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    int value = 0;
    bool operator==(IR::BFN::ParserCounterDecrement const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterDecrement"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterDecrement"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserCounterDecrement(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserCounterPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserCounterDecrement(Util::SourceInfo srcInfo, cstring declName) :
    ParserCounterPrimitive(srcInfo, declName)
    { validate(); }
    ParserCounterDecrement(cstring declName) :
    ParserCounterPrimitive(declName)
    { validate(); }
    IRNODE_SUBCLASS(ParserCounterDecrement)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterDecrement, NodeKind::BFN_ParserCounterDecrement, ParserCounterPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterPop : public ParserCounterPrimitive {
 public:
#line 293 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20214 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ParserCounterPop const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterPop"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterPop"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserCounterPop(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserCounterPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserCounterPop(Util::SourceInfo srcInfo, cstring declName) :
    ParserCounterPrimitive(srcInfo, declName)
    { validate(); }
    ParserCounterPop(cstring declName) :
    ParserCounterPrimitive(declName)
    { validate(); }
    IRNODE_SUBCLASS(ParserCounterPop)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterPop, NodeKind::BFN_ParserCounterPop, ParserCounterPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterRVal : public ParserRVal {
 public:
    cstring declName;
    bool operator==(IR::BFN::ParserCounterRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterRVal"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterRVal"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserCounterRVal(JSONLoader & json);
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserCounterRVal(Util::SourceInfo srcInfo, const IR::Type* type, cstring declName) :
    ParserRVal(srcInfo, type), declName(declName)
    { validate(); }
    ParserCounterRVal(const IR::Type* type, cstring declName) :
    ParserRVal(type), declName(declName)
    { validate(); }
    ParserCounterRVal(Util::SourceInfo srcInfo, cstring declName) :
    ParserRVal(srcInfo), declName(declName)
    { validate(); }
    ParserCounterRVal(cstring declName) :
    declName(declName)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserCounterRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterRVal, NodeKind::BFN_ParserCounterRVal, ParserRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterIsZero : public ParserCounterRVal {
 public:
#line 301 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20275 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ParserCounterIsZero const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterIsZero"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterIsZero"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserCounterIsZero(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserCounterRVal const & a) const override;
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserCounterIsZero(Util::SourceInfo srcInfo, const IR::Type* type, cstring declName) :
    ParserCounterRVal(srcInfo, type, declName)
    { validate(); }
    ParserCounterIsZero(const IR::Type* type, cstring declName) :
    ParserCounterRVal(type, declName)
    { validate(); }
    ParserCounterIsZero(Util::SourceInfo srcInfo, cstring declName) :
    ParserCounterRVal(srcInfo, declName)
    { validate(); }
    ParserCounterIsZero(cstring declName) :
    ParserCounterRVal(declName)
    { validate(); }
    IRNODE_SUBCLASS(ParserCounterIsZero)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterIsZero, NodeKind::BFN_ParserCounterIsZero, ParserCounterRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserCounterIsNegative : public ParserCounterRVal {
 public:
#line 305 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20310 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ParserCounterIsNegative const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserCounterIsNegative"_cs; }
    static cstring static_type_name() { return "BFN::ParserCounterIsNegative"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserCounterIsNegative(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserCounterRVal const & a) const override;
    bool operator==(IR::BFN::ParserRVal const & a) const override;
    bool operator==(IR::Expression const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserCounterIsNegative(Util::SourceInfo srcInfo, const IR::Type* type, cstring declName) :
    ParserCounterRVal(srcInfo, type, declName)
    { validate(); }
    ParserCounterIsNegative(const IR::Type* type, cstring declName) :
    ParserCounterRVal(type, declName)
    { validate(); }
    ParserCounterIsNegative(Util::SourceInfo srcInfo, cstring declName) :
    ParserCounterRVal(srcInfo, declName)
    { validate(); }
    ParserCounterIsNegative(cstring declName) :
    ParserCounterRVal(declName)
    { validate(); }
    IRNODE_SUBCLASS(ParserCounterIsNegative)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserCounterIsNegative, NodeKind::BFN_ParserCounterIsNegative, ParserCounterRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserPrioritySet : public ParserPrimitive {
 public:
#line 309 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20345 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    unsigned val;
    bool operator==(IR::BFN::ParserPrioritySet const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserPrioritySet"_cs; }
    static cstring static_type_name() { return "BFN::ParserPrioritySet"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserPrioritySet(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserPrioritySet(Util::SourceInfo srcInfo, unsigned val) :
    ParserPrimitive(srcInfo), val(val)
    { validate(); }
    ParserPrioritySet(unsigned val) :
    val(val)
    { validate(); }
    IRNODE_SUBCLASS(ParserPrioritySet)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserPrioritySet, NodeKind::BFN_ParserPrioritySet, ParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserChecksumPrimitive : public ParserPrimitive {
 public:
    cstring declName;
    bool operator==(IR::BFN::ParserChecksumPrimitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserChecksumPrimitive"_cs; }
    static cstring static_type_name() { return "BFN::ParserChecksumPrimitive"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserChecksumPrimitive(JSONLoader & json);
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserChecksumPrimitive(Util::SourceInfo srcInfo, cstring declName) :
    ParserPrimitive(srcInfo), declName(declName)
    { validate(); }
    ParserChecksumPrimitive(cstring declName) :
    declName(declName)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserChecksumPrimitive)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserChecksumPrimitive, NodeKind::BFN_ParserChecksumPrimitive, ParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserChecksumWritePrimitive : public ParserChecksumPrimitive {
 public:

#line 319 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    const IR::BFN::FieldLVal *getWriteDest() const override;
#line 20401 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 323 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    IR::BFN::ParserWriteMode getWriteMode() const override;
#line 20404 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    ParserWriteMode write_mode = ParserWriteMode::SINGLE_WRITE;
    bool operator==(IR::BFN::ParserChecksumWritePrimitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserChecksumWritePrimitive"_cs; }
    static cstring static_type_name() { return "BFN::ParserChecksumWritePrimitive"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserChecksumWritePrimitive(JSONLoader & json);
    bool operator==(IR::BFN::ParserChecksumPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserChecksumWritePrimitive(Util::SourceInfo srcInfo, cstring declName) :
    ParserChecksumPrimitive(srcInfo, declName)
    { validate(); }
    ParserChecksumWritePrimitive(cstring declName) :
    ParserChecksumPrimitive(declName)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserChecksumWritePrimitive)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserChecksumWritePrimitive, NodeKind::BFN_ParserChecksumWritePrimitive, ParserChecksumPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ChecksumVerify : public ParserChecksumWritePrimitive {
 public:
#line 329 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20434 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 331 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    const IR::BFN::FieldLVal *getWriteDest() const override;
#line 20437 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::FieldLVal* dest = nullptr;
    bool operator==(IR::BFN::ChecksumVerify const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::ChecksumVerify"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumVerify"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ChecksumVerify(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserChecksumWritePrimitive const & a) const override;
    bool operator==(IR::BFN::ParserChecksumPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ChecksumVerify(Util::SourceInfo srcInfo, cstring declName, const IR::BFN::FieldLVal* dest) :
    ParserChecksumWritePrimitive(srcInfo, declName), dest(dest)
    { validate(); }
    ChecksumVerify(cstring declName, const IR::BFN::FieldLVal* dest) :
    ParserChecksumWritePrimitive(declName), dest(dest)
    { validate(); }
    ChecksumVerify(Util::SourceInfo srcInfo, cstring declName) :
    ParserChecksumWritePrimitive(srcInfo, declName)
    { validate(); }
    ChecksumVerify(cstring declName) :
    ParserChecksumWritePrimitive(declName)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumVerify)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumVerify, NodeKind::BFN_ChecksumVerify, ParserChecksumWritePrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ChecksumResidualDeposit : public ParserChecksumWritePrimitive {
 public:
#line 337 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20475 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 339 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    const IR::BFN::FieldLVal *getWriteDest() const override;
#line 20478 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::FieldLVal* dest = nullptr;

    const IR::BFN::PacketRVal* header_end_byte = nullptr;
    bool operator==(IR::BFN::ChecksumResidualDeposit const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ChecksumResidualDeposit"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumResidualDeposit"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ChecksumResidualDeposit(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserChecksumWritePrimitive const & a) const override;
    bool operator==(IR::BFN::ParserChecksumPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ChecksumResidualDeposit(Util::SourceInfo srcInfo, cstring declName, const IR::BFN::FieldLVal* dest, const IR::BFN::PacketRVal* header_end_byte) :
    ParserChecksumWritePrimitive(srcInfo, declName), dest(dest), header_end_byte(header_end_byte)
    { validate(); }
    ChecksumResidualDeposit(cstring declName, const IR::BFN::FieldLVal* dest, const IR::BFN::PacketRVal* header_end_byte) :
    ParserChecksumWritePrimitive(declName), dest(dest), header_end_byte(header_end_byte)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumResidualDeposit)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumResidualDeposit, NodeKind::BFN_ChecksumResidualDeposit, ParserChecksumWritePrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ChecksumDepositToClot : public ParserChecksumPrimitive {
 public:
#line 347 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20513 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 350 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    const Clot* clot = nullptr;
#line 20516 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ChecksumDepositToClot const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ChecksumDepositToClot"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumDepositToClot"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ChecksumDepositToClot(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserChecksumPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ChecksumDepositToClot(Util::SourceInfo srcInfo, cstring declName) :
    ParserChecksumPrimitive(srcInfo, declName)
    { validate(); }
    ChecksumDepositToClot(cstring declName) :
    ParserChecksumPrimitive(declName)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumDepositToClot)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumDepositToClot, NodeKind::BFN_ChecksumDepositToClot, ParserChecksumPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ChecksumAdd : public ParserChecksumPrimitive {
 public:
#line 355 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20544 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::PacketRVal* source = nullptr;

    bool swap;
    bool isHeaderChecksum;
    bool operator==(IR::BFN::ChecksumAdd const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ChecksumAdd"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumAdd"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ChecksumAdd(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserChecksumPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ChecksumAdd(Util::SourceInfo srcInfo, cstring declName, const IR::BFN::PacketRVal* source, bool swap, bool isHeaderChecksum) :
    ParserChecksumPrimitive(srcInfo, declName), source(source), swap(swap), isHeaderChecksum(isHeaderChecksum)
    { validate(); }
    ChecksumAdd(cstring declName, const IR::BFN::PacketRVal* source, bool swap, bool isHeaderChecksum) :
    ParserChecksumPrimitive(declName), source(source), swap(swap), isHeaderChecksum(isHeaderChecksum)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumAdd)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumAdd, NodeKind::BFN_ChecksumAdd, ParserChecksumPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ChecksumSubtract : public ParserChecksumPrimitive {
 public:
#line 363 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20580 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::PacketRVal* source = nullptr;

    bool swap;
    bool isPayloadChecksum;
    bool operator==(IR::BFN::ChecksumSubtract const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ChecksumSubtract"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumSubtract"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ChecksumSubtract(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserChecksumPrimitive const & a) const override;
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ChecksumSubtract(Util::SourceInfo srcInfo, cstring declName, const IR::BFN::PacketRVal* source, bool swap, bool isPayloadChecksum) :
    ParserChecksumPrimitive(srcInfo, declName), source(source), swap(swap), isPayloadChecksum(isPayloadChecksum)
    { validate(); }
    ChecksumSubtract(cstring declName, const IR::BFN::PacketRVal* source, bool swap, bool isPayloadChecksum) :
    ParserChecksumPrimitive(declName), source(source), swap(swap), isPayloadChecksum(isPayloadChecksum)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumSubtract)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumSubtract, NodeKind::BFN_ChecksumSubtract, ParserChecksumPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {

class HdrLenIncStop : public ParserPrimitive {
 public:
#line 372 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20617 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::PacketRVal* source = nullptr;
    bool operator==(IR::BFN::HdrLenIncStop const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::HdrLenIncStop"_cs; }
    static cstring static_type_name() { return "BFN::HdrLenIncStop"_cs; }
    void toJSON(JSONGenerator & json) const override;
    HdrLenIncStop(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    HdrLenIncStop(Util::SourceInfo srcInfo, const IR::BFN::PacketRVal* source) :
    ParserPrimitive(srcInfo), source(source)
    { validate(); }
    HdrLenIncStop(const IR::BFN::PacketRVal* source) :
    source(source)
    { validate(); }
    IRNODE_SUBCLASS(HdrLenIncStop)
    DECLARE_TYPEINFO_WITH_TYPEID(HdrLenIncStop, NodeKind::BFN_HdrLenIncStop, ParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserMatchValue : public Node {
 public:
    bool operator==(IR::BFN::ParserMatchValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserMatchValue"_cs; }
    static cstring static_type_name() { return "BFN::ParserMatchValue"_cs; }
    void toJSON(JSONGenerator & json) const override;
    ParserMatchValue(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    ParserMatchValue(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    ParserMatchValue() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(ParserMatchValue)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserMatchValue, NodeKind::BFN_ParserMatchValue, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ParserConstMatchValue : public ParserMatchValue {
 public:
    match_t value;
#line 380 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20671 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 381 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 20674 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ParserConstMatchValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserConstMatchValue"_cs; }
    static cstring static_type_name() { return "BFN::ParserConstMatchValue"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserConstMatchValue(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserMatchValue const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserConstMatchValue(Util::SourceInfo srcInfo, match_t value) :
    ParserMatchValue(srcInfo), value(value)
    { validate(); }
    ParserConstMatchValue(match_t value) :
    value(value)
    { validate(); }
    IRNODE_SUBCLASS(ParserConstMatchValue)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserConstMatchValue, NodeKind::BFN_ParserConstMatchValue, ParserMatchValue);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// One PVS is value vector that is matched against ALL select fields in that states.
class ParserPvsMatchValue : public ParserMatchValue {
 public:
#line 387 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    using FieldSlice = std::pair<cstring, nw_bitrange>;
    using MatcherSlice = std::pair<MatchRegister, le_bitrange>;
    ordered_map<FieldSlice, MatcherSlice> mapping;
#line 20705 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring name;
    int size;
#line 393 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20710 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 394 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 20713 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::ParserPvsMatchValue const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::ParserPvsMatchValue"_cs; }
    static cstring static_type_name() { return "BFN::ParserPvsMatchValue"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserPvsMatchValue(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::ParserMatchValue const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserPvsMatchValue(Util::SourceInfo srcInfo, cstring name, int size) :
    ParserMatchValue(srcInfo), name(name), size(size)
    { validate(); }
    ParserPvsMatchValue(cstring name, int size) :
    name(name), size(size)
    { validate(); }
    IRNODE_SUBCLASS(ParserPvsMatchValue)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserPvsMatchValue, NodeKind::BFN_ParserPvsMatchValue, ParserMatchValue);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Phase0 representation in the parser. The phase0 or port metadata can be
/// represented through a table in P4-14 or parser extract/extern in P4-16. In
/// both cases, the representation is converted to a Phase0 node for the backend.
class Phase0 : public Node {
 public:
    const IR::IndexedVector<IR::StructField>* fields = nullptr;
    int size;
    int handle;
    cstring tableName;
    cstring actionName;
    cstring keyName;

    bool namedByAnnotation;
#line 410 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 20752 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::Phase0 const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Phase0"_cs; }
    static cstring static_type_name() { return "BFN::Phase0"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Phase0(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Phase0(Util::SourceInfo srcInfo, const IR::IndexedVector<IR::StructField>* fields, int size, int handle, cstring tableName, cstring actionName, cstring keyName, bool namedByAnnotation) :
    Node(srcInfo), fields(fields), size(size), handle(handle), tableName(tableName), actionName(actionName), keyName(keyName), namedByAnnotation(namedByAnnotation)
    { validate(); }
    Phase0(const IR::IndexedVector<IR::StructField>* fields, int size, int handle, cstring tableName, cstring actionName, cstring keyName, bool namedByAnnotation) :
    fields(fields), size(size), handle(handle), tableName(tableName), actionName(actionName), keyName(keyName), namedByAnnotation(namedByAnnotation)
    { validate(); }
    IRNODE_SUBCLASS(Phase0)
    DECLARE_TYPEINFO_WITH_TYPEID(Phase0, NodeKind::BFN_Phase0, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// The high-level representation of a parser state transition.
class Transition : public Node {
 public:
#line 418 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void validate() const override;
#line 20783 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 425 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Transition(match_t v)
        : value(new ParserConstMatchValue(v)), next(nullptr) { }
    Transition(match_t v, unsigned shift)
        : value(new ParserConstMatchValue(v)), shift(shift), next(nullptr) { }
    Transition(match_t v, unsigned shift, const ParserState* next)
        : value(new ParserConstMatchValue(v)), shift(shift), next(next) { }
#line 20791 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The owning state's select expressions evaluate to a value which
/// matches this...
    const IR::BFN::ParserMatchValue* value = nullptr;
/// number of bytes to shift out of the input buffer
    unsigned shift;
/// ...and transition to this state (or, if null, end the parser program).
    const IR::BFN::ParserState* next = nullptr;
#line 444 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring loop;
#line 20801 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The save to registers need to perform for this transition.
    IR::Vector<IR::BFN::SaveToRegister> saves;
/// registers to scratch pad on write
    std::set<MatchRegister> scratches;
    bool operator==(IR::BFN::Transition const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::Transition"_cs; }
    static cstring static_type_name() { return "BFN::Transition"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Transition(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Transition(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next, IR::Vector<IR::BFN::SaveToRegister> saves, std::set<MatchRegister> scratches) :
    Node(srcInfo), value(value), shift(shift), next(next), saves(saves), scratches(scratches)
    { validate(); }
    Transition(const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next, IR::Vector<IR::BFN::SaveToRegister> saves, std::set<MatchRegister> scratches) :
    value(value), shift(shift), next(next), saves(saves), scratches(scratches)
    { validate(); }
    Transition(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next, std::set<MatchRegister> scratches) :
    Node(srcInfo), value(value), shift(shift), next(next), scratches(scratches)
    { validate(); }
    Transition(const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next, std::set<MatchRegister> scratches) :
    value(value), shift(shift), next(next), scratches(scratches)
    { validate(); }
    Transition(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next, IR::Vector<IR::BFN::SaveToRegister> saves) :
    Node(srcInfo), value(value), shift(shift), next(next), saves(saves)
    { validate(); }
    Transition(const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next, IR::Vector<IR::BFN::SaveToRegister> saves) :
    value(value), shift(shift), next(next), saves(saves)
    { validate(); }
    Transition(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next) :
    Node(srcInfo), value(value), shift(shift), next(next)
    { validate(); }
    Transition(const IR::BFN::ParserMatchValue* value, unsigned shift, const IR::BFN::ParserState* next) :
    value(value), shift(shift), next(next)
    { validate(); }
    IRNODE_SUBCLASS(Transition)
    DECLARE_TYPEINFO_WITH_TYPEID(Transition, NodeKind::BFN_Transition, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A parser selection operation. These represent a load of a value from some
/// source which will be compared against the state's Transitions to select the
/// next state to transition to.
class Select : public Node {
 public:
#line 458 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Select(const IR::BFN::ParserRVal* source, const IR::Expression* p4Source);
#line 20856 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 461 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void validate() const override;
#line 20859 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The value to match against.
    const IR::BFN::ParserRVal* source = nullptr;
#line 472 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    /// Original p4 source.
    const Expression* p4Source = nullptr;
#line 20865 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::Select const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::Select"_cs; }
    static cstring static_type_name() { return "BFN::Select"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Select(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Select(Util::SourceInfo srcInfo, const IR::BFN::ParserRVal* source) :
    Node(srcInfo), source(source)
    { validate(); }
    Select(const IR::BFN::ParserRVal* source) :
    source(source)
    { validate(); }
    IRNODE_SUBCLASS(Select)
    DECLARE_TYPEINFO_WITH_TYPEID(Select, NodeKind::BFN_Select, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A high-level parser state. Contains primitives which operate on fields and
/// field-like objects.
class ParserState : public Unit {
 public:
#line 480 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    ParserState(const IR::ParserState* p4State, cstring name, gress_t gr);
#line 20896 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 482 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    ParserState(std::set<IR::ParserState const *> p4States, cstring name, gress_t gr);
#line 20899 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 485 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    int stage() const override;
#line 20902 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 486 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    gress_t thread() const override;
#line 20905 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 487 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 20908 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 488 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 20912 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 492 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    IR::ParserState const * p4State() const;
#line 20915 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 499 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    /// The original P4 state(s). Empty if this is a generated state that doesn't
    /// correspond to anything in the P4 program. Not visited.
    /// Can contain multiple states due to state merging.
    std::set<const IR::ParserState*> p4States;

    /// Debugging information about the P4 state or states that were used to
    /// generate this ParserState.
    ::BFN::DebugInfo debug;
#line 20925 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    cstring name;
    gress_t gress;
/// If true, extract at stridded offset on state re-entry
    bool stride = false;

    bool dontMerge = false;
    IR::Vector<IR::BFN::ParserPrimitive> statements;
    IR::Vector<IR::BFN::Select> selects;
    IR::Vector<IR::BFN::Transition> transitions;
    bool operator==(IR::BFN::ParserState const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ParserState"_cs; }
    static cstring static_type_name() { return "BFN::ParserState"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ParserState(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    ParserState(Util::SourceInfo srcInfo, cstring name, gress_t gress, IR::Vector<IR::BFN::ParserPrimitive> statements, IR::Vector<IR::BFN::Select> selects, IR::Vector<IR::BFN::Transition> transitions) :
    Unit(srcInfo), name(name), gress(gress), statements(statements), selects(selects), transitions(transitions)
    { validate(); }
    ParserState(cstring name, gress_t gress, IR::Vector<IR::BFN::ParserPrimitive> statements, IR::Vector<IR::BFN::Select> selects, IR::Vector<IR::BFN::Transition> transitions) :
    name(name), gress(gress), statements(statements), selects(selects), transitions(transitions)
    { validate(); }
    IRNODE_SUBCLASS(ParserState)
    DECLARE_TYPEINFO_WITH_TYPEID(ParserState, NodeKind::BFN_ParserState, Unit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// The supertype for all BFN IR parsers.
class AbstractParser : public Unit {
 public:
    IRNODE_DECLARE_APPLY_OVERLOAD(AbstractParser)
#line 526 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    int stage() const override;
#line 20966 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 527 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    gress_t thread() const override;
#line 20969 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    gress_t gress;
    bool operator==(IR::BFN::AbstractParser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::AbstractParser"_cs; }
    static cstring static_type_name() { return "BFN::AbstractParser"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AbstractParser(JSONLoader & json);
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    AbstractParser(Util::SourceInfo srcInfo, gress_t gress) :
    Unit(srcInfo), gress(gress)
    { validate(); }
    AbstractParser(gress_t gress) :
    gress(gress)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(AbstractParser)
    DECLARE_TYPEINFO_WITH_TYPEID(AbstractParser, NodeKind::BFN_AbstractParser, Unit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// The high-level representation of a parser in backend.
/// This is the representation used prior to PHV allocation.
/// It is created from IR::BFN::TnaParser by BFN::ExtractParser in post-midend
/// passes BridgedPacking and SubstitutePackedHeaders.
/// It contains primitives which operate on fields and field-like objects;
/// some operands may be expressions that can't yet be evaluated.
class Parser : public AbstractParser {
 public:
    IRNODE_DECLARE_APPLY_OVERLOAD(Parser)
#line 540 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 21005 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::ParserState* start = nullptr;
    IR::ID name;
    cstring pipeName;
    const IR::BFN::Phase0* phase0 = nullptr;

    std::vector<int> portmap;

    bool operator==(IR::BFN::Parser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Parser"_cs; }
    static cstring static_type_name() { return "BFN::Parser"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Parser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::AbstractParser const & a) const override;
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), name(name), pipeName(pipeName), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(gress), start(start), name(name), pipeName(pipeName), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, cstring pipeName, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), pipeName(pipeName), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, cstring pipeName, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(gress), start(start), pipeName(pipeName), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), name(name), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(gress), start(start), name(name), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, const IR::BFN::Phase0* phase0, std::vector<int> portmap) :
    AbstractParser(gress), start(start), phase0(phase0), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), name(name), pipeName(pipeName), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName, std::vector<int> portmap) :
    AbstractParser(gress), start(start), name(name), pipeName(pipeName), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, cstring pipeName, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), pipeName(pipeName), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, cstring pipeName, std::vector<int> portmap) :
    AbstractParser(gress), start(start), pipeName(pipeName), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), name(name), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name, std::vector<int> portmap) :
    AbstractParser(gress), start(start), name(name), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, std::vector<int> portmap) :
    AbstractParser(srcInfo, gress), start(start), portmap(portmap)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, std::vector<int> portmap) :
    AbstractParser(gress), start(start), portmap(portmap)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName, const IR::BFN::Phase0* phase0) :
    AbstractParser(srcInfo, gress), start(start), name(name), pipeName(pipeName), phase0(phase0)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName, const IR::BFN::Phase0* phase0) :
    AbstractParser(gress), start(start), name(name), pipeName(pipeName), phase0(phase0)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, cstring pipeName, const IR::BFN::Phase0* phase0) :
    AbstractParser(srcInfo, gress), start(start), pipeName(pipeName), phase0(phase0)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, cstring pipeName, const IR::BFN::Phase0* phase0) :
    AbstractParser(gress), start(start), pipeName(pipeName), phase0(phase0)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name, const IR::BFN::Phase0* phase0) :
    AbstractParser(srcInfo, gress), start(start), name(name), phase0(phase0)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name, const IR::BFN::Phase0* phase0) :
    AbstractParser(gress), start(start), name(name), phase0(phase0)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, const IR::BFN::Phase0* phase0) :
    AbstractParser(srcInfo, gress), start(start), phase0(phase0)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, const IR::BFN::Phase0* phase0) :
    AbstractParser(gress), start(start), phase0(phase0)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName) :
    AbstractParser(srcInfo, gress), start(start), name(name), pipeName(pipeName)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name, cstring pipeName) :
    AbstractParser(gress), start(start), name(name), pipeName(pipeName)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, cstring pipeName) :
    AbstractParser(srcInfo, gress), start(start), pipeName(pipeName)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, cstring pipeName) :
    AbstractParser(gress), start(start), pipeName(pipeName)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start, IR::ID name) :
    AbstractParser(srcInfo, gress), start(start), name(name)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start, IR::ID name) :
    AbstractParser(gress), start(start), name(name)
    { validate(); }
    Parser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserState* start) :
    AbstractParser(srcInfo, gress), start(start)
    { validate(); }
    Parser(gress_t gress, const IR::BFN::ParserState* start) :
    AbstractParser(gress), start(start)
    { validate(); }
    IRNODE_SUBCLASS(Parser)
    DECLARE_TYPEINFO_WITH_TYPEID(Parser, NodeKind::BFN_Parser, AbstractParser);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Ghost Parser to account for implicit ghost MD writes. This is a fake Parser
/// and does not have a P4 equivalent. This parser must be present on all pipes
/// in the P4 program whenever there is atleast one Ghost Control present on a
/// pipe. The ParserLVal consists of ghost intrinsic metadata header fields which
/// are recognized by PHV allocation for allocation and correct live range
/// analysis.
class GhostParser : public AbstractParser {
 public:
#line 556 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 21141 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"

    const IR::BFN::ParserLVal* ghost_md = nullptr;

    IR::ID name;
    cstring pipeName;
    bool operator==(IR::BFN::GhostParser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::GhostParser"_cs; }
    static cstring static_type_name() { return "BFN::GhostParser"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    GhostParser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::AbstractParser const & a) const override;
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    GhostParser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserLVal* ghost_md, IR::ID name, cstring pipeName) :
    AbstractParser(srcInfo, gress), ghost_md(ghost_md), name(name), pipeName(pipeName)
    { validate(); }
    GhostParser(gress_t gress, const IR::BFN::ParserLVal* ghost_md, IR::ID name, cstring pipeName) :
    AbstractParser(gress), ghost_md(ghost_md), name(name), pipeName(pipeName)
    { validate(); }
    GhostParser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserLVal* ghost_md, cstring pipeName) :
    AbstractParser(srcInfo, gress), ghost_md(ghost_md), pipeName(pipeName)
    { validate(); }
    GhostParser(gress_t gress, const IR::BFN::ParserLVal* ghost_md, cstring pipeName) :
    AbstractParser(gress), ghost_md(ghost_md), pipeName(pipeName)
    { validate(); }
    GhostParser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserLVal* ghost_md, IR::ID name) :
    AbstractParser(srcInfo, gress), ghost_md(ghost_md), name(name)
    { validate(); }
    GhostParser(gress_t gress, const IR::BFN::ParserLVal* ghost_md, IR::ID name) :
    AbstractParser(gress), ghost_md(ghost_md), name(name)
    { validate(); }
    GhostParser(Util::SourceInfo srcInfo, gress_t gress, const IR::BFN::ParserLVal* ghost_md) :
    AbstractParser(srcInfo, gress), ghost_md(ghost_md)
    { validate(); }
    GhostParser(gress_t gress, const IR::BFN::ParserLVal* ghost_md) :
    AbstractParser(gress), ghost_md(ghost_md)
    { validate(); }
    IRNODE_SUBCLASS(GhostParser)
    DECLARE_TYPEINFO_WITH_TYPEID(GhostParser, NodeKind::BFN_GhostParser, AbstractParser);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A list of fields which will be written into a buffer as part of a deparser
/// digest.
class DigestFieldList : public Node {
 public:
/// Index of this field list in the digest table
    int idx;
/// The fields to be copied into the buffer.
    IR::Vector<IR::BFN::FieldLVal> sources;
    const IR::Type_StructLike* type = nullptr;
/// Learning needs control plane name for the field list.
    cstring controlPlaneName;
    bool operator==(IR::BFN::DigestFieldList const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::DigestFieldList"_cs; }
    static cstring static_type_name() { return "BFN::DigestFieldList"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DigestFieldList(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DigestFieldList(Util::SourceInfo srcInfo, int idx, IR::Vector<IR::BFN::FieldLVal> sources, const IR::Type_StructLike* type, cstring controlPlaneName) :
    Node(srcInfo), idx(idx), sources(sources), type(type), controlPlaneName(controlPlaneName)
    { validate(); }
    DigestFieldList(int idx, IR::Vector<IR::BFN::FieldLVal> sources, const IR::Type_StructLike* type, cstring controlPlaneName) :
    idx(idx), sources(sources), type(type), controlPlaneName(controlPlaneName)
    { validate(); }
    DigestFieldList(Util::SourceInfo srcInfo, int idx, IR::Vector<IR::BFN::FieldLVal> sources, const IR::Type_StructLike* type) :
    Node(srcInfo), idx(idx), sources(sources), type(type)
    { validate(); }
    DigestFieldList(int idx, IR::Vector<IR::BFN::FieldLVal> sources, const IR::Type_StructLike* type) :
    idx(idx), sources(sources), type(type)
    { validate(); }
    IRNODE_SUBCLASS(DigestFieldList)
    DECLARE_TYPEINFO_WITH_TYPEID(DigestFieldList, NodeKind::BFN_DigestFieldList, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A deparser digest. Each digest writes one of several lists of fields into a
/// special hardware buffer, with the list to be used chosen by the value of a
/// selector field.
class Digest : public Node {
 public:
#line 582 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Digest(cstring name);
#line 21243 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 583 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Digest(cstring name, const IR::BFN::FieldLVal* selector);
#line 21246 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 584 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Digest(cstring name, const IR::Expression* selector);
#line 21249 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The name of the digest, identifying a special buffer to be filled in by
/// the deparser hardware. The name is chosen to match the corresponding
/// assembly directive, which in turn is named based on definitions in the
/// CSRs.
    cstring name;
/// The field which controls which field list will be written into the
/// buffer. Selector is nullptr when only one field list is supported.
/// For example, tofino2 pktgen only supports one field list.
    const IR::BFN::FieldLVal* selector = nullptr;
/// The available field lists
    IR::Vector<IR::BFN::DigestFieldList> fieldLists;
/// If present, the POV bit controlling whether the contents of the source
/// location are valid. Not used on Tofino.
    const IR::BFN::FieldLVal* povBit = nullptr;
    bool operator==(IR::BFN::Digest const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Digest"_cs; }
    static cstring static_type_name() { return "BFN::Digest"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Digest(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    Digest(Util::SourceInfo srcInfo, cstring name, const IR::BFN::FieldLVal* selector, IR::Vector<IR::BFN::DigestFieldList> fieldLists) :
    Node(srcInfo), name(name), selector(selector), fieldLists(fieldLists)
    { validate(); }
    Digest(cstring name, const IR::BFN::FieldLVal* selector, IR::Vector<IR::BFN::DigestFieldList> fieldLists) :
    name(name), selector(selector), fieldLists(fieldLists)
    { validate(); }
    Digest(Util::SourceInfo srcInfo, cstring name, IR::Vector<IR::BFN::DigestFieldList> fieldLists) :
    Node(srcInfo), name(name), fieldLists(fieldLists)
    { validate(); }
    Digest(cstring name, IR::Vector<IR::BFN::DigestFieldList> fieldLists) :
    name(name), fieldLists(fieldLists)
    { validate(); }
    IRNODE_SUBCLASS(Digest)
    DECLARE_TYPEINFO_WITH_TYPEID(Digest, NodeKind::BFN_Digest, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Supertype for all deparser primitives - i.e., actions that can be executed
/// in a deparser control.
class DeparserPrimitive : public Node {
 public:
    bool operator==(IR::BFN::DeparserPrimitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::DeparserPrimitive"_cs; }
    static cstring static_type_name() { return "BFN::DeparserPrimitive"_cs; }
    void toJSON(JSONGenerator & json) const override;
    DeparserPrimitive(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    DeparserPrimitive(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    DeparserPrimitive() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(DeparserPrimitive)
    DECLARE_TYPEINFO_WITH_TYPEID(DeparserPrimitive, NodeKind::BFN_DeparserPrimitive, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Common abstract base class for all deparser emit types
class Emit : public DeparserPrimitive {
 public:
#line 612 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Emit(const IR::Expression* povBit);
#line 21325 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 614 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Emit(Util::SourceInfo si, const IR::Expression* povBit);
#line 21328 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The POV bit this emit is predicated on
    const IR::BFN::FieldLVal* povBit = nullptr;
    bool operator==(IR::BFN::Emit const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Emit"_cs; }
    static cstring static_type_name() { return "BFN::Emit"_cs; }
    void toJSON(JSONGenerator & json) const override;
    Emit(JSONLoader & json);
    bool operator==(IR::BFN::DeparserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    Emit(Util::SourceInfo srcInfo, const IR::BFN::FieldLVal* povBit) :
    DeparserPrimitive(srcInfo), povBit(povBit)
    { validate(); }
    Emit(const IR::BFN::FieldLVal* povBit) :
    povBit(povBit)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(Emit)
    DECLARE_TYPEINFO_WITH_TYPEID(Emit, NodeKind::BFN_Emit, DeparserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A deparser emit operation, representing a copy by the deparser of the
/// contents of some location (ultimately backed by a PHV container) to the
/// output packet.
class EmitField : public Emit {
 public:
#line 625 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    EmitField(const IR::Expression* source, const IR::Expression* povBit);
#line 21363 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 627 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    EmitField(Util::SourceInfo si, const IR::Expression* source, const IR::Expression* povBit);
#line 21366 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 630 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 21369 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The location to be copied into the output packet.
    const IR::BFN::FieldLVal* source = nullptr;
    bool operator==(IR::BFN::EmitField const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::EmitField"_cs; }
    static cstring static_type_name() { return "BFN::EmitField"_cs; }
    void toJSON(JSONGenerator & json) const override;
    EmitField(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Emit const & a) const override;
    bool operator==(IR::BFN::DeparserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    EmitField(Util::SourceInfo srcInfo, const IR::BFN::FieldLVal* povBit, const IR::BFN::FieldLVal* source) :
    Emit(srcInfo, povBit), source(source)
    { validate(); }
    EmitField(const IR::BFN::FieldLVal* povBit, const IR::BFN::FieldLVal* source) :
    Emit(povBit), source(source)
    { validate(); }
    IRNODE_SUBCLASS(EmitField)
    DECLARE_TYPEINFO_WITH_TYPEID(EmitField, NodeKind::BFN_EmitField, Emit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class EmitConstant : public Emit {
 public:
#line 640 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 21402 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::Constant* constant = nullptr;
    bool operator==(IR::BFN::EmitConstant const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::EmitConstant"_cs; }
    static cstring static_type_name() { return "BFN::EmitConstant"_cs; }
    void toJSON(JSONGenerator & json) const override;
    EmitConstant(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Emit const & a) const override;
    bool operator==(IR::BFN::DeparserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    EmitConstant(Util::SourceInfo srcInfo, const IR::BFN::FieldLVal* povBit, const IR::Constant* constant) :
    Emit(srcInfo, povBit), constant(constant)
    { validate(); }
    EmitConstant(const IR::BFN::FieldLVal* povBit, const IR::Constant* constant) :
    Emit(povBit), constant(constant)
    { validate(); }
    IRNODE_SUBCLASS(EmitConstant)
    DECLARE_TYPEINFO_WITH_TYPEID(EmitConstant, NodeKind::BFN_EmitConstant, Emit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A deparser emit operation, representing a copy by the deparser of the
/// contents of some location (ultimately backed by a CLOT) to the
/// output packet.
class EmitClot : public Emit {
 public:
#line 651 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 21437 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 656 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Clot* clot = nullptr;
#line 21440 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::EmitClot const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::EmitClot"_cs; }
    static cstring static_type_name() { return "BFN::EmitClot"_cs; }
    void toJSON(JSONGenerator & json) const override;
    EmitClot(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Emit const & a) const override;
    bool operator==(IR::BFN::DeparserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    EmitClot(Util::SourceInfo srcInfo, const IR::BFN::FieldLVal* povBit) :
    Emit(srcInfo, povBit)
    { validate(); }
    EmitClot(const IR::BFN::FieldLVal* povBit) :
    Emit(povBit)
    { validate(); }
    IRNODE_SUBCLASS(EmitClot)
    DECLARE_TYPEINFO_WITH_TYPEID(EmitClot, NodeKind::BFN_EmitClot, Emit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {

class ChecksumEntry : public Node {
 public:
#line 661 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 21469 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    const IR::BFN::FieldLVal* field = nullptr;
    const IR::BFN::FieldLVal* povBit = nullptr;
/// Corresponds to an offset of the FieldVal in the checksum list.
    int offset;
    bool operator==(IR::BFN::ChecksumEntry const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ChecksumEntry"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumEntry"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ChecksumEntry(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ChecksumEntry(Util::SourceInfo srcInfo, const IR::BFN::FieldLVal* field, const IR::BFN::FieldLVal* povBit, int offset) :
    Node(srcInfo), field(field), povBit(povBit), offset(offset)
    { validate(); }
    ChecksumEntry(const IR::BFN::FieldLVal* field, const IR::BFN::FieldLVal* povBit, int offset) :
    field(field), povBit(povBit), offset(offset)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumEntry)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumEntry, NodeKind::BFN_ChecksumEntry, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A deparser computed checksum operation. This instructs the deparser to
/// compute the checksum of a group of fields and write the result into the
/// output packet.
class EmitChecksum : public Emit {
 public:
/// The fields from which the checksum will be computed.
    IR::Vector<IR::BFN::ChecksumEntry> sources;

    bool zeros_as_ones = false;
    const IR::BFN::ChecksumLVal* dest = nullptr;


    IR::Vector<IR::BFN::EmitChecksum> nested_checksum;
    bool operator==(IR::BFN::EmitChecksum const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::EmitChecksum"_cs; }
    static cstring static_type_name() { return "BFN::EmitChecksum"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    EmitChecksum(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Emit const & a) const override;
    bool operator==(IR::BFN::DeparserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    EmitChecksum(Util::SourceInfo srcInfo, const IR::BFN::FieldLVal* povBit, IR::Vector<IR::BFN::ChecksumEntry> sources, const IR::BFN::ChecksumLVal* dest, IR::Vector<IR::BFN::EmitChecksum> nested_checksum) :
    Emit(srcInfo, povBit), sources(sources), dest(dest), nested_checksum(nested_checksum)
    { validate(); }
    EmitChecksum(const IR::BFN::FieldLVal* povBit, IR::Vector<IR::BFN::ChecksumEntry> sources, const IR::BFN::ChecksumLVal* dest, IR::Vector<IR::BFN::EmitChecksum> nested_checksum) :
    Emit(povBit), sources(sources), dest(dest), nested_checksum(nested_checksum)
    { validate(); }
    EmitChecksum(Util::SourceInfo srcInfo, const IR::BFN::FieldLVal* povBit, IR::Vector<IR::BFN::ChecksumEntry> sources, const IR::BFN::ChecksumLVal* dest) :
    Emit(srcInfo, povBit), sources(sources), dest(dest)
    { validate(); }
    EmitChecksum(const IR::BFN::FieldLVal* povBit, IR::Vector<IR::BFN::ChecksumEntry> sources, const IR::BFN::ChecksumLVal* dest) :
    Emit(povBit), sources(sources), dest(dest)
    { validate(); }
    IRNODE_SUBCLASS(EmitChecksum)
    DECLARE_TYPEINFO_WITH_TYPEID(EmitChecksum, NodeKind::BFN_EmitChecksum, Emit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Configures the location from which an intrinsic deparser parameter should
/// obtain its value.
class DeparserParameter : public Node {
 public:
#line 692 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    DeparserParameter(cstring name, const IR::Expression* source);
#line 21552 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 694 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    DeparserParameter(Util::SourceInfo si, cstring name, const IR::Expression* source);
#line 21555 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 697 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void dbprint(std::ostream & out) const override;
#line 21558 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The deparser parameter to configure. The name is the one used in the
/// assembly, which in turn derives from the CSR register name.
    cstring name;
/// The location to read the parameter value from.
    const IR::BFN::FieldLVal* source = nullptr;
/// If present, the POV bit controlling whether the contents of the source
/// location are valid. Not used on Tofino.
    const IR::BFN::FieldLVal* povBit = nullptr;
/// A source is required. If this is false, then a DeparserParameter can
/// exist that is just a povBit.
    bool sourceReq = true;
#line 722 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    void validate() const override;
#line 21572 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::DeparserParameter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::DeparserParameter"_cs; }
    static cstring static_type_name() { return "BFN::DeparserParameter"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DeparserParameter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DeparserParameter(Util::SourceInfo srcInfo, cstring name, const IR::BFN::FieldLVal* source) :
    Node(srcInfo), name(name), source(source)
    { validate(); }
    DeparserParameter(cstring name, const IR::BFN::FieldLVal* source) :
    name(name), source(source)
    { validate(); }
    IRNODE_SUBCLASS(DeparserParameter)
    DECLARE_TYPEINFO_WITH_TYPEID(DeparserParameter, NodeKind::BFN_DeparserParameter, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// The supertype for all BFN IR deparsers.
class AbstractDeparser : public Unit {
 public:
    IRNODE_DECLARE_APPLY_OVERLOAD(AbstractDeparser)
#line 734 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    int stage() const override;
#line 21603 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 735 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    gress_t thread() const override;
#line 21606 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    gress_t gress;
    bool operator==(IR::BFN::AbstractDeparser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::AbstractDeparser"_cs; }
    static cstring static_type_name() { return "BFN::AbstractDeparser"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    AbstractDeparser(JSONLoader & json);
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    AbstractDeparser(Util::SourceInfo srcInfo, gress_t gress) :
    Unit(srcInfo), gress(gress)
    { validate(); }
    AbstractDeparser(gress_t gress) :
    gress(gress)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(AbstractDeparser)
    DECLARE_TYPEINFO_WITH_TYPEID(AbstractDeparser, NodeKind::BFN_AbstractDeparser, Unit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class Deparser : public AbstractDeparser {
 public:
#line 742 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    Deparser(gress_t gr);
#line 21635 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(Deparser)
#line 744 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde.def"
    cstring toString() const override;
#line 21639 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IR::Vector<IR::BFN::Emit> emits;
    IR::Vector<IR::BFN::DeparserParameter> params;
    IR::NameMap<IR::BFN::Digest> digests;
    bool operator==(IR::BFN::Deparser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::Deparser"_cs; }
    static cstring static_type_name() { return "BFN::Deparser"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    Deparser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::AbstractDeparser const & a) const override;
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(Deparser)
    DECLARE_TYPEINFO_WITH_TYPEID(Deparser, NodeKind::BFN_Deparser, AbstractDeparser);
};
}  // namespace BFN
}  // namespace P4::IR

#line 23 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
#include "lib/ordered_set.h"
#include "backends/tofino/bf-p4c/common/debug_info.h"
#include "backends/tofino/bf-p4c/ir/bitrange.h"
#include "backends/tofino/bf-p4c/ir/ir_enums.h"
#include "backends/tofino/bf-p4c/parde/clot/clot.h"
#include "backends/tofino/bf-p4c/parde/match_register.h"
#include "backends/tofino/bf-p4c/phv/phv.h"

namespace BFN {
struct FieldPacking;
}  // namespace BFN
#line 21675 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
namespace P4::IR {
namespace BFN {
/// A value that can be read from in the parser on the hardware.
class LoweredParserRVal : public Node {
 public:
    bool operator==(IR::BFN::LoweredParserRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredParserRVal"_cs; }
    static cstring static_type_name() { return "BFN::LoweredParserRVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoweredParserRVal(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    LoweredParserRVal(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    LoweredParserRVal() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(LoweredParserRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredParserRVal, NodeKind::BFN_LoweredParserRVal, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An r-value that represents a read from a range of input buffer bytes (rather
/// than bits, as in the high-level parser IR) in the input buffer. The
/// coordinate system used will depend on the specific type of
/// `LoweredInputBufferRVal`.
class LoweredInputBufferRVal : public LoweredParserRVal {
 public:
/// @return this buffer range as a half-open range of bytes in network order.
#line 47 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    nw_byteinterval byteInterval() const;
#line 21710 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The region represented by this `LoweredInputBufferRVal`, expressed as a
/// range of bytes in network order.
    nw_byterange range;
    bool operator==(IR::BFN::LoweredInputBufferRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredInputBufferRVal"_cs; }
    static cstring static_type_name() { return "BFN::LoweredInputBufferRVal"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredInputBufferRVal(JSONLoader & json);
    bool operator==(IR::BFN::LoweredParserRVal const & a) const override;
    bool operator==(IR::Node const & a) const override;
 protected:
    LoweredInputBufferRVal(Util::SourceInfo srcInfo, nw_byterange range) :
    LoweredParserRVal(srcInfo), range(range)
    { validate(); }
    LoweredInputBufferRVal(nw_byterange range) :
    range(range)
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(LoweredInputBufferRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredInputBufferRVal, NodeKind::BFN_LoweredInputBufferRVal, LoweredParserRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {

class LoweredPacketRVal : public LoweredInputBufferRVal {
 public:
#line 58 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 21742 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredPacketRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredPacketRVal"_cs; }
    static cstring static_type_name() { return "BFN::LoweredPacketRVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoweredPacketRVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredInputBufferRVal const & a) const override;
    bool operator==(IR::BFN::LoweredParserRVal const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredPacketRVal(Util::SourceInfo srcInfo, nw_byterange range) :
    LoweredInputBufferRVal(srcInfo, range)
    { validate(); }
    LoweredPacketRVal(nw_byterange range) :
    LoweredInputBufferRVal(range)
    { validate(); }
    IRNODE_SUBCLASS(LoweredPacketRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredPacketRVal, NodeKind::BFN_LoweredPacketRVal, LoweredInputBufferRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An r-value representing a range of bits from the region of the input buffer
/// that's mapped onto special metadata, rather than data from the input packet.
/// @see BufferRVal for more details about the coordinate system.
class LoweredMetadataRVal : public LoweredInputBufferRVal {
 public:
#line 67 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 21773 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredMetadataRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredMetadataRVal"_cs; }
    static cstring static_type_name() { return "BFN::LoweredMetadataRVal"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoweredMetadataRVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredInputBufferRVal const & a) const override;
    bool operator==(IR::BFN::LoweredParserRVal const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredMetadataRVal(Util::SourceInfo srcInfo, nw_byterange range) :
    LoweredInputBufferRVal(srcInfo, range)
    { validate(); }
    LoweredMetadataRVal(nw_byterange range) :
    LoweredInputBufferRVal(range)
    { validate(); }
    IRNODE_SUBCLASS(LoweredMetadataRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredMetadataRVal, NodeKind::BFN_LoweredMetadataRVal, LoweredInputBufferRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A lowered representation of a constant used as an r-value in the parser.
class LoweredConstantRVal : public LoweredParserRVal {
 public:
#line 74 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 21802 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The constant to extract.
    uint32_t constant;
    bool operator==(IR::BFN::LoweredConstantRVal const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredConstantRVal"_cs; }
    static cstring static_type_name() { return "BFN::LoweredConstantRVal"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredConstantRVal(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredParserRVal const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredConstantRVal(Util::SourceInfo srcInfo, uint32_t constant) :
    LoweredParserRVal(srcInfo), constant(constant)
    { validate(); }
    LoweredConstantRVal(uint32_t constant) :
    constant(constant)
    { validate(); }
    IRNODE_SUBCLASS(LoweredConstantRVal)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredConstantRVal, NodeKind::BFN_LoweredConstantRVal, LoweredParserRVal);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class LoweredParserPrimitive : public Node {
 public:
    bool operator==(IR::BFN::LoweredParserPrimitive const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredParserPrimitive"_cs; }
    static cstring static_type_name() { return "BFN::LoweredParserPrimitive"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoweredParserPrimitive(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    LoweredParserPrimitive(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    LoweredParserPrimitive() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(LoweredParserPrimitive)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredParserPrimitive, NodeKind::BFN_LoweredParserPrimitive, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A lowered parser extraction operation, representing a write by the parser
/// into a PHV container.
class LoweredExtractPhv : public LoweredParserPrimitive {
 public:
#line 86 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    /// Convenience constructors for accepting a raw PHV::Container.
    LoweredExtractPhv(PHV::Container dest, const LoweredParserRVal* source)
      : source(source), dest(new BFN::ContainerRef(dest)) { }
    LoweredExtractPhv(Util::SourceInfo si, PHV::Container dest,
                   const LoweredParserRVal* source)
      : LoweredParserPrimitive(si), source(source), dest(new BFN::ContainerRef(dest)) { }
#line 21861 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 94 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 21864 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 98 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void validate() const override;
#line 21867 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The location that will be read from.
    const IR::BFN::LoweredParserRVal* source = nullptr;
/// The PHV container this extract writes to.
    const IR::BFN::ContainerRef* dest = nullptr;
    ParserWriteMode write_mode = ParserWriteMode::SINGLE_WRITE;
#line 109 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    /// Debugging information about the high-level operations that are
    /// implemented by this low-level extract.
    ::BFN::DebugInfo debug;
#line 21877 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredExtractPhv const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::LoweredExtractPhv"_cs; }
    static cstring static_type_name() { return "BFN::LoweredExtractPhv"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredExtractPhv(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredExtractPhv(Util::SourceInfo srcInfo, const IR::BFN::LoweredParserRVal* source, const IR::BFN::ContainerRef* dest) :
    LoweredParserPrimitive(srcInfo), source(source), dest(dest)
    { validate(); }
    LoweredExtractPhv(const IR::BFN::LoweredParserRVal* source, const IR::BFN::ContainerRef* dest) :
    source(source), dest(dest)
    { validate(); }
    IRNODE_SUBCLASS(LoweredExtractPhv)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredExtractPhv, NodeKind::BFN_LoweredExtractPhv, LoweredParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class LoweredExtractClot : public LoweredParserPrimitive {
 public:
#line 116 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 21907 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// Indicates that this is the first extract into the CLOT
    bool is_start;
/// The location that will be read from.
    const IR::BFN::LoweredPacketRVal* source = nullptr;
/// The CLOT this extract writes to.
    Clot * dest;
/// The higher order parser state this CLOT started in.
/// Used to get the proper length of the CLOT from dest->length_in_bytes(parser_state).
    IR::BFN::ParserState const * higher_parser_state = nullptr;
#line 131 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    /// Debugging information about the high-level operations that are
    /// implemented by this low-level extract.
    ::BFN::DebugInfo debug;
#line 21921 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 136 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dump_fields(std::ostream & out) const override;
#line 21924 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredExtractClot const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredExtractClot"_cs; }
    static cstring static_type_name() { return "BFN::LoweredExtractClot"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoweredExtractClot(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredExtractClot(Util::SourceInfo srcInfo, bool is_start, const IR::BFN::LoweredPacketRVal* source, Clot * dest) :
    LoweredParserPrimitive(srcInfo), is_start(is_start), source(source), dest(dest)
    { validate(); }
    LoweredExtractClot(bool is_start, const IR::BFN::LoweredPacketRVal* source, Clot * dest) :
    is_start(is_start), source(source), dest(dest)
    { validate(); }
    IRNODE_SUBCLASS(LoweredExtractClot)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredExtractClot, NodeKind::BFN_LoweredExtractClot, LoweredParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class LoweredParserChecksum : public LoweredParserPrimitive {
 public:
#line 145 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 21954 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    unsigned unit_id;
    std::set<nw_byterange> masked_ranges;
    unsigned swap;
    bool start;
    bool end;
    unsigned end_pos;
    BFN::ChecksumMode type;
    unsigned multiply_2;
    const IR::BFN::ContainerBitRef* csum_err = nullptr;
    Clot clot_dest = {};
    const IR::BFN::ContainerRef* phv_dest = nullptr;
    ParserWriteMode write_mode;
    bool operator==(IR::BFN::LoweredParserChecksum const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::LoweredParserChecksum"_cs; }
    static cstring static_type_name() { return "BFN::LoweredParserChecksum"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredParserChecksum(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredParserChecksum(Util::SourceInfo srcInfo, unsigned unit_id, std::set<nw_byterange> masked_ranges, unsigned swap, bool start, bool end, unsigned end_pos, BFN::ChecksumMode type, unsigned multiply_2, ParserWriteMode write_mode) :
    LoweredParserPrimitive(srcInfo), unit_id(unit_id), masked_ranges(masked_ranges), swap(swap), start(start), end(end), end_pos(end_pos), type(type), multiply_2(multiply_2), write_mode(write_mode)
    { validate(); }
    LoweredParserChecksum(unsigned unit_id, std::set<nw_byterange> masked_ranges, unsigned swap, bool start, bool end, unsigned end_pos, BFN::ChecksumMode type, unsigned multiply_2, ParserWriteMode write_mode) :
    unit_id(unit_id), masked_ranges(masked_ranges), swap(swap), start(start), end(end), end_pos(end_pos), type(type), multiply_2(multiply_2), write_mode(write_mode)
    { validate(); }
    IRNODE_SUBCLASS(LoweredParserChecksum)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredParserChecksum, NodeKind::BFN_LoweredParserChecksum, LoweredParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A lowered save operation; represents saving bits from input buffer to match register
class LoweredSave : public LoweredParserPrimitive {
 public:
/// Convenience constructors for accepting a raw source
#line 177 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    LoweredSave(MatchRegister const & reg, IR::BFN::LoweredInputBufferRVal const * source);
#line 21998 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 180 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 22001 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The location that will be read from.
    const IR::BFN::LoweredInputBufferRVal* source = nullptr;
/// The register this save writes to.
    MatchRegister dest;
#line 188 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"

    /// Debugging information about the high-level operations that are
    /// implemented by this low-level extract.
    ::BFN::DebugInfo debug;
#line 22011 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredSave const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredSave"_cs; }
    static cstring static_type_name() { return "BFN::LoweredSave"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredSave(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredParserPrimitive const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredSave(Util::SourceInfo srcInfo, const IR::BFN::LoweredInputBufferRVal* source, MatchRegister dest) :
    LoweredParserPrimitive(srcInfo), source(source), dest(dest)
    { validate(); }
    LoweredSave(const IR::BFN::LoweredInputBufferRVal* source, MatchRegister dest) :
    source(source), dest(dest)
    { validate(); }
    IRNODE_SUBCLASS(LoweredSave)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredSave, NodeKind::BFN_LoweredSave, LoweredParserPrimitive);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A lowered parser selection operation; represents a vector of
/// registers that have data loaded from input buffer in an earlier state
/// which will be compared against in the state's LoweredParserMatch
/// entries to select the next state to transition to.
class LoweredSelect : public Node {
 public:
#line 201 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    explicit LoweredSelect(const ordered_set<MatchRegister>& regs)
        : regs(regs) { }

    /// The registers to match against.
    ordered_set<MatchRegister> regs;

    /// The counter output (is_zero, is_negative) to match against.
    std::vector<const IR::BFN::ParserCounterRVal*> counters;

    /// Debugging information about the high-level operations that are
    /// implemented by this low-level select operation.
    ::BFN::DebugInfo debug;
#line 22057 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredSelect const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredSelect"_cs; }
    static cstring static_type_name() { return "BFN::LoweredSelect"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredSelect(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    LoweredSelect(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    LoweredSelect() 
    { validate(); }
    IRNODE_SUBCLASS(LoweredSelect)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredSelect, NodeKind::BFN_LoweredSelect, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// This class represents the operations to perform on a match at
/// the current parser state. Each LoweredParserMatch uses a single
/// TCAM row in the parser for constant matches, and multiple TCAM rows
/// for value sets. Operations use a row in their associated action RAMs
/// (Early Action RAM and Checksum Control RAM).
class LoweredParserMatch : public Node {
 public:
#line 223 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    LoweredParserMatch(match_t value, unsigned shift, const LoweredParserState* next)
        : value(new ParserConstMatchValue(value)),
          shift(shift), bufferRequired(0), next(next) { }
#line 22090 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The match value: constant or a value set
    const IR::BFN::ParserMatchValue* value = nullptr;
/// Number of bytes to shift out of input buffer at current state
    unsigned shift;
/// Final amount to add to header length
    std::optional<unsigned> hdrLenIncFinalAmt;
/// Extractions to perform
    IR::Vector<IR::BFN::LoweredParserPrimitive> extracts;
/// Save match word to registers
    IR::Vector<IR::BFN::LoweredSave> saves;
/// registers to scratch pad on write
    std::set<MatchRegister> scratches;
/// Checksum calculations
    IR::Vector<IR::BFN::LoweredParserChecksum> checksums;
/// Counter instructions
    IR::Vector<IR::BFN::ParserCounterPrimitive> counters;
/// Priority set
    const IR::BFN::ParserPrioritySet* priority = nullptr;
/// The number of packet bytes which must be available in the input buffer
/// for the extractions to be performed successfully. If `std::nullopt`,
/// there is no particular requirement; the assembler will choose a default.
    std::optional<unsigned> bufferRequired;

    bool partialHdrErrProc;
/// Next state to transition to (null means terminal state)
    const IR::BFN::LoweredParserState* next = nullptr;
/// Increment destination offset on state re-entry
    std::optional<unsigned> offsetInc;
#line 269 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    cstring loop;
#line 22121 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 273 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    /// Debugging information about the high-level parser states that were used
    /// to generate this low-level match construct.
    ::BFN::DebugInfo debug;
#line 22126 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredParserMatch const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredParserMatch"_cs; }
    static cstring static_type_name() { return "BFN::LoweredParserMatch"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredParserMatch(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    Node(srcInfo), value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    Node(srcInfo), value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    Node(srcInfo), value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    Node(srcInfo), value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next, std::optional<unsigned> offsetInc) :
    value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next), offsetInc(offsetInc)
    { validate(); }
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    Node(srcInfo), value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    Node(srcInfo), value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, std::optional<unsigned> bufferRequired, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), bufferRequired(bufferRequired), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    Node(srcInfo), value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, std::optional<unsigned> hdrLenIncFinalAmt, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    value(value), shift(shift), hdrLenIncFinalAmt(hdrLenIncFinalAmt), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    LoweredParserMatch(Util::SourceInfo srcInfo, const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    Node(srcInfo), value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    LoweredParserMatch(const IR::BFN::ParserMatchValue* value, unsigned shift, IR::Vector<IR::BFN::LoweredParserPrimitive> extracts, IR::Vector<IR::BFN::LoweredSave> saves, std::set<MatchRegister> scratches, IR::Vector<IR::BFN::LoweredParserChecksum> checksums, IR::Vector<IR::BFN::ParserCounterPrimitive> counters, const IR::BFN::ParserPrioritySet* priority, bool partialHdrErrProc, const IR::BFN::LoweredParserState* next) :
    value(value), shift(shift), extracts(extracts), saves(saves), scratches(scratches), checksums(checksums), counters(counters), priority(priority), partialHdrErrProc(partialHdrErrProc), next(next)
    { validate(); }
    IRNODE_SUBCLASS(LoweredParserMatch)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredParserMatch, NodeKind::BFN_LoweredParserMatch, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A lowered parser state, representing a group of related parser TCAM rows.
/// We do not maintain a 1-to-1 mapping between LoweredParserStates and parser
/// states in the original P4 program.
class LoweredParserState : public Unit {
 public:
#line 284 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    LoweredParserState(cstring name, gress_t gress);
#line 22202 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 287 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    int stage() const override;
#line 22205 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 288 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    gress_t thread() const override;
#line 22208 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 289 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    cstring toString() const override;
#line 22211 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 290 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
#line 22215 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The name of this state. This does not necessarily correspond to any
/// state name in the P4 program.
    cstring name;
/// The thread to which this state is assigned.
    gress_t gress;
/// The bytes from the input buffer which will be loaded into the match
/// registers and used to select a LoweredParserMatch transition to take.
    const IR::BFN::LoweredSelect* select = nullptr;
/// The possible transitions out of this state.
    IR::Vector<IR::BFN::LoweredParserMatch> transitions;
    bool operator==(IR::BFN::LoweredParserState const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredParserState"_cs; }
    static cstring static_type_name() { return "BFN::LoweredParserState"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredParserState(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(LoweredParserState)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredParserState, NodeKind::BFN_LoweredParserState, Unit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class BaseLoweredParser : public AbstractParser {
 public:
#line 311 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    BaseLoweredParser(gress_t gress);
#line 22249 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(BaseLoweredParser)
#line 314 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    cstring toString() const override;
#line 22253 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::BaseLoweredParser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::BaseLoweredParser"_cs; }
    static cstring static_type_name() { return "BFN::BaseLoweredParser"_cs; }
    void toJSON(JSONGenerator & json) const override;
    BaseLoweredParser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::AbstractParser const & a) const override;
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(BaseLoweredParser)
    DECLARE_TYPEINFO_WITH_TYPEID(BaseLoweredParser, NodeKind::BFN_BaseLoweredParser, AbstractParser);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/**
 * @brief The lowered representation of a Tofino 1/2 parser in backend.
 * @ingroup parde
 *
 * This is the representation used after PHV allocation.
 * It is created from IR::BFN::Parser by backend pass LowerParser.
 * It contains primitives which operate on PHV containers and numeric constants.
 */
class LoweredParser : public BaseLoweredParser {
 public:
#line 330 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    LoweredParser(gress_t gress, const IR::BFN::LoweredParserState* start, const IR::BFN::Phase0* phase0, cstring name, std::vector<int> portmap);
#line 22283 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(LoweredParser)
/// The entry point to the parser.
    const IR::BFN::LoweredParserState* start = nullptr;
/// parser error
    const IR::BFN::ContainerRef* parserError = nullptr;
/// The set of PHV containers that are allowed to be written more than once (bitwise OR on rewrite)
    IR::Vector<IR::BFN::ContainerRef> bitwiseOrContainers;
/// The set of PHV containers that are allowed to be written more than once (clear on rewrite)
    IR::Vector<IR::BFN::ContainerRef> clearOnWriteContainers;
/// The set of PHV containers that are zero initialized
    IR::Vector<IR::BFN::ContainerRef> initZeroContainers;
/// Num of bytes of metadata prepended to user packet
    unsigned hdrLenAdj = 0;
    const IR::BFN::Phase0* phase0 = nullptr;

    cstring name;

    std::vector<int> portmap;

#line 361 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    /// bitmask for selection of optional metadata metadata (egress only)
    /// refer to CSR for what metadata field each bit means
    std::optional<unsigned> metaOpt;
#line 22307 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LoweredParser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredParser"_cs; }
    static cstring static_type_name() { return "BFN::LoweredParser"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredParser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::BaseLoweredParser const & a) const override;
    bool operator==(IR::BFN::AbstractParser const & a) const override;
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(LoweredParser)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredParser, NodeKind::BFN_LoweredParser, BaseLoweredParser);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Common base type for all emit types -- write data to output packet
class LoweredEmit : public Node {
 public:
    bool operator==(IR::BFN::LoweredEmit const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LoweredEmit"_cs; }
    static cstring static_type_name() { return "BFN::LoweredEmit"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoweredEmit(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
 protected:
    LoweredEmit(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    LoweredEmit() 
    { validate(); }
    IRNODE_ABSTRACT_SUBCLASS(LoweredEmit)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredEmit, NodeKind::BFN_LoweredEmit, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A primitive that writes the contents of a PHV container to the output
/// packet.
class LoweredEmitPhv : public LoweredEmit {
 public:
#line 373 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 22360 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The POV bit the emit is predicated on
    const IR::BFN::ContainerBitRef* povBit = nullptr;
/// The container whose contents will be written to the packet.
    const IR::BFN::ContainerRef* source = nullptr;
    bool operator==(IR::BFN::LoweredEmitPhv const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredEmitPhv"_cs; }
    static cstring static_type_name() { return "BFN::LoweredEmitPhv"_cs; }
    void toJSON(JSONGenerator & json) const override;
    LoweredEmitPhv(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredEmit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredEmitPhv(Util::SourceInfo srcInfo, const IR::BFN::ContainerBitRef* povBit, const IR::BFN::ContainerRef* source) :
    LoweredEmit(srcInfo), povBit(povBit), source(source)
    { validate(); }
    LoweredEmitPhv(const IR::BFN::ContainerBitRef* povBit, const IR::BFN::ContainerRef* source) :
    povBit(povBit), source(source)
    { validate(); }
    IRNODE_SUBCLASS(LoweredEmitPhv)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredEmitPhv, NodeKind::BFN_LoweredEmitPhv, LoweredEmit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A primitive that writes the result of a checksum unit to the output packet.
class LoweredEmitChecksum : public LoweredEmit {
 public:
#line 384 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 22395 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The POV bit the emit is predicated on
    const IR::BFN::ContainerBitRef* povBit = nullptr;
/// The checksum unit whose result will be written to the packet.
    unsigned unit;
    bool operator==(IR::BFN::LoweredEmitChecksum const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredEmitChecksum"_cs; }
    static cstring static_type_name() { return "BFN::LoweredEmitChecksum"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredEmitChecksum(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredEmit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredEmitChecksum(Util::SourceInfo srcInfo, const IR::BFN::ContainerBitRef* povBit, unsigned unit) :
    LoweredEmit(srcInfo), povBit(povBit), unit(unit)
    { validate(); }
    LoweredEmitChecksum(const IR::BFN::ContainerBitRef* povBit, unsigned unit) :
    povBit(povBit), unit(unit)
    { validate(); }
    IRNODE_SUBCLASS(LoweredEmitChecksum)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredEmitChecksum, NodeKind::BFN_LoweredEmitChecksum, LoweredEmit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A primitive that writes the contents of a CLOT to the output packet.
class LoweredEmitClot : public LoweredEmit {
 public:
    const IR::BFN::EmitClot* clot = nullptr;
    bool operator==(IR::BFN::LoweredEmitClot const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredEmitClot"_cs; }
    static cstring static_type_name() { return "BFN::LoweredEmitClot"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredEmitClot(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredEmit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredEmitClot(Util::SourceInfo srcInfo, const IR::BFN::EmitClot* clot) :
    LoweredEmit(srcInfo), clot(clot)
    { validate(); }
    LoweredEmitClot(const IR::BFN::EmitClot* clot) :
    clot(clot)
    { validate(); }
    IRNODE_SUBCLASS(LoweredEmitClot)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredEmitClot, NodeKind::BFN_LoweredEmitClot, LoweredEmit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class LoweredEmitConstant : public LoweredEmit {
 public:
#line 399 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 22460 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The POV bit the emit is predicated on
    const IR::BFN::ContainerBitRef* povBit = nullptr;
    uint8_t constant;
    bool operator==(IR::BFN::LoweredEmitConstant const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredEmitConstant"_cs; }
    static cstring static_type_name() { return "BFN::LoweredEmitConstant"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredEmitConstant(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::LoweredEmit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    LoweredEmitConstant(Util::SourceInfo srcInfo, const IR::BFN::ContainerBitRef* povBit, uint8_t constant) :
    LoweredEmit(srcInfo), povBit(povBit), constant(constant)
    { validate(); }
    LoweredEmitConstant(const IR::BFN::ContainerBitRef* povBit, uint8_t constant) :
    povBit(povBit), constant(constant)
    { validate(); }
    IRNODE_SUBCLASS(LoweredEmitConstant)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredEmitConstant, NodeKind::BFN_LoweredEmitConstant, LoweredEmit);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Configures the container whose value will be used to set an intrinsic
/// deparser parameter.
class LoweredDeparserParameter : public Node {
 public:
#line 412 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void dbprint(std::ostream & out) const override;
#line 22496 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 427 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void validate() const override;
#line 22499 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The deparser parameter to configure. The name is the one used in the
/// assembly, which in turn derives from the CSR register name.
    cstring name;
/// The container whose contents will be used for the parameter.
    IR::Vector<IR::BFN::ContainerRef> sources;
/// On JBay, each deparser parameter has a POV bit which determines whether
/// the container's contents are valid (and often implicitly enables or
/// disables the corresponding feature). On Tofino, the hidden per-container
/// validity bits serve the same role.
    const IR::BFN::ContainerBitRef* povBit = nullptr;
    bool operator==(IR::BFN::LoweredDeparserParameter const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    cstring node_type_name() const override { return "BFN::LoweredDeparserParameter"_cs; }
    static cstring static_type_name() { return "BFN::LoweredDeparserParameter"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredDeparserParameter(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    LoweredDeparserParameter(Util::SourceInfo srcInfo, cstring name, IR::Vector<IR::BFN::ContainerRef> sources, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), name(name), sources(sources), povBit(povBit)
    { validate(); }
    LoweredDeparserParameter(cstring name, IR::Vector<IR::BFN::ContainerRef> sources, const IR::BFN::ContainerBitRef* povBit) :
    name(name), sources(sources), povBit(povBit)
    { validate(); }
    LoweredDeparserParameter(Util::SourceInfo srcInfo, cstring name, IR::Vector<IR::BFN::ContainerRef> sources) :
    Node(srcInfo), name(name), sources(sources)
    { validate(); }
    LoweredDeparserParameter(cstring name, IR::Vector<IR::BFN::ContainerRef> sources) :
    name(name), sources(sources)
    { validate(); }
    IRNODE_SUBCLASS(LoweredDeparserParameter)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredDeparserParameter, NodeKind::BFN_LoweredDeparserParameter, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An entry in a digest table, consisting of a sequence of containers.
class DigestTableEntry : public Node {
 public:
/// The index for the entry
    int idx;
/// The PHV containers in the entry.
    IR::Vector<IR::BFN::ContainerRef> sources;
    bool operator==(IR::BFN::DigestTableEntry const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::DigestTableEntry"_cs; }
    static cstring static_type_name() { return "BFN::DigestTableEntry"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DigestTableEntry(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DigestTableEntry(Util::SourceInfo srcInfo, int idx, IR::Vector<IR::BFN::ContainerRef> sources) :
    Node(srcInfo), idx(idx), sources(sources)
    { validate(); }
    DigestTableEntry(int idx, IR::Vector<IR::BFN::ContainerRef> sources) :
    idx(idx), sources(sources)
    { validate(); }
    IRNODE_SUBCLASS(DigestTableEntry)
    DECLARE_TYPEINFO_WITH_TYPEID(DigestTableEntry, NodeKind::BFN_DigestTableEntry, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// Digest Field contains information on how a field is placed within a
/// phv container within a digest format. A digest format (controlPlaneFormat) is a
/// collection of multiple digest fields placed in network order.
class DigestField : public Node {
 public:
/// P4 Name of the digest field
    cstring fieldName;
/// The start byte in digest format for field location in network order
    unsigned startByte;
/// The start bit within byte in digest format for field location in network
/// order
    unsigned startBit;
/// The width of field within the phv container
    unsigned fieldWidth;
/// The field offset within the phv container
    unsigned fieldOffset;
    bool operator==(IR::BFN::DigestField const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::DigestField"_cs; }
    static cstring static_type_name() { return "BFN::DigestField"_cs; }
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    DigestField(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    DigestField(Util::SourceInfo srcInfo, cstring fieldName, unsigned startByte, unsigned startBit, unsigned fieldWidth, unsigned fieldOffset) :
    Node(srcInfo), fieldName(fieldName), startByte(startByte), startBit(startBit), fieldWidth(fieldWidth), fieldOffset(fieldOffset)
    { validate(); }
    DigestField(cstring fieldName, unsigned startByte, unsigned startBit, unsigned fieldWidth, unsigned fieldOffset) :
    fieldName(fieldName), startByte(startByte), startBit(startBit), fieldWidth(fieldWidth), fieldOffset(fieldOffset)
    { validate(); }
    IRNODE_SUBCLASS(DigestField)
    DECLARE_TYPEINFO_WITH_TYPEID(DigestField, NodeKind::BFN_DigestField, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An entry in the learning digest table.
class LearningTableEntry : public DigestTableEntry {
 public:
#line 476 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    using DigestPacking = safe_vector<DigestField>;
    LearningTableEntry(int idx,
                       const IR::Vector<IR::BFN::ContainerRef>& sources,
                       cstring controlPlaneName,
                       const DigestPacking* controlPlaneFormat)
      : DigestTableEntry(idx, sources), controlPlaneName(controlPlaneName),
        controlPlaneFormat(controlPlaneFormat) { }
#line 22622 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
#line 485 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    void validate() const override;
#line 22625 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
/// The control plane name for this type of learn quanta.
    cstring controlPlaneName;
#line 491 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    /// The packing format for this type of learn quanta; this describes to the
    /// driver how the fields included in the learn quantum are laid out.
    const DigestPacking* controlPlaneFormat = nullptr;
#line 22632 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    bool operator==(IR::BFN::LearningTableEntry const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    cstring node_type_name() const override { return "BFN::LearningTableEntry"_cs; }
    static cstring static_type_name() { return "BFN::LearningTableEntry"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LearningTableEntry(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::DigestTableEntry const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(LearningTableEntry)
    DECLARE_TYPEINFO_WITH_TYPEID(LearningTableEntry, NodeKind::BFN_LearningTableEntry, DigestTableEntry);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// A lowered deparser digest. Each kind of digest has a set of table entries
/// which identify containers to be written into a specific buffer. The table
/// entry is chosen based on the value in the selector container.
class LoweredDigest : public Node {
 public:
/// The name of the digest, identifying a special buffer to be filled in by
/// the deparser hardware. The name is chosen to match the corresponding
/// assembly directive, which in turn is named based on definitions in the
/// CSRs.
    cstring name;
/// The container which selects a digest table entry.
    const IR::BFN::ContainerRef* selector = nullptr;
/// The available table entries; the index of each entry in the vector
/// corresponds to the selector value which chooses it.
    IR::Vector<IR::BFN::DigestTableEntry> entries;
    const IR::BFN::ContainerBitRef* povBit = nullptr;
    bool operator==(IR::BFN::LoweredDigest const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredDigest"_cs; }
    static cstring static_type_name() { return "BFN::LoweredDigest"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredDigest(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    LoweredDigest(Util::SourceInfo srcInfo, cstring name, const IR::BFN::ContainerRef* selector, IR::Vector<IR::BFN::DigestTableEntry> entries, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), name(name), selector(selector), entries(entries), povBit(povBit)
    { validate(); }
    LoweredDigest(cstring name, const IR::BFN::ContainerRef* selector, IR::Vector<IR::BFN::DigestTableEntry> entries, const IR::BFN::ContainerBitRef* povBit) :
    name(name), selector(selector), entries(entries), povBit(povBit)
    { validate(); }
    LoweredDigest(Util::SourceInfo srcInfo, cstring name, IR::Vector<IR::BFN::DigestTableEntry> entries, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), name(name), entries(entries), povBit(povBit)
    { validate(); }
    LoweredDigest(cstring name, IR::Vector<IR::BFN::DigestTableEntry> entries, const IR::BFN::ContainerBitRef* povBit) :
    name(name), entries(entries), povBit(povBit)
    { validate(); }
    LoweredDigest(Util::SourceInfo srcInfo, cstring name, const IR::BFN::ContainerRef* selector, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), name(name), selector(selector), povBit(povBit)
    { validate(); }
    LoweredDigest(cstring name, const IR::BFN::ContainerRef* selector, const IR::BFN::ContainerBitRef* povBit) :
    name(name), selector(selector), povBit(povBit)
    { validate(); }
    LoweredDigest(Util::SourceInfo srcInfo, cstring name, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), name(name), povBit(povBit)
    { validate(); }
    LoweredDigest(cstring name, const IR::BFN::ContainerBitRef* povBit) :
    name(name), povBit(povBit)
    { validate(); }
    LoweredDigest(Util::SourceInfo srcInfo, cstring name, const IR::BFN::ContainerRef* selector, IR::Vector<IR::BFN::DigestTableEntry> entries) :
    Node(srcInfo), name(name), selector(selector), entries(entries)
    { validate(); }
    LoweredDigest(cstring name, const IR::BFN::ContainerRef* selector, IR::Vector<IR::BFN::DigestTableEntry> entries) :
    name(name), selector(selector), entries(entries)
    { validate(); }
    LoweredDigest(Util::SourceInfo srcInfo, cstring name, IR::Vector<IR::BFN::DigestTableEntry> entries) :
    Node(srcInfo), name(name), entries(entries)
    { validate(); }
    LoweredDigest(cstring name, IR::Vector<IR::BFN::DigestTableEntry> entries) :
    name(name), entries(entries)
    { validate(); }
    LoweredDigest(Util::SourceInfo srcInfo, cstring name, const IR::BFN::ContainerRef* selector) :
    Node(srcInfo), name(name), selector(selector)
    { validate(); }
    LoweredDigest(cstring name, const IR::BFN::ContainerRef* selector) :
    name(name), selector(selector)
    { validate(); }
    LoweredDigest(Util::SourceInfo srcInfo, cstring name) :
    Node(srcInfo), name(name)
    { validate(); }
    LoweredDigest(cstring name) :
    name(name)
    { validate(); }
    IRNODE_SUBCLASS(LoweredDigest)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredDigest, NodeKind::BFN_LoweredDigest, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// An input to a checksum unit.
class ChecksumPhvInput : public Node {
 public:
/// A container whose contents will be included in the checksum.
    const IR::BFN::ContainerRef* source = nullptr;
    unsigned swap = 0;
/// On JBay, each checksum input has an independent POV bit, which makes it
/// easier to safely compute a checksum involving headers which may be
/// present in different combinations. On Tofino, this is always null.
    const IR::BFN::ContainerBitRef* povBit = nullptr;
    bool operator==(IR::BFN::ChecksumPhvInput const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ChecksumPhvInput"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumPhvInput"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ChecksumPhvInput(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ChecksumPhvInput(Util::SourceInfo srcInfo, const IR::BFN::ContainerRef* source, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), source(source), povBit(povBit)
    { validate(); }
    ChecksumPhvInput(const IR::BFN::ContainerRef* source, const IR::BFN::ContainerBitRef* povBit) :
    source(source), povBit(povBit)
    { validate(); }
    ChecksumPhvInput(Util::SourceInfo srcInfo, const IR::BFN::ContainerRef* source) :
    Node(srcInfo), source(source)
    { validate(); }
    ChecksumPhvInput(const IR::BFN::ContainerRef* source) :
    source(source)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumPhvInput)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumPhvInput, NodeKind::BFN_ChecksumPhvInput, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class ChecksumClotInput : public Node {
 public:
    Clot * clot;
    bool invert = false;
    const IR::BFN::ContainerBitRef* povBit = nullptr;
    bool operator==(IR::BFN::ChecksumClotInput const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::ChecksumClotInput"_cs; }
    static cstring static_type_name() { return "BFN::ChecksumClotInput"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    ChecksumClotInput(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    ChecksumClotInput(Util::SourceInfo srcInfo, Clot * clot, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), clot(clot), povBit(povBit)
    { validate(); }
    ChecksumClotInput(Clot * clot, const IR::BFN::ContainerBitRef* povBit) :
    clot(clot), povBit(povBit)
    { validate(); }
    IRNODE_SUBCLASS(ChecksumClotInput)
    DECLARE_TYPEINFO_WITH_TYPEID(ChecksumClotInput, NodeKind::BFN_ChecksumClotInput, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class PartialChecksumUnitConfig : public Node {
 public:


    unsigned unit;
/// The phv inputs to this checksum unit
    IR::Vector<IR::BFN::ChecksumPhvInput> phvs;
    const IR::BFN::ContainerBitRef* povBit = nullptr;

    bool invert = false;
    bool operator==(IR::BFN::PartialChecksumUnitConfig const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::PartialChecksumUnitConfig"_cs; }
    static cstring static_type_name() { return "BFN::PartialChecksumUnitConfig"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    PartialChecksumUnitConfig(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    PartialChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::ChecksumPhvInput> phvs, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), unit(unit), phvs(phvs), povBit(povBit)
    { validate(); }
    PartialChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::ChecksumPhvInput> phvs, const IR::BFN::ContainerBitRef* povBit) :
    unit(unit), phvs(phvs), povBit(povBit)
    { validate(); }
    PartialChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, const IR::BFN::ContainerBitRef* povBit) :
    Node(srcInfo), unit(unit), povBit(povBit)
    { validate(); }
    PartialChecksumUnitConfig(unsigned unit, const IR::BFN::ContainerBitRef* povBit) :
    unit(unit), povBit(povBit)
    { validate(); }
    PartialChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::ChecksumPhvInput> phvs) :
    Node(srcInfo), unit(unit), phvs(phvs)
    { validate(); }
    PartialChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::ChecksumPhvInput> phvs) :
    unit(unit), phvs(phvs)
    { validate(); }
    PartialChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit) :
    Node(srcInfo), unit(unit)
    { validate(); }
    PartialChecksumUnitConfig(unsigned unit) :
    unit(unit)
    { validate(); }
    IRNODE_SUBCLASS(PartialChecksumUnitConfig)
    DECLARE_TYPEINFO_WITH_TYPEID(PartialChecksumUnitConfig, NodeKind::BFN_PartialChecksumUnitConfig, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
class FullChecksumUnitConfig : public Node {
 public:



/// The unit number to configure; this is referenced by LoweredEmitChecksum
/// to actually write the checksum unit's output to the packet. On Tofino,
/// these unit numbers exist in a separate namespace for ingress and egress;
/// on JBay, both threads share the same checksum units.
    unsigned unit;

    IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits;
/// clot inputs
    IR::Vector<IR::BFN::ChecksumClotInput> clots;

    bool zeros_as_ones = false;
    bool operator==(IR::BFN::FullChecksumUnitConfig const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::FullChecksumUnitConfig"_cs; }
    static cstring static_type_name() { return "BFN::FullChecksumUnitConfig"_cs; }
    void dbprint(std::ostream & out) const override;
    void dump_fields(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    FullChecksumUnitConfig(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::Node const & a) const override;
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    Node(srcInfo), unit(unit), partialUnits(partialUnits), clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    unit(unit), partialUnits(partialUnits), clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    Node(srcInfo), partialUnits(partialUnits), clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    partialUnits(partialUnits), clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    Node(srcInfo), unit(unit), clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    unit(unit), clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    Node(srcInfo), clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(IR::Vector<IR::BFN::ChecksumClotInput> clots, bool zeros_as_ones) :
    clots(clots), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, bool zeros_as_ones) :
    Node(srcInfo), unit(unit), partialUnits(partialUnits), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, bool zeros_as_ones) :
    unit(unit), partialUnits(partialUnits), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, bool zeros_as_ones) :
    Node(srcInfo), partialUnits(partialUnits), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, bool zeros_as_ones) :
    partialUnits(partialUnits), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, bool zeros_as_ones) :
    Node(srcInfo), unit(unit), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit, bool zeros_as_ones) :
    unit(unit), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, bool zeros_as_ones) :
    Node(srcInfo), zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(bool zeros_as_ones) :
    zeros_as_ones(zeros_as_ones)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    Node(srcInfo), unit(unit), partialUnits(partialUnits), clots(clots)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    unit(unit), partialUnits(partialUnits), clots(clots)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    Node(srcInfo), partialUnits(partialUnits), clots(clots)
    { validate(); }
    FullChecksumUnitConfig(IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits, IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    partialUnits(partialUnits), clots(clots)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    Node(srcInfo), unit(unit), clots(clots)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    unit(unit), clots(clots)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    Node(srcInfo), clots(clots)
    { validate(); }
    FullChecksumUnitConfig(IR::Vector<IR::BFN::ChecksumClotInput> clots) :
    clots(clots)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits) :
    Node(srcInfo), unit(unit), partialUnits(partialUnits)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits) :
    unit(unit), partialUnits(partialUnits)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits) :
    Node(srcInfo), partialUnits(partialUnits)
    { validate(); }
    FullChecksumUnitConfig(IR::Vector<IR::BFN::PartialChecksumUnitConfig> partialUnits) :
    partialUnits(partialUnits)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo, unsigned unit) :
    Node(srcInfo), unit(unit)
    { validate(); }
    FullChecksumUnitConfig(unsigned unit) :
    unit(unit)
    { validate(); }
    FullChecksumUnitConfig(Util::SourceInfo srcInfo) :
    Node(srcInfo)
    { validate(); }
    FullChecksumUnitConfig() 
    { validate(); }
    IRNODE_SUBCLASS(FullChecksumUnitConfig)
    DECLARE_TYPEINFO_WITH_TYPEID(FullChecksumUnitConfig, NodeKind::BFN_FullChecksumUnitConfig, Node);
};
}  // namespace BFN
}  // namespace P4::IR
namespace P4::IR {
namespace BFN {
/// The lowered representation of the deparser. This representation is
/// constructed after PHV allocation and refers only to PHV containers;
/// references to high level objects like fields have all been eliminated.
class LoweredDeparser : public AbstractDeparser {
 public:
#line 569 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    LoweredDeparser(gress_t gress);
#line 23000 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IRNODE_DECLARE_APPLY_OVERLOAD(LoweredDeparser)
#line 571 "/builddir/build/BUILD/p4c-1.2.5.8/backends/tofino/bf-p4c/ir/parde-lowered.def"
    cstring toString() const override;
#line 23004 "/builddir/build/BUILD/p4c-1.2.5.8/redhat-linux-build/ir/ir-generated.h"
    IR::Vector<IR::BFN::LoweredEmit> emits;
    IR::Vector<IR::BFN::LoweredDeparserParameter> params;
    IR::Vector<IR::BFN::LoweredDigest> digests;
    IR::Vector<IR::BFN::FullChecksumUnitConfig> checksums;
    bool operator==(IR::BFN::LoweredDeparser const & a) const override;
    bool equiv(IR::Node const & a_) const override;
    void visit_children(Visitor & v, char const * n) override;
    void visit_children(Visitor & v, char const * n) const override;
    void validate() const override;
    cstring node_type_name() const override { return "BFN::LoweredDeparser"_cs; }
    static cstring static_type_name() { return "BFN::LoweredDeparser"_cs; }
    void dbprint(std::ostream & out) const override;
    void toJSON(JSONGenerator & json) const override;
    LoweredDeparser(JSONLoader & json);
    static IR::Node * fromJSON(JSONLoader & json);
    bool operator==(IR::BFN::AbstractDeparser const & a) const override;
    bool operator==(IR::BFN::Unit const & a) const override;
    bool operator==(IR::Node const & a) const override;
    IRNODE_SUBCLASS(LoweredDeparser)
    DECLARE_TYPEINFO_WITH_TYPEID(LoweredDeparser, NodeKind::BFN_LoweredDeparser, AbstractDeparser);
};
}  // namespace BFN
}  // namespace P4::IR
#endif /* IR_GENERATED_H_ */
